C          PROGRAM TO PREPARE INPUT FOR MULTAN 88 
C               
C     **********************
C
C    MULTAN 88 consists of 3 separate programs which, when
C    run in series, will perform all the necessary calculations.
C    This input program creates the command files to run two of
C    the three programs:  NOFI (Normal and First), LAST.  Another
C    subroutine, MAPSIN, creates the command file for  
C    MAPS (Exfft and Search)
C
c      This program will to write 'p1'.cdr file
C                                 'p1'.nof file
C                                 'p1'.las file
c                                 
c
C     *********************
C
c                    input to NOFI
      SUBROUTINE MULTANIN
      Character*20 ANAM
      CHARACTER*4 CARD(20)
      CHARACTER*4 DARD(19)
      CHARACTER*6 ANS
      CHARACTER*20 BRANCH
      CHARACTER*4 C4
      CHARACTER*15 TRIX
      CHARACTER*80 C    
      CHARACTER*40 C1
      CHARACTER*1 CC(80)
      CHARACTER*4 BLANK
      CHARACTER*1 BL
      CHARACTER*2 AT(8)
      EQUIVALENCE (CC,C(1:80)),(DARD,CARD(2))
      DIMENSION AA(8),IN(8),JZ(8),IPN(31),BB(21)
      INTEGER*2 ICD(20)
      BYTE FIRST,LAST
      	COMMON/PASS/BRANCH,TRIX
      CHARACTER*16 NFILE,NAMDES
      COMMON/FNAME/NFILE,NAMLEN
      DATA BLANK/'    '/
1     FORMAT(A)
2     FORMAT(1X,20A4)
3     FORMAT(20A4)
4     FORMAT(80A1)
6     FORMAT(1X,A)
8     FORMAT(F8.5)
10    FORMAT(I10)
20    FORMAT(F12.6)
114   FORMAT(I5,4X,A1,7I5,F5.2,I5,F5.2)
132   FORMAT(5F10.3)
141   FORMAT(1X,A4,2I5,F5.2,6F10.3)
150   FORMAT(A4)
210   FORMAT(2I5,:,14I5)
215   FORMAT(2I5,:,I5,4X,A1,2I5,F10.3)
221   FORMAT(I5,:,3F10.6)
228   FORMAT(3I5,F10.5)
247   FORMAT(6I5,F10.4)
249   FORMAT(4I5,F10.4)
251   FORMAT(2I5,F10.4)
254   FORMAT(5I5,F10.4)
264   FORMAT(5I5,3F10.6)
268   FORMAT(20I4)
284   FORMAT(20F4.2)
C    ***********************
C
C    This subroutine is entered from the program INPUT by stating that
C    you want to run NORMAL, NOFI, LAST, MAPS (the user may use either
C    EXFFT, SEARCH to reach MAPS, also) or the generic MULTAN.  
C    If the latter option was used, a menu appears
C    asking the user specifically which program is desired.
C
C    **********************
C
      IF(BRANCH(1:4).EQ.'MULT') GOTO 200
      IF(BRANCH(1:2).EQ.'NO')THEN 
        GOTO 300
      ELSE IF(BRANCH(1:1).EQ.'L')THEN 
        GOTO 500
      ELSEIF(BRANCH(1:1).EQ.'M')THEN 
        GOTO 600
      ELSE
        GOTO 919
      ENDIF
C*************************** MULTAN INPUT HERE *************************
200   ANS(1:4)=BLANK                 ! MAKE SURE NOTHING IS IN ACCEPT
      ANS(5:6)=BLANK(1:2)
      C(1:4)=BRANCH
      TYPE 6,C(1:4)
      TYPE*,' Which MULTAN program do you want to run?'
      TYPE*,' '
      TYPE*,' [1] NOFI (Normal and First)'
      TYPE*,'  2  NORMAL (only)'
      TYPE*,'  3  LAST'
      TYPE*,'  4  MAPS (Exfft and Search)'
      ACCEPT 1,ANS
      WRITE(4,1)ANS(1:3)
      TYPE 6,ANS(1:3)
      IF(ANS(1:1).EQ.'2')THEN
        BRANCH='NORM'
        TYPE 6, BRANCH(1:4)
C       FIRST=9
        GOTO 300
      ELSE IF(ANS(1:1).EQ.'3')THEN
        BRANCH='LAST'
        TYPE 6, BRANCH(1:4)
        LAST=9
        GOTO 500
      ELSE IF(ANS(1:1).EQ.'4')THEN
        BRANCH='MAPS'
        TYPE 6, BRANCH(1:4)
        GOTO 600
      ELSE
        BRANCH='NOFI'
        TYPE 6, BRANCH(1:4)
C       FIRST=9
      ENDIF
C*********************************************************************
C
C      These questions write the .cdr file for Multan.  They are
c      REQUIRED to run NORMAL and NOFI.  If the user opts to run
C      NORMAL only, NORM will be written on the .cdr file.  Otherwise,
C      the NORMAL/FIRST parameters will be written on the .nof file.
C
300   I=NAMLEN+1
        ANAM=NFILE
        ANAM(I:I+3)='.CDR'
      OPEN (unit=10,file=ANAM,status='new',FORM='FORMATTED',err=9999)
      TYPE*,' Enter title for title card - FREE FORMAT'
      READ(5,1)C
      TYPE 6,C
      WRITE(10,1)C
      TYPE*,' The following questions MUST be answered.'
      TYPE*,' '
310   TYPE*,' Unit cell parameters card'
      TYPE*,' Enter A, B, C, ALPHA, BETA, and GAMMA separated by',
     1' commas (Real or Integer) '
      READ(5,1310,ERR=9310)(AA(I),I=1,6)
1310  FORMAT(3F10.0,:,3F10.0)
      WRITE(10,1315,ERR=9310)(AA(I),I=1,6)
1315  FORMAT('CEL  ',3F10.6,3F11.6)
320   TYPE*,' Is your space group centrosymmetric?  Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')THEN   
        C(1:4)='CEN      '
      WRITE(10,1)C(1:4)
      TYPE 6,C(1:4)    
      ENDIF
327   TYPE*,' Enter lattice type (A1). [P],A,B,C,I,F,or R'
      ACCEPT 1,C(5:5)
      IF(C(5:5).EQ.' ')C(5:5)='P'       ! DEFAULT
      C(1:4)='LAT '
      WRITE(10,1)C(1:5)
      TYPE 6,C(1:5)
325   TYPE*,' The identity, X,Y,Z, is supplied. Do you have other'
      TYPE*,' symmetry positions? ANS Y/[N]'
      ACCEPT 1,ANS
      C(1:13)='SYM  X,Y,Z * '
      N=14
      IF(ANS(1:1).EQ.'Y')THEN
        TYPE*,' Symmetry input is in the form of general equivalent '
        TYPE*,' positions as in the International Tables.  For example:'
        TYPE*,'                    1/4-X,Y,1/2+Z'
        TYPE*,' Do not include positions related by a center of '
        TYPE*,' symmetry.  Include only those general equivalent '
        TYPE*,' positions associated with one lattice point.'
1325    TYPE*,' Enter one general equivalent position,',
     1  ' fields separated by commas.  RETURN if done.'
        READ(5,1)C1
        I=41
328     I=I-1
        IF(I.EQ.1)GOTO 329   ! DONE
        IF(C1(I:I).EQ.' ')GOTO 328  ! LOOKING FOR END OF FIELD - NONBLANK
        IF(I+N.GT.75)GOTO 1327  ! NEED CONTINUATION CARD
326     C(N:(N+I)-1)=C1(1:I)
        N=N+I
        C(N:N+2)=' * '
        N=N+3
        GOTO 1325
1327    TYPE 6,C(1:N-3)
        WRITE(10,1)C(1:N-3)
        N=1
        GOTO 326
329    CONTINUE
      ENDIF
      N=N-3
      TYPE 6,C(1:N)
      WRITE(10,1)C(1:N)
330   TYPE 1330
1330   FORMAT(' Enter the total contents of the unit cell.',/,
     +' Include all atoms whether the lattice is centered or primitive,' 
     +,/,
     +' and all atoms whether input later as part of a group or not.'
     +,/,
     +' C1 N1 C2 N2 C3 N3 C4 N4 C5 N5 ........',/,
     +' C1 is the symbol of atom type 1 and N1 is the number of atoms',/,
     +' of this type in the unit cell.',/,
     +' EX:  C  20  H  34  S  1',/,
     +'  Separated by one or more blanks ')
      C(1:4)='CON '
      READ(5,1,ERR=9330)C(5:)
      J=INDEX(C(5:),BLANK)
      IF(J.LT.4)THEN
        TYPE*,' Do you want to try contents of cell entry again?  Y/[N]'
        ACCEPT 1,ANS(1:1)
        IF(ANS(1:1).EQ.'Y')GO TO 330
      ENDIF
      IF(J.LT.81)THEN
        WRITE(10,1)C(1:J+4)
        TYPE 6,C(1:J+4)
        GOTO 332
      ELSE
        TYPE 1331
1331    FORMAT (' Something wrong here. TRY AGAIN.')
        GO TO 330
      ENDIF
331   TYPE 1330
      TYPE 1332
1332  FORMAT(' Scattering factors are stored in for these 50 ',/,
     +' atoms:  ',/,
     +' H  ,LI ,BE ,B  ,C  ,N  ,O  ,F  ,NA ,MG ,AL ,SI ,P  ,S  ,CL '
     +,/,' K  ,CA ,TI ,V  ,CR ,MN ,FE ,CO ,NI ,CU ,ZN ,AS ,SE ,BR '
     +,/,' RB ,SR ,ZR ,MO ,RU ,RH ,PD ,AG ,CD ,SN ,SB ,I  ,CS ,BA '
     +,/,' W  ,OS ,PT ,AU ,HG ,PB ,BI ',/,
     +' If an atom is not one of the above, ',/,
     +' see Multan Manual, page 6.')
332   TYPE*,' Enter atomic symbol or return for no scattering factor'
      C(1:4)='FAC '
      READ(5,1)C(5:7)
      IF(C(5:7).EQ.BLANK(1:3))GO TO 340
333   TYPE*,' Enter 5 constants separated by commas (Real or Integer)'
      READ(5,1335,ERR=9333)(AA(I),I=1,5)
1335  FORMAT(5F10.0)
      ENCODE(80,1333,CC,ERR=9333)C(1:7),(AA(I),I=1,5)
1333  FORMAT(A7,5F10.3)
      TYPE 1334,CC
1334  FORMAT(1X,79A1)
      WRITE(10,4,ERR=9333)CC
      TYPE*,' Do you want to enter any more constants? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')GOTO 332
340   C(1:22)='FOR 4 (4(3I3,F8.3,I2))'
      WRITE(10,1)C(1:22)
345   IF(BRANCH(1:4).eq.'NORM') THEN
        C(1:4)='NOR '
        TYPE 6,C(1:4)
        WRITE(10,2)C(1:4)
      END IF
350   C4='END '
      TYPE 6, C4
      WRITE(10,3)C4
3550  CLOSE(10,STATUS='SAVE')
C*****************************************************************
C
C  PARAMETERS FOR NORMAL
C
C*****************************************************************
355   TYPE*,'Do you accept all the NORMAL Defaults? [Y]/N'
      READ(5,1)C(1:1)
      IF (C(1:1) .NE. 'N') GOTO 455
400   TYPE 1400
1400  FORMAT(' Enter the number of reflections with largest ',/,
     +' E-values to be condsidered for phase determination. ',/,
     +' See Manual for DEFAULT. (Integer) ')
      C(1:4)='NRE '
      READ(5,1,ERR=9400)C(5:10)
      IF(C(4:10).NE.BLANK)THEN
        TYPE 6,C(1:10)
        WRITE(4,1)C(1:10)
      ENDIF
405   TYPE*,' Program will attempt to determine phases for the best N'
      TYPE*,' reflections chosen by the convergence procedure. Default'
      TYPE*,' is 11% fewer reflections than specified by NREF or its'
      TYPE*,' default. Enter integer or RETURN for default.'
      ACCEPT 1,C(5:10)
      IF(C(5:9).NE.BLANK)THEN
        C(1:4)='DET '
        TYPE 6,C(1:10)
        WRITE(4,1)C(1:10)
      ENDIF
410   TYPE 1410
1410  FORMAT(' Do you want to enter the number of smallest E-values' ,/,
     +' for use in the psi(zero) figure of merit? (If the  ',/,
     +' Sayre-equation tangent formula is chosen, these reflections ',/,
     +' are used activelY as cross-terms in the formation of quartets. ',/,
     +' Default is NDET/2. ',/,
     +'   Enter integer or RETURN for default')
      C(1:4)='NZR '
      READ(5,1,ERR=9410)C(5:13)
      IF(C(5:9).NE.BLANK)THEN
        TYPE 6,C(1:13)
        WRITE(4,1)C(1:13)
      ENDIF
415   TYPE 1415
1415  FORMAT(' Do you want to list the complete set of E s used ',/,
     +'  in phase determination or only [the 30 strongest and ',/,
     +'  12 weakest Es and none of the psi(zero)s]? Y/[N]')
      READ(5,1,err=9415)C(1:1)
      IF (C(1:1) .EQ. 'Y') THEN
1416    FORMAT('ELI ')
        TYPE 6,1416
        WRITE(4,1416)
      ENDIF
420   TYPE 1420
1420  FORMAT('  You may restrict the reflection input data by',/,
     +' entering a maximum value of sin(theta)/lambda)**2. ',/,
     +' Default is to accept all the data. Enter rhomax',/,
     +' or RETURN for default. (Real)')
      C(1:4)='RHO '
      READ(5,1,ERR=9420)C(5:12)
      IF(C(5:9).NE.BLANK)THEN
        WRITE(4,1)C(1:12)
        TYPE 6,C(1:12)
      ENDIF
425   TYPE 1425
1425   FORMAT(' Do you wish to rescale index groups? Y/[N]')
       READ(5,1)C
       IF(C.NE.'Y') THEN
         GOTO 430
       ELSE
         C(1:4)='GRO '
         TYPE 1426
1426     FORMAT(' See manual for explanation of Group option. ')
426      TYPE 1427
1427     FORMAT(' Then type the expressions to be used to ',/,
     +   ' define the group or RETURN for default.')
         READ(5,1)C(5:80)
         IF(C(5:9).EQ.BLANK) THEN 
           WRITE(4,1)C(1:4)
           TYPE 6,C(1:4)
         ELSE
           WRITE(4,1)C(1:80)
           TYPE 6,C(1:80)
         ENDIF
        TYPE*, ' Do you want to define another group? Y/[N]'
        ACCEPT 1,ANS(1:1)
        IF (ANS.EQ.'Y') GO TO 426
      ENDIF
430   TYPE 1430
1430  FORMAT(' Do you have any group(s) of atoms whose geometry,',/, 
     +' or position are known ?  Y/[N].')
      ACCEPT 1,ANS(1:1)
      IF(ANS(1:1).NE.'Y')GO TO 455
431   TYPE*,' Is it randomly oriented and randomly positioned ? [Y]/N'
      ACCEPT 1,ANS(1:1)
      IF(ANS(1:1).NE.'N')THEN
        C(1:4)='RAN '
        GOTO 432
      ENDIF
      IF(ANS(1:1).EQ.'N') THEN
435     TYPE*,' Group of known orientation but random position ? [Y]/N'
        ACCEPT 1,ANS(1:1)
        IF(ANS(1:1).NE.'N')THEN
          C(1:4)='ORI '
          GOTO 432
        ENDIF
      ENDIF
      IF(ANS(1:1).EQ.'N') THEN
        TYPE*,' Molecular group of known position ? [Y]/N'
        ACCEPT 1,ANS(1:1)
        IF(ANS(1:1).NE.'N')THEN
          C(1:4)='POS '
          GOTO 432
        ENDIF
      ENDIF
      IF(ANS(1:1).EQ.'N') THEN
        TYPE*,' Group for Karle recycling through MULTAN ? [Y]/N'
        ACCEPT 1,ANS(1:1)
        IF(ANS(1:1).NE.'N')THEN
          C(1:4)='KAR '
          GOTO 432
        ENDIF
      ENDIF
      IF(ANS(1:1).EQ.'N') THEN
        TYPE*,' Group for weighted Fourier recycling? [Y]/N'
        ACCEPT 1,ANS(1:1)
        IF(ANS(1:1).NE.'N')THEN
          C(1:4)='WFO '
          GOTO 432               
        ENDIF
      ENDIF
      TYPE*,' Group for differences Fourier recycling ? [Y]/N'
      ACCEPT 1,ANS(1:1)
      IF(ANS(1:1).NE.'N')THEN
        C(1:4)='DFO '
      ELSE
        TYPE*,' There are no more choices.  Do you want to try '
        Type*,' again? Y/[N] '
        ACCEPT 1,ANS(1:1)
        IF(ANS(1:1).NE.'Y')GOTO 455
        GOTO 431
      ENDIF
432   TYPE 6,C(1:4)
      WRITE(4,1)C(1:4)
      TYPE*,' Enter the number of times the group appears '
      TYPE*,' in the unit cell. (Real or Integer)'
      READ(5,10)MUL
      ENCODE(7,1432,C(1:7))MUL
1432  FORMAT('MUL ',I3)
      TYPE 6,C(1:7)
      WRITE(4,1)C(1:7)
433   TYPE 1433
1433  FORMAT(' Enter cell parameters for cell to which',/,
     +  ' group coords are referred, 6 numbers (Real or Integer) ',/,
     +  ' separated by commas, or DEFAULT of [1,1,1,90,90,90].')
      READ(5,1310,ERR=9433)(AA(J),J=1,6)
      IF(AA(1).NE.0.0)THEN
        ENCODE(47,1434,C(1:47))(AA(J),J=1,6)
1434    FORMAT('CELL ',6F7.3)
        WRITE(4,1)C(1:47)
        TYPE 6,C(1:47)
        GO TO 450
      ENDIF
445   IF(C(1:4).NE.'MUL '.AND.C(1:4).NE.'CEL ')THEN
        WRITE(4,1)C(1:4)
        TYPE 6,C(1:4)
      ENDIF
C   ATOMIC SYMBOLS AND COORDINATES
450   TYPE*,' Enter the number of atoms in this group (Integer)'
      READ(5,10)NOA
      IF(NOA.EQ.0)GOTO 451
      DO J=1,NOA
        TYPE*,' Enter the chemical symbols and coordinates - FREE',
     1    ' FORMAT, SEPARATED BY **SPACES**!'
        READ(5,4)CC
        ENCODE(80,4,CARD)CC
        TYPE 1334,CC
        WRITE(4,3)CARD
      ENDDO
451   TYPE 1451 
1451  FORMAT(' Do you have any other groups of atoms whose ',/, 
     +'  geometry, or position are known ?  Y/[N].')
      ACCEPT 1,ANS(1:1)
      IF(ANS(1:1).EQ.'Y')GO TO 431
455   CONTINUE
      IF(BRANCH(1:4).eq.'NORM') GOTO 900
C*********************************************************************
C
C  Parameters for FIRST
C
C*********************************************************************
460   TYPE*, ' Do you accept all the FIRST defaults? [Y]/N'
      READ(5,1)C(1:1)
      IF(C(1:1).NE.'N')GOTO 900
465   TYPE*,' Enter a minimum Kappa-value for use in phase'
      TYPE*,' determinations or DEFAULT of [0.6]. (Real)'
      READ(5,1465)REAL
1465  FORMAT(F6.0)
      IF (REAL.NE.0.0)THEN
        ENCODE(80,1466,C(1:10),ERR=9465)REAL
1466    FORMAT(' KMI ',F6.4)
        TYPE 6,C(1:10)
        WRITE(4,1)C(1:10)
      ENDIF
470   TYPE*,' Enter ''LIST'' for a full listing of convergence map'
      TYPE*,' or ''NOLIST'' for no listing of the map, or RETURN for'
      TYPE*,' default which is a listing of the bottom 60 places.'
      ACCEPT 1,C(1:7)
      IF(C(1:4).NE.BLANK)THEN
        TYPE 6,C(1:7)
        WRITE(4,1)C(1:7)
      ENDIF
475   TYPE*,' Enter number of special reflections required in starting'
      TYPE*,' set, or RETURN for default. (Integer)'
      ACCEPT 1,C(5:9)
      IF(C(5:8).NE.BLANK)THEN
        C(1:4)='SPE '
        TYPE 6,C(1:9)
        WRITE(4,1)C(1:9)
      ENDIF
480   TYPE*,' Enter number of general reflections required in starting '
      TYPE*,' set, or RETURN for default. (Integer)'
      ACCEPT 1,C(5:9)
      IF(C(5:8).NE.BLANK)THEN
        C(1:4)='GEN '
        TYPE 6,C(1:9)
        WRITE(4,1)C(1:9)
      ENDIF
485   TYPE*,' Enter number of reflections of any sort required in '
      TYPE*,' starting set, or RETURN. (Integer) '
      ACCEPT 1,C(5:9)
      IF(C(5:8).NE.BLANK)THEN
        C(1:4)='ANY '
        TYPE 6,C(1:9)
        WRITE(4,1)C(1:9)
      ENDIF
490   TYPE*,' Enter the maximum number of phase sets to be generated.'
      TYPE*,' Default is 300.  If the starting set is not specified,'
      TYPE*,' the default becomes 3/2 times the number of independent'
      TYPE*,' reflections. (Integer) '
      ACCEPT 1,C(5:9)
      IF(C(5:8).NE.BLANK)THEN
        C(1:4)='MAX '
        TYPE 6,C(1:9)
        WRITE(4,1)C(1:9)
      ENDIF
495   CONTINUE
      GOTO 900
C******************************************************************
C
C  PARAMETERS FOR LAST
C
C******************************************************************
500   TYPE*,' Do you wish to accept LAST defaults? [Y]/N '
      READ(5,1)C(1:1)
      IF (C(1:1).NE.'N')GOTO 900
501   TYPE*,' Do you wish to run SAYTAN? Y/[N] '
      READ(5,1)C(5:5)
      IF(C(5:5).EQ.'Y')THEN
        C(1:4)='SAY '
        TYPE 6,C(1:4)
        WRITE (4,1)C(1:4)
505     TYPE*,' Enter a scaling factor to be applied to the'
        Type*,' zero-quartets or RETURN for default'
        READ(5,1)C(5:12)
        IF(C(5:5).NE.BLANK)THEN
          C(1:4)='QZS '
          TYPE 6,C(1:12)
          WRITE (4,1)C(1:12)
        ENDIF
510     TYPE*,' Do you want to see the value of QZSC? Y/[N] '
        READ(5,1)C(5:5)
        IF(C(5:5).EQ.'Y')THEN
          C(1:5)='WRI 1 '
          TYPE 6,C(1:5)
          WRITE (4,1)C(1:5)
        ENDIF
515     TYPE*,' Enter a scaling factor to be applied to the'
        TYPE*,' the big-quartets. (Default is zero) '
        READ(5,1)C(5:12)
        IF(C(5:5).EQ.'Y')THEN
          C(1:4)='QBS '
          TYPE 6,C(1:12)
          WRITE (4,1)C(1:12)
        ENDIF
520     TYPE*,' Do you wish to use the XMY parameter-shift '
        TYPE*,' method for phase determination? Y/[N] '
        READ(5,1)C(5:5)
        IF(C(5:5).EQ.'Y')THEN
          C(1:4)='XMY '
          TYPE 6,C(1:4)
          WRITE (4,1)C(1:4)
        ENDIF
      ENDIF
525   TYPE*,' Do you want to run RANTAN? Y/[N]'
      READ(5,1)C(5:5)
      IF(C(5:5).EQ.'Y')THEN
        C(1:4)='RAN '
        TYPE*,' What starting value would you like to assign '
        TYPE*,' to all phases (integer value)? '
        READ(5,1)C(5:12)
        TYPE 6,C(1:12)
        WRITE (4,1)C(1:12)
530     TYPE*,' Enter the maximum number of phase sets to be generated.'
        TYPE*,' Default is 300.  If the starting set is not specified,'
        TYPE*,' the default becomes 3/2 times the number of independent'
        TYPE*,' reflections.'
        ACCEPT 1,C(5:9)
        IF(C(5:8).NE.BLANK)THEN
          C(1:4)='MAX '
          TYPE 6,C(1:9)
          WRITE(4,1)C(1:9)
        ENDIF
535     TYPE*,' Do you wish to continue generating phase sets '
        TYPE*,' even after a very good one has been found? Y/[N] '
        READ(5,1)C(5:5)
        IF(C(5:5).EQ.'Y')THEN
          C(1:4)='ALL '
          TYPE 6,C(1:4)
          WRITE (4,1)C(1:4)
        ENDIF
      ENDIF
540   TYPE*,' If your last run ran out of time, what was the'
      TYPE*,' last phase set to be written to the output file -- '
      TYPE*,' RETURN to skip '
      READ(5,1)C(5:12)
      IF(C(5:8).NE.BLANK)THEN
        C(1:4)='SKI '
        TYPE 6,C(1:12)
        WRITE (4,1)C(1:12)
      ENDIF
545   TYPE*,' Enter weight of absolute figure of merit for the '
      TYPE*,' combined figure of merit or DEFAULT of [0.6]'
      ACCEPT 1,C(5:12)
      IF(C(5:8).NE.BLANK)THEN
        C(1:4)='ABS '
        TYPE 6,C(1:12)
        WRITE(4,1)C(1:12)
      ENDIF
550   TYPE*,' Enter weight of psi-zero figure of merit for combined'
      TYPE*,' figure of merit or DEFAULT [1.2]'
      ACCEPT 1,C(5:12)
      IF(C(5:8).NE.BLANK)THEN
        C(1:4)='PSI '
        TYPE 6,C(1:12)
        WRITE(4,1)C(1:12)
      ENDIF
555   TYPE*,' Enter weight of residual figure of merit for combined'
      TYPE*,' figure of merit or DEFAULT [1.2]'
      ACCEPT 1,C(5:12)
      IF(C(5:8).NE.BLANK)THEN
        C(1:4)='RES '
        TYPE 6,C(1:12)
        WRITE(4,1)C(1:12)
      ENDIF
C                                PHASES
560   TYPE*,' Enter number of starting phases.'
      TYPE*,' (Max is 250) Return is [0]'
      READ (5,10,ERR=9560)IMK     !Number of phases to be read
      IF(IMK.NE.0)THEN
C
        CALL RD20(IMK,ICD)        ! SUBROUTINE TO READ IN CODES,MARKERS,
C        GO TO 900               ! MUST BE FINAL KEYWORD IF USED
      ENDIF
565   TYPE*,' Do you want to specify phase sets? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')GO TO 900
      TYPE*,' Enter the number of phase sets you want. Max of 12.'
      ACCEPT 10,IMK                 ! NUMBER OF SETS
      IF (IMK.GT.12) THEN
        TYPE*, 'Ooops, the maximum number of phase sets is 12.'
        TYPE*, 'Try again'
        GOTO 565
      ENDIF
      ENCODE (3,1565,C(6:8))IMK
      C(1:5)='SETS '
      WRITE(4,1)C(1:8)
      TYPE 6,C(1:8)
1565  FORMAT(I3)
C      IMK2=IMK
C566   IF(IMK2.LT.21)THEN
C        NN=IMK
        TYPE 1566,IMK
1566    FORMAT(' Enter ',I3,' phase set numbers, in ascending',
     1  ' order, in 20I4 format.')
        READ(5,1567)(ICD(JJ),JJ=1,NN)
1567    FORMAT(<NN>I4)
C      ELSE
C        NN=20
C        IMK2=IMK-20         ! LEFT TODO
C        TYPE 1566,NN
C        READ(5,1567)(ICD(JJ),JJ=1,NN)
C      ENDIF
      NN4=NN*4                ! NUMBER OF BYTES
      TYPE 6,(ICD(JJ),JJ=1,NN)
      ENCODE(NN4,1567,C(1:NN4))(ICD(JJ),JJ=1,NN)
      WRITE(4,1)C(1:NN4)
C      IF(IMK2.GT.0)GO TO 566  
      NORM=0
C********************************************************************
600   CALL MAPSIN
      GOTO 800
900   C4='END '
      ENCODE(80,150,CARD)C4
      TYPE 2,CARD
      WRITE(4,3)CARD
800   STOP  
9310  ASSIGN 310 TO IGO
      GO TO 999
9330  ASSIGN 330 TO IGO
      GO TO 999
9333  ASSIGN 333 TO IGO
      GO TO 999
9400  ASSIGN 400 TO IGO
      GO TO 999
9410  ASSIGN 410 TO IGO
      GO TO 999
9415  ASSIGN 415 TO IGO
      GO TO 999
9420  ASSIGN 420 TO IGO
      GO TO 999
9433  ASSIGN 433 TO IGO
      GO TO 999
9465  ASSIGN 465 TO IGO
      GO TO 999
9560  ASSIGN 560 TO IGO
      GO TO 999
919   ASSIGN 800 TO IGO
      GO TO 999
999   TYPE*,'  Error on last input. Try again'
      GO TO IGO
9999  TYPE*,' ERROR OPENING .CDR FILE'
      END
