c PROGRAM TO CONVERT .DAT FILES GENERATED BY CAMBRIDGE (CSD) SEARCHES
C TO .CRD COORDINATE FILES, WRITING CELL PARAMETERS AS CELL CARD.
C
      REAL x,y,z,a,b,c,alpha,beta,gamma,cell(6)
      INTEGER x1,x2,x3,y1,y2,y3,z1,z2,z3,icell(12),num
      CHARACTER*4 dummy_char,atom1,atom2,atom3
      CHARACTER*129 Line
      CHARACTER*10 CSDname,name
      CHARACTER*12 fileCRD
      CHARACTER*3 FF
      LOGICAL file_exists,Yes_FF,Yes_EndAtom
      INTEGER ix,iy,iz,istart,num_blocks
C
C Initializing some variables:
      Yes_FF=.TRUE.      !Will try to guess form factors
      Yes_EndAtom=.TRUE. !Strict constraints checking for end of atoms
C
      WRITE(*,*)
      WRITE(*,*)
      WRITE(*,*)
      WRITE(*,8)
      WRITE(*,9)'                                                    '
      WRITE(*,9)'   CONVERTING CSD .DAT FILE TO CRYM FORMAT          '
      WRITE(*,9)'                                                    '
      WRITE(*,9)'This program will read your NAME.DAT file and write '
      WRITE(*,9)'a new filename.CRD file with a CELL card & COORD    '
      WRITE(*,9)'cards.  (Where filename = CSD reference code name.) '
      WRITE(*,9)'                                                    '
      WRITE(*,8)
      WRITE(*,*)
      WRITE(*,*)
    9 FORMAT(8x,'*',3x,a52,3x,'*')
    8 FORMAT(8X,'***************************************************',
     1 '*********')
C
      WRITE(*,*)
   90 format(a1)
C Opening .DAT file
          INQUIRE(unit=5,EXIST=file_exists)
          IF(file_exists) THEN
               OPEN(unit=5,STATUS='OLD',READONLY) ! .DAT file
                       ELSE
               WRITE(*,*)'ERROR - INPUT FILE DOES NOT EXIST!'
               GOTO 1000
          ENDIF
C
  105 WRITE(*,*)
C Find out what structure name you want:
      REWIND (5)
  108 Write(*,*)' Input CSD structure code name you are',
     1    ' interested in',' ("Q" to exit; "**" for special options):'
      read(*,110)CSDname
  110 format(a8)
C      
C   CALL CAPITALIZE
C
      CALL CAPITALIZE(CSDNAME,8)
C
C Checking input
      if(CSDname(1:1).ne.' ') goto 115
          write(*,*)' Invalid name, try again!'
          goto 108 
  115 if(CSDname(1:2).eq.'Q ')goto1000
C To look at the special options menu:
      if(CSDname(1:2).eq.'**') then
            Call Special_Options(Yes_FF,Yes_EndAtom)
            goto 108
      endif
C Opening .CRD output file
      DO 117 i=8,1,-1
      if(CSDname(i:i).ne.' ')goto 118
  117 continue
  118 fileCRD(1:i)=CSDname(1:i)
      fileCRD(i+1:i+4)='.CRD'
      OPEN(unit=7,file=fileCRD,status='new',carriagecontrol='list')
C
C Start searching for CSD structure codenames
      write(*,*)'Starting search,...'
  120 READ(5,125,END=200)Line
  125 FORMAT(A80)
C
      DECODE(80,127,line)dummy_char
  127 FORMAT(A1)
C
C Look for # to indicate structure codename
      IF(dummy_char .EQ. '#') THEN
          DECODE(80,137,line)name
  137     FORMAT(1x,A8)
          if(name.eq.CSDname) goto 300
      endif 
      goto 120
C
  200 write(*,*)' Reference code not found!'
      write(*,*)
      goto 105
C
C
C Write out first line of data
  300 write(*,*)' Found reference code: ',CSDname
C Find cell paramters:
      READ(5,125,END=999)Line
C    icell(1-6) are a,b,...gamma, x10**icell(7-12)
      DECODE(80,306,line,ERR=310)(icell(i),i=1,12)
  306 format(6I6,6I1)
	      DO 308 i=1,6
	      cell(i)=float(icell(i)) / 10.0**float(icell(i+6))
  308 continue
      write(*,*)
      write(*,*)' Generated CELL card:'
      write(7,309)(cell(i),i=1,6)
  309 format('CELL',2x,3(f7.4,1x),3(f7.3,1x))
      write(*,309)(cell(i),i=1,6)
      write(*,*)
      goto 319
C
C Can't generate CELL card!
  310 write(*,*)' Error generating CELL card - DO IT YOURSELF!'
      write(*,*)
C backing up to beginning of data
  319 WRITE(*,*)
      BACKSPACE(5)
      BACKSPACE(5)
C Write out first few lines of data
      num_blocks=0  !helps keep track of how many lines read/written
  318 istart=1+(num_blocks*12)  !starting line number of output
      DO 325 j=istart, istart+11
  320 READ(5,125,END=328)LINE
      write(*,322)j,line
  322 format(' (',i2,') ',a73)
  325 continue
C find out which line data begins on
  328 write(*,*)
      write(*,*)' Coordinate data begins on which line number',
     1          ' (0 for more lines):'
      read(*,330)num
  330 format(i2)
C check for valid input; must be ge zero and le no. lines written
          if ((num.lt.0).or.(num.ge.13+(num_blocks*12))) then
              write(*,*)'ERROR: invalid line number!  Try again.'
              goto 328
          endif
C check for zero input; this means print more lines out
      if(num.eq. 0) then
          num_blocks = num_blocks + 1
          goto 318  !go print more lines
      endif
C backup to specified line
      do 335 i=1,(13+num_blocks*12)-num
      BACKSPACE(5)
  335 continue
C 
C Start reading coordinates
C
      write(*,*)' Generating COORD cards:'
  333 READ(5,125,END=999)LINE
          DECODE(80,337,line)atom1,x1,y1,z1,atom2,x2,y2,z2,
     1                       atom3,x3,y3,z3
  337     FORMAT(A4,1x,3i7,1x,a4,1X,3i7,1x,a4,1X,3i7)
      if((atom1(1:1).eq.'#').or.(atom1(1:1).eq.' ')) goto 400
C writing out coordinates 
      x = float(x1) / 100000.0
      y = float(y1) / 100000.0
      z = float(z1) / 100000.0
C call subroutine to `guess' form factor
      CALL Form_Factor(atom1,FF,Yes_FF)
      Write(7,340)atom1,FF,x,y,z
  340 format('COORD',1x,A4,2x,A3,3F9.6)
      Write(*,340)atom1,FF,x,y,z
C
C check for end of atoms
      if((atom2(1:1).eq.'#').or.(atom2(1:1).eq.' ')) goto 400
C
      x = float(x2) / 100000.0
      y = float(y2) / 100000.0
      z = float(z2) / 100000.0
      CALL Form_Factor(atom2,FF,Yes_FF)
      Write(7,340)atom2,FF,x,y,z
      Write(*,340)atom2,FF,x,y,z
C
C check for end of atoms
      if((atom3(1:1).eq.'#').or.(atom3(1:1).eq.' ')) goto 400
C
      x = float(x3) / 100000.0
      y = float(y3) / 100000.0
      z = float(z3) / 100000.0
      CALL Form_Factor(atom3,FF,Yes_FF)
      Write(7,340)atom3,FF,x,y,z
      Write(*,340)atom3,FF,x,y,z
C
      goto 333
C  End of referenced data reached. 
  400 write(*,*)
      write(*,*)
      goto 105
C
  500 WRITE(*,*)' End of .TAB file reached.'
  999 write(*,*)' Error: encountered end of file!'
 1000 WRITE(*,*)
      END
C
C ****************************************************************
C
      SUBROUTINE Special_Options(Yes_FF,Yes_EndAtom)
C Allows user to toggle on/off the guessing of form factors and the
C most restrictive constraints on checking end of atom list
      logical Yes_FF,Yes_EndAtom
      character*4 answer
1110  WRITE(*,*)
      WRITE(*,*)'              CURRENT OPTIONS             '
      WRITE(*,*)
      if (Yes_FF) then
         WRITE(*,*)'(F) Form Factor option:    ON   - will insert ',
     1          'form factor'
       else
         WRITE(*,*)'(F) Form Factor option:    OFF  - will not insert',
     1          ' form factor'
      endif
C
      if (Yes_EndAtom) then
          WRITE(*,*)'(E) End Atom List option:  ON   - may cut-off ',
     1          'atom list too soon'
        else
          WRITE(*,*)'(E) End Atom List option:  OFF  - may cut-off ',
     1          'atom list late'
      endif
      WRITE(*,*)
C
      write(*,1120)
1120  format(1x,'Choose option (Q to search or quit)')
      READ(*,'(a)')answer
      if((answer.eq.'Q').or.(answer.eq.'q')) goto 1149
      if((answer.eq.'F').or.(answer.eq.'f')) Yes_FF=.NOT.(Yes_FF)
      if((answer.eq.'E').or.(answer.eq.'e')) Yes_EndAtom =
     1                                      .NOT.(Yes_EndAtom)
      goto 1110
1149  write(*,*)
      RETURN 
      END
C
C ****************************************************************
C
      SUBROUTINE Form_Factor(atom,FF,Yes_FF)
C Tries to guess Form Factor from CSD atom name
      CHARACTER*4 atom
      CHARACTER*3 FF,FFS(48),FFtemp
      LOGICAL Yes_FF
C IF YOU ADD ELEMENTS, CHANGE LINE BELOW AND SIZE OF FFS (above)
      num_elements = 48
C                1     2     3     4     5     6     7     8
      DATA FFS/'H**','HF ','HE ','A**','AU ','AG ','AL ','AS ',
     1         'N**','NI ','NA ','NB ','NE ',
     2         'C**','CL ','CU ','CR ','CA ','CS ','CD ','CO ',
     3         'P**','PT ','PD ','PB ',
     4         'R**','RH ','RU ','RE ','RB ',
     5         'S**','SI ','SN ','SC ','SE ','SR ','SB ',
     6         'O**','OS ',
     7         'B**','BE ','BA ','BR ','BI ',
     8         'I**','IR ','IN ',
     9         'F**'/
      FF='   '
      IF (.NOT. Yes_FF) goto 1299
C Search for any first letter matches in form factor data list
      DO 1250 i=1,num_elements
      if((FFS(i)(2:3).eq.'**').and.(atom(1:1).eq.FFS(i)(1:1)))goto1260
1250  CONTINUE
C No match found - return
      GOTO 1299
C continue search; now looking for a match
1260  FF=FFS(i)(1:1)
      DO 1280 j=i+1,num_elements
      if(FFS(j)(2:3).eq.'**') goto 1290
      if(FFS(j)(1:2).eq.atom(1:2))FF=FFS(j)
1280  CONTINUE
1290  if(FF(1:1).eq.'H') FF='HS '
1299  RETURN
      END
      subroutine CaPiTaLiZe(a,l)
c
c This subroutine capitalizes lowercase letters in a character string
c
      CHARACTER*(*) A
      DO I=1,L
      N=ICHAR(A(I:I))
      IF (N .GT. 96 .AND. N .LT. 123) A(I:I)=CHAR(N-32)
      ENDDO
      return
      END
