C   ROUTINE DECAY2
C
C   THIS PROGRAM CALCULATES THE FIT AND CORRESPONDING STANDARD
C   DEVIATIONS FOR LINEAR TIME DECAY CURVES WITH INPUT COEFFICIENTS.
C
      parameter mc=16,mcm=1000
      character*80 idhkl(mc)
      character*132 line
      integer h,k,l,nochek,chekno(mc),id(mc,mcm)
      real t(mc,mcm),fobs(mc,mcm),sigma(mc,mcm),f0(mc,2),a(mc),b(mc)
      real gof(mc,2),fcal(mc,mcm,2),resi(mc,mcm,2),wt(mc,mcm)
      real sumf(mc),sumw(mc)
c
      OPEN(UNIT=5,STATUS='OLD')
      OPEN(UNIT=6,STATUS='new',carriagecontrol='list')
c
      TYPE *, 'Enter A value and (optional) end time (in hours):'
      read (*,12) Atot, TIMEEND
   12 format(2f10.4)
      atots=atot*.001
c 
c
      read(5,1)line
    1 format(a)
      if(line(4:7) .ne. 'DECA') then
       write(6,2)
    2  format(' Not a DECAY file; no DECA on first line')
       stop
      endif
      read(5,1)line
      decode(14,3,line,err=4)timestart
    3 format(6x,f8.2)
      nochek=0
c
c read in check reflections
c
    6 read(5,1,end=8)line
c see if new check
      if (line(2:8) .eq. 'CHECK #') then
       nochek=nochek+1
       chekno(nochek)=0
       sumf(nochek)=0.0
       idhkl(nochek)=line(1:80)
c see if data
      elseif (line(15:15).eq.'.' .and. line(75:75).eq.'.') then 
       chekno(nochek)=chekno(nochek) + 1
       decode(132,7,line,err=4) id(nochek,chekno(nochek)),
     1 t(nochek,chekno(nochek)),fobs(nochek,chekno(nochek)),
     2 sigma(nochek,chekno(nochek)),
     3 fcal(nochek,chekno(nochek),1),resi(nochek,chekno(nochek),1)
    7  format(i7,f10.2,f10.3,f9.3,32x,2f11.3)
       if(t(nochek,chekno(nochek)).gt.timeend)
     1   timeend=t(nochek,chekno(nochek))
       wt(nochek,chekno(nochek))=1./sigma(nochek,chekno(nochek))
       sumw(nochek)=sumw(nochek)+wt(nochek,chekno(nochek))
       sumf(nochek)=sumf(nochek)+fobs(nochek,chekno(nochek))*
     1  wt(nochek,chekno(nochek))/(1.+atots*t(nochek,chekno(nochek)))
      elseif (line(79:80).eq.'A=') then 
       decode(132,9,line,err=4) f0(nochek,1),a(nochek)
    9  format(68x,f8.2,4x,f8.4)
      endif
      goto 6
c
c
c
    8 percent=-100.*atots*(timeend-timestart)
      write(6,13) atot,timestart,timeend,percent
   13 format('  Test of linear decay coefficient'/
     1       '          with A (x10^3) =',f8.4/
     2       '  data collection started at',f6.2,' hours'/
     3       '               and ending at',f6.2,' hours,'/
     4       '  the percent decay of F is',f7.2//)
c
c
c  Add to inf file
c
      do i=1,nochek
       f0(i,2)=sumf(i)/sumw(i)
        gof(i,1)=0.        
        gof(i,2)=0.        
        do j=1,chekno(i)
        fcal(i,j,2)=f0(i,2)*(1.+atots*t(i,j))
         resi(i,j,2)=(fobs(i,j)-fcal(i,j,2))/(1/wt(i,j))
         gof(i,1)=gof(i,1)+(wt(i,j)*(fobs(i,j)-fcal(i,j,1)))**2
         gof(i,2)=gof(i,2)+(wt(i,j)*(fobs(i,j)-fcal(i,j,2)))**2
        enddo
        degf=float(chekno(i))-2.
        gof(i,1)=sqrt(gof(i,1)/degf)
        gof(i,2)=sqrt(gof(i,2)/degf)
c
c
c
        write(6,1) idhkl(i)
        write (6,14)
   14   format(/3x'ID#'5x'T'6x'F(obs)'4x'Sigma'5x'F(calc)  Residual' 
     1         4x'F(calc)  Residual')
        do j=1,chekno(i)
         write(6,10) id(i,j),t(i,j),fobs(i,j),sigma(i,j),fcal(i,j,1),
     1    resi(i,j,1),fcal(i,j,2),resi(i,j,2)
   10    format(i7,f7.2,f10.3,f9.3,2(f12.3,f9.3))
       enddo
       write(6,11) f0(i,1),f0(i,2),a(i),atot,gof(i,1),gof(i,2) 
   11  format(32x,'F(0)='f8.2,8x,'F(0)=',f8.2,/
     1        35x,'A='f8.4,11x,'A='f8.4/
     2        33x,'GOF='f6.2,9x,'''GOF''='F6.2///)
      enddo
      stop
    4 write(6,5)line  
    5 format(' Error decoding this line'/a)
      stop
      end
