C
      PROGRAM SHElinsight
C
C VAX/VMS Version of SHELXL-93 - Crystal Structure Refinement
c to read .ins file and output parameters
C
c
c  XRAY.FRM
c
c
c  # xray.frm
c  # format file for reading atoms from xray facility
c  #
c  
c  # title
c  FORMAT_FOR 1
c  TITLE             1   80
c  END_FORMAT
c  
c  # space group
c  FORMAT_FOR 1
c  MARKER            1    "SPACE GROUP"
c  SPACE_GROUP      13   15
c  END_FORMAT
c  
c  # cell parameters
c  FORMAT_FOR 1
c  MARKER            1    "CELL"
c  CELL_A            7    8
c  CELL_B           15    8
c  CELL_C           23    8
c  ALPHA            31    8
c  BETA             39    8
c  GAMMA            47    8
c  END_FORMAT
c  
c  # number of atoms
c  FORMAT_FOR 1
c  NUM_ATOMS         1    4
c  END_FORMAT
c  
c  # atom data
c  FORMAT_FOR $NUM_ATOMS
c  DEFINE_ATOM
c  ATOM_NUMBER       1    4
c  ATOM_NAME         6    4
c  ELEMENT_NUMBER   10    4
c  ATOM_X           16    9
c  ATOM_Y           25    9
c  ATOM_Z           34    9
c  OCCUPANCY        43    9
c  #TEMP_FACTOR      49    9
c  END_FORMAT
c  
c
c
      CHARACTER*1 IH(50),KD
      CHARACTER*76 IT
c it is TITLE
      CHARACTER*80 NM,FN,IR
      INTEGER MH(512),MK(512),ML(512),MB(512)
      REAL FF(512),SI(512),FC(512),SQ(512),WL(512),FB(512)
      REAL A(250000),B(1250000),C(12000)
      COMMON ST,SL,TC,TL,LM,LU,IM,LR,LG,LH,LI,LP,LF,LA,LC,LW,LY,LL,LB,
     +LX,LE,LV,LJ,LD,LS,LO,LT,LK,LQ,LZ,LN,KH,IV,JA,JB,JC,JD,JW,HA,HD
      COMMON/SMALL/A
      COMMON/LARGE/B
      COMMON/ADMAT/C
      COMMON/REFL/MB,MH,MK,ML,FF,SI,SQ,WL,FB,FC
      COMMON/WORD/IH,IT,IR,NM,KD
      COMMON/VAX/IVX,INCH
      COMMON/TTY/KS
      CHARACTER*1 KS
      INTEGER*2 INCH
      INTEGER LIB$INIT_TIMER,SYS$ASSIGN
      I=LIB$INIT_TIMER(IVX)
      I=SYS$ASSIGN('SYS$INPUT',INCH,,)
      KS=CHAR(1)
C
C KD should be set to CHAR(13) for UNIX systems to write the .res
C file in DOS rather than UNIX format with <CR><LF> instead of <LF>
C as line terminator. This is useful if the disk can also be accessed
C by MSDOS PC's.  For standard UNIX action, set KD to CHAR(32) here.
C
      KD=CHAR(32)
C
C Switch off meaningless 'underflows' here if necessary (IBM etc.).
C Start timing and set default maxtime TL for finishing off.  TL
C could be set to say 0.8 times CPU limit for the job, if known.
C The value of TL may be reduced but not increased by means of
C the TIME instruction in the .ins file.  TC (and TX in the IBM
C version) handle possible resetting of the clock at midnight.
C
      TL=999999.
      TC=0.
      CALL SXTI(SL)
      ST=SL
C
C IM is the maximum number of parameters which may be refined in one
C full-matrix block.  The dimension of C in COMMON/ADMAT/ must be 8*IM.
C In order to increase the maximum number of parameters, IM and COMMON
C /ADMAT/ should be increased, the dimensions of C..C7 in subroutine
C SXMM should be equal to IM, and JW and the dimension of B IN COMMON
C /LARGE/ should be appreciably (at least 10%) larger than IM*(IM+5)/2.
C For conjugate gradient refinement (CGLS) IM is ignored but B must be
C large enough to store 7*NP plus the restraints part of the Jacobian
C (as a sparse matrix), where NP is the number of parameters.
C
      IM=1500
C LM is the dimension of A (used to store crystal data, instructions and
C atoms).  JW = dimension of B (working space).  Both should be 16000 or
C greater;  in the standard version LM = 250000 and JW = 1250000 which
C corresponds to IM = 1500 and a maximum of about 5000 atoms.
C
      LM=250000
      JW=1250000
C
C LU is the buffer size for input/output, and must be equal to the
C dimensions of the arrays in COMMON/REFL/.  If these dimensions are
C changed, they must be changed in all routines.  Since these arrays
C are also used for other purposes it is not advisable to reduce LU
C from the standard value of 512, but it may be increased.
C
      LU=512
C
C IV is the optimum vector length for the least-squares calculations,
C and determines the dynamic memory partitioning of array B in the
C subroutine SX3D.  The best value to use depends on a subtle
C compromise between vector processing efficiency and cache sizes.
C Even for purely scalar machines too low a value will certainly be
C inefficient. For many systems 512 is a good value for both IV and LU;
C it is more efficient if IV is a multiple of 8 and if LU is a multiple
C of IV.  If the array B is not large enough the program may have to
C use a smaller vector length; the value actually used is printed out
C at the start of each cycle (it may change from cycle to cycle !).
C The fourth number on the L.S. and CGLS instructions overrides the
C default maximum value defined below, and so can be used for testing
C the effect of different vector lengths.
C
      IV=512
C
C Set chars/inch across (HA) and lines/inch down page (HD)
C (usually HA=10. and HD=6. or 8., more for laser printers).
C This is only used for the 'lineprinter plots' of electron
C density syntheses (PLAN -n).
C
      HA=16.6667
      HD=10.
C
C Set unit numbers for files.   All unit numbers must be
C different, and all files used by SHELXL-93 are sequential.
C LR is incremented to read include files ('+filename') and
C so must be larger than all other unit numbers; LK stores
C the original value of LR.
C
      LW=1
      LA=2
      LH=3
      LC=4
      LF=8
      LP=9
      LI=10
      LZ=11
      LQ=12
      LR=14
      LK=LR
      natoms=0
c     number of atoms read in      
C
C Open files using name from command line and standard extensions.
C The OPEN statements may need to be changed for some computers.
C Subroutine SXNM gets the generic filename from the command line.
C If the files are to be defined completely externally to the
C program (e.g. in an IBM or REX 'EXEC' procedure on an IBM
C computer), then SXNM sets LN to 0.  Units 9 and 11 will often have
C STATUS='UNKNOWN' but VMS requires 'NEW'.  For UNIX, all filenames
C should be lowercase.
C
      CALL SXNM
      L=0
      IF(LN.EQ.0)GOTO 1
      L=LN+4
      FN=NM(1:LN)//'.ins'
      OPEN(UNIT=LR,FILE=FN(1:L),STATUS='OLD',ERR=7)
c      FN=NM(1:LN)//'.lst'
c      OPEN(UNIT=LI,FILE=FN(1:L),STATUS='NEW',ERR=7)
      FN=NM(1:LN)//'.frm'
      OPEN(UNIT=13,FILE=FN(1:L),STATUS='NEW',ERR=7,
     +CARRIAGECONTROL='LIST')
C
C Comment out the next statement if the listing file is NOT destined
C for compressed mode output on an HP or compatible laserprinter.  It
C may be necessary to add a directive to the format (1X,A) to make
C sure that no carriage control characters are written to the file
C before the first escape character.  Note that the ampersand (&) is
C sometimes lost in email transmissions; it comes before 'l0o..' in
C the first text string.
C
C     WRITE(LI,'(1X,A)')CHAR(27)//'&l0o5c1X'//CHAR(27)//'(0u'//
C    +CHAR(27)//'(s0p16.66h8.5v0s0b0T'
C
c      FN=NM(1:LN)//'.res'
c      OPEN(UNIT=LP,FILE=FN(1:L),STATUS='NEW',ERR=7,
c     +CARRIAGECONTROL='LIST')
C
C Open scratch files (unformatted, sequential).  As above,
C OPEN statements may need to be changed for some computers
C
      FN='SCRATCH'
      L=7
      OPEN(UNIT=LA,STATUS='SCRATCH',FORM='UNFORMATTED',ERR=7)
      OPEN(UNIT=LC,STATUS='SCRATCH',FORM='UNFORMATTED',ERR=7)
      OPEN(UNIT=LF,STATUS='SCRATCH',FORM='UNFORMATTED',ERR=7)
C
C Delete any name.fin left over from a previous job
C
      CALL SXFN(I)
C
C Print heading then call SX3A, SX3B and SX3C, which may be
C overlay segments.  SX3A reads and interprets the .ins instruction
C file, SX3B sets up restraints and fits model groups and SX3C
C processes reflection data and analyses constraints.
C
   1  CALL SXTL
      CALL SX3A
c      CALL SX3B
C
C Open remaining files here if required by input instructions
C
c      IF(LN.EQ.0)GOTO 2
c      L=LN+4
c      IF(A(131).LT.0.5)GOTO 2
c      FN=NM(1:LN)//'.hkl'
c      OPEN(UNIT=LW,FILE=FN(1:L),STATUS='OLD',ERR=7)
c   2  CALL SX3C
c      CLOSE(UNIT=LR,STATUS='KEEP',IOSTAT=I)
c      IF(A(73).LT.0.5)GOTO 3
c      IF(LN.EQ.0)GOTO 3
c      FN=NM(1:LN)//'.fcf'
c      OPEN(UNIT=LZ,FILE=FN(1:L),STATUS='NEW',ERR=7,
c     +CARRIAGECONTROL='LIST')
c   3  IF(A(74).LT.0.5)GOTO 4
c      IF(LN.EQ.0)GOTO 4
c      FN=NM(1:LN)//'.cif'
c      OPEN(UNIT=LH,FILE=FN(1:L),STATUS='NEW',ERR=7,
c     +CARRIAGECONTROL='LIST')
c   4  IF(ABS(A(199)).LT.0.5)GOTO 5
c      IF(LN.EQ.0)GOTO 5
c      FN=NM(1:LN)//'.pdb'
c      OPEN(UNIT=LQ,FILE=FN(1:L),STATUS='NEW',ERR=7,
c     +CARRIAGECONTROL='LIST')
C
C Call remaining subroutines, which may each be overlay segments.
C SX3D and SX3E are the sfls routines, SX3F produces the analysis
C of variance and tables, and SX3G does Fouriers, peaksearch etc.
C
c   5  CALL SX3D
c      CALL SX3E
c      IF(LK.GT.0)GOTO 5
c      CALL SX3F
c      CALL SX3G
      CALL SXIT
   6  FORMAT(/'  CANNOT OPEN FILE ',A)
   7  WRITE(*,6)FN(1:L)
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXNM
C
C Get generic filename (NAME) and its length (LN) from the command
C line.  Set LN to 0 if the file names are to be defined externally
C in a command procedure.  This subroutine is very computer-specific.
C For UNIX, all filenames are converted to lower case.
C
      CHARACTER*1 IH(50),KD,KS
      CHARACTER*76 IT
      CHARACTER*80 NM,IR
      COMMON ST,SL,TC,TL,LM,LU,IM,LR,LG,LH,LI,LP,LF,LA,LC,LW,LY,LL,LB,
     +LX,LE,LV,LJ,LD,LS,LO,LT,LK,LQ,LZ,LN,KH,IV,JA,JB,JC,JD,JW,HA,HD
      COMMON/WORD/IH,IT,IR,NM,KD
      INTEGER CLI$GET_VALUE
C
   1  FORMAT(/'   ** BAD COMMAND LINE **'/)
C
      LN=0
      NM=' '
      I=CLI$GET_VALUE('$LINE',NM)
      M=0
        DO 2 I=1,80
        KS=NM(I:I)
        NM(I:I)=' '
        IF(KS.EQ.' ')GOTO 2
        M=M+1
        IF(M.EQ.I)GOTO 2
        LN=LN+1
        NM(LN:LN)=KS
   2    CONTINUE
      IF(LN.GT.0)GOTO 3
      WRITE(*,1)
      STOP
   3  RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXTL
C
C Put out heading and other useful information. This computer-
C specific routine is called once, from the main program.
C
      CHARACTER*1 IH(50),KD
      CHARACTER*9 DT
      CHARACTER*11 TM
      CHARACTER*76 IT
      CHARACTER*80 NM,IR
      COMMON ST,SL,TC,TL,LM,LU,IM,LR,LG,LH,LI,LP,LF,LA,LC,LW,LY,LL,LB,
     +LX,LE,LV,LJ,LD,LS,LO,LT,LK,LQ,LZ,LN,KH,IV,JA,JB,JC,JD,JW,HA,HD
      COMMON/WORD/IH,IT,IR,NM,KD
C
   1  FORMAT(/' ',64('+')/' +  SHELXL-93 - ',
     +' random output stuff +'
c     +'CRYSTAL STRUCTURE REFINEMENT - VAX/VMS VERSION  +'
     +/' +  ',A24,'  started at ',A8,' on ',A9,'  +'/' ',64('+')/)
      CALL SXPG(LI)
      CALL TIME(TM)
      CALL DATE(DT)
      L=LN
   2  IF(NM(L:L).EQ.':')GOTO 3
      IF(NM(L:L).EQ.']')GOTO 3
      L=L-1
      IF(L.GT.0)GOTO 2
   3  M=L+24
      IF(M.GT.80)M=80
c      WRITE(LI,1)NM(L+1:M),TM(1:8),DT
      WRITE(*,1)NM(L+1:M),TM(1:8),DT
      RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXTI(T)
      COMMON ST,SL,TC,TL,LM,LU,IM,LR,LG,LH,LI,LP,LF,LA,LC,LW,LY,LL,LB,
     +LX,LE,LV,LJ,LD,LS,LO,LT,LK,LQ,LZ,LN,KH,IV,JA,JB,JC,JD,JW,HA,HD
      INTEGER*2 INCH
      COMMON/VAX/IVX,INCH
      INTEGER LIB$STAT_TIMER,IT(2)
C
C Sets T to the CPU time used so far in seconds (not necessarily
C zero at the start of SHELXL). If the operating system does not
C provide this information, the subroutine should set T to -1.
C TC keeps track of the last time reported to detect if the clock
C is reset at midnight
C
      T=LIB$STAT_TIMER(2,IT,IVX)
      T=0.01*REAL(IT(1))
   1  IF(T.GT.TC-0.1)GOTO 2
      T=T+86400.
      GOTO 1
   2  TC=T
      RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXTM(SL,LI)
C
C Print CPU time used since last called
C
   1  FORMAT(/F10.1,' seconds CPU time')
      T=SL
      CALL SXTI(SL)
      IF(SL.LT.0.)GOTO 2
      T=SL-T
c      WRITE(LI,1)T
   2  RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXTX(KR)
C
C Put current time in format hr:mn:sc in string KR
C
      CHARACTER*8 KR
      CHARACTER*11 TM
      CALL TIME(TM)
      KR=TM(1:8)
      RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXIT
C
C Terminate job in manner appropriate to operating system
C - e.g. print time and trailer, then stop.
C
      CHARACTER*1 IH(50),KD
      CHARACTER*11 TM
      CHARACTER*76 IT
      CHARACTER*80 NM,IR
      COMMON ST,SL,TC,TL,LM,LU,IM,LR,LG,LH,LI,LP,LF,LA,LC,LW,LY,LL,LB,
     +LX,LE,LV,LJ,LD,LS,LO,LT,LK,LQ,LZ,LN,KH,IV,JA,JB,JC,JD,JW,HA,HD
      COMMON/WORD/IH,IT,IR,NM,KD
C
   1  FORMAT(/' ',77('+')/' +  ',A17,' finished at ',A8,3X,
     +'Total CPU time:',F10.1,' secs  +'/' ',77('+'))
C
      CALL SXTI(T)
      T=T-ST
      CALL TIME(TM)
c      WRITE(LI,1)NM(1:17),TM(1:8),T
      WRITE(*,1)NM(1:17),TM(1:8),T
C
C Comment out the next statement if the listing file is NOT destined
C for compressed mode output on an HP or compatible laserprinter
C
C     WRITE(LI,'(1X,A)')CHAR(27)//'E'
C
      STOP' '
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXCC
C
C This subroutine is polled frequently to enable the user to signal
C to the program (with <Escape>) that he wishes to do no more
C refinement cycles but instead to tidy up and finish off, or (with
C <Ctrl-C> or - better - <Crtl-I>) that the job should be aborted.
C
      CHARACTER*1 KS
      INTEGER SYS$QIOW
      INTEGER*2 INCH
      COMMON ST,SL,TC,TL,LM,LU,IM,LR,LG,LH,LI,LP,LF,LA,LC,LW,LY,LL,LB,
     +LX,LE,LV,LJ,LD,LS,LO,LT,LK,LQ,LZ,LN,KH,IV,JA,JB,JC,JD,JW,HA,HD
      COMMON/VAX/IVX,INCH
      COMMON/TTY/KS
      INCLUDE'($IODEF)'
C
      I=ICHAR(KS)
      IF(I.EQ.0)GOTO 3
      IF(I.NE.27)GOTO 1
      IF(TL.LT.-1.5)GOTO 2
      TL=-2.
      WRITE(*,'(/A/)')'   ** Escape Key pressed - finishing off **'
   1  IF(I.EQ.3)CALL SXER('Terminated by Control-C')
      IF(I.EQ.9)CALL SXER('Terminated by Control-I')
   2  KS=CHAR(0)
      K=IO$_READLBLK.OR.IO$M_NOECHO.OR.IO$M_ESCAPE
      L=SYS$QIO(,%VAL(INCH),%VAL(K),,,,
     +%REF(KS),%VAL(1),,,,)
   3  RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXPG(LI)
C
C Print form feed = start new page.
C
c      WRITE(LI,'(1X,A)')CHAR(12)
      RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXFN(I)
C
C This routine deletes the dummy file name.fin.  If successful
C (i.e. the file existed) the program tidies up and finishes off
C instead of doing further least-squares refinement cycles.  The
C subroutine signals this by setting I to -1.  If the file name.fin
C cannot be deleted I is set to 0.  Note that this routine is also
C called at the beginning of a run to clear any name.fin left over
C from a previous job.  This facility has the same action on a batch
C job as hitting the escape key for an interactive SHELXL run.
C
      CHARACTER*1 IH(50),KD
      CHARACTER*76 IT
      CHARACTER*80 NM,IR
      COMMON ST,SL,TC,TL,LM,LU,IM,LR,LG,LH,LI,LP,LF,LA,LC,LW,LY,LL,LB,
     +LX,LE,LV,LJ,LD,LS,LO,LT,LK,LQ,LZ,LN,KH,IV,JA,JB,JC,JD,JW,HA,HD
      COMMON/WORD/IH,IT,IR,NM,KD
C
      I=0
      OPEN(UNIT=LW,FILE=NM(1:LN)//'.fin',STATUS='OLD',ERR=1)
      CLOSE(UNIT=LW,STATUS='DELETE',ERR=1)
      I=-1
   1  RETURN
      END
C
C ---------------------------------------------------------------
C ** Computer-independent part of SHELXL - standard FORTRAN-77 **
C ---------------------------------------------------------------
C
      SUBROUTINE SXLC(K)
C
C Convert an upper case character to lower case.
C If it is not an upper case letter do nothing.
C
      CHARACTER K*1
      IF(K.GT.'Z')GOTO 1
      IF(K.LT.'A')GOTO 1
      K=CHAR(ICHAR(K)+ICHAR('a')-ICHAR('A'))
   1  RETURN
      END
C
C -----------------------------------------------------------
C
      SUBROUTINE SXUC(K)
C
C Convert a lower case character to upper case.
C If it is not a lower case letter do nothing.
C
      CHARACTER K*1
      IF(K.GT.'z')GOTO 1
      IF(K.LT.'a')GOTO 1
      K=CHAR(ICHAR(K)+ICHAR('A')-ICHAR('a'))
   1  RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXPS(X,KS)
C
C Pack 4 characters from character*4 string into one real
C
      CHARACTER*4 KS
      READ(KS,'(A4)')X
      RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXUS(X,KS)
C
C Unpack 4 characters from one real into character*4 string
C
      CHARACTER*4 KS
      WRITE(KS,'(A4)')X
      RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXPN(X,N)
C
C Left justify integer as string and pack into one real
C
      CHARACTER*1 IH(50),KD
      CHARACTER*4 KS
      CHARACTER*76 IT
      CHARACTER*80 NM,IR
      COMMON/WORD/IH,IT,IR,NM,KD
C
      KS=' '
      K=0
      L=IABS(N)
      M=1000
   1  IF(M.LE.L)GOTO 2
      M=M/10
      IF(M.GT.1)GOTO 1
   2  K=K+1
      I=MOD(L/M,10)
      KS(K:K)=IH(I+1)
      M=M/10
      IF(M.GT.0)GOTO 2
      CALL SXPS(X,KS)
      RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXAS(X,IS,L)
C
C Append character*4 string stored in real X to a string variable
C IS, eliminating blanks and updating the current length L of IS.
C
      CHARACTER*4 KT
      CHARACTER*(*)IS
      CALL SXUS(X,KT)
        DO 1 I=1,4
        IF(KT(I:I).EQ.' ')GOTO 1
        L=L+1
        IS(L:L)=KT(I:I)
   1    CONTINUE
      RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXAN(N,IS,L)
C
C Append full atom name of atom starting in A(N) to a string variable
C IS, eliminating blanks and updating the current length L of IS.
C
      CHARACTER*4 KT
      CHARACTER*(*)IS
      REAL A(250000)
      COMMON/SMALL/A
      K=N
      CALL SXUS(A(K+1),KT)
      IF(KT.EQ.'    ')K=INT(A(N+3))
      M=INT(ABS(A(K+3)))
      CALL SXUS(A(M+13),KT)
      M=L
      CALL SXAS(A(N),IS,L)
      IF(KT(2:2).EQ.' ')GOTO 1
      IF(L.EQ.M+1)GOTO 1
      M=M+2
      IF(KT(2:2).EQ.IS(M:M))CALL SXLC(IS(M:M))
   1  CALL SXUS(A(K+1),KT)
      IF(KT.EQ.'0   ')GOTO 2
      L=L+1
      IS(L:L)='_'
      CALL SXAS(A(K+1),IS,L)
      IF(K.NE.N)GOTO 3
   2  IF(K.EQ.N)GOTO 4
      L=L+1
      IS(L:L)='_'
   3  CALL SXAS(A(N+2),IS,L)
   4  RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXLP(KR,L)
C
C Outputs a record to logical unit L with blanks stripped and
C terminator KD appended (unless KD is a space).
C
      CHARACTER*1 IH(50),KD
      CHARACTER*76 IT
      CHARACTER*80 NM,IR,KR
      COMMON/WORD/IH,IT,IR,NM,KD
   1  FORMAT(A)
C
      M=1
        DO 2 I=1,80
        IF(KR(I:I).NE.IH(20))M=I
   2    CONTINUE
      IF(KD.EQ.' ')GOTO 3
      WRITE(L,1)KR(1:M)//KD
      GOTO 4
   3  WRITE(L,1)KR(1:M)
   4  RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SXER(KS)
      CHARACTER KS*(*)
C
C Error exit - output diagnostic message to console and
C printer (.LST file), then call exit routine.
C
      COMMON ST,SL,TC,TL,LM,LU,IM,LR,LG,LH,LI,LP,LF,LA,LC,LW,LY,LL,LB,
     +LX,LE,LV,LJ,LD,LS,LO,LT,LK,LQ,LZ,LN,KH,IV,JA,JB,JC,JD,JW,HA,HD
C
   1  FORMAT(/' ** ',A,' **'/)
   2  FORMAT(/' ** ',A,' **')
c      WRITE(LI,1)KS
      WRITE(*,2)KS
      CALL SXIT
      RETURN
      END
C
C ------------------------------------------------------------
C
      SUBROUTINE SX3A
C
C Read and interpret instructions
C
      parameter maxat=600
c maxat is maximum number of atoms to be read in
C****
      dimension cell(6),xyz(maxat,3),uij(maxat,6),sof(maxat)
      integer atnum(maxat),nsfac(12)
      character*4 label(maxat)
c
      CHARACTER*1 IH(50),IG(50),KK,KJ,KD
      CHARACTER*2 KA(94)
      CHARACTER*4 KL,KQ,KS,KT,KU,KV,KW,KX,KY,KZ,KC(76)
      CHARACTER*76 IT
      CHARACTER*80 NM,IR
      INTEGER MH(512),MK(512),ML(512),MB(512)
      REAL FF(512),SI(512),FC(512),SQ(512),WL(512),FB(512)
      REAL A(250000),B(1250000)
      REAL EF(1880)
      COMMON ST,SL,TC,TL,LM,LU,IM,LR,LG,LH,LI,LP,LF,LA,LC,LW,LY,LL,LB,
     +LX,LE,LV,LJ,LD,LS,LO,LT,LK,LQ,LZ,LN,KH,IV,JA,JB,JC,JD,JW,HA,HD
      COMMON/SMALL/A
      COMMON/LARGE/B
      COMMON/REFL/MB,MH,MK,ML,FF,SI,SQ,WL,FB,FC
      COMMON/WORD/IH,IT,IR,NM,KD
c
c****
      nel=0
c
c
C
C Character DATA statements
C
      DATA IG/'0','1','2','3','4','5','6','7','8','9','.','-',
     +'+','X','Y','Z',',','=','/',' ','*','_','<','>','(',')',
     +'A','B','C','D','E','F','G','H','I','J','K','L','M','N',
     +'O','P','Q','R','S','T','U','V','W','$'/,KJ/'!'/
C
C Instruction codewords
C
      DATA KC/'    ','END ','MOVE','SWAT','WPDB','BASF','EXTI',
     +'FVAR','WGHT','FRAG','FEND','REM ','CELL','ZERR','LATT',
     +'SYMM','SFAC','UNIT','GRID','MOLE','FMAP','PLAN','AFIX',
     +'TWIN','SPEC','OMIT','MERG','SUMP','RESI','SHEL','MORE',
     +'TIME','L.S.','CGLS','ACTA','DAMP','LIST','PART','DISP',
     +'HKLF','SLIM','TITL','SIZE','EQIV','EXYZ','EADP','BOND',
     +'FREE','BIND','DFIX','SAME','CONF','RTAB','MPLA','FLAT',
     +'CHIV','BLOC','DELU','SIMU','ISOR','SADI','ANIS','CONN',
     +'HFIX','LAUE','BUMP','TEMP','DEFS','ABSC','FACE','EMPI',
     +'LAMI','HOPE','DMAT','SKIP','$H  '/
C
C Data specific to chemical elements
C
      DATA KA(1)/'H '/,EF(13)/.32/,EF(14)/1.008/,
     +EF(1)/0.49300/,EF(2)/10.51091/,EF(3)/0.32291/,
     +EF(4)/26.12573/,EF(5)/0.14019/,EF(6)/3.14236/,
     +EF(7)/0.04081/,EF(8)/57.79977/,EF(9)/0.00304/,
     +EF(10)/0.000/,EF(11)/0.000/,EF(12)/.655/,
     +EF(15)/0.000/,EF(16)/0.000/,EF(17)/.624/,
     +EF(18)/0.000/,EF(19)/0.000/,EF(20)/.614/
C
      DATA KA(2)/'HE'/,EF(33)/1.50/,EF(34)/4.00/,
     +EF(21)/0.87340/,EF(22)/9.10371/,EF(23)/0.63090/,
     +EF(24)/3.35680/,EF(25)/0.31120/,EF(26)/22.92763/,
     +EF(27)/0.17800/,EF(28)/0.98210/,EF(29)/0.00640/,
     +EF(30)/0.000/,EF(31)/0.000/,EF(32)/1.94/,
     +EF(35)/0.000/,EF(36)/0.000/,EF(37)/1.34/,
     +EF(38)/0.000/,EF(39)/0.000/,EF(40)/1.28/
C
      DATA KA(3)/'LI'/,EF(53)/1.52/,EF(54)/6.94/,
     +EF(41)/1.12820/,EF(42)/3.95460/,EF(43)/0.75080/,
     +EF(44)/1.05240/,EF(45)/0.61750/,EF(46)/85.39058/,
     +EF(47)/0.46530/,EF(48)/168.26120/,EF(49)/0.03770/,
     +EF(50)/0.0008/,EF(51)/0.0003/,EF(52)/5.76/,
     +EF(55)/-0.0003/,EF(56)/0.0001/,EF(57)/2.28/,
     +EF(58)/-0.0004/,EF(59)/0.0000/,EF(60)/2.06/
C
      DATA KA(4)/'BE'/,EF(73)/1.11/,EF(74)/9.01/,
     +EF(61)/1.59190/,EF(62)/43.64275/,EF(63)/1.12780/,
     +EF(64)/1.86230/,EF(65)/0.53910/,EF(66)/103.48310/,
     +EF(67)/0.70290/,EF(68)/0.54200/,EF(69)/0.03850/,
     +EF(70)/0.0038/,EF(71)/0.0014/,EF(72)/16.6/,
     +EF(75)/0.0005/,EF(76)/0.0002/,EF(77)/3.83/,
     +EF(78)/0.0001/,EF(79)/0.0001/,EF(80)/3.13/
C
      DATA KA(5)/'B '/,EF(93)/0.82/,EF(94)/10.81/,
     +EF(81)/2.05450/,EF(82)/23.21852/,EF(83)/1.33260/,
     +EF(84)/1.02100/,EF(85)/1.09790/,EF(86)/60.34987/,
     +EF(87)/0.70680/,EF(88)/0.14030/,EF(89)/-0.19320/,
     +EF(90)/0.0090/,EF(91)/0.0039/,EF(92)/41.5/,
     +EF(95)/0.0013/,EF(96)/0.0007/,EF(97)/6.61/,
     +EF(98)/0.0004/,EF(99)/0.0004/,EF(100)/4.79/
C
      DATA KA(6)/'C '/,EF(113)/0.77/,EF(114)/12.01/,
     +EF(101)/2.31000/,EF(102)/20.84392/,EF(103)/1.02000/,
     +EF(104)/10.20751/,EF(105)/1.58860/,EF(106)/0.56870/,
     +EF(107)/0.86500/,EF(108)/51.65125/,EF(109)/0.21560/,
     +EF(110)/0.0181/,EF(111)/0.0091/,EF(112)/89.9/,
     +EF(115)/0.0033/,EF(116)/0.0016/,EF(117)/11.5/,
     +EF(118)/0.0015/,EF(119)/0.0009/,EF(120)/7.45/
C
      DATA KA(7)/'N '/,EF(133)/0.70/,EF(134)/14.01/,
     +EF(121)/12.21261/,EF(122)/0.00570/,EF(123)/3.13220/,
     +EF(124)/9.89331/,EF(125)/2.01250/,EF(126)/28.99754/,
     +EF(127)/1.16630/,EF(128)/0.58260/,EF(129)/-11.52901/,
     +EF(130)/0.0311/,EF(131)/0.0180/,EF(132)/173./,
     +EF(135)/0.0061/,EF(136)/0.0033/,EF(137)/19.6/,
     +EF(138)/0.0030/,EF(139)/0.0019/,EF(140)/11.7/
C
      DATA KA(8)/'O '/,EF(153)/0.66/,EF(154)/16.00/,
     +EF(141)/3.04850/,EF(142)/13.27711/,EF(143)/2.28680/,
     +EF(144)/5.70111/,EF(145)/1.54630/,EF(146)/0.32390/,
     +EF(147)/0.86700/,EF(148)/32.90894/,EF(149)/0.25080/,
     +EF(150)/0.0492/,EF(151)/0.0322/,EF(152)/304./,
     +EF(155)/0.0106/,EF(156)/0.0060/,EF(157)/32.5/,
     +EF(158)/0.0056/,EF(159)/0.0036/,EF(160)/18.2/
C
      DATA KA(9)/'F '/,EF(173)/0.64/,EF(174)/19.00/,
     +EF(161)/3.53920/,EF(162)/10.28251/,EF(163)/2.64120/,
     +EF(164)/4.29440/,EF(165)/1.51700/,EF(166)/0.26150/,
     +EF(167)/1.02430/,EF(168)/26.14763/,EF(169)/0.27760/,
     +EF(170)/0.0727/,EF(171)/0.0534/,EF(172)/498./,
     +EF(175)/0.0171/,EF(176)/0.0103/,EF(177)/51.5/,
     +EF(178)/0.0096/,EF(179)/0.0061/,EF(180)/27.7/
C
      DATA KA(10)/'NE'/,EF(193)/1.50/,EF(194)/20.18/,
     +EF(181)/3.95530/,EF(182)/8.40421/,EF(183)/3.11250/,
     +EF(184)/3.42620/,EF(185)/1.45460/,EF(186)/0.23060/,
     +EF(187)/1.12510/,EF(188)/21.71841/,EF(189)/0.35150/,
     +EF(190)/0.1019/,EF(191)/0.0833/,EF(192)/768./,
     +EF(195)/0.0259/,EF(196)/0.0164/,EF(197)/78.6/,
     +EF(198)/0.0152/,EF(199)/0.0098/,EF(200)/41.2/
C
      DATA KA(11)/'NA'/,EF(213)/1.86/,EF(214)/22.99/,
     +EF(201)/4.76260/,EF(202)/3.28500/,EF(203)/3.17360/,
     +EF(204)/8.84221/,EF(205)/1.26740/,EF(206)/0.31360/,
     +EF(207)/1.11280/,EF(208)/129.42410/,EF(209)/0.67600/,
     +EF(210)/0.1353/,EF(211)/0.1239/,EF(212)/1140./,
     +EF(215)/0.0362/,EF(216)/0.0249/,EF(217)/116./,
     +EF(218)/0.0218/,EF(219)/0.0150/,EF(220)/59.6/
C
      DATA KA(12)/'MG'/,EF(233)/1.60/,EF(234)/24.31/,
     +EF(221)/5.42041/,EF(222)/2.82750/,EF(223)/2.17350/,
     +EF(224)/79.26118/,EF(225)/1.22690/,EF(226)/0.38080/,
     +EF(227)/2.30730/,EF(228)/7.19371/,EF(229)/0.85840/,
     +EF(230)/0.1719/,EF(231)/0.1771/,EF(232)/1610./,
     +EF(235)/0.0486/,EF(236)/0.0363/,EF(237)/165./,
     +EF(238)/0.0298/,EF(239)/0.0220/,EF(240)/84.2/
C
      DATA KA(13)/'AL'/,EF(253)/1.25/,EF(254)/26.98/,
     +EF(241)/6.42021/,EF(242)/3.03870/,EF(243)/1.90020/,
     +EF(244)/0.74260/,EF(245)/1.59360/,EF(246)/31.54724/,
     +EF(247)/1.96460/,EF(248)/85.08868/,EF(249)/1.11510/,
     +EF(250)/0.2130/,EF(251)/0.2455/,EF(252)/2220./,
     +EF(255)/0.0645/,EF(256)/0.0514/,EF(257)/229./,
     +EF(258)/0.0406/,EF(259)/0.0313/,EF(260)/116./
C
      DATA KA(14)/'SI'/,EF(273)/1.17/,EF(274)/28.09/,
     +EF(261)/6.29151/,EF(262)/2.43860/,EF(263)/3.03530/,
     +EF(264)/32.33374/,EF(265)/1.98910/,EF(266)/0.67850/,
     +EF(267)/1.54100/,EF(268)/81.69379/,EF(269)/1.14070/,
     +EF(270)/0.2541/,EF(271)/0.3302/,EF(272)/2970./,
     +EF(275)/0.0817/,EF(276)/0.0704/,EF(277)/310./,
     +EF(278)/0.0522/,EF(279)/0.0431/,EF(280)/156./
C
      DATA KA(15)/'P '/,EF(293)/1.10/,EF(294)/30.97/,
     +EF(281)/6.43451/,EF(282)/1.90670/,EF(283)/4.17910/,
     +EF(284)/27.15704/,EF(285)/1.78000/,EF(286)/0.52600/,
     +EF(287)/1.49080/,EF(288)/68.16457/,EF(289)/1.11490/,
     +EF(290)/0.2955/,EF(291)/0.4335/,EF(292)/3880./,
     +EF(295)/0.1023/,EF(296)/0.0942/,EF(297)/410./,
     +EF(298)/0.0667/,EF(299)/0.0580/,EF(300)/206./
C
      DATA KA(16)/'S '/,EF(313)/1.03/,EF(314)/32.06/,
     +EF(301)/6.90531/,EF(302)/1.46790/,EF(303)/5.20341/,
     +EF(304)/22.21512/,EF(305)/1.43790/,EF(306)/0.25360/,
     +EF(307)/1.58630/,EF(308)/56.17207/,EF(309)/0.86690/,
     +EF(310)/0.3331/,EF(311)/0.5567/,EF(312)/4970./,
     +EF(315)/0.1246/,EF(316)/0.1234/,EF(317)/532./,
     +EF(318)/0.0826/,EF(319)/0.0763/,EF(320)/267./
C
      DATA KA(17)/'CL'/,EF(333)/0.99/,EF(334)/35.45/,
     +EF(321)/11.46041/,EF(322)/0.01040/,EF(323)/7.19641/,
     +EF(324)/1.16620/,EF(325)/6.25561/,EF(326)/18.51942/,
     +EF(327)/1.64550/,EF(328)/47.77846/,EF(329)/-9.55741/,
     +EF(330)/0.3639/,EF(331)/0.7018/,EF(332)/6240./,
     +EF(335)/0.1484/,EF(336)/0.1585/,EF(337)/678./,
     +EF(338)/0.0998/,EF(339)/0.0984/,EF(340)/341./
C
      DATA KA(18)/'AR'/,EF(353)/1.50/,EF(354)/39.95/,
     +EF(341)/7.48451/,EF(342)/0.90720/,EF(343)/6.77231/,
     +EF(344)/14.84071/,EF(345)/0.65390/,EF(346)/43.89835/,
     +EF(347)/1.64420/,EF(348)/33.39293/,EF(349)/1.44450/,
     +EF(350)/0.3843/,EF(351)/0.8717/,EF(352)/7720./,
     +EF(355)/0.1743/,EF(356)/0.2003/,EF(357)/851./,
     +EF(358)/0.1191/,EF(359)/0.1249/,EF(360)/429./
C
      DATA KA(19)/'K '/,EF(373)/2.27/,EF(374)/39.10/,
     +EF(361)/8.21861/,EF(362)/12.79491/,EF(363)/7.43981/,
     +EF(364)/0.77480/,EF(365)/1.05190/,EF(366)/213.18720/,
     +EF(367)/0.86590/,EF(368)/41.68416/,EF(369)/1.42280/,
     +EF(370)/0.3868/,EF(371)/1.0657/,EF(372)/9400./,
     +EF(375)/0.2009/,EF(376)/0.2494/,EF(377)/1050./,
     +EF(378)/0.1399/,EF(379)/0.1562/,EF(380)/532./
C
      DATA KA(20)/'CA'/,EF(393)/1.97/,EF(394)/40.08/,
     +EF(381)/8.62661/,EF(382)/10.44211/,EF(383)/7.38731/,
     +EF(384)/0.65990/,EF(385)/1.58990/,EF(386)/85.74849/,
     +EF(387)/1.02110/,EF(388)/178.43720/,EF(389)/1.37510/,
     +EF(390)/0.3641/,EF(391)/1.2855/,EF(392)/11300./,
     +EF(395)/0.2262/,EF(396)/0.3064/,EF(397)/1290./,
     +EF(398)/0.1611/,EF(399)/0.1926/,EF(400)/652./
C
      DATA KA(21)/'SC'/,EF(413)/1.61/,EF(414)/44.96/,
     +EF(401)/9.18901/,EF(402)/9.02131/,EF(403)/7.36791/,
     +EF(404)/0.57290/,EF(405)/1.64090/,EF(406)/136.10810/,
     +EF(407)/1.46800/,EF(408)/51.35315/,EF(409)/1.33290/,
     +EF(410)/0.3119/,EF(411)/1.5331/,EF(412)/13500./,
     +EF(415)/0.2519/,EF(416)/0.3716/,EF(417)/1560./,
     +EF(418)/0.1829/,EF(419)/0.2348/,EF(420)/789./
C
      DATA KA(22)/'TI'/,EF(433)/1.45/,EF(434)/47.90/,
     +EF(421)/9.75951/,EF(422)/7.85081/,EF(423)/7.35581/,
     +EF(424)/0.50000/,EF(425)/1.69910/,EF(426)/35.63383/,
     +EF(427)/1.90210/,EF(428)/116.10510/,EF(429)/1.28070/,
     +EF(430)/0.2191/,EF(431)/1.8069/,EF(432)/15900./,
     +EF(435)/0.2776/,EF(436)/0.4457/,EF(437)/1860./,
     +EF(438)/0.2060/,EF(439)/0.2830/,EF(440)/947./
C
      DATA KA(23)/'V '/,EF(453)/1.31/,EF(454)/50.94/,
     +EF(441)/10.29711/,EF(442)/6.86571/,EF(443)/7.35111/,
     +EF(444)/0.43850/,EF(445)/2.07030/,EF(446)/26.89383/,
     +EF(447)/2.05710/,EF(448)/102.47810/,EF(449)/1.21990/,
     +EF(450)/0.0687/,EF(451)/2.1097/,EF(452)/18500./,
     +EF(455)/0.3005/,EF(456)/0.5294/,EF(457)/2200./,
     +EF(458)/0.2276/,EF(459)/0.3376/,EF(460)/1120./
C
      DATA KA(24)/'CR'/,EF(473)/1.24/,EF(474)/52.00/,
     +EF(461)/10.64061/,EF(462)/6.10381/,EF(463)/7.35371/,
     +EF(464)/0.39200/,EF(465)/3.32400/,EF(466)/20.26262/,
     +EF(467)/1.49220/,EF(468)/98.73999/,EF(469)/1.18320/,
     +EF(470)/-0.1635/,EF(471)/2.4439/,EF(472)/21300./,
     +EF(475)/0.3209/,EF(476)/0.6236/,EF(477)/2580./,
     +EF(478)/0.2496/,EF(479)/0.3992/,EF(480)/1330./
C
      DATA KA(25)/'MN'/,EF(493)/1.37/,EF(494)/54.94/,
     +EF(481)/11.28191/,EF(482)/5.34091/,EF(483)/7.35731/,
     +EF(484)/0.34320/,EF(485)/3.01930/,EF(486)/17.86742/,
     +EF(487)/2.24410/,EF(488)/83.75438/,EF(489)/1.08960/,
     +EF(490)/-0.5299/,EF(491)/2.8052/,EF(492)/24600./,
     +EF(495)/0.3368/,EF(496)/0.7283/,EF(497)/3020./,
     +EF(498)/0.2704/,EF(499)/0.4681/,EF(500)/1550./
C
      DATA KA(26)/'FE'/,EF(513)/1.24/,EF(514)/55.85/,
     +EF(501)/11.76951/,EF(502)/4.76111/,EF(503)/7.35731/,
     +EF(504)/0.30720/,EF(505)/3.52220/,EF(506)/15.35351/,
     +EF(507)/2.30450/,EF(508)/76.88058/,EF(509)/1.03690/,
     +EF(510)/-1.1336/,EF(511)/3.1974/,EF(512)/28000./,
     +EF(515)/0.3463/,EF(516)/0.8444/,EF(517)/3490./,
     +EF(518)/0.2886/,EF(519)/0.5448/,EF(520)/1800./
C
      DATA KA(27)/'CO'/,EF(533)/1.25/,EF(534)/58.93/,
     +EF(521)/12.28411/,EF(522)/4.27910/,EF(523)/7.34091/,
     +EF(524)/0.27840/,EF(525)/4.00340/,EF(526)/13.53591/,
     +EF(527)/2.34880/,EF(528)/71.16927/,EF(529)/1.01180/,
     +EF(530)/-2.3653/,EF(531)/3.6143/,EF(532)/31400./,
     +EF(535)/0.3494/,EF(536)/0.9721/,EF(537)/4010./,
     +EF(538)/0.3050/,EF(539)/0.6296/,EF(540)/2070./
C
      DATA KA(28)/'NI'/,EF(553)/1.25/,EF(554)/58.71/,
     +EF(541)/12.83761/,EF(542)/3.87850/,EF(543)/7.29201/,
     +EF(544)/0.25650/,EF(545)/4.44380/,EF(546)/12.17631/,
     +EF(547)/2.38000/,EF(548)/66.34216/,EF(549)/1.03410/,
     +EF(550)/-3.0029/,EF(551)/0.5091/,EF(552)/4760./,
     +EF(555)/0.3393/,EF(556)/1.1124/,EF(557)/4570./,
     +EF(558)/0.3147/,EF(559)/0.7232/,EF(560)/2380./
C
      DATA KA(29)/'CU'/,EF(573)/1.28/,EF(574)/63.54/,
     +EF(561)/13.33801/,EF(562)/3.58280/,EF(563)/7.16761/,
     +EF(564)/0.24700/,EF(565)/5.61581/,EF(566)/11.39661/,
     +EF(567)/1.67350/,EF(568)/64.81267/,EF(569)/1.19100/,
     +EF(570)/-1.9646/,EF(571)/0.5888/,EF(572)/5470./,
     +EF(575)/0.3201/,EF(576)/1.2651/,EF(577)/5180./,
     +EF(578)/0.3240/,EF(579)/0.8257/,EF(580)/2710./
C
      DATA KA(30)/'ZN'/,EF(593)/1.33/,EF(594)/65.37/,
     +EF(581)/14.07431/,EF(582)/3.26550/,EF(583)/7.03181/,
     +EF(584)/0.23330/,EF(585)/5.16521/,EF(586)/10.31631/,
     +EF(587)/2.41000/,EF(588)/58.70976/,EF(589)/1.30410/,
     +EF(590)/-1.5491/,EF(591)/0.6778/,EF(592)/6290./,
     +EF(595)/0.2839/,EF(596)/1.4301/,EF(597)/5860./,
     +EF(598)/0.3242/,EF(599)/0.9375/,EF(600)/3070./
C
      DATA KA(31)/'GA'/,EF(613)/1.26/,EF(614)/69.72/,
     +EF(601)/15.23541/,EF(602)/3.06690/,EF(603)/6.70061/,
     +EF(604)/0.24120/,EF(605)/4.35910/,EF(606)/10.78051/,
     +EF(607)/2.96230/,EF(608)/61.41357/,EF(609)/1.71890/,
     +EF(610)/-1.2846/,EF(611)/0.7763/,EF(612)/7190./,
     +EF(615)/0.2307/,EF(616)/1.6083/,EF(617)/6600./,
     +EF(618)/0.3179/,EF(619)/1.0589/,EF(620)/3460./
C
      DATA KA(32)/'GE'/,EF(633)/1.22/,EF(634)/72.59/,
     +EF(621)/16.08162/,EF(622)/2.85090/,EF(623)/6.37471/,
     +EF(624)/0.25160/,EF(625)/3.70680/,EF(626)/11.44681/,
     +EF(627)/3.68300/,EF(628)/54.76256/,EF(629)/2.13130/,
     +EF(630)/-1.0885/,EF(631)/0.8855/,EF(632)/8190./,
     +EF(635)/0.1547/,EF(636)/1.8001/,EF(637)/7380./,
     +EF(638)/0.3016/,EF(639)/1.1903/,EF(640)/3870./
C
      DATA KA(33)/'AS'/,EF(653)/1.21/,EF(654)/74.92/,
     +EF(641)/16.67232/,EF(642)/2.63450/,EF(643)/6.07011/,
     +EF(644)/0.26470/,EF(645)/3.43130/,EF(646)/12.94791/,
     +EF(647)/4.27790/,EF(648)/47.79726/,EF(649)/2.53100/,
     +EF(650)/-0.9300/,EF(651)/1.0051/,EF(652)/9290./,
     +EF(655)/0.0499/,EF(656)/2.0058/,EF(657)/8220./,
     +EF(658)/0.2758/,EF(659)/1.3314/,EF(660)/4330./
C
      DATA KA(34)/'SE'/,EF(673)/1.17/,EF(674)/78.96/,
     +EF(661)/17.00063/,EF(662)/2.40980/,EF(663)/5.81961/,
     +EF(664)/0.27260/,EF(665)/3.97310/,EF(666)/15.23721/,
     +EF(667)/4.35430/,EF(668)/43.81635/,EF(669)/2.84090/,
     +EF(670)/-0.7943/,EF(671)/1.1372/,EF(672)/10500./,
     +EF(675)/-0.0929/,EF(676)/2.2259/,EF(677)/9110./,
     +EF(678)/0.2367/,EF(679)/1.4831/,EF(680)/4820./
C
      DATA KA(35)/'BR'/,EF(693)/1.14/,EF(694)/79.91/,
     +EF(681)/17.17892/,EF(682)/2.17230/,EF(683)/5.23581/,
     +EF(684)/16.57962/,EF(685)/5.63771/,EF(686)/0.26090/,
     +EF(687)/3.98510/,EF(688)/41.43285/,EF(689)/2.95570/,
     +EF(690)/-0.6763/,EF(691)/1.2805/,EF(692)/11800./,
     +EF(695)/-0.2901/,EF(696)/2.4595/,EF(697)/10000./,
     +EF(698)/0.1811/,EF(699)/1.6452/,EF(700)/5350./
C
      DATA KA(36)/'KR'/,EF(713)/1.50/,EF(714)/83.80/,
     +EF(701)/17.35551/,EF(702)/1.93840/,EF(703)/6.72861/,
     +EF(704)/16.56232/,EF(705)/5.54931/,EF(706)/0.22610/,
     +EF(707)/3.53750/,EF(708)/39.39723/,EF(709)/2.82500/,
     +EF(710)/-0.5657/,EF(711)/1.4385/,EF(712)/13200./,
     +EF(715)/-0.5574/,EF(716)/2.7079/,EF(717)/11000./,
     +EF(718)/0.1067/,EF(719)/1.8192/,EF(720)/5920./
C
      DATA KA(37)/'RB'/,EF(733)/2.48/,EF(734)/85.47/,
     +EF(721)/17.17842/,EF(722)/1.78880/,EF(723)/9.64351/,
     +EF(724)/17.31512/,EF(725)/5.13990/,EF(726)/0.27480/,
     +EF(727)/1.52920/,EF(728)/164.93420/,EF(729)/3.48730/,
     +EF(730)/-0.4688/,EF(731)/1.6079/,EF(732)/14800./,
     +EF(735)/-0.9393/,EF(736)/2.9676/,EF(737)/12100./,
     +EF(738)/0.0068/,EF(739)/2.0025/,EF(740)/6520./
C
      DATA KA(38)/'SR'/,EF(753)/2.15/,EF(754)/87.62/,
     +EF(741)/17.56631/,EF(742)/1.55640/,EF(743)/9.81841/,
     +EF(744)/14.09881/,EF(745)/5.42200/,EF(746)/0.16640/,
     +EF(747)/2.66940/,EF(748)/132.37610/,EF(749)/2.50640/,
     +EF(750)/-0.3528/,EF(751)/1.8200/,EF(752)/16500./,
     +EF(755)/-1.5307/,EF(756)/3.2498/,EF(757)/13200./,
     +EF(758)/-0.1172/,EF(759)/2.2025/,EF(760)/7150./
C
      DATA KA(39)/'Y '/,EF(773)/1.78/,EF(774)/88.91/,
     +EF(761)/17.77602/,EF(762)/1.40290/,EF(763)/10.29461/,
     +EF(764)/12.80061/,EF(765)/5.72630/,EF(766)/0.12560/,
     +EF(767)/3.26588/,EF(768)/104.35410/,EF(769)/1.91213/,
     +EF(770)/-0.2670/,EF(771)/2.0244/,EF(772)/18300./,
     +EF(775)/-2.7962/,EF(776)/3.5667/,EF(777)/14300./,
     +EF(778)/-0.2879/,EF(779)/2.4099/,EF(780)/7800./
C
      DATA KA(40)/'ZR'/,EF(793)/1.59/,EF(794)/91.22/,
     +EF(781)/17.87653/,EF(782)/1.27618/,EF(783)/10.94801/,
     +EF(784)/11.91601/,EF(785)/5.41733/,EF(786)/0.11762/,
     +EF(787)/3.65721/,EF(788)/87.66278/,EF(789)/2.06929/,
     +EF(790)/-0.1862/,EF(791)/2.2449/,EF(792)/20300./,
     +EF(795)/-2.9673/,EF(796)/0.5597/,EF(797)/2470./,
     +EF(798)/-0.5364/,EF(799)/2.6141/,EF(800)/8470./
C
      DATA KA(41)/'NB'/,EF(813)/1.43/,EF(814)/92.91/,
     +EF(801)/17.61423/,EF(802)/1.18865/,EF(803)/12.01441/,
     +EF(804)/11.76601/,EF(805)/4.04183/,EF(806)/0.20479/,
     +EF(807)/3.53346/,EF(808)/69.79576/,EF(809)/3.75591/,
     +EF(810)/-0.1121/,EF(811)/2.4826/,EF(812)/22300./,
     +EF(815)/-2.0727/,EF(816)/0.6215/,EF(817)/2730./,
     +EF(818)/-0.8282/,EF(819)/2.8404/,EF(820)/9220./
C
      DATA KA(42)/'MO'/,EF(833)/1.36/,EF(834)/95.94/,
     +EF(821)/3.70250/,EF(822)/0.27720/,EF(823)/17.23563/,
     +EF(824)/1.09580/,EF(825)/12.88761/,EF(826)/11.00401/,
     +EF(827)/3.74290/,EF(828)/61.65846/,EF(829)/4.38750/,
     +EF(830)/-0.0483/,EF(831)/2.7339/,EF(832)/24600./,
     +EF(835)/-1.6832/,EF(836)/0.6857/,EF(837)/3000./,
     +EF(838)/-1.2703/,EF(839)/3.0978/,EF(840)/11500./
C
      DATA KA(43)/'TC'/,EF(853)/1.35/,EF(854)/98.00/,
     +EF(841)/19.13013/,EF(842)/0.86413/,EF(843)/11.09481/,
     +EF(844)/8.14488/,EF(845)/4.64902/,EF(846)/21.57072/,
     +EF(847)/2.71263/,EF(848)/86.84727/,EF(849)/5.40429/,
     +EF(850)/0.0057/,EF(851)/3.0049/,EF(852)/27000./,
     +EF(855)/-1.4390/,EF(856)/0.7593/,EF(857)/3320./,
     +EF(858)/-2.0087/,EF(859)/3.3490/,EF(860)/10700./
C
      DATA KA(44)/'RU'/,EF(873)/1.33/,EF(874)/101.07/,
     +EF(861)/19.26743/,EF(862)/0.80852/,EF(863)/12.91821/,
     +EF(864)/8.43468/,EF(865)/4.86337/,EF(866)/24.79974/,
     +EF(867)/1.56756/,EF(868)/94.29289/,EF(869)/5.37875/,
     +EF(870)/0.0552/,EF(871)/3.2960/,EF(872)/29500./,
     +EF(875)/-1.2594/,EF(876)/0.8363/,EF(877)/3640./,
     +EF(878)/-5.3630/,EF(879)/3.6506/,EF(880)/1920./
C
      DATA KA(45)/'RH'/,EF(893)/1.35/,EF(894)/102.91/,
     +EF(881)/19.29572/,EF(882)/0.75154/,EF(883)/14.35011/,
     +EF(884)/8.21759/,EF(885)/4.73425/,EF(886)/25.87494/,
     +EF(887)/1.28918/,EF(888)/98.60629/,EF(889)/5.32800/,
     +EF(890)/0.0927/,EF(891)/3.6045/,EF(892)/32300./,
     +EF(895)/-1.1178/,EF(896)/0.9187/,EF(897)/3990./,
     +EF(898)/-2.5280/,EF(899)/0.5964/,EF(900)/2100./
C
      DATA KA(46)/'PD'/,EF(913)/1.38/,EF(914)/106.40/,
     +EF(901)/19.33192/,EF(902)/0.69866/,EF(903)/15.50172/,
     +EF(904)/7.98930/,EF(905)/5.29537/,EF(906)/25.20523/,
     +EF(907)/0.60584/,EF(908)/76.89868/,EF(909)/5.26593/,
     +EF(910)/0.1215/,EF(911)/3.9337/,EF(912)/35200./,
     +EF(915)/-0.9988/,EF(916)/1.0072/,EF(917)/4360./,
     +EF(918)/-1.9556/,EF(919)/0.6546/,EF(920)/2300./
C
      DATA KA(47)/'AG'/,EF(933)/1.44/,EF(934)/107.87/,
     +EF(921)/19.28082/,EF(922)/0.64460/,EF(923)/16.68852/,
     +EF(924)/7.47261/,EF(925)/4.80451/,EF(926)/24.66054/,
     +EF(927)/1.04630/,EF(928)/99.81570/,EF(929)/5.17900/,
     +EF(930)/0.1306/,EF(931)/4.2820/,EF(932)/38200./,
     +EF(935)/-0.8971/,EF(936)/1.1015/,EF(937)/4760./,
     +EF(938)/-1.6473/,EF(939)/0.7167/,EF(940)/2510./
C
      DATA KA(48)/'CD'/,EF(953)/1.49/,EF(954)/112.40/,
     +EF(941)/19.22142/,EF(942)/0.59460/,EF(943)/17.64442/,
     +EF(944)/6.90891/,EF(945)/4.46100/,EF(946)/24.70084/,
     +EF(947)/1.60290/,EF(948)/87.48257/,EF(949)/5.06941/,
     +EF(950)/0.1185/,EF(951)/4.6533/,EF(952)/41500./,
     +EF(955)/-0.8075/,EF(956)/1.2024/,EF(957)/5180./,
     +EF(958)/-1.4396/,EF(959)/0.7832/,EF(960)/2730./
C
      DATA KA(49)/'IN'/,EF(973)/1.44/,EF(974)/114.82/,
     +EF(961)/19.16241/,EF(962)/0.54760/,EF(963)/18.55962/,
     +EF(964)/6.37761/,EF(965)/4.29480/,EF(966)/25.84993/,
     +EF(967)/2.03960/,EF(968)/92.80299/,EF(969)/4.93911/,
     +EF(970)/0.0822/,EF(971)/5.0449/,EF(972)/45000./,
     +EF(975)/-0.7276/,EF(976)/1.3100/,EF(977)/5630./,
     +EF(978)/-1.2843/,EF(979)/0.8542/,EF(980)/2970./
C
      DATA KA(50)/'SN'/,EF(993)/1.40/,EF(994)/118.69/,
     +EF(981)/19.18892/,EF(982)/5.83031/,EF(983)/19.10052/,
     +EF(984)/0.50310/,EF(985)/4.45850/,EF(986)/26.89093/,
     +EF(987)/2.46630/,EF(988)/83.95718/,EF(989)/4.78211/,
     +EF(990)/0.0259/,EF(991)/5.4591/,EF(992)/48600./,
     +EF(995)/-0.6537/,EF(996)/1.4246/,EF(997)/6110./,
     +EF(998)/-1.1587/,EF(999)/0.9299/,EF(1000)/3230./
C
      DATA KA(51)/'SB'/,EF(1013)/1.41/,EF(1014)/121.75/,
     +EF(1001)/19.64182/,EF(1002)/5.30340/,EF(1003)/19.04552/,
     +EF(1004)/0.46070/,EF(1005)/5.03711/,EF(1006)/27.90744/,
     +EF(1007)/2.68270/,EF(1008)/75.28258/,EF(1009)/4.59091/,
     +EF(1010)/-0.0562/,EF(1011)/5.8946/,EF(1012)/52500./,
     +EF(1015)/-0.5866/,EF(1016)/1.5461/,EF(1017)/6620./,
     +EF(1018)/-1.0547/,EF(1019)/1.0104/,EF(1020)/3500./
C
      DATA KA(52)/'TE'/,EF(1033)/1.37/,EF(1034)/127.60/,
     +EF(1021)/19.96442/,EF(1022)/4.81742/,EF(1023)/19.01382/,
     +EF(1024)/0.42089/,EF(1025)/6.14488/,EF(1026)/28.52844/,
     +EF(1027)/2.52390/,EF(1028)/70.84036/,EF(1029)/4.35200/,
     +EF(1030)/-0.1759/,EF(1031)/6.3531/,EF(1032)/56500./,
     +EF(1035)/-0.5308/,EF(1036)/1.6751/,EF(1037)/7160./,
     +EF(1038)/-0.9710/,EF(1039)/1.0960/,EF(1040)/3780./
C
      DATA KA(53)/'I '/,EF(1053)/1.33/,EF(1054)/126.90/,
     +EF(1041)/20.14722/,EF(1042)/4.34700/,EF(1043)/18.99492/,
     +EF(1044)/0.38140/,EF(1045)/7.51381/,EF(1046)/27.76604/,
     +EF(1047)/2.27350/,EF(1048)/66.87767/,EF(1049)/4.07120/,
     +EF(1050)/-0.3257/,EF(1051)/6.8362/,EF(1052)/60700./,
     +EF(1055)/-0.4742/,EF(1056)/1.8119/,EF(1057)/7730./,
     +EF(1058)/-0.8919/,EF(1059)/1.1868/,EF(1060)/4090./
C
      DATA KA(54)/'XE'/,EF(1073)/1.50/,EF(1074)/131.30/,
     +EF(1061)/20.29332/,EF(1062)/3.92820/,EF(1063)/19.02982/,
     +EF(1064)/0.34400/,EF(1065)/8.97671/,EF(1066)/26.46594/,
     +EF(1067)/1.99000/,EF(1068)/64.26587/,EF(1069)/3.71180/,
     +EF(1070)/-0.5179/,EF(1071)/7.3500/,EF(1072)/65200./,
     +EF(1075)/-0.4205/,EF(1076)/1.9578/,EF(1077)/8340./,
     +EF(1078)/-0.8200/,EF(1079)/1.2838/,EF(1080)/4410./
C
      DATA KA(55)/'CS'/,EF(1093)/2.65/,EF(1094)/132.91/,
     +EF(1081)/20.38922/,EF(1082)/3.56900/,EF(1083)/19.10622/,
     +EF(1084)/0.31070/,EF(1085)/10.66201/,EF(1086)/24.38794/,
     +EF(1087)/1.49530/,EF(1088)/213.90420/,EF(1089)/3.33520/,
     +EF(1090)/-0.7457/,EF(1091)/7.9052/,EF(1092)/70000./,
     +EF(1095)/-0.3680/,EF(1096)/2.1192/,EF(1097)/8980./,
     +EF(1098)/-0.7527/,EF(1099)/1.3916/,EF(1100)/4750./
C
      DATA KA(56)/'BA'/,EF(1113)/2.17/,EF(1114)/137.34/,
     +EF(1101)/20.33612/,EF(1102)/3.21600/,EF(1103)/19.29703/,
     +EF(1104)/0.27560/,EF(1105)/10.88801/,EF(1106)/20.20732/,
     +EF(1107)/2.69590/,EF(1108)/167.20220/,EF(1109)/2.77310/,
     +EF(1110)/-1.0456/,EF(1111)/8.4617/,EF(1112)/75000./,
     +EF(1115)/-0.3244/,EF(1116)/2.2819/,EF(1117)/9650./,
     +EF(1118)/-0.6940/,EF(1119)/1.5004/,EF(1120)/5110./
C
      DATA KA(57)/'LA'/,EF(1133)/1.87/,EF(1134)/138.91/,
     +EF(1121)/20.57802/,EF(1122)/2.94817/,EF(1123)/19.59901/,
     +EF(1124)/0.24448/,EF(1125)/11.37271/,EF(1126)/18.77261/,
     +EF(1127)/3.28719/,EF(1128)/133.12410/,EF(1129)/2.14678/,
     +EF(1130)/-1.4094/,EF(1131)/9.0376/,EF(1132)/80300./,
     +EF(1135)/-0.2871/,EF(1136)/2.4523/,EF(1137)/10400./,
     +EF(1138)/-0.6411/,EF(1139)/1.6148/,EF(1140)/5490./
C
      DATA KA(58)/'CE'/,EF(1153)/1.83/,EF(1154)/140.12/,
     +EF(1141)/21.16711/,EF(1142)/2.81219/,EF(1143)/19.76952/,
     +EF(1144)/0.22684/,EF(1145)/11.85131/,EF(1146)/17.60832/,
     +EF(1147)/3.33049/,EF(1148)/127.11310/,EF(1149)/1.86264/,
     +EF(1150)/-1.8482/,EF(1151)/9.6596/,EF(1152)/85700./,
     +EF(1155)/-0.2486/,EF(1156)/2.6331/,EF(1157)/11100./,
     +EF(1158)/-0.5890/,EF(1159)/1.7358/,EF(1160)/5880./
C
      DATA KA(59)/'PR'/,EF(1173)/1.82/,EF(1174)/140.91/,
     +EF(1161)/22.04402/,EF(1162)/2.77393/,EF(1163)/19.66972/,
     +EF(1164)/0.22209/,EF(1165)/12.38561/,EF(1166)/16.76692/,
     +EF(1167)/2.82428/,EF(1168)/143.64410/,EF(1169)/2.05830/,
     +EF(1170)/-2.4164/,EF(1171)/10.2820/,EF(1172)/91200./,
     +EF(1175)/-0.2180/,EF(1176)/2.8214/,EF(1177)/11900./,
     +EF(1178)/-0.5424/,EF(1179)/1.8624/,EF(1180)/6300./
C
      DATA KA(60)/'ND'/,EF(1193)/1.81/,EF(1194)/144.24/,
     +EF(1181)/22.68452/,EF(1182)/2.66248/,EF(1183)/19.68472/,
     +EF(1184)/0.21063/,EF(1185)/12.77401/,EF(1186)/15.88502/,
     +EF(1187)/2.85137/,EF(1188)/137.90310/,EF(1189)/1.98486/,
     +EF(1190)/-3.1807/,EF(1191)/10.9079/,EF(1192)/96800./,
     +EF(1195)/-0.1943/,EF(1196)/3.0179/,EF(1197)/12700./,
     +EF(1198)/-0.5012/,EF(1199)/1.9950/,EF(1200)/6740./
C
      DATA KA(61)/'PM'/,EF(1213)/1.81/,EF(1214)/147.00/,
     +EF(1201)/23.34052/,EF(1202)/2.56270/,EF(1203)/19.60953/,
     +EF(1204)/0.20209/,EF(1205)/13.12351/,EF(1206)/15.10091/,
     +EF(1207)/2.87516/,EF(1208)/132.72110/,EF(1209)/2.02876/,
     +EF(1210)/-4.0598/,EF(1211)/11.5523/,EF(1212)/102000./,
     +EF(1215)/-0.1753/,EF(1216)/3.2249/,EF(1217)/13500./,
     +EF(1218)/-0.4626/,EF(1219)/2.1347/,EF(1220)/7200./
C
      DATA KA(62)/'SM'/,EF(1233)/1.80/,EF(1234)/150.35/,
     +EF(1221)/24.00424/,EF(1222)/2.47274/,EF(1223)/19.42583/,
     +EF(1224)/0.19645/,EF(1225)/13.43961/,EF(1226)/14.39961/,
     +EF(1227)/2.89604/,EF(1228)/128.00710/,EF(1229)/2.20963/,
     +EF(1230)/-5.3236/,EF(1231)/12.2178/,EF(1232)/108000./,
     +EF(1235)/-0.1638/,EF(1236)/3.4418/,EF(1237)/14400./,
     +EF(1238)/-0.4287/,EF(1239)/2.2815/,EF(1240)/7680./
C
      DATA KA(63)/'EU'/,EF(1253)/2.00/,EF(1254)/151.96/,
     +EF(1241)/24.62744/,EF(1242)/2.38790/,EF(1243)/19.08862/,
     +EF(1244)/0.19420/,EF(1245)/13.76031/,EF(1246)/13.75461/,
     +EF(1247)/2.92270/,EF(1248)/123.17410/,EF(1249)/2.57450/,
     +EF(1250)/-8.9294/,EF(1251)/11.1857/,EF(1252)/110000./,
     +EF(1255)/-0.1578/,EF(1256)/3.6682/,EF(1257)/15400./,
     +EF(1258)/-0.3977/,EF(1259)/2.4351/,EF(1260)/8190./
C
      DATA KA(64)/'GD'/,EF(1273)/1.79/,EF(1274)/157.25/,
     +EF(1261)/25.07094/,EF(1262)/2.25341/,EF(1263)/19.07982/,
     +EF(1264)/0.18195/,EF(1265)/13.85181/,EF(1266)/12.93311/,
     +EF(1267)/3.54545/,EF(1268)/101.39810/,EF(1269)/2.41960/,
     +EF(1270)/-8.8380/,EF(1271)/11.9157/,EF(1272)/105000./,
     +EF(1275)/-0.1653/,EF(1276)/3.9035/,EF(1277)/16300./,
     +EF(1278)/-0.3741/,EF(1279)/2.5954/,EF(1280)/8720./
C
      DATA KA(65)/'TB'/,EF(1293)/1.76/,EF(1294)/158.92/,
     +EF(1281)/25.89763/,EF(1282)/2.24256/,EF(1283)/18.21852/,
     +EF(1284)/0.19614/,EF(1285)/14.31671/,EF(1286)/12.66481/,
     +EF(1287)/2.95354/,EF(1288)/115.36210/,EF(1289)/3.58324/,
     +EF(1290)/-9.1472/,EF(1291)/9.1891/,EF(1292)/84700./,
     +EF(1295)/-0.1723/,EF(1296)/4.1537/,EF(1297)/17400./,
     +EF(1298)/-0.3496/,EF(1299)/2.7654/,EF(1300)/9270./
C
      DATA KA(66)/'DY'/,EF(1313)/1.75/,EF(1314)/162.50/,
     +EF(1301)/26.50703/,EF(1302)/2.18020/,EF(1303)/17.63832/,
     +EF(1304)/0.20217/,EF(1305)/14.55962/,EF(1306)/12.18991/,
     +EF(1307)/2.96577/,EF(1308)/111.87410/,EF(1309)/4.29728/,
     +EF(1310)/-9.8046/,EF(1311)/9.8477/,EF(1312)/97700./,
     +EF(1315)/-0.1892/,EF(1316)/4.4098/,EF(1317)/18400./,
     +EF(1318)/-0.3302/,EF(1319)/2.9404/,EF(1320)/9850./
C
      DATA KA(67)/'HO'/,EF(1333)/1.74/,EF(1334)/164.93/,
     +EF(1321)/26.90494/,EF(1322)/2.07051/,EF(1323)/17.29402/,
     +EF(1324)/0.19794/,EF(1325)/14.55831/,EF(1326)/11.44071/,
     +EF(1327)/3.63837/,EF(1328)/92.65669/,EF(1329)/4.56797/,
     +EF(1330)/-14.9734/,EF(1331)/3.7046/,EF(1332)/34700./,
     +EF(1335)/-0.2175/,EF(1336)/4.6783/,EF(1337)/19500./,
     +EF(1338)/-0.3168/,EF(1339)/3.1241/,EF(1340)/10400./
C
      DATA KA(68)/'ER'/,EF(1353)/1.73/,EF(1354)/167.26/,
     +EF(1341)/27.65634/,EF(1342)/2.07356/,EF(1343)/16.42853/,
     +EF(1344)/0.22355/,EF(1345)/14.97791/,EF(1346)/11.36041/,
     +EF(1347)/2.98233/,EF(1348)/105.70310/,EF(1349)/5.92047/,
     +EF(1350)/-9.4367/,EF(1351)/3.9380/,EF(1352)/36700./,
     +EF(1355)/-0.2586/,EF(1356)/4.9576/,EF(1357)/20700./,
     +EF(1358)/-0.3091/,EF(1359)/3.3158/,EF(1360)/11100./
C
      DATA KA(69)/'TM'/,EF(1373)/1.72/,EF(1374)/168.93/,
     +EF(1361)/28.18193/,EF(1362)/2.02859/,EF(1363)/15.88512/,
     +EF(1364)/0.23885/,EF(1365)/15.15421/,EF(1366)/10.99751/,
     +EF(1367)/2.98706/,EF(1368)/102.96110/,EF(1369)/6.75622/,
     +EF(1370)/-8.0393/,EF(1371)/4.1821/,EF(1372)/39300./,
     +EF(1375)/-0.3139/,EF(1376)/5.2483/,EF(1377)/21900./,
     +EF(1378)/-0.3084/,EF(1379)/3.5155/,EF(1380)/11700./
C
      DATA KA(70)/'YB'/,EF(1393)/1.94/,EF(1394)/173.04/,
     +EF(1381)/28.66414/,EF(1382)/1.98890/,EF(1383)/15.43451/,
     +EF(1384)/0.25712/,EF(1385)/15.30871/,EF(1386)/10.66471/,
     +EF(1387)/2.98963/,EF(1388)/100.41710/,EF(1389)/7.56673/,
     +EF(1390)/-7.2108/,EF(1391)/4.4329/,EF(1392)/41000./,
     +EF(1395)/-0.3850/,EF(1396)/5.5486/,EF(1397)/23100./,
     +EF(1398)/-0.3157/,EF(1399)/3.7229/,EF(1400)/12400./
C
      DATA KA(71)/'LU'/,EF(1413)/1.72/,EF(1414)/174.97/,
     +EF(1401)/28.94763/,EF(1402)/1.90182/,EF(1403)/15.22081/,
     +EF(1404)/9.98520/,EF(1405)/15.10001/,EF(1406)/0.26103/,
     +EF(1407)/3.71601/,EF(1408)/84.32988/,EF(1409)/7.97629/,
     +EF(1410)/-6.6179/,EF(1411)/4.6937/,EF(1412)/45000./,
     +EF(1415)/-0.4720/,EF(1416)/5.8584/,EF(1417)/24400./,
     +EF(1418)/-0.3299/,EF(1419)/3.9377/,EF(1420)/13100./
C
      DATA KA(72)/'HF'/,EF(1433)/1.56/,EF(1434)/178.49/,
     +EF(1421)/29.14404/,EF(1422)/1.83262/,EF(1423)/15.17261/,
     +EF(1424)/9.59991/,EF(1425)/14.75861/,EF(1426)/0.27512/,
     +EF(1427)/4.30013/,EF(1428)/72.02908/,EF(1429)/8.58155/,
     +EF(1430)/-6.1794/,EF(1431)/4.9776/,EF(1432)/46000./,
     +EF(1435)/-0.5830/,EF(1436)/6.1852/,EF(1437)/25800./,
     +EF(1438)/-0.3548/,EF(1439)/4.1643/,EF(1440)/13900./
C
      DATA KA(73)/'TA'/,EF(1453)/1.43/,EF(1454)/180.95/,
     +EF(1441)/29.20244/,EF(1442)/1.77333/,EF(1443)/15.22931/,
     +EF(1444)/9.37047/,EF(1445)/14.51351/,EF(1446)/0.29598/,
     +EF(1447)/4.76492/,EF(1448)/63.36447/,EF(1449)/9.24355/,
     +EF(1450)/-5.7959/,EF(1451)/5.2718/,EF(1452)/48500./,
     +EF(1455)/-0.7052/,EF(1456)/6.5227/,EF(1457)/27200./,
     +EF(1458)/-0.3831/,EF(1459)/4.3992/,EF(1460)/14600./
C
      DATA KA(74)/'W '/,EF(1473)/1.37/,EF(1474)/183.85/,
     +EF(1461)/29.08183/,EF(1462)/1.72029/,EF(1463)/15.43001/,
     +EF(1464)/9.22591/,EF(1465)/14.43271/,EF(1466)/0.32170/,
     +EF(1467)/5.11983/,EF(1468)/57.05606/,EF(1469)/9.88751/,
     +EF(1470)/-5.4734/,EF(1471)/5.5774/,EF(1472)/51300./,
     +EF(1475)/-0.8490/,EF(1476)/6.8722/,EF(1477)/28600./,
     +EF(1478)/-0.4201/,EF(1479)/4.6430/,EF(1480)/15400./
C
      DATA KA(75)/'RE'/,EF(1493)/1.37/,EF(1494)/186.20/,
     +EF(1481)/28.76213/,EF(1482)/1.67191/,EF(1483)/15.71892/,
     +EF(1484)/9.09228/,EF(1485)/14.55641/,EF(1486)/0.35050/,
     +EF(1487)/5.44174/,EF(1488)/52.08615/,EF(1489)/10.47201/,
     +EF(1490)/-5.2083/,EF(1491)/5.8923/,EF(1492)/57200./,
     +EF(1495)/-1.0185/,EF(1496)/7.2310/,EF(1497)/30100./,
     +EF(1498)/-0.4693/,EF(1499)/4.8944/,EF(1500)/16200./
C
      DATA KA(76)/'OS'/,EF(1513)/1.34/,EF(1514)/190.20/,
     +EF(1501)/28.18944/,EF(1502)/1.62903/,EF(1503)/16.15501/,
     +EF(1504)/8.97949/,EF(1505)/14.93051/,EF(1506)/0.38266/,
     +EF(1507)/5.67590/,EF(1508)/48.16475/,EF(1509)/11.00051/,
     +EF(1510)/-4.9801/,EF(1511)/6.2216/,EF(1512)/58000./,
     +EF(1515)/-1.2165/,EF(1516)/7.6030/,EF(1517)/31600./,
     +EF(1518)/-0.5280/,EF(1519)/5.1558/,EF(1520)/17100./
C
      DATA KA(77)/'IR'/,EF(1533)/1.36/,EF(1534)/192.20/,
     +EF(1521)/27.30493/,EF(1522)/1.59279/,EF(1523)/16.72961/,
     +EF(1524)/8.86554/,EF(1525)/15.61152/,EF(1526)/0.41792/,
     +EF(1527)/5.83378/,EF(1528)/45.00114/,EF(1529)/11.47221/,
     +EF(1530)/-4.7710/,EF(1531)/6.5667/,EF(1532)/62400./,
     +EF(1535)/-1.4442/,EF(1536)/7.9887/,EF(1537)/33100./,
     +EF(1538)/-0.5977/,EF(1539)/5.4269/,EF(1540)/18000./
C
      DATA KA(78)/'PT'/,EF(1553)/1.37/,EF(1554)/195.09/,
     +EF(1541)/27.00594/,EF(1542)/1.51293/,EF(1543)/17.76392/,
     +EF(1544)/8.81175/,EF(1545)/15.71312/,EF(1546)/0.42459/,
     +EF(1547)/5.78371/,EF(1548)/38.61034/,EF(1549)/11.68831/,
     +EF(1550)/-4.5932/,EF(1551)/6.9264/,EF(1552)/63400./,
     +EF(1555)/-1.7033/,EF(1556)/8.3905/,EF(1557)/34800./,
     +EF(1558)/-0.6812/,EF(1559)/5.7081/,EF(1560)/18900./
C
      DATA KA(79)/'AU'/,EF(1573)/1.44/,EF(1574)/196.9665/,
     +EF(1561)/16.88193/,EF(1562)/0.46110/,EF(1563)/18.59132/,
     +EF(1564)/8.62161/,EF(1565)/25.55824/,EF(1566)/1.48260/,
     +EF(1567)/5.86001/,EF(1568)/36.39563/,EF(1569)/12.06581/,
     +EF(1570)/-4.4197/,EF(1571)/7.2980/,EF(1572)/66900./,
     +EF(1575)/-2.0133/,EF(1576)/8.8022/,EF(1577)/36500./,
     +EF(1578)/-0.7638/,EF(1579)/5.9978/,EF(1580)/19900./
C
      DATA KA(80)/'HG'/,EF(1593)/1.50/,EF(1594)/200.59/,
     +EF(1581)/20.68092/,EF(1582)/0.54500/,EF(1583)/19.04172/,
     +EF(1584)/8.44841/,EF(1585)/21.65752/,EF(1586)/1.57290/,
     +EF(1587)/5.96761/,EF(1588)/38.32463/,EF(1589)/12.60891/,
     +EF(1590)/-4.2923/,EF(1591)/7.6849/,EF(1592)/66800./,
     +EF(1595)/-2.3894/,EF(1596)/9.2266/,EF(1597)/38200./,
     +EF(1598)/-0.8801/,EF(1599)/6.2989/,EF(1600)/20900./
C
      DATA KA(81)/'TL'/,EF(1613)/1.64/,EF(1614)/204.37/,
     +EF(1601)/27.54463/,EF(1602)/0.65515/,EF(1603)/19.15842/,
     +EF(1604)/8.70752/,EF(1605)/15.53802/,EF(1606)/1.96347/,
     +EF(1607)/5.52594/,EF(1608)/45.81496/,EF(1609)/13.17461/,
     +EF(1610)/-4.1627/,EF(1611)/8.0900/,EF(1612)/75400./,
     +EF(1615)/-2.8358/,EF(1616)/9.6688/,EF(1617)/40100./,
     +EF(1618)/-1.0117/,EF(1619)/6.6090/,EF(1620)/21900./
C
      DATA KA(82)/'PB'/,EF(1633)/1.60/,EF(1634)/207.19/,
     +EF(1621)/31.06174/,EF(1622)/0.69020/,EF(1623)/13.06371/,
     +EF(1624)/2.35760/,EF(1625)/18.44202/,EF(1626)/8.61801/,
     +EF(1627)/5.96961/,EF(1628)/47.25795/,EF(1629)/13.41181/,
     +EF(1630)/-4.0753/,EF(1631)/8.5060/,EF(1632)/79800./,
     +EF(1635)/-3.3944/,EF(1636)/10.1111/,EF(1637)/41900./,
     +EF(1638)/-1.1676/,EF(1639)/6.9287/,EF(1640)/22900./
C
      DATA KA(83)/'BI'/,EF(1653)/1.60/,EF(1654)/208.98/,
     +EF(1641)/33.36894/,EF(1642)/0.70400/,EF(1643)/12.95101/,
     +EF(1644)/2.92380/,EF(1645)/16.58772/,EF(1646)/8.79371/,
     +EF(1647)/6.46921/,EF(1648)/48.00935/,EF(1649)/13.57821/,
     +EF(1650)/-4.0111/,EF(1651)/8.9310/,EF(1652)/84300./,
     +EF(1655)/-4.1077/,EF(1656)/10.2566/,EF(1657)/43800./,
     +EF(1658)/-1.3494/,EF(1659)/7.2566/,EF(1660)/24000./
C
      DATA KA(84)/'PO'/,EF(1673)/1.60/,EF(1674)/210.00/,
     +EF(1661)/34.67264/,EF(1662)/0.70100/,EF(1663)/15.47331/,
     +EF(1664)/3.55078/,EF(1665)/13.11381/,EF(1666)/9.55643/,
     +EF(1667)/7.02589/,EF(1668)/47.00455/,EF(1669)/13.67701/,
     +EF(1670)/-3.9670/,EF(1671)/9.3834/,EF(1672)/88100./,
     +EF(1675)/-5.1210/,EF(1676)/11.0496/,EF(1677)/45800./,
     +EF(1678)/-1.5613/,EF(1679)/7.5986/,EF(1680)/25100./
C
      DATA KA(85)/'AT'/,EF(1693)/1.60/,EF(1694)/210.00/,
     +EF(1681)/35.31633/,EF(1682)/0.68587/,EF(1683)/19.02112/,
     +EF(1684)/3.97458/,EF(1685)/9.49888/,EF(1686)/11.38241/,
     +EF(1687)/7.42519/,EF(1688)/45.47156/,EF(1689)/13.71081/,
     +EF(1690)/-3.9588/,EF(1691)/9.8433/,EF(1692)/86500./,
     +EF(1695)/-7.9122/,EF(1696)/9.9777/,EF(1697)/40700./,
     +EF(1698)/-1.8039/,EF(1699)/7.9509/,EF(1700)/26200./
C
      DATA KA(86)/'RN'/,EF(1713)/1.80/,EF(1714)/222.00/,
     +EF(1701)/35.56314/,EF(1702)/0.66310/,EF(1703)/21.28162/,
     +EF(1704)/4.06910/,EF(1705)/8.00371/,EF(1706)/14.04221/,
     +EF(1707)/7.44331/,EF(1708)/44.24734/,EF(1709)/13.69051/,
     +EF(1710)/-3.9487/,EF(1711)/10.3181/,EF(1712)/97200./,
     +EF(1715)/-8.0659/,EF(1716)/10.4580/,EF(1717)/39800./,
     +EF(1718)/-2.0847/,EF(1719)/8.3112/,EF(1720)/27300./
C
      DATA KA(87)/'FR'/,EF(1733)/2.80/,EF(1734)/223.00/,
     +EF(1721)/35.92993/,EF(1722)/0.64645/,EF(1723)/23.05472/,
     +EF(1724)/4.17619/,EF(1725)/12.14391/,EF(1726)/23.10522/,
     +EF(1727)/2.11253/,EF(1728)/150.64510/,EF(1729)/13.72471/,
     +EF(1730)/-3.9689/,EF(1731)/10.8038/,EF(1732)/102000./,
     +EF(1735)/-7.2224/,EF(1736)/7.7847/,EF(1737)/32200./,
     +EF(1738)/-2.4129/,EF(1739)/8.6839/,EF(1740)/28500./
C
      DATA KA(88)/'RA'/,EF(1753)/2.20/,EF(1754)/226.00/,
     +EF(1741)/35.76303/,EF(1742)/0.61634/,EF(1743)/22.90642/,
     +EF(1744)/3.87135/,EF(1745)/12.47391/,EF(1746)/19.98872/,
     +EF(1747)/3.21097/,EF(1748)/142.32510/,EF(1749)/13.62111/,
     +EF(1750)/-4.0088/,EF(1751)/11.2969/,EF(1752)/102000./,
     +EF(1755)/-6.7704/,EF(1756)/8.1435/,EF(1757)/33000./,
     +EF(1758)/-2.8081/,EF(1759)/9.0614/,EF(1760)/29800./
C
      DATA KA(89)/'AC'/,EF(1773)/1.90/,EF(1774)/227.00/,
     +EF(1761)/35.65973/,EF(1762)/0.58909/,EF(1763)/23.10323/,
     +EF(1764)/3.65155/,EF(1765)/12.59771/,EF(1766)/18.59901/,
     +EF(1767)/4.08655/,EF(1768)/117.02010/,EF(1769)/13.52661/,
     +EF(1770)/-4.0794/,EF(1771)/11.7994/,EF(1772)/143000./,
     +EF(1775)/-6.8494/,EF(1776)/8.5178/,EF(1777)/54000./,
     +EF(1778)/-3.2784/,EF(1779)/9.4502/,EF(1780)/31100./
C
      DATA KA(90)/'TH'/,EF(1793)/1.85/,EF(1794)/232.04/,
     +EF(1781)/35.56453/,EF(1782)/0.56336/,EF(1783)/23.42192/,
     +EF(1784)/3.46204/,EF(1785)/12.74731/,EF(1786)/17.83092/,
     +EF(1787)/4.80704/,EF(1788)/99.17230/,EF(1789)/13.43141/,
     +EF(1790)/-4.1491/,EF(1791)/12.3296/,EF(1792)/118000./,
     +EF(1795)/-7.2400/,EF(1796)/8.8979/,EF(1797)/37000./,
     +EF(1798)/-3.8533/,EF(1799)/9.8403/,EF(1800)/32300./
C
      DATA KA(91)/'PA'/,EF(1813)/1.80/,EF(1814)/231.00/,
     +EF(1801)/35.88474/,EF(1802)/0.54775/,EF(1803)/23.29482/,
     +EF(1804)/3.41519/,EF(1805)/14.18911/,EF(1806)/16.92352/,
     +EF(1807)/4.17287/,EF(1808)/105.25110/,EF(1809)/13.42871/,
     +EF(1810)/-4.2473/,EF(1811)/12.8681/,EF(1812)/106000./,
     +EF(1815)/-8.0334/,EF(1816)/9.2807/,EF(1817)/38700./,
     +EF(1818)/-4.6067/,EF(1819)/10.2413/,EF(1820)/34200./
C
      DATA KA(92)/'U '/,EF(1833)/1.80/,EF(1834)/238.03/,
     +EF(1821)/36.02284/,EF(1822)/0.52930/,EF(1823)/23.41283/,
     +EF(1824)/3.32530/,EF(1825)/14.94911/,EF(1826)/16.09273/,
     +EF(1827)/4.18800/,EF(1828)/100.61310/,EF(1829)/13.39661/,
     +EF(1830)/-4.3638/,EF(1831)/13.4090/,EF(1832)/112000./,
     +EF(1835)/-9.6767/,EF(1836)/9.6646/,EF(1837)/40300./,
     +EF(1838)/-5.7225/,EF(1839)/10.6428/,EF(1840)/35000./
C
      DATA KA(93)/'NP'/,EF(1853)/1.80/,EF(1854)/237.00/,
     +EF(1841)/36.18744/,EF(1842)/0.51193/,EF(1843)/23.59642/,
     +EF(1844)/3.25396/,EF(1845)/15.64022/,EF(1846)/15.36222/,
     +EF(1847)/4.18550/,EF(1848)/97.49089/,EF(1849)/13.35731/,
     +EF(1850)/-4.5053/,EF(1851)/13.9666/,EF(1852)/123000./,
     +EF(1855)/-11.4937/,EF(1856)/4.1493/,EF(1857)/25700./,
     +EF(1858)/-6.9995/,EF(1859)/9.5876/,EF(1860)/29900./
C
      DATA KA(94)/'PU'/,EF(1873)/1.80/,EF(1874)/242.00/,
     +EF(1861)/36.52544/,EF(1862)/0.49938/,EF(1863)/23.80832/,
     +EF(1864)/3.26371/,EF(1865)/16.77072/,EF(1866)/14.94551/,
     +EF(1867)/3.47947/,EF(1868)/105.98010/,EF(1869)/13.38121/,
     +EF(1870)/-4.6563/,EF(1871)/14.3729/,EF(1872)/113000./,
     +EF(1875)/-9.4100/,EF(1876)/4.3056/,EF(1877)/16200./,
     +EF(1878)/-13.5905/,EF(1879)/6.9468/,EF(1880)/22700./
C
   1  FORMAT(A)
   2  FORMAT(1X,A)
   3  FORMAT(/' V =',F12.2,5X,'F(000) =',F10.1,5X,'Mu =',F7.2,
     +' mm-1',5X,' Cell Wt =',F12.2,'    Rho =',F7.3/)
   4  FORMAT(/' Name    a1       b1       a2       b2       a3      ',
     +' b3       a4       b4        c        f''       f"        mu ',
     +'     M    rad'/)
   5  FORMAT(1X,A4,11F9.5,F10.2,F7.2,F6.2)
   6  FORMAT(F7.3,2F8.3)
   7  FORMAT(/' ** SHELX-76/XLS weights are inappropriate for ',
     +'refinement against F-squared **'/)
C
      WRITE(*,'(A)')' Read instructions and data'
C
C Default parameters
C
        DO 8 I=1,50
        IH(I)=IG(I)
   8    CONTINUE
      IA=0
      JA=1
      JB=0
      JC=0
      JE=0
      KH=0
      KI=0
      KG=0
      LY=201
      LL=1
      LB=0
      LX=0
      LT=0
      NA=LU
      NQ=12
      DT=.05
      B(JA)=0.
        DO 9 I=1,212
        A(I)=0.
   9    CONTINUE
        DO 10 I=33,35
        A(I)=-2.
        A(I+3)=2.
  10    CONTINUE
      A(39)=-9.E9
      CALL SXPS(A(43),KC(1))
      CALL SXPS(A(44),'0   ')
      A(46)=2.
      A(49)=1.
      A(51)=1.
      A(52)=-3.
      A(53)=1.
      A(56)=53.
      A(58)=-1.
      A(59)=3.
      A(63)=1.
      A(64)=.1
      A(69)=.3333333
      A(70)=1.
      A(72)=1.
      A(104)=20.
      A(121)=.001
      A(122)=.001
      A(123)=9.E9
      A(124)=9.E9
      A(125)=.2
      A(126)=12.
      A(130)=9.E9
      A(132)=.03
      A(133)=.2
      A(134)=.01
      A(135)=.05
      A(155)=1.
      A(159)=1.
      A(170)=15.
      A(180)=-999.
      A(196)=1.
      A(197)=.5
      A(198)=.3
      A(200)=-999.
      A(201)=1.
      A(205)=1.
      A(209)=1.
      ML(1)=1
C
C Read instruction and identify codeword
C
  11  IF(LX.GT.LM-1000)GOTO 76
      IF(JA.GT.JW-1000)GOTO 76
      CALL SXCC
      READ(LR,1,END=98)IR
      KS='    '
      IF(IR(1:1).EQ.IH(13))GOTO 20
        DO 12 KB=1,4
        IF(IR(KB:KB).EQ.CHAR(13))IR(KB:KB)=IH(20)
        KK=IR(KB:KB)
        IF(KK.EQ.IH(20))GOTO 13
        IF(KK.EQ.IH(22))GOTO 13
        IF(KK.EQ.KJ)GOTO 13
        CALL SXUC(KK)
        KS(KB:KB)=KK
  12    CONTINUE
      KB=5
  13  KB=KB-1
      KR=KB
      IF(KR.EQ.0)KR=1
      KE=80
        DO 14 I=KB+1,80
        IF(IR(I:I).EQ.CHAR(13))IR(I:I)=IH(20)
        IF(IR(I:I).EQ.KJ)KE=MIN0(KE,I-1)
        IF(IR(I:I).NE.IH(20))KR=I
  14    CONTINUE
      IF(KE.GT.KR)KE=KR
c      IF(A(51).GT.0.5)WRITE(LI,2)IR(1:KR)
        DO 15 NK=1,75
        IF(KC(NK).EQ.KS)GOTO 16
  15    CONTINUE
      NK=1
      IF(LR.NE.LK)GOTO 23
      IF(JB.EQ.0)WRITE(LC)NK,KR,KS,IR
      GOTO 23
  16  IF(NK.EQ.62)GOTO 19
      IF(NK.EQ.64)GOTO 19
      IF(KR.NE.1)GOTO 17
      NK=NQ
      NQ=1
  17  IF(NK.EQ.1)GOTO 11
      IF(LR.NE.LK)GOTO 19
      IF(NK.EQ.5)GOTO 18
      IF(NK.LT.12)GOTO 19
  18  WRITE(LC)NK,KR,KS,IR
      IF(KR.NE.1)NQ=12
  19  IF(NK.EQ.12)GOTO 11
      IF(NK.NE.42)GOTO 22
c  here for TITL card?????
      IF(KE.LT.5)KE=5
      IT=IR(5:KE)
      GOTO 11
C
C Open nested input files
C
  20  K=0
        DO 21 I=2,80
        IF(IR(I:I).EQ.IH(20))GOTO 21
        K=K+1
        IR(K:K)=IR(I:I)
        IF(IR(K:K).GE.'A'.AND.IR(K:K).LE.'Z')IR(K:K)=CHAR(32+
     +  ICHAR(IR(K:K)))
  21    CONTINUE
      I=-1
      WRITE(LC)I,K+1,KS,IH(13)//IR(1:79)
      LR=LR+1
      OPEN(LR,FILE=IR(1:K),STATUS='OLD',ERR=96)
      GOTO 11
C
C Decode instruction
C
  22  IF(JB.EQ.0)GOTO 23
      IF(NK.NE.11)CALL SXER(KS//' NOT ALLOWED IN FRAG...FEND SECTION')
  23  MQ=0
        DO 28 I=KB+1,KE
        CALL SXUC(IR(I:I))
        IF(IR(I:I).EQ.IH(23))GOTO 24
        IF(IR(I:I).NE.IH(24))GOTO 27
  24    IF(MQ.EQ.0)GOTO 26
        IF(I.EQ.KE)GOTO 26
        IF(IR(I-1:I-1).NE.IH(20))GOTO 25
        IF(IR(I+1:I+1).EQ.IH(20))GOTO 28
  25    CALL SXER('SPACE NEEDED BEFORE AND AFTER < OR >')
  26    CALL SXER('MISPLACED < OR >')
  27    IF(IR(I:I).NE.IH(20))MQ=1
  28    CONTINUE
      CALL SXUS(A(44),KT)
      CALL SXPS(FC(1),KT)
      IF(NA.LT.1)NA=1
      CALL SXZA(FF,NA)
      NA=0
      MQ=1
C
C Evaluate numbers in instruction
C
      N=KB
      NJ=77
      L=91
      IF(NK.EQ.44)GOTO 29
      NJ=LY+7
      L=LY+21
      IF(NK.NE.16)GOTO 31
  29  M=L+2
        DO 30 I=NJ+5,M
        A(I)=0.
  30    CONTINUE
  31  W=1.
  32  V=0.
      NB=0
      Y=1.
      U=10.
      Z=1.
      X=0.
      GOTO 34
  33  Z=Y*Z
      V=U*ABS(V)+Z*X
      NB=1
      IF(ABS(V).LT.1.E-8)GOTO 34
      V=SIGN(V,W)
      W=V
  34  N=N+1
      K=11
      IF(N.GT.KE)GOTO 37
      X=0.
        DO 35 K=1,19
        IF(IR(N:N).EQ.IH(K))GOTO 36
        X=X+1.
  35    CONTINUE
      K=1
      GOTO 37
C
C SYMM and EQIV
C
  36  IF(K.LT.11)GOTO 33
      K=K-9
  37  IF(NK.NE.44)GOTO 38
      M=0
      IF(IR(N:N).EQ.IH(50))GOTO 57
      GOTO 39
  38  IF(NK.NE.16)GOTO 51
  39  IF(K.NE.10)GOTO 43
      IF(ABS(V).LT.1.E-8)GOTO 83
      N=N+1
      IF(N.GT.KE)GOTO 83
        DO 40 I=2,7
        IF(IH(I).EQ.IR(N:N))GOTO 41
  40    CONTINUE
      GOTO 83
  41  V=V/REAL(I-1)
      W=V
      IF(N.EQ.KE)GOTO 34
        DO 42 I=1,10
        IF(IH(I).EQ.IR(N+1:N+1))GOTO 83
  42    CONTINUE
      GOTO 34
  43  IF(K.EQ.9)GOTO 47
      IF(K.GT.7)GOTO 46
      IF(K.GT.4)GOTO 45
      IF(K.GT.2)GOTO 53
      IF(K.EQ.1)GOTO 34
  44  U=1.
      Y=0.1
      GOTO 34
  45  K=K+NJ
      A(K)=W
      GOTO 31
  46  U=AINT(V)
      A(L)=A(L)+U+AINT(24.5*(V-U))/24.
      L=L+1
      NJ=NJ+3
      IF(NJ+8.LT.L)GOTO 31
      IF(NK.EQ.44)GOTO 216
      LY=LY+12
      IF(LB.EQ.0)GOTO 11
      CALL SXER('MISPLACED SYMM INSTRUCTION')
C
C Continuation lines and errors
C
  47  IF(NK.EQ.44)GOTO 80
      IF(NK.EQ.16)GOTO 80
      READ(LR,1,END=50)IR
      KR=1
      KE=80
        DO 48 I=1,80
        IF(IR(I:I).EQ.CHAR(13))IR(I:I)=IH(20)
        IF(IR(I:I).EQ.KJ)KE=MIN0(KE,I-1)
        IF(IR(I:I).EQ.IH(20))GOTO 48
        KR=I
        CALL SXUC(IR(I:I))
  48    CONTINUE
      IF(KE.GT.KR)KE=KR
      N=0
c      IF(A(51).GT.0.5)WRITE(LI,2)IR(1:KR)
      IF(NK.EQ.62)GOTO 49
      IF(NK.EQ.64)GOTO 49
      IF(LR.NE.LK)GOTO 49
      IF(NK.GT.11)WRITE(LC)N,KR,KS,IR
  49  IF(IR(1:1).NE.IH(20))CALL SXER('BAD CONTINUATION LINE')
      GOTO 31
  50  CALL SXER('END OF FILE INSTEAD OF CONTINUATION LINE')
  51  IF(K.EQ.2)GOTO 44
      IF(NB.EQ.0)GOTO 55
      NA=NA+1
      IF(NA.GT.LU)CALL SXER('TOO MANY NUMBERS IN COMMAND')
      FF(NA)=V
  52  IF(K.LT.9)GOTO 54
      IF(K.GT.9)GOTO 99
      GOTO 47
  53  U=AINT(V)
      A(L)=A(L)+U+AINT(24.5*(V-U))/24.
  54  IF(K.NE.3)GOTO 31
      W=-1.
      GOTO 32
  55  IF(K.EQ.1)K=6
      IF(IABS(K-6).GT.1)GOTO 52
      IF(IR(N:N).EQ.IH(20))GOTO 52
C
C Decode atom names and residue references
C
      M=0
      IF(IR(N:N).NE.IH(22))GOTO 57
      IF(N.GT.KB+1)CALL SXER('RESIDUE REFERENCE MUST '//
     +'IMMEDIATELY FOLLOW COMMAND OR ATOM NAME')
  56  N=N+1
      M=1
  57  KT=KC(1)
        DO 58 K=1,4
        IF(N.GT.KE)GOTO 59
        IF(IR(N:N).EQ.IH(17))GOTO 59
        IF(IR(N:N).EQ.IH(18))GOTO 59
        IF(IR(N:N).EQ.IH(20))GOTO 59
        IF(IR(N:N).EQ.IH(22))GOTO 59
        KT(K:K)=IR(N:N)
        N=N+1
  58    CONTINUE
  59  IF(M.NE.0)GOTO 69
      MQ=MQ+2
      IF(MQ.GE.LU)CALL SXER('TOO MANY NAMES IN COMMAND')
      CALL SXPS(FC(MQ-1),KT)
      CALL SXPS(FC(MQ),KC(1))
      IF(KT(1:1).NE.IH(23))GOTO 60
      IF(NK.EQ.51)GOTO 31
      GOTO 94
  60  IF(KT(1:1).NE.IH(24))GOTO 61
      IF(NK.EQ.61)GOTO 94
      IF(NK.EQ.26)GOTO 31
      IF(NK.GT.50)GOTO 31
      IF(IABS(NK-46).LT.2)GOTO 31
      GOTO 94
  61  IF(KT(1:1).NE.IH(50))GOTO 67
      IF(NK.EQ.61)GOTO 94
      IF(NK.GE.57)GOTO 68
      IF(NK.EQ.26)GOTO 68
      IF(NK.EQ.39)GOTO 68
      IF(NK.NE.47)GOTO 62
      IF(KT(2:2).NE.IH(34))GOTO 68
      IF(KT(3:3).EQ.IH(20))GOTO 31
      GOTO 68
  62  IF(NK.NE.17)GOTO 63
      KQ=KT(2:4)
      KT=KQ
      GOTO 31
  63  IF(NK.NE.44)GOTO 94
      GOTO 65
  64  IF(NK.EQ.61)GOTO 65
      IF(NK.GT.55)GOTO 94
      IF(NK.EQ.51)GOTO 94
      IF(NK.LT.47)GOTO 94
  65    DO 66 I=1,10
        IF(IH(I).EQ.KT(2:2))GOTO 31
  66    CONTINUE
      GOTO 95
  67  IF(NK.EQ.17)GOTO 68
      IF(NK.EQ.26)GOTO 68
      IF(NK.EQ.29)GOTO 68
      IF(NK.EQ.39)GOTO 68
      IF(NK.LT.45)GOTO 90
      IF(NK.GT.65)GOTO 90
  68  IF(IR(N:N).NE.IH(22))GOTO 31
      GOTO 56
  69  CALL SXPS(FC(MQ),KT)
      IF(NK.EQ.26)GOTO 70
      IF(NK.LT.45)GOTO 93
      IF(NK.GT.64)GOTO 93
  70  IF(KT(1:1).EQ.IH(50))GOTO 64
      IF(KT(1:1).EQ.IH(12))GOTO 71
      IF(KT(1:1).NE.IH(13))GOTO 73
  71  IF(MQ.EQ.1)GOTO 94
      IF(NK.EQ.50)GOTO 72
      IF(NK.EQ.57)GOTO 72
      IF(NK.EQ.61)GOTO 72
      IF(NK.LT.52)GOTO 94
      IF(NK.GT.55)GOTO 94
  72  IF(KT(2:2).NE.IH(20))GOTO 93
      GOTO 31
  73  IF(MQ.EQ.1)GOTO 31
        DO 74 K=1,10
        IF(KT(1:1).EQ.IH(K))GOTO 31
  74    CONTINUE
      IF(KT(1:1).NE.IH(21))GOTO 93
      IF(KT(2:2).NE.IH(20))GOTO 93
      CALL SXUS(FC(MQ-1),KT)
      IF(KT(1:1).NE.IH(50))GOTO 93
      IF(NK.EQ.58)GOTO 31
      IF(NK.EQ.59)GOTO 31
      GOTO 93
C
C Error diagnostics
C
  75  CALL SXER('INCOMPLETE '//KS//' GROUP')
  76  CALL SXER('PROBLEM TOO LARGE FOR CURRENT ARRAY DIMENSIONS')
  77  CALL SXER('WRONG NUMBER OF NUMERICAL PARAMETERS')
  78  CALL SXER('WRONG NUMBER OF ATOM NAMES')
  79  CALL SXER('REPEATED '//KS//' INSTRUCTION')
  80  CALL SXER('CONTINUATION LINE NOT ALLOWED AFTER '//KS)
  81  CALL SXER('CELL MISSING')
  82  CALL SXER('BAD CELL')
  83  CALL SXER('BAD SYMMETRY OPERATOR')
  84  CALL SXER('INCONSISTENT LATT/SYMM')
  85  CALL SXER('BAD ATOM OR UNKNOWN INSTRUCTION')
  86  CALL SXER('CONFLICTING AFIX BEFORE END OF FITTED GROUP')
  87  CALL SXER('AFIX REFERS TO UNKNOWN FRAG')
  88  CALL SXER('FREE VARIABLE REFERENCE PREVENTS MOVE')
  89  CALL SXER('PARAMETER OUT OF RANGE')
  90  CALL SXER('ATOM NAMES NOT ALLOWED')
  91  CALL SXER('LAUE REQUIRES ONE $EL TO SPECIFY ELEMENT')
  92  CALL SXER('LAUE MUST FOLLOW ALL ATOMS')
  93  CALL SXER('ILLEGAL REFERENCE TO RESIDUE '//KT)
  94  CALL SXER(KT(1:1)//' NOT ALLOWED HERE')
  95  CALL SXER('EQIV MUST BE FOLLOWED BY $n THEN SYMMETRY OPERATOR')
  96  CALL SXER('CANNOT OPEN NESTED INPUT FILE '//IR(1:K))
  97  CALL SXER(KS//'NOT ALLOWED IN INCLUDE FILE')
C
C Eof or END - close current input file and return to previous level
C
  98  NK=2
      NA=0
  99  IF(NK.NE.2)GOTO 101
      IF(NA.NE.0)CALL SXER('BAD END')
      IF(LR.LE.LK)GOTO 100
      CLOSE(LR,STATUS='KEEP')
      LR=LR-1
      GOTO 11
 100  NK=40
      NA=1
      FF(1)=4.
      KR=6
      IR='HKLF 4'
      IF(LR.EQ.LK)WRITE(LC)NK,KR,IR(1:4),IR
C
C Set up crystal data - CELL
C
 101  IF(NK.GT.69)GOTO 11
      IF(NK.NE.13)GOTO 105
      IF(A(1).GT.0.001)GOTO 79
      IF(NA.NE.7)GOTO 82
      IF(FF(1).LE.0.)GOTO 82
      A(1)=FF(1)
        DO 102 I=2,NA
        IF(.1.GT.FF(I))GOTO 82
        A(I)=FF(I)
 102    CONTINUE
c****
c thisa is cell output (wavelkength first)
       do iii=1,6
        cell(iii)=ff(iii+1)
       enddo
c****
      U=2.*A(2)*A(3)*A(4)
        DO 103 I=2,4
        X=1.74533E-2*A(I+3)
        FF(I)=COS(X)
        FF(I+3)=SIN(X)
        A(I+9)=U*FF(I)/A(I)
        FF(I+6)=A(I+9)**2
        A(I+6)=A(I)**2
 103    CONTINUE
      X=(FF(2)-FF(3)*FF(4))/(FF(6)*FF(7))
      A(94)=A(2)
      A(95)=A(3)*FF(4)
      A(96)=A(4)*FF(3)
      A(97)=A(3)*FF(7)
      A(98)=A(4)*FF(6)*X
      A(99)=A(4)*FF(6)*SQRT(ABS(1.-X**2))
      A(20)=A(94)*A(97)*A(99)
      V=.125*(A(1)/A(20))**2
        DO 104 I=8,10
        A(I+6)=.5*V*((U**2/A(I))-FF(I))
        A(I+9)=-2.*V*A(I)*A(I+3)
 104    CONTINUE
      A(17)=A(17)+V*A(12)*A(13)
      A(18)=A(18)+V*A(11)*A(13)
      A(19)=A(19)+V*A(11)*A(12)
      NA=10
      GOTO 11
C
C ZERR
C
 105  IF(NK.NE.14)GOTO 108
      IF(FF(1).LT.0.01)GOTO 89
      NJ=26
      K=7
 106  IF(NA.GT.K)GOTO 77
      IF(MQ.NE.1)GOTO 90
      NA=MAX0(NA,1)
        DO 107 I=1,NA
        A(NJ)=FF(I)
        NJ=NJ+1
 107    CONTINUE
      GOTO 11
C
C LATT
C
 108  IF(NK.NE.15)GOTO 109
      IF(ABS(A(1)).LT.1.E-8)GOTO 81
      IF(FF(1).LT.0.)A(23)=1.
      IF(LL.NE.1)GOTO 79
      LL=INT(0.5+ABS(FF(1)))
      IF(LL.EQ.0)GOTO 89
      IF(LL.GT.7)GOTO 89
      GOTO 11
C
C SFAC - set up lattice transformations
C
 109  IF(NK.NE.17)GOTO 134
      IF(ABS(A(1)).LT.1.E-8)GOTO 81
      IF(LL.GT.160)GOTO 125
      IF(A(26).LT.0.1)CALL SXER('ZERR MISSING')
      N=3*LL+20
      L=INT(4.1-2.*A(23))
        DO 110 I=24,32
        SI(I)=.5
 110    CONTINUE
      IF(N.LT.32)GOTO 112
      IF(N.GT.32)GOTO 114
        DO 111 I=24,32,4
        SI(I)=0.
 111    CONTINUE
 112  IF(N.NE.29)GOTO 115
        DO 113 I=24,29
        SI(I)=.6666667
 113    CONTINUE
      SI(25)=.3333333
      SI(26)=.3333333
      SI(27)=.3333333
      GOTO 115
 114  SI(LL+19)=0.
      N=24
 115  LL=LY+8
        DO 117 K=2,L,2
          DO 116 M=21,N,3
          LL=LL+4
          A(LL)=3.-REAL(K)
          A(LL+1)=SI(M)+99.5
          A(LL+2)=SI(M+1)+99.5
          A(LL+3)=SI(M+2)+99.5
 116      CONTINUE
 117    CONTINUE
      LB=LL-12
C
C Check LATT/SYMM
C
      M=LY+12
      N=LL+2
        DO 119 K=201,LY,12
        CALL SXCC
        IF(ABS(ABS(A(K)*(A(K+4)*A(K+8)-A(K+5)*A(K+7))+A(K+1)*
     +  (A(K+5)*A(K+6)-A(K+3)*A(K+8))+A(K+2)*(A(K+3)*A(K+7)-
     +  A(K+4)*A(K+6)))-1.).GT.0.01)GOTO 83
          DO 118 L=M,LL,4
          N=N+3
          A(N)=AMOD(A(L)*(.143*A(K)+.277*A(K+1)+
     +    .811*A(K+2)+A(K+9))+A(L+1)+.5,1.)
          A(N+1)=AMOD(A(L)*(.143*A(K+3)+.277*A(K+4)+
     +    .811*A(K+5)+A(K+10))+A(L+2)+.5,1.)
          A(N+2)=AMOD(A(L)*(.143*A(K+6)+.277*A(K+7)+
     +    .811*A(K+8)+A(K+11))+A(L+3)+.5,1.)
 118      CONTINUE
 119    CONTINUE
        DO 124 K=201,LY,12
          DO 123 L=M,LL,4
          CALL SXCC
          I=LL+2
 120      I=I+3
          IF(I.GT.N)GOTO 123
          X=AMOD(A(L)*(A(I)*A(K)+A(I+1)*A(K+1)+
     +    A(I+2)*A(K+2)+A(K+9))+A(L+1)+.5,1.)
          Y=AMOD(A(L)*(A(I)*A(K+3)+A(I+1)*A(K+4)+
     +    A(I+2)*A(K+5)+A(K+10))+A(L+2)+.5,1.)
          Z=AMOD(A(L)*(A(I)*A(K+6)+A(I+1)*A(K+7)+
     +    A(I+2)*A(K+8)+A(K+11))+A(L+3)+.5,1.)
          NB=0
          NJ=LL+2
 121      NJ=NJ+3
          IF(NJ.GT.N)GOTO 122
          IF(ABS(X-A(NJ))+ABS(Y-A(NJ+1))+ABS(Z-A(NJ+2)).LT.0.001)
     +    NB=NB+1
          GOTO 121
 122      IF(NB.EQ.1)GOTO 120
          GOTO 84
 123      CONTINUE
 124    CONTINUE
C
C SFAC
C
 125  IF(NA.GT.0)GOTO 130
      K=0
 126  K=K+2
      IF(K.GT.MQ)GOTO 11
      CALL SXUS(FC(K),KT)
        DO 127 M=1,94
        IF(KA(M).EQ.KT(1:2))GOTO 128
 127    CONTINUE
      CALL SXER('UNKNOWN ELEMENT')
 128  continue
c****
      nel=nel+1
      nsfac(nel)=m  
      LB=LB+16
      M=20*M-19
      I=M+9
      IF(A(1).LT.1.)I=I+5
      IF(A(1).LT.0.6)I=I+3
      IF(M.EQ.1)KH=LB
      A(LB)=EF(I)
      A(LB+1)=EF(I+1)
      A(LB+2)=EF(M+12)
      L=LB+3
        DO 129 N=M,M+7
        A(L)=EF(N)
        L=L+1
 129    CONTINUE
      A(L)=EF(M+8)+EF(I)
      A(LB+12)=EF(M+13)
      CALL SXPS(A(LB+13),KT)
      A(LB+14)=EF(I+2)
      A(LB+15)=AINT(.5+EF(M)+EF(M+2)+EF(M+4)+EF(M+6)+EF(M+8))
      GOTO 126
 130  IF(MQ.LT.2)CALL SXER('NO ELEMENT NAME FOR SFAC')
      LB=LB+16
      IF(NA.EQ.14)GOTO 132
      IF(NA.NE.5)GOTO 77
        DO 131 I=LB,LB+10
        A(I)=0.
 131    CONTINUE
      A(LB+11)=FF(1)
 132  A(LB+1)=FF(NA-3)
      A(LB+2)=FF(NA-1)
      A(LB+14)=FF(NA-2)
      A(LB+15)=0.
      IF(FF(NA).LT.0.0001)GOTO 89
      A(LB+12)=-FF(NA)
      CALL SXUS(FC(2),KT)
      CALL SXPS(A(LB+13),KT)
      IF(KT.EQ.'H   ')KH=LB
      IF(NA.NE.14)GOTO 11
      L=LB+3
        DO 133 M=1,8
        A(L)=FF(M)
        L=L+1
 133    CONTINUE
      A(L)=FF(9)+FF(10)
      A(LB)=FF(10)
      A(LB+15)=AINT(.5+FF(1)+FF(3)+FF(5)+FF(7)+FF(9))
      GOTO 11
C
C DISP
C
 134  IF(NK.NE.39)GOTO 139
      IF(NA.GT.3)GOTO 77
      IF(NA.EQ.0)GOTO 77
      IF(LX.NE.0)GOTO 135
      IF(LB.GT.LL)GOTO 136
 135  CALL SXER('DISP MUST COME BETWEEN SFAC AND UNIT')
 136  IF(MQ.LT.3)CALL SXER('DISP REQUIRES ATOM TYPES')
      CALL SXUS(FC(1),KT)
      IF(KT.NE.'0   ')GOTO 93
        DO 138 I=2,MQ,2
        CALL SXUS(FC(I+1),KT)
        IF(KT.NE.'    ')GOTO 93
        CALL SXUS(FC(I),KT)
        KS=KT(1:4)
        IF(KT(1:1).EQ.IH(50))KS=KT(2:4)//IH(20)
          DO 137 K=LL+4,LB,16
          CALL SXUS(A(K+13),KT)
          IF(KT.NE.KS)GOTO 137
          A(K)=FF(1)
          IF(NA.GT.1)A(K+1)=FF(2)
          IF(NA.GT.3)A(K+14)=FF(3)
          GOTO 138
 137      CONTINUE
        CALL SXER('UNKNOWN ELEMENT '//KS//' FOR DISP')
 138    CONTINUE
      GOTO 11
C
C UNIT
C
 139  IF(NK.NE.18)GOTO 141
      MZ=(LB+16-LL)/16
      IF(MZ.EQ.0)CALL SXER('SFAC MISSING')
      IF(NA.NE.MZ)GOTO 77
      IF(LX.NE.0)GOTO 79
      LX=LB-16
      A(24)=.25*REAL(LL-LY-8)
c      IF(A(51).GT.2.5)WRITE(LI,4)
      M=LL-12
        DO 140 I=1,NA
        M=M+16
        CALL SXUS(A(M+13),KS)
c        IF(A(51).GT.2.5)WRITE(LI,5)KS,(A(K),K=M+3,M+10),
c     +  A(M+11)-A(M),A(M),A(M+1),A(M+14),A(M+12),A(M+2)
        A(21)=A(21)+FF(I)*ABS(A(M+12))
        A(M+12)=0.
        A(22)=A(22)+FF(I)*A(M+15)
        A(25)=A(25)+FF(I)*A(M+14)
        A(M+14)=FF(I)
        A(M+15)=0.
 140    CONTINUE
      A(45)=A(21)*1.66054/A(20)
      A(25)=.1*A(25)/A(20)
c      IF(A(51).GT.0.5)WRITE(LI,3)A(20),A(22),A(25),A(21),A(45)
      GOTO 11
C
C Atoms in FRAG ... FEND section
C
 141  IF(LX.EQ.0)CALL SXER('UNIT MISSING')
      IF(NK.GT.1)GOTO 180
      IF(JB.EQ.0)GOTO 142
      JA=JA+3
      B(JA-3)=FF(2)*A(76)+FF(3)*A(77)+FF(4)*A(78)
      B(JA-2)=FF(3)*A(79)+FF(4)*A(80)
      B(JA-1)=FF(4)*A(81)
      B(JA)=0.
      B(JB)=100000.1+REAL(JA-JB)
      GOTO 11
C
C Atoms
C
 142  IF(LR.NE.LK)GOTO 97
      IF(FF(1).LT.0.9999)GOTO 85
c****
c this is order of atum in sfac list
      nell=ff(1)
      IF(AMOD(FF(1)+.0001,1.).GT.0.0002)GOTO 85
      K=INT(ABS(FF(1))+0.01)*16+LL-12
      IF(K.GT.LB)GOTO 85
      IF(NA.LT.4)GOTO 85
      IF(NA.LT.7)GOTO 143
      IF(NA.EQ.11)GOTO 143
      IF(NA.GT.7)GOTO 85
      FF(NA)=0.
      NA=6
 143  IF(LT.NE.0)GOTO 92
      LX=LX+32
      CALL SXPS(A(LX),KS)
      CALL SXUS(A(44),KT)
      CALL SXPS(A(LX+1),KT)
      CALL SXUS(A(43),KT)
      CALL SXPS(A(LX+2),KT)
      A(LX+27)=A(125)
      A(LX+29)=1.000001*A(42)
      A(LX+30)=0.
      A(LX+31)=.01*A(40)+.001
      A(LX+3)=REAL(K)+.1
      IF(NA.EQ.11)A(LX+3)=-A(LX+3)
      A(LX+4)=0.
      A(LX+5)=A(126)+AMIN1(.99,.01*A(K+2))
      A(LX+6)=A(121)
      A(LX+28)=REAL(KG)+.1
      IF(KG.EQ.1)A(122)=AMOD(A(122),10.)
      IF(KG.GT.0)KG=KG-1
      L=LX+7
      IF(ABS(A(60))+ABS(A(61))+ABS(A(62))+ABS(A(63)-1.).LT.0.0001)
     +GOTO 145
        DO 144 I=2,4
        IF(ABS(FF(I)).GT.15.)GOTO 88
        X=AMOD(FF(I)+5.,10.)-5.
        FF(I)=FF(I)+A(I+58)+X*(A(63)-1.)
 144    CONTINUE
 145  IF(NA.GT.5)GOTO 147
      FF(6)=DT
      IF(NA.GT.4)GOTO 146
      FF(5)=11.
 146  NA=6
 147  IF(A(123).LT.99998.)FF(5)=A(123)
      IF(NA.GT.6)GOTO 148
      IF(A(124).LT.99998.)FF(6)=A(124)
 148  IF(A(130).LT.8.E9)FF(5)=A(130)
c****
      natoms=natoms+1
      atnum(natoms)=nsfac(nell)
      label(natoms)=ks
      do jjj=1,3
       xyz(natoms,jjj)=ff(jjj+1)
       if(xyz(natoms,jjj).gt.5.) xyz(natoms,jjj)=xyz(natoms,jjj)-10.
      enddo
      sof(natoms)=ff(5)
      if (sof(natoms).gt.3.) sof(natoms)=sof(natoms)-10.
      do jjj=1,3
       uij(natoms,jjj)=ff(jjj+5)
       if(uij(natoms,jjj).gt.3.) uij(natoms,jjj)=uij(natoms,jjj)-10.
      enddo
      do jjj=4,6
       uij(natoms,jjj)=ff(15-jjj)
       if(uij(natoms,jjj).gt.3.) uij(natoms,jjj)=uij(natoms,jjj)-10.
      enddo
        DO 149 I=2,11
        A(L)=FF(I)
        A(L+10)=0.
        L=L+1
 149    CONTINUE
      IF(JC.EQ.0)GOTO 150
      A(LX+17)=B(JC)
      A(LX+18)=B(JC+1)
      A(LX+19)=B(JC+2)
      JC=JC+3
      IF(JC.GE.JD)JC=0
      IF(JC.EQ.0)A(122)=AMOD(A(122),10.)
 150  A(121)=A(122)
C
C Compare stored ANIS, CONN, OMIT and HFIX instructions
C
      CALL SXUS(A(43),KY)
      CALL SXUS(A(44),KZ)
      MX=LX
      JZ=1
      IF(NA.EQ.11)GOTO 152
      IF(IA.EQ.0)GOTO 152
      IF(K.EQ.KH)GOTO 152
      IA=IA-1
      A(LX+6)=-ABS(A(LX+6))
      GOTO 152
 151  JZ=JZ+JE
 152  NK=INT(.0001*B(JZ))
      JE=INT(AMOD(B(JZ),10000.))
      IF(NK.EQ.0)GOTO 11
      IF(NK.LT.62)GOTO 151
      IF(NK.GT.65)GOTO 151
      J=JZ+1
      IF(NK.EQ.63)J=JZ+3
      IF(NK.EQ.64)J=JZ+4
      CALL SXUS(B(J),KL)
 153  J=J+2
      IF(J.GE.JZ+JE)GOTO 151
C
C Interpret _code
C
      CALL SXUS(B(J-1),KT)
      IF(KT(1:1).EQ.IH(24))GOTO 154
      IF(KT(1:1).NE.IH(50))GOTO 157
      CALL SXUS(A(K+13),KU)
      IF(KU(1:3).NE.KT(2:4))GOTO 153
      GOTO 158
 154  IF(K.EQ.KH)GOTO 153
      CALL SXUS(B(J-3),KV)
      CALL SXUS(B(J-2),KX)
      IF(KX.EQ.KC(1))KX=KL
      J=J+2
      IF(J.GE.JZ+JE)GOTO 151
      CALL SXUS(B(J-1),KT)
      CALL SXUS(B(J),KU)
      IF(KU.EQ.KC(1))KU=KL
      L=MX
 155  L=L-32
      IF(L.LT.LB+16)GOTO 153
      CALL SXUS(A(L),KW)
      IF(KW.NE.KT)GOTO 156
      CALL SXUS(A(L+1),KQ)
      IF(KQ.EQ.KU)GOTO 153
      CALL SXUS(A(L+2),KQ)
      IF(KQ.EQ.KU)GOTO 153
 156  IF(KW.NE.KV)GOTO 155
      CALL SXUS(A(L+1),KW)
      IF(KW.EQ.KX)GOTO 159
      CALL SXUS(A(L+2),KW)
      IF(KW.NE.KX)GOTO 155
      GOTO 159
 157  IF(KT.NE.KS)GOTO 153
 158  CALL SXUS(B(J),KW)
      IF(KW.EQ.KC(1))KW=KL
      IF(KW(1:1).EQ.IH(21))GOTO 159
      IF(KW.EQ.KZ)GOTO 159
      IF(KW.NE.KY)GOTO 153
C
C Apply ANIS, OMIT, CONN and HFIX
C
 159  IF(NK.GT.62)GOTO 160
      A(MX+6)=-ABS(A(MX+6))
      GOTO 153
 160  IF(NK.NE.65)GOTO 161
      A(MX+31)=-ABS(A(MX+31))
      GOTO 153
 161  IF(NK.EQ.64)GOTO 162
      A(LX+5)=B(JZ+1)+AMOD(A(LX+5),1.)
      IF(B(JZ+2).GE.-8.E9)A(LX+5)=B(JZ+1)+
     +AMIN1(.99,AMAX1(-.99,.01*B(JZ+2)))
      GOTO 153
 162  IF(A(MX+30).GT.0.5)GOTO 153
      A(MX+30)=1.
      N=INT(.1*ABS(B(JZ+1)))
      IF(N.EQ.0)GOTO 153
      V=ABS(B(JZ+1))+.1*B(JZ+3)
      Z=SIGN(5.,A(MX+10))
      R=A(MX+10)
      IF(N.NE.12)GOTO 163
      R=R-0.5*(AMOD(R+Z,10.)-Z)
      N=6
      GOTO 164
 163  IF(N.EQ.13)N=3
      IF(N.EQ.9)N=2
      IF(N.GT.3)N=1
 164  N=N*32+MX
C
C Create dummy AFIX
C
      IR=KC(23)
      Z=B(JZ+1)
      NI=INT(Z)
      M=8
 165  I=MOD(IABS(NI),10)
      IR(M:M)=IH(I+1)
      M=M-1
      NI=NI/10
      IF(NI.GT.0)GOTO 165
      Y=B(JZ+3)
      IF(ABS(Y).LT.1.E-4)GOTO 168
      IR(12:12)=IH(11)
      X=AMOD(ABS(Y),1.)
        DO 166 NI=13,16
        X=10.*AMOD(X,1.)
        L=INT(X)
        IR(NI:NI)=IH(L+1)
 166    CONTINUE
      L=11
      NI=INT(ABS(Y))
 167  I=MOD(NI,10)
      IR(L:L)=IH(I+1)
      L=L-1
      NI=NI/10
      IF(NI.GT.0)GOTO 167
      IF(Y.LT.0.)IR(L:L)=IH(12)
 168  KR=16
      NI=23
      WRITE(LC)NI,KR,KC(23),IR
C
C Insert extra hydrogens for HFIX
C
      KR=1
        DO 169 I=1,76
        IR(I:I)=IH(20)
 169    CONTINUE
      CALL SXUS(A(LX),KT)
      KT(1:1)=IH(34)
        DO 170 NI=1,4
        IF(KT(NI:NI).EQ.IH(20))GOTO 171
 170    CONTINUE
      NI=4
 171  IF(NI.NE.2)GOTO 172
      KT(2:2)=IH(1)
      NI=3
 172  L=26
      KK=KT(NI-1:NI-1)
        DO 173 I=1,10
        IF(KK.EQ.IH(I))GOTO 174
 173    CONTINUE
      L=1
 174  IF(N.EQ.MX+32)GOTO 176
 175  L=L+1
      IF(L.EQ.11)L=14
      IF(L.EQ.17)L=27
      KT(NI:NI)=IH(L)
 176  M=LB-16
 177  M=M+32
      IF(M.GE.LX)GOTO 178
      CALL SXUS(A(M),KX)
      IF(KX.NE.KT)GOTO 177
      CALL SXUS(A(M+1),KX)
      IF(KX.NE.KZ)GOTO 177
      IF(L.LT.50)GOTO 175
 178  LX=LX+32
      CALL SXPS(A(LX),KT)
      M=1
      WRITE(LC)M,KR,KT,IR
      CALL SXPS(A(LX+1),KZ)
      CALL SXPS(A(LX+2),KY)
      A(LX+3)=REAL(KH)+.1
        DO 179 I=LX+4,LX+30
        A(I)=0.
 179    CONTINUE
      A(LX+6)=V
      A(LX+10)=R
      A(LX+11)=B(JZ+2)
      A(LX+27)=A(125)
      A(LX+28)=REAL((N+32-LX)/32)+.1
      A(LX+29)=1.000001*A(42)
      A(LX+31)=A(LX-1)
      IF(LX.LT.N)GOTO 175
      IR=KC(23)
      IR(7:7)=IH(1)
      N=23
      KR=7
      WRITE(LC)N,KR,KC(23),IR
      GOTO 153
C
C Other instructions - ACTA
C
 180  IF(NK.NE.35)GOTO 181
      A(74)=1.1
      IF(NA.EQ.1)A(74)=ABS(FF(1))
      GOTO 11
C
C AFIX
C
 181  IF(NK.NE.23)GOTO 186
      IF(LR.NE.LK)GOTO 97
      IF(NA.GT.4)GOTO 77
      A(123)=99999.
      IF(NA.GE.3)A(123)=FF(3)
      A(124)=99999.
      IF(NA.EQ.4)A(124)=FF(4)
      FF(1)=ABS(FF(1))
      K=INT(.1*FF(1))
      IF(KG.LE.0)GOTO 182
      IF(KI.NE.0)GOTO 86
      IF(IABS(K-6).LT.2)GOTO 86
      IF(K.EQ.10)GOTO 86
      IF(K.EQ.11)GOTO 86
      IF(K.GT.16)GOTO 86
      KI=KG
 182  KG=K
      IF(K.EQ.4)KG=1
      IF(K.EQ.7)KG=6
      IF(K.EQ.8)KG=1
      IF(K.EQ.9)KG=2
      IF(K.EQ.11)KG=10
      IF(K.EQ.12)KG=6
      IF(K.GT.12)KG=3-2*(K/14)
      IF(KI.EQ.0)GOTO 184
      IF(IABS(K-6).LT.2)GOTO 183
      IF(K.GT.16)GOTO 183
      IF(K.EQ.10)GOTO 183
      IF(K.NE.11)GOTO 184
 183  KG=KI
      KI=0
 184  JC=0
      IF(FF(2).LT.0.)GOTO 89
      IF(FF(2).GT.9.)GOTO 89
      IF(NA.LT.2)FF(2)=.01
      A(121)=AINT(FF(1)+.1)+.1*FF(2)
      A(122)=A(121)
      I=INT(AMOD(FF(1)+.1,10.))
      IF(I.EQ.9)A(122)=A(122)-4.
      IF(I.EQ.6)A(122)=A(122)-1.
      NA=4
C
C FRAG/AFIX fit coordinates
C
      IF(K.LT.17)GOTO 11
      JD=1
 185  JC=JD
      JD=INT(AMOD(B(JC),10000.))+JC
      IF(JD.EQ.JC)GOTO 87
      IF(INT(.0001*B(JC)).NE.10)GOTO 185
      IF(K.NE.INT(B(JC+1)))GOTO 185
      JC=JC+3
      KG=(JD-JC)/3
      GOTO 11
C
C ANIS
C
 186  IF(NK.NE.62)GOTO 191
      IF(LR.NE.LK)GOTO 97
      IF(NA.GT.1)GOTO 77
      IF(NA.GT.0)GOTO 187
      FF(1)=32000.
      IF(MQ.GT.2)GOTO 188
 187  IA=INT(ABS(FF(1))+.1)
      IF(MQ.LT.2)GOTO 11
      NA=0
C
C Buffer instructions in B
C
 188  B(JA)=10000.*REAL(NK)+REAL(MQ+NA)+1.1
      JA=JA+1
        DO 189 I=1,NA
        B(JA)=FF(I)
        JA=JA+1
 189    CONTINUE
        DO 190 I=1,MQ
        CALL SXUS(FC(I),KT)
        CALL SXPS(B(JA),KT)
        JA=JA+1
 190    CONTINUE
      B(JA)=0.
      GOTO 11
C
C BASF
C
 191  IF(NK.NE.6)GOTO 194
      IF(LR.NE.LK)GOTO 97
        DO 192 I=1,NA
        IF(FF(I).LE.0.)GOTO 89
 192    CONTINUE
 193  MQ=0
      A(127)=1.
      GOTO 188
C
C BIND and FREE
C
 194  IF(NK.EQ.48)GOTO 195
      IF(NK.NE.49)GOTO 197
 195  IF(MOD(MQ,4).NE.1)GOTO 78
      IF(MQ.EQ.1)GOTO 78
 196  IF(NA.GT.0)GOTO 77
      GOTO 188
C
C BLOC
C
 197  IF(NK.NE.57)GOTO 198
      IF(NA.GT.2)GOTO 77
      A(103)=AMAX1(A(103),ABS(FF(1)),ABS(FF(2)))
      NA=2
      GOTO 188
C
C BOND
C
 198  IF(NK.NE.47)GOTO 200
      NA=0
      IF(MQ.GT.1)GOTO 199
      IF(ABS(A(158)).LT.0.1)A(158)=1.1
      GOTO 11
 199  CALL SXUS(FC(2),KT)
      IF(KT.NE.KC(76))GOTO 188
      A(158)=-1.1
      GOTO 11
C
C BUMP
C
 200  IF(NK.NE.66)GOTO 204
      IF(NA.GT.16)GOTO 77
      A(180)=0.1
      L=181
        DO 201 I=LL+4,LB,16
        CALL SXUS(A(I+13),KT)
        A(L)=3.5
        IF(KT.EQ.'C   ')A(L)=3.2
        IF(KT.EQ.'N   ')A(L)=2.7
        IF(KT.EQ.'O   ')A(L)=2.6
        L=L+1
        IF(L.GT.196)GOTO 202
 201    CONTINUE
 202    DO 203 I=1,NA
        A(I+179)=FF(I)
 203    CONTINUE
      IF(A(180).LT.0.0001)A(180)=.0001
      GOTO 11
C
C CHIV
C
 204  IF(NK.NE.56)GOTO 206
      IF(NA.GT.2)GOTO 77
      IF(NA.LT.2)FF(2)=A(133)
      IF(NA.LT.1)FF(1)=0.
      CALL SXUS(FC(1),KS)
        DO 205 I=3,MQ
        B(JA)=560006.1
        B(JA+1)=FF(1)
        B(JA+2)=FF(2)
        CALL SXUS(FC(I),KT)
        IF(KT.EQ.KC(1))KT=KS
        CALL SXPS(B(JA+3),KT)
        CALL SXUS(FC(I-1),KT)
        CALL SXPS(B(JA+4),KT)
        CALL SXPS(B(JA+5),KC(1))
        JA=JA+6
 205    CONTINUE
      B(JA)=0.
      GOTO 11
C
C CONF
C
 206  IF(NK.NE.52)GOTO 208
      IF(MQ.GT.1)GOTO 207
      A(128)=2.
      GOTO 11
 207  IF(MQ.LT.9)GOTO 78
      GOTO 196
C
C CONN
C
 208  IF(NK.NE.63)GOTO 209
      IF(NA.LT.1)GOTO 77
      IF(NA.GT.2)GOTO 77
      FF(1)=AINT(ABS(FF(1)))
      IF(NA.LT.2)FF(2)=-9.E9
      NA=2
      IF(MQ.GT.1)GOTO 188
      IF(FF(2).GT.-8.E9)GOTO 77
      A(126)=FF(1)
      GOTO 11
C
C DAMP
C
 209  IF(NK.NE.36)GOTO 210
      IF(NA.GT.0)A(72)=FF(1)
      IF(NA.GT.1)A(170)=FF(2)
      IF(NA.GT.2)GOTO 77
      IF(A(72).LT.0.)GOTO 89
      IF(A(170).LT.0.)GOTO 89
      GOTO 11
C
C DEFS
C
 210  IF(NK.NE.68)GOTO 212
      IF(NA.GT.5)GOTO 77
      A(132)=.01
      A(133)=.2
      A(134)=.002
      A(135)=.02
      IF(NA.GT.4)A(196)=FF(5)
      IF(NA.GT.4)NA=4
        DO 211 I=1,NA
        IF(FF(I).LE.0.)GOTO 89
        A(I+131)=FF(I)
 211    CONTINUE
      GOTO 11
C
C DELU
C
 212  IF(NK.NE.58)GOTO 213
      IF(NA.GT.2)GOTO 77
      IF(NA.LT.1)FF(1)=A(134)
      IF(NA.LT.2)FF(2)=FF(1)
      NA=2
      GOTO 188
C
C DFIX
C
 213  IF(NK.NE.50)GOTO 215
      IF(NA.LT.1)GOTO 77
      IF(NA.GT.2)GOTO 77
      IF(NA.EQ.2)GOTO 214
      FF(2)=A(132)
      IF(FF(1).LT.0.)FF(2)=.1
 214  IF(MOD(MQ,4).NE.1)GOTO 78
      IF(MQ.EQ.1)GOTO 78
      IF(ABS(FF(1)).LT.0.0001)GOTO 89
      NK=50
      NA=2
      GOTO 188
C
C EADP
C
 215  IF(NK.NE.46)GOTO 218
      GOTO 196
C
C EQIV
C
 216    DO 217 I=1,12
        FF(I)=A(I+81)
 217    CONTINUE
      NA=12
      IF(MQ.NE.3)GOTO 95
      CALL SXUS(FC(2),KZ)
      IF(KZ(1:1).NE.IH(50))GOTO 95
      GOTO 188
C
C EXTI and SWAT
C
 218  IF(NK.NE.4)GOTO 220
      IF(A(200).GT.-998.)A(39)=-9.E9
      IF(NA.LT.2)FF(2)=2.
      A(200)=FF(2)
      IF(A(39).LT.-8.E9)GOTO 221
 219  CALL SXER('EXTI and SWAT may not be used together')
 220  IF(NK.NE.7)GOTO 222
      IF(A(200).GT.-998.)GOTO 219
 221  IF(LR.NE.LK)GOTO 97
      IF(FF(1).LT.0.)FF(1)=0.
      A(39)=FF(1)
      GOTO 11
C
C EXYZ
C
 222  IF(NK.EQ.45)GOTO 196
C
C FEND
C
      IF(NK.NE.11)GOTO 223
      JB=0
      GOTO 11
C
C FLAT
C
 223  IF(NK.NE.55)GOTO 224
      IF(MQ.LT.7)GOTO 78
      IF(NA.EQ.0)FF(1)=A(133)
      IF(NA.GT.1)GOTO 77
      NA=1
      GOTO 188
C
C FMAP
C
 224  IF(NK.NE.21)GOTO 225
      IF(NA.EQ.0)FF(1)=2.
      IF(ABS(FF(1)).LT.1.9)GOTO 89
      IF(ABS(FF(1)).GT.4.1)GOTO 89
      NJ=54
      K=3
      GOTO 106
C
C FRAG
C
 225  IF(NK.NE.10)GOTO 228
      JB=JA
      IF(NA.EQ.7)GOTO 226
      FF(5)=90.
      FF(6)=90.
      FF(7)=90.
      IF(NA.EQ.4)GOTO 226
      FF(2)=1.
      FF(3)=1.
      FF(4)=1.
      IF(NA.EQ.1)GOTO 226
      IF(NA.NE.0)GOTO 77
      FF(1)=17.
 226    DO 227 I=2,4
        IF(FF(I).LT.0.1)GOTO 89
        X=1.74533E-2*FF(I+3)
        FC(I)=COS(X)
        FC(I+3)=SIN(X)
 227    CONTINUE
      X=(FC(2)-FC(3)*FC(4))/(FC(6)*FC(7))
      A(76)=FF(2)
      A(77)=FF(3)*FC(4)
      A(78)=FF(4)*FC(3)
      A(79)=FF(3)*FC(7)
      A(80)=FF(4)*FC(6)*X
      A(81)=FF(4)*FC(6)*SQRT(ABS(1.-X**2))
      CALL SXZA(FF(2),6)
      NA=1
      GOTO 188
C
C FVAR
C
 228  IF(NK.NE.8)GOTO 229
      IF(LR.NE.LK)GOTO 97
      GOTO 193
C
C GRID
C
 229  IF(NK.NE.19)GOTO 230
      NJ=33
      K=6
      GOTO 106
C
C HFIX
C
 230  IF(NK.NE.64)GOTO 233
      IF(KH.EQ.0)CALL SXER('H SFAC REQUIRED FOR HFIX')
      IF(LR.NE.LK)GOTO 97
      IF(NA.LT.1)GOTO 77
      IF(NA.GT.3)GOTO 77
      FF(1)=ABS(FF(1))
      K=MOD(INT(FF(1)+.1),10)
      IF(K.EQ.6)GOTO 89
      IF(K.EQ.9)GOTO 89
      K=INT(.1*FF(1)+.1)
      IF(K.GT.16)GOTO 89
      IF(K.GT.11)GOTO 231
      IF(K.GT.9)GOTO 89
      IF(IABS(K-6).LT.2)GOTO 89
 231  IF(NA.GT.1)GOTO 232
      FF(2)=-1.2
      IF(K.EQ.3)FF(2)=-1.5
      IF(K.EQ.8)FF(2)=-1.5
      IF(K.GT.11)FF(2)=-1.5
      IF(K.GT.14)FF(2)=-1.2
 232  NA=3
      IF(MQ.LT.3)GOTO 78
      GOTO 188
C
C ISOR
C
 233  IF(NK.NE.60)GOTO 234
      IF(NA.EQ.0)FF(1)=0.1
      IF(NA.LT.2)FF(2)=2.*FF(1)
      IF(NA.GT.2)GOTO 77
      NA=2
      GOTO 188
C
C L.S. and CGLS
C
 234  A(159)=1.
      IF(NK.EQ.33)GOTO 235
      IF(NK.NE.34)GOTO 236
      IF(FF(1).LT.0.)A(159)=-1.
 235  NJ=177
      K=3
      FF(1)=ABS(FF(1))+0.1
      IF(NK.EQ.34)FF(1)=-FF(1)*A(159)
      IF(NA.GT.4)GOTO 77
      IF(NA.EQ.4)IV=MAX0(INT(FF(4)),8)
      NA=3
      GOTO 106
C
C LAUE
C
 236  IF(NK.NE.65)GOTO 242
      IF(LX.LT.LB)GOTO 92
      A(46)=1.1
      IF(MQ.LT.3)GOTO 91
      CALL SXUS(FC(2),KS)
      KT=KS
      IF(KS(1:1).EQ.IH(50))KT=KS(2:4)//IH(20)
      READ(LR,1,END=240)IR
      I=LL-12
 237  I=I+16
      IF(I.GT.LB)CALL SXER('NO SFAC FOR LAUE ELEMENT')
      CALL SXUS(A(I+13),KS)
      IF(KS.NE.KT)GOTO 237
      IF(A(I+12).GT.0.5)CALL SXER('TWO LAUE INSTRUCTIONS FOR '//KS)
      IF(LT.EQ.0)LT=LX+31
      LT=LT+1
      M=LT
      A(I+12)=REAL(LT)
 238  IF(LT+5.GT.LM)GOTO 76
      IR=' '
      READ(LR,1,END=240)IR
        DO 239 I=1,23
        IF(IR(I:I).EQ.CHAR(13))IR(I:I)=IH(20)
 239    CONTINUE
      READ(IR,6,ERR=240,END=240)A(LT+1),A(LT+2),A(LT+3)
      IF(A(LT+1).LT.1.E-6)GOTO 241
      LT=LT+3
      IF(LT.LT.M+4)GOTO 238
      IF(A(LT-2).LT.A(LT-5)+1.E-6)CALL SXER('WAVELENGTHS NOT IN '//
     +'ASCENDING ORDER FOR LAUE '//KS)
      GOTO 238
 240  CALL SXER('ERROR OR END OF FILE READING DISPERSION FACTORS'//
     +' (LAUE)')
 241  IF(LT.EQ.M)GOTO 77
      A(M)=REAL(LT-2)
      GOTO 11
C
C LIST
C
 242  IF(NK.NE.37)GOTO 243
      IF(NA.GT.2)GOTO 77
      IF(NA.EQ.0)FF(1)=4.
      A(73)=FF(1)
      IF(NA.EQ.2)A(155)=FF(2)
      GOTO 11
C
C MERG
C
 243  IF(NK.NE.27)GOTO 246
      IF(ABS(FF(1)).GT.4.1)GOTO 89
      IF(NA.EQ.0)FF(1)=2.1
      IF(NA.GT.1)GOTO 77
      IF(ABS(FF(1)).LT.3.5)GOTO 245
        DO 244 I=LL+4,LB,16
        A(I+1)=0.
 244    CONTINUE
      FF(1)=SIGN(3.1,FF(1))
 245  A(46)=ABS(FF(1))
      IF(ABS(FF(1)).LT.1.1)GOTO 11
      IF(LT.NE.0)CALL SXER('MERG NOT COMPATIBLE WITH LAUE')
      GOTO 11
C
C MOLE
C
 246  IF(NK.NE.20)GOTO 247
      IF(LR.NE.LK)GOTO 97
      A(40)=AINT(ABS(FF(1)))
      IF(A(40).GT.99.1)GOTO 89
      GOTO 11
C
C MORE
C
 247  IF(NK.NE.31)GOTO 248
      A(51)=FF(1)
      GOTO 11
C
C MOVE
C
 248  IF(NK.NE.3)GOTO 249
      IF(LR.NE.LK)GOTO 97
      IF(NA.LT.4)FF(4)=1.
      IF(ABS(ABS(FF(4))-1.).GT.0.0001)GOTO 89
      NJ=60
      K=4
      NA=4
      GOTO 106
C
C MPLA
C
 249  IF(NK.NE.54)GOTO 250
      IF(NA.GT.1)GOTO 77
      IF(ABS(ABS(FF(1))-1.5).LT.1.4)GOTO 89
      IF(MQ/2.GT.(LU-1)/3)GOTO 78
      NA=1
      GOTO 188
C
C OMIT
C
 250  IF(NK.NE.26)GOTO 252
      IF(NA.EQ.3)GOTO 193
      IF(NA.NE.0)GOTO 251
      NK=65
      IF(MQ.GT.1)GOTO 188
      GOTO 77
 251  IF(MQ.GT.1)GOTO 77
      A(52)=.5*FF(1)
      IF(NA.LT.2)GOTO 11
      IF(FF(2).LT.0.0001)GOTO 89
      IF(FF(2).GT.180.)GOTO 89
      A(53)=SIGN(SIN(8.726646E-3*FF(2))**2,FF(2))
      IF(NA.LT.3)GOTO 11
      GOTO 77
C
C PART
C
 252  IF(NK.NE.38)GOTO 253
      IF(LR.NE.LK)GOTO 97
      A(130)=9.E9
      IF(NA.EQ.2)A(130)=FF(2)
      A(42)=FF(1)
      IF(NA.LT.3)GOTO 11
      GOTO 77
C
C PLAN
C
 253  IF(NK.NE.22)GOTO 254
      NJ=57
      K=3
      I=NA
      NA=3
      IF(ABS(FF(1)).GT.999.5)GOTO 89
      IF(I.EQ.0)FF(1)=20.
      IF(I.LT.2)FF(2)=-1.
      IF(I.LT.3)FF(3)=3.
      IF(FF(1).GT.-0.5)GOTO 106
      IF(I.LT.2)FF(2)=.5
      IF(I.LT.3)FF(3)=2.
      GOTO 106
C
C RESI
C
 254  IF(NK.NE.29)GOTO 257
      IF(LR.NE.LK)GOTO 97
      IF(MQ.GT.3)GOTO 78
      KT=KC(1)
      IF(MQ.EQ.3)CALL SXUS(FC(2),KT)
      CALL SXPS(A(43),KT)
      IF(NA.EQ.0)GOTO 77
      IF(NA.GT.2)GOTO 77
      IF(FF(1).GT.9999.1)GOTO 89
      IF(FF(1).LT.-0.1)GOTO 89
      IF(FF(2).GT.9999.1)GOTO 89
      IF(FF(2).LT.-0.1)GOTO 89
      K=INT(FF(1))
      I=INT(FF(2))
      IF(I.EQ.0)GOTO 255
      N=ML(1)+1
      IF(N.GT.LU)CALL SXER('TOO MANY RESIDUE ALIASES')
      ML(1)=N
      MK(N)=I
      ML(N)=K
 255  CALL SXPN(A(44),K)
      CALL SXUS(A(44),KZ)
      N=LX+32
 256  N=N-32
      IF(N.LT.LB)GOTO 11
      CALL SXUS(A(N+1),KS)
      IF(KS.NE.KZ)GOTO 256
      CALL SXUS(A(N+2),KS)
      IF(KS.EQ.KT)GOTO 11
      CALL SXER('RESIDUE '//KZ//' ALREADY DEFINED AS CLASS '//KS)
C
C RTAB
C
 257  IF(NK.NE.53)GOTO 258
      IF(MQ.LT.5)GOTO 78
      IF(MQ.GT.11)GOTO 78
      IF(NA.NE.0)GOTO 77
      GOTO 188
C
C SADI
C
 258  IF(NK.NE.61)GOTO 259
      IF(NA.EQ.0)FF(1)=A(132)
      IF(NA.GT.1)GOTO 77
      IF(MOD(MQ,4).NE.1)GOTO 78
      IF(MQ.EQ.1)GOTO 78
      NA=1
      GOTO 188
C
C SAME
C
 259  IF(NK.NE.51)GOTO 260
      IF(NA.GT.2)GOTO 77
      IF(NA.LT.1)FF(1)=A(132)
      IF(NA.LT.2)FF(2)=FF(1)
      FF(3)=REAL(LX)+32.1
      NA=3
      IF(MQ.LT.5)GOTO 78
      GOTO 188
C
C SHEL
C
 260  IF(NK.NE.30)GOTO 262
      IF(NA.NE.2)GOTO 77
        DO 261 I=1,NA
        A(I+48)=AMIN1(1.,(.5*A(1)/AMAX1(FF(I),0.0001))**2)
 261    CONTINUE
      GOTO 11
C
C SIMU
C
 262  IF(NK.NE.59)GOTO 263
      IF(NA.GT.3)GOTO 77
      IF(NA.LT.1)FF(1)=A(135)
      IF(NA.LT.2)FF(2)=2.*FF(1)
      IF(NA.LT.3)FF(3)=1.7
      NA=3
      GOTO 188
C
C SIZE
C
 263  IF(NK.NE.43)GOTO 264
      K=3
      NJ=100
      IF(NA.NE.3)GOTO 77
      GOTO 106
C
C SLIM
C
 264  IF(NK.NE.41)GOTO 265
      IF(NA.LT.1)FF(1)=.8
      IF(NA.LT.2)FF(2)=.2
      A(197)=.5*(FF(1)+FF(2))
      A(198)=.5*(FF(1)-FF(2))
      GOTO 11
C
C SPEC
C
 265  IF(NK.NE.25)GOTO 266
      A(125)=FF(1)
      IF(NA.EQ.0)A(125)=.2
      GOTO 11
C
C SUMP
C
 266  IF(NK.NE.28)GOTO 267
      IF(NA.LT.3)GOTO 77
      IF(MOD(NA,2).NE.0)GOTO 77
      GOTO 193
C
C TEMP
C
 267  IF(NK.NE.67)GOTO 268
      IF(LX.GT.LB)CALL SXER('TEMP MUST PRECEDE ALL ATOMS')
      IF(FF(1).LT.-273.9)GOTO 89
      A(104)=FF(1)
      IF(FF(1).LT.-40.)DT=.04
      IF(FF(1).LT.-80.)DT=.03
      GOTO 11
C
C TIME
C
 268  IF(NK.NE.32)GOTO 269
      TL=FF(1)
      GOTO 11
C
C TWIN
C
 269  IF(NK.NE.24)GOTO 272
      IF(ABS(A(160)).GT.0.1)GOTO 79
      A(160)=2.01
      IF(NA.NE.10)GOTO 270
      IF(INT(ABS(FF(10))).LT.2)GOTO 89
      A(160)=FF(10)
      NA=9
 270  IF(NA.NE.9)GOTO 271
      IF(ABS(1.-ABS(FF(1)*(FF(5)*FF(9)-FF(6)*FF(8))+FF(2)*(FF(6)*FF(7)-
     +FF(4)*FF(9))+FF(3)*(FF(4)*FF(8)-FF(5)*FF(7)))).GT.0.01)GOTO 89
      IF(ABS(A(161)+1.)+ABS(A(162))+ABS(A(163))+ABS(A(164))+
     +ABS(A(165)+1.)+ABS(A(166))+ABS(A(167))+ABS(A(168))+
     +ABS(A(169)+1.).LT.0.01)A(160)=2.2
      NJ=161
      K=9
      GOTO 106
 271  IF(NA.NE.0)GOTO 77
      A(160)=2.2
      A(161)=-1.
      A(165)=-1.
      A(169)=-1.
      GOTO 11
C
C WGHT
C
 272  IF(NK.NE.9)GOTO 275
      IF(LR.NE.LK)GOTO 97
      IF(NA.GT.6)GOTO 77
      IF(FF(1).LT.0.)GOTO 273
      IF(FF(1).GT.0.011)GOTO 274
      IF(NA.LT.3)GOTO 274
      IF(NA.GT.4)GOTO 274
c 273  WRITE(LI,7)
 273  continue
      WRITE(*,7)
 274  IF(NA.LT.6)FF(6)=.333333
      IF(NA.LT.1)FF(1)=.1
      IF(FF(1).LT.0.)GOTO 89
      A(70)=1.
      IF(FF(3).GT.0.)A(70)=0.
      A(71)=0.
      IF(FF(3).GT.0.)A(71)=1.
      IF(FF(3).LT.0.)A(71)=-1.
      NJ=64
      K=6
      NA=6
      GOTO 106
C
C WPDB
C
 275  IF(NK.NE.5)GOTO 276
      IF(NA.EQ.0)FF(1)=1.
      A(199)=FF(1)
      IF(NA.GT.1)GOTO 77
      GOTO 11
C
C HKLF (actual or implied)
C
 276  IF(NK.NE.40)GOTO 85
      IF(ABS(FF(1)).GT.6.1)GOTO 89
        DO 277 I=131,143
        A(I)=0.
 277    CONTINUE
      IF(NA.LT.3)GOTO 278
      IF(IABS(NA-12).GT.2)GOTO 77
 278  A(132)=1.
      A(133)=1.
      A(137)=1.
      A(141)=1.
      A(142)=1.
        DO 279 I=1,NA
        A(I+130)=FF(I)
 279    CONTINUE
      KS=KC(23)
      IF(KG.NE.0)GOTO 75
      KR=4
      IR='END '
      IF(LR.NE.LK)WRITE(LC)NK,KR,IR(1:4),IR
c****
      write(13,1000) it
 1000 format(a76)
      write(13,1001)
 1001 format('SPACE GROUP xxxx')
      write(13,1002) cell
 1002 format('CELL  ',3f8.3,3f8.2)
      write(13,1003) natoms
 1003 format(i4)
      do ll=1,natoms
       write(13,1004) ll,label(ll),atnum(ll),(xyz(ll,mm),mm=1,3),sof(ll)
 1004  format(i4,1x,a4,i4,2x,3f9.5,f9.3)
      enddo
      stop
      END
C
C -----------------------------------------------------------------
C ** For optimum efficiency the following SHELXL routines should **
C ** be compiled with the highest level of optimization and      **
C ** vectorization available.  For large structures they account **
C ** for about 99% of the total cpu time.  It may well prove     **
C ** counter-productive to try to optimize and/or vectorize the  **
C ** rest of the program (i.e. it will probably run more slowly  **
C ** and may even give the wrong answers) !  For large matrix    **
C ** blocks SXMM and SXPV are the most important. Computer Gurus **
C ** may enjoy hand-tuning these routines !                      **
C ---------------------------------------------------------
C
      SUBROUTINE SXZA(A,N)
      REAL A(N)
C
C Zero first N elements of array A.  Some computers may have a
C fast routine which could be used here.
C
      M=(N/4)*4
        DO 1 I=1,M,4
        A(I)=0.
        A(I+1)=0.
        A(I+2)=0.
        A(I+3)=0.
   1    CONTINUE
      IF(M+1.GT.N)GOTO 2
      A(M+1)=0.
      IF(M+2.GT.N)GOTO 2
      A(M+2)=0.
      IF(M+3.NE.N)GOTO 2
      A(N)=0.
   2  RETURN
      END
C
C -----------------------------------------------------------
