C**********  BLOCK DATA PROGRAM FOR /EFNCM0/  **********
C
C
      BLOCK DATA
C
C
      PARAMETER EFN_BPC = 32
      PARAMETER EFN_CLS = 2
      PARAMETER EFN_SYS = 8
      PARAMETER EFN_MAX = EFN_CLS * EFN_BPC
      LOGICAL*1 EFN_ALLOC(EFN_MAX)
      INTEGER EFN_REM(EFN_CLS)
      INTEGER EFN_MASK(EFN_BPC), EFN_SMSK
      COMMON /EFNCM0/ EFN_ALLOC, EFN_REM, EFN_MASK, EFN_SMSK
C
C
      PARAMETER EFN_REM1 = EFN_BPC - EFN_SYS - 1
      PARAMETER EFN_REM2 = EFN_BPC - 0
     0DATA EFN_ALLOC /.TRUE., EFN_REM1 * .FALSE., EFN_SYS * .TRUE.
     1              , EFN_REM2 * .FALSE./
      DATA EFN_REM /EFN_REM1, EFN_REM2/
     0DATA EFN_MASK /'00000001'X, '00000002'X, '00000004'X, '00000008'X
     1             , '00000010'X, '00000020'X, '00000040'X, '00000080'X
     2             , '00000100'X, '00000200'X, '00000400'X, '00000800'X
     3             , '00001000'X, '00002000'X, '00004000'X, '00008000'X
     4             , '00010000'X, '00020000'X, '00040000'X, '00080000'X
     5             , '00100000'X, '00200000'X, '00400000'X, '00800000'X
     6             , '01000000'X, '02000000'X, '04000000'X, '08000000'X
     7             , '10000000'X, '20000000'X, '40000000'X, '80000000'X/
      DATA EFN_SMSK /'FF000001'X/
C
C
      END

     0SUBROUTINE ALLOC_EFN(
     1                     CLUSTER
     2                    ,COUNT
     3                    ,EFN
     4                    ,MASK
     5                    ,RESULT
     Z                    )
C
C
      INTEGER CLUSTER
      INTEGER COUNT
C     INTEGER EFN(COUNT)
      INTEGER EFN(1)
      INTEGER MASK
      INTEGER RESULT
C
C
      PARAMETER EFN_BPC = 32
      PARAMETER EFN_CLS = 2
      PARAMETER EFN_SYS = 8
      PARAMETER EFN_MAX = EFN_CLS * EFN_BPC
      LOGICAL*1 EFN_ALLOC(EFN_MAX)
      INTEGER EFN_REM(EFN_CLS)
      INTEGER EFN_MASK(EFN_BPC), EFN_SMSK
      COMMON /EFNCM0/ EFN_ALLOC, EFN_REM, EFN_MASK, EFN_SMSK
C
C**********  LOCAL PARAMETERS  **********
C
     0PARAMETER
     1    SUCCESS     = 0,
     2    NO_EFNS     = 1,
     3    BAD_CLUSTER = 2
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER EFNS, CL
      LOGICAL BLDMASK, CLSPEC
      INTEGER ALLOC
      INTEGER I, J
C
C
C=======================================================================
C
  100 CONTINUE
C
C**********  ANALYZE THE INPUT PARAMETERS  **********
C
  200 EFNS = 1
      IF(%LOC(COUNT) .NE. 0) EFNS = COUNT
      BLDMASK = %LOC(MASK) .NE. 0
      CL = %LOC(CLUSTER)
      IF(CL .NE. 0) GO TO 220
      CLSPEC = BLDMASK
      GO TO 240
  220 CL = CLUSTER / EFN_BPC + 1
      CLSPEC = .TRUE.
      IF((CL .LE. 0) .OR. (CL .GT. EFN_CLS)) GO TO 9020
  240 CONTINUE
C
C**********  DETERMINE IF ALLOCATION IS POSSIBLE  **********
C
  300 IF(CL .EQ. 0) GO TO 320
      IF(EFN_REM(CL) .GE. EFNS) GO TO 390
      GO TO 9040
  320 IF(CLSPEC) GO TO 360
      ALLOC = 0
      DO 340 CL = 1, EFN_CLS
          ALLOC = ALLOC + EFN_REM(CL)
  340     CONTINUE
      IF(ALLOC .LT. EFNS) GO TO 9040
      CL = 1
      GO TO 390
  360 DO 380 CL = 1, EFN_CLS
          IF(EFN_REM(CL) .GE. EFNS) GO TO 390
  380     CONTINUE
      GO TO 9040
  390 CONTINUE
C
C**********  ALLOCATE THE EVENT FLAGS  **********
C
  400 ALLOC = EFNS
      I = (CL - 1) * EFN_BPC + 1
      DO 420 I = I, EFN_MAX
          IF(ALLOC .LE. 0) GO TO 440
          IF(EFN_ALLOC(I)) GO TO 420
          EFN_ALLOC(I) = .TRUE.
          EFN(ALLOC) = I - 1
          ALLOC = ALLOC - 1
          CL = (I - 1) / EFN_BPC + 1
          EFN_REM(CL) = EFN_REM(CL) - 1
  420     CONTINUE
  440 CONTINUE
C
C**********  BUILD THE EFN MASK  **********
C
  500 IF(.NOT. BLDMASK) GO TO 540
      MASK = 0
      IF(EFNS .LE. 0) GO TO 540
      DO 520 I = 1, EFNS
          J = MOD(EFN(I), EFN_BPC)
          MASK = MASK .OR. EFN_MASK(J + 1)
  520     CONTINUE
  540 CONTINUE
C
C**********  EXIT  **********
C
 9000 RESULT = SUCCESS
      RETURN
 9020 RESULT = BAD_CLUSTER
      RETURN
 9040 RESULT = NO_EFNS
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE DEALL_EFN(
     1                     CLUSTER
     2                    ,COUNT
     3                    ,EFN
     4                    ,MASK
     5                    ,RESULT
     Z                    )
C
C
      INTEGER CLUSTER
      INTEGER COUNT
C     INTEGER EFN(COUNT)
      INTEGER EFN(1)
      INTEGER MASK
      INTEGER RESULT
C
C
      PARAMETER EFN_BPC = 32
      PARAMETER EFN_CLS = 2
      PARAMETER EFN_SYS = 8
      PARAMETER EFN_MAX = EFN_CLS * EFN_BPC
      LOGICAL*1 EFN_ALLOC(EFN_MAX)
      INTEGER EFN_REM(EFN_CLS)
      INTEGER EFN_MASK(EFN_BPC), EFN_SMSK
      COMMON /EFNCM0/ EFN_ALLOC, EFN_REM, EFN_MASK, EFN_SMSK
C
C**********  LOCAL PARAMETERS  **********
C
     0PARAMETER
     1    SUCCESS     = 0,
     2    BAD_EFN     = 1,
     3    BAD_CLUSTER = 2,
     4    BAD_MASK    = 3
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER CL, DMASK(EFN_CLS)
      INTEGER EFNS, BIT
      INTEGER I, J
      EQUIVALENCE (J, BIT)
C
C
C=======================================================================
C
  100 RESULT = SUCCESS
C
C**********  INITIALIZE THE DEALLOCATION MASKS  **********
C
  200 DO 220 CL = 1, EFN_CLS
          DMASK(CL) = 0
  220     CONTINUE
      IF(%LOC(CLUSTER) .EQ. 0) GO TO 260
      CL = CLUSTER / EFN_BPC + 1
      IF((CL .GT. 0) .AND. (CL .LE. EFN_CLS)) GO TO 240
      RESULT = BAD_CLUSTER
      GO TO 260
  240 IF(%LOC(MASK) .EQ. 0) GO TO 260
      DMASK(CL) = MASK
      IF((EFN_SMSK .AND. DMASK(1)) .EQ. 0) GO TO 260
      RESULT = BAD_MASK
      DMASK(1) = DMASK(1) .AND. (.NOT. EFN_SMSK)
  260 CONTINUE
C
C**********  INCLUDE THE SPECIFIED EFN'S  **********
C
  300 IF(%LOC(EFN) .EQ. 0) GO TO 360
      EFNS = 1
      IF(%LOC(COUNT) .NE. 0) EFNS = COUNT
      IF(EFNS .LE. 0) GO TO 360
      DO 340 I = 1, EFNS
          CL = EFN(I) / EFN_BPC + 1
          IF((CL .GT. 0) .AND. (CL .LE. EFN_CLS)) GO TO 320
          RESULT = BAD_EFN
          GO TO 340
  320     BIT = MOD(EFN(I), EFN_BPC)
          DMASK(CL) = DMASK(CL) .OR. EFN_MASK(BIT + 1)
  340     CONTINUE
      IF((EFN_SMSK .AND. DMASK(1)) .EQ. 0) GO TO 360
      RESULT = BAD_EFN
      DMASK(1) = DMASK(1) .AND. (.NOT. EFN_SMSK)
  360 CONTINUE
C
C**********  DEALLOCATE THE GIVEN EFN'S  **********
C
  400 DO 440 CL = 1, EFN_CLS
          DO 420 I = 1, EFN_BPC
              IF(DMASK(CL) .EQ. 0) GO TO 440
              IF((DMASK(CL) .AND. EFN_MASK(I)) .EQ. 0) GO TO 420
              DMASK(CL) = DMASK(CL) .AND. (.NOT. EFN_MASK(I))
              J = (CL - 1) * EFN_BPC + I
              IF(.NOT. EFN_ALLOC(J)) GO TO 420
              EFN_REM(CL) = EFN_REM(CL) + 1
              EFN_ALLOC(J) = .FALSE.
  420         CONTINUE
  440     CONTINUE
      RETURN
C
C=======================================================================
C
C
      END
