	SUBROUTINE OPENMTIN(ID,NFSTART)
C						J.KRISTIAN 1980
C
C SPLIT OFF WORKING PARTS INTO OPENMTIN2, 4/21/83.
C
C OPENS AN INPUT TAPE IN A STANDARD WAY.
C INTERACTIVE: REQUIRES RESPONSE FROM THE USER.
C
C INPUT PARAMETER:
C    NFSTART = THE DESIRED STARTING FILE NUMBER.
C		MUST BE LARGER THAN ZER0; I.E., WILL SPACE THE TAPE
C		FORWARD AFTER OPENING THE DRIVE, BUT NOT BACKWARD.
C
C OUTPUT PARAMETER:
C    ID = THE NUMBER TO BE USED TO IDENTIFY THE TAPE DRIVE
C	    IN SUBSEQUENT CALLS TO MTPCKG SUBROUTINES.
C	IF TAPE IS NOT OPENED DUE TO ILLEGAL FILE NUMBER, RETURNS
C	  ID = -1.
C
	INTEGER*4 ID, NFSTART, NUMBER, IRET
	CHARACTER REPLY*1
C
	IF(NFSTART.LE.0) THEN
	  ID = -1
	  TYPE 7, NFSTART
7	  FORMAT(' OPENMTIN ASKED TO OPEN AN INPUT TAPE AT',
     *    ' ILLEGAL FILE NUMBER:',I5)
	  TYPE *,'IF YOU KNOW WHAT THE CORRECT NUMBER IS, TYPE IT IN,'
	  CALL NEWI4(' OTHERWISE TAPE OPEN WILL BE ABORTED. ',NUMBER)
	  IF(NUMBER.LE.0) RETURN
	  NFSTART = NUMBER
	  END IF
C
	CALL CAPSTRG(' DO YOU WANT THE SYSTEM TO RETRY BAD RECORDS? ',
     *  REPLY)
	RETRY = .TRUE.
	IF(REPLY.NE.'Y') RETRY = .FALSE.
C
6	CALL OPENMTIN3(RETRY,ID,NERROR)
	IF(NERROR.EQ.1) THEN
	  PAUSE
	  RETURN
	  END IF
	IF(NERROR.EQ.2) THEN
C	  TAPE IS OFF-LINE; FORCE USER TO PUT ON-LINE.
	  CALL MTCLOS(ID,IRET)
	  GO TO 6
	  END IF
C
	NFILE = 1 !DEFINES THE INITIAL LOCATION AS FILE 1
	IF(NFSTART.NE.1) THEN
	  TYPE *, 'POSITIONING INPUT TAPE.'
	  CALL SKIPFMT(ID,NFILE,NFSTART)
	  END IF
C
	RETURN
	END

	SUBROUTINE OPENMTIN2(ID,NERROR)
C
C
C ***********  NOTE: THIS ROUTINE SUPERSEDED 9/83 BY OPENMTIN3, *******
C ***********        WHICH SHOULD BE USED INSTEAD.               *****
C
C
C						J.KRISTIAN 4/83
C OPENS AN INPUT TAPE IN A STANDARD WAY.
C INTERACTIVE: REQUIRES RESPONSE FROM THE USER.
C NEARLY IDENTICAL WITH OPENMTIN, EXCEPT RETURNS AN ERROR CODE (NERROR),
C  AND DOES NOT ALLOW FOR THE POSSIBILITY OF MOVING TAPE TO THE
C  BEGINNING OF ANOTHER FILE AFTER OPENING IT.
C
C INPUT PARAMETERS:
C
C	NONE
C
C OUTPUT PARAMETERS:
C
C	ID = THE NUMBER TO BE USED TO IDENTIFY THE TAPE DRIVE
C	    IN SUBSEQUENT CALLS TO MTPCKG SUBROUTINES.
C
C	NERROR = ERROR CODE, WITH THE FOLLOWING POSSIBLE VALUES:
C
C	   0 :	DRIVE IS OPENED, TAPE IS POSITIONED AT WHEREVER IT 
C		MAY HAVE BEEN (NOT NECESSARILY AT ITS BEGINNING,
C		NOR EVEN AT THE BEGINNING OF A FILE).
C	   1 :	TAPE DRIVE HAS NOT BEEN OPENED (NO AVAILABLE DRIVE,
C		NO I/O CHANNEL, OR NO EVENT FLAG [WHATEVER THAT MEANS]).
C	   2 :	DRIVE HAS BEEN OPENED OK, BUT TAPE IS OFF LINE.
C		THE DRIVE IS LEFT OPEN, BUT THE USER IS GIVEN NO
C		OPPORTUNITY TO PUT THE TAPE ON-LINE;  THIS MUST BE
C		DONE IN THE CALLING PROGRAM.
C
C
	LOGICAL*1 STATUS(4)
	CHARACTER NAMEMT*15, RETRY*1
	INTEGER*4 ID, IRET, NAMELEN
C
	NERROR = 0
	ID = 0
C
4	TYPE 2
2	FORMAT(' DO YOU WANT THE SYSTEM TO RETRY BAD RECORDS? ',$)
	ACCEPT 3, RETRY
3	FORMAT(A)
	IF(RETRY.NE.'Y') RETRY = 'N'
C
	CALL MTOPEN(ID,IRET)
	CALL MTERRMESS('MTOPEN',IRET,6)
	IF(IRET.NE.0) THEN  !DRIVE CAN'T BE OPENED
	  NERROR = 1
	  RETURN
	  END IF
C
	IF(RETRY.EQ.'N') CALL MTSERM(ID,.TRUE.,IRET)
C
	CALL MTNAME(ID,NAMEMT,NAMELEN,IRET)
	CALL MTERRMESS('MTNAME',IRET,6)
	TYPE *, 'MOUNT THE INPUT TAPE ON ',NAMEMT
	PAUSE
C
6	CALL MTSENS(ID,STATUS,IRET)
C	 POSSIBLE VALUES OF IRET: 1 MEANS I/O ERROR, 2 MEANS TAPE IS
C	 OFF LINE, 3 MEANS TAPE HAS BEEN OFF LINE.
C 	 IT IS LIKELY THAT MTSENS DOES NOT RETURN CORRECT DATA UNTIL
C	 AFTER A READ OR A WRITE.
	CALL MTERRMESS('MTSENS',IRET,6)
	IF(IRET.EQ.1) THEN
	  TYPE *,'I DON''T KNOW WHAT THIS MEANS IN THIS CONTEXT.'
	  CALL BELL
	  PAUSE
	  END IF
	IF(IRET.EQ.2) THEN   !TAPE IS OFF-LINE.
	  NERROR = 2
	  RETURN
	  END IF
C
	I = STATUS(3)
	IF(JIAND(I,8).EQ.0) THEN
	  CALL BELL
	  CALL BELL
	  TYPE 5
5	  FORMAT(' **** WARNING **** THE INPUT TAPE HAS A WRITE RING.')
	  END IF
1	CONTINUE
C
	RETURN
	END

	SUBROUTINE OPENMTIN3(RETRY,ID,NERROR)
C						J.KRISTIAN 9/83
C OPENS AN INPUT TAPE IN A STANDARD WAY.
C INTERACTIVE: REQUIRES RESPONSE FROM THE USER.
C NEARLY IDENTICAL WITH OPENMTIN, EXCEPT RETURNS AN ERROR CODE (NERROR),
C  AND DOES NOT ALLOW FOR THE POSSIBILITY OF MOVING TAPE TO THE
C  BEGINNING OF ANOTHER FILE AFTER OPENING IT.
C
C IDENTICAL WITH OPENMTIN2, WHICH IT IS INTENDED TO SUPPLANT, EXCEPT
C THAT "RETRY" IS PASSED IN INSTEAD OF THE USER BEING QUERIED.
C THE SUBROUTINE "OPENMTIN" WAS CHANGED TO REFLECT THIS, AND AS FAR
C AS I KNOW THAT IS THE ONLY ROUTINE WHICH CALLS THIS ONE.
C
C
C INPUT PARAMETERS:
C
C	RETRY (LOGICAL)
C
C OUTPUT PARAMETERS:
C
C	ID = THE NUMBER TO BE USED TO IDENTIFY THE TAPE DRIVE
C	    IN SUBSEQUENT CALLS TO MTPCKG SUBROUTINES.
C
C	NERROR = ERROR CODE, WITH THE FOLLOWING POSSIBLE VALUES:
C
C	   0 :	DRIVE IS OPENED, TAPE IS POSITIONED AT WHEREVER IT 
C		MAY HAVE BEEN (NOT NECESSARILY AT ITS BEGINNING,
C		NOR EVEN AT THE BEGINNING OF A FILE).
C	   1 :	TAPE DRIVE HAS NOT BEEN OPENED (NO AVAILABLE DRIVE,
C		NO I/O CHANNEL, OR NO EVENT FLAG [WHATEVER THAT MEANS]).
C	   2 :	DRIVE HAS BEEN OPENED OK, BUT TAPE IS OFF LINE.
C		THE DRIVE IS LEFT OPEN, BUT THE USER IS GIVEN NO
C		OPPORTUNITY TO PUT THE TAPE ON-LINE;  THIS MUST BE
C		DONE IN THE CALLING PROGRAM.
C
C
	LOGICAL*1 STATUS(4)
	LOGICAL RETRY
	CHARACTER NAMEMT*15
	INTEGER*4 ID, IRET, NAMELEN
C
	NERROR = 0
	ID = 0
C
	CALL MTOPEN(ID,IRET)
	CALL MTERRMESS('MTOPEN',IRET,6)
	IF(IRET.NE.0) THEN  !DRIVE CAN'T BE OPENED
	  NERROR = 1
	  RETURN
	  END IF
C
	IF(.NOT.RETRY) CALL MTSERM(ID,.TRUE.,IRET)
C
	CALL MTNAME(ID,NAMEMT,NAMELEN,IRET)
	CALL MTERRMESS('MTNAME',IRET,6)
	TYPE *, 'MOUNT THE INPUT TAPE ON ',NAMEMT
	PAUSE
C
6	CALL MTSENS(ID,STATUS,IRET)
C	 POSSIBLE VALUES OF IRET: 1 MEANS I/O ERROR, 2 MEANS TAPE IS
C	 OFF LINE, 3 MEANS TAPE HAS BEEN OFF LINE.
C 	 IT IS LIKELY THAT MTSENS DOES NOT RETURN CORRECT DATA UNTIL
C	 AFTER A READ OR A WRITE.
	CALL MTERRMESS('MTSENS',IRET,6)
	IF(IRET.EQ.1) THEN
	  TYPE *,'I DON''T KNOW WHAT THIS MEANS IN THIS CONTEXT.'
	  CALL BELL
	  PAUSE
	  END IF
	IF(IRET.EQ.2) THEN   !TAPE IS OFF-LINE.
	  NERROR = 2
	  RETURN
	  END IF
C
	I = STATUS(3)
	IF(JIAND(I,8).EQ.0) THEN
	  CALL BELL
	  CALL BELL
	  TYPE 5
5	  FORMAT(' **** WARNING **** THE INPUT TAPE HAS A WRITE RING.')
	  END IF
1	CONTINUE
C
	RETURN
	END

	SUBROUTINE OPENMTOUT(ID,NFSTART)
C
C						J. KRISTIAN 1980
C
C			REVISION 5/1/81. RETURNS WITH ID =-1 FOR ILLEGAL
C			  STARTING FILE NUMBER.
C
C OPENS AN OUTPUT TAPE (THAT IS, A TAPE WHICH IS INTENDED TO BE
C WRITTEN ON), AND POSITIONS IT AT A REQUESTED STARTING FILE,
C USING MTPCKG PRIMITIVES.  EXECUTES INTERACTIVELY.
C
C INPUT/OUTPUT PARAMETER:
C
C    NFSTART 
C        (INPUT) = REQUESTED STARTING FILE,ASSUMING THAT THE INITIAL
C		POSITION, WHEREVER THAT MAY BE ON THE TAPE, IS FILE 1.
C		IF THE INITIAL POSITION IS NOT THE BEGINNING OF THE
C		TAPE, THE USER WILL BE INFORMED AND MUST GIVE HIS
C		APPROVAL BEFORE PROCEEDING.
C
C		IF NFSTART = 1, THE TAPE IS LEFT AT ITS INITIAL
C		POSITION, WHICH MAY NOT BE THE START OF A FILE.
C
C		IF NFSTART > 1, WILL TAKE INITIAL POSITION ON TAPE AS
C		FILE 1 AND SKIP TO THE BEGINNING OF THE APPROPRIATE FILE
C
C		SPECIAL CASE: IF NFSTART = -1, THE TAPE WILL BE
C		POSITIONED JUST PAST THE LAST DATA ON THE TAPE.
C
C		IF NFSTART IS ANYTHING ELSE, WILL INFORM THE USER THAT
C		THE FILE NUMBER IS ILLEGAL AND ASK HIM FOR A NEW NUMBER.
C
C        (OUTPUT) = INPUT VALUE EXCEPT FOR THE FOLLOWING:
C
C		IF THE INPUT VALUE OF NFSTART IS -1 (REQUEST TO POSITION
C		TAPE PAST THE END OF EXISTING DATA), THE OUTPUT VALUE
C		IS THE ACTUAL POSITION OF THE TAPE FOLLOWING THIS
C		OPERATION (WITH THE INITIAL POSITION DEFINED AS FILE 1).
C
C OUTPUT PARAMETER:
C
C    ID = THE NUMBER USED TO IDENTIFY THE TAPE DRIVE
C	    IN SUBSEQUENT CALLS TO MTPCKG SUBROUTINES.
C	IF TAPE IS NOT OPENED DUE TO ILLEGAL FILE NUMBER, RETURNS
C	  ID = -1.
C
C ***********************
C
C OVERALL LOGICAL STRUCTURE:
C
C	CHECK FOR LEGALITY OF STARTING FILE NUMBER.  IF AN ILLEGAL
C	   NUMBER IS GIVEN, THE USER IS GIVEN ONE CHANCE TO SUPPLY A
C	   LEGAL NUMBER FROM THE TERMINAL.  OTHERWISE THE ROUTINE
C	   RETURNS WITH A VALUE OF ID = -1.
C	OPEN THE TAPE DRIVE.  GET THE NAME OF THE DRIVE.
C	ASK USER TO MOUNT A TAPE ON THE NAMED DRIVE
C	IF DRIVE IS OFF LINE, ASK AGAIN
C	IF THERE IS NO WRITE RING ON THE TAPE, ASK THE USER TO PUT ONE
C	   IN, THEN START OVER.
C	IF THE TAPE IS NOT POSITIONED AT THE BEGINNING, MAKE SURE THAT
C	   THE USER KNOWS AND APPROVES BEFORE PROCEEDING FURTHER.
C	IF THE STARTING FILE IS -1, SKIP TO THE END OF DATA, RETURN.
C	IF THE STARTING FILE IS NOT THE INITIAL ONE, SKIP TO THE
C	   STARTING FILE, TELL THE USER THE DENSITY, AND RETURN.
C	IF THE START IS THE BEGINNING OF THE TAPE, GET THE DENSITY
C	   FROM THE USER, INITIALIZE THE TAPE.
C
C ************************
C
	LOGICAL*1 PRT, STATUS(4), PARTF
	LOGICAL*1 TAPELOST,WRENABLE,EOT,EOF,BOT,EPARITY
	CHARACTER NAMEMT*15, REPLY*1, STRING*20
C
	IF(NFSTART.EQ.0.OR.NFSTART.LT.-1) THEN
	  ID = -1
	  TYPE 7, NFSTART
7	  FORMAT(' OPENMTOUT ASKED TO OPEN AN OUTPUT TAPE AT',
     *    ' ILLEGAL FILE NUMBER:',I5)
	  TYPE *,'IF YOU KNOW WHAT THE CORRECT NUMBER IS, TYPE IT IN,'
	  CALL NEWI4(' OTHERWISE TAPE OPEN WILL BE ABORTED. ',NUMBER)
	  IF(NUMBER.EQ.0.OR.NUMBER.LT.-1) RETURN
	  NFSTART = NUMBER
	  END IF
C
3	CALL MTOPEN(ID,IRET)
	CALL MTERRMESS('MTOPEN',IRET,6)
	IF(IRET.NE.0) THEN
	  ID = 0
	  RETURN
	  END IF
C
	CALL MTNAME(ID,NAMEMT,NAMELEN,IRET)
	IF(IRET.NE.0) TYPE *,'ERROR RETURN FROM MTNAME'
	IF(IRET.NE.0) PAUSE
C
1	TYPE *, 'MOUNT THE OUTPUT TAPE ON ',NAMEMT
	PAUSE
	CALL STATUSWORD(ID,STATUS,NDENS,TAPELOST,WRENABLE,EOT,EOF,BOT,
     *  EPARITY,IRET)
	IF(IRET.EQ.2) GO TO 1   ! TAPE IS OFF-LINE.
	IF(IRET.EQ.1) PAUSE    ! I/O ERROR. NOT SURE OF SIGNIFICANCE.
	IF(.NOT.WRENABLE) THEN
	  CALL MTCLOS(ID,IRET)
	  TYPE *, 'THERE IS NO WRITE RING ON THE OUTPUT TAPE.'
	  TYPE *, 'PUT IN A WRITE RING AND'
	  GO TO 3
	  END IF
	IF(.NOT.BOT) THEN
	  CALL PXSTRG(' OUTPUT TAPE IS NOT POSITIONED AT THE'//
     *    ' BEGINNING.  IS THIS OK? ',REPLY)
	  IF(REPLY.NE.'Y') GO TO 1
	  END IF
C
	IF(NFSTART.EQ.-1) THEN
	CALL ENDOFDATA(ID,NFILES,NRECS,PARTF,BOT,EOT)
	NFSTART = NFILES + 1
	IF(BOT) THEN
	  TYPE *,'OUTPUT TAPE APPEARS EMPTY, POSITIONED AT BEGINNING.'
	 ELSE
	  TYPE *,'OUTPUT TAPE IS POSITIONED AT END OF DATA.'
	  END IF
	IF(EOT) THEN
	  TYPE *,'THIS IS AT OR NEAR THE END OF THE TAPE.'
	  CALL PXSTRG('  DO YOU WANT TO CONTINUE? ',REPLY)
	  IF(REPLY.NE.'Y') STOP
	  END IF
	IF(PARTF) THEN
	  TYPE *,'THERE IS NO END-OF-FILE AT THE END.'
	  CALL PXSTRG('  DO YOU WANT TO WRITE ONE BEFORE'//
     *    ' CONTINUING? ',REPLY)
	  IF(REPLY.EQ.'Y') THEN
	    CALL MTWEOF(ID,IRET) 
	    CALL MTERRMESS('MTWEOF',IRET,6)
	    NFSTART = NFSTART + 1
	    END IF
	  END IF
	GO TO 9
	END IF
C
	NFINIT = 1   !DEFINES INITIAL POSITION OF TAPE AS FILE 1
	IF(NFSTART.NE.1) THEN
	  TYPE *, 'POSITIONING OUTPUT TAPE.'
	  CALL SKIPFMT(ID,NFINIT,NFSTART)
	  CALL STATUSWORD(ID,STATUS,NDENS,TAPELOST,WRENABLE,EOT,EOF,BOT,
     *    EPARITY,IRET)
	  IF(IRET.NE.0) PAUSE
	  TYPE 4, NDENS
4	  FORMAT(' OUTPUT TAPE DENSITY IS',I5,' BPI.')
	  END IF
C
9	IF(NFSTART.EQ.1) THEN
	CALL STATUSWORD(ID,STATUS,NDENS,TAPELOST,WRENABLE,EOT,EOF,BOT,
     *  EPARITY,IRET)
	IF(BOT) THEN   !SET TAPE DENSITY.
5	  TYPE 2
2	  FORMAT(' 800 OR 1600 BPI OUTPUT? ',$)
	  ACCEPT *, NDENS
	  IF(NDENS.EQ.8) NDENS = 800
	  IF(NDENS.EQ.16) NDENS = 1600
	  IF(NDENS.NE.800.AND.NDENS.NE.1600) GO TO 5
	  CALL BELL
	  TYPE *,'IF YOU ARE USING A SYSTEM INDUSTRIES TAPE DRIVE,'
	  TYPE *,'I HAVE NO IDEA WHAT THE OUTPUT DENSITY WILL BE.'
	  TYPE *,'IF IT MATTERS TO YOU, YOU ARE ADVISED TO WALK'
	  TYPE *,'TO THE TAPE DRIVE AND SET THE DENSITY YOURSELF,'
	  TYPE *,'USING THE BUTTONS ON THE FRONT PANEL.'
	  CALL BELL
	  PAUSE
6	  CALL MTPREP(ID,NDENS,IRET)
	  CALL MTERRMESS('MTPREP',IRET,6)
	  IF(IRET.GE.2) PAUSE
	  IF(IRET.EQ.2) GO TO 6   !TAPE OFFLINE.
	  IF(IRET.EQ.3) GO TO 5  !ILLEGAL DENSITY: SHOULDN'T HAPPEN.
	  END IF
	END IF
C
	RETURN
	END

	SUBROUTINE SKIPFMT(ID,NFILE,NEXTF)
C						J. KRISTIAN 1980
C MOVES A TAPE FROM ONE FILE TO ANOTHER.
C
C INPUT PARAMETERS:
C    ID = THE ID NUMBER OF THE TAPE.
C    NFILE = THE CURRENT FILE NUMBER. (NFILE IS NOT UPDATED).
C    NEXTF = THE FILE NUMBER TO WHICH YOU WANT TO SKIP.
C	THE TAPE WILL BE LEFT POSITIONED AT THE BEGINNING OF NEXTF.
C	IF NEXTF = 1, TAPE WILL BE REWOUND.
C	  (IF THE TAPE WAS STARTED IN THE MIDDLE, CAN GET TO
C	   THE STARTING FILE OR EARLIER FILES BY ADDING SOME LARGE
C	   NUMBER TO BOTH NFILE AND NEXTF IN THE CALL.)
C	IF NEXTF = NFILE, WILL POSITION THE TAPE AT THE BEGINNING
C	OF THE CURRENT FILE.
C
C INTERNAL PARAMETERS:
C    IRETSK = ERROR RETURN FROM MTSKFI.  1 IS I/O ERROR (DON'T KNOW WHAT
C	THIS MEANS), 2 IS TAPE OFFLINE, 4 IS END OF TAPE, 5 IS END OF
C	DATA.
C    IRETRW = ERROR RETURN FROM MTREWI.  POSSIBLE VALUES 1 AND 2, AS
C	IN IRETSK ABOVE.
C
C ERROR RECOVERY:
C    EXCEPT FOR THE TAPE BEING OFFLINE (IN WHICH CASE THE USER IS FORCED
C    TO CORRECT THE ERROR), THE ERROR RECOVERY IS VERY POOR.
C    AN ERROR MESSAGE IS TYPED ON THE TERMINAL, AND THE PROGRAM PAUSES
C    IN ORDER TO FORCE THE USER TO NOTICE THE ERROR.  IF THE PROGRAM IS
C    CONTINUED, THE SUBROUTINE RETURNS WITH NO INDICATION TO THE CALLING
C    PROGRAM OF THE OCCURRENCE OF AN ERROR, NOR OF THE CURRENT POSITION
C    OF THE TAPE.
C
C    TO AVOID THESE PROBLEMS, USE JUMPFILE.
C
CCCC	TYPE *,'SKIPFMT ASKED TO MOVE FROM FILE',NFILE,
CCCC     *    ' TO FILE',NEXTF
C
	IF(NFILE.LT.1.OR.NEXTF.LT.1) THEN
	TYPE 4, NFILE, NEXTF
4	FORMAT(' ERROR IN CALL TO SKIPFMT.  ASKED TO',
     *  ' GO FROM FILE',I4,' TO FILE',I4)
	PAUSE
	RETURN
	END IF
C
	IF(NEXTF.EQ.1) THEN
2	  CALL MTREWI(ID,IRETRW)
	  CALL MTERRMESS('MTREWI',IRETRW,6)
	  IF(IRETRW.NE.0) PAUSE
	  IF(IRETRW.EQ.2) GO TO 2
	  RETURN
	  END IF
C
CCCC	TYPE *, 'CALLING JUMPFILE.'
	CALL JUMPFILE(ID,NFILE,NEXTF,NEWF,NERR)
	IF(NERR.NE.0) THEN
	  TYPE *,' ERROR RETURN FROM JUMPFILE: NERR =',NERR
	  PAUSE
	  END IF
	IF(NEWF.NE.NEXTF) THEN
	  TYPE 1, NEWF,NEXTF
1	  FORMAT(' ERROR IN SKIPFMT.  TAPE IS NOW POSITIONED AT FILE',
     *     I4,' INSTEAD OF FILE',I4)
	  PAUSE
	  END IF
C
	RETURN
	END

	SUBROUTINE JUMPFILE(ID,NFILE,NEXTF,NEWF,NERR)
C						J. KRISTIAN MAY 1981.
C MOVES A TAPE FROM ONE FILE TO THE BEGINNING OF ANOTHER.
C THIS IS AN IMPROVED VERSION OF SKIPFMT.
C
C INPUT PARAMETERS:
C    ID = THE ID NUMBER OF THE TAPE.
C    NFILE = THE CURRENT FILE NUMBER. (NFILE IS NOT UPDATED).
C    NEXTF = THE FILE NUMBER TO WHICH YOU WANT TO SKIP.  NORMALLY,
C	THE TAPE WILL BE LEFT POSITIONED AT THE BEGINNING OF NEXTF.
C	IF NEXTF = NFILE, WILL POSITION THE TAPE AT THE BEGINNING
C	OF THE CURRENT FILE.
C
C    NOTE THAT NFILE, NEXTF AND NEWF HAVE NOTHING TO DO WITH THE
C    ACTUAL PHYSICAL POSITION OF THE TAPE.  ONLY THEIR DIFFERENCES
C    ARE MEANINGFUL.  IN PARTICULAR, NEGATIVE NUMBERS ARE ALLOWED,
C    AND IF NEXTF = 1, THE TAPE IS NOT REWOUND, BUT SEARCHED IN
C    THE SAME WAY AS ANY OTHER FILE.
C
C OUTPUT PARAMETERS:
C    NEWF = THE ACTUAL FILE NUMBER OF THE TAPE LOCATION AT THE END
C	OF THE OPERATION.  IN THE ABSENCE OF PROBLEMS, SHOULD HAVE
C	NEWF = NEXTF.
C    NERR = ERROR CODE. 1-5 SAME AS RETURN FROM MTSKFI:
C       1 IS I/O ERROR (DON'T KNOW WHAT THIS MEANS), 2 IS TAPE OFFLINE,
C	4 IS END OF TAPE, 5 IS END OF DATA.
C	6 MEANS WRONG NUMBER OF FILES SKIPPED, BUT NO ERROR RETURN
C	FROM MTSKFI.  THIS CONDITION SHOULD NEVER ARISE.
C
C
CCCC	TYPE *,'JUMPFILE ASKED TO GO FROM FILE',NFILE,
CCCC     *   ' TO FILE',NEXTF
C
	NSKIP = NEXTF - NFILE
CCCC	TYPE *,'JUMPFILE WILL TRY TO SKIP',NSKIP,' FILES.'
C
5	CALL MTSKFI(ID,NSKIP,NDONE,IRET)
C
	IF(IRET.EQ.2) THEN	!TAPE OFFLINE. TRY AGAIN.
	  CALL MTERRMESS('MTSKFI',IRET,6)
	  PAUSE
	  GO TO 5
	  END IF
C
	IF(NSKIP.GE.0) NEWF = NFILE + NDONE
	IF(NSKIP.LT.0) NEWF = NFILE - NDONE
CCCC	TYPE *,NDONE,' FILES SKIPPED. NEW FILE =',NEWF
	NERR = IRET
C
	IF(IRET.GE.1) RETURN
C
	IF(NDONE.NE.JIABS(NSKIP)) THEN
	  TYPE 1, NSKIP, NDONE
1	  FORMAT(' ERROR IN SKIPFMT.  ASKED TO SKIP',I3,
     *    ' FILES, ACTUALLY SKIPPED',I3,'.  REASON UNKNOWN.')
	  NERR = 6
	  RETURN
	  END IF
C
	IF(NSKIP.GT.0) RETURN
C
C	IF SKIP IS BACKWARD, MUST MOVE TO THE BEGINNING OF THE FILE:
	CALL MTSKFI(ID,-1,NDONE,IRET)   !SKIP BACKWARD ONE MORE EOF.
CCCC	TYPE *,'SKIP BACKWARD ANOTHER FILE.'
	NEWF = NEWF - NDONE
CCCC	TYPE *,'NEW FILE =',NEWF
	IF(IRET.EQ.4) RETURN	!TAPE IS AT BOT.
	CALL MTERRMESS('MTSKFI',IRET,6)
	IF(IRET.GT.1) PAUSE
	IF(NDONE.NE.1) THEN
	  TYPE 1, -1, NDONE
	  NERR = 6
	  RETURN
	  END IF
CCCC	TYPE *,'NEXT SKIP FORWARD ONE FILE.'
	CALL MTSKFI(ID,1,NDONE,IRET)   !SKIP FORWARD ONE EOF
	NEWF = NEWF + NDONE
CCCC	TYPE *,'NEW FILE =',NEWF
	CALL MTERRMESS('MTSKFI',IRET,6)
	IF(IRET.GT.1) PAUSE
	IF(NDONE.NE.1) THEN
	  TYPE 1, 1, NDONE
	  NERR = 6
	  RETURN
	  END IF
C
	RETURN
	END

	SUBROUTINE MTERRMESS(SUBNAME,IRET,LOGUNIT)
C						J. KRISTIAN 1980
	CHARACTER SUBNAME*(*)
C WORKS FOR MTSENS(1-3): MTPREP(1-3): MTREAD(1-5): MTRDBK(1-3):
C  MTWRIT(1-4): MTWEOF(1-4): MTREWI(1-2): MTUNLD(1-2):
C  MTSKRE(1-5): MTSKFI(1,2,4,5): MTOPEN(1-3): MTNAME(1):
C  VFCPIX(1-4)
C NUMBERS IN PARENTHESES ABOVE ARE POSSIBLE VALUES OF IRET FOR EACH CALL
C
C  MTREAD:
C
C	1 - I/O ERROR
C	2 - TAPE IS OFFLINE
C	3 - END OF FILE READ
C	4 - REACHED END OF TAPE MARKER
C	5 - NOTHING MORE IS WRITTEN ON TAPE.
C
	IF(IRET.EQ.0) RETURN
C
	IF(SUBNAME.EQ.'MTOPEN') THEN
	  IF(IRET.EQ.1) WRITE(LOGUNIT,1) SUBNAME,'NO AVAILABLE DRIVE'
	  IF(IRET.EQ.2) WRITE(LOGUNIT,1) SUBNAME,'NO I/O CHANNEL.'
	  IF(IRET.EQ.3) WRITE(LOGUNIT,1) SUBNAME,'NO EVENT FLAG.'
	  RETURN
	  END IF
C
	IF(SUBNAME.EQ.'MTNAME') THEN
	  WRITE(LOGUNIT,1) SUBNAME,'TRUNCATED NAME.'
	  RETURN
	  END IF
C
1	FORMAT(' ERROR RETURN FROM ',A, ': ',A,I3)
C
	IF(IRET.EQ.1) WRITE(LOGUNIT,1) SUBNAME,'I/O ERROR'
C
	IF(IRET.EQ.2) WRITE(LOGUNIT,1) SUBNAME,'TAPE IS OFFLINE'
C
	IF(IRET.EQ.3) GO TO 22
C
	IF(IRET.EQ.4) WRITE(LOGUNIT,1) SUBNAME,'REACHED END-OF-TAPE'
C
	IF(IRET.EQ.5) WRITE(LOGUNIT,1) SUBNAME,
     *  'THERE IS NOTHING MORE WRITTEN ON THE TAPE.'
C
	IF(IRET.GT.5.OR.IRET.LT.1) WRITE(LOGUNIT,1) SUBNAME,
     *  'ERROR CODE =',IRET
C
	RETURN
C
22	CONTINUE  !THIS SECTION IS FOR IRET = 3.
	IF(SUBNAME.EQ.'MTWRIT'.OR.SUBNAME.EQ.'MTWEOF'.
     *  OR.SUBNAME.EQ.'VFCPIX') THEN
	  WRITE (LOGUNIT,*) 'NO WRITE RING ON TAPE.'
	  END IF
C
	IF(SUBNAME.EQ.'MTREAD') WRITE(LOGUNIT,*)'END OF FILE READ.'
C
	IF(SUBNAME.EQ.'MTSENS') WRITE(LOGUNIT,*)
     *  'ERROR RETURN FROM MTSENS: TAPE HAS BEEN OFFLINE.'
C
	IF(SUBNAME.EQ.'MTPREP') WRITE(LOGUNIT,*)
     *  'ERROR RETURN FROM MTPREP: ILLEGAL DENSITY REQUESTED.'
C
	IF(SUBNAME.EQ.'MTRDBK'.OR.SUBNAME.EQ.'MTSKRE')
     *  WRITE(LOGUNIT,23) SUBNAME
23	FORMAT(' ERROR RETURN FROM ',A,': REACHED EOF OR BOT.')
C
	IF(SUBNAME.EQ.'MTSKFI') TYPE 24
24	FORMAT(' ERROR RETURN = 3 FROM MTSKFI.  ILLEGAL ERROR RETURN.')
C
	RETURN
	END

	SUBROUTINE SKIPREC(ID,NFILE,NREC)
C						J. KRISTIAN 1980
	TYPE 1
1	FORMAT(' HOW MANY RECORDS DO YOU WANT SKIPPED?  ',$)
	ACCEPT *, NSKIPR
	IF(NSKIPR.EQ.0) RETURN
	TYPE 2
2	FORMAT(' RECORDS BEING SKIPPED: DON''T GO AWAY.')
	CALL MTSKRE(ID,NSKIPR,NDONE,IRET)
	IF(IRET.EQ.3) NDONE = NDONE -1
	TYPE 3, NDONE
3	FORMAT(1X,I4,' RECORDS SKIPPED.')
	CALL MTERRMESS('MTSKRE',IRET,6)
	NREC = NREC + NSKIPR
	IF(IRET.EQ.3.AND.NSKIPR.GT.0) NFILE = NFILE + 1
	IF(IRET.EQ.3.AND.NSKIPR.LT.0) NFILE = NFILE - 1
	IF(IRET.EQ.3) NREC = 0
	RETURN
	END

	SUBROUTINE SKIPFILE(ID,NFILE,NREC)
C						J. KRISTIAN 1980
C
C SKIPS FILES, EITHER FORWARD OR BACKWARD.  INTERACTIVE ROUTINE.
C GETS NUMBER OF FILES TO BE SKIPPED FROM USER AT TERMINAL,
C REPORTS RESULTS ON TERMINAL, LEAVES IT UP TO USER TO DECIDE
C WHAT TO DO NEXT.  USED BY MTCHECK.
C
C INPUT PARAMETERS:
C    ID = IDENTIFICATION NUMBER OF TAPE TO BE SKIPPED.
C
C INPUT/OUTPUT PARAMETER:
C    NFILE.  ASSUMING THE INPUT VALUE IS THE CURRENT FILE NUMBER OF
C	THE TAPE, THEN THE OUTPUT VALUE IS THE CURRENT FILE NUMBER
C	AFTER SKIPPING.  IF FILES ARE SKIPPED FORWARD, THE TAPE
C	IS LEFT POSITIONED AT THE BEGINNING OF NFILE.  IF FILES
C	ARE SKIPPED BACKWARD, THE TAPE IS LEFT AT THE END OF NFILE.
C
C OUTPUT PARAMETER:
C	NREC = 0 IF NFSKIP.NE.0.  OTHERWISE INPUT VALUE IS UNCHANGED.
C
C TERMINAL INPUT PARAMETERS:
C    NFSKIP = NUMBER OF FILES TO BE SKIPPED.
C	      IF ZERO, RETURNS WITHOUT DOING ANYTHING.
C	      IF GREATER THAN ZERO, SKIPS FORWARD.
C	      IF LESS THAN ZERO, SKIPS BACKWARD.
C
C INTERNAL PARAMETERS:
C    NDONE = ACTUAL NUMBER OF FILES SKIPPED.  NORMALLY WILL BE THE
C	SAME AS NFSKIP, BUT MAY NOT BE.  ALWAYS > 0, WHETHER FILES
C	ARE SKIPPED FORWARD OR BACKWARD.
C
C
	TYPE 1
1	FORMAT(' HOW MANY EOF''S DO YOU WANT SKIPPED?  ',$)
	ACCEPT *, NFSKIP
C
	IF(NFSKIP.EQ.0) RETURN
C
	TYPE 2
2	FORMAT(' MOVING TO NEXT FILE: HANG LOOSE')
	CALL MTSKFI(ID,NFSKIP,NDONE,IRET)
	CALL MTERRMESS('MTSKFI',IRET,6)
	IF(NFSKIP.GT.0) NFILE = NFILE + NDONE
	IF(NFSKIP.LT.0) NFILE = NFILE - NDONE
	NREC = 0
	IF(NDONE.NE.0) THEN
	  IF(NFSKIP.GT.0) TYPE 3, NDONE, NFILE
3	  FORMAT(' MTSKIF HAS SKIPPED ',I3,' EOF''S FORWARD.'/
     *    '  TAPE IS NOW AT THE BEGINNING OF FILE',I5)
	  IF(NFSKIP.LT.0) TYPE 4, NDONE, NFILE
4	  FORMAT(' MTSKIF HAS SKIPPED ',I3,' EOF''S BACKWARD.'/
     *    '      TAPE IS NOW AT THE END OF FILE',I5)
	 ELSE
	  TYPE 5, NFILE
5	  FORMAT(' ERROR: NO FILES WERE SKIPPED.  TAPE IS STILL',
     *    ' WITHIN FILE',I5)
	  END IF
C
	RETURN
	END

	SUBROUTINE OLDLASTEOF(ID,NEXTFILE)
C						J. KRISTIAN 1980
C THIS SUBROUTINE HAS BEEN REPLACED WITH A
C SIMPLE VERSION WHICH CALLS ENDOFDATA AND THEN SKIPS BACKWARD AND
C THEN FORWARD ONE FILE.
C
C
C
C MOVES A TAPE TO A POSITION JUST PAST THE LAST END-OF-FILE.
C FINDS END OF DATA BY SKIPPING FILES FORWARD UNTIL THE
C END-OF-DATA MESSAGE IS RETURNED, THEN BACKS UP AND FORWARD
C TO POSITION ITSELF JUST AFTER THE LAST EOF.
C
C NOTE THAT IF THERE IS DATA WRITTEN AT THE END WITHOUT AN EOF,
C THE TAPE WILL BE POSTIONED AT THE BEGINNING OF THAT DATA.
C
C IF THERE ARE MANY SEQUENTIAL EOF'S TAPE WILL BE POSITIONED AT
C THE END OF ALL OF THEM
C
C INPUT PARAMETER:
C    ID = TAPE DRIVE IDENTIFICATION.
C 
C OUTPUT PARAMETER:
C    NEXTFILE = THE NUMBER OF THE FILE AT WHICH THE TAPE IS POSITIONED
C		WHEN THE SUBROUTINE IS DONE, WHERE FILE 1 IS DEFINED TO
C		BE THE TAPE POSITION WHEN THE SUBROUTINE IS CALLED.
C
C HAS NOT BEEN EXTENSIVELY TESTED, STILL PRINTS DIAGNOSTIC MESSAGES.
C
	LOGICAL*1 STWORD(4),TAPELOST,WRENABLE,EOT,EOF,BOT,EPARITY
	INTEGER*4 IDENS,IRET
C
	NSKIPF = 1  !FORWARD SKIP FILES ONE AT A TIME.
	NTOTAL = 0  !NTOTAL IS THE TOTAL NUMBER OF FILES SKIPPED.
	TYPE *, ' '
	TYPE *, 'DIAGNOSTIC MESSAGES FROM SUBROUTINE LASTEOF:'
	TYPE *,'SEARCHING FOR END OF DATA ON TAPE.'
C
1	CONTINUE
	CALL MTSKFI(ID,NSKIPF,NSKIPPED,IRET)
	CALL MTERRMESS('MTSKFI',IRET,6)
	IF(IRET.EQ.0) THEN
	  TYPE *, 'EOF READ.'
	  NTOTAL = NTOTAL + 1
	  GO TO 1
	  END IF
	IF(IRET.EQ.5) THEN    !HAVE HIT END OF STUFF ON TAPE.
	  NSKIPF = -1   !NOW BACKSKIP ONE FILE
	  TYPE *, 'BACKSKIPPING TAPE.'
	  CALL MTSKFI(ID,NSKIPF,NSKIPPED,IRET)
	  CALL MTERRMESS('MTSKFI',IRET,6)
C
C THE DRIVE SOMETIMES GIVES UP SEARCHING BACKWARD FOR THE
C LAST EOF BEFORE IT FINDS IT, WITH AN ERROR RETURN OF 5.
C REPEATING THE BACKWARD SKIP ONCE HAS WORKED ON SEVERAL TAPES.
C IN THE SECTION OF CODE BELOW, THE BACKWARD SKIP IS REPEATED UP TO
C THREE TIMES IF NECESSARY.
	  NREPEAT = 3
	  DO 2, N=1,NREPEAT
	  IF(IRET.EQ.5) THEN
	    TYPE *,'REPEAT BACKSKIP'
	    CALL MTSKFI(ID,NSKIPF,NSKIPPED,IRET)
	    END IF
2	  CONTINUE
C
	  TYPE *,'HAVE SKIPPED BACKWARD ONE FILE.'
	    CALL STATUSWORD(ID,STWORD,IDENS,TAPELOST,WRENABLE,EOT,EOF,
     *    BOT,EPARITY,IRET)
	  IF(BOT) THEN
	    TYPE *,'TAPE IS POSTIONED AT ITS BEGINNING.'
	    NEXTFILE = 1
	    RETURN
	    END IF
	  NSKIPF = 1   !NEXT SKIP FORWARD OVER LAST EOF.
	  CALL MTSKFI(ID,NSKIPF,NSKIPPED,IRET)
	  CALL MTERRMESS('MTSKFI',IRET,6)
	  TYPE *, 'HAVE SKIPPED FORWARD ACROSS LAST EOF.'
	  TYPE *, 'TAPE IS POSITIONED AT END OF DATA.'
	  TYPE *,' '
	  NEXTFILE = NTOTAL + 1.
	  RETURN
	  END IF
C
	PAUSE  !THIS MEANS AN ERROR RETURN OTHER THAN 0 OR 5.
	RETURN
	END

	SUBROUTINE LASTEOF(ID,NFILES,BOT,EOT)
C						J. KRISTIAN 1980
	LOGICAL*1 PARTF,BOT,EOT
	CALL ENDOFDATA(ID,NFILES,NRECS,PARTF,BOT,EOT)
	IF(.NOT.PARTF) RETURN
	IF(BOT) RETURN
	CALL MTSKFI(ID,-1,NDONE,IRET)
	CALL MTERRMESS('MTSKFI',IRET,6)
	CALL MTSKFI(ID,1,NDONE,IRET)
	CALL MTERRMESS('MTSKFI',IRET,6)
	RETURN
	END

	SUBROUTINE STATUSWORD(ID,STWORD,IDENS,TAPELOST,WRENABLE,EOT,EOF,
     *  BOT,EPARITY,IRET)
C						J. KRISTIAN 1980
C READS AND DECODES THE MAG TAPE STATUS WORD.
C
C ID (INPUT) IS THE IDENTIFYING NUMBER OF THE TAPE DRIVE USED BY MTPCKG.
C STWORD (OUTPUT) IS THE 32-BIT STATUS WORD, PLACED INTO A 4 ELEMENT
C LOGICAL*1 ARRAY.  
C OTHER OUTPUTS (ALL ARE LOGICAL*1 EXCEPT IDENS AND IRET):
C	IDENS (INTEGER*4) = TAPE DENSITY. 800, 1600 OR 0 (ERROR DEFAULT)
C	TAPELOST.  THE SYSTEM DOESN'T KNOW THE TAPE POSITION.
C	WRENABLE.  THERE IS A WRITE RING IN THE TAPE REEL.
C	EOT.  THE TAPE IS LOCATED AT THE END-OF-TAPE MARKER.
C	EOF.  THE LAST THING READ WAS AN END-OF-FILE.
C	BOT (BEGINNING OF TAPE).  TAPE IS POSITIONED AT THE LOAD POINT.
C	EPARITY.  THE PARITY OF THE TAPE IS EVEN.
C	IRET (INTEGER*4) = ERROR RETURN FROM MTSENS
C		(FOR DOCUMENTATION, SEE DOC:MTPCKG.DOC.)
C
C THE FOLLOWING ARE NOT EXPLICITLY EXAMINED:
C	LOW ORDER 3 BITS OF STWORD(1).  SHOULD BE ZEROS.
C	HIGH ORDER 4 BITS OF STWORD(2).  HAS SOMETHING TO DO WITH
C		THE TAPE FORMAT, BUT NO ONE IS SURE WHAT.
C		(THE DEC DOCUMENTATION IS NOT VERY CLEAR).
C	HIGH ORDER 3 BITS OF STWORD(3).  SHOULD BE ZERO.
C	ALL OF STWORD(4).  SHOULD BE ALL ZEROS.
C
	LOGICAL*1 STWORD(4),TAPELOST,WRENABLE,EOT,EOF,BOT,EPARITY
	INTEGER*4 IDENS,IRET
C
	CALL MTSENS(ID,STWORD,IRET)    !THIS READS THE STATUS WORD.
	CALL MTERRMESS('MTSENS',IRET,6)
C
	IF(STWORD(2).EQ.3) IDENS = 800
	IF(STWORD(2).EQ.4) IDENS = 1600
	IF(STWORD(2).NE.3.AND.STWORD(2).NE.4) IDENS = 0  !ERROR!
C
C
	N3 = STWORD(3)   ! WILL EXAMINE 3RD BYTE BIT-BY-BIT.
C
	IF(JIAND(N3,1).EQ.1) BOT = .TRUE.          !1ST BIT
	IF(JIAND(N3,1).NE.1) BOT = .FALSE.
C
	IF(JIAND(N3,2).EQ.2) EOF = .TRUE.          !2ND BIT
	IF(JIAND(N3,2).NE.2) EOF = .FALSE.
C
	IF(JIAND(N3,4).EQ.4) EOT = .TRUE.          !3RD BIT
	IF(JIAND(N3,4).NE.4) EOT = .FALSE.
C
	IF(JIAND(N3,8).EQ.8) WRENABLE = .FALSE.    !4TH BIT
	IF(JIAND(N3,8).NE.8) WRENABLE = .TRUE.
C
	IF(JIAND(N3,16).EQ.16) TAPELOST = .TRUE.   !5TH BIT
	IF(JIAND(N3,16).NE.16) TAPELOST = .FALSE.
C
C
	N1 = STWORD(1)
	IF(JIAND(N1,8).EQ.8) EPARITY = .TRUE.
	IF(JIAND(N1,8).NE.8) EPARITY = .FALSE.
C
	RETURN
	END

	SUBROUTINE ENDOFDATA(ID,NFILES,NRECS,PARTF,BOT,EOT)
C						J. KRISTIAN 1981
C  POSITIONS A TAPE AT THE END OF ALL EXISTING DATA.
C
C PROGRAM STRUCTURE: SKIPS FORWARD ONE RECORD AT A TIME UNTIL
C EITHER THE END-OF-DATA OR THE END-OF-TAPE IF FOUND.  THEN
C SKIPS BACKWARD ONE RECORD AND FORWARD ONE RECORD TO POSITION
C TAPE AT THE END OF THE DATA.
C
C INPUT PARAMETER:
C    ID = IDENTIFICATION OF TAPE USED BY MTPCKG SUBROUTINES
C
C OUTPUT PARAMETERS:
C    NFILES = NUMBER OF END-OF-FILE MARKS FOUND PAST THE
C             INITIAL POSITION WHEN THE SUBROUTINE IS CALLED
C    NRECS = NUMBER OF RECORDS FOUND PAST THE LAST END-OF-FILE.
C            IF THE INITIAL POSITION ON THE TAPE IS ALREADY PAST THE
C            END OF THE DATA, THEN THE NUMBER OF RECORDS IS UNKNOWN
C            AND THE VALUE ZERO IS RETURNED.
C            IF THE INITIAL POSITION OF THE TAPE WAS IN THE MIDDLE
C            OF THE LAST (INCOMPLETE) FILE, THEN THE VALUE RETURNED
C            IS ONLY THE NUMBER BETWEEN THE INITIAL POINT AND THE END.
C    PARTF (LOGICAL*1).  FLAG FOR PARTIAL FILE AT END.
C            IF TRUE, MEANS THAT THE LAST THING ON
C            THE TAPE IS NOT AN END-OF-FILE.
C            IF TRUE AND NRECS = 0, THIS MEANS THAT THE INITIAL POSITION
C            ON THE TAPE WAS ALREADY PAST THE END OF THE DATA.
C    BOT (LOGICAL*1).  IF TRUE, TAPE IS LEFT POSITIONED AT THE
C            BEGINNING (THE LOAD POINT).  IMPLIES THAT THERE IS
C            NOTHING AT ALL WRITTEN ON THE TAPE.
C    EOT (LOGICAL*1).  IF TRUE, THE END OF THE DATA IS AT OR
C            NEAR (WITHIN ONE SEARCH LENGTH) THE END-OF-TAPE
C            MARK.  THE EXACT DISTANCE FROM THE END IS INDETERMINATE.
C            (THERE MAY OR MAY NOT BE ROOM TO WRITE MORE.)
C
C INTERNAL PARAMETERS:
C    IRET = ERROR CODE RETURNED FROM MTSKRE. 0 MEANS OK, 1 MEANS I/O
C           ERROR, 2 MEANS TAPE OFF-LINE, 3 MEANS END-OF-FILE OR
C           BEGINNING OF TAPE, 4 MEANS END OF TAPE, 5 MEANS NO MORE DATA
C
	LOGICAL*1 PARTF
	LOGICAL*1 STWORD(4),TAPELOST,WRENABLE,EOT,EOF,BOT,EPARITY
	INTEGER*4 ID,NFILES,NRECS,IDENS,IRET
C
	NFILES = 0
	NRECS = 0
	EOT = .FALSE.
	BOT = .FALSE.
	PARTF = .FALSE.
C
	TYPE *,' '
	TYPE *,'DIAGNOSTIC MESSAGES FROM ENDOFDATA:'
	TYPE *,'FORWARD SKIP RECORDS UNTIL THE END OF THE DATA.'
1	CALL MTSKRE(ID,1,NDONE,IRET)
C
	IF(IRET.EQ.0.OR.IRET.EQ.1) THEN
	  NRECS = NRECS + 1
	  GO TO 1
	  END IF
	IF(IRET.EQ.2) THEN
	  TYPE *,'TAPE IS OFFLINE.  TO CONTINUE, PUT IT ONLINE.'
	  PAUSE
	  GO TO 1
	  END IF
	IF(IRET.EQ.3) THEN
	  NFILES = NFILES + 1
	  TYPE *,'FILE',NFILES,' CONTAINS',NRECS,' RECORDS'
	  NRECS = 0
	  GO TO 1
	  END IF
	IF(IRET.EQ.4) THEN
	  EOT = .TRUE.
	  TYPE *,'END OF TAPE REACHED.'
	  TYPE *,'NEXT BACKSKIP OVER END-OF-TAPE MARKER.'
	  CALL MTSKRE(ID,-1,NDONE,IRET)
	  CALL MTERRMESS('MTSKRE',IRET,6)
	  END IF
	IF(IRET.EQ.5) TYPE *,'END OF DATA REACHED.'
	IF(IRET.LT.0.OR.IRET.GT.5) THEN
	  TYPE *,'ILLEGAL ERROR CODE FROM MTSKRE =',IRET
	  TYPE *,'PROGRAM ABORTED.'
	  STOP
	  END IF
C
	IF(NRECS.NE.0) THEN
	  PARTF = .TRUE.
	  TYPE *,'THE LAST FILE CONTAINS',NRECS,' RECORDS WITH NO EOF.'
	 ELSE
	  IF(NFILES.EQ.0) TYPE *,'NO DATA FOUND BEYOND INITIAL POSITION'
	  END IF
C
	TYPE *,'NEXT BACKSKIP ACROSS LAST RECORD.'
2	CALL MTSKRE(ID,-1,NDONE,IRET)  !BACKSKIP ONE RECORD.
C
	IF(IRET.EQ.2) THEN
	  TYPE *,'TAPE IS OFFLINE.  TO CONTINUE, PUT IT ONLINE.'
	  PAUSE
	  GO TO 2
	  END IF
	IF(IRET.EQ.5) THEN    !DATA NOT FOUND. TRY AGAIN.
	  TYPE *,'DATA NOT FOUND. REPEAT BACKSKIP.'
	  EOT = .FALSE.
C		IF DATA IS NOT FOUND WITHIN ONE BACKWARD SKIP, THEN
C		BY DEFINITION THE TAPE IS NOT NEAR THE END.
	  GO TO 2
	  END IF
	IF(IRET.EQ.4) THEN
	  TYPE *,'BEGINNING OF TAPE ENCOUNTERED DURING BACKSKIP.'
	  BOT = .TRUE.
	  TYPE *,'BOT FLAG SET.'
	  RETURN
	  END IF
	IF(IRET.LT.0.OR.IRET.GT.5) THEN
	  TYPE *,'ILLEGAL ERROR CODE FROM MTSKRE =',IRET
	  TYPE *,'PROGRAM ABORTED.'
	  STOP
	  END IF
	IF(NFILES.EQ.0.AND.NRECS.EQ.0.      !INITIAL POSITION PAST DATA
     *  .AND.(IRET.EQ.0.OR.IRET.EQ.1)) PARTF = .TRUE.
	IF((IRET.EQ.0.OR.IRET.EQ.1).AND..NOT.PARTF) THEN
	  TYPE *,'EXPECTED EOF NOT FOUND ON BACKSKIP.'
	  TYPE *,'PROGRAM ABORTED.'
	  STOP
	  END IF
	IF(IRET.EQ.3) THEN
	  IF(PARTF) THEN
	    TYPE *,'UNEXPECTED EOF ENCOUNTERED ON BACKSKIP.'
	    TYPE *,'PROGRAM ABORTED.'
	    STOP
	    END IF
	  CALL STATUSWORD(ID,STWORD,IDENS,TAPELOST,WRENABLE,EOT,EOF,
     *    BOT,EPARITY,IRET)
	  IF(BOT) TYPE *,'TAPE IS POSITIONED AT ITS BEGINNING.'
	  IF(BOT) TYPE *,' '
	  IF(BOT) RETURN
	  END IF
C
	TYPE *,'NEXT SKIP FORWARD ACROSS LAST RECORD.'
3	CALL MTSKRE(ID,1,NDONE,IRET)  !FORWARD SKIP ONE RECORD.
C                                     !TO GET TO END OF DATA.
C
	IF(IRET.EQ.2) THEN
	  TYPE *,'TAPE IS OFFLINE.  TO CONTINUE, PUT IT ONLINE.'
	  PAUSE
	  GO TO 3
	  END IF
	IF(IRET.LT.0.OR.IRET.GE.4) THEN
	  TYPE *,'UNEXPECTED CONDITION ON LAST FORWARD SKIP.'
	  TYPE *,'ERROR CODE FROM MTSKRE =',IRET
	  TYPE *,'PROGRAM ABORTED.'
	  STOP
	  END IF
	IF((IRET.EQ.0.OR.IRET.EQ.1).AND..NOT.PARTF) THEN
	  TYPE *,'EXPECTED EOF NOT FOUND AT END.'
	  TYPE *,'PROGRAM ABORTED.'
	  STOP
	  END IF
	IF(IRET.EQ.3.AND.PARTF) THEN
	  TYPE *,'UNEXPECTED EOF ENCOUNTERED AT END.'
	  TYPE *,'PROGRAM ABORTED.'
	  STOP
	  END IF
C
	TYPE *,'TAPE IS POSITIONED AT THE END OF THE DATA.'
	IF(EOT) TYPE *,'THIS IS AT OR NEAR THE END OF THE TAPE.'
	IF(PARTF) TYPE *,'THERE IS NO END-OF-FILE AT THE END.'
	TYPE *,' '
	RETURN
	END
