CCALL OPENMTIN(ID,1)
	SUBROUTINE OPENMTIN(ID,NFSTART)
C						J.KRISTIAN 1980
C
C SPLIT OFF WORKING PARTS INTO OPENMTIN2, 4/21/83.
C
C OPENS AN INPUT TAPE IN A STANDARD WAY.
C INTERACTIVE: REQUIRES RESPONSE FROM THE USER.
C
C INPUT PARAMETER:
C    NFSTART = THE DESIRED STARTING FILE NUMBER.
C		MUST BE LARGER THAN ZER0; I.E., WILL SPACE THE TAPE
C		FORWARD AFTER OPENING THE DRIVE, BUT NOT BACKWARD.
C
C OUTPUT PARAMETER:
C    ID = THE NUMBER TO BE USED TO IDENTIFY THE TAPE DRIVE
C	    IN SUBSEQUENT CALLS TO MTPCKG SUBROUTINES.
C	IF TAPE IS NOT OPENED DUE TO ILLEGAL FILE NUMBER, RETURNS
C	  ID = -1.
C
	INTEGER*4 ID, NFSTART, NUMBER, IRET
	CHARACTER REPLY*1
C
	IF(NFSTART.LE.0) THEN
	  ID = -1
	  TYPE 7, NFSTART
7	  FORMAT(' OPENMTIN ASKED TO OPEN AN INPUT TAPE AT',
     *    ' ILLEGAL FILE NUMBER:',I5)
	  TYPE *,'IF YOU KNOW WHAT THE CORRECT NUMBER IS, TYPE IT IN,'
	  CALL NEWI4(' OTHERWISE TAPE OPEN WILL BE ABORTED. ',NUMBER)
	  IF(NUMBER.LE.0) RETURN
	  NFSTART = NUMBER
	  END IF
C
	CALL CAPSTRG(' DO YOU WANT THE SYSTEM TO RETRY BAD RECORDS? ',
     *  REPLY)
	RETRY = .TRUE.
	IF(REPLY.NE.'Y') RETRY = .FALSE.
C
6	CALL OPENMTIN3(RETRY,ID,NERROR)
	IF(NERROR.EQ.1) THEN
	  PAUSE
	  RETURN
	  END IF
	IF(NERROR.EQ.2) THEN
C	  TAPE IS OFF-LINE; FORCE USER TO PUT ON-LINE.
	  CALL MTCLOS(ID,IRET)
	  GO TO 6
	  END IF
C
	NFILE = 1 !DEFINES THE INITIAL LOCATION AS FILE 1
	IF(NFSTART.NE.1) THEN
	  TYPE *, 'POSITIONING INPUT TAPE.'
	  CALL SKIPFMT(ID,NFILE,NFSTART)
	  END IF
C
	RETURN
	END
	SUBROUTINE OPENMTIN3(RETRY,ID,NERROR)
C						J.KRISTIAN 9/83
C OPENS AN INPUT TAPE IN A STANDARD WAY.
C INTERACTIVE: REQUIRES RESPONSE FROM THE USER.
C NEARLY IDENTICAL WITH OPENMTIN, EXCEPT RETURNS AN ERROR CODE (NERROR),
C  AND DOES NOT ALLOW FOR THE POSSIBILITY OF MOVING TAPE TO THE
C  BEGINNING OF ANOTHER FILE AFTER OPENING IT.
C
C IDENTICAL WITH OPENMTIN2, WHICH IT IS INTENDED TO SUPPLANT, EXCEPT
C THAT "RETRY" IS PASSED IN INSTEAD OF THE USER BEING QUERIED.
C THE SUBROUTINE "OPENMTIN" WAS CHANGED TO REFLECT THIS, AND AS FAR
C AS I KNOW THAT IS THE ONLY ROUTINE WHICH CALLS THIS ONE.
C
C
C INPUT PARAMETERS:
C
C	RETRY (LOGICAL)
C
C OUTPUT PARAMETERS:
C
C	ID = THE NUMBER TO BE USED TO IDENTIFY THE TAPE DRIVE
C	    IN SUBSEQUENT CALLS TO MTPCKG SUBROUTINES.
C
C	NERROR = ERROR CODE, WITH THE FOLLOWING POSSIBLE VALUES:
C
C	   0 :	DRIVE IS OPENED, TAPE IS POSITIONED AT WHEREVER IT 
C		MAY HAVE BEEN (NOT NECESSARILY AT ITS BEGINNING,
C		NOR EVEN AT THE BEGINNING OF A FILE).
C	   1 :	TAPE DRIVE HAS NOT BEEN OPENED (NO AVAILABLE DRIVE,
C		NO I/O CHANNEL, OR NO EVENT FLAG [WHATEVER THAT MEANS]).
C	   2 :	DRIVE HAS BEEN OPENED OK, BUT TAPE IS OFF LINE.
C		THE DRIVE IS LEFT OPEN, BUT THE USER IS GIVEN NO
C		OPPORTUNITY TO PUT THE TAPE ON-LINE;  THIS MUST BE
C		DONE IN THE CALLING PROGRAM.
C
C
	LOGICAL*1 STATUS(4)
	LOGICAL RETRY
	CHARACTER NAMEMT*15
	INTEGER*4 ID, IRET, NAMELEN
C
	NERROR = 0
	ID = 0
C
	CALL MTOPEN(ID,IRET)
	CALL MTERRMESS('MTOPEN',IRET,6)
	IF(IRET.NE.0) THEN  !DRIVE CAN'T BE OPENED
	  NERROR = 1
	  RETURN
	  END IF
C
	IF(.NOT.RETRY) CALL MTSERM(ID,.TRUE.,IRET)
C
	CALL MTNAME(ID,NAMEMT,NAMELEN,IRET)
	CALL MTERRMESS('MTNAME',IRET,6)
	TYPE *, 'MOUNT THE INPUT TAPE ON ',NAMEMT
	PAUSE
C
6	CALL MTSENS(ID,STATUS,IRET)
C	 POSSIBLE VALUES OF IRET: 1 MEANS I/O ERROR, 2 MEANS TAPE IS
C	 OFF LINE, 3 MEANS TAPE HAS BEEN OFF LINE.
C 	 IT IS LIKELY THAT MTSENS DOES NOT RETURN CORRECT DATA UNTIL
C	 AFTER A READ OR A WRITE.
	CALL MTERRMESS('MTSENS',IRET,6)
	IF(IRET.EQ.1) THEN
	  TYPE *,'I DON''T KNOW WHAT THIS MEANS IN THIS CONTEXT.'
	  CALL BELL
	  PAUSE
	  END IF
	IF(IRET.EQ.2) THEN   !TAPE IS OFF-LINE.
	  NERROR = 2
	  RETURN
	  END IF
C
	I = STATUS(3)
	IF(JIAND(I,8).EQ.0) THEN
	  CALL BELL
	  CALL BELL
	  TYPE 5
5	  FORMAT(' **** WARNING **** THE INPUT TAPE HAS A WRITE RING.')
	  END IF
1	CONTINUE
C
	RETURN
	END
