C**********  PROGRAM TO COPY FILES FROM TAPE TO TAPE  **********
C
C 
C#######################################################################
C
C
C                                                J. KRISTIAN
C                  CHANGED TO FIT INTO CRYM 10/88 BJW
C
C COPIES SELECTED FILES FROM ONE TAPE TO DISK.
C OPERATES  WITH CRYVAX
C
C PROGRAM STRUCTURE:
C    GET LIST OF FILES TO BE COPIED AND OTHER PARAMETERS FROM USER.
C    OPEN THE NECESSARY DATA SETS.
C    FOR EACH FILE IN THE LIST:
C      MOVE INPUT TAPE TO THE START OF THE FILE, IF NECESSARY;
C          COPY THE FILE TO DISK
C      IF END OF TAPE OR END OF DATA IS FOUND, SKIP REST OF LIST.
C    CLOSE THE INPUT TAPE.
C
C PARAMETERS:
C    LIST = USER SUPPLIED LIST OF FILES TO BE COPIED.
C    LISTLEN = NUMBER OF ENTRIES IN LIST, MAX = PARAMETER MAXNFIL.
C    NDRIVES = NUMBER OF DRIVES AVAILABLE  ONLY 1 IN CRYM
C    FIXREC = FLAG.  IF TRUE, ALL RECORDS ARE FORCED TO BE THE
C             SAME LENGTH.
C             THIS WAS INCLUDED TO HANDLE TAPES WRITTEN BY THE
C             CIPHER DRIVES, WHICH HAVE FREQUENT BYTE COUNT ERRORS.
C    FIXLEN = IF FIXREC AND FIXLEN .GT. 0, THEN THE LENGTH OF THE OUTPUT
C             RECORDS, ELSE IF FIXREC AND FIXLEN .LE. 0, THEN THE LENGTH
C             OF THE OUTPUT RECORDS WILL BE THAT OF THE FIRST INPUT RECORD
C             READ.
C    TRUNCB = FLAG.  IF FIXREC AND TRUNCB, THEN LONG INPUT RECORDS WILL BE
C             TRUNCATED AT THE BEGINNING, ELSE IF FIXREC AND NOT TRUNCB,
C             THEN THEY WILL BE TRUNCATED AT THE END.
C    PADZER = FLAG.  IF FIXREC AND PADZER, THEN SHORT INPUT RECORDS WILL
C             BE PADDED WITH ZEROES AT THE END, ELSE IF FIXREC AND NOT PADZER,
C             THEN SHORT RECORDS WILL BE PADDED WITH THE END CONTENTS OF
C             THE PREVIOUS RECORD.
C    PRTMESS = FLAG.   FALSE FOR CRYM
C    TYPMESS = FLAG. FALSE FOR CRYM 
C    MTIN,MTOUT = IDENTIFICATION NUMBERS FOR THE INPUT TAPE AND
C                 THE OUTOUT TAPE FOR USE BY MTPCKG SUBROUTINES.
C    NFOUT = CURRENT FILE NUMBER OF OUTPUT TAPE.  THE TAPE WILL BE
C            POSITIONED AT THE BEGINNING OF THIS FILE AT ANY TIME.
C            SUBROUTINE COPYFILE.
C    NFILE =
C    NLIST =
C    LUDATA = LOGICAL UNIT NUMBER OF THE DISK FILE USED TO STORE
C             THE DATA IF THERE IS ONLY ONE TAPE DRIVE.
C    NEXTF =
C    ENDINPUT =
C 
C#######################################################################
C
C
C**********  LOCAL PARAMETERS  **********
C
      PARAMETER MAXNFIL = 2000
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER LIST(MAXNFIL), LISTLEN, NFILE, NLIST, NDRIVES, FIXLEN
      INTEGER MTIN, MTOUT, LUDATA, LUPRT, NEXTF, NFOUT
      INTEGER IRET, NEXTRA, I
      LOGICAL*1 FIXREC, TRUNCB, PADZER, PRTMESS, ENDINPUT, TYPMESS
C
      CHARACTER*80 CRYMREC
C
C=======================================================================
C
  100 CONTINUE
C
C**********  OBTAIN THE COPY PARAMETERS  **********
C
  200 CONTINUE
      NFILE = 1
      NLIST = 1
C    0CALL INPUT(LIST, MAXNFIL, LISTLEN, NDRIVES, FIXREC, FIXLEN
C    1         , TRUNCB, PADZER, PRTMESS, TYPMESS)
      LISTLEN=1
      NDRIVES=1
      READ(1,1000)CRYMREC       ! READ THE FILE NUMBER FROM CRYM INPUT
1000  FORMAT(A)
      IF (CRYMREC(10:12).EQ.'CAD')THEN
      READ(1,1000)CRYMREC
      DECODE(2,1001,CRYMREC(6:7))NFIN
1001  FORMAT(I2)
      NFIN=NFIN+1
      TYPE *,NFIN
      LIST(NLIST)=NFIN
      ENDIF
     0CALL OPEN (NDRIVES, MTIN, MTOUT, LUDATA, FIXREC, FIXLEN, TRUNCB
     1         , PADZER, PRTMESS, LUPRT, NFOUT)
      CONTINUE
C
C**********  COPY THE TAPE FILES  **********
C
  300 CONTINUE
      NDRIVES=1           ! FOR XRAY ALWAYS ONE DRIVE
      IF(NDRIVES .NE. 0) THEN
          ENDINPUT = .FALSE.
          DO WHILE((.NOT. ENDINPUT) .AND. (NLIST .LE. LISTLEN))
              NEXTF = LIST(NLIST)
              IF(NFILE .NE. NEXTF) THEN
                  TYPE *, 'SKIPPING FILES ON INPUT TAPE.'
                  CALL SKIPFMT(MTIN, NFILE, NEXTF)
              END IF
              NFILE = NEXTF
     0        CALL COPYFILE(NDRIVES, MTIN, MTOUT, LUDATA, NFILE
     1                    , FIXREC, FIXLEN, TRUNCB, PADZER, NLIST
     2                    , PRTMESS, LUPRT, TYPMESS, NFOUT, ENDINPUT)
              CONTINUE
          END DO
C    0    TYPE *, 'THE INPUT TAPE WILL NOW BE UNLOADED ' //
C    1            'UNLESS IT IS TAKEN OFFLINE.'
C         PAUSE
C         CALL MTUNLD(MTIN, IRET)
          CALL MTCLOS(MTIN, IRET)
          IF(NDRIVES .EQ. 1) STOP
C    0        CALL DSKTOMT(LISTLEN, LUDATA, FIXREC, FIXLEN, TRUNCB
C    1                   , PADZER, PRTMESS, LUPRT, TYPMESS, MTOUT)
C         END IF
      END IF
      CONTINUE
C
C**********  TERMINATE THE OUTPUT TAPE  **********
C
  400 CONTINUE
     0TYPE '(/'' HOW MANY EXTRA EOF''''S DO YOU WANT ON THE OUTPUT ' //
     1     'TAPE? '', $)'
      ACCEPT *, NEXTRA
      IF(NEXTRA .GT. 0) THEN
          DO I = 1, NEXTRA
              CALL MTWEOF(MTOUT, IRET)
          END DO
      END IF
C   0TYPE *, 'THE OUTPUT TAPE WILL NOW BE UNLOADED ' //
C    1        'UNLESS IT IS TAKEN OFFLINE.'
C     PAUSE
      CALL MTUNLD(MTOUT, IRET)
      CALL MTCLOS(MTOUT, IRET)
      TYPE *, 'COPYING IS COMPLETE.'
      IF(PRTMESS) THEN
     0    TYPE *, 'THERE IS A PRINTABLE RECORD COUNT IN THE DISK ' //
     1            'FILE, MTCOPY.LIS'
      END IF
      STOP
C
C=======================================================================
C
C
      END
     0SUBROUTINE INPUT (
     1                  LIST
     2                 ,MAXNFIL
     3                 ,LISTLEN
     4                 ,NDRIVES
     5                 ,FIXREC
     6                 ,FIXLEN
     7                 ,TRUNCB
     8                 ,PADZER
     9                 ,PRTMESS
     A                 ,TYPMESS
     Z                 )
C
C
      INTEGER LIST(MAXNFIL)
      INTEGER MAXNFIL
      INTEGER LISTLEN
      INTEGER NDRIVES
      LOGICAL*1 FIXREC
      INTEGER FIXLEN
      LOGICAL*1 TRUNCB
      LOGICAL*1 PADZER
      LOGICAL*1 PRTMESS
      LOGICAL*1 TYPMESS
C
C
C#######################################################################
C
C GETS LIST OF FILES TO BE COPIED AND OTHER INFORMATION FROM USER
C FOR PROGRAM MTCOPY.
C
C INPUT PARAMETERS:
C
C	MAXNFIL = MAXIMUM NUMBER OF FILES ALLOWED (SET IN MAIN).
C
C OUTPUT PARAMETERS:
C
C    LIST = ARRAY CONTAINING THE LIST OF FILES TO BE COPIED.
C    LISTLEN = THE NUMBER OF FILES IN THE LIST.
C    NDRIVES = THE NUMBER OF DRIVES AVAILABLE (ONLY 1 OR 2 ALLOWED).
C    FIXREC = EXECUTION FLAG.  IF TRUE, ALL RECORDS COPIED WILL BE
C             FORCED TO HAVE THE SAME LENGTH.
C    FIXLEN = IF FIXREC IS TRUE, THE FIXED RECORD LENGTH IN BYTES.  IF
C             THIS VALUE IS NOT POSITIVE, THEN THE OUTPUT RECORDS WILL BE
C             FORCED TO BE THE SAME LENGTH AS THE FIRST RECORD READ FROM
C             THE INPUT TAPE.
C    TRUNCB = EXECUTION FLAG.  IF FIXREC AND TRUNCB, THEN LONG INPUT RE-
C             CORDS WILL BE TRUNCATED AT THE BEGINNING.
C    PADZER = EXECUTION FLAG.  IF FIXREC AND PADZER, THEN SHORT INPUT RE-
C             CORDS WILL BE PADDED WITH ZEROES AT THE END.
C    PRTMESS = EXECUTION FLAG.  IF TRUE, MESSAGES GENERATED BY THE
C              PROGRAM WILL BE WRITTEN TO A PRINTABLE DISK FILE.
C    TYPMESS = FLAG.  IF FALSE, ROUTINE MESSAGES WILL NOT BE WRITTEN TO
C              THE TERMINAL AS THE PROGRAM PROCEEDS.  ERROR MESSAGES,
C              HOWEVER, WILL BE WRITTEN TO THE TERMINAL.
C
C#######################################################################
C
C
C**********  LOCAL VARIABLES  **********
C
      CHARACTER REPLY*1
C
C
C=======================================================================
C
  100 CONTINUE
C
C**********  OBTAIN THE FILES TO BE COPIED  **********
C
  200 CONTINUE
      LISTLEN = 0
      DO WHILE(LISTLEN .LE. 0)
     0    TYPE '('' STARTING FROM THE INITIAL POSITION ON THE INPUT ' //
     1         'TAPE AS FILE 1, WHICH FILES DO YOU WANT TO HAVE ' //
     2         'COPIED?'', $)'
          CALL FRLIST(LIST, MAXNFIL, LISTLEN)
          IF(LISTLEN .GT. MAXNFIL) THEN
              TYPE *, 'TOO MANY FILES. MAX NUMBER =', MAXNFIL
              LISTLEN = 0
          END IF
      END DO
      CONTINUE
C
C**********  FIXED LENGTH RECORDS ?  **********
C
  300 CONTINUE
C    0TYPE '('' DO YOU WANT TO FORCE ALL OUTPUT RECORDS TO BE THE ' //
C    1     'SAME LENGTH? '', $)'
C     ACCEPT '(A)', REPLY
      REPLY='N'
      FIXREC = REPLY .EQ. 'Y'
      IF(FIXREC) THEN
          TYPE '('' SAME LENGTH AS THE FIRST? '', $)'
          ACCEPT '(A)', REPLY
          IF(REPLY .EQ. 'Y') THEN
              FIXLEN = 0
          ELSE
              CALL GETI4(' HOW LONG? ', FIXLEN)
              IF(FIXLEN .LE. 0) THEN
     0            TYPE *, 'THE OUTPUT RECORDS WILL BE THE SAME ' //
     1                    'LENGTH AS THE FIRST INPUT RECORD.'
              END IF
          END IF
          TYPE '('' TRUNCATE LONG RECORDS AT THE BEGINNING? '', $)'
          ACCEPT '(A)', REPLY
          TRUNCB = REPLY .EQ. 'Y'
          TYPE '('' PAD SHORT RECORDS WITH ZEROES? '', $)'
          ACCEPT '(A)', REPLY
          PADZER = REPLY .EQ. 'Y'
      END IF
      CONTINUE
C
C**********  OBTAIN THE NUMBER OF TAPE DRIVES  **********
C
  400 CONTINUE
       NDRIVES=1
      CONTINUE
C
C**********  OBTAIN THE OUTPUT FLAGS  **********
C
  500 CONTINUE
      REPLY='N'
      TYPMESS= REPLY .EQ. 'Y'
      REPLY='N'
      PRTMESS = REPLY .EQ. 'Y'
      RETURN
C
C=======================================================================
C
C
      END
     0SUBROUTINE OPEN  (
     1                  NDRIVES
     2                 ,MTIN
     3                 ,MTOUT
     4                 ,LUDATA
     5                 ,FIXREC
     6                 ,FIXLEN
     7                 ,TRUNCB
     8                 ,PADZER
     9                 ,PRTMESS
     A                 ,LUPRT
     B                 ,NFOUT
     Z                 )
C
C
      INTEGER NDRIVES
      INTEGER MTIN
      INTEGER MTOUT
      INTEGER LUDATA
      LOGICAL*1 FIXREC
      INTEGER FIXLEN
      LOGICAL*1 TRUNCB
      LOGICAL*1 PADZER
      LOGICAL*1 PRTMESS
      INTEGER LUPRT
      INTEGER NFOUT
C
C
C#######################################################################
C
C						J. KRISTIAN
C OPENS NECESSARY DATA SETS FOR PROGRAM MTCOPY.
C
C INPUT PARAMETERS:
C
C	NDRIVES = NUMBER OF TAPE DRIVES AVAILABLE.
C		POSSIBILITIES EXPECTED ARE 0, 1 OR 2.
C		VALUES ARE NOT CHECKED.
C	FIXREC, FIXLEN:  THESE ARE ONLY PASSED THROUGH TO THE SUB-
C		ROUTINE DSKTOMT IN THE VERY RARE CASE NDRIVES = 0,
C		OTHERWISE NOT USED IN THIS SUBROUTINE.
C       TRUNCB, PADZER:  SAME AS FOR FIXREC AND FIXLEN, ABOVE.
C	PRTMESS (LOGICAL*1). IF TRUE, DISK FILE MTCOPY.LIS WILL BE
C		OPENED TO RECEIVE OUTPUT MESSAGES.
C
C OUTPUT PARAMETERS:
C
C	MTIN, MTOUT = NUMBERS BY WHICH TO REFER TO THE INPUT AND OUTPUT
C		TAPES IN ANY CALLS TO MTPCKG SUBROUTINES.
C	LUDATA = LOGICAL UNIT NUMBER FOR THE DISK FILE USED FOR
C		TEMPORARY DATA STORAGE IN THE CASE NDRIVES = 1 (OR 0).
C	LUPRT = LOGICAL UNIT NUMBER OF DISK FILE MTCOPY.LIS, TO BE
C		USED FOR WRITING MESSAGES (IF PRTMESS IS TRUE).
C	NFOUT = STARTING FILE OF OUTPUT TAPE (IF NDRIVES =2).
C		VALUE IS GOTTEN INTERACTIVELY FROM USER DURING EXECUTION
C
C#######################################################################
C
C
C**********  LOCAL VARIABLES  **********
C
      CHARACTER DFNAME*20 
      INTEGER NFILES
      INTEGER NFIN
C
C**********  FORMAT STATEMENTS  **********
C
   99 FORMAT(' STARTING FILE OF OUTPUT TAPE?'
     X     / ' (FILE 1 IS ASSUMED TO BE THE INITIAL POSITION.'
     X     / '  TO START AFTER THE LAST DATA ON THE TAPE,'
     X     / '  SPECIFY -1). ', $)
C
C
C=======================================================================
C
  100 CONTINUE
C
C**********  OPEN A MESSAGE FILE IF REQUESTED  **********
C
  200 CONTINUE
      IF(PRTMESS) THEN
          LUPRT = 1
     0    OPEN(UNIT=LUPRT, NAME='MTCOPY.LIS', TYPE='NEW'
     1       , DISP='SAVE')
      END IF
      CONTINUE
C
C********** HANDLE THE SPECIAL CASE, NDRIVES .EQ. 0  **********
C
  300 CONTINUE
      LUDATA = 20
      CONTINUE
C
C**********  OPEN THE INPUT TAPE  **********
C
      NFIN=1

      CALL OPENMTIN(MTIN, NFIN)
C     IF(MTIN .LT. 0) PAUSE
      CONTINUE
C
C**********  OPEN THE OUTPUT MEDIUM  **********
C
  500 CONTINUE
C     IF(NDRIVES .EQ. 1) THEN
     0    OPEN(UNIT=LUDATA, TYPE='NEW'
     1       , FORM='UNFORMATTED', RECORDTYPE='SEGMENTED'
     2       , DISP='SAVE')               ! CHANGE FROM DELETE TO SAVE
C     END IF     IN CRYM VERSION NDRIVES ALWAYS=1
      RETURN
C
C=======================================================================
C
C
      END
     0SUBROUTINE COPYFILE(
     1                    NDRIVES
     2                   ,MTIN
     3                   ,MTOUT
     4                   ,LUDATA
     5                   ,NFILEIN
     6                   ,FIXREC
     7                   ,FIXLEN
     8                   ,TRUNCB
     9                   ,PADZER
     A                   ,NLIST
     B                   ,PRTMESS
     C                   ,LUPRT
     D                   ,TYPMESS
     E                   ,NFILEOUT
     F                   ,ENDINPUT
     Z                   )
C
C
      INTEGER NDRIVES
      INTEGER MTIN
      INTEGER MTOUT
      INTEGER LUDATA
      INTEGER NFILEIN
      LOGICAL*1 FIXREC
      INTEGER FIXLEN
      LOGICAL*1 TRUNCB
      LOGICAL*1 PADZER
      INTEGER NLIST
      LOGICAL*1 PRTMESS
      INTEGER LUPRT
      LOGICAL*1 TYPMESS
      INTEGER NFILEOUT
      LOGICAL*1 ENDINPUT
C
C
C#######################################################################
C
C COPIES ONE COMPLETE FILE FROM THE INPUT TAPE.
C
C INPUT PARAMETERS:
C
C	NDRIVES = NUMBER OF DRIVES AVAILABLE (1 OR 2).
C	MTIN, MTOUT = REFERENCE NUMBERS USED BY SUBROUTINES OF MTPCKG
C	  FOR THE INPUT AND OUTPUT TAPE DRIVES, RESPECTIVELY.
C	  (IF NDRIVES=1, ONLY MTIN IS RELEVANT).
C	LUDATA = LOGICAL UNIT NUMBER OF DISK DATA FILE USED FOR STORING
C	  THE DATA FROM THE INPUT TAPE.  THE DATA WILL LATER BE COPIED
C	  TO THE OUTPUT TAPE IN SUBROUTINE DKSTOMT.  RELEVANT
C	  ONLY IF NDRIVES=1.
C	FIXREC = OPERATION FLAG.  IF TRUE, ALL RECORDS WRITTEN TO THE
C	  THE OUTPUT TAPE WILL BE FORCED TO HAVE THE SAME LENGTH.
C       FIXLEN = LENGTH OF THE OUTPUT RECORDS IF FIXREC IS TRUE.  IF
C         FIXREC AND THIS VALUE IS NOT POSITIVE, THEN ALL OUTPUT RECORDS
C         WILL GIVEN THE SAME LENGTH AS THE FIRST RECORD READ FROM THE
C         INPUT TAPE.
C       TRUNCB = OPERATION FLAG IF FIXREC.  LONG RECORDS WILL BE TRUNCATED
C         AT THE BEGINNING IF TRUNCB IS TRUE, ELSE AT THE END.
C       PADZER = OPERATION FLAG IF FIXREC.  SHORT RECORDS WILL PADDED
C         WITH ZEROES AT THE END IF PADZER IS TRUE, ELSE THE END DATA OF
C         THE PREVIOUS RECORD WILL BE USED.
C	PRTMESS = OPERATION FLAG.  IF TRUE, MESSAGES CONCERNING THE
C	  COPYING WILL BE WRITTEN TO A PRINTABLE DISK FILE.
C	LUPRT = LOGICAL UNIT NUMBER OF DISK FILE IF PRTMESS = .TRUE.
C	TYPMESS = OPERATION FLAG.  IF TRUE, MESSAGES WILL BE TYPED
C	  ON THE TERMINAL.
C
C INPUT/OUTPUT PARAMETERS:
C
C    ON INPUT,
C	NFILEIN = THE CURRENT FILE NUMBER OF THE INPUT TAPE.
C	NLIST = THE SERIAL NUMBER OF THE CURRENT INPUT TAPE FILE IN THE
C	  LIST OF FILES TO BE COPIED.
C	NFILEOUT = CURRENT FILE NUMBER OF OUTPUT TAPE.
C    ON OUTPUT,
C	NFILEIN, NFILEOUT, NLIST ARE ALL INCREMENTED BY 1 IF THE FILE
C	   IS COPIED NORMALLY, OTHERWISE ARE UNCHANGED.
C
C OUTPUT PARAMETERS:
C
C	ENDINPUT = FLAG INDICATING THAT THE END OF THE INPUT TAPE HAS
C	  BEEN REACHED, EITHER BECAUSE THE END-OF-TAPE MARK WAS FOUND,
C	  OR BECAUSE THE TAPE HAS NOTHING MORE WRITTEN ON IT.
C
C INTERNAL PARAMETERS:
C
C	IRDERR = ERROR RETURN FROM READ OF INPUT TAPE. 0 MEANS NO ERROR,
C	  1 MEANS I/O ERROR, 2 MEANS TAPE DRIVE IS OFF LINE,
C	  3 MEANS END-OF-FILE, 4 MEANS END-OF-TAPE, 5 MEANS END OF DATA.
C	IWRERR = ERROR RETURN FROM WRITE TO OUTPUT TAPE.
C	IEOFERR = ERROR RETURN FROM WRITING EOF ON OUTPUT TAPE.
C	LREC1 = THE LENGTH OF THE FIRST RECORD ON THE INPUT TAPE.
C
C LOGICAL STRUCTURE:
C
C	TRY TO READ A RECORD FROM THE INPUT TAPE (CALL MTREAD)
C	IF THE RECORD IS A NOISE RECORD, READ THE NEXT RECORD.
C	IF THE RECORD IS OK OR HAS AN I/O ERROR, THEN:
C	  WRITE THE RECORD TO DISK (1 DRIVE) OR TAPE (2 DRIVES);
C	  READ THE NEXT RECORD AND REPEAT.
C	IF THE INPUT TAPE IS OFFLINE, TRY AGAIN.
C	IF THE END-OF-TAPE MARK IS REACHED, OR THE TAPE IS BLANK,
C	  SET THE ENDINPUT FLAG AND WRITE AN EOF ON THE OUTPUT
C	IF AN END-OF-FILE IS REACHED, WRITE IT ON THE OUTPUT FILE,
C	  INCREMENT NFILEIN, NFILEOUT AND NLIST BY 1.
C
C#######################################################################
C
C
C**********  LOCAL VARIABLES  **********
C
      LOGICAL*1 BUFFER(65535)
      INTEGER NREC, LREC1
      INTEGER LENGTH, IRDERR
      INTEGER NWRITE, I, J, NOUT, IWRERR
      INTEGER IEOFERR
C
C
      DATA LREC1 /0/  !WILL BE SET TO THE LENGTH OF THE FIRST RECORD.
C
C**********  FORMAT STATEMENTS  **********
C
   99 FORMAT(X, I6, ' BYTES READ FROM FILE', I4, ', RECORD', I5)
   98 FORMAT(X, I6, ' BYTES COPIED FROM FILE', I4, ' TO FILE'
     X     , I4, ' RECORD', I5)
   97 FORMAT(X, I6, ' BYTES FROM FILE', I4, ' COPIED AS', I6
     X     , ' BYTES TO FILE', I4, ' RECORD', I5)
   96 FORMAT(' AN END-OF-FILE WILL BE WRITTEN ON THE OUTPUT TAPE.')
C
C
C=======================================================================
C
  100 CONTINUE
C
C**********  COPY ONE FILE  **********
C
  200 CONTINUE
      ENDINPUT = .FALSE.
      NREC = 0
      IRDERR = 0
      DO WHILE((IRDERR .EQ. 0) .OR. (IRDERR .EQ. 1))
          LENGTH = 0
          IRDERR = 1
          DO WHILE((LENGTH .LE. 12) .AND. (IRDERR .EQ. 1))
              CALL MTREAD(MTIN, 65535, BUFFER, LENGTH, IRDERR)
          END DO
          CALL MTERRMESS('MTREAD', IRDERR, 6)
          IF(PRTMESS) CALL MTERRMESS('MTREAD', IRDERR, LUPRT)
          IF((IRDERR .EQ. 0) .OR. (IRDERR .EQ. 1)) THEN  
              IF(LREC1 .EQ. 0) LREC1 = LENGTH
              IF(FIXREC) THEN
                  IF(FIXLEN .LE. 0) THEN
                      NWRITE = LREC1
                  ELSE
                      NWRITE = FIXLEN
                  END IF
                  IF((NWRITE .GT. LENGTH) .AND. PADZER) THEN
                      DO I = LENGTH + 1, NWRITE
                          BUFFER(I) = 0
                      END DO
                  ELSE IF((NWRITE .LT. LENGTH) .AND. TRUNCB) THEN
                      J = LENGTH - NWRITE
                      DO I = 1, NWRITE
                          BUFFER(I) = BUFFER(I + J)
                      END DO
                  END IF
              ELSE
                  NWRITE = LENGTH
              END IF
              NREC = NREC + 1
              IF(NDRIVES .EQ. 1) THEN
                  IF(TYPMESS) TYPE 99, LENGTH, NFILEIN, NREC
                  IF(PRTMESS) WRITE(LUPRT, 99) LENGTH, NFILEIN, NREC
                  WRITE(LUDATA) NWRITE, (BUFFER(I), I = 1, NWRITE)
              ELSE ! IF(NDRIVES .EQ. 2) THEN
                  IWRERR = 2
                  DO WHILE((IWRERR .EQ. 2) .OR. (IWRERR .EQ. 3))
                      CALL MTWRIT(MTOUT, NWRITE, BUFFER, NOUT, IWRERR)
                      CALL MTERRMESS('MTWRIT', IWRERR, 6)
                      IF(PRTMESS) THEN
                          CALL MTERRMESS('MTWRIT', IWRERR, LUPRT)
                      END IF
C                     IF(IWRERR .NE. 0) PAUSE
                  END DO
                  IF(LENGTH .EQ. NOUT) THEN
                      IF(TYPMESS) THEN
                          TYPE 98, LENGTH, NFILEIN, NFILEOUT, NREC
                      END IF
                      IF(PRTMESS) THEN
     0                    WRITE(LUPRT, 98) LENGTH, NFILEIN, NFILEOUT
     1                                   , NREC
                      END IF
                  ELSE
                      IF(TYPMESS) THEN
                          TYPE 97, LENGTH, NFILEIN, NOUT, NFILEOUT, NREC
                      END IF
                      IF(PRTMESS) THEN
     0                    WRITE(LUPRT, 97) LENGTH, NFILEIN, NOUT
     1                                   , NFILEOUT, NREC
                      END IF
                  END IF
              END IF
          ELSE IF(IRDERR .EQ. 2) THEN  !TAPE IS OFFLINE.
C             PAUSE
              IRDERR = 0
          END IF
      END DO
      CONTINUE
C
C**********  ANALYZE THE TERMINATION STATUS  **********
C
  300 CONTINUE
      IF((IRDERR .EQ. 4) .OR. (IRDERR .EQ. 5)) THEN
          ENDINPUT = .TRUE.
          IF(NREC .EQ. 0) RETURN  !THE LAST FILE WRITTEN HAS AN EOF.
          TYPE 96
          IF(PRTMESS) WRITE(LUPRT, 96)
      END IF
      IF((IRDERR .EQ. 3) .OR. ENDINPUT) THEN  !WRITE EOF
          IF(NDRIVES .EQ. 1) THEN
              ENDFILE LUDATA
          END IF
          IF(.NOT. ENDINPUT) THEN
              NFILEIN = NFILEIN + 1
              NFILEOUT = NFILEOUT + 1
              NLIST = NLIST +1
          END IF
      END IF
      RETURN
C
C=======================================================================
C
C
      END
