$ ver := 'f$verify(0)'
$ set noon
$!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
$!
$! Command file to define the symbol "NEXTJOB" to the entry number
$! of the next "HOLD"ing job owned by the current user in the
$! current queue.
$!
$! USAGE TEMPORARILY VOIDED ON KIRBY
$! Use:		$ @PUB:NEXTJOB queue_name
$!
$! where "queue_name" is the name of the queue to look for the job
$! (if the "queue_name" isn't specified: for batch jobs, the current 
$! queue is used; otherwise SYS$BATCH is used.)
$!
$! Written	18-Mar-83	
$! Modified	 4-Apr-83	
$! Modified	22-Jul-85       Also releases device queue jobs
$! Modified	19-Aug-85	Checks time of job submitted to
$!				find nextjob to release
$!
$!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
$ user := 'f$getjpi(0,"USERNAME")'
$ open/error=makedir f scr01:[s]'user'.dir
$ close f
$ goto dirok
$ makedir: create/directory/nolog sys$scratch
$ dirok:
$ if "''quenam'".eqs."" then quenam :==
$ queue :=
$ if "''f$mode()'".nes."BATCH" then queue := sys$batch
$ if "''p1'".nes."" then queue := 'p1'
$ if queue.eqs."" then queue := 'quenam'
$ nextj = 99999
$ nextjob = 99999
$ bestime := 'f$cvtime(f$time())'
$!
$! Wants the default queue (current queue)
$!
$ if queue.nes."" then goto gotque
$ assign/user sys$login:quesrch_'f$getjpi(0,"PID")'.tmp sys$output
$ where/batch/pid/nointer/nouser/noterm/notype/noimage/nocpu
$ open f sys$login:quesrch_'f$getjpi(0,"PID")'.tmp
$ read f inl
$ rdlp0: read/end=edlp0 f inl
$ if "''f$extract(0,8,inl)'".nes."''f$getjpi(0,"PID")'" then goto rdlp0
$ queue := 'f$extract(f$locate("Queue",inl)+6,16,inl)'
$ queue := 'f$extract(0,f$locate(" ",queue),queue)'
$ edlp0: close f
$ delete/nolog/noconf sys$login:quesrch_'f$getjpi(0,"PID")'.tmp;
$ if queue.eqs."" then queue := sys$batch
$ quenam :== 'queue'
$!
$! Make a listing of jobs in the queue
$!
$ gotque:
$ assign/user sys$login:quesrch_'f$getjpi(0,"PID")'.tmp sys$output
$ show queue/full 'queue'
$ open inp sys$login:quesrch_'f$getjpi(0,"PID")'.tmp
$!
$! Look for the next HOLDing job own by this username
$!
$ read/end=edlp inp inline
$!
$! Check first line to get the current queue status (stopped/started)
$!
$ if 'f$locate(" queue ",inline)'.eq.'f$length(inline)' then goto -
  notquenam
$ questop := n
$ if 'f$locate("stopped",inline)'.ne.'f$length(inline)' then -
  questop := y
$ smrdlp: read/end=edlp inp inline
$ if inline.nes."" then goto smrdlp
$ read/end=edlp inp inline
$ read/end=edlp inp inline
$!
$ rdlp: read/end=edlp inp inline
$!
$! This line should have the date / time job was submitted
$!
$ notquenam: if "''f$extract(6,1,inline)'" .nes. " " then goto headln
$ if nextj.eq.99999 then goto rdlp
$ if "''f$extract(8,11,inline)'" .nes. " Submitted " then goto rdlp
$ time := 'f$cvtime(f$extract(19,23,inline))'
$ if "''time'".lts."''bestime'" then nextjob = nextj
$ if time.eqs.bestime.and.'nextj'.lt.'nextjob' then nextjob = nextj
$ if time.lts.bestime then bestime := 'time'
$ nextj = 99999
$ goto rdlp
$!
$! This line has the Jobname, Username, Entry Number, and Status
$!
$ headln: if  -
  "''f$extract(46,7,inline)'".nes."Holding" then goto rdlp
$ tst := 'f$extract(25,12,inline)'
$ if user.nes.tst then goto rdlp
$!
$! We found the next job, get its number
$!
$ nextj = 'f$extract(2,5,inline)'
$ goto rdlp
$ edlp: close inp
$ delete/nolog/noconf sys$login:quesrch_'f$getjpi(0,"PID")'.tmp;*
$ if nextjob.ne.99999 then goto subnexjob
$!
$! Couldn't find a HOLDing job owned by this user
$!
$ write sys$output "%NEXTJOB-I-NOJOB, no holding jobs in queue ''queue'"
$ if ver then set verify
$ exit 3
$!
$! Release the nextjob
$!
$ subnexjob: set queue/entry='nextjob'/release/after=-- 'queue'
$ write sys$output -
  "%NEXTJOB-I-JOBREL, job ''nextjob' released from queue ''queue'"
$ if questop then write sys$output -
  "-NEXTJOB-W-QUESTOP, queue ''queue' is stopped"
$ if ver then set verify
$ exit 1
