      SUBROUTINE ORABS
C	ABSORPTION FOR THE VAX
C     3-DIMENSIONAL, DIFFRACTOMETER DATA                                00000050
C     MODIFIED FROM 'ORABS' PROGRAM.                                    00000070
C     also includes correction based on psi scans
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD,JPAGE,IIT1,IIT2,CX,CY,
     1CZ,ADI,TQ
      COMMON/FNAME/NFILE,NAMLEN
      INCLUDE '($RMSDEF)'
      INTEGER*4 FILESTAT, STATUS
      INTEGER*2 ID,IDHKL(4)
      REAL*4 INT,INTCOR,INTABS,INTMIN(36),INTMAX(36)
      CHARACTER*2 NVERS(10)
      CHARACTER*3 IN,OUT,BLNK,LIST
      CHARACTER*7 notheta
      CHARACTER*16 NFILE,NFILE2
      CHARACTER*80 INFC
      DIMENSION REAL(13),T(12),R(8),U(8),DATA(7500),CARD(20),IDCF(8),
     1TAPE(31),CX(150),CY(150),CZ(150),ADI(150),TQ(150),DATMIN(36),
     2DATMAX(36),IDMIN(36),K1MIN(36),K2MIN(36),TTHMIN(36),PHIMIN(36),
     3CHIMIN(36),OMEMIN(36),SIGMIN(36),FCRMIN(36),DCRMIN(36),SIMIN(36),
     4IDMAX(36),K1MAX(36),K2MAX(36),K3MAX(36),TTHMAX(36),CHIMAX(36),
     5PHIMAX(36),OMEMAX(36),SIGMAX(36),FCRMAX(36),DCRMAX(36),SIMAX(36),
     6K3MIN(36)
c       use in linear interpolation to find number abscor*int=intcor
c       phi correction input      abscor*sig=sigcor
      dimension cphi(73),tphi(73)        
      EQUIVALENCE (CARD(13),IDCF(1)),(KI1,T(1),TAPE(1)),
     1(KI2,TAPE(2)),(KI3,TAPE(3)),(THET,TAPE(24)),(PHI,TAPE(25)),
     2(CHI,TAPE(26)),(OMEG,TAPE(27)),(FO,TAPE(4)),(WT,TAPE(5))
      EQUIVALENCE(TAPE(13),R(1)),(TAPE(21),U(1))
C     EQUIVALENCE(REAL(5),SPEED),(real(13),abscor),(real(2),phi)
C this ATT ought to be in common 
      logical thetadep
      PARAMETER ATT=20.9
      DATA BLNK/'   '/
      NS=7500
      thetadep=.true.
C
C Initialization for all types of absorption correction.
C
      NFILE2(1:NAMLEN)=NFILE(1:NAMLEN)
      I=NAMLEN+1
      NFILE2(I:I+3)='.INF'  ! HAVE AN INF FILE?
      IINF=0
C  BJW APR293  OPEN(NAME=NFILE2,UNIT=27,TYPE='OLD',FORM='FORMATTED',ERR=9019)
      STATUS=FILESTAT(NFILE2)
      IF(STATUS.EQ.RMS$_NORMAL.OR.STATUS.EQ.RMS$_FLK)IINF=1
      IF(IINF.EQ.0)WRITE(3,9019)
9019  FORMAT('   INF FILE DOES NOT EXIST OR CANNOT BE OPENED')
C  IF INF EXISTS,IINF=1 AND IT WILL BE OPENED IN ADDON
      NFIL=1
      ILIST=0
      DECODE(80,501,CARD)NVERS
C  READING TITLE CARD - INCLUDES VERSION NUMBERS OF MAG FILES IF ANY
501   FORMAT(22X,10A2)
      DO I=1,10
      IF(NVERS(I).EQ.'  ')GOTO 503
      ENDDO
503   NFIL=I-1
C  NFIL IS NUMBER OF MAG FILES ENTERED
C  nfl is current mag file so nfil=0 is no problem
      DO 497 I=1,36
      DATMIN(I)=100.
497   DATMAX(I)=0.0
      ABSMIN=1000.  ! MIN ABS COEF. FOR RANGE
      ABSMAX=0.0    ! MAX ABS COEF. FOR RANGE
      corf=1.
C     READ CONSTANTS
C                        INITIALIZE
      NFL=1
1001  FORMAT(a4,I4,F10.6,A3,A3,3X,A3,f10.2,2x,a7)
      READ(1,1001) method,N,VMU,IN,OUT,LIST,phioff,notheta
C   NVERS IS THE VERSION NUMBER OF THE MAG FILE TO BE USED
C  for gaussian (meth=1,con) N is number of faces
C  for psi (meth=2,psi) N is number of points (default=37)
C  IF LIST IS NONBLANK, UPDATED REFLECTIONS WILL BE LISTED
C  IF OUT IS BLANK, NO UPDATED INFORMATION WILL BE STORED, IF NONBLANK,
C  UPDATED INFORMATION WILL BE STORED ON THAT FILE.
C  Phioff is a phi offset. This number is added to the actual phi
c   value. It can be Phi(cad4) minus Phi(P1bar).
c  Thetadep true (default) means use theta dependence of psi scan
c   Set thetadep false with N in col 43 on PSI cad
      IF(LIST.NE.BLNK)ILIST=1  ! ILIST=1 FOR OUTPUT OF ALL REFLECTIONS
      IF(ILIST.EQ.0)WRITE(3,1011)
1011  FORMAT(' NO LISTING OF UPDATED REFLECTIONS.')
      if (notheta(1:1).eq.'N') thetadep=.false.
      IF(OUT.NE.BLNK)THEN
        IF(OUT.EQ.IN)GO TO 300
        IF(OUT(1:1).EQ.'C')GO TO 300
        WRITE(3,1000)IN,OUT
1000   FORMAT('  YOU CAN NOT HAVE A ',A3,' FILE AS INPUT AND A ',A3,
     + ' FILE AS CORRECTED OUTPUT.',/,'  UNLESS YOUR CORRECTED OUTPUT',
     + ' IS A CRD FILE, THE INPUT AND OUTPUT FILE TYPE MUST BE THE '
     + 'SAME.')
        RETURN
      ENDIF
300   IF(IN(1:1).eq.'M') then
C       INPUT FROM MAG FILE - RETRIEVE FILE NAME FROM SYSTEM
502     NAM=NAMLEN+1
        NFILE(NAM:NAM+4)='.MAG;'
        NAM=NAM+5
        IF(NVERS(NFL).NE.'  ')NFILE(NAM:NAM+1)=NVERS(NFL)
        WRITE(3,3144)NFILE
3144    FORMAT(' MAG FILE USED: ',A16)
        OPEN(NAME=NFILE,UNIT=13,TYPE='OLD',FORM='UNFORMATTED',
     1   BLOCKSIZE=32768)
        NFILE(NAM:NAM+1)='  '
        OPEN(NAME=NFILE,UNIT=20,TYPE='NEW',FORM='UNFORMATTED',
     1   BLOCKSIZE=32768)
        IF(NFL.GT.1)GOTO 7004
      endif
      meth=1
      if (method.eq.'PSI ') meth=2
      if (method.eq.'PSI1') meth=3
      goto (108,109,110) meth
C
C  NFL IS CURRENT MAG FILE NUMBER
C
C     Default here on 'constants' for gaussian quadrature
C     INITIALIZE FOR GAUSSIAN QUADRATURE                                00000180
C     M(=THE NUMBER OF GAUSSIAN POINTS) IS ASSUMED TO BE 8.             00000190
C       'U' CONTAINS GAUSSIAN POINTS, 'R' CONTAINS WEIGHTS.             00000200
  108 M=8                                                               00000220
      U(1)=.01985507                                                    00000230
      U(2)=.10166676                                                    00000240
      U(3)=.23723380                                                    00000250
      U(4)=.40828268                                                    00000260
      R(1)=.05061427                                                    00000270
      R(2)=.11119052                                                    00000280
      R(3)=.15685332                                                    00000290
      R(4)=.18134189                                                    00000300
      DO 9001 I=5,8                                                     00000310
      J=9-I                                                             00000320
      R(I)=R(J)                                                         00000330
 9001 U(I)=1.0-U(J)                                                     00000340
      NCOF=1                                                            00000400
      CALL FACE (N,DATA,NCOF)                                     
      EPS1=.000005                                                      00000420
      I1=NS-6*N-12                                                      00000430
      NP=I1/(M*(N+1))                                                   00000440
      I2=M**2                                                           00000450
  316 IF (MOD(I2,NP)) 318,312,318                                       00000460
  318 NP=NP-1                                                           00000470
      GO TO 316                                                         00000480
  312 IF (NP) 8313,8313,311                                             00000490
  311 IF (I1-NP*M*(N+1)-2*N) 318,318,313                                00000500
  313 NB=I2/NP                                                          00000510
      NEND=4*N                                                          00000520
      NUM=NEND+1                                                        00000530
      NUMED =NP*M*(N+1)+NEND                                            00000540
      IDIF1=NUMED+1                                                     00000550
      IDIF2=IDIF1+N                                                     00000560
      IX=IDIF2+N                                                        00000570
C                                                                       00000580
C     DETERMINE COEFFICIENTS OF CORNERS AND REPORT                      00000590
C                                                                       00000600
C     CALCULATE A,B,B-A                                                 00000610
C                                                                       00000620
      IF (NB-1) 7006,7006,7007                                          00000630
 7007 REWIND 5                                                          00000640
      WRITE (3,2009)                                                    00000650
7006	CONTINUE	! WAS CALL TO TDAT (CARD(16))
      IF(ILIST.NE.0)WRITE (3,1002) IDCF
      WRITE (3,2001)                                                    00000680
      NCNR=0                                                            00000690
   60 A=10.3E37                                                         00000700
      B=-A                                                              00000710
      IZ=N-2                                                            00000720
      DO 27 IP=1,IZ                                                     00000730
      IP1=IP+1                                                          00000740
      IY=N-1                                                            00000750
      DO 26 IQ=IP1,IY                                                   00000760
      IQ1=IQ+1                                                          00000770
      DO 54 IR=IQ1,N                                                    00000780
      I1=4*IP-3                                                         00000790
      DO 24 K=1,12,3                                                    00000800
      T(K)=DATA(I1)                                                     00000810
   24 I1=I1+1                                                           00000820
      I1=4*IQ-3                                                         00000830
      DO 23 K=1,12,3                                                    00000840
      T(K+1)=DATA(I1)                                                   00000850
   23 I1=I1+1                                                           00000860
      I1=4*IR-3                                                         00000870
      DO 22 K=1,12,3                                                    00000880
      T(K+2)=DATA(I1)                                                   00000890
   22 I1=I1+1                                                           00000900
      CALL GAUSOL(T,3)                                                  00000910
      IF (IS3) 54,69,54                                                 00000920
   69 DO 28 K=NCOF,NEND,4                                               00000930
      IF (DATA(K)*T(10)+DATA(K+1)*T(11)+DATA(K+2)*T(12)-DATA(K+3)+EPS1) 00000940
     154,28,28                                                          00000950
   28 CONTINUE                                                          00000960
      IF (A-T(10)) 50,50,51                                             00000970
   51 A=T(10)                                                           00000980
   50 IF (T(10)-B) 52,52,53                                             00000990
   53 B=T(10)                                                           00001000
   52 WRITE (3,2002) IP,IQ,IR,T(10),T(11),T(12)                         00001010
      NCNR=NCNR+1                                                       00001020
      CX(NCNR)=T(10)                                                    00001030
      CY(NCNR)=T(11)                                                    00001040
      CZ(NCNR)=T(12)                                                    00001050
   54 CONTINUE                                                          00001060
   26 CONTINUE                                                          00001070
   27 CONTINUE                                                          00001080
   57 DIF1=B-A                                                          00001090
      IF (DIF1) 56,56,55                                                00001100
   55 WRITE (3,1006) A,B                                                00001110
C                                                                       00001120
C     SET UP 'X' INTERVALS AND ITERATE                                  00001130
C                                                                       00001140
      V=0.0                                                             00001150
      NP1=NP                                                            00001160
      K1=NUM                                                            00001170
      DO 107 I=1,M                                                      00001180
      X=A+DIF1*U(I)                                                     00001190
      WX=R(I)*DIF1                                                      00001200
      I2=IDIF1                                                          00001210
      DO 70 I1=NCOF,NEND,4                                              00001220
      DATA(I2)=DATA(I1+3)-DATA(I1)*X                                    00001230
   70 I2=I2+1                                                           00001240
C                                                                       00001250
C     CALCULATE C,D,D-C                                                 00001260
C                                                                       00001270
      C=10.0E37                                                         00001280
      D=-C                                                              00001290
      DO 71 IP=1,IY                                                     00001300
      IP1=IP+1                                                          00001310
      DO 76 IQ=IP1,N                                                    00001320
      I1=4*IP-2                                                         00001330
      DO 73 K=1,4,3                                                     00001340
      T(K)=DATA(I1)                                                     00001350
   73 I1=I1+1                                                           00001360
      I1=4*IQ-2                                                         00001370
      DO 74 K=1,4,3                                                     00001380
      T(K+1)=DATA(I1)                                                   00001390
   74 I1=I1+1                                                           00001400
      I1=IDIF1+IP-1                                                     00001410
      T(7)=DATA(I1)                                                     00001420
      I1=IDIF1+IQ-1                                                     00001430
      T(8)=DATA(I1)                                                     00001440
      CALL GAUSOL(T,2)                                                  00001450
      IF (IS3) 76,68,76                                                 00001460
   68 I2=IDIF1                                                          00001470
      DO 75 I1=NCOF,NEND,4                                              00001480
      IF (DATA(I1+1)*T(7)+DATA(I1+2)*T(8)-DATA(I2)+EPS1) 76,75,75       00001490
   75 I2=I2+1                                                           00001500
      IF (C-T(7)) 77,77,78                                              00001510
   78 C=T(7)                                                            00001520
   77 IF (T(7)-D) 76,76,79                                              00001530
   79 D=T(7)                                                            00001540
   76 CONTINUE                                                          00001550
   71 CONTINUE                                                          00001560
      DIF2=D-C                                                          00001570
      IF (DIF2) 72,72,80                                                00001580
   80 WRITE (3,1007) C,D,X                                              00001590
C                                                                       00001600
C     SET 'Y' INTERVALS AND DETERMINE 'Z'S                              00001610
C                                                                       00001620
      DO 91 J=1,M                                                       00001630
      Y=C+DIF2*U(J)                                                     00001640
      WY=WX*DIF2*R(J)                                                   00001650
      I2=IDIF1                                                          00001660
      I3=IDIF2                                                          00001670
      DO 90 I1=NCOF,NEND,4                                              00001680
      DATA(I3)=DATA(I2)-DATA(I1+1)*Y                                    00001690
      I2=I2+1                                                           00001700
   90 I3=I3+1                                                           00001710
      E=10.0E37                                                         00001720
      F=-E                                                              00001730
      I3=IDIF2                                                          00001740
      DO 93 I1=NCOF,NEND,4                                              00001750
      IF (DATA(I1+2)) 92,93,92                                          00001760
   92 Z=DATA(I3)/DATA(I1+2)                                             00001770
      I4=IDIF2                                                          00001780
      DO 94 I2=NCOF,NEND,4                                              00001790
      IF (DATA(I2+2)*Z-DATA(I4)+EPS1) 93,94,94                          00001800
   94 I4=I4+1                                                           00001810
      IF (E-Z) 96,96,97                                                 00001820
   97 E=Z                                                               00001830
   96 IF (Z-F) 93,93,98                                                 00001840
   98 F=Z                                                               00001850
   93 I3=I3+1                                                           00001860
      DIF3=F-E                                                          00001870
      IF (DIF3) 99,99,100                                               00001880
  100 WY=WY*DIF3                                                        00001890
      DO 101 K=1,M                                                      00001900
      Z=E+DIF3*U(K)                                                     00001910
      I2=IDIF2                                                          00001920
      DO 102 I1=NCOF,NEND,4                                             00001930
      DATA(K1)=DATA(I2)-DATA(I1+2)*Z                                    00001940
      IF (DATA(K1)) 103,103,104                                         00001950
  104 DATA(K1)=0.0                                                      00001960
  103 K1=K1+1                                                           00001970
  102 I2=I2+1                                                           00001980
      DATA(K1)=WY*R(K)                                                  00001990
      V=V+DATA(K1)                                                      00002000
  101 K1=K1+1                                                           00002010
      IF (NB-1) 91,91,7002                                              00002020
 7002 NP1=NP1-1                                                         00002030
      IF (NP1) 105,105,91                                               00002040
  105 WRITE (5) (DATA(I1),I1=NUM,NUMED)                                 00002050
      K1=NUM                                                            00002060
      NP1=NP                                                            00002070
   91 CONTINUE                                                          00002080
  107 CONTINUE                                                          00002090
      WRITE (3,2093)V                                                   00002100
      IF(IN(1:1).EQ.'M')THEN
        CORF=-((V/4.*3./3.14159)**(1./3.))
        WRITE(3,1073)CORF
1073    FORMAT(' INTCOR AND SIG(INT) HAVE BEEN MULTIPLIED BY EXP(',
     1  E12.6,' * MU)/TRANS')
        CORF=EXP(CORF*VMU)
      ENDIF
      IF (NB-1) 7004,7004,7005                                          00002110
 7005 REWIND 5                                                          00002120
C
C End of setup for gaussian quadrature.
C                                                                       00002130
C                                                                       00002170
C PSI SCAN INTERPOLATION - method =  PSI    setup
  109 ang=0.0
      delt=360./float(n)
      do I=1,N+1
      TPHI(I)=ANG
      ang=ang+delt
      enddo
c   read in values at phi=0,360 here 
  114 i=1
      j=6
  115 read(1,116)(cphi(ii),ii=i,j)
  116 format(4x,6(f5.4,1X))
      write(3,117)(cphi(ii),ii=i,j)
  117 FORMAT(4X,' CORRECTION=',6(1X,F7.4))
      i=i+6
      j=j+6
      if(i.gt.n) goto 118
      if(j.gt.n) j=n
      goto 115
  118 cphi(N+1)=cphi(1)    
      goto 7004
c
c
c     setup for PSI1 function 
c     y=a1*(1.-a2*exp(-a3*|cos(x+a4)|))
C
  110 rad=0.017453293                                                
      read(1,119)a1,a2,a3,a4
  119 format(4f9.4)
      write(3,120)a1,a2,a3,a4
  120 format('  a1=',f8.4,'  a2=,'f8.4,'  a3=',f8.4,'  a4=',f8.4)
      goto 7004
c
c
c
c
C
C     INITIAL CALCULATIONS COMPLETE.                                    00002140
C                                                                       00002150
C     REFLECTION INPUT                                                  00002160
C     
C
 7004 NLINES=0                                                          00002180
      NCR=0                                                             00002190
      NTEST=0                                                           00002200
      K1=N+1                                                            00002210
C      IF (CARD(13)-CARD(12)) 7012,7010,7012                             00002220
C 7010 IF (CARD(14)-CARD(12)) 7012,7011,7012                             00002230
C 7011 NTEST=1                                                           00002240
7012  CONTINUE
       IF(IN(1:1).EQ.'M')GO TO 9000       ! INPUT IS A MAG FILE
      IF(IN(1:1).EQ.'C')GO TO 7024        ! INPUT IS A CRD FILE
 7013 REWIND IIT1                        ! INPUT IS A HKL FILE       
      REWIND IIT2                                                       00002270
      READ (IIT1) TAPE                                                  00002280
      WRITE (IIT2) TAPE                                                 00002290
      READ (IIT1) TAPE                                                  00002300
      WRITE (IIT2) TAPE                                                 00002310
 7015 READ (IIT1) TAPE                                                  00002320
      WRITE (IIT2) TAPE                                                 00002330
      IF (KI1) 7015,7018,7015                                           00002340
 7018 READ (IIT1) TAPE                                                  00002350
      IF (KI1-999999) 7038,436,7038                                     00002360
 7024 READ (1,1005) KI1,KI2,KI3,FO,WT,THET,PHI,CHI
      IF (THET) 7038,444,7038          ! 444 MEANS ALL DONE       
C7030 IF (NTEST) 7038,7032,7038                                         00002390
C 7032 IF (TAPE(22)-CARD(13)) 7035,7033,7035                             00002400
C 7033 IF (TAPE(23)-CARD(14)) 7035,7038,7035                             00002410
C 7035 IF (ITAPE) 7024,404,7018                                          00002420
9000  READ(13)IDHKL,THET,PHI,CHI,RANGE,SPEED,BG1,SCAN,BG2,EXPTM,
     1TBTS,INTCOR,SIGCOR,BLANK
c      WRITE(3,7032) IDHKL,CHI,PHI
c7032  FORMAT(/' IDHKL= '4I4'   CHI='F7.2'   PHI='F7.2)
C
      ID=IDHKL(1)
      KI1=IDHKL(2)
      KI2=IDHKL(3)
      KI3=IDHKL(4)
      IF(ID.EQ.0)GOTO 9444 ! LAST REFLECTION ON MAG FILE HAS ID=0
      IF(SPEED.LT.0.0)GOTO 9000
C  DELETED REFLECTIONS MARKED WITH NEGATIVE SCAN SPEED - SKIP
      GO TO 7038
C
C
C
C     CALCULATE ABSORPTION FACTOR                                       00002440
7038  continue
      goto (111,112,113) meth      
C
  111 OMEG=0.0
C     why is omeg=0??????? bisecting mode omega=theta
      if (sigcor.eq.-1.) then 
       omeg=intcor - 0.5*thet
      endif
C attempt to fix corrections for non-bisecting mode
C omega has been stored in real(12)==intcor by nonius
Caution: 2background will overwrite this
c 
      CALL ANGLE (DATA,THET,PHI,CHI,OMEG,IX)                            000
c      WRITE(3,7033) IX,CHI,PHI,(DATA(IQQ),IQQ=IX+1,IX+6)
c7033  FORMAT(' IX='I5,'  CHI='F7.2'  PHI='F7.2,
c     1 /' DATA=' 6F8.4)
      ABSCOR=0.0                                                           00002470
      DO 201 I1=1,NB                                                    00002480
      IF (NB-1)7001,7001,7003                                           00002490
 7003 READ (5)(DATA(I2),I2=NUM,NUMED)                                   00002500
 7001 I2=IX                                                             00002510
      I9=IDIF1                                                          00002520
      I8=IDIF2                                                          00002530
      DO 203 I4=NCOF,NEND,4                                             00002540
      DATA(I9)=DATA(I4)*DATA(I2+1)+DATA(I4+1)*DATA(I2+2)+DATA(I4+2)*DATA00002550
     1(I2+3)                                                            00002560
      DATA(I8)=DATA(I4)*DATA(I2+4)+DATA(I4+1)*DATA(I2+5)+DATA(I4+2)*DATA00002570
     1(I2+6)                                                            00002580
      I9=I9+1                                                           00002590
  203 I8=I8+1                                                           00002600
      I9=IDIF2-1                                                        00002610
      DO 215 I7=NUM,NUMED,K1                                            00002620
      I5=I7                                                             00002630
      RA=10.0E37                                                        00002640
      RB=RA                                                             00002650
      I8=IDIF2                                                          00002660
      DO 208 I4=IDIF1,I9                                                00002670
      IF (DATA(I4)) 911,213,213                                         00002680
  911 TA=DATA(I5)/DATA(I4)                                              00002690
      IF (RA-TA) 213,213,205                                            00002700
  205 RA=TA                                                             00002710
  213 IF (DATA(I8)) 216,217,217                                         00002720
  216 TB=DATA(I5)/DATA(I8)                                              00002730
      IF (RB-TB) 217,217,207                                            00002740
  207 RB=TB                                                             00002750
  217 I5=I5+1                                                           00002760
      I8=I8+1                                                           00002770
  208 CONTINUE                                                          00002780
      RA=RA+RB                                                          00002790
      ABSCOR=ABSCOR+EXP(-VMU*RA)*DATA(I5)                
  215 CONTINUE                                                          00002810
  201 CONTINUE                                                          00002820
      IF (NB-1) 7009,7009,7110                                          00002830
 7110 REWIND 5                                                          00002840
 7009 ABSCOR=ABSCOR/V                                       
      goto 210
C
C
c
c
c     Calculate corrrection for interpolation.
c    
  112 continue
      rphi=phi+phioff           ! leave mag file phi untouched
c phioff allows for cad4 to p1bar conversion. Cad4 minus P1bar. 
c add optional theta dependence per north, phillips, mathews      
      if (thetadep) then
       thcch=thet/2.*cos(CHI*.017453293)                                        
      else
       thcch=0.0
      endif
      phiin=rphi-thcch
      if(phiin.gE.360.)phiin=phiin-360.
      if(phiin.lt.0.)phiin=rphiin+360.
      if(phiin.gE.360.)phiin=phiin-360.
      if(phiin.lt.0.)phiin=rphiin+360.
      do  i=2,n+1
      J=I-1
      IF(PHIin.LT.TPHI(I))THEN
        dphi=tphi(i)-phiin       ! diff in phi TPHI(I).GT.RPHI
        dcr=cphi(i)-cphi(j)      ! correction diff
        dcr=dphi/delt*dcr         ! down from i
        abscor=cphi(i)-dcr
        GO TO 121
      ENDIF
      ENDDO
  121 phiout=rphi+thcch
      if(phiout.gE.360.)phiout=phiout-360.
      if(phiout.lt.0.)phiout=rphiout+360.
      if(phiout.gE.360.)phiout=phiout-360.
      if(phiout.lt.0.)phiout=rphiout+360.
      do  i=2,n+1
      J=I-1
      IF(PHIout.LT.TPHI(I))THEN
        dphi=tphi(i)-phiout       ! diff in phi TPHI(I).GT.RPHI
        dcr=cphi(i)-cphi(j)      ! correction diff
        dcr=dphi/delt*dcr         ! down from i
        abscor=0.5*(abscor + cphi(i)-dcr)
        GO TO 210
      ENDIF
      ENDDO
C
C
C
C     Calculate abscor for PSI1 function.
c     y=a1*(1.-a2*exp(-a3*|cos(x+a4)|))
C
  113 abscor=a1-(1.-a2*exp(-a3*abs(cos(rad*phi+a4))))
      goto 210
C
C
C
C     PRINT RESULTS AND APPLY CORRECTION                                00002870
  210 NLINES=NLINES-1                                                   00002890
      IF (NLINES) 240,240,241                                           00002900
  240 NLINES=75                                                         00002910
C      CALL TDAT (CARD(16))                                              00002920
      IF(ILIST.NE.0)WRITE (3,1002) IDCF
      IF(ILIST.EQ.0)GOTO 241
      IF(IN(1:1).EQ.'M')THEN
C       INPUT FROM MAG FILE OUTPUTS INT AND SIG CORRECTED FOR ABSORPTION -
C       INPUT FROM OTHER FILES OUTPUTS WEIGHT AND F CORRECTED FOR ABS.
        WRITE(3,1009)VMU
1009    FORMAT('    ID     H     K     L    INTCOR  SIG(INT)',
     1  '   2TH    PHI    CHI  OMEGA TRANS(MU= ',F8.4,') TTHR',/)
      ELSE
        WRITE (3,1004) VMU                                                00002940
      ENDIF
241   NCR=NCR+1
      IF(IN(1:1).EQ.'M')THEN
C       IF INPUT FROM MAG FILE, INT AND SIG ARE CORRECTED FOR ABSORPTION
        IF(INTCOR.NE.0.0)THEN 
C         INT AND SIG CORRECTED FOR BACKGROUND STORED ON MAG FILE IF
C         BACKGROUND2 HAS BEEN RUN - USE THESE VALUES FOR INT AND SIG
          INT=INTCOR
          SIG=SIGCOR
        ELSE
C         NO INT AND SIG CORRECTED FOR BACKGROUND ON FILE - CALCULATE
          INT=(SCAN-(BG1+BG2)/TBTS)*SPEED
          SIG=SQRT(SPEED**2*(SCAN+(BG1+BG2)/TBTS**2))
          IF(EXPTM.LT.0.0)THEN
C           TIME LESS THAN 0.0, MEANS ATTENUATOR WAS SET
            SIG=SIG*ATT
            INT=INT*ATT
          ENDIF
        ENDIF
        INTABS=(INT/ABSCOR)*CORF
        SIGABS=(SIG/ABSCOR)*CORF
      ELSE ! INPUT NOT A MAG FILE - F AND WEIGHT CORRECTED FOR ABS
        DCR=FO*FO/ABSCOR                     
        FCR=SQRT(DCR)                                                     00002960
        IF (FO) 242,243,243                                               00002970
  242   FCR=-FCR                                                          00002980
  243   WTR=ABSCOR*WT                      
        SI=1.0/WTR                                                        00003000
      ENDIF
      IF(ABSCOR.LT.ABSMIN)ABSMIN=ABSCOR  ! MIN ABS COEF
      IF(ABSCOR.GT.ABSMAX)ABSMAX=ABSCOR  ! MAX ABS COEF
      IF(ILIST.EQ.0)GOTO 2431
C  ILIST=0 SIGNALS NO OUTPUT OF UPDATED REFLECTIONS
      IF(IN(1:1).EQ.'M')THEN
C  INPUT FROM MAG - OUTPUT HAS INT AND SIG CORRECTED FOR ABSORPTION
        WRITE(3,9119)IDHKL,INTABS,SIGABS,THET,PHI,CHI,OMEG,ABSCOR
9119    FORMAT(1X,4I6,F11.2,F8.2,4F7.2,1X,F11.6,1X,I5,'-',I5)
      ELSE  ! INPUT FROM MAG - OUTPUT HAS CORRECTED WEIGHT AND F
        WRITE (3,1003) KI1,KI2,KI3,FCR,DCR,SI,THET,PHI,CHI,OMEG,ABSCOR 
      ENDIF
      GOTO 2432
2431  ICK=abs(THET)/5+1
      IF(ABSCOR.LT.DATMIN(ICK))THEN
C       HERE FOR NO LISTING OF REFLECTIONS - INSTEAD, SAVING REFLECTIONS
C       WITH MAXIMUM AND MINIMUM VALUES OF ABSCOR (ABSORBTION COEFFICIENT)
        IDMIN(ICK)=ID
        K1MIN(ICK)=KI1
        K2MIN(ICK)=KI2
        K3MIN(ICK)=KI3
        TTHMIN(ICK)=THET
        PHIMIN(ICK)=PHI
        CHIMIN(ICK)=CHI
        OMEMIN(ICK)=OMEG
        DATMIN(ICK)=ABSCOR
        IF(IN(1:1).EQ.'M')THEN
          INTMIN(ICK)=INTABS
          SIGMIN(ICK)=SIGABS
        ELSE
          FCRMIN(ICK)=FCR
          DCRMIN(ICK)=DCR
          SIMIN(ICK)=SI
        ENDIF
      ENDIF
      IF(ABSCOR.GT.DATMAX(ICK))THEN
        IDMAX(ICK)=ID
        K1MAX(ICK)=KI1
        K2MAX(ICK)=KI2
        K3MAX(ICK)=KI3
        TTHMAX(ICK)=THET
        CHIMAX(ICK)=CHI
        PHIMAX(ICK)=PHI
        OMEMAX(ICK)=OMEG
        DATMAX(ICK)=ABSCOR
        IF(IN(1:1).EQ.'M')THEN
          INTMAX(ICK)=INTABS
          SIGMAX(ICK)=SIGABS
        ELSE
          FCRMAX(ICK)=FCR
          DCRMAX(ICK)=DCR
          SIMAX(ICK)=SI
        ENDIF
      ENDIF
2432  IF(OUT(1:1).EQ.'C') WRITE(2,9003)KI1,KI2,KI3,FCR,WTR,ABSCOR
9003  FORMAT(4X,3I6,F8.2,F8.4,32X,F8.6)
      IF(OUT(1:1).EQ.'M')WRITE(20)IDHKL,THET,PHI,CHI,RANGE,SPEED,BG1,
     1SCAN,BG2,EXPTM,TBTS,INTCOR,SIGCOR,ABSCOR
      IF(IN(1:1).EQ.'M')GOTO 9000
      IF(IN(1:1).EQ.'C')GO TO 7024
      IF(OUT(1:1).NE.'H')GO TO 7018
  402 FO=FCR                                                            00003040
      WT=WTR                                                            00003050
  404 WRITE(IIT2) TAPE                                                  00003060
      GO TO 7018                                                        00003070
C     TERMINATE CALCULATIONS.                                           00003090
9444  IF(ILIST.EQ.0)THEN
C   PRINTING REFLECTIONS WITH MAXIMUM AND MINIMUM ABS COEFF VALUES
        WRITE(3,9117)
9117  FORMAT(' REFLECTIONS WITH MINIMUM AND MAXIMUM VALUES OF THE',
     1' TRANSMISSION COEFFICIENT: ')
        WRITE(3,1009)VMU
        DO 9118 I=1,36
        IF(DATMAX(I).NE.0.0)THEN
          ICK=(I-1)*5
          ICK1=ICK+5
          WRITE(3,9119)IDMIN(I),K1MIN(I),K2MIN(I),K3MIN(I),INTMIN(I),
     1 SIGMIN(I),TTHMIN(I),PHIMIN(I),CHIMIN(I),OMEMIN(I),DATMIN(I),ICK,
     2    ICK1
          WRITE(3,9119)IDMAX(I),K1MAX(I),K2MAX(I),K3MAX(I),INTMAX(I),
     1 SIGMAX(I),TTHMAX(I),PHIMAX(I),CHIMAX(I),OMEMAX(I),DATMAX(I),ICK,
     2    ICK1
        ENDIF
9118    CONTINUE
      ENDIF
      IF(NFIL.EQ.1)GO TO 444
C          NFIL=NFILES FROM PROCESS
      WRITE(3,2004)NCR
      WRITE(3,9004)NFILE
9004  FORMAT('END OF DATA ON FILE',A14)
       GO TO 444
C 436 IF (ITAPE) 444,440,442                                            00003110
436   IF(ILIST.EQ.0)THEN
C   WRITING REFLECTIONS WITH MAXIMUM AND MINIMUM ABS COEF VALUES
        WRITE(3,9117)
        WRITE(3,1004),VMU
        DO 9116 I=1,36
        IF(DATMAX(I).NE.0.0)THEN
          ICK=(I-1)*5
          ICK1=ICK+5
          WRITE(3,1003)K1MIN(I),K2MIN(I),K3MIN(I),FCRMIN(I),
     1     DCRMIN(I),SIMIN(I),TTHMIN(I),PHIMIN(I),CHIMIN(I),
     2     OMEMIN(I),DATMIN(I),ICK,ICK1
          WRITE(3,1003)K1MAX(I),K2MAX(I),K3MAX(I),FCRMAX(I),DCRMAX(I),
     1  SIGMAX(I),TTHMAX(I),PHIMAX(I),CHIMAX(I),OMEMAX(I),DATMAX(I),ICK,
     2     ICK1
        ENDIF
9116    CONTINUE
      ENDIF
      IF(IN(1:1).EQ.'H')THEN
        IF(OUT(1:1).EQ.'H')THEN
  440     WRITE (IIT2) TAPE                                                 00003120
          WRITE (IIT2) TAPE                                                 00003130
          I1=IIT2                                                           00003140
          IIT2=IIT1                                                         00003150
          IIT1=I1                                                           00003160
        ENDIF
        REWIND IIT1                                                       00003170
        REWIND IIT2                                                       00003180
      ENDIF
444   IF(OUT(1:1).EQ.'M')THEN
        WRITE(20)IDHKL,THET,PHI,CHI,RANGE,SPEED,BG1,SCAN,BG2,EXPTM,
     1  TBTS,INTCOR,SIGCOR,ABSCOR
        CLOSE(UNIT=13,DISP='SAVE')
        CLOSE(UNIT=20,DISP='SAVE')
      ENDIF
      NFL=NFL+1
      IF(NFL.LE.NFIL)GOTO 502
      IS2=NCNR                                                          00003200
      DO 445 I=1,NCNR                                                   00003210
      ADI(I)=CARD(15)                                                   00003220
  445 TQ(I)=CARD(1)                                                     00003230
      IS1=0                                                             00003240
      IF(IINF.EQ.1)THEN  ! ADD ABS. COEF. TO INF FILE
        ENCODE(80,4453,INFC)ABSMIN,ABSMAX
4453    FORMAT(' TRANSMISSION COEFF. = ',F6.2,' TO ',F6.2)
        CALL ADDON(INFC,27,IFLG)
        IF(IFLG.EQ.0)WRITE(3,8314)
8314    FORMAT('  ERROR WRITING ABS. COEF. TO INF FILE')  
      ENDIF
      RETURN                                                            00003250
C     ERROR RETURNS                                                     00003270
 8313 WRITE (3,2313) N,M,NS,NP                                          00003290
      GO TO 8312                                                        00003300
   56 WRITE (3,2011) A,DIF1                                             00003310
      GO TO 8312                                                        00003320
   72 WRITE (3,2012) C,DIF2                                             00003330
      GO TO 8312                                                        00003340
   99 WRITE (3,2013) F,DIF3                                             00003350
 8312 IS1=5                                                             00003360
      RETURN                                                            00003370
C     FORMATS                                                           00003390
 1002 FORMAT ('1',10X,'ABSORPTION CORRECTION',10X,8A4/)                 00003420
 1003 FORMAT (' ',3I4,F8.2,F9.1,F8.1,3X,4F7.2,3X,5F11.6,1X,I5,'-',I5)
 1004 FORMAT ('0',3X,'H   K   L   F(CR)   I(CR)    S(I)',6X,
     1'2TH    PHI    CHI   OMEGA 2THR',4X,'TRANSMISSION(MU =',F8.4,')'/)
 1005 FORMAT (4X,3I6,5F8.2)
 1006 FORMAT ('0',8X,'INTEGRATION LIMITS'/'0  A =',F10.5,',  B =',      00003470
     1F10.5/)                                                           00003480
 1007 FORMAT ('   C =',F10.5,',  D =',F10.5,'  FOR X =',F10.5)          00003490
 2002 FORMAT (' ',3I4,3F13.6)                                           00003500
 2004 FORMAT ('0 NUMBER OF REFLECTIONS CALCULATED =',I6)                00003510
 2313 FORMAT (36H0MEMORY IS TOO SMALL FOR PARAMETERS./4H0N =I3,3HM =I3, 00003520
     119HAVAILABLE STORAGE =I6,4HNP =I5)                                00003530
 2093 FORMAT (10H0VOLUME = F15.8)                                       00003540
 2001 FORMAT (34H0COORDINATES OF CORNERS OF CRYSTAL/52H0INDEX OF PLANES 00003550
     1FORMING CORNER, FOLLOWED BY X, Y, Z//)                            00003560
 2009 FORMAT ('0 PROGRAM IS USING DISK STORAGE')                        00003570
 2011 FORMAT (61H0ERROR IN CALCULATION OF UPPER AND LOWER LIMITS (B, A).00003580
     1  A = E15.8,8H, B-A = E15.8/)                                     00003590
 2012 FORMAT (61H0ERROR IN CALCULATION OF UPPER AND LOWER LIMITS (D, C).00003600
     1  C = E15.8,8H, D-C = E15.8/)                                     00003610
 2013 FORMAT (61H0ERROR IN CALCULATION OF UPPER AND LOWER LIMITS (F, E).00003620
     1  E = E15.8,8H, F-E = E15.8/)                                     00003630
      END                                                               00003640
C     SUBROUTINE FACE                                                   00000010
C     BEFORE ENTRY NCOF AND N ARE SET                                   00000030
C     UPON EXIT, SUBROUTINE SUPPLIES COEFFICIENTS WHICH DESCRIBE PLANES 00000040
C         FORMING FACES OF CRYSTAL                                      00000050
C     NOTATION                                                          00000060
C     N = NUMBER OF FACES                                               00000070
C     DATA = BLOCK                                                      00000080
C     NCOF = ELEMENT OF DATA CONTAINING FIRST COEFFICIENT DESCRIBING    00000090
C         PLANES, OR FIRST AVAILABLE CELL OF STORAGE UPON ENTRY         00000100
      SUBROUTINE FACE(N,DATA,NCOF)
      DIMENSION DATA(1)                                                 00000120
      NEND=4*N+NCOF-1                                                   00000130
    3 NBEG=NCOF                                                         00000140
      K3=0                                                              00000150
    7 WRITE (3,2001)N                                                   00000160
      DO 4 K1=NBEG,NEND,4                                               00000170
      READ (1,205) CHIF,PHIF,DLEFT,dleftmm                              00000180
      if (dleft.eq.0.0) dleft=dleftmm*10.
      CHIFR=0.174532925E-1*CHIF                                         00000190
      PHIFR=0.174532925E-1*PHIF                                         00000200
      DATA (K1)=-COS(CHIFR)*COS(PHIFR)                                  00000210
      DATA(K1+1)=-COS(CHIFR)*SIN(PHIFR)                                 00000220
      DATA(K1+2)=-SIN(CHIFR)                                            00000230
      DATA(K1+3)=-1.0*DLEFT   ! -SCALE*DLEFT
      K2=K1+3                                                           00000250
      K3=K3+1                                                           00000260
      WRITE (3,2002) K3,(DATA(I1),I1=K1,K2),CHIF,PHIF,DLEFT             00000270
      IF (50-K3) 5,5,4                                                  00000280
    5 NBEG=K1                                                           00000290
      GO TO 7                                                           00000300
    4 CONTINUE                                                          00000310
 1002 FORMAT (4E10.8)                                                   00000320
 2001 FORMAT (1H0,10X,17HNUMBER OF FACES =I5/75H0COEFFICIENTS A, B, C, D00000330
     1 WHERE  AX + BY + CZ = D  DESCRIBES FACE OF CRYSTAL/1H0,2X,1HN,7X,00000340
     21HA,9X,1HB,9X,1HC,9X,1HD,8X,'CHI',5X,'PHI',6X,'D'//)              00000350
 2002 FORMAT (1H I3,2X,4F10.5,2X,2F8.2,F8.4)                            00000360
  205 FORMAT ('FACE',2X,4F8.5)
    2 RETURN                                                            00000380
      END                                                               00000390
C     SUBROUTINE GAUSOL (B,N)                                           00000010
C                                                                       00000020
      SUBROUTINE GAUSOL (B,N)                                           00000030
      DIMENSION A(3,4),B(3,4)                                           00000040
      COMMON IS1,IS2,IS3                                                00000050
C     SOLUTION OF SYSTEM OF EQUATIONS BY GAUSSIAN ELIMINATION USING     00000060
C         INTERCHANGES                                                  00000070
C     A = NAME OF MATRIX (ORIGINAL MATRIX IS DESTROYED)                 00000080
C     MATRIX IS STORED BY COLUMNS, VECTOR FOLLOWS                       00000090
C     N = ORDER OF MATRIX                                               00000100
C     (N MUST BE LESS THAN OR EQUAL DIMENSION STATEMENT)                00000110
C     SOLUTION IS FOUND IN A(1,N+1) THROUGH A(N,N+1)                    00000120
      DOUBLE PRECISION A,R,X,T                                          00000130
      N2=N-1                                                            00000140
      IS3=0                                                             00000150
      N1=N+1                                                            00000160
      DO 20 I=1,N                                                       00000170
      DO 20 J=1,N1                                                      00000180
   20 A(I,J)=B(I,J)                                                     00000190
      DO 9 I1=1,N2                                                      00000200
      L=0                                                               00000210
      R=A(I1,I1)                                                        00000220
      I11=I1+1                                                          00000230
      DO 2 IR=I11,N                                                     00000240
      IF (DABS(R)-DABS(A(IR,I1))) 3,2,2                                 00000250
    3 R=A(IR,I1)                                                        00000260
      L=IR                                                              00000270
    2 CONTINUE                                                          00000280
      IF (L) 4,4,5                                                      00000290
    5 DO 6 IJ=I1,N1                                                     00000300
      X=A(L,IJ)                                                         00000310
      A(L,IJ)=A(I1,IJ)                                                  00000320
    6 A(I1,IJ)=X                                                        00000330
    4 DO 8 I2=I11,N                                                     00000340
      IF(A(I1,I1))24,23,24                                              00000350
   23 IS3=1                                                             00000360
      GO TO 13                                                          00000370
   24 T=A(I2,I1)/A(I1,I1)                                               00000380
      DO 7 I3=I11,N1                                                    00000390
    7 A(I2,I3)=A(I2,I3)-A(I1,I3)*T                                      00000400
    8 CONTINUE                                                          00000410
    9 CONTINUE                                                          00000420
      IF (A(N,N)) 29,23,29                                              00000430
   29 A(N,N1)=A(N,N1)/A(N,N)                                            00000440
      DO 11 I=1,N2                                                      00000450
      I1=N-I                                                            00000460
      I2=I1+1                                                           00000470
      DO 10 I3=I2,N                                                     00000480
   10 A(I1,N1)=A(I1,N1)-A(I1,I3)*A(I3,N1)                               00000490
      IF (A(I1,I1)) 11,23,11                                            00000500
   11 A(I1,N1)=A(I1,N1)/A(I1,I1)                                        00000510
      DO 22 I=1,N                                                       00000520
      DO 22 J=1,N1                                                      00000530
   22 B(I,J)=A(I,J)                                                     00000540
   13 RETURN                                                            00000550
      END                                                               00000560
C     SUBROUTINE ANGLE                                                  00000020
C     FOR FOUR CIRCLE GONIOMETER                                        00000040
      SUBROUTINE ANGLE(DATA,THET,PHI,CHI,OMEG,I)                        00000060
      DIMENSION DATA(1)                                                 00000070
      THR=THET*.008726646                                               00000080
      PHR=PHI*.017453293                                                00000090
      CHR=CHI*.017453293                                                00000100
      OMEGR=OMEG*.017453293                                             00000110
      THB=THR+OMEGR                                                     00000120
      THD=THR-OMEGR                                                     00000130
      BS=SIN(THB)                                                       00000140
      BC=COS(THB)                                                       00000150
      DS=SIN(THD)                                                       00000160
      DC=COS(THD)                                                       00000170
      CS=SIN(CHR)                                                       00000180
      CC=COS(CHR)                                                       00000190
      PS=SIN(PHR)                                                       00000200
      PC=COS(PHR)                                                       00000210
      DATA(I+1)=CC*PC*BS+PS*BC                                          00000220
      DATA(I+2)=CC*PS*BS-PC*BC                                          00000230
      DATA(I+3)=CS*BS                                                   00000240
      DATA(I+4)=CC*PC*DS-PS*DC                                          00000250
      DATA(I+5)=CC*PS*DS+PC*DC                                          00000260
      DATA(I+6)=CS*DS                                                   00000270
      RETURN                                                            00000280
	END	!COMPARE THIS WITH IBM VERSION 
