       SUBROUTINE BGROUND
C
C   THIS ROUTINE EVALUATES THE BACKGROUND DISTRIBUTION AS A FUNCTION
C   OF 2THETA - INPUT DATA IS FROM A MAG FILE 'NAME.MAG'
C
C   THE USER CAN REJECT REFLEXIONS BY INDICATING THE VALID RANGE ON
C   CHI AND/OR BY SPECIFYING THE CORRESPONDING SEQ. NUMBERS (IN THE
C   LATTER CASE, THE MAXIMUM NO. OF REJECTED REFLNS IS 500).
c   Reflections can also be rejected if they .LE. or .GE. 
c   Two Theta limits.  2/13/96
C       TWO DISTRIBUTIONS ARE ALWAYS PRODUCED: THE FIRST INCLUDES DATA
C   WITH I.LE.AL(1)*SIG(I), THE SECOND ONE THOSE WITH I.LE.AL(2)*SIG(I)
C   AL(1) AND AL(2) ARE INPUT NUMBERS.
C   ************  AL(2) MUST BE .LE.AL(1) **************
C   THE DISTRIBUTIONS ARE WRITTEN ON A BGD FILE, 'NAME.BGD',
C   ALONG WITH THE ID NUMBER OF DELETED REFLECTIONS.
C ?  DATA WITH I.LE.AL(2)*SIG(I) CANNOT BE MORE THAN 20000 IN NUMBER AND
C   THE MAXIMUM NO. OF POINTS IN THE DISTRIBUTIONS IS 120.
C   IF NECESSARY, THE USER CAN INCREASE THESE LIMITS BY CHANGING THE 
C ?  VALUES OF NRM (PRESENT VALUE IS 20000) AND NPO (NOW=120) 
C  NUMBER IN EACH BIN (nbin = 2000) in the  "PARAMETER" STATEMENT. 
C         THE INTERVAL WIDTH (IN DEGREES) IS AN INPUT PARAMETER (DE-
C   FAULT VALUE IS 1.0).
C
      PARAMETER NPO = 120, NRM = 20000, nbin=2000, ATT=20.9
      INTEGER*2  HKL(4), NQ(NRM), IDD(100,2),HH(NRM),KK(NRM),LL(NRM),
     1 ID1(200),NDR(12),IDDEL(500)
      CHARACTER*1 DASH(11)
      REAL*4  INT
      CHARACTER*16 NFILE,NFILE2
      CHARACTER*1 ISTAR(NPO)
      CHARACTER*2 NT(10)
      DIMENSION X(13),TITLE(20),AL(2),TTHMIN(NPO),TTHMAX(NPO)
      DIMENSION BM(NPO),NTOA(NPO),TSUM(NPO),SSUM(NPO),TI(NPO,nbin)
      DIMENSION BI(NPO,nbin),FDIS(NPO),Q1(NRM),Q2(NRM),Q3(NRM),Q4(NRM)
      DIMENSION Q5(NRM),CARD(20),Q6(NRM),BINT(11)
      EQUIVALENCE(B1,X(6)),(B2,X(8)),(TTH,X(1)),(TBTS,X(10))
      EQUIVALENCE(CHI,X(3)),(SRAT,X(5)),(SCR,X(4)),(SCAN,X(7))
      EQUIVALENCE(EXPTM,X(9))
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B22,CARD
      COMMON/FNAME/NFILE,NAMLEN
      DATA DEL/'DELE'/
      DATA CLIM/'LIMI'/
      DATA END/'END '/
C
C  INPUT PARAMETERS ARE READ IN FROM FILE IN = 4, DATA FROM FILE
C  NFIN = 12
C
      IN=1
      OCK=0   ! FLAG TO NOTE IF BGD FILE IS OPEN
      NFIN=12
      NSFIRST=1
      NSLAST=99999
      NTOUT=13  ! BACKGROUND DISTRIBUTIONS WRITTEN HERE
      ICC=0
      DECODE(80,5000,CARD)NT
5000  FORMAT(11X,10A2)
C  TITLE CARD - NT IS THE VERSION NUMBER OF THE PRC FILES TO BE USED
C  NMT IS THE TOTAL NUMBER OF PRC FILES - DEFAULT IS 1
      DO 501 I=1,10
        IF(NT(I).EQ.'  ')GOTO 502
501   CONTINUE
502   NMT=I-1
      IF(NMT.EQ.0)THEN
        WRITE(3,121)
121     FORMAT(' ONLY THE LATEST VERSION OF YOUR MAG FILE WILL BE USED')
      ELSE
        WRITE(3,122)NT
122     FORMAT(' VERSIONS OF MAG FILE TO BE USED: ',10A2)
      ENDIF
      NGR=0
      NY=0
C  NY IS A FLAG TO TELL WHETHER A CARD HAS BEEN DECODED OR NOT - I.E.
C  IF NY=1, CARD HAS BEEN DECODED SO NEXT CARD IS READY TO BE READ IN
      ND=0 ! NUMBER OF SETS OF DELETION SPECIFIERS
      ND1=0 ! NUMBER OF SINGLE DELETION SPECIFIERS
C
C   ECHO INPUT PARAMETERS
C
C   AL(1)    DEFINES THE UPPER LIMIT FOR INTENSITY VALUES TO BE INCLUDED
C	     IN THE FIRST DISTRIBUTION  -  ONLY REFLNS WITH I.LE.AL(1)*
C	     SIGMA(I) ARE ACCEPTED
C   AL(2)    ACTS AS ABOVE IN THE SECOND DISTRIBUTION
C ***  AL(2) MUST BE .LE.AL(1)  ***
C   WID      LENGTH (DEGREES) OF EACH INTERVAL IN THE DISTRIBUTIONS
C            if wid is negative, length is abs(1/wid); if wid is positive
C            then interval = wid.
C   CHIMIN   
C    AND     DEFINE THE INCLUSIVE CHI LIMITS FOR REFLNS TO BE ACCEPTED
C   CHIMAX
C            IF CHIMIN AND CHIMAX ARE BOTH = ZERO, NO REJECTION OCCURS
C   tthlow   
C    AND     Everything within (but not equal to) these limits
C   tthhi    is included
c
C            IF tthlow AND tthhi ARE BOTH = ZERO, NO REJECTION OCCURS
C   
C   NSA     FIRST SEQ. NO.
C   NSB     LAST  SEQ. NO.
C   TBTS    RATIO OF TIME FOR BCKGROUND TO TIME FOR SCAN IN DATA COLL.
C   TTRA1   2THETA RANGE BELOW K ALPHA1 (=INPUT VALUE AT LOC 200 IN THE
C           SYNTEX 2THETA-THETA AUTOCOLLECTION PROGRAM)
C
      READ(1,504)CARD
504   FORMAT(20A4)
      IF(CARD(1).NE.CLIM)THEN
C  DEFAULT VALUES FOR LIMIT CARD
        AL(1)=8.
        AL(2)=3.
        WID=1.
        CHIMIN=0.
        CHIMAX=0.
        tthlow=0.
        tthhi=180.
        GOTO 507
      ENDIF
C  READ IN LIMIT CARD
C23456789012345678901234567890123456789
CIMIT AL(1)-AL(2)-WID---CHIMINCHIMAX
      DECODE(80,509,CARD,ERR=9988)AL,IWID,CHIMIN,CHIMAX,tthlow,tthhi
509   FORMAT(6X,2F6.2,I6,4F7.2)
      NY=1
      WID=IWID
      IF(AL(1).EQ.0.)AL(1)=8.
      IF(AL(2).EQ.0.)AL(2)=3.
      IF(WID.EQ.0.)WID=1.
      if(wid.lt.0.)wid=-1./wid
507   WRITE(3,508)AL,WID
508   FORMAT(' INTENSITY UPPER LIMITS - FIRST DISTRIBUTION: ',F8.2,
     1' SECOND DISTRIBUTION: ',F8.2,/,
     1' 2TH INTERVAL LENGTH: ',F8.2,' DEGREES')
      IF(CHIMIN.NE.0.0.or.CHIMAX.NE.0.0)ICC=1
      IF(ICC.EQ.1)THEN
C  CHECK ON CHI VALUE ONLY IF ICC=1
        WRITE(3,105)CHIMIN,CHIMAX
105	FORMAT (1X,'ONLY REFLNS MEASURED AT CHI VALUES IN THE RANGE ',
     1 F7.2,' TO ',F7.2' ARE ACCEPTED.')
      ELSE
        WRITE(3,106)
106	FORMAT (1X,'NO RESTRICTIONS ON CHI VALUES',/)
      ENDIF
c
c  Check for two theta min and max limits  (2/13/96)
c  E.g., to deal with low angle spikes in P1bar dataset.
c
        if (tthlow .lt. 0.0) tthlow=0.0
        if (tthhi .le. 0.0) tthhi=180.0
        if (tthlo .ne. 0. .or. tthhi .ne. 180.) then
         WRITE(3,107)tthlow,tthhi
107	 FORMAT (1X,'ONLY REFLNS MEASURED AT Abs(TwoTheta)',
     1           ' VALUES withIN (exclusive) THE RANGE ',
     2           F7.2,' TO ',F7.2' ARE ACCEPTED.')
        ELSE
         WRITE(3,108)
108	 FORMAT (1X,'NO RESTRICTIONS ON Two Theta VALUES',/)
        ENDIF
      IF(NY.NE.0)READ(1,504)CARD
      NY=0
      IF(CARD(1).NE.DEL)GOTO 518
C  DELETE CARDS, IF ANY, HERE
5120  DECODE(80,513,CARD)(NDR(I),DASH(I),I=1,11),NDR(12)
513   FORMAT(7X,11(I5,A1),I5)
      NY=1
514   FORMAT(1X,20A4)
      WRITE(3,5130)(NDR(I),DASH(I),I=1,11),NDR(12)
5130  FORMAT(' DELETE',11(I5,A1),I5)
      II=1
5140  IF(NDR(II).EQ.0)GOTO 5145
      IF(DASH(II).EQ.'-')THEN
C  DASH INDICATES RANGE OF ID'S HAS BEEN ENTERED
        ND=ND+1
        IF(ND.GT.100)THEN
          ND=100
          WRITE(3,5141)NDR(II)
5141      FORMAT(' DELETION ARRAY OVERFLOW - REFLECTION NO. ',I5,' NOT',
     1  ' DELETED')
        ENDIF
        IDD(ND,1)=NDR(II)
        IDD(ND,2)=NDR(II+1)
        II=II+2 
      ELSE
C  SINGLE ID TO BE DELETED
        ND1=ND1+1
        IF(ND1.GT.200)THEN
          ND1=200
          WRITE(3,5141)NDR(II)
        ENDIF
        ID1(ND1)=NDR(II)
        II=II+1
      ENDIF
      IF(II.LE.12)GOTO 5140
5145  READ(1,504)CARD
      NY=0
      IF(CARD(1).EQ.DEL)GOTO 5120
518   IF(CARD(1).NE.END)THEN
        WRITE(3,519)
519     FORMAT(' UNRECOGNIZED COMMAND - PROGRAM HALTED.')
        WRITE(3,514)CARD
        STOP
      ENDIF
C   OPENING MAG FILE
      NAML=NAMLEN+1
      NFILE(NAML:NAML+4)='.MAG;'
      NAML=NAML+5
      IF(NMT.GE.1)NFILE(NAML:NAML+1)=NT(1)
      OPEN(NAME=NFILE,UNIT=NFIN,TYPE='OLD',FORM='UNFORMATTED',
     1BLOCKSIZE=32768)
      OCK=1  ! TELLS THAT BGD FILE IS OPEN
      NOF=1    ! KEEPS TRACK OF HOW MANY PRC FILES HAVE BEEN READ
      N3 = 0
C N3 WILL INDICATE THE NO. OF REFLNS IN THE SECOND DISTRIBUTION
      JJJ = 0
C JJJ = 0 FLAGS THE FIRST DISTR.; JJJ = 1 THE SECOND ONE.
      NN = 0
C IF NN BECOMES = 1, MORE THAN 1000 REFLNS SHOULD BE INCLUDED IN THE
C                   SECOND DISTRIBUTION
	IW = WID + 0.05
14    DO 15 I = 1,NPO
	NTOA(I) = 0
        TSUM(I)=0.0
        SSUM(I)=0.0
	BM(I) = 0.0
15    CONTINUE
      JMAX = 1
      NIDEL=0
      SUMG=0.0
      SUMN=0.0
      NBAD=0
C
C  MAIN DO LOOP STARTS HERE
C
      DO 1000 I =NSFRST,NSLAST
        IF(JJJ.NE.0) GO TO 19
16      READ (NFIN) HKL,X
        x(1)=abs(x(1))
c sets tth positive
	NS = HKL(1)
	NS = IABS (NS)
	IF (NS.GT.NSLAST) GO TO 1001
        IF(NS.EQ.0)GOTO 1010
        IF(SRAT.LT.0.0)GOTO 16
C  PREVIOUSLY DELETED REFLECTION (UPDATE) MARKED ON MAG FILE WITH
C  NEGATIVE SCAN SPEED.
        IF(EXPTM.LT.0.0)THEN
C  EXPTM LESS THAN 0.0 MEANS ATTENUATOR WAS SET
          b1=b1*att
          b2=b2*att
          scan=scan*att
        ENDIF
        TSTB=1./TBTS
        INT=(SCAN-(B1+B2)*TSTB)*SRAT
        SIG=SQRT(SRAT**2*(SCAN+(B1+B2)*TSTB**2))
        IF(ND.EQ.0)GOTO 5001
        DO 5001 II=1,ND
          IF(NS.GE.IDD(II,1).AND.NS.LE.IDD(II,2))THEN
C   CHECKING IF ID IS IN ONE OF THE DELETION RANGES
            NIDEL=NIDEL+1
            IF(NIDEL.GT.500)NIDEL=500 ! PREVENT ARRAY OVERFLOW
            IDDEL(NIDEL)=HKL(1)
C   AT THIS POINT, DELETIONS ARE ONLY LISTED ON THE OUTPUT IN CASE
C  THERE HAS BEEN AN ERROR ON THE DELETION CARD.  THE DELETIONS ARE
C  INCLUDED ON THE BGD FILE AND DELETED WHEN 2BACKGROUND IS RUN.
C  (AFTER 2BGROUND, DELETIONS WILL BE MARKED WITH A NEGATIVE SCAN SPEED
C  RATHER THAN BEING COMPLETELY DELETED FROM THE MAG FILE.)
            GOTO 16   ! READ NEXT REFLECTION
          ENDIF
5001    CONTINUE
        IF(ND1.EQ.0)GOTO 17
        DO 5002 II=1,ND1
          IF(NS.EQ.ID1(II))THEN
C  IS REFLECTION ONE OF THE SINGLY-DELETED REFLECTIONS
            NIDEL=NIDEL+1
            IF(NIDEL.GT.500)NIDEL=500  ! PREVENT ARRAY OVERFLOW
            IDDEL(NIDEL)=HKL(1)
            GOTO 16
          ENDIF
5002    CONTINUE
17      if (tth .le. tthlow .or. tth .ge. tthhi) go to 16
        IF (ICC.EQ.0) GO TO 20
	IF (CHI.GT.180.) CHI = CHI - 360.
	IF ((CHI.GE.CHIMIN).AND.(CHI.LE.CHIMAX)) GO TO 20
	GO TO 16                
19	NS = NQ(I)
	TTH = Q1(I)
	B1 = Q2(I)
	B2 = Q3(I)
	SCR = Q4(I)
	SRAT = Q5(I)
        TBTS=Q6(I)
	GO TO 21
20	ALIM = AL(1) * SIG
	IF (INT.GT.ALIM) GO TO 16
        if (b1+b2.eq.0.0) goto 1690
        IF((B1-B2).GT.6.0*SQRT(B1+B2))GOTO 1690
C  CHECK FOR BACKGROUND INCOMPATABILITY
        IF((B2-B1).GT.3.0*SQRT(B1+B2))GOTO 1690
21      JJ=TTH/WID+1
        IF(JJ.GT.NPO)JJ=NPO
        IF(JJ.GT.JMAX)JMAX=JJ
        TIME=(SCR/SRAT)*TBTS*60.
	IF (JJJ.NE.0) GO TO 22
	ALIM1 = AL(2) * SIG
	IF (INT.GT.ALIM1) GO TO 22
	N3 = N3 + 1
	N4 = N3
	IF (N3.LE.NRM) GO TO 23
	N4 = NRM
	NN = 1
	GO TO 22
1690    IF(NBAD.EQ.0)THEN
          WRITE(3,1691)
1691      FORMAT('1  REFLECTIONS DELETED FROM BACKGROUND CALCULATIONS',
     1  ' DUE TO BACKGROUND INEQUALITY or zero background: ')
          NBAD=1
          WRITE(3,1693)
1693   FORMAT(/,'  ID      H     K     L        B1     SCAN      B2',//)
          NOL=5
        ENDIF
        NOL=NOL+1
        IF(NOL.GT.82)THEN
          NOL=3
          WRITE(3,1693)
        ENDIF
        IB1=B1
        IB2=B2
        ISCAN=SCAN
        WRITE(3,1692)HKL,IB1,ISCAN,IB2
1692    FORMAT(4I6,2X,I7,I10,I7)
        GOTO 1000
23	NQ(N4) = NS
        HH(N4)=HKL(2)
        KK(N4)=HKL(3)
        LL(N4)=HKL(4)
	Q1(N4) = TTH
	Q2(N4) = B1
	Q3(N4) = B2
	Q4(N4) = SCR
	Q5(N4) = SRAT
        Q6(N4)=TBTS
22      NTOA(JJ)=NTOA(JJ)+1
        TSUM(JJ)=TSUM(JJ)+TIME
        SSUM(JJ)=SSUM(JJ)+(TIME*TIME/(B1+B2))
        BI(JJ,NTOA(JJ))=B1+B2
        TI(JJ,NTOA(JJ))=TIME
1000  CONTINUE
      GOTO 1001
1010  REWIND NFIN
      CLOSE(UNIT=NFIN,DISP='SAVE')
      OCK=0
      IF(NOF.GE.NMT)GOTO 1001
      NOF=NOF+1
      NFILE(NAML:NAML+1)=NT(NOF)
      OPEN(NAME=NFILE,UNIT=NFIN,TYPE='OLD',FORM='UNFORMATTED',
     1BLOCKSIZE=32768)
      OCK=1
      GOTO 16
1001  NNN = JJJ + 1
      IF(JJJ.EQ.0)THEN
C   LISTING DELETED REFLECTIONS
        IF(NIDEL.NE.0)THEN
          WRITE(3,1005)
1005      FORMAT(//' THESE REFLECTIONS WERE DELETED FROM CALCULATIONS',
     1' AS REQUESTED',/,' AND WILL BE MARKED AS DELETED ON THE MAG'
     2' FILE WHEN BGROUND2 IS RUN UNLESS OTHERWISE DIRECTED.'/)
          IF(NIDEL.GE.500)WRITE(3,1009)
1009      FORMAT(' NOTE: ONLY THE FIRST 500 REFLECTIONS WRITTEN HERE.')
          II=0
1006      II=II+1
          I1=15*II-14
          I2=15*II
          IF(I2.GT.NIDEL)I2=NIDEL
          WRITE(3,1007)(IDDEL(I),I=I1,I2)
1007      FORMAT(15I6)
          IF(I2.LT.NIDEL)GOTO 1006
        ENDIF
      ENDIF
      IF (NNN.EQ.1) GO TO 60
      IF (NN.EQ.0) GO TO 60
      WRITE (3,300) N3,AL(2),NRM
300   FORMAT (///,1X,'***  WARNING  ***',3X,I5,2X,'REFLNS HAVE I .LE.
     1  ',F7.2,' * SIG(I)',/,28X,'ONLY THE FIRST',I5,'  HAVE BEEN ACCEPT
     2ED',//)
60    WRITE (3,302) AL(NNN)
302   FORMAT (1H1,40X,'ANALYSIS OF DATA WITH I .LT.',F8.1,' * SIG(I)',
     1  /)
      TTMIN=0.0
      WRITE (3,400)
400   FORMAT(//,1X,'2THETA RANGE',8X,' AVERAGE BACKGROUND',
     2  //,18X,'NO. OF',3X,'MEAN VALUE',3X,'SIGMA',5X,'GOF',
     4 /,18X, 'MEAS.S',6X,'(CPS)',5X,'(CPS)',//)
      TOTGOF=0.0
      DO 40 I = 1,JMAX
        ISTAR(I)=' '
        GOF=0.0
        SIGINT=0.0
        TTHMIN(I)=(I-1)*IW
        TTHMAX(I)=I*IW
        IF(NTOA(I).EQ.0)TTMIN=TTHMIN(I)
	IF (NTOA(I).EQ.0) GO TO 199
	BM(I) = TSUM(I)/SSUM(I)
        SIGINT=SQRT(1./SSUM(I))
	IF(NTOA(I).EQ.1)THEN
          ISTAR(I)='*'
          GOTO 199
        ENDIF
        DO II=1,NTOA(I)
          XX=((BM(I)-(BI(I,II)/TI(I,II)))/(SQRT(BI(I,II))/TI(I,II)))**2
          GOF=GOF+XX
          TOTGOF=TOTGOF+XX
        ENDDO
        GOF=SQRT(GOF/(NTOA(I)-1))
199     WRITE (3,200) (TTHMIN(I),TTHMAX(I),
     1  NTOA(I),BM(I),SIGINT,ISTAR(I),GOF)
200	FORMAT (1X,F5.0,' -',F5.0,5X,I4,6X,F7.3,3X,F7.3,2X,A1,F7.3)
40    CONTINUE
      NTOT=0
2001  FORMAT(//,' TOTAL GOF: ',F8.3)
      DO 5 I = 1,JMAX
        NTOT=NTOT+NTOA(I)
5     CONTINUE
      TOTGOF=SQRT(TOTGOF/(NTOT-1))
      WRITE(3,2001)TOTGOF
      WRITE(3,201) NTOT
201   FORMAT(1X,' NO. OF BACKGROUNDS: ',I6)
      WRITE(3,2011)TTMIN+WID
2011  FORMAT(' MINIMUM 2THETA YOU MAY CHOOSE FOR THE 3 POINT FIT IN'
     1' BGROUND2 FOR THIS DISTRIBUTION IS: ',F4.0)
      J1M=JMAX
      BMAX=0.
      WRITE(3,2761)
2761  FORMAT(1H1,15X,' 2THETA VS. AVE. BACKGROUND',//)
      DO 2710 I=1,JMAX
2710  IF(BM(I).GT.BMAX)BMAX=BM(I)
      ISTEP=(BMAX+10)/10
      STEP=ISTEP/10.
      TTHSTEP=(TTHMAX(1)-TTHMIN(1))/2
      DO 2716 I=JMAX,1,-1
        TTHAV=TTHMIN(I)+TTHSTEP
        WRITE(3,2711)TTHAV
        IF(BM(I).EQ.0)GOTO 2716
2711    FORMAT(F7.2,2X,'I')
        IX=(BM(I)/STEP+.5)+8
        WRITE(3,2712)
2712    FORMAT('+',<IX>X,'*')
2716  CONTINUE
      BINT(1)=0.
      DO 2718 I=2,11
2718  BINT(I)=BINT(I-1)+10*STEP
      WRITE(3,2719)BINT
2719  FORMAT(10X,'---------+---------+---------+---------+-----',
     1'----+---------+---------+---------+---------+---------+',/,
     2 3X,11F10.3,//,40X,' COUNTS PER SECOND')
      IF (JJJ.NE.0) GO TO 28
      NFILE2(1:NAMLEN)=NFILE(1:NAMLEN)
C   OPENING BGD FILE
      NAML2=NAMLEN+1
      NFILE2(NAML2:NAML2+3)='.BGD'
      OPEN(NAME=NFILE2,UNIT=NTOUT,TYPE='NEW',FORM='UNFORMATTED',
     1BLOCKSIZE=32768)
      WRITE(NTOUT)ND,ND1
      IF(ND.NE.0)WRITE(NTOUT)(IDD(II,1),IDD(II,2),II=1,ND)
      IF(ND1.NE.0)WRITE(NTOUT)(ID1(II),II=1,ND1)
      WRITE (NTOUT) JMAX,WID
      WRITE (NTOUT) (TTHMIN(I),BM(I),SSUM(I),I = 1,JMAX)
27    DO 30 I = 1,JMAX
30    FDIS(I) = BM(I)
      JJJ = JJJ + 1
      JMAX = 1
      NSFRST = 1
      NSLAST = N4
      GO TO 14
28    WRITE (NTOUT) JMAX,WID
      WRITE (NTOUT) (TTHMIN(I),BM(I),SSUM(I),I = 1,JMAX)
      CLOSE(UNIT=NTOUT,DISP='SAVE')
29    DIF = 0.0
      DO 31 I = 1,J1M
	IF (FDIS(I).LT.0.1) GO TO 31
	IF (BM(I).LT.0.01) GO TO 31
	DIF = DIF + FDIS(I) - BM(I)
31    CONTINUE
      WRITE (3,204) DIF
204   FORMAT (/,1X,'THE TOTAL DIFFERENCE BETWEEN THE MEAN VALUE OF',
     1' THE AVER. BACKGR. IN THE FIRST DIST. AND THAT IN THE',
     2' SECOND ONE IS', F10.5)
      NBAD=0
      DO 2047 I=1,NSLAST
C   LISTING REFLECTIONS WITH BACKGROUND DISCREPANCIES THAT WERE
C   INCLUDED IN THE DISTRIBUTIONS.
        TTH=Q1(I)
        B1=Q2(I)
        B2=Q3(I)
        SCR=Q4(I)
        SRAT=Q5(I)
        TBTS=Q6(I)
        JJ=TTH/WID+1
        TIME=(SCR/SRAT)*TBTS*60.
        BC=(B1+B2)/TIME
        BCSR=(SQRT(B1+B2))/TIME
        IF(ABS(BC-BM(JJ)).LE.3.*BCSR)GOTO 2047
        IF(NBAD.EQ.0)THEN
          WRITE(3,2048)
2048      FORMAT(1H1,' REFLECTIONS WITH BACKGROUND DISCREPANCIES:')
          NBAD=1
          WRITE(3,2049)
2049      FORMAT(/,'   ID     H     K     L       2TH      B1     B2 ',
     1' DEL/SIG',//)
          NOL=5
        ENDIF
        NOL=NOL+1
        IF(NOL.GT.82)THEN
          WRITE(3,2049)
          NOL=3
        ENDIF
        IB1=B1
        IB2=B2
        IF(BCSR.EQ.0.)THEN
          RATIO=0.
        ELSE
          RATIO=(BC-BM(JJ))/BCSR
        ENDIF
        WRITE(3,2046)NQ(I),HH(I),KK(I),LL(I),TTH,IB1,IB2,RATIO
2046    FORMAT(4I6,2X,F9.2,2I7,F8.2)
2047  CONTINUE
      IF(OCK.EQ.1)CLOSE(UNIT=NFIN,DISP='SAVE')
      RETURN
9988  WRITE(3,9989)
9989  FORMAT(' ERROR ON LIMIT CARD.  PERHAPS WIDTH IS A REAL NUMBER.',
     1' IT MUST BE AN INTEGER!')
      STOP
      END
