      SUBROUTINE BGROUND2
C  THIS PROGRAM DOES CORRECTIONS FOR BACKGROUNDS (AND THUS INTENSITIES
C  AND SIGMAS) BY USE OF THE DISTRIBUTIONS CREATED IN BACKGROUND AND
C  STORED ON THE BGD FILE
      INTEGER*2 IDHKL(4),ID,IDD(100,2),ID1(200),NDR(12),NDID(500),
     1 IRES(100,2),IRES1(200)
      CHARACTER*1 DASH(11)
      INTEGER*4 SYS$TRNLOG
      REAL  INTCOR,INT
      CHARACTER*17 NFILE,NBLANK
      CHARACTER*10 NAMDES
      CHARACTER*2 NT(10)
      DIMENSION REAL(13),TTHMIN(120),BM(120),SIGINT(120),
     1 AI11(120),AI12(120),AI22(120),AI(3,3,3),X1(120),X2(120),CARD(20)
      EQUIVALENCE(IDHKL(1),ID),(REAL(1),TTH),(REAL(4),RANGE),
     1(REAL(5),RATE),(REAL(6),B1),(REAL(7),SCAN),(REAL(8),B2),
     2(REAL(10),TBTS),(REAL(11),INTCOR),(REAL(12),SIGCOR),
     3(REAL(3),CHI),(REAL(9),EXPTM)
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B22,CARD
      DATA NBLK/'    '/
      PARAMETER ATT=20.9
      NBLANK='                 '
      A11=0.0
      A12=0.0
      A22=0.0
      A23=0.0
      A33=0.0
      Y1=0.0
      Y2=0.0
      NDTOT=0
      NLS1=0
      NBGD=12  ! NAME.BGD FILE
      NMAG=13  ! NAME.MAG FILE 
      NSCR=20  ! SCRATCH DISK
      NOPR=0
      ICC=0
      NRES=0
      NRES1=0
      NUMF=1
      DECODE(80,103,CARD)NT
C  TITLE CARD - VERSION NUMBERS OF MAG FILES ARE STORED IN NT.
C  DEFAULT IF NT IS BLANK IS TO USE THE HIGHEST VERSION MAG FILE
C  ONLY.  NMT IS THE NUMBER OF VERSION NUMBERS ENTERED
103   FORMAT(12X,10A2)
      DO 104 I=1,10
      IF(NT(I).EQ.'  ')GOTO 105
104   CONTINUE
105   NMT=I-1   ! NUMBER OF MAG FILES
      READ(1,1050)TTMIN,NDIST,CHIMIN,CHIMAX,NOLIS,tthlow,tthhi
1050  FORMAT(F5.0,I2,1X,2F7.2,1X,A4,11x,2f7.2)
C  TTMIN IS THE MIN 2TH INTERVAL TO USE IN 3-POINT FIT
C  NDIST IS THE NUMBER OF THE DISTRIBUTION TO BE USED - DEFAULT IS 1
C  IF NOLIS IS NONBLANK, NO PRINTED OUTPUT OF REFLECTIONS
C  CHIMIN AND CHIMAX DEFINE CHI INTERVAL TO ACCEPT REFLECTIONS - 
C  REFLECTIONS HAVING CHI VALUES OUTSIDE THIS INTERVAL ARE REFECTED.
C  DEFAULT FOR CHI VALUES IS NO DELETIONS ON THE BASIS OF CHI VALUES
c 2/13/96  tthlow is lower exclusive 2theta limit for using background
c          tthhi  is upper exclusive 2theta limit for using background
c    That is, reflns with tthlow < 2theta < tthhi will use background fit
      IF(NDIST.EQ.0)NDIST=1
      WRITE(3,106)TTMIN,NDIST
      IF(NOLIS.NE.NBLK)NOPR=1
      IF(NOPR.EQ.1)WRITE(3,1060)
1060  FORMAT(' NO LISTING OF REFLECTIONS.')
106   FORMAT(' 3-POINT CALCULATIONS START AT ',F5.0,/,' DISTRIBUTION ',
     1 I2,' FROM BGD FILE WILL BE USED.')
      IF(CHIMIN.NE.0.0.OR.CHIMAX.NE.0.0)ICC=1
C  ICC=1 SIGNALS THAT CHI LIMITS HAVE BEEN SET
      IF(ICC.EQ.1)THEN
      WRITE(3,1062)CHIMIN,CHIMAX
1062  FORMAT(' ONLY REFLECTIONS WITH CHI VALUES IN THE RANGE ',F8.2,
     1 ' TO ',F8.2,' WILL BE CORRECTED FOR BACKGROUND.')
      ELSE
      WRITE(3,1063)
1063  FORMAT(' NO RESTRICTIONS ON CHI VALUES.')
      ENDIF
c
      if (tthlow .lt. 0.0) tthlow=0.0
      IF(tthlow.gt.0. .or. tthhi.gt.0.0)THEN
       if (tthhi .le. tthlow) tthhi=180.
       WRITE(3,1064)tthlow,tthhi
 1064  FORMAT(' Only reflections with',F8.2,' < 2Theta <',
     1        F8.2,' will be corrected for background.')
      ELSE
       if (tthhi .eq. 0.0) tthhi=180.
       WRITE(3,1065)
 1065  FORMAT(' No restrictions on 2Theta values.')
      ENDIF
c
C  RETRIEVING FILE NAME FROM SYSTEM
      ICD=SYS$TRNLOG('NAM',NAMLEN,NAMDES,,,)
      IF(.NOT.ICD)THEN
      WRITE(3,901)
901   FORMAT('  ERROR ON RETURN FROM TRNLOG')
      RETURN
      ENDIF
C  OPENING BGD FILE
      NFILE(1:NAMLEN)=NAMDES
      N=NAMLEN+1
      NFILE(N:N+3)='.BGD'
      OPEN(NAME=NFILE,UNIT=NBGD,TYPE='OLD',FORM='UNFORMATTED',
     1 BLOCKSIZE=32768)
C  READING IN DELETIONS
      READ(NBGD)ND,ND1
      IF(ND.NE.0)READ(NBGD)(IDD(II,1),IDD(II,2),II=1,ND)
C   READING IN DELETIONS - GROUPS OF ID'S
      IF(ND1.NE.0)READ(NBGD)(ID1(II),II=1,ND1)
C   READING IN DELETIONS - SINGLE ID'S
      DO 107 II=1,NDIST
      READ(NBGD)JMAX,WID
      READ(NBGD)(TTHMIN(I),BM(I),SIGINT(I),I=1,JMAX)
107   CONTINUE
C   SEEING IF RESTORE OR DELETE CARDS ENTERED
1071  READ(1,108)CARD
108   FORMAT(20A4)
      IF(CARD(1).EQ.'END ')GOTO 1090
      IF(CARD(1).EQ.'REST')GOTO 1081
      IF(CARD(1).EQ.'DELE')GOTO 1083
      GOTO 904
1081  IF(CARD(3).EQ.'ALL ')THEN
C  RESTORE ALL - ALL DELETED REFLECTIONS RESTORED (INCLUDING THOSE
C  DELETED IN BACKGROUND AND LISTED ON BGD FILE.
      ND=0
      ND1=0
C  RESTORE ALL SETS DELETION POINTERS (READ IN FROM BGD FILE AND
C  INCREMENTED WHEN DELETE CARD ENCOUNTERED) TO 0.  THEREFORE, RESTORE
C  ALL SHOULD COME BEFORE ANY DELETES TO MAKE THE DELETES VALID.
      WRITE(3,906)CARD
      GOTO 1071
      ENDIF
C  HERE FOR RESTORING SINGLE OR RANGES OF REFLECTIONS - NOT ALL
      DECODE(80,1084,CARD)(NDR(I),DASH(I),I=1,11),NDR(12)
      WRITE(3,1088)(NDR(I),DASH(I),I=1,11),NDR(12)
1088  FORMAT(' RESTORE',11(I5,A1),I5)
      I=1
1091  IF(NDR(I).EQ.0)GOTO 1071
      IF(DASH(I).EQ.'-')THEN
C  DASH SIGNIFIES RANGE OF REFLECTIONS TO BE RESTORED
      NRES=NRES+1
      IF(NRES.GT.100)THEN
      NRES=100  ! PREVENT ARRAY OVERFLOW
      WRITE(3,1089)NDR(I)
1089  FORMAT(' RESTORATION ARRAY OVERFLOW - REFLECTION # ',I5,' NOT',
     1' RESTORED.')
      ENDIF
      IRES(NRES,1)=NDR(I)
C  IRES KEEPS TRACK OF RANGES OF RESTORED REFLECTIONS - NRES IS TOTAL
C  NUMBER OF RANGES OF RESTORED REFLECTIONS.
      IRES(NRES,2)=NDR(I+1)
      I=I+1
      ELSE
C  SINGLE REFLECTION TO BE RESTORED
      NRES1=NRES1+1
      IF(NRES1.GT.200)THEN
      NRES1=200  ! PREVENT ARRAY OVERFLOW
      WRITE(3,1089)NDR(I)
      ENDIF
      IRES1(NRES1)=NDR(I)
C  IRES1 KEEPS TRACK OF SINGLE RESTORED REFLECTIONS - NRES1 IS TOTAL
C  NUMBER OF SINGLE RESTORED REFLECTIONS
      I=I+1
      ENDIF
      IF(I.LE.12)GOTO 1091
      GOTO 1071
1083  DECODE(80,1084,CARD)(NDR(I),DASH(I),I=1,11),NDR(12)
C   DELETE CARDS
1084  FORMAT(7X,11(I5,A1),I5)
      WRITE(3,1086)(NDR(I),DASH(I),I=1,11),NDR(12)
1086  FORMAT(1X,'DELETE ',11(I5,A1),I5)
      I=1
1085  IF(NDR(I).EQ.0)GOTO 1071
      IF(DASH(I).EQ.'-')THEN
C  HYPHEN SIGNIFIES THAT A RANGE OF ID'S TO BE DELETED IS ENTERED
      ND=ND+1
      IF(ND.GT.100)THEN
C  NO MORE THAN 100 RANGES OF DELETION ID'S ALLOWED
      ND=100
      WRITE(3,1087)NDR(I)
1087  FORMAT(' DELETION ARRAY OVERFLOW - REFLECTION NO. ',I5,' NOT',
     1' DELETED.')
      ENDIF
      IDD(ND,1)=NDR(I)
      IDD(ND,2)=NDR(I+1)
      I=I+2
      ELSE
C  A SINGLE ID TO BE DELETED
      ND1=ND1+1
      IF(ND1.GT.200)THEN
C  NO MORE THAN 200 SINGLE DELETION ID'S ALLOWED
      ND1=200
      WRITE(3,1087)NDR(I)
      ENDIF
      ID1(ND1)=NDR(I)
      I=I+1
      ENDIF
      IF(I.LE.12)GOTO 1085
      GOTO 1071
1090  I=0
109   I=I+1
      IF(TTHMIN(I).GE.TTMIN)GOTO 112
C   HERE FOR TTH'S THAT CAN'T BE DONE BY 3-POINT CALCULATIONS
C   ONE LEAST SQUARES FIT IS DONE THROUGH ALL OF THESE GROUPS
      IF(SIGINT(I).EQ.0)GOTO 109
      NLS1=NLS1+1
      A11=A11+SIGINT(I)
      TTHMID=TTHMIN(I)+WID/2.         ! BJW 30-OCT-89
      TOT1=SIGINT(I)
      A12=A12+TOT1*TTHMID
      A22=A22+TOT1*TTHMID**2
      A23=A23+TOT1*TTHMID**3
      A33=A33+TOT1*TTHMID**4
      Y1=Y1+TOT1*BM(I)
      Y2=Y2+TOT1*BM(I)*TTHMID
      Y3=Y3+TOT1*BM(I)*TTHMID**2
      GOTO 109
112   IF(NLS1.GT.0.AND.NLS1.LT.4)WRITE(3,113)
113   FORMAT(' TOO FEW POINTS BELOW 3-POINT CUTOFF FOR LEAST SQUARES',
     1' CALCULATIONS.  THESE POINT WILL NOT HAVE',/,' A CORRECTED',
     2' BACKGROUND.')
      IF(NLS1.LT.4)GOTO 115
      CALL INVERSE3(A11,A12,A22,A12,A22,A23,A22,A23,A33,AI)
      X1(1)=AI(1,1,3)*Y1+AI(1,2,3)*Y2+AI(1,3,3)*Y3
      X2(1)=AI(1,2,3)*Y1+AI(2,2,3)*Y2+AI(2,3,3)*Y3
      X3=AI(3,1,3)*Y1+AI(3,2,3)*Y2+AI(3,3,3)*Y3
115   I=I+1
      IF((I+1).GT.JMAX)GOTO 118
      TOT1=SIGINT(I-1)
      TOT2=SIGINT(I)
      TOT3=SIGINT(I+1)
      IF(TOT1.EQ.0.)GOTO 902
      IF(TOT2.EQ.0.)GOTO 902
      IF(TOT3.EQ.0.)GOTO 902
      DET=4.*TOT1*TOT3+TOT2*(TOT1+TOT3)
      AI11(I)=(TOT1+TOT3)/DET
      AI12(I)=(TOT1-TOT3)/DET
      AI22(I)=(TOT1+TOT2+TOT3)/DET
      Y1=TOT1*BM(I-1)+TOT2*BM(I)+TOT3*BM(I+1)
      Y2=-1.*TOT1*BM(I-1)+TOT3*BM(I+1)
      X1(I)=AI11(I)*Y1+AI12(I)*Y2
      X2(I)=(AI12(I)*Y1+AI22(I)*Y2)/WID
      GOTO 115
118   JTOT=I+1
      CLOSE(UNIT=NBGD,DISP='SAVE')
      WRITE(3,1180)
1180  FORMAT(//' 2THETA RANGE',15X,'EQUATION FOR BCOR'/)
C  WRITING EQUATIONS FOR BCOR
      IF(NLS1.LT.4)WRITE(3,1181)TTMIN
1181  FORMAT('  UNDER ',F5.0,15X,'NO CORRECTION')
C  TOO FEW REFLECTIONS UNDER 2THETA CUTOFF POINT - NO CORRECTIONS DONE
C  FOR THOSE REFLECTIONS
      IF(NLS1.GE.4)WRITE(3,1182)TTMIN,X1(1),X2(1),X3
1182  FORMAT('  UNDER ',F5.0,8X,'BCOR=',F9.4,' + TTH*',F9.4,' + TTH**',
     1'2*',F9.4)
C  EQUATION FOR REFLECTIONS UNDER 2THETA CUTOFF
      I=0
1183  I=I+1
      IF(TTHMIN(I).LT.TTMIN)GOTO 1183
C  SPECIAL CASE IF ON 2THETA CUTOFF
      IF(TTHMIN(I).EQ.TTMIN)THEN
        WRITE(3,1184)TTHMIN(I),TTHMIN(I)+WID,X1(I+1),TTHMIN(I+1)+WID/2.,
     1 X2(I+1)
      ELSE
C  SPECIAL CASE IF LAST 2THETA RANGE
        IF(I.EQ.JMAX)THEN
          WRITE(3,1184)TTHMIN(I),TTHMIN(I)+WID,X1(I-1),TTHMIN(I-1)+WID
     1/2.,X2(I-1)
        ELSE
C  OTHER RANGES
          WRITE(3,1184)TTHMIN(I),TTHMIN(I)+WID,X1(I),TTHMIN(I)+WID/2.,
     1 X2(I)
        ENDIF
      ENDIF
      IF(I.LT.JMAX)GOTO 1183
1184  FORMAT(1X,F5.0,' -',F5.0,8X,'BCOR=',F9.4,' + (TTH -',F6.1,')*',
     1 F8.5)
      WRITE(3,1185)
1185  FORMAT(//' BCOR WRITTEN ON MAG FILE AND OUTPUT = BCOR*(RANGE/',
     1'SPEED)*TBTS*60')
      NFILE=NBLANK
      IF(NOPR.EQ.0)WRITE(3,1210)
      NOL=8  ! KEEPING TRACK OF NUMBER OF WRITTEN LINES ON PAGE
      NFILE(1:NAMLEN)=NAMDES
      N=NAMLEN+1
      NFILE(N:N+4)='.MAG;'
      IF(NMT.NE.0)THEN
      N=N+5
      NFILE(N:N+1)=NT(1)
      ENDIF
      OPEN(NAME=NFILE,UNIT=NMAG,TYPE='OLD',FORM='UNFORMATTED',
     1 BLOCKSIZE=32768)
      OPEN(NAME=NFILE,UNIT=NSCR,TYPE='NEW',FORM='UNFORMATTED',
     1 BLOCKSIZE=32768)
120   READ(NMAG)IDHKL,REAL
      real(1)=abs(real(1))
c     set two theta positive
      IF(ID.EQ.0)GOTO 125
      TSTB=1./TBTS
      IDA=IABS(ID)
      IF(ND.EQ.0)GOTO 1201
      IF(RATE.LT.0.0)GOTO 1192
C  RATE LESS THAN 0 MEANS DELETED REFLECTION - SEE IF RESTORED
      DO 1201 JJ=1,ND
C  CHECKING IF ID IS IN ONE OF THE DELETION RANGES
      IF(IDA.GE.IDD(JJ,1).AND.IDA.LE.IDD(JJ,2))GOTO 1192
1201  CONTINUE
      GOTO 1207
1192  IF(NRES.EQ.0)GOTO 1190
      DO 1190 I=1,NRES
C  SEEING IF REFLECTION IS IN ONE OF THE RESTORATION RANGES
      IF(IDA.GE.IRES(I,1).AND.IDA.LE.IRES(I,2))GOTO 1195
1190  CONTINUE
      IF(NRES1.EQ.0)GOTO 1191
      DO 1191 I=1,NRES1
C  SEEING IF ONE OF SINGLE RESTORED REFLECTIONS
      IF(IDA.EQ.IRES1(I))GOTO 1195
1191  CONTINUE
C  REFLECTIONS NOT RESTORED
      RATE=-RATE
C ****************************************************************
C  DELETED REFLECTIONS ARE MARKED WITH NEGATIVE SCAN SPEEDS! THEREFORE
C  THEY ARE NOT REMOVED COMPLETELY FROM THE MAG FILE AND MAY BE 
C   USED IN INITIA IF NEEDED
C ****************************************************************
      NDTOT=NDTOT+1
      IF(NDTOT.GT.500)NDTOT=500  ! PREVENT ARRAY OVERFLOW
      NDID(NDTOT)=ID
1195  GOTO 1202
1207  IF(ND1.EQ.0)GOTO 1202
      DO 1203 JJ=1,ND1
C   CHECKING TO SEE IF ID IS ONE OF THE SINGLY DELETED ID'S
      IF(IDA.EQ.ID1(JJ))GOTO 1192
1203  CONTINUE
1202  J=TTH/WID+1
c
      IF(tth.Le.tthlow .OR. tth.Ge.tthhi)THEN
C  NO CORRECTION APPLIED TO REFLECTIONS OUTSIDE 2theta LIMIT
       SIGCOR=SQRT(RATE**2*(SCAN+(B1+B2)*(1./TBTS)**2))
       INTCOR=(SCAN-(B1+B2)*(1./TBTS))*ABS(RATE)
       BCOR=0.0
       SIGBAC=0.0
       IF(EXPTM.LT.0.0)THEN
C  EXPTM LT 0.0 MEANS ATTENUATOR WAS SET
        SIGCOR=SIGCOR*ATT
        INTCOR=INTCOR*ATT
       ENDIF
       GOTO 121
      ENDIF
c
      IF(ICC.EQ.0)GOTO 1204
      CHICK=CHI
C  CHECKING IF REFLECTION OUTSIDE CHI LIMIT
      IF(CHICK.GT.180.)CHICK=CHICK-360.
      IF(CHICK.LT.CHIMIN.OR.CHICK.GT.CHIMAX)THEN
C  NO CORRECTION APPLIED TO REFLECTIONS OUTSIDE CHI LIMIT
      SIGCOR=SQRT(RATE**2*(SCAN+(B1+B2)*(1./TBTS)**2))
      INTCOR=(SCAN-(B1+B2)*(1./TBTS))*ABS(RATE)
      BCOR=0.0
      SIGBAC=0.0
      IF(EXPTM.LT.0.0)THEN
C  EXPTM LT 0.0 MEANS ATTENUATOR WAS SET
        SIGCOR=SIGCOR*ATT
        INTCOR=INTCOR*ATT
      ENDIF
      GOTO 121
      ENDIF
1204  IF(TTHMIN(J).LT.TTMIN)THEN
      IF(NLS1.LT.4)THEN
C  HERE IF TOO FEW POINTS FOR LEAST SQUARES FIT UNDER 3-POINT CUTOFF.
C  SIGMA AND INT WILL NOT BE CORRECTED FOR BACKGROUND.
      SIGCOR=SQRT(RATE**2*(SCAN+(B1+B2)*(1./TBTS)**2))
      INTCOR=(SCAN-(B1+B2)*(1./TBTS))*ABS(RATE)
      IF(EXPTM.LT.0.0)THEN
C  EXPTM LT 0.0 MEANS ATTENUATOR WAS SET
        SIGCOR=SIGCOR*ATT
        INTCOR=INTCOR*ATT
      ENDIF
      SIGBAC=0.0
      BCOR=0.0
      GOTO 121
      ENDIF
C  HERE FOR REFLECTIONS WITH 2THETAS LESS THAN 3-POINT CUTOFF
      DELT=TTH
      J=1
      ELSE
C  HERE FOR REFLECTIONS IN 3-POINT CALCULATION RANGE
      IF(TTHMIN(J).EQ.TTMIN)J=J+1
C  IF J IS ON LOWER BORDER, USE J,J+1 AND J+2 CALCULATIONS RATHER THAN
C  J-1, J AND J+1
      IF(J.GE.JMAX)J=J-1
C  IF J IS ON UPPER BORDER, USE J, J-1 AND J-2 CALCULATIONS
      DELT=TTH-(TTHMIN(J)+WID/2)
      ENDIF
      IF(J.EQ.1)THEN
C  QUADRATIC FIT BELOW 2THETA CUTOFF
        BCOR=X1(J)+X2(J)*DELT+X3*DELT**2
        SIGBAC=SQRT(AI(1,1,3)+2*AI(1,2,3)*DELT+2*AI(1,3,3)*DELT**2+
     1 AI(2,2,3)*DELT**2+2*AI(2,3,3)*DELT**3+AI(3,3,3)*DELT**4)
      ELSE
        BCOR=X1(J)+X2(J)*DELT
        SIGBAC=SQRT(AI11(J)+2*AI12(J)*DELT+AI22(J)*DELT**2)
      ENDIF
      TIME=RANGE/ABS(RATE)*TBTS*60.
      BCOR=BCOR*TIME
      SIGBAC=SIGBAC*TIME
      cscan=scan
      catt=1.
      IF(EXPTM.LT.0.0) then
       cscan=scan*ATT
       catt=att
      endif
      SIGCOR=SQRT(RATE**2*(cSCAN*catt+(SIGBAC**2)*TSTB**2))
      INTCOR=(cSCAN-BCOR*TSTB)*ABS(RATE)
121   IF(SPEED.LT.0.0)GOTO 123
      INT=(SCAN-(B1+B2)*TSTB)*ABS(RATE)
      SIG=SQRT(RATE**2*(SCAN+(B1+B2)*TSTB**2))
      IF(EXPTM.LT.0.0)THEN
C  EXPTM LT 0.0 MEANS ATTENUATOR WAS SET
        SIG=SIG*ATT
        INT=INT*ATT
      ENDIF
      IB1=B1
      IB2=B2
      IBCOR=BCOR
      ISCAN=SCAN
      IF(NOL.GT.82)THEN
      IF(NOPR.EQ.0)WRITE(3,1210)
1210  FORMAT(1H1,'    H    K    L       2TH     B1    SCAN  ',
     1'  B2       INT      SIG    BCOR  SIG(BC)   INTCOR  SIG(INT)',
     2' SPEED RANGE TBTS ' //)
      NOL=3
      ENDIF
      IF(NOPR.EQ.0)WRITE(3,122)(IDHKL(j),j=2,4),
     2  TTH,B1,SCAN,B2,INT,SIG,BCOR,
     1 SIGBAC,INTCOR,SIGCOR,RATE,RANGE,TBTS
122   FORMAT(3I5,F9.2,f8.2,f10.2,f8.2,F11.2,F8.2,f5.2,F8.2,F11.2,
     1    F8.2,F7.2,F6.2,F9.4)
      NOL=NOL+1
123   WRITE(NSCR)IDHKL,REAL
      GOTO 120
125   WRITE(NSCR)IDHKL,REAL
      CLOSE(UNIT=NMAG,DISP='DELETE')
c  close-open-close in order to keep old version number
      CLOSE(UNIT=NSCR,DISP='save')
      n=namlen+6
      nfile(n:n+1)=nt(numf)
      open(name=nfile,unit=nmag,type='old',form='unformatted',
     1 blocksize=32768)
      close(unit=nmag,disp='save')
      NUMF=NUMF+1
      IF(NUMF.LE.NMT)THEN
      N=NAMLEN+6
      NFILE(N:N+1)=NT(NUMF)
      OPEN(NAME=NFILE,UNIT=NMAG,TYPE='OLD',FORM='UNFORMATTED',
     1 BLOCKSIZE=32768)
      GOTO 120
      ENDIF
C  LISTING DELETED REFLECTIONS
      IF(NDTOT.EQ.0)GOTO 1270
      I=0
      WRITE(3,1251)
1251  FORMAT(//,' THE FOLLOWING REFLECTIONS HAVE BEEN MARKED AS',
     1 'DELETED ON THE MAG FILE: ',/)
      IF(NDTOT.GE.500)WRITE(3,1259)
1259  FORMAT(' NOTE: ONLY THE FIRST 500 REFLECTIONS WRITTEN HERE.')
1250  I=I+1
      I1=I*15-14
      I2=I*15
      IF(I2.GT.NDTOT)I2=NDTOT
      WRITE(3,126)(NDID(II),II=I1,I2)
126   FORMAT(1X,15(I5,1X))
      IF(I2.LT.NDTOT)GOTO 1250
1270  RETURN
902   WRITE(3,903)TTHMIN(I),TTHMIN(I)+WID
903   FORMAT(' IN 2TH RANGE ',F5.0,' TO ',F5.0,' THERE ARE NO ',
     1 ' REFLECTIONS.  CHOOSE A DIFFERENT TTMIN.')
      CLOSE(UNIT=NBGD,DISP='SAVE')
      STOP
904   WRITE(3,905)
905   FORMAT(' UNRECOGNIZED COMMAND - PROGRAM STOPPED')
      WRITE(3,906)CARD
906   FORMAT(20A4)
      STOP
      END
