      SUBROUTINE CONVERT
C  THIS PROGRAM READS CRYM FORMAT COORD, ANISO AND ISO CARDS AND
C  CONVERTS THEM TO THE FORMAT AND ORDER DEMANDED BY ORTEP.
C  CARDS TO BE CONVERTED MAY BE READ FROM A NAME.CRD FILE OR INCLUDED
C  IN THE INPUT FILE.
C  YOU MAY SPECIFY ATOM TYPES NOT TO BE CONVERTED (I.E. HS) AND/OR
C  INDIVIDUAL ATOMS TO BE CONVERTED.
C  SYMMETRY TRANSLATIONS TO BE APPLIED TO ALL CONVERTED ATOMS MAY BE
C  SPECIFIED.
      DIMENSION X(600),Y(600),Z(600),B(600,6),TEMP(600,6),DUM(4),
     1SYM(10,3)
      CHARACTER*4 CARD(20)
      character*6 an(600),at(600),a1,atom(100)
      CHARACTER*3 OMIT(10),AK(600),NCRD
      CHARACTER*1 C30(30)
      CHARACTER*30 CHAR
      CHARACTER*2 NVERS
      CHARACTER*1 UCK(600)
      CHARACTER*16 NFILE,NFILE2
      INTEGER*2 ICK(600),ITYPE(600),ISYM(10,3)
      EQUIVALENCE(C30(1),CHAR)
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD
      COMMON/FNAME/NFILE,NAMLEN
      DO 100 I=1,600
100   ICK(I)=0
      NOA=0
      NSYM=0
      NATOM=0
      NOMIT=0
      NOI=0
      NFILE2=NFILE
      N=NAMLEN+1
      NFILE(N:N+4)='.CRD;'
      NFILE2(N:N+3)='.CVT'
      DECODE(80,101,CARD)NCRD,NVERS
C  SEE IF VERSION OF NAME.CRD FILE ENTERED
101   FORMAT(8X,A3,A2)
      IF(NVERS.NE.'  ')THEN
         N=N+5
         NFILE(N:N+1)=NVERS
      ENDIF
205   READ(1,102)CARD
102   FORMAT(20A4)
      IF(CARD(1).EQ.'SYM ')GOTO 200
      IF(CARD(1).EQ.'ATOM')GOTO 300
      IF(CARD(1).EQ.'OMIT')GOTO 400
      IF(CARD(1).EQ.'END ')GOTO 2050
C  COORD OR TEMP CARDS ENTERED
      NFIL=1
      GOTO 2051
200   NSYM=NSYM+1
C  SYMMETRY CARDS HERE
      DECODE(80,201,CARD)CHAR
      WRITE(3,102)CARD
201   FORMAT(4X,A30)
      ILEN=0
      DO 203 K=1,3
C  TRANSLATING SYM CARDS - SYMMETRY ENTERED IN "FREE FORMAT".  
C  FOR EX. -1/2-X, 1+Y,-Z
C  FRACTIONS SPECIFIED WITH "/" (I.E. 1/2, NOT .5)
C  SPACES NO PROBLEM
C  ONLY RESTRICTIONS ARE THAT COMMAS SEPARATE X, Y, AND Z SPECIFIERS
C  AND THAT IF A DIVIDE SIGN IS USED (1/3,1/2, ETC.) THE TWO DIVISORS
C  NEED TO BE RIGHT NEXT TO THE "/" SIGN (NO SPACES).
C  SYM(I,J): FOR THE I"TH SYMMETRY; THE CONSTANT TO BE ADDED TO 
C  X (J=1), Y (J=2), AND Z (J=3).
C  ISYM(I,J): FOR THE I"TH SYMMETRY; TELLS WHETHER TO ADD (ISYM=0)
C  OR SUBTRACT (ISYM=1) X (J=1), Y(J=2), AND Z(J=3).
C  I.E., IF ISYM(I,1)=0 THEN
C              XNEW=SYM(I,1)+X
C          ELSE (ISYM(I,1)=1)
C              XNEW=SYM(I,1)-X
        SYM(NSYM,K)=0.0
        ISYM(NSYM,K)=0
        I=INDEX(CHAR,',')
C  LOOKING FOR "," WHICH SEPARATES X, Y, AND Z SPECIFIERS
        IF(I.EQ.0)I=30
C  I MARKS END FIELD OF SPECIFIER, ILEN IS STARTING FIELD
        C30(I)=' '
        J=INDEX(CHAR,'/')
C  ANY FRACTIONS?
        IF(J.GT.ILEN.AND.J.LT.I)THEN
          N=J-2
          IF(N.EQ.0)THEN
            DECODE(30,2022,CHAR)II
C  DECODE DIVISORS ON EITHER SIDE OF "/" SIGN
          ELSE
            DECODE(30,202,CHAR)II
          ENDIF
202       FORMAT(<N>X,I1)
          N=J
          DECODE(30,202,CHAR)JJ
          AA=II
          BB=JJ
          SYM(NSYM,K)=AA/BB
          CHAR(J-1:J+1)='   '
        ELSE
          DO 2020 JJ=ILEN+1,I-1
C  LOOK FOR WHOLE NUMBERS TO BE ADDED OR SUBTRACTED
            IF(C30(JJ).EQ.'+'.OR.C30(JJ).EQ.'-')GOTO 2020
            IF(C30(JJ).EQ.' ')GOTO 2020
            IF(C30(JJ).EQ.'X'.OR.C30(JJ).EQ.'x')GOTO 2020
            IF(C30(JJ).EQ.'Y'.OR.C30(JJ).EQ.'y')GOTO 2020
            IF(C30(JJ).EQ.'Z'.OR.C30(JJ).EQ.'z')GOTO 2020
            N=JJ-1
            IF(N.EQ.0)THEN
              DECODE(30,2022,CHAR)II
C  DECODE WHOLE NUMBER
2022          FORMAT(I1)
            ELSE
              DECODE(30,202,CHAR)II
            ENDIF
            SYM(NSYM,K)=II
            C30(JJ)=' '
            GOTO 2021
2020        CONTINUE
          N=0
2021    ENDIF
        J=INDEX(CHAR,'-')
C  LOOKING FOR "-" SIGN BEFORE CONSTANT
        IF(J.GT.ILEN.AND.J.LT.N)THEN
          SYM(NSYM,K)=-SYM(NSYM,K)
          C30(J)=' '
        ENDIF
        J=INDEX(CHAR,'-')
C  LOOKING FOR "-" SIGN BEFORE X, Y, OR Z
        IF(J.GT.ILEN.AND.J.LT.I)THEN
          ISYM(NSYM,K)=1
          C30(J)=' '
        ENDIF
        ILEN=I
203   CONTINUE
      GOTO 205
300   NATOM=NATOM+1
      DECODE(80,301,CARD)(ATOM(I),I=NATOM,NATOM+9)
C  INDIVIDUAL ATOM IDENTIFIERS OF ATOMS TO BE INCLUDED.  IF NO ATOM
C  TYPES HAVE BEEN OMITTED ON AN OMIT CARD, ONLY ATOMS LISTED ON THE
C  ATOM CARDS WILL BE CONVERTED.  IF ATOM TYPES HAVE BEEN OMITTED,
C  ATOMS ON THE ATOM CARD OVERRIDE THIS OMISSION.
      WRITE(3,102)CARD
301   FORMAT(5X,10(A6,1X))
      DO 302 I=1,10
        IF(ATOM(I).EQ.'      ')GOTO 303
302   CONTINUE
      I=11
303   NATOM=NATOM+(I-1)
      GOTO 205
400   DECODE(80,401,CARD)OMIT
      WRITE(3,102)CARD
C  OMIT CARDS - ATOM TYPES ARE LISTED.  ALL ATOMS WITH SPECIFIED TYPES
C  WILL NOT BE CONVERTED (UNLESS LISTED ON AN ATOM CARD).
401   FORMAT(5X,10(A3,1X))
      DO 402 I=1,10
        IF(OMIT(I).EQ.'   ')GOTO 403
402   CONTINUE
      I=11
403   NOMIT=I-1
      GOTO 205
2050  IF(NCRD.NE.'CRD')GOTO 120  ! END
       NFIL=18
C  READING FROM CRD FILE
       OPEN(NAME=NFILE,UNIT=18,TYPE='OLD',FORM='FORMATTED',
     1 BLOCKSIZE=32768)
       READ(18,102,end=120)CARD
       WRITE(3,1021)
2051  OPEN(NAME=NFILE2,UNIT=17,TYPE='NEW',FORM='FORMATTED',
     1 BLOCKSIZE=32768)
1021  FORMAT(' COORD, ANISO AND ISO CARDS WILL BE READ FROM NAME.CRD',
     1 ' FILE.')
1000   WRITE(3,1023)CARD
1023  FORMAT(1X,20A4)
      IF(CARD(1).EQ.'END ')GOTO 120
      IF(CARD(1).EQ.'SYM ')GOTO 200
      IF(CARD(1).EQ.'ATOM')GOTO 300
      IF(CARD(1).EQ.'OMIT')GOTO 400
      IF(CARD(1).NE.'COOR')GOTO 105
C  READING COORD CARDS HERE
      NOA=NOA+1
      IF(NOA.GT.601)THEN  ! PREVENT ARRAY OVERFLOW
         WRITE(3,902)
         RETURN
      ENDIF
902   FORMAT(' ONLY 600 ATOMS ACCEPTED')
      DECODE(80,103,CARD)AT(NOA),AK(NOA),X(NOA),Y(NOA),Z(NOA)
103   FORMAT(6X,A6,A3,3F9.6)
      ICK(NOA)=1
C  ICK USED AS CHECK TO MAKE SURE THAT COORESPONDING COORD AND TEMP 
C  CARDS ARE ENTERED.
      GOTO 114
105   IF(CARD(1).NE.'ANIS')GOTO 110
C  ANISO CARDS READ HERE
      NOI=NOI+1
      IF(NOI.GT.601)THEN  ! PREVENT ARRAY OVERFLOW
         WRITE(3,902)
         RETURN
      ENDIF
      DECODE(80,106,CARD)UCK(NOI),AN(NOI),(TEMP(NOI,I),I=1,6)
106   FORMAT(5X,A1,A6,6F10.6)
      GOTO 114
110   IF(CARD(1).NE.'ISO ')GOTO 114
C  ISO CARDS READ HERE
      NOI=NOI+1
      IF(NOI.GT.600)THEN  ! PREVENT ARRAY OVERFLOW
         WRITE(3,902)
         RETURN
      ENDIF
      DECODE(80,111,CARD)AN(NOI),TEMP(NOI,1)
111   FORMAT(6X,A6,F13.5)
      TEMP(NOI,3)=0.0
114   READ(NFIL,102,end=120)CARD
      GOTO 1000  ! READ NEXT CARD
120   IF(NFIL.EQ.1.AND.NCRD.EQ.'CRD')GOTO 2050
C  COORDS AND ANISOS INCLUDED IN INPUT FILE AS WELL AS CRD FILE
      DO 119 I=1,NOI
      DO 115 J=1,NOA
C  MATCHING COORD AND TEMPS BY ATOM IDENTIFIER
      IF(AN(I).EQ.AT(J))GOTO 116
115   CONTINUE
C  HERE IF NO MATCH FOR TEMP AN(I)
      A1=AN(I)
      GOTO 904
116   IF(ICK(J).NE.1)THEN
C  ICK SHOULD = 1.  IF NOT, MEANS MATCH PREVIOUSLY FOUND FOR COORD.
         A1=AN(I)
         GOTO 904
      ENDIF
      IF(TEMP(I,3).EQ.0.0)THEN
C  ISO 
         B(J,1)=TEMP(I,1)
         B(J,3)=0.0
      ELSE
C  ANISO
        ITYPE(J)=1
        IF(UCK(I).EQ.'U')ITYPE(J)=8
C  IF ANISO U'S ARE ENTERED, AN 8 IS ENTERED IN COLUMN 72. FOR ANISO
C  B'S, A 6 IS ENTERED.
         DO 117 II=1,6
         B(J,II)=TEMP(I,II)
117      CONTINUE
      ENDIF
      ICK(J)=0
119   CONTINUE
      DO 121 I=1,NOA
      IF(ICK(I).NE.0)THEN
C  ICK=1 IF NO MATCH FOUND FOR COORD
         A1=AT(I)
         GOTO 904
      ENDIF
121   CONTINUE
      IFLAG=1
C  IFLAG IS FLAG TELLING WHETHER OR NOT ANY CARD HAS BEEN ENCODED.
C  ALL CARDS ARE ENCODED FIRST AND WRITTEN WHEN NEXT CARD IS ENCODED.
C  THIS IS SO THAT THE LAST TEMPERATURE CARD MAY BE MARKED WITH A 
C  "1" IN THE FIRST COLUMN AT THE END.
      DO 125 I=1,NOA
        ICH=0
        IF(NOMIT.EQ.0)GOTO 1212
C  HERE IF ATOM TYPES HAVE BEEN OMITTED
        DO 1210 K=1,NOMIT
          IF(OMIT(K).EQ.AK(I))THEN
            ICH=1
            GOTO 1212
          ENDIF
1210    CONTINUE
1212    IF(NATOM.EQ.0)GOTO 1215
        IF(NOMIT.EQ.0)ICH=1
C  ICH SPECIFIES IF AN ATOM SHOULD BE OMITTED.  IF OMIT CARDS ARE
C  INCLUDED, ATOMS OF SPECIFIED TYPE ARE MARKED.  THEY WILL NOT BE
C  CONVERTED UNLESS LISTED INDIVIDUALLY ON AN ATOM CARD.  IF NO
C  OMIT CARDS ARE INCLUDED, ONLY ATOMS ON ATOM CARDS WILL BE CONVERTED.
        DO 1213 K=1,NATOM
          IF(ATOM(K).EQ.AT(I))THEN
            ATOM(K)='      '
            ICH=0
            GOTO 1215
          ENDIF
1213    CONTINUE
1215    IF(ICH.EQ.1)GOTO 125
        IF(IFLAG.NE.1)THEN
          WRITE(3,102)CARD
          WRITE(17,102)CARD
        ENDIF
        ENCODE(80,122,CARD)AT(I),X(I),Y(I),Z(I)
        IFLAG=0
122     FORMAT(a6,21X,3F9.6)
        WRITE(3,102)CARD
        WRITE(17,102)CARD
        IF(B(I,3).EQ.0.0)THEN
C  ISO
          ENCODE(80,123,CARD)B(I,1)
        ELSE
C  ANISO B OR U
          ENCODE(80,124,CARD)(B(I,J),J=1,6),ITYPE(I)
        ENDIF
123     FORMAT(1X,F8.5,53X,'6')
124     FORMAT(1X,F8.6,5F9.6,8X,I1)
        IF(NSYM.EQ.0)GOTO 125
        DO 1245 II=1,NSYM
C  CREATING COORDS AND TEMPS RELATED BY SYMMETRY
          IF(ISYM(II,1).EQ.0)THEN
            XX=SYM(II,1)+X(I)
          ELSE
            XX=SYM(II,1)-X(I)
          ENDIF
          IF(ISYM(II,2).EQ.0)THEN
            YY=SYM(II,2)+Y(I)
          ELSE
            YY=SYM(II,2)-Y(I)
          ENDIF
          IF(ISYM(II,3).EQ.0)THEN
            ZZ=SYM(II,3)+Z(I)
          ELSE
            ZZ=SYM(II,3)-Z(I)
          ENDIF
          IF(XX.EQ.X(I).AND.YY.EQ.Y(I).AND.ZZ.EQ.Z(I))GOTO 1245
C  MAKE SURE RESULTING COORD IS NOT SAME AS ORIGINAL COORD
          WRITE(3,102)CARD
          WRITE(17,102)CARD
          ENCODE(80,122,CARD)AT(I),XX,YY,ZZ
          WRITE(3,102)CARD
          WRITE(17,102)CARD
          IF(B(I,3).EQ.0.0)THEN
            ENCODE(80,123,CARD)B(I,1)
C  ISO - NO CHANGE
          ELSE
C  ANISO - NO CHANGE IN 11,22, AND 33 TERMS.  12,13, AND 23 GET
C  SIGN FROM X AND Y, X AND Z, AND Y AND Z RESPECTIVELY.
            B4=B(I,4)
            IF(ISYM(II,1)+ISYM(II,2).EQ.1)B4=-B4
            B5=B(I,5)
            IF(ISYM(II,1)+ISYM(II,3).EQ.1)B5=-B5
            B6=B(I,6)
            IF(ISYM(II,2)+ISYM(II,3).EQ.1)B6=-B6
            ENCODE(80,124,CARD)(B(I,J),J=1,3),B4,B5,B6,ITYPE(I)
          ENDIF
1245    CONTINUE
125   CONTINUE
      C30(1)='1'
C  LAST TEMP CARD MARKED WITH 1 IN COLUMN 1.
      ENCODE(1,1250,CARD(1)),C30(1)
1250  FORMAT(A1)
      WRITE(3,102)CARD
      WRITE(17,102)CARD
      IF(NATOM.EQ.0)GOTO 1252
      DO 1252 I=1,NATOM
C  LOOKING TO SEE IF ANY OF THE ATOMS ON AN ATOM CARD WERE NOT FOUND
C  AND HENCE NOT CONVERTED.
        IF(ATOM(I).NE.'      ')WRITE(3,1251)ATOM(I)
1251    FORMAT(' ATOM ',A6,' AS SPECIFIED ON YOUR ATOM CARD WAS NOT',/,
     1  ' FOUND.  IT IS NOT CONVERTED.')
1252  CONTINUE
      CLOSE(UNIT=17,DISP='SAVE')
      IF(NFIL.EQ.18)CLOSE(UNIT=18,DISP='SAVE')
      RETURN
904   WRITE(3,905)A1
C  HERE FOR PROBLEM
905   FORMAT(' ATOM IDENTIFIER PROBLEM WTH ATOM ',A6)
      RETURN
      END
