      SUBROUTINE CRYSTAL
C  SUBROUTINE FOR CRYM PROGRAM CRYSTAL DATA WHICH CALCULATED THE CELL
C  DENSITY, CELL VOLUME, SIGMA OF THE CELL VOLUME, ABSORPTION COEFF.,
C  AND ROUNDED OF CELL PARAMETERS.
C  COURTESY LARRY HENLING. 
C  INCORPORATED INTO CRYM 6/88 BY KMS
      DIMENSION ATWT(12),ATMURO(12),ATNO(12),ATFR(12,3),MK1(12),
     1 MK(12),KNF(12),QFT(12,30),DUMA(4),DUMB(4),atbarn(12),
     2 TPICS(12),ATNUM(12)
c  note ATNO is number of each type of atom
c       ATNUM is atomic number 
      INTEGER*4 NSA,NSB,NSC,NAL,NBE,NGA
      CHARACTER*2 TARGET
      CHARACTER*4 WORD
      CHARACTER*80 CARD
      CHARACTER*16 ANAM
      CHARACTER*32 NAME
      include '($RMSDEF)'
      INTEGER*4 FILESTAT,STATUS
      COMMON/FNAME/ANAM,NAMLEN
      DATA MK1/12*'   '/
  100 FORMAT(6HCELL  3F8.5,3F8.4,10X,A3)
159   FORMAT('0  CELL PARAMETERS '/'0',3F9.5,3F9.4,:,/'0',
     +3F9.5,3F9.4)
  175 FORMAT(6HKIND F,12A3,4x,I2,30x,a2)
  176 FORMAT('0KIND F',10X,12(2X,A3),1x,I2,1x,a2)
  131 FORMAT (10F8.3/10F8.3/10F8.3/2A3)
  132 FORMAT(' ',10F8.3/' ',10F8.3/' ',10F8.3/2(1X,A3))
 4107 FORMAT('0ATOM WEIGHT NOT FOUND FOR EQUIVALENT ATOM')
 4116 FORMAT('0NUMBER OF ATOMS ',12F5.1////)
 4118 FORMAT(' CELL'3(F9.3'('I2')')3(F8.2'('I2')'))
 4119 FORMAT (' V = ',F9.1,'(',I2,') A**3') 
201   FORMAT(4X,I3)
203   FORMAT(' WEIGHT = ',F9.3)
      IOP15=0
      I=NAMLEN+1
      ANAM(I:I+3)='.INF'
      NAME(1:16)=ANAM
      STATUS=FILESTAT(NAME)
C      OPEN(NAME=ANAM,UNIT=15,TYPE='OLD',FORM='FORMATTED',ERR=200)
      IF(STATUS.EQ.RMS$_NORMAL.OR.STATUS.EQ.RMS$_FLK)IOP15=1 !INF EXISTS
c      write(3,9000)iop15
c9000  format('   iop15=',i3)
200   READ(1,100)A,B,C,ALPHA,BETA,GAMMA,KCK
C  READ IN OF CELL CARD
C  KCK IS THREE BLANKS - USED TO COMPARE TO KIND F IDENTIFIERS TO FIND 
C  LAST ONE
      READ(1,4117)SIGA,SIGB,SIGC,SIGAL,SIGBE,SIGGA
4117  FORMAT('CELSIG',3F8.5,3F8.4)
C  READ IN OF CELSIG CARD
      WRITE(3,159)A,B,C,ALPHA,BETA,GAMMA,SIGA,SIGB,SIGC,SIGAL,SIGBE,
     1            SIGGA
C GET ROUNDED OFF LENGTHS,SIGMAS
      ATEM=ANINT(1000.*A)/1000.
      BTEM=ANINT(1000.*B)/1000.
      CTEM=ANINT(1000.*C)/1000.
      NSA = SIGA * 1000. + 0.5
      NSB = SIGB * 1000. + 0.5
      NSC = SIGC * 1000. + 0.5
      NAL = SIGAL * 100. + 0.5
      NBE = SIGBE * 100. + 0.5
      NGA = SIGGA * 100. + 0.5
C GET ROUNDED OFF ANGLES,SIGMAS . CONVERT FROM DEGREES
      AALFA=ANINT(100.*ALPHA)/100.
      ALFA = 3.14159 * AALFA / 180.
      ABETUH=ANINT(100.*BETA)/100.
      BETUH = 3.14159 * ABETUH / 180.
      AGAMA=ANINT(100.*GAMMA)/100.
      GAMA = 3.14159 * AGAMA / 180.
C
      SIGA=FLOATJ(NSA)/1000.
      SIGB=FLOATJ(NSB)/1000.
      SIGC=FLOATJ(NSC)/1000.
      SIGAL=FLOATJ(NAL)/100.
      DAL = SIGAL/57.2958
      SIGBE=FLOATJ(NBE)/100.
      DBE = SIGBE/57.2958
      SIGGA=FLOATJ(NGA)/100.
      DGA = SIGGA/57.2958
C CALCULATIONS FROM WPS VIA REDUC.FOR TO GET VOLUME DETAILS
      FNC = SQRT(1.0-(COS(ALFA))**2-(COS(BETUH))**2-(COS(GAMA))**2
     1           + 2.*(COS(ALFA)*COS(BETUH)*COS(GAMA)))
      PT1A=(SIN(ALFA)*(COS(ALFA)-COS(BETUH)*COS(GAMA))*DAL) 
      PT1B=(SIN(BETUH)*(COS(BETUH)-COS(ALFA)*COS(GAMA))*DBE)
      PT1C=(SIN(GAMA)*(COS(GAMA)-COS(ALFA)*COS(BETUH))*DGA)
      PART1=((ATEM*BTEM*TEMC)/FNC)**2*((PT1A)**2+(PT1B)**2+(PT1C)**2) 
      PART2=FNC**2*((ATEM*BTEM*SIGC)**2+(ATEM*CTEM*SIGB)**2+
     1      (BTEM*CTEM*SIGA)**2)
      VOL = ATEM*BTEM*CTEM*FNC
      SIGV = SQRT(PART1 + PART2)
      NSIGV=ANINT(10.*SIGV)
C     END OF ROUNDED OFF CELL PARAMETER CALCULATION
      READ(1,175)KNF,NRED,target
      if (target .ne. 'CU') target='MO'
C  READING IN OF KIND F
      WRITE(3,176)KNF,NRED,target
      NQ=0
2222  NQ=NQ+1
      IF(NQ.EQ.12)GOTO 2223
      IF(KNF(NQ).NE.KCK)GOTO 2222
      NQ=NQ-1
2223  IF(NRED.NE.O)THEN
        DO K=1,NRED
C MK1(K) IS ATOMIC SYMBOL OF READ IN FORM FACTOR
          READ(1,131)(QFT(K,L),L=1,30),MK(K),MK1(K)
          WRITE(3,132)(QFT(K,L),L=1,30),MK(K),MK1(K)
        ENDDO
      ENDIF
      READ(1,4109)ATNO
C  READ IN OF NUMBER OF ATOMS CARD
 4109 FORMAT(20X,12F4.0)
      WRITE(3,4116) ATNO
      SAT=0.0
      DO I=1,12
        SAT=ATNO(I)+SAT
      ENDDO
      IF (SAT.EQ.0.0)GO TO 4108 
      DO 4100 I=1,NQ
        IF(NRED.NE.0)THEN
          DO K=1,NRED
            IF(MK(K).EQ.KNF(I))GO TO 4104
          ENDDO
        ENDIF
C CALL FFBC FOR ATOMIC MASS, abs stuff FOR MOLY,copper ONLY
 4101   CALL FFBC(target,KNF(I),dumA,DUMB,DUMC,ERG)
c 4101   CALL FFMURO(KNF(I),ATWT(I),ATMURO(I),DUM1,WAVLEN,ERG)
         atbarn(i)=dumA(3)
         atmuro(i)=dumA(4)
         atwt(i)=dumB(1)
         atnum(i)=dumB(2)
        IF (ERG) 4105,4100,4105
 4104   IF (MK1(K) .EQ. '   ') GOTO 4105
        CALL FFBC(target,MK1(K),dumA,DUMB,DUMC,ERG)
         atbarn(i)=dumA(3)
         atmuro(i)=dumA(4)
         atwt(i)=dumB(1)
         atnum(i)=dumB(2)
        IF(ERG.NE.0)GO TO 4105
 4100 CONTINUE
C
C   CALCULATE WEIGHT,F000 MU BY MASS ATTENUATION COEFFIIENT
C
      WEIGHT=0.0
      F000=0.0
      DO I=1,NQ
        ATFR(I,1)=ATNO(I)*ATWT(I)
        WEIGHT=WEIGHT+ATFR(I,1)
        F000 = F000 + ATNO(I)*ATNUM(I)
        ENCODE(80,215,CARD)F000
        CALL ADDON(CARD,15,IFLG)
  215   FORMAT(' F000 (no fp) =',F8.0,' e')
      ENDDO
      TOMURO=0.0
      DO I=1,NQ
        ATFR(I,2)=ATFR(I,1)/WEIGHT
        ATFR(I,3)=ATFR(I,2)*ATMURO(I)
        TOMURO=TOMURO+ATFR(I,3)
      ENDDO
      GOTO 4122
 4105 WRITE(3,4107)
 4122 RO=WEIGHT/VOL/0.6022045
      TOMU=TOMURO*RO
 4108 CONTINUE
C
C
C   CALCULATE MU BY TOTAL PHOTON INTERACTION CROSS SECTION
C
      BARN=0
      DO I=1,NQ
       TPICS(I)=ATNO(I)*ATBARN(I)
       BARN=BARN+TPICS(I)
      ENDDO
       BARNMU=BARN/VOL
C
      WRITE(3,4118)ATEM,NSA,BTEM,NSB,CTEM,NSC,
     1AALFA,NAL,ABETUH,NBE,AGAMA,NGA
      WRITE (3,4119) VOL,NSIGV
      IF(IOP15.EQ.1)THEN  ! WRITE CELL DIMENS + VOLUME TO INF FILE
        ENCODE(80,4118,CARD)ATEM,NSA,BTEM,NSB,CTEM,NSC,AALFA,NAL,
     1  ABETUH,NBE,AGAMA,NGA
        CALL ADDON(CARD,15,IFLG)
        ENCODE(80,4119,CARD)VOL,NSIGV
        CALL ADDON(CARD,15,IFLG)
      ENDIF
C
C
C
      IF(SAT.GT.0.0)THEN
        IF(IOP15.EQ.1)THEN  !  Z AND MASS TO INF FILE
          WORD='Z = '
          CALL FIND(CARD,WORD,II,15)  ! IS Z IN INF FILE?
          IF(II.EQ.1)THEN  ! YES, SO CAN ADD MASS
            DECODE(80,201,CARD,ERR=202)IZ
            ZMASS=IZ
            ZMASS=WEIGHT/ZMASS
            ENCODE(80,203,CARD)ZMASS
            CALL ADDON(CARD,15,IFLG)
202       ENDIF
          WORD='CRYS'
          TOMUSIG=0
          BARNMUM=0
          CALL FIND(CARD,WORD,II,15)
          IF(II.EQ.1)THEN  ! FOUND CRYSTAL SIZE DIMENS.
            DECODE(80,210,CARD,ERR=211)X,Y,Z
210         FORMAT(15X,F6.3,3X,F6.3,3X,F6.3)
            X=X/10.
            Y=Y/10.
            Z=Z/10.
            DIAG=(0.5*SQRT(X*X+Y*Y+Z*Z))
            TOMUSIG=TOMU*DIAG
            BARNMUM=BARNMU*DIAG
            ENCODE(80,204,CARD)TOMU,TOMUSIG
204   FORMAT(' U = ',F8.3,' CM^(-1), (UR(MAX) = ',F8.3,')')
            CALL ADDON(CARD,15,IFLG)
            ENCODE(80,214,CARD)BARNMU,BARNMUM
214   FORMAT(' UB= ',F8.3,' CM^(-1), (UR(MAX) = ',F8.3,')')
            CALL ADDON(CARD,15,IFLG)
           ELSE
211         ENCODE(80,212,CARD)TOMU
            CALL ADDON(CARD,15,IFLG)
212         FORMAT(' U = ',F8.3,' CM^(-1)')
            ENCODE(80,213,CARD)BARNMU
  213       FORMAT(' UB= ',F8.3,' CM^(-1)')
            CALL ADDON(CARD,15,IFLG)
          ENDIF
          ENCODE(80,2125,CARD)RO
2125      FORMAT(' DENSITY = ',F6.3)
          CALL ADDON(CARD,15,IFLG)  ! ADDING DENSITY
        ENDIF
        WRITE(3,4114) (atnum(i),KNF(I),ATNO(I),ATWT(I),
     1               ATFR(I,1),ATFR(I,2),
     2              ATMURO(I),ATFR(I,3),ATBARN(I),TPICS(I),I=1,NQ)
 4114 FORMAT(////13X'ATOM ATOM'4X'# OF'5X'ATOM'5X'TOTAL'
     1       5X'FRAC'5X'FRAC',15X,' CROSS        TOTAL',/,
     2       13X' NUM LABEL'3X'ATOMS'4X'MASS'5X'MASS'6X'MASS'5X
     3       'u/p'7X'u/p',7X,' SECT     CROSS SECT ',/,
     4       /10X,47('-=')/
     5       12(/12X,f4.0,3x,A3,F9.2,2F10.4,F8.4,F9.3,F10.3,2F12.3/)/)
        WRITE(3,4115) WEIGHT,TOMURO,BARN,RO,F000,
     1                TOMU,TOMUSIG,BARNMU,BARNMUM
 4115 FORMAT('+',9x,47('=-')//40X,F11.4,17X,F10.4,10X,F14.3,////
     1       ///10x,'p(CALC) =',F8.3,/,
     2          10x,'F000 =',F8.2,//,
     3       10X,'u(1/cm) ='F8.3,5X,'(UR(MAX) = ',F8.3,')',
     4       '     based on mass attenuation coefficients',/,
     5       10X,'ub(1/cm)='F8.3,5x,'(UbR(MAX)= ',F8.3,')'
     6       '     based on total photon interaction cross section',
     7                ////)
      ENDIF
C      IF(IOP15.EQ.1)CLOSE(UNIT=15,DISP='SAVE')  BJWFEB93
      RETURN
      END
