C        COMB                                                           00000020
C     SUBROUTINE FOR COMBINING SYMMETRY RELATIONS BY 'FOLLOWED BY'      00000040
C     OPERATION                                                         00000050
      SUBROUTINE COMBI(AGL,I,J,M)
      DIMENSION AGL(12,192)
      DO 1 J1=1,4
      DO 1 I1=1,9,4
1     AGL(J1+I1-1,M)=AGL(I1,J)*AGL(J1,I)+AGL(I1+1,J)*AGL(J1+4,I)
     1+AGL(I1+2,J)*AGL(J1+8,I)
      DO 2 J1=4,12,4
2     AGL(J1,M)=AMOD(AGL(J1,M)+AGL(J1,J),1.0)
      RETURN
      END
C     SUBROUTINE ORTHOG                                                 00000020
C     SUBROUTINE ORTHOG                                                 00000020
      SUBROUTINE ORTHOG(X,Y,Z,X1,Y1,Z1)                                 00000050
      COMMON /GEN/ R1,R2,R3,R4,R5,S
      Y1=S*Y+R3*X+R4*Z                                                  00000100
      X1=R1*X+R2*Z                                                      00000110
      Z1=R5*Z                                                           00000120
      RETURN                                                            00000130
      END                                                               00000140
!File Subtors.for, for inclusion in Crym, based on
!File Tors.for, a study for revision of Tors in Distan
!Tors.for gave the same results as the Crym Tors (written by R. Stanford) and checks out algebraically with it, but is shorter
!and easier to read.  It also has effective tests for special cases that cause the R. S. Tors to bomb out. (V.S. 21 Feb 88)
	Subroutine Tors(Xor,Yor,Zor,Ia,Num,Sigma)
C	 The following have core allocated in Cryd.
C	 Dimension 300 is a dummy
	Dimension Xor(300),Yor(300),Zor(300), Num(300),Sigma(300)
	Dimension Ia(4)
	Parameter Rad=57.2958, C1=.000001, C2=.01
	Dimension X(4),Y(4),Z(4),Xi(4),Yi(4),Zi(4),S(4)
	Do 20 J=1,4
		X(J)	=Xor(Ia(J))-Xor(Ia(2))				!Pick out the needed data and Shift origin to R(2))
		Y(J)	=Yor(Ia(J))-Yor(Ia(2))
		Z(J)	=Zor(Ia(J))-Zor(Ia(2))
20		S(J)	=Sigma(Ia(J))
	If((Abs(X(3))+Abs(Y(3))).lt.C1) Then				!If At(3) isn't on z-axis, rotate around z to Xi(3)=0
		Do 25 J=1,4
			Xi(J)=X(J)
			Yi(J)=Y(J)
25			Zi(J)=Z(J)
	Else
		Th	=Atan2(X(3),Y(3))
		Do 30 J=1,4
			Xi(J)	=X(J)*Cos(Th) -Y(J)*Sin(Th)
			Yi(J)	=X(J)*Sin(Th) +Y(J)*Cos(Th)
30			Zi(J)	=Z(J)
	Endif
	If((Abs(Yi(3))+Abs(Zi(3))).lt.C2) Goto 110
		Th	=Atan2(Yi(3),Zi(3))				!If At(3)--At(2) isn't too short,		
		Do 40 J=1,4						!rotate around x to Y(3)=0
			Y(J)	=Yi(J)*Cos(Th) -Zi(J)*Sin(Th)		
			Z(J)	=Yi(J)*Sin(Th) +Zi(J)*Cos(Th)
40			X(J)	=Xi(J)					!At(3)--At(2) now lies along z
	If((Abs(Y(1))+Abs(X(1))).lt.C2) Goto 120			!If At(1) is not on the z-axis,
	If((Abs(Y(4))+Abs(X(4))).lt.C2) Goto 130			!And if At(4) is not on the z-axis,
	T	=Atan2(Y(4),X(4)) - Atan2(Y(1),X(1))			!Find the torsion angle.
	R1	=Sqrt(X(1)**2+Y(1)**2)
	R4	=Sqrt(X(4)**2+Y(4)**2)
	d1	=S(1)/R1						!Increment in Tau from motion of At(1)
	d4	=S(4)/R4						!Increment in Tau from motion of At(4)
	d2pe	=S(2)/Z(3)*((Z(4)-Z(3))/R4*Cos(T)-(Z(1)-Z(3))/R1)	!Increment in Tau from perp. motion of At(2)
	d2pa	=S(2)/Z(3)* (Z(4)-Z(3))/R4*Sin(T)			!Increment in Tau from par. motion of At(2)
	d3pe    =S(3)/Z(3)*(Z(1)/R1*Cos(T)-Z(4)/R4)			!Increment in Tau from perp. motion of At(3)
	d3pa	=-S(3)/Z(3)*Z(1)/R1*Sin(T)				!Increment in Tau from par. motion of At(3)
	St	=Sqrt(d1**2+d4**2+d2pe**2+d2pa**2+d3pe**2+d3pa**2)	!Sigma of Tau
	Write(3,108) (Num(Ia(J)),J=1,4),T*Rad,St*Rad
108	Format('0Torsion Angle',4(X,A4,','),' = ',F7.2,5X,'Sigma = ',F7.3)
109	Format('0Torsion Angle',4(X,A4,','),10X,A)
	Return
110	Write(3,109) (Num(Ia(J)),J=1,4), 'At3 and At2 Coincide'
	Return
120	Write(3,109) (Num(Ia(J)),J=1,4), 'Atoms 1,2,3 Collinear'
	Return
130	Write(3,109) (Num(Ia(J)),J=1,4), 'Atoms 2,3,4 Collinear'
	Return
	End
      SUBROUTINE DETERM (A,N,D)                                         DETE0001
      DIMENSION A(3,3),SAVEA(3,3)
       REAL M                                                           DETE0002
    4  IF (N .EQ. 1)GO TO 46                                            DETE0004
    5  C = 1.                                                           DETE0005
    6  NN = N                                                           DETE0006
    7  DO 9 I = 1,NN                                                    DETE0007
    8  DO 9 J = 1,NN                                                    DETE0008
    9  SAVEA(I,J) = A(I,J)                                              DETE0009
   10  K = 1                                                            DETE0010
   11  GO TO 13                                                         DETE0011
   12  K = K + 1                                                        DETE0012
   13  I = K + 1                                                        DETE0013
   14  L = K                                                            DETE0014
   15  GO TO 17                                                         DETE0015
   16  I = I + 1                                                        DETE0016
   17  IF (ABS(SAVEA(I,K)) .GT. ABS(SAVEA(L,K))) L = I                  DETE0017
   18  IF (I .NE. NN)GO TO 16                                           DETE0018
   19  IF (L .EQ. K)GO TO 28                                            DETE0019
   20  J = K                                                            DETE0020
C      ROW INTERCHANGE                                                  DETE0021
   21  GO TO 23                                                         DETE0022
   22  J = J + 1                                                        DETE0023
   23  SAVEKJ = SAVEA(K,J)                                              DETE0024
   24  SAVEA(K,J) = SAVEA(L,J)                                          DETE0025
   25  SAVEA(L,J) = SAVEKJ                                              DETE0026
   26  IF (J .NE. NN)GO TO 22                                           DETE0027
   27  C = -C                                                           DETE0028
   28  I = K + 1                                                        DETE0029
   29  GO TO 31                                                         DETE0030
   30  I = I + 1                                                        DETE0031
   31  M = SAVEA(I,K) / SAVEA(K,K)                                      DETE0032
   32  SAVEA(I,K) = 0.                                                  DETE0033
   33  J = K + 1                                                        DETE0034
   34  GO TO 36                                                         DETE0035
   35  J = J + 1                                                        DETE0036
   36  SAVEA(I,J) = SAVEA(I,J) - M * SAVEA(K,J)                         DETE0037
   37  IF (J .NE. NN)GO TO 35                                           DETE0038
   38  IF (I .NE. NN)GO TO 30                                           DETE0039
   39  IF (K .NE. (NN-1))GO TO 12                                       DETE0040
   40  D = 1.                                                           DETE0041
   41  DO 43 I = 1,NN                                                   DETE0042
   42  J = I                                                            DETE0043
       D = D * SAVEA(I,J)                                               DETE0044
       IF (ABS(D) .LT. 1.E-36) GO TO 48                                 DETE0045
  43   CONTINUE                                                         DETE0046
   44  D = D * C                                                        DETE0047
   45  RETURN                                                           DETE0048
   46  D = A(1,1)                                                       DETE0049
   47  RETURN                                                           DETE0050
  48   D = 0.                                                           DETE0051
       WRITE (3,51)                                                     DETE0052
       RETURN                                                           DETE0053
  51   FORMAT(//5X,41HMATRIX IS SINGULAR. DETERMINANT SET = 0.  //)     DETE0054
       END                                                              DETE0055
C        THERM                                                          00000020
C     SUBROUTINE FOR FINDING THE PRINCIPAL AXES OF THE ANISOTROPIC      00000030
C        THERMAL FACTOR IN CRYSTALLOGRAPHIC COORDINATES.                00000040
C     CALL THERM(B,A,AR,SAM,DC,SI,N)                                    00000060
C     WHERE 'B' (1X6) IS THE ANISOTROPIC THERMAL FACTOR FOR THE EQUATION00000080
C     EXP-(B11*H*H+B22*K*K+B33*L*L+B12*H*K+B13*H*L+B23*K*L),'A' AND 'AR'00000090
C     ARE THE (3X3) METRIC TENSORS FOR REAL AND RECIPROCAL SPACE RESPE- 00000100
C     CTIVELY,'LAM' IS A (1X3) ARRAY FOR STORING MEAN SQUARE DISPLACE-  00000110
C     MENTS ALONG PRINCIPAL AXES, 'DC' IS A(3X3)FOR STORING DIRECTION   00000120
C     COSINES OF THE CORRESPONDING PRINCIPAL AXES WITH RESPECT TO THE   00000130
C     CRYSTAL AXES, 'SI' IS A (1X3) FOR USE IN CONVERTING RECIPROCAL    00000140
C     SPACE COMPONENTS TO REAL SPACE DIRECTION COSINES. 'N' IS AN ERROR 00000150
C     INDICATOR-=0 FOR O.K.,=1 FOR TROUBLE.                             00000160
      SUBROUTINE THERM(B,A,AR,SAM,DC,SI,N)                              00000180
      DIMENSION B(6),A(3,3),SAM(3),DC(3,3),R(3,3),T(3,3),SI(3),AR(3,3)  00000190
      N=0                                                               00000200
      S=.0506605918                                                     00000210
      DO 5 I=1,3                                                        00000220
    5 R(I,I)=B(I)*S                                                     00000230
      S=S*0.5                                                           00000240
      R(1,2)=B(4)*S                                                     00000250
      R(1,3)=B(5)*S                                                     00000260
      R(2,3)=B(6)*S                                                     00000270
      R(2,1)=R(1,2)                                                     00000280
      R(3,1)=R(1,3)                                                     00000290
      R(3,2)=R(2,3)                                                     00000300
      DO 15 J=1,3                                                       00000310
      DO 15 K=1,3                                                       00000320
      T(J,K)=0.0                                                        00000330
      DO 15 L=1,3                                                       00000340
   15 T(J,K)=T(J,K)+A(J,L)*R(L,K)                                       00000350
      CALL EIGEN (T,SAM,R,N)                                            00000360
      IF (N) 21,26,21                                                   00000370
   21 N=1                                                               00000380
      RETURN                                                            00000390
   26 DO 36 J=1,3                                                       00000400
      S=0.0                                                             00000410
      DO 32 K=1,3                                                       00000420
      DO 32 L=1,3                                                       00000430
   32 S=S+AR(K,L)*R(K,J)*R(L,J)                                         00000440
      IF (S) 21,21,34                                                   00000450
   34 S=SQRT(S)                                                         00000460
      DO 36 K=1,3                                                       00000470
   36 DC(K,J)=R(K,J)*SI(K)/S                                            00000480
      RETURN                                                            00000490
      END                                                               00000500
      SUBROUTINE AXEQB(A1,X,B1,JJJ)                                     00000010
C     SOLUTION OF MATRIX EQUATION AX=B FOR X                            00000030
C     USES METHOD OF TRIANGULAR ELIMINATION                             00000050
C     B AND X HAVE DIMENSIONS (3,JJJ),A IS ALWAYS (3,3)                 00000070
C     TO INVERT A MAKE B 3 BY 3 IDENITY MATRIX                          00000090
      DIMENSION A1(3,3),A(3,3),B(3,3),B1(3,3),X(3,3)                    00000110
      NV=JJJ                                                            00000120
C     TRANSFER DATA                                                     00000140
      DO 2 I=1,3                                                        00000160
      DO 2 J=1,3                                                        00000170
      IF (NV-J) 2,1,1                                                   00000180
    1 B(I,J)=B1(I,J)                                                    00000190
    2 A(I,J)=A1(I,J)                                                    00000200
C     TRIANGULARIZE MATRIX A                                            00000220
      DO 17 I=1,2                                                       00000240
      S=0.0                                                             00000250
      DO 4 J=I,3                                                        00000260
      R=ABS(A(J,I))                                                     00000270
      IF (R-S) 4,3,3                                                    00000280
    3 S=R                                                               00000290
      L=J                                                               00000300
    4 CONTINUE                                                          00000310
      IF (L-I) 5,10,5                                                   00000320
    5 DO 6 J=I,3                                                        00000330
      S=A(I,J)                                                          00000340
      A(I,J)=A(L,J)                                                     00000350
    6 A(L,J)=S                                                          00000360
      DO 8 J=1,NV                                                       00000370
      S=B(I,J)                                                          00000380
      B(I,J)=B(L,J)                                                     00000390
    8 B(L,J)=S                                                          00000400
   10 TEM=A(I,I)                                                        00000410
      IF(ABS(TEM).LT.1.E-10)THEN
      A(I,I)=0.0
      GO TO 17
       ENDIF
   11 IPO=I+1                                                           00000430
      DO 16 J=IPO,3                                                     00000440
      IF (A(J,I)) 12,16,12                                              00000450
   12 S=A(J,I)/TEM                                                      00000460
      A(J,I)=0.0                                                        00000470
      DO 13 K=IPO,3                                                     00000480
   13 A(J,K)=A(J,K)-A(I,K)*S                                            00000490
      DO 15 K=1,NV                                                      00000500
   15 B(J,K)=B(J,K)-B(I,K)*S                                            00000510
   16 CONTINUE                                                          00000520
   17 CONTINUE                                                          00000530
C     MODIFY SINGULAR MATRIX                                            00000550
      DO 20 I=1,3                                                       00000570
      IF (A(I,I)) 20,19,20                                              00000580
   19 A(I,I)=AMAX1(1.E-15,AMAX1(A(1,1),A(2,2),A(3,3))*1.E-10)        
   20 CONTINUE                                                          00000600
      DO 24 K=1,NV                                                      00000610
      DO 24 I=1,3                                                       00000620
      N=4-I                                                             00000630
      M=N+1                                                             00000640
      TEM=B(N,K)                                                        00000650
      IF (3-M) 23,21,21                                                 00000660
   21 DO 22 J=M,3                                                       00000670
   22 TEM=TEM-A(N,J)*B(J,K)                                             00000680
   23 B(N,K)=TEM/A(N,N)                                                 00000690
   24 X(N,K)=B(N,K)                                                     00000700
      RETURN                                                            00000710
      END                                                               00000720
      SUBROUTINE GENE (X,Y,Z,NUM,IR,NM1,NM2,NM3,NM4,DIST,NA,KN,IER)
      DIMENSION XG(24),YG(24),ZG(24),NUM(1),X(1),Y(1),Z(1)
      COMMON /GEN/ R1,R2,R3,R4,R5,S,XG,YG,ZG
      EQUIVALENCE                  (XG(1),XV),(XG(2),XW),(YG(1),YV),(YG(00000090
     12),YW),(ZG(2),ZW),(ZG(1),ZV)                                      00000100
      IK1=0                                                             00000110
      IK2=0                                                             00000120
      IER=0                                                             00000130
      IK3=0                                                             00000140
      IK4=0                                                             00000150
      DO 820 J=1,NA                                                     00000160
      KIT=NUM(J)                                                        00000170
      IF (NM1-KIT) 814,813,814                                          00000180
  813 IK1=J                                                             00000190
  814 IF (NM2-KIT) 816,815,816                                          00000200
  815 IK2=J                                                             00000210
  816 IF (NM3-KIT) 818,817,818                                          00000220
  817 IK3=J                                                             00000230
  818 IF (NM4-KIT) 820,819,820                                          00000240
  819 IK4=J                                                             00000250
  820 CONTINUE                                                          00000260
      IF (IK1) 821,1820,821                                             00000270
  821 IF (IK2) 822,1820,822                                             00000280
  822 IF (IK1-IK2) 823,1822,823                                         00000290
  823 CALL ORTHOG(X(IK1),Y(IK1),Z(IK1),XRC,YRC,ZRC)                     00000300
      XR1=R1*X(IK2)+R2*Z(IK2)-XRC                                       00000310
      YR1=S*Y(IK2)+R3*X(IK2)+R4*Z(IK2)-YRC                              00000320
      ZR1=R5*Z(IK2)-ZRC                                                 00000330
      SN1=SQRT(XR1*XR1+YR1*YR1+ZR1*ZR1)                                 00000340
      GO TO (825,825,825,870),IR                                        00000350
  825 IF (IK3) 826,1820,826                                             00000360
  826 XR2=R1*X(IK3)+R2*Z(IK3)-XRC                                       00000370
      YR2=S*Y(IK3)+R3*X(IK3)+R4*Z(IK3)-YRC                              00000380
      ZR2=R5*Z(IK3)-ZRC                                                 00000390
      SN2=SQRT(XR2*XR2+YR2*YR2+ZR2*ZR2)                                 00000400
      IF (IK3-IK1) 831,1822,831                                         00000410
  831 IF (IK3-IK2) 832,1822,832                                         00000420
  832 GO TO (850,835,860,875),IR                                        00000430
C                                                                       00000440
C     SP 3  SINGLE ATOM                                                 00000450
C                                                                       00000460
  835 IF (IK4) 836,1820,836                                             00000470
  836 IF (IK4-IK1) 837,1822,837                                         00000480
  837 IF (IK4-IK2) 838,1822,838                                         00000490
  838 IF (IK4-IK3) 839,1822,839                                         00000500
  839 XR3=R1*X(IK4)+R2*Z(IK4)-XRC                                       00000510
      YR3=S*Y(IK4)+R3*X(IK4)+R4*Z(IK4)-YRC                              00000520
      ZR3=R5*Z(IK4)-ZRC                                                 00000530
      SN3=SQRT(XR3*XR3+YR3*YR3+ZR3*ZR3)                                 00000540
      XV=XR1/SN1+XR2/SN2+XR3/SN3                                        00000550
      KN=1                                                              00000560
      YV=YR1/SN1+YR2/SN2+YR3/SN3                                        00000570
      ZV=ZR1/SN1+ZR2/SN2+ZR3/SN3                                        00000580
  840 SV=DIST/SQRT(XV*XV+YV*YV+ZV*ZV)                                   00000590
      XV=XRC-XV*SV                                                      00000600
      YV=YRC-YV*SV                                                      00000610
      ZV=ZRC-ZV*SV                                                      00000620
      GO TO 900                                                         00000630
C                                                                       00000640
C     SP 2  SINGLE ATOM                                                 00000650
C                                                                       00000660
  850 XV=XR1/SN1+XR2/SN2                                                00000670
      YV=YR1/SN1+YR2/SN2                                                00000680
      ZV=ZR1/SN1+ZR2/SN2                                                00000690
      KN=1                                                              00000700
      GO TO 840                                                         00000710
C                                                                       00000720
C     SP 3  TWO ATOMS                                                   00000730
C                                                                       00000740
  860 XR1=XR1/SN1                                                       00000750
      YR1=YR1/SN1                                                       00000760
      ZR1=ZR1/SN1                                                       00000770
      XR2=XR2/SN2                                                       00000780
      YR2=YR2/SN2                                                       00000790
      ZR2=ZR2/SN2                                                       00000800
      XF=YR1*ZR2-ZR1*YR2                                                00000810
      YF=ZR1*XR2-XR1*ZR2                                                00000820
      ZF=XR1*YR2-YR1*XR2                                                00000830
      SV=SQRT(XF*XF+YF*YF+ZF*ZF)/.81664                                 00000840
      XF=XF/SV                                                          00000850
      YF=YF/SV                                                          00000860
      ZF=ZF/SV                                                          00000870
      XD=-(XR1+XR2)                                                     00000880
      YD=-(YR1+YR2)                                                     00000890
      ZD=-(ZR1+ZR2)                                                     00000900
      SV=SQRT(XD*XD+YD*YD+ZD*ZD)/.57714                                 00000910
      XD=XD/SV                                                          00000920
      YD=YD/SV                                                          00000930
      ZD=ZD/SV                                                          00000940
      XV=-(XD+XF)                                                       00000950
      YV=-(YD+YF)                                                       00000960
      ZV=-(ZD+ZF)                                                       00000970
      XW=XD-XF                                                          00000980
      YW=YD-YF                                                          00000990
      ZW=ZD-ZF                                                          00001000
      SV=DIST/SQRT(XW*XW+YW*YW+ZW*ZW)                                   00001010
      XW=XRC+XW*SV                                                      00001020
      YW=YRC+YW*SV                                                      00001030
      ZW=ZRC+ZW*SV                                                      00001040
      KN=2                                                              00001050
      GO TO 840                                                         00001060
C                                                                       00001070
C     SP 3  THREE ATOMS - MANY ATOMS                                    00001080
C                                                                       00001090
  870 IF (IK3) 826,880,826                                              00001100
C                                                                       00001110
C     THREE ATOMS                                                       00001120
C                                                                       00001130
  875 XF=YR2*ZR1-ZR2*YR1                                                00001140
      YF=ZR2*XR1-XR2*ZR1                                                00001150
      ZF=XR2*YR1-YR2*XR1                                                00001160
      SV=(.816/SQRT(XF*XF+YF*YF+ZF*ZF))*DIST                            00001170
      XF=XF*SV                                                          00001180
      YF=YF*SV                                                          00001190
      ZF=ZF*SV                                                          00001200
      XGX=YF*ZR1-ZF*YR1                                                 00001210
      YGX=ZF*XR1-XF*ZR1                                                 00001220
      ZGX=XF*YR1-YF*XR1                                                 00001230
      SV=(.9426/SQRT(XGX*XGX+YGX*YGX+ZGX*ZGX))*DIST                     00001240
      XGX=XGX*SV                                                        00001250
      YGX=YGX*SV                                                        00001260
      ZGX=ZGX*SV                                                        00001270
      SV=(.3338/SN1)*DIST                                               00001280
      XC=-XR1*SV+XRC                                                    00001290
      YC=-YR1*SV+YRC                                                    00001300
      ZC=-ZR1*SV+ZRC                                                    00001310
      XG(1)=XC+XGX                                                      00001320
      XG(2)=XC+XF-XGX/2                                                 00001330
      XG(3)=XC-XF-XGX/2                                                 00001340
      YG(1)=YC+YGX                                                      00001350
      YG(2)=YC+YF-YGX/2                                                 00001360
      YG(3)=YC-YF-YGX/2                                                 00001370
      ZG(1)=ZC+ZGX                                                      00001380
      ZG(2)=ZC+ZF-ZGX/2                                                 00001390
      ZG(3)=ZC-ZF-ZGX/2                                                 00001400
      KN=3                                                              00001410
      GO TO 900                                                         00001420
C                                                                       00001430
C     MANY ATOMS                                                        00001440
C                                                                       00001450
  880 GO TO 251                                                         00001460
 1820 IER=1                                                             00001470
      GO TO 900                                                         00001480
 1822 IER=2                                                             00001490
      GO TO 900                                                         00001500
  251 IER=3                                                             00001510
  900 RETURN                                                            00001520
      END                                                               00001530
C     DIHED                                                             00000020
      SUBROUTINE DIHED(NUM,X,Y,Z,KIN,KSA,ANGLE,IER,NA)                  00000040
      DIMENSION NUM(1),X(1),Y(1),Z(1),KIN(1),KSA(1),XAR(4),YAR(4),      00000050
     1ZAR(4),XGR(3),YGR(3),ZGR(3)                                       00000060
      DOUBLE PRECISION DXT,DANGL                                        00000070
      IER=1                                                             00000080
      DO 205 I=1,4                                                      00000090
      DO 202 K=1,NA                                                     00000100
      IF (KIN(I)-NUM(K)) 202,204,202                                    00000110
  202 CONTINUE                                                          00000120
      IER=2                                                             00000130
      GO TO 205                                                         00000140
  204 CALL TRANS(X(K),Y(K),Z(K),XA,YA,ZA,KSA(I))                        00000150
      CALL ORTHOG(XA,YA,ZA,XAR(I),YAR(I),ZAR(I))                        00000160
  205 CONTINUE                                                          00000170
      IF (IER-2) 208,229,229                                            00000180
  208 DO 210 I=1,3                                                      00000190
      J=I+1                                                             00000200
      XGR(I)=XAR(I)-XAR(J)                                              00000210
      YGR(I)=YAR(I)-YAR(J)                                              00000220
  210 ZGR(I)=ZAR(I)-ZAR(J)                                              00000230
      XA=YGR(1)*ZGR(2)-YGR(2)*ZGR(1)                                    00000240
      YA=ZGR(1)*XGR(2)-ZGR(2)*XGR(1)                                    00000250
      ZA=XGR(1)*YGR(2)-XGR(2)*YGR(1)                                    00000260
      XB=YGR(2)*ZGR(3)-YGR(3)*ZGR(2)                                    00000270
      YB=ZGR(2)*XGR(3)-ZGR(3)*XGR(2)                                    00000280
      ZB=XGR(2)*YGR(3)-XGR(3)*YGR(2)                                    00000290
      DA=XA*XA+YA*YA+ZA*ZA                                              00000300
      DB=XB*XB+YB*YB+ZB*ZB                                              00000310
      DC=(XB-XA)**2+(YB-YA)**2+(ZB-ZA)**2                               00000320
      DEN=2.0*SQRT(DA*DB)                                               00000330
      COSA=(DA+DB-DC)/DEN                                               00000340
      DEN=1.0-COSA*COSA                                                 00000350
      IF (DEN) 225,226,226                                              00000360
  225 DEN=0.0                                                           00000370
  226 DXT=SQRT(DEN)/COSA                                                00000380
      DANGL=DATAN(DXT)                                                  00000390
      ANGLE=DANGL*57.29580000                                           00000400
      IF (ANGLE) 228,229,229                                            00000410
  228 ANGLE=180.0+ANGLE                                                 00000420
  229 RETURN                                                            00000430
      END                                                               00000440
      SUBROUTINE EIGEN (W,VALU,VECT,NG)                                 00000010
C******EIGENVALUES AND EIGENVECTORS OF 3X3 MATRIX*******                00000020
      DIMENSION W(3,3),VALU(3),VECT(3,3),A(3,3),B(3,3),V(3),U(3)        00000030
      REAL*8 TEM,DV(3),BIG
      BYTE IFIX
      PARAMETER (REDUCE=.00000000001)    ! 10**-10
      PARAMETER (RESTOR=10000000000.)    ! 10**10
       BIG=100000000000000.                ! 10**14
      IFIX=0
C     START OF PROGRAM                                                  00000050
      ERRND=5.E-8                                                       00000070
      SIGMA=0.                                                          00000080
      DO 115 J=1,3                                                      00000090
      DO 115 I=1,3                                                      00000100
      TEM=W(I,J)                                                        00000110
      A(I,J)=TEM                                                        00000120
  115 SIGMA=SIGMA+TEM*TEM                                               00000130
C     *****CHECK FOR NULL MATRIX*****                                   00000140
      IF (SIGMA) 230,230,120                                            00000150
  120 SIGMA=SQRT(SIGMA)                                                 00000160
C                                                                       00000170
C     FORM CHARACTERISTIC EQUATION                                      00000180
C                                                                       00000190
      B2=A(1,1)+A(2,2)+A(3,3)                                           00000200
      B1=-A(1,1)*A(2,2)-A(1,1)*A(3,3)-A(2,2)*A(3,3)+A(1,3)*A(3,1)+A(2,3)00000210
     1*A(3,2)+A(1,2)*A(2,1)                                             00000220
      B0=A(1,1)*A(2,2)*A(3,3)+A(1,2)*A(2,3)*A(3,1)+A(1,3)*A(3,2)*A(2,1)-00000230
     1A(1,3)*A(3,1)*A(2,2)-A(1,1)*A(2,3)*A(3,2)-A(1,2)*A(2,1)*A(3,3)    00000240
C                                                                       00000250
C     FIRST ROOT BY BISECTION                                           00000260
C                                                                       00000270
      X=0.                                                              00000280
      Y=SIGMA                                                           00000290
      TEM=((B2-SIGMA)*SIGMA+B1)*SIGMA+B0                                00000300
      VNEW=0.0                                                          00000310
      IF (B0) 135,250,145                                               00000320
  135 IF (TEM) 140,140,165                                              00000330
  140 Y=-Y                                                              00000340
      GO TO 165                                                         00000350
  145 Y=0.                                                              00000360
      X=SIGMA                                                           00000370
      IF (TEM) 165,165,150                                              00000380
  150 X=-X                                                              00000390
C                                                                       00000400
C     NOW PHIF(X).LT.0.AND.PHIF(Y).GT.0.                                00000410
C                                                                       00000420
  165 VNEW=(X+Y)*.5                                                     00000430
      DO 225 I=1,40                                                     00000440
  175 PHF=((B2-VNEW)*VNEW+B1)*VNEW+B0                                   00000450
      IF (PHF) 180,250,185                                              00000460
  180 X=VNEW                                                            00000470
      GO TO 200                                                         00000480
  185 Y=VNEW                                                            00000490
  200 VOLD=VNEW                                                         00000500
      VNEW=(X+Y)*.5                                                     00000510
      TEM=ABS(VOLD-VNEW)                                                00000520
      IF (TEM-ERRND) 250,250,205                                        00000530
  205 IF (VOLD) 210,225,210                                             00000540
  210 IF (ABS(TEM/VOLD)-ERRND) 250,250,225                              00000550
  225 CONTINUE                                                          00000560
C                                                                       00000570
C     DID NOT CONVERGE, SET ERROR INDICATOR                             00000580
C                                                                       00000590
  230 NG=6                                                              00000600
      GO TO 400                                                         00000610
C                                                                       00000620
C     STORE FIRST ROOT                                                  00000630
C                                                                       00000640
  250 U(3)=VNEW                                                         00000650
C                                                                       00000660
C     DEFLATE                                                           00000670
C                                                                       00000680
      C1=B2-VNEW                                                        00000690
      C0=B1+C1*VNEW                                                     00000700
C                                                                       00000710
C     SOLVE QUADRATIC                                                   00000720
C                                                                       00000730
      TEM=C1*C1+4.*C0                                                   00000740
      IF (TEM) 255,265,260                                              00000750
C                                                                       00000760
C     IGNORE IMAGINARY COMPONENT OF COMPLEX ROOT                        00000770
  255 TEM=0.                                                            00000780
      GO TO 265                                                         00000790
  260 TEM=SQRT(TEM)                                                     00000800
  265 U(1)=.5*(C1-TEM)                                                  00000810
      U(2)=.5*(C1+TEM)                                                  00000820
C                                                                       00000830
C     SORT ROOTS                                                        00000840
C                                                                       00000850
      DO 275 J=1,2                                                      00000860
      IF (U(J)-U(3)) 275,275,270                                        00000870
  270 TEM=U(J)                                                          00000880
      U(J)=U(3)                                                         00000890
      U(3)=TEM                                                          00000900
  275 CONTINUE                                                          00000910
      LLL=-2                                                            00000920
      DO 375 III=1,2                                                    00000930
C                                                                       00000940
C     CHECK FOR MULTIPLE ROOTS                                          00000950
C                                                                       00000960
      TEM=ERRND*100.                                                    00000970
      NG=0                                                              00000980
      L=1                                                               00000990
      DO 305 I=1,2                                                      00001000
      IF (U(I+1)-U(I)-TEM) 300,300,290                                  00001010
  290 IF (U(I)) 295,305,295                                             00001020
  295 IF (ABS((U(I+1)-U(I))/U(I))-TEM) 300,300,305                      00001030
  300 L=L-1                                                             00001040
      NG=NG-2*I                                                         00001050
  305 CONTINUE                                                          00001060
      IF (LLL-L) 308,400,400                                            00001070
  308 LLL=L                                                             00001080
C                                                                       00001090
C     EIGENVECTOR ROUTINE                                               00001100
C                                                                       00001110
      DO 375 II=1,3                                                     00001120
      T1=U(II)                                                          00001130
      IF (L) 315,310,322                                                00001140
C                                                                       00001150
C     TWO VECTORS NULL FOR DOUBLE ROOT                                  00001160
C                                                                       00001170
  310 IF (NG+5-II) 315,322,315                                          00001180
C                                                                       00001190
C     ALL VECTORS NULL FOR TRIPLE ROOT                                  00001200
C                                                                       00001210
  315 DO 320 J=1,3                                                      00001220
  320 VECT(J,II)=0.0                                                    00001230
      GO TO 375                                                         00001240
  322 DO 325 J=1,3                                                      00001250
  325 A(J,J)=W(J,J)-T1                                                  00001260
      SMAX=0.0                                                          00001270
      DO 355 I=1,3                                                      00001280
      I1=1                                                              00001290
      IF (I-2) 335,335,340                                              00001300
  335 I1=I+1                                                            00001310
  340 B(I,1)=A(I,2)*A(I1,3)-A(I,3)*A(I1,2)                              00001320
      B(I,2)=A(I,3)*A(I1,1)-A(I,1)*A(I1,3)                              00001330
      B(I,3)=A(I,1)*A(I1,2)-A(I,2)*A(I1,1)                              00001340
      TEM=B(I,1)**2+B(I,2)**2+B(I,3)**2                                 00001350
      IF (TEM-SMAX) 355,355,350                                         00001360
  350 SMAX=TEM                                                          00001370
      IMAX=I                                                            00001380
  355 CONTINUE                                                          00001390
      IF (SMAX) 353,353,360                                             00001400
  353 NG=7                                                              00001410
      GO TO 375                                                         00001420
  360 SMAX=SQRT(SMAX)                                                   00001430
      DO 365 J=1,3                                                      00001440
  365 V(J)=B(IMAX,J)/SMAX                                               00001450
C                                                                       00001460
C     REFINE EIGENVECTOR                                                00001470
C     WRITE(3,105)V
105    FORMAT('  BEFORE CALL TO AXEQB V= ',3E16.6)
C                                                                       00001480
      CALL AXEQB(A,V,V,1)                                               00001490
      DO I=1,3
      DV(I)=V(I)
      IF(V(I).GT.BIG)IFIX=9
       ENDDO
C     WRITE(3,100)V(1),V(2),V(3)
      IF(IFIX.NE.0)THEN
      DO I=1,3
      DV(I)=DV(I)*REDUCE
      ENDDO
      ENDIF
C     WRITE(3,100)DV
 100   FORMAT('  AFTER RETURN FROM AXEQB V=  ',3E12.4)
101    FORMAT('   AND SQRT=',E16.6)
      TEM=DV(1)*DV(1)+DV(2)*DV(2)+DV(3)*DV(3)
      TEM=DSQRT(TEM)                   
C     WRITE(3,101)TEM
      DO 370 J=1,3                                                      00001510
      DV(J)=DV(J)/TEM                                                
C     IF(IFIX.EQ.9)DV(J)=DV(J)*RESTOR
  370 VECT(J,II)=DV(J)                                                
      IFIX=0
      T1=0.                                                             00001540
      DO 372 J=1,3                                                      00001550
  372 T1=T1+DV(J)*(DV(1)*W(J,1)+DV(2)*W(J,2)+DV(3)*W(J,3))              
      U(II)=T1                                                          00001570
  375 VALU(II)=T1                                                       00001580
  400 RETURN                                                            00001590
      END                                                               00001600
