C        FORM FACTOR STORAGE SUBPROGRAM.                                00000020
c         and miscellaneous atom data storage
c
C        CALLED BY PREP.FOR        and crystal.for
c
C        CALL FFBC(what,IDEN,A,B,C,ERG)
C        WHERE                                                          00000050
c        what = what to do
c               FF for form factor
c               MO for moly data    and atomic data
c               CU for copper data  and atomic data
C        IDEN = FORM FACTOR IDENTIFIER (A3FORMAT)                       00000060
c
c
c           a(4),b(4),c are 9 real numbers
c
c
c         for FF      FORM FACTOR
c
C             A AND B ARE THE appropriate WORDS OF A 868 WORD ARRAY
c             C = THE appropriate WORD OF A 217 WORD ARRAY
C             FOR CALCULATING SCATTERING FACTORS.
C             ERG = ERROR INDICATOR = 0 FOR SUCCESS.                    00000090
c
c
c         for MO or CU
c
c             a(1) is f' , fp , f prime
c             a(2) is f" , fpp , f double prime
c             a(3) is total photon cross section barns/atom
c             a(4) is mass attenuation coefficient cm**2/g
c             b(1) is atomic mass
c             b(2) is atomic number
c             b(3) is approximate atomic radii
c
c
C             MASS ABSORPTION DATA SUBPROGRAM
C DATA PRESENTLY ONLY INCLUDED FOR MO K <ALPHA> and Cu K <ALPHA>
C        CALL FFMURO(LABEL,WEIGHT,ATMURO,REDICO,WAVLEN,ERG)
c
c
c
c
c
c  new data installed end of FEB, 1996
C
c
c
c
       SUBROUTINE FFBC(what,IDEN,A,B,C,ERG)
c
      DIMENSION NOTA(217),KINDF(217)
      DIMENSION ATMASS(103),RADII(103)
      REAL FPMo(103),FPPMo(103),BARNMo(103),MACMo(103)
      REAL FPCu(103),FPPCu(103),BARNCu(103),MACCu(103)
c
	DIMENSION A(4),B(4)
	DIMENSION atabl(868),btabl(868),ATAB(4,217),BTAB(4,217),
     1  CTAB(217)
	EQUIVALENCE(ATABL(1),ATAB(1,1)),(BTABL(1),BTAB(1,1))
      CHARACTER*2 what
c
c
C    ORDER IS IMPORTANT. ADD NEW FFF'S AND SCATTERING FACTORS AT END
C       ORDER IN KINDF AND TABLE MUST BE THE SAME 
c
C       THERE ARE 217  KIND F'S    ONE BLANK INCLUDED
C       DIMENSION TABLE (207,4)   (I,J)  J INDEX POINTS TO FFF
C                                        I INDEX POINTS TO NUMBERS
C    ORDER IS IMPORTANT. ADD NEW FFF'S AND SCATTERING FACTORS AT END
C       ORDER IN KINDF AND TABLE MUST BE THE SAME

c
c
c  f prime from International Tables, Vol C, pp 219-222
c      for Mo Kalpha_bar, real anomalous dispersion
c
      DATA FPMO   /0.0000,  0.0000, -0.0003,  0.0005,  0.0013,  0.0033,
     2             0.0061,  0.0106,  0.0171,  0.0259,  0.0362,  0.0486,
     3             0.0645,  0.0817,  0.1023,  0.1246,  0.1484,  0.1743,
     4             0.2009,  0.2262,  0.2519,  0.2776,  0.3005,  0.3209,
     5             0.3368,  0.3463,  0.3494,  0.3393,  0.3201,  0.2839,
     6             0.2307,  0.1547,  0.0499, -0.0929, -0.2901, -0.5574,
     7            -0.9393, -1.5307, -2.7962, -2.9673, -2.0727, -1.6832,
     8            -1.4390, -1.2594, -1.1178, -0.9988, -0.8971, -0.8075,
     9            -0.7276, -0.6537, -0.5866, -0.5308, -0.4742, -0.4205,
     .            -0.3680, -0.3244, -0.2871, -0.2486, -0.2180, -0.1943,
     1            -0.1753, -0.1638, -0.1578, -0.1653, -0.1723, -0.1892,
     2            -0.2175, -0.2586, -0.3139, -0.3850, -0.4720, -0.5830,
     3            -0.7052, -0.8490, -1.0185, -1.2165, -1.4442, -1.7033,
     4            -2.0133, -2.3894, -2.8358, -3.3944, -4.1077, -5.1210,
     5            -7.9122, -8.0659, -7.2224, -6.7704, -6.8494, -7.2400,
     6            -8.0334, -9.6767,-11.4937, -9.4100, -7.8986, -7.3248,
     7            -6.8498, -6.6561,  0.0000,  0.0000,  0.0000,  0.0000,
     8             0.0000/
c
c
c  f double prime from International Tables, Vol C, pp 219-222
c      for Mo Kalpha_bar, imaginary anomalous dispersion
c
      DATA FPPMO  /0.0000,  0.0000,  0.0001,  0.0002,  0.0007,  0.0016,
     2             0.0033,  0.0060,  0.0103,  0.0164,  0.0249,  0.0363,
     3             0.0514,  0.0704,  0.0942,  0.1234,  0.1585,  0.2003,
     4             0.2494,  0.3064,  0.3716,  0.4457,  0.5294,  0.6236,
     5             0.7283,  0.8444,  0.9721,  1.1124,  1.2651,  1.4301,
     6             1.6083,  1.8001,  2.0058,  2.2259,  2.4595,  2.7079,
     7             2.9676,  3.2498,  3.5667,  0.5597,  0.6215,  0.6857,
     8             0.7593,  0.8363,  0.9187,  1.0072,  1.1015,  1.2024,
     9             1.3100,  1.4246,  1.5461,  1.6751,  1.8119,  1.9578,
     .             2.1192,  2.2819,  2.4523,  2.6331,  2.8214,  3.0179,
     1             3.2249,  3.4418,  3.6682,  3.9035,  4.1537,  4.4098,
     2             4.6783,  4.9576,  5.2483,  5.5486,  5.8584,  6.1852,
     3             6.5227,  6.8722,  7.2310,  7.6030,  7.9887,  8.3905,
     4             8.8022,  9.2266,  9.6688, 10.1111, 10.2566, 11.0496,
     5             9.9777, 10.4580,  7.7847,  8.1435,  8.5178,  8.8979,
     6             9.2807,  9.6646,  4.1493,  4.3056,  4.5125,  4.6980,
     7             4.9086,  5.0785,  0.0000,  0.0000,  0.0000,  0.0000,
     8             0.0000/
c
c
c  photon interaction cross section from International Tables, Vol C, pp 193-199
c       for Mo for calculation absorption coefficient
c
      DATA BARNMO/.624E+00,.134E+01,.228E+01,.383E+01,.661E+01,.115E+02,
     2            .196E+02,.325E+02,.515E+02,.786E+02,.116E+03,.165E+03,
     3            .229E+03,.310E+03,.410E+03,.532E+03,.678E+03,.851E+03,
     4            .105E+04,.129E+04,.156E+04,.186E+04,.220E+04,.258E+04,
     5            .302E+04,.349E+04,.401E+04,.457E+04,.518E+04,.586E+04,
     6            .660E+04,.738E+04,.822E+04,.911E+04,.100E+05,.110E+05,
     7            .121E+05,.132E+05,.143E+05,.247E+04,.273E+04,.300E+04,
     8            .332E+04,.364E+04,.399E+04,.436E+04,.476E+04,.518E+04,
     9            .563E+04,.611E+04,.662E+04,.716E+04,.773E+04,.834E+04,
     .            .898E+04,.965E+04,.104E+05,.111E+05,.119E+05,.127E+05,
     1            .135E+05,.144E+05,.154E+05,.163E+05,.174E+05,.184E+05,
     2            .195E+05,.207E+05,.219E+05,.231E+05,.244E+05,.258E+05,
     3            .272E+05,.286E+05,.301E+05,.316E+05,.331E+05,.348E+05,
     4            .365E+05,.382E+05,.401E+05,.419E+05,.438E+05,.458E+05,
     5            .407E+05,.398E+05,.322E+05,.330E+05,.540E+05,.370E+05,
     6            .387E+05,.403E+05,.257E+05,.162E+05,.189E+05,.201E+05,
     7            .201E+05,.209E+05,.000E+00,.000E+00,.000E+00,.000E+00,
     8            .000E+00/
C
c
c
c  f prime from International Tables, Vol C, pp 219-222
c      for Cu Kalpha_bar, real anomalous dispersion
c
      DATA FPCU   /0.0000,  0.0000,  0.0008,  0.0038,  0.0090,  0.0181,
     2             0.0311,  0.0492,  0.0727,  0.1019,  0.1353,  0.1719,
     3             0.2130,  0.2541,  0.2955,  0.3331,  0.3639,  0.3843,
     4             0.3868,  0.3641,  0.3119,  0.2191,  0.0687, -0.1635,
     5            -0.5299, -1.1336, -2.3653, -3.0029, -1.9646, -1.5491,
     6            -1.2846, -1.0885, -0.9300, -0.7943, -0.6763, -0.5657,
     7            -0.4688, -0.3528, -0.2670, -0.1862, -0.1121, -0.0483,
     8             0.0057,  0.0552,  0.0927,  0.1215,  0.1306,  0.1185,
     9             0.0822,  0.0259, -0.0562, -0.1759, -0.3257, -0.5179,
     .            -0.7457, -1.0456, -1.4094, -1.8482, -2.4164, -3.1807,
     1            -4.0598, -5.3236, -8.9294, -8.8380, -9.1472, -9.8046,
     2           -14.9734, -9.4367, -8.0393, -7.2108, -6.6179, -6.1794,
     3            -5.7959, -5.4734, -5.2083, -4.9801, -4.7710, -4.5932,
     4            -4.4197, -4.2923, -4.1627, -4.0753, -4.0111, -3.9670,
     5            -3.9588, -3.9487, -3.9689, -4.0088, -4.0794, -4.1491,
     6            -4.2473, -4.3638, -4.5053, -4.6563, -4.8483, -5.0611,
     7            -5.3481, -5.5545,  0.0000,  0.0000,  0.0000,  0.0000,
     8             0.0000/
c
c
c  f double prime from International Tables, Vol C, pp 219-222
c      for Cu Kalpha_bar, imaginary anomalous dispersion
c
      DATA FPPCU  /0.0000,  0.0000,  0.0003,  0.0014,  0.0039,  0.0091,
     2             0.0180,  0.0322,  0.0534,  0.0833,  0.1239,  0.1771,
     3             0.2455,  0.3302,  0.4335,  0.5567,  0.7018,  0.8717,
     4             1.0657,  1.2855,  1.5331,  1.8069,  2.1097,  2.4439,
     5             2.8052,  3.1974,  3.6143,  0.5091,  0.5888,  0.6778,
     6             0.7763,  0.8855,  1.0051,  1.1372,  1.2805,  1.4385,
     7             1.6079,  1.8200,  2.0244,  2.2449,  2.4826,  2.7339,
     8             3.0049,  3.2960,  3.6045,  3.9337,  4.2820,  4.6533,
     9             5.0449,  5.4591,  5.8946,  6.3531,  6.8362,  7.3500,
     .             7.9052,  8.4617,  9.0376,  9.6596, 10.2820, 10.9079,
     1            11.5523, 12.2178, 11.1857, 11.9157,  9.1891,  9.8477,
     2             3.7046,  3.9380,  4.1821,  4.4329,  4.6937,  4.9776,
     3             5.2718,  5.5774,  5.8923,  6.2216,  6.5667,  6.9264,
     4             7.2980,  7.6849,  8.0900,  8.5060,  8.9310,  9.3834,
     5             9.8433, 10.3181, 10.8038, 11.2969, 11.7994, 12.3296,
     6            12.8681, 13.4090, 13.9666, 14.3729, 15.0877, 15.6355,
     7            16.3190, 16.7428,  0.0000,  0.0000,  0.0000,  0.0000,
     8             0.0000/
c
c
c  photon interaction cross section from International Tables, Vol C, pp 193-199
c       for Cu for calculation absorption coefficient
c
      DATA BARNCU/.655E+00,.194E+01,.576E+01,.166E+02,.415E+02,.899E+02,
     2            .173E+03,.304E+03,.498E+03,.768E+03,.114E+04,.161E+04,
     3            .222E+04,.297E+04,.388E+04,.497E+04,.624E+04,.772E+04,
     4            .940E+04,.113E+05,.135E+05,.159E+05,.185E+05,.213E+05,
     5            .246E+05,.280E+05,.314E+05,.476E+04,.547E+04,.629E+04,
     6            .719E+04,.819E+04,.929E+04,.105E+05,.118E+05,.132E+05,
     7            .148E+05,.165E+05,.183E+05,.203E+05,.223E+05,.246E+05,
     8            .270E+05,.295E+05,.323E+05,.352E+05,.382E+05,.415E+05,
     9            .450E+05,.486E+05,.525E+05,.565E+05,.607E+05,.652E+05,
     .            .700E+05,.750E+05,.803E+05,.857E+05,.912E+05,.968E+05,
     1            .102E+06,.108E+06,.110E+06,.105E+06,.847E+05,.977E+05,
     2            .347E+05,.367E+05,.393E+05,.410E+05,.450E+05,.460E+05,
     3            .485E+05,.513E+05,.572E+05,.580E+05,.624E+05,.634E+05,
     4            .669E+05,.668E+05,.754E+05,.798E+05,.843E+05,.881E+05,
     5            .865E+05,.972E+05,.102E+06,.102E+06,.143E+06,.118E+06,
     6            .106E+06,.112E+06,.123E+06,.113E+06,.144E+06,.138E+06,
     7            .143E+06,.150E+06,.000E+00,.000E+00,.000E+00,.000E+00,
     8            .000E+00/
c
C MASS ABS DATA FROM INTERNATIONAL TABLES (1992), VOL C, P 200-206
c      for Mo Kalpha_average
c23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
       DATA MACMO /3.73E-01,2.02E-01,1.98E-01,2.56E-01,3.68E-01,
     2             5.76E-01,8.45E-01,1.22E+00,1.63E+00,2.35E+00,
     3             3.03E+00,4.09E+00,5.11E+00,6.64E+00,7.97E+00,
     4             9.99E+00,1.15E+01,1.28E+01,1.62E+01,1.93E+01,
     5             2.08E+01,2.34E+01,2.60E+01,2.99E+01,3.31E+01,
     6             3.76E+01,4.10E+01,4.69E+01,4.91E+01,5.40E+01,
     7             5.70E+01,6.12E+01,6.61E+01,6.95E+01,7.56E+01,
     8             7.93E+01,8.51E+01,9.06E+01,9.70E+01,1.63E+01,
     9             1.77E+01,1.88E+01,2.04E+01,2.17E+01,2.33E+01,
     .             2.47E+01,2.65E+01,2.78E+01,2.95E+01,3.10E+01,
     1             3.27E+01,3.38E+01,3.67E+01,3.82E+01,4.07E+01,
     2             4.23E+01,4.49E+01,4.77E+01,5.07E+01,5.30E+01,
     3             5.63E+01,5.78E+01,6.09E+01,6.26E+01,6.58E+01,
     4             6.83E+01,7.13E+01,7.44E+01,7.79E+01,8.04E+01,
     5             8.40E+01,8.69E+01,9.04E+01,9.38E+01,9.74E+01,
     6             1.00E+02,1.04E+02,1.07E+02,1.12E+02,1.15E+02,
     7             1.18E+02,1.22E+02,1.26E+02,1.32E+02,1.17E+02,
     8             1.08E+02,8.70E+01,8.80E+01,9.08E+01,9.65E+01,
     9             1.01E+02,1.02E+02,4.22E+01,3.99E+01,4.81E+01,
     .             4.90E+01,4.90E+01,5.00E+01,0.00E+00,0.00E+00,
     1             0.00E+00,0.00E+00,0.00E+00/
c
c
C MASS ABS DATA FROM INTERNATIONAL TABLES (1992), VOL C, P 200-206
c      for Cu Kalpha_average
c23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
       DATA MACCU /3.91E-01,2.92E-01,5.00E-01,1.11E+00,2.31E+00,
     2             4.51E+00,7.44E+00,1.15E+01,1.58E+01,2.29E+01,
     3             2.97E+01,4.00E+01,4.96E+01,6.37E+01,7.55E+01,
     4             9.33E+01,1.06E+02,1.16E+02,1.45E+02,1.70E+02,
     5             1.80E+02,2.00E+02,2.19E+02,2.47E+02,2.70E+02,
     6             3.02E+02,3.21E+02,4.88E+01,5.18E+01,5.79E+01,
     7             6.21E+01,6.79E+01,7.47E+01,8.00E+01,8.90E+01,
     8             9.52E+01,1.04E+02,1.13E+02,1.24E+02,1.39E+02,
     9             1.45E+02,1.54E+02,1.66E+02,1.76E+02,1.89E+02,
     .             1.99E+02,2.13E+02,2.22E+02,2.36E+02,2.47E+02,
     1             2.59E+02,2.67E+02,2.88E+02,2.99E+02,3.17E+02,
     2             3.25E+02,3.48E+02,3.68E+02,3.90E+02,4.04E+02,
     3             4.26E+02,4.34E+02,4.34E+02,4.03E+02,3.21E+02,
     4             3.62E+02,1.29E+02,1.32E+02,1.40E+02,1.42E+02,
     5             1.56E+02,1.55E+02,1.58E+02,1.68E+02,1.87E+02,
     6             1.84E+02,1.91E+02,1.88E+02,2.01E+02,1.88E+02,
     7             2.26E+02,2.35E+02,2.44E+02,2.54E+02,2.48E+02,
     8             2.67E+02,2.77E+02,2.73E+02,3.17E+02,3.06E+02,
     9             2.71E+02,2.88E+02,3.14E+02,2.80E+02,3.22E+02,
     .             3.38E+02,3.52E+02,3.60E+02,0.00E+00,0.00E+00,
     1             0.00E+00,0.00E+00,0.00E+00/
c
c
C MASS ABS DATA FROM INTERNATIONAL TABLES (1962), VOL IV, P 61-66
c       DATA TAMURO/.3727,.2019,.1968,.2451,.3451,.5348,.7898,1.147,
c     1 1.584,2.209,2.939,3.979,5.043,6.533,7.870,9.625,11.64,12.62,
c     2 16.20,19.00,21.04,23.25,25.24,29.25,31.86,37.74,41.02,47.24,
c     3 49.34,55.46,56.90,60.47,65.97,68.82,74.68,79.10,83.00,88.04,
c     4 97.56,16.10,16.96,18.44,19.78,21.33,23.05,24.42,26.38,27.73,
c     4 29.13,31.18,33.01,33.92,36.33,38.31,40.44,42.37,45.34,48.56,
c     5 50.78,53.28,55.52,57.96,61.18,62.79,66.77,68.89,72.14,75.61,
c     6 78.98,80.23,84.18,86.33,89.51,95.76,98.74,100.2,103.4,108.6,
c     7 111.3,114.7,119.4,122.8,125.9,117.2,99.46,96.67,48.84,16*0.0/
cC REAL DISPERSION CORRECTIONS, INTERNATIONAL TABLES (1974), VOL IV, P 150-151
c      DATA REDISP/5*0.,.002,.004,.008,.014,.021,.030,.042,.056,
c     1 .072,.090,.110,.132,.155,.179,.203,.226,.248,.267,.284,
c     2 .295,.301,.299,.285,.263,.222,.163,.081,-.030,-.178,-.374,
c     3 -.652,-1.044,-1.657,-2.951,-2.965,-2.197,-1.825,-1.590,
c     4 -1.420,-1.287,-1.177,-1.085,-1.005,-.936,-.873,-.816,
c     5 -.772,-.726,-.684,-.644,-.613,-.588,-.564,-.530,-.535,
c     6 -.530,-.533,-.542,-.564,-.591,-.619,-.666,-.723,-.795,
c     7 -.884,-.988,-1.118,-1.258,-1.421,-1.598,-1.816,-2.066,
c     8 -2.352,-2.688,-3.084,-3.556,-4.133,-4.861,-5.924,-7.444,
c     9 -8.862,-7.912,-7.620,-7.725,-8.127,-8.960,-10.673,-11.158,
c     1 -9.725,-8.926,-8.416,-7.990,-7.683,5*0./
c
c
c
c
c   STRUCTURE FACTOR TYPES
c     from International Tables, Vol  ,pp
c
      DATA KINDF/
     1      'HS ','H  ','H1 ','LI ','LI1','BE ','BE2','B  ','C  ','   ',
     2      'CV ','N  ','O  ','O1 ','F  ','F1 ','NA ','NA1','MG ','MG2',
     3      'AL ','AL3','SI ','SI4','P  ','S  ','CL ','CL1','K  ','K1 ',
     4      'CA ','CA2','SC ','SC3','TI ','TI2','TI3','TI4','V  ','V2 ',
     5      'V3 ','V5 ','CR ','CR2','CR3','MN ','MN2','MN3','MN4','FE ',
     6      'FE2','FE3','CO ','CO2','CO3','NI ','NI2','NI3','CU ','CU1',
     7      'CU2','ZN ','ZN2','GA ','GA3','GE ','GE4','AS ','SE ','BR ',
     8      'BR1','RB ','RB1','SR ','SR2','Y  ','Y3 ','ZR ','ZR4','NB ',
     9      'NB3','NB5','MO ','MO3','MO5','MO6','TC ','RU ','RU3','RU4',
     .      'RH ','RH3','RH4','PD ','PD2','PD4','AG ','AG1','AG2','CD ',
     1      'CD2','IN ','IN3','SN ','SN2','SN4','SB ','SB3','SB5','TE ',
     2      'I  ','I1 ','CS ','CS1','BA ','BA2','LA ','LA3','CE ','CE3',
     3      'CE4','PR ','PR3','PR4','ND ','ND3','PM ','PM3','SM ','SM3',
     4      'EU ','EU2','EU3','GD ','GD3','TB ','TB3','DY ','DY3','HO ',
     5      'HO3','ER ','ER3','TM ','TM3','YB ','YB2','YB3','LU ','LU3',
     6      'HF ','HF4','TA ','TA5','W  ','W6 ','RE ','OS ','OS4','IR ',
     7      'IR3','IR4','PT ','PT2','PT4','AU ','AU1','AU3','HG ','HG1',
     8      'HG2','TL ','TL1','TL3','PB ','PB2','PB4','BI ','BI3','BI5',
     9      'PO ','AT ','RN ','FR ','RA ','RA2','AC ','AC3','TH ','TH4',
     .      'PA ','U  ','U3 ','U4 ','U6 ','NP ','NP3','NP4','NP6','PU ',
     1      'PU3','PU4','PU6','AM ','CM ','BK ','CF ','HE ','NE ','AR ',
     2      'KR ','XE ','ES ','FM ','MD ','NO ','LR '/
c
c
C THIS ARRAY MAPS FORM FACTORS TO ATOMIC NUMBERS
c
       DATA NOTA/
     1         1,    1,    1,    3,    3,    4,    4,    5,    6,    0, 
     2         6,    7,    8,    8,    9,    9,   11,   11,   12,   12, 
     3        13,   13,   14,   14,   15,   16,   17,   17,   19,   19, 
     4        20,   20,   21,   21,   22,   22,   22,   22,   23,   23, 
     5        23,   23,   24,   24,   24,   25,   25,   25,   25,   26, 
     6        26,   26,   27,   27,   27,   28,   28,   28,   29,   29, 
     7        29,   30,   30,   31,   31,   32,   32,   33,   34,   35, 
     8        35,   37,   37,   38,   38,   39,   39,   40,   40,   41, 
     9        41,   41,   42,   42,   42,   42,   43,   44,   44,   44, 
     .        45,   45,   45,   46,   46,   46,   47,   47,   47,   48, 
     1        48,   49,   49,   50,   50,   50,   51,   51,   51,   52, 
     2        53,   53,   55,   55,   56,   56,   57,   57,   58,   58, 
     3        58,   59,   59,   59,   60,   60,   61,   61,   62,   62, 
     4        63,   63,   63,   64,   64,   65,   65,   66,   66,   67, 
     5        67,   68,   68,   69,   69,   70,   70,   70,   71,   71, 
     6        72,   72,   73,   73,   74,   74,   75,   76,   76,   77, 
     7        77,   77,   78,   78,   78,   79,   79,   79,   80,   80, 
     8        80,   81,   81,   81,   82,   82,   82,   83,   83,   83, 
     9        84,   85,   86,   87,   88,   88,   89,   89,   90,   90, 
     .        91,   92,   92,   92,   92,   93,   93,   93,   93,   94, 
     1        94,   94,   94,   95,   96,   97,   98,    2,   10,   18, 
     2        36,   54,   99,  100,  101,  102,  103/
c
c
C
C DATA FOR ATOMIC MASSES TAKEN FROM VCH Periodic Table
C based on 1985 IUPAC values
C except for Th and U, radioactive elements have nuclidic mass of
C  important isotope
C compiled by FLUCK amd HEUMANN
C
       DATA ATMASS/
     1    1.00794   ,  4.002602  ,  6.941     ,  9.012182  , 10.811
     2 , 12.011     , 14.00674   , 15.9994    , 18.9984032 , 20.1797
     3 , 22.989768  , 24.3050    , 26.981539  , 28.0855    , 30.973762
     4 , 32.066     , 35.4527    , 39.948     , 39.0983    , 40.078
     5 , 44.955910  , 47.88      , 50.9415    , 51.9961    , 54.93805
     6 , 55.847     , 58.93320   , 58.69      , 63.546     , 65.39
     7 , 69.723     , 72.61      , 74.92159   , 78.96      , 79.904
     8 , 83.80      , 85.4678    , 87.62      , 88.90585   , 91.224
     9 , 92.90638   , 95.94      , 98.9063    ,101.07      ,102.90550
     * ,106.42      ,107.8682    ,112.411     ,114.82      ,118.710
     1 ,121.75      ,127.60      ,126.90447   ,131.29      ,132.90543
     2 ,137.327     ,138.9055    ,140.115     ,140.90765   ,144.24
     3 ,146.9151    ,150.36      ,151.965     ,157.25      ,158.92534
     4 ,162.50      ,164.93032   ,167.26      ,168.93421   ,173.04
     5 ,174.967     ,178.49      ,180.9479    ,183.85      ,186.207
     6 ,190.2       ,192.22      ,195.08      ,196.96654   ,200.59
     7 ,204.3833    ,207.2       ,208.98037   ,208.9824    ,209.9871
     8 ,222.0176    ,223.0197    ,226.0254    ,227.0278    ,232.0381
     9 ,231.0359    ,238.0289    ,237.0482    ,244.0642    ,243.0614
     * ,247.0703    ,247.0703    ,251.0796    ,252.0829    ,257.0951
     1 ,258.0986    ,259.1009    ,260.1053   /
c
C
C BONDING RADIUS FROM SHELXL1.F (SHELXL93) (last 9 arbitrary)
      DATA RADII/
     1     0.32,    1.50,    1.52,    1.11,    0.82,    0.77,    0.70, 
     2     0.66,    0.64,    1.50,    1.86,    1.60,    1.25,    1.17, 
     3     1.10,    1.03,    0.99,    1.50,    2.27,    1.97,    1.61, 
     4     1.45,    1.31,    1.24,    1.37,    1.24,    1.25,    1.25, 
     5     1.28,    1.33,    1.26,    1.22,    1.21,    1.17,    1.14, 
     6     1.50,    2.48,    2.15,    1.78,    1.59,    1.43,    1.36, 
     7     1.35,    1.33,    1.35,    1.38,    1.44,    1.49,    1.44, 
     8     1.40,    1.41,    1.37,    1.33,    1.50,    2.65,    2.17, 
     9     1.87,    1.83,    1.82,    1.81,    1.81,    1.80,    2.00, 
     *     1.79,    1.76,    1.75,    1.74,    1.73,    1.72,    1.94, 
     1     1.72,    1.56,    1.43,    1.37,    1.37,    1.34,    1.36, 
     2     1.37,    1.44,    1.50,    1.64,    1.60,    1.60,    1.60, 
     3     1.60,    1.80,    2.80,    2.20,    1.90,    1.85,    1.80, 
     4     1.80,    1.80,    1.80,    3.00,    3.00,    3.00,    3.00, 
     5     3.00,    3.00,    3.00,    3.00,    3.00/
c
C DATA FOR ATOMIC MASSES TAKEN FROM CRC HANDBOOK, 66 ED  1985-1986 
C TABLE OF STANDARD ATOMIC WEIGHTS 1981
c       DATA ATMASS/1.00794,4.0026,6.941,9.01218,10.81,12.011,
c     1 14.0067,15.9994,18.998403,20.179,22.98977,24.305,26.98154,
c     2 28.0855,30.97376,32.06,35.453,39.948,39.0983,40.08,44.9559,
c     3 47.88,50.9415,51.996,54.9380,55.847,58.9332,58.69,63.546,
c     4 65.38,69.72,72.59,74.9216,78.96,79.904,83.80,85.4678,87.62,
c     5 88.9059,91.22,92.9064,95.94,98.,101.07,102.9055,106.42,
c     6 107.8682,112.41,114.82,118.69,121.75,127.60,126.9045,131.29,
c     7 132.9054,137.33,138.9055,140.12,140.9077,144.24,145.,150.36,
c     8 151.96,157.25,158.9254,162.50,164.9304,167.26,168.9342,173.04,
c     9 174.967,178.49,180.9479,183.85,186.207,190.2,192.22,195.08,
c     1 196.9665,200.59,204.383,207.2,208.9804,209.,210.,222.,223.,
c     1 226.0254,227.0278,232.0381,231.0359,238.0289,237.0482,244.,243.,
c     2 247.,247.,251.,252.,257.,258.,259.,260./
c
c
C END (207)
      DATA ATABL/.493002,.322912,.140191,.040810,.489918,.262003,
     1 .196767,.049879,.897661,.565616,.415815,.116973,1.1282,.7508,
     2 .6175,.4653,.6968,.7888,.3414,.1563,1.5919,1.1278,.5391,.7029,
     3 6.2603,.8849,.7993,.1647,2.0545,1.3326,1.0979,.7068,
C   C,CV (32)
     4 2.31,1.02,1.5886,.865,4*0.0,2.26069,1.56165,1.05075,.839259,
     5 12.2126,3.1322,2.0125,1.1663,3.0485,2.2868,1.5463,.867,4.1916,
     6 1.63969,1.52673,-20.307,3.5392,2.6412,1.517,1.0243,3.6322,
     7 3.51057,1.26064,.940706,4.7626,3.1736,1.2674,1.1128,3.2565,
C  NA1,MG (69)
     8 3.9362,1.3998,1.0032,5.4204,2.1735,1.2269,2.3073,3.4988,3.8378,
     9 1.3284,.8497,6.4202,1.9002,1.5936,1.9646,4.17448,3.3876,
     1 1.20296,.528137,6.2915,3.0353,1.9891,1.541,4.43918,3.20345,
     1 1.19453,.41653,6.4345,4.1791,1.78,1.4908,6.9053,5.2034,1.4379, 
C  CL,CL1 (103)
     2 1.5863,11.4604,7.1964,6.2556,1.6455,18.2915,7.2084,6.5337,
     3 2.3386,8.2186,7.4398,1.0519,.8659,7.9578,7.4917,6.359,1.1915,
     4 8.6266,7.3873,1.5899,1.0211,15.6348,7.9518,8.4372,.8537,9.189,
     5 7.36790,1.6408,1.468,13.4008,8.0273,1.65943,1.57936,9.7595,
C  SC,TI4(137)
     6 7.3558,1.6991,1.9021,9.11423,7.62174,2.2793,.087899,17.7344,
     7 8.73816,5.25691,1.92134,19.5114,8.23473,2.01341,1.5208,10.2971,
     8 7.3511,2.0703,2.0571,10.106,7.3541,2.2884,.0223,9.43141,7.7419,
     9 2.15343,.016865,15.6887,8.14208,2.03081,-9.576,10.6406,7.3537,
C CR,MN3 (170)
     2 3.324,1.4922,9.54034,7.7509,3.58274,.509107,9.6809,7.81136,
     1 2.87603,.113575,11.2819,7.3573,3.0193,2.2441,10.8061,7.362,
     2 3.5268,.2184,9.84521,7.87194,3.56531,.323613,9.96253,7.97057,
     3 2.76067,.054447,11.7695,7.3573,3.5222,2.3045,11.0424,7.374,
C  MN3,CO (202)
     4 4.1346,.4399,11.1764,7.3863,3.3948,.0724,12.2841,7.3409,4.0034,
     5 2.3488,11.2296,7.3883,4.7393,.7108,10.338,7.88173,4.76795,
     6 .725591,12.8376,7.292,4.4438,2.38,11.4166,7.4005,5.3442,.9773,
     7 10.7806,7.75868,5.22746,.847114,13.338,7.1676,5.6158,1.6735,
C  NI3,ZN2  (236)
     8 11.9475,7.3573,6.2455,1.5578,11.8168,7.11181,5.78135,1.14523,
     9 14.0743,7.0318,5.1652,2.41,11.9719,7.3862,6.4668,1.394,15.2354,
     3 6.7006,4.3591,2.9623,12.692,6.69883,6.06692,1.0066,16.0816,
     1 6.3747,3.7068,3.683,12.9172,6.70003,6.06791,.859041,
C  END OF PAGE ONE (268)
     2 16.6723,6.0701,3.4313,4.2779,17.0006,5.8196,3.9731,4.3543, 
     3 17.1789,5.2358,5.6377,3.9851,17.1718,6.3338,5.5754,3.7272,
     4 17.1784,9.6435,5.1399,1.5292,17.5816,7.6598,5.8981,2.7817,
     5 17.5663,9.8184,5.422,2.6694,18.0874,8.1373,2.5654,-34.193,
C  RB,Y3 (300)
     6 17.776,10.2946,5.72629,3.26588,17.9268,9.1531,1.76795,-33.108,
     7 17.8765,10.948,5.41732,3.65721,18.1668,10.0562,1.01118,-2.6479,
     8 17.6142,12.0144,4.04183,3.53346,19.8812,18.0653,11.0177,1.94715,
     9 17.9163,13.3417,10.799,.337905,3.7025,17.2356,12.8876,3.7429,
C  NB5,TC (332)
     4 21.1664,18.2017,11.7423,2.30951,21.0149,18.0992,11.4632,.740625,
     1 17.8871,11.175,6.57891,0.0,19.1301,11.0948,4.64901,2.71263,
     2 19.2674,12.9182,4.86337,1.56756,18.5638,13.2885,9.32602,3.00964,
     3 18.5003,13.1787,4.71304,2.18535,19.2957,14.3501,4.73425,1.28918,
C  RH3 (364)
     4 18.8785,14.1259,3.32515,-6.1989,18.8545,13.9806,2.53464,-5.6526,
     5 19.3319,15.5017,5.29537,.605844,19.1701,15.2096,4.32234,0.0,
     6 19.2493,14.79,2.89289,-7.9492,19.2808,16.6885,4.8045,1.0463,
     7 19.1812,15.9719,5.27475,.357534,19.1643,16.2456,4.3709,0.0,
C  AG,IN (396)
     8 19.2214,17.6444,4.461,1.6029,19.1514,17.2535,4.47128,0.0,
     9 19.1624,18.5596,4.2948,2.0396,19.1045,18.1108,3.78897,0.0,
     5 19.1889,19.1005,4.4585,2.4663,19.1094,19.0548,4.5648,.487,
     1 18.9333,19.7131,3.4182,.0193,19.6418,19.0455,5.0371,2.6827,
C SB,I1 (428)
     2 18.9755,18.933,5.10789,.288753,19.8685,19.0302,2.41253,0.0,
     3 19.9644,19.0138,6.14487,2.5239,20.1472,18.9949,7.5138,2.2735,
     4 20.2332,18.997,7.8069,2.8868,20.3892,19.1062,10.662,1.4953,
     5 20.3524,19.1278,10.2821,.9615,20.3361,19.297,10.888,2.6959,
C BA2 (460)
     6 20.1807,19.1136,10.9054,.77634,20.578,19.599,11.3727,3.28719,
     7 20.2489,19.3763,11.6323,.336048,21.1671,19.7695,11.8513,3.33049,
     8 20.8036,19.559,11.9369,.612376,20.3235,19.8186,12.1233,.144583,
     9 22.044,19.6697,12.3856,2.82428,21.3727,19.7491,12.1329,.97518,
     6 20.9413,20.0539,12.4668,.296689,22.6845,19.6847,12.774,2.85137,
C ND3 (500)
     1 21.961,19.9339,12.12,1.51031,23.3405,19.6095,13.1235,2.87516,
     2 22.5527,20.1108,12.0671,2.07492,24.0042,19.4258,13.4396,2.89604,
     3 23.1504,20.2599,11.9202,2.71488,24.6274,19.0886,13.7603,2.9227,
     4 24.0063,19.9504,11.8034,3.87243,23.7497,20.3745,11.8509,3.26503,
     5 25.0709,19.0798,13.8518,3.54545,24.3466,20.4208,11.8708,3.7149,
C  BOTTOM PAGE TWO (540)
     6 25.8976,18.2185,14.3167,2.95354,24.9559,20.3271,12.2471,3.773,
     7 26.507,17.6383,14.5596,2.96577,25.5395,20.2861,11.9812,4.50073,
     8 26.9049,17.294,14.5583,3.63837,26.1296,20.0994,11.9788,4.93676,
     9 27.6563,16.4285,14.9779,2.98233,26.722,19.7748,12.1506,5.17379,
     6 28.1819,15.8851,15.1542,2.98706,27.3083,19.332,12.3339,5.38348,
C YB (580)
     1 28.6641,15.4345,15.3087,2.98963,28.1209,17.6817,13.3335,5.14657,
     2 27.8917,18.7614,12.6072,5.47647,28.9476,15.2208,15.1,3.71601,
     3 28.4628,18.121,12.8429,5.59415,29.144,15.1726,14.7586,4.30013,
     4 28.8131,18.4601,12.7285,5.59927,29.2024,15.2293,14.5135,4.76492,
     5 29.1587,18.8407,12.8268,5.38695,29.0818,15.43,14.4327,5.11982,
C W6 (620)
     6 29.4936,19.3763,13.0544,5.06412,28.7621,15.7189,14.5564,5.44174,
     7 28.1894,16.155,14.9305,5.67589,30.419,15.2637,14.7458,5.06795,
     8 27.3049,16.7296,15.6115,5.83377,30.4156,15.862,13.6145,5.82008,
     9 30.7058,15.5512,14.2326,5.53672,27.0059,17.7639,15.7131,5.7837,
     7 29.8429,16.7224,13.2153,6.35234,30.9612,15.9829,13.7348,5.92034,
C AU (660)
     1 16.8819,18.5913,25.5582,5.86,28.0109,17.8204,14.3359,6.58077,
     2 30.6886,16.9029,12.7801,6.52354,20.6809,19.0417,21.6575,5.9676,
     3 25.0853,18.4973,16.8883,6.48216,29.5641,18.06,12.8374,6.89912,
     4 27.5446,19.1584,15.538,5.52593,21.3985,20.4723,18.7478,6.82847,
     5 30.8695,18.3481,11.9328,7.00574,31.0617,13.0637,18.442,5.9696,
C PB2 (700)
     6 21.7886,19.5682,19.1406,7.01107,32.1244,18.8003,12.0175,6.96886,
     7 33.3689,12.951,16.5877,6.4692,21.8053,19.5026,19.1053,7.10295,
     8 33.5364,25.0946,19.2497,6.91555,
     9 34.6726,15.4733,13.1138,7.02588,35.3163,19.0211,
     1 9.49887,7.42518,35.5631,21.2816,8.0037,7.4433,35.9299,23.0547,
C FR
     2 12.1439,2.11253,35.7630,22.9064,12.4739,3.21097,35.2150,
     3 21.67,7.91342,7.65078,35.6597,23.1032,12.5977,4.08655,35.1736,
     4 22.1112,8.19216,7.05545,35.5645,23.4219,12.7473,4.80703,35.1007,
     5 22.4418,9.78554,5.29444,35.8847,23.2948,14.1891,4.17287,36.0228,
     6 23.4128,14.9491,4.188,35.5747,22.5259,12.2165,5.37073,35.3715,
C U4
     7 22.5326,12.0291,4.7984,34.8509,22.7584,14.0099,1.21457,36.1874,
     8 23.5964,15.6402,4.1855,35.7074,22.613,12.9898,5.43227,
     9 35.5103,22.5787,12.7766,4.92159,35.0136,22.7286,14.3884,1.75669,
     1 36.5254,23.8083,16.7707,3.47947,35.84,22.7169,13.5807,5.66016,
     1 35.6493,22.646,13.3595,5.18831,35.1736,22.7181,14.7635,2.28678,
C PU6
     2 36.6706,24.0992,17.3415,3.49331,36.6488,24.4096,17.399,4.21665,
     3 36.7881,24.7736,17.8919,4.23284,36.9185,25.1995,18.3317,4.24391,
     4 .8734,.6309,.3112,.178,3.9553,3.1125,1.4546,1.1251,
     5 7.4845,6.7723,.6539,1.6442,17.3555,6.7286,5.5493,3.5375,
     6 20.2933,19.0298,8.9767,1.99,20*0.0/
C END (828)
      DATA BTABL/10.5109,26.1257,3.14236,57.7997,20.6593,7.74039,
     1 49.5519,2.20159,53.1368,15.187,186.576,3.56709,3.9546,1.0524,
     2 85.3905,168.261,4.62370,1.9557,.6316,10.0953,43.6427,1.8623,
     3 103.483,.542,.0027,.8313,2.2758,5.1146,23.2185,1.021,60.3498,
C  C,CV (31)
     4 .1403,20.8439,10.2075,.5687,51.6512,4*0.0,22.6907,.656665,
     5 9.75618,55.5949,.0057,9.8933,28.9975,.5826,13.2771,5.7011,
     6 .3239,32.9089,12.8573,4.17236,47.0179,-.01404,10.2825,4.2944,
     7 .2615,26.1476,5.27756,14.7353,.442258,47.3437,3.285,8.8422,
C  NA,NA1 (66)
     8 .3136,129.424,2.6671,6.1153,.2001,14.039,2.8275,79.2611,.3808,
     9 7.1937,2.1676,4.7542,.185,10.1411,3.0387,.7426,31.5472,85.0886,
     1 1.93816,4.14553,.228753,8.28524,2.4386,32.3337,.6785,81.6937,
     1 1.64167,3.43757,.2149,6.65365,1.9067,27.157,.526,68.1645,
C  S,CL (100)
     2 1.4679,22.2151,.2536,56.172,.0104,1.1662,18.5194,47.7784,.0066,
     3 1.1717,19.5424,60.4486,12.7949,.7748,213.187,41.6841,12.6331,
     4 .7674,-.002,31.9128,10.4421,.6599,85.7484,178.437,-.0074,.6089,
     5 10.3116,25.9905,9.0213,.5729,136.108,51.3531,.29854,7.9629,
C  SC,TI4 (134)
     6 -.28604,16.0662,7.8508,.5000,35.6338,116.105,7.5243,.457585,
     7 19.5361,61.6558,.22061,7.04716,-.15762,15.9768,.178847,6.67018,
     8 -.29263,12.9464,6.8657,.4385,26.8938,102.478,6.8818,.4409,
     9 20.3004,115.122,6.39535,.383349,15.1908,63.969,.679003,5.40135,
C TI4,CR (166)
     2 9.97278,.940464,6.1038,.39200,20.2626,98.7399,5.66078,.344261,
     1 13.3075,32.4224,5.59463,.334393,12.8288,32.8761,5.3409,.343200,
     2 17.8674,83.7543,5.2796,.343500,14.343,41.3235,4.91797,.294393,
     3 10.8171,24.1281,4.8485,.283303,10.4852,27.573,4.7611,.307200,
C MN3,CO (198)
     4 15.3535,76.8805,4.6538,.305300,12.0546,31.2809,4.6147,.300500,
     5 11.6729,38.5566,4.2791,.278400,13.5359,71.1692,4.1231,.272600,
     6 10.2443,25.6466,3.90969,.238668,8.35583,18.3491,3.8785,.256500,
     7 12.1763,66.3421,3.6766,.2449,8.87300,22.1626,3.5477,.22314,
C NI3,ZN2 (230)
     8 7.64468,16.9673,3.5828,.24700,11.3966,64.8126,3.3669,.227400,
     9 8.6625,25.8487,3.37484,.244078,7.9876,19.897,3.2655,.233300,
     3 10.3163,58.7097,2.9946,.203100,7.0826,18.0995,3.0699,.241200,
     1 10.7805,61.4135,2.81262,.22789,6.36441,14.4122,2.8509,.251600,
     2 11.4468,54.7625,2.53718,.205855,5.47913,11.6030,
C  BOTTOM PAGE 1 (268)
     3 2.6345,.2647,12.9479,47.7972,2.4098,.2726,15.2372,43.8163,
     4 2.1723,16.5796,.2609,41.4328,2.2059,19.3345,.2871,58.1535,
C  RB (284)
     5 1.7888,17.3151,.2748,164.934,1.7139,14.7957,.1603,31.2087,
     6 1.5564,14.0988,.1664,132.376,1.4907,12.6963,24.5651,-.0138,
     7 1.4029,12.8006,.125599,104.354,1.35417,11.2145,22.6599,-.01319,
     8 1.27618,11.916,.1176222,87.6627,1.2148,10.1483,21.6054,-.10276,
     9 1.18865,11.766,.204785,69.7957,.019175,1.13305,10.1621,28.3389,
C  NB5 (324)
     4 1.12446,.028781,9.28206,25.7228,.2772,1.0958,11.004,61.6584,
     1 .014734,1.03031,9.53659,26.6307,.014345,1.02238,8.78809,23.3452,
     2 1.03649,8.48061,.058881,0.0,.864132,8.14487,21.5707,86.8472,
     3 .80852,8.43467,24.7997,94.2928,.847329,8.37164,.017662,22.887,
     4 .844582,8.12534,.036495,20.8504,.751536,8.21758,25.8749,98.6062,
C RH3 (364)
     5 .764252,7.84438,21.2487,-.01036,.760825,7.62436,19.3317,-.0102,
     6 .698655,7.98929,25.2052,76.8986,.696219,7.55573,22.5057,0.0,
     7 .683839,7.14833,17.9144,.005127,.6446,7.4726,24.6605,99.8156,
     8 .646179,7.19123,21.7326,66.1147,.645643,7.18544,21.4072,0.0,
     9 .5946,6.9089,24.7008,87.4825,.597922,6.80639,20.2521,0.0,
C IN (404)
     5 .5476,6.3776,25.8499,92.8029,.551522,6.3247,17.3595,0.0,
     1 5.8303,.5031,26.8909,83.9571,.5036,5.8378,23.3752,62.2061,
     2 5.764,.4655,14.0049,-.7583,5.3034,.4607,27.9074,75.2825,
     3 .467196,5.22126,19.5902,55.5113,5.44853,.467973,14.1259,0.0,
     4 4.81742,.420885,28.5284,70.8403,4.347,.3814,27.766,66.8776,
C  I1 (444)
     5 4.3579,.3815,29.5259,84.9304,3.569,.3107,24.3879,213.904,
     6 3.552,.3086,23.7128,59.4565,3.216,.2756,20.2073,167.202,
C  BA2 (460)
     7 3.21367,.28331,20.0558,51.746,2.94817,.24475,18.7726,133.124,
     8 2.92070,.250698,17.8211,54.9453,2.81219,.226836,17.6083,127.113,
     9 2.77691,.23154,16.5408,43.1692,2.65941,.21885,15.7992,62.2355,
     6 2.77393,.222087,16.7669,143.644,2.6452,.214299,15.323,36.4065,
     1 2.54467,.202481,14.8137,45.4643,2.66248,.210628,15.885,137.903,
C ND3 (500)
     2 2.52722,.199237,14.1783,30.8717,2.5627,.202088,15.1009,132.721,
     3 2.4174,.185769,13.1275,27.4491,2.47274,.196451,14.3996,128.007, 
     4 2.31641,.174081,12.1571,24.8242,2.3879,.1942,13.7546,123.174,
     5 2.27783,.17353,11.6096,26.5156,2.22258,.16394,11.311,22.9966,
     6 2.25341,.181951,12.9331,101.398,2.13553,.155525,10.5782,21.7029,
C BOTTOM PAGE TWO (540)
     7 2.24256,.196143,12.6648,115.362,2.05601,.149525,10.0499,21.2773,
     8 2.1802,.202172,12.1899,111.874,1.9804,.143384,9.34972,19.581,
     9 2.07051,.19794,11.4407,92.6566,1.91072,.139358,8.80018,18.5908,
     7 2.07356,.223545,11.3604,105.703,1.84659,.13729,8.36225,17.8974,
     1 2.02859,.238849,10.9975,102.961,1.78711,.136974,7.96778,17.2922,
C YB (580)
     2 1.9889,.257119,10.6647,100.417,1.78503,.15997,8.18304,20.39,
     3 1.73272,.13879,7.64412,16.8153,1.90182,9.98519,.261033,84.3298,
     4 1.68216,.142292,7.33727,16.3535,1.83262,9.5999,.275116,72.029,
     5 1.59136,.128903,6.76232,14.0366,1.77333,9.37046,.295977,63.3644,
     6 1.50711,.116741,6.31524,12.4244,1.72029,9.2259,.321703,57.056,
C W6 (620)
     7 1.42755,.104621,5.93667,11.1972,1.67191,9.09227,.3505,52.0861,
     8 1.62903,8.97948,.382661,48.1647,1.37113,6.84706,.165191,18.003,
     9 1.59279,8.86553,.417916,45.0011,1.34323,7.10909,.204633,20.3254,
     8 1.30923,6.71983,.167252,17.4911,1.51293,8.81174,.424593,38.6103,
     1 1.32927,7.38979,.263297,22.9426,1.24813,6.60834,.16864,16.9392,
C AU (660)
     2 .4611,8.6216,1.4826,36.3956,1.35321,7.7395,.356752,26.4043,
     3 1.2199,6.82872,.212867,18.659,.545,8.4484,1.5729,38.3246,
     4 1.39507,7.65105,.443378,28.2262,1.21152,7.05639,.284738,20.7482,
     5 .65515,8.70751,1.96347,45.8149,1.4711,.517394,7.43463,28.8482,
     6 1.1008,6.53852,.219074,17.2114,.6902,2.3576,8.618,47.2579,
C PB (700)
     7 1.3366,.488383,6.7727,23.8132,1.00566,6.10926,.147041,14.714,
     8 .704,2.9238,8.7937,48.0093,1.2356,6.24149,.469999,20.3185,
     9 .91654,.039042,5.71414,12.8285,
     1 .700999,3.55078,9.55642,47.0045,.68587,3.97458,11.3824,
     1 45.4715,.6631,4.0691,14.0422,44.2473,.646453,4.17619,23.1052,
C FR
     2 150.645,.616341,3.87135,19.9887,142.325,.604909,3.5767,12.601,
     3 29.8436,.589092,3.65155,18.599,117.02,.579689,3.41437,12.9187,
     4 25.9443,.563359,3.46204,17.8309,99.1722,.555054,3.24498,13.4661,
     5 23.9533,.547751,3.41519,16.9235,105.251,.5293,3.3253,16.0927,
     6 100.613,.52048,3.12293,12.7148,26.3394,.516598,3.05053,12.5723,
C U4
     7 23.4582,.507079,2.8903,13.1767,25.2017,.511929,3.25396,15.3622,
     8 97.4908,.502322,3.03807,12.1449,25.4928,.498626,2.96627,11.9484,
     9 22.7502,.48981,2.81099,12.33,22.6581,.499384,3.26371,14.9455,
     1 105.98,.484938,2.96118,11.5331,24.3992,.481422,2.8902,11.316,
     1 21.8301,.473204,2.73848,11.553,20.9303,.483629,3.20647,14.3136,
C AM
     2 102.273,.465154,3.08997,13.4346,88.4834,.451018,3.04619,12.8946,
     3 86.003,.437533,3.00775,12.4044,83.7881,
     4 9.1037,3.3568,22.9276,.9821,8.4042,3.4262,0.2306,21.7184,
     5 .9072,14.8407,43.8983,33.3929,1.9384,16.5623,.2261,39.3972,
     6 3.9282,.344,26.4659,64.2658,20*0.0/
C END (828)
      DATA CTAB/.003038,.001305,.002389,.037700,.0167,.0385,-6.1092,
     1 -0.1932,.2156,0.0,.286977,-11.529,.2508,21.9412,.2776,.653396,
     2 .676,.404,.8584,.4853,1.1151,.706786,1.1407,.746297,1.1149,
     3 .8669,-9.5574,-16.378,1.4228,-4.9978,1.3751,-14.875,1.33290,
     4 -6.6667,1.2807,.897155,-14.652,-13.280,
     5 1.21990,1.22980,.656565,1.71430,1.18320,.616898,.518275,1.0896,
C MN2 (46)
     6 1.08740,.393974,.251877,1.03690,1.00970,.970700,1.01180,.93240,
     7 .286667,1.03410,.861400,.386044,1.19100,.89000,1.14431,1.30410,
     8 .780700,1.71890,1.53545,2.13130,1.45572,
C END PAGE ONE (67)
     9 2.531,2.8409,2.9557,3.1776,3.4873,2.0782,2.5064,41.4025,1.91213,
     1 40.2602,2.06929,9.41454,3.75591,-12.912,-6.3934,4.3875,
     2 -14.421,-14.316,.344941,5.40428,5.37874,-3.1892,1.42357,5.328,
     3 11.8678,11.2835,5.26593,5.2916,13.0174,5.179,5.21572,5.21404,
     4 5.06940,5.11937,4.9391,4.99635,4.7821,4.7861,3.9182,4.5909,
     5 4.69626,4.69263,4.352,4.0712,4.0714,3.3352,3.2791,2.7731,
C BA2 (115)
     6 3.02902,2.14678,2.4086,1.86264,2.09013,1.5918,2.0583,1.77132,
     7 1.24285,1.98486,1.47588,2.02876,1.19499,2.20963,.954586,2.5745,
     8 1.36389,.759344,2.4196,.645089,
C END OF TWO (135)
     9 3.58324,.691967,4.29728,.68969,4.56796,.852795,5.92046,1.17613,
     3 6.75621,1.63929,7.56672,3.70983,2.26001,7.97628,2.97573,8.58154,
     1 2.39699,9.24354,1.78555,9.8875,1.01074,10.472,11.0005,6.49804,
     2 11.4722,8.27903,6.96824,11.6883,9.85329,7.39534,12.0658,11.2299,
     3 9.0968,12.6089,12.0205,10.6268,13.1746,12.5258,9.8027,13.4118,
C PB
     4 12.4734,8.08428,13.5782,12.4711,-6.7994,
     1 13.677,13.7108,13.6905,13.7247,13.6211,13.5431,13.5266,
     1 13.4637,13.4314,13.376,13.4287,13.3966,13.3092,13.2671,13.1665,
     2 13.3573,13.2544,13.2116,13.113,13.3812,13.1991,13.1555,13.0582,
     3 13.3592,13.2887,13.2754,13.2674,.0064,.3515,1.4445,2.825,
     4 3.7118,5*0.0/
C END (207)
c
c
c
      if (what .eq. 'FF') then
c
        DO 1 J=1,217
        IF(IDEN.EQ.KINDF(J))GO TO 2
    1   CONTINUE
C       HERE IF NO MATCH
        ERG=99
        GO TO 4
    2   DO 3 I=1,4
        A(I)=ATAB(I,J)
        B(I)=BTAB(I,J)
    3   CONTINUE
	C=CTAB(J)
        ERG=0
    4   RETURN
c
      elseif (what .eq. 'MO') then
c
c      WAVLEN=0.7107
      DO 5 J=1,217
      IF (IDEN .EQ. KINDF(J)) GOTO 6
    5 CONTINUE
C       HERE IF NO MATCH
      ERG=1
      GOTO 7
    6 K=NOTA(J)
      a(1)=fpMO(k)
      a(2)=fppMO(k)
      a(3)=barnMO(k)
      a(4)=macMO(k)
      b(1)=atmass(k)
      b(2)=k
      b(3)=radii(k)
      ERG=0
    7 RETURN
c
      elseif (what .eq. 'CU') then
c
c      WAVLEN=0.7107
      DO 8 J=1,217
      IF (IDEN .EQ. KINDF(J)) GOTO 9
    8 CONTINUE
C       HERE IF NO MATCH
      ERG=2
      GOTO 10
    9 K=NOTA(J)
      a(1)=fpCU(k)
      a(2)=fppCU(k)
      a(3)=barnCU(k)
      a(4)=macCU(k)
      b(1)=atmass(k)
      b(2)=k
      b(3)=radii(k)
      ERG=0
   10 RETURN
c
      endif
c
         END
