      SUBROUTINE HKLADD
C            PROGRAM CALCULATES 2THETA, CHI, PHI FROM THE
C ORIENTATION MATRIX AND WRITES THE VALUES ON A HKL DISK
C INPUT IS :   WAVE LENGTH  FORMAT F12.6
C              ORIENTATION MATRIX FROM THE P21 AND P1BAR DIFFRACTOMETER
C              ORIENTATION MATRIX FORMAT 3F12.6,/
C              ORDER IS (1,3),(1,2),(1,3)
C                       (2,1),(2,2),(2,3)
C                       (3,1),(3,2),(3,3)
C UNIT 10 CONTAINS THE INPUT HKL FILE
C UNIT 11 CONTAINS THE OUTPUT HKL FILE
C WITH 2 THETA IN WORD (24)
C      PHI IN WORD (25)
C      CHI IN WORD (26)
C      OMEGA IN WORD (27)
      INTEGER H,K,L,SYS$TRNLOG
      INTEGER*2 NAMLEN
      CHARACTER*9 NAMDES
      CHARACTER*17 NFILE
      DIMENSION AA (3,3),DUMMY (31),REST(28)
      EQUIVALENCE (DUMMY(1),REST(1))
1      FORMAT(3F12.6)
2      FORMAT(3I5,5F10.2)
3      FORMAT(2X,3F12.6)
        IN=10                 ! HKL READ FROM UNIT 10
        OUT=11                ! OUTPUT FILE IS ON 11
      READ(1,1)WAVE
      IF(WAVE.EQ.0.0)WAVE=.7107    ! DEFAULT IF RECORD IS BLANK
      WRITE(3,3)WAVE
      READ(1,1)((AA(I,J),J=1,3),I=1,3)
      WRITE(3,3)((AA(I,J),J=1,3),I=1,3)
130   ICD=SYS$TRNLOG('NAM',NAMLEN,NAMDES,,,)
      IF(.NOT. ICD)THEN
      WRITE(3,999)
999   FORMAT(' ERROR ON RETURN FROM TRNLOG')
      RETURN
      ENDIF
      NFILE(1:NAMLEN)=NAMDES
      NAMLEN=NAMLEN+1
      NFILE(NAMLEN:NAMLEN+3)='.HKL'
      NAMLEN=NAMLEN+4
      OPEN(NAME=NFILE,UNIT=IN,TYPE='OLD',FORM='UNFORMATTED',
     1 BLOCKSIZE=32768)
C
      OPEN(NAME=NFILE,UNIT=OUT,TYPE='NEW',FORM='UNFORMATTED',
     + BLOCKSIZE=32768)
      DO I=1,3
      READ(10)DUMMY
      WRITE(11)DUMMY
      ENDDO
10     READ(10)H,K,L,REST
      IF(H.EQ.999999)GO TO 20
      AH=H
      AK=K
      AL=L
      XX=AA(1,1)*AH+AA(1,2)*AK+AA(1,3)*AL
      YY=AA(2,1)*AH+AA(2,2)*AK+AA(2,3)*AL
      ZZ=AA(3,1)*AH+AA(3,2)*AK+AA(3,3)*AL
      ROOT=SQRT((XX*XX)+(YY*YY)+(ZZ*ZZ))
      IF(XX.EQ.0.0)GO TO 58
      PHYX=YY/XX
      APHI=ATAN(PHYX)*57.2958
      GO TO 59
58    APHI=90.
59    IF(YY.LT.0.0.AND.XX.GT.0.)APHI=APHI+360.
      IF(YY.LT.0.0.AND.XX.LE.0.)APHI=APHI+180.
      IF(YY.GT.0.0.AND.XX.LT.0.)APHI=APHI+180.
      ACHI=ASIN(ZZ/ROOT)*57.2958
      THETA=2*ASIN(ROOT*(WAVE/2.))*57.2958
      OMEG=0.0
      REST(24)=OMEG
      REST(21)=THETA
      IF(ACHI.GT.-10.0)THEN
      REST(22)=APHI
      REST(23)=ACHI
      ELSE
      REST(22)=APHI+180.
      IF(REST(22).GT.360.)REST(22)=REST(22)-360.
      REST(23)=-ACHI
      ENDIF
      WRITE(11)H,K,L,REST
C     WRITE(3,2)H,K,L,REST(1),REST(2),REST(21),REST(22),REST(23)
      GO TO 10
20    CONTINUE
      WRITE(11)H,K,L,REST
      CLOSE(UNIT=IN,DISP='KEEP')
      CLOSE(UNIT=OUT,DISP='KEEP')
      RETURN
      END
