      SUBROUTINE HOPT
C
C     THIS IS A PROGRAM TO CONVERT GENERAL PLANE FOURIER MAP COORDINATES
C        TO ATOMIC X, Y AND Z COORDINATES. IT WILL ALSO OPTIMIZE THE
C        POSITIONS OF THREE ATOMS (E. G., H ATOMS OF AN AMMONIA GROUP)
C        THAT ARE SYMMETRIC ABOUT THE MAP CENTER.
C           JANUARY 23, 1980       WPS
C
C   INCORPORATED INTO CRYM 10/28/87 KMS BY SPECIAL PERMISSION OF AUTHOR
C
  1   FORMAT(1X,I2,1X,9F8.5)
  111 FORMAT(5X,3(1X,F4.1))
  112 FORMAT(20A4)
    2 FORMAT(I2,1X,I1,1X,A3,1X,A3,1X,A5,1X,A3,1X,F5.2,1X,2F5.1,1X,A3,
     1 F12.8)
120   FORMAT(1X,I2,1X,I1,1X,A3,1X,A3,1X,A5,1X,A3,1X,F5.2,1X,2F5.1,1X,A3,
     1 F12.8)
131   FORMAT(2F5.1,I4)
132   FORMAT(1X,2F5.1,I4)
   43 FORMAT ('COORD', 1X, A3,A1,2X,A3,3F9.6)
   45 FORMAT (3(2F6.4,4X))
   47 FORMAT (1X, 3(2F8.4, 4X))
   48 FORMAT (1X, 3F8.4)
   50 FORMAT (12X, 'X0 =', F8.5, 2X, 'Y0 =', F8.5, 2X, 'Z0 =', F8.5)
   51 FORMAT (12X, 'DXH =', F8.5, 2X, 'DXV =', F8.5, 4X, 'DYH =', F8.5,
     * 2X, 'DYV =', F8.5, 4X, 'DZH =', F 8.5, 2X, 'DZV =', F8.5)
   57 FORMAT (12X,'COORDINATE # ',I2,':  H = ',F5.1,', V = ',F5.1)
   52 FORMAT (12X, 'ATOM NO.', 2X, A3,A1, 3X, 'H =', F5.1, 3X, 'V =',
     * F5.1,5X, 'WEIGHT =', I3)
   53 FORMAT (12X, 'MAP SCALE =', F4.1, ' INCHES / ANGSTROM')
   59 FORMAT(12X,'RADIUS = ',F5.1,' ANGSTROMS')
   54 FORMAT (' CALCULATIONS FOR MAP NUMBER', I4)
   55 FORMAT (12X, 'BETA =', F7.2, '. THE ANGLES ARE:')
   56 FORMAT(6(5X,F8.2))
   58 FORMAT (' ')
   71 FORMAT (5X, 'INPUT DATA')
   72 FORMAT (5X, 'NORMALIZED MAP COORDINATES')
   73 FORMAT (5X, 'OPTIMIZED MAP COORDINATES')
   93 FORMAT (10X, 'COORD', 1X, A3,A1, 2X, A3, 3(F9.6, 2X))
   95 FORMAT (15X, 'SUMV CHECK EXCEEDS LIMITS FOR MAP NUMBER ', I3)
   99 FORMAT (15X, 'SUMH CHECK EXCEEDS LIMITS FOR MAP NUMBER ', I3)
      INTEGER W, Q
      PARAMETER PI=3.14159,RADDEG=57.29578
      DIMENSION H(10),V(10),W(10),CORANG(10),X(10),Y(10),Z(10),
     * S(10),G(10),U(10),CORANR(10),D(10),CH(10),CV(10),CORR(10),
     * TH(10),ANG(10),AWT(10),IWT(10)
      COMMON /FNAME/NFILE,NAMLEN
      CHARACTER*4 CNAME(20)
      CHARACTER*3 CHAR3,C3,ATOMTYP,CISO
      CHARACTER*5 C5
      CHARACTER*1 CHAR(9),CNUM(9),CN(9)
      CHARACTER*16 NFILE,NFILE1
      DATA CHAR/'A','B','C','D','E','F','G','H','I'/
      DATA CNUM/'1','2','3','4','5','6','7','8','9'/
C  OPEN HOP FILE CREATED BY FOURIER FOR READING AND CRD FILE 
C  FOR WRITING.
      N=NAMLEN+1
      NFILE1(1:N-1)=NFILE(1:N-1)
      NFILE(N:N+3)='.HOP'
      OPEN(UNIT=17,NAME=NFILE,TYPE='OLD',FORM='FORMATTED')
      NFILE1(N:N+3)='.CRD'
      OPEN(UNIT=16,NAME=NFILE1,TYPE='NEW',FORM='FORMATTED')
C
C 1.  THIS DO LOOP READS IN ONE PAIR OF CARDS AND DOES ALL THE
C        CALCULATIONS ON THEM. 99 PAIRS OF CARDS ARE THE MAXIMUM. PUT ONE
C        BLANK CARD AT THE END OF THE DATA TO STOP THE CALCULATION.
C
      DO 10 K = 1, 99
C
C 2.  THIS DO LOOP ZEROES THE CONTENTS OF ALL THE ARRAYS.
C
      DO 32 I = 1, 10
      TH(I)=0.0
      ANG(I)=0.0
      AWT(I)=0.0
      IWT(I)=0
      H(I) = 0.
      V(I) = 0.
      W(I) = 0.
      CORANG(I) = 0.
      X(I) = 0.
      Y(I) = 0.
      Z(I) = 0.
      S(I) = 0.
      G(I) = 0.
      U(I) = 0.
      CORANR(I) = 0.
      D(I) = 0.
      CH(I) = 0.
      CV(I) = 0.
      CORR(I) = 0.
   32 CONTINUE
      A = 0.0
      SUMH=0.0
      ATOT=0.0
      BTOT=0.0
      SUMV=0.0
      BETA = 0.0
      OPT=1
      IALPHA=1
      READ(1,112)CNAME
      IF(CNAME(1).EQ.'END ')GOTO 3
      DECODE(80,2,CNAME)NOA,NIR,ATOMTYP,C3,C5,CHAR3,R,HDT,VDT,CISO,BISO
      WRITE(3,120)NOA,NIR,ATOMTYP,C3,C5,CHAR3,R,HDT,VDT,CISO,BISO
      IF(CHAR3.EQ.'   ')OPT=0
      IF(NIR.EQ.0)NIR=3
      IF(C3.EQ.'   ')C3=ATOMTYP
      IF(NOA.EQ.0)NOA=1
      IF(R.EQ.0.0)R=0.9
      IF(C5.NE.'     ')THEN
        DO 320 II=1,NIR
320     CN(II)=CHAR(II)
      ELSE
        DO 321 II=1,NIR
321     CN(II)=CNUM(II)
      ENDIF
      DO 130 II=1,NIR
      READ(1,131)H(II),V(II),W(II)
      WRITE(3,132)H(II),V(II),W(II)
130   CONTINUE
C
C DATA.  THE FIRST CARD CONTAINS THE MAP NUMBER CORRESPONDING TO
C        INFORMATION PRINTED IN THE HOP FILE  (NOA) DEF. IS 1.
C        NIR - NUMBER OF ATOMS CONVERTED FROM THIS MAP. (DEF. 3)
C        ATOMTYP - FORM FACTOR LABEL TO BE ASSIGNED TO COORD CARDS.
C        C3 - FIRST 3 LETTERS OF ATOM IDENTIFIER ASSIGNED TO COORD
C        CARDS  (DEFAULT IS ATOMTYP).
C        C5 - IF NONBLANK, 4TH CHARACTER OF ATOM IDENTIFIER IS
C        ALPHA (A,B,C...) RATHER THAN NUMERIC (1,2,3...).
C        CHAR3 - IF BLANK, NO OPTIMIZATION.
C        R - RADIUS FROM RING CENTER TO ANY ATOM IN A. (DEF. 0.9)
C        HDT,VDT - HORIZONTAL AND VERITCAL COORDINATES OF THE MAP CENTER
C        IF DIFFERENT FROM CENTER OF THE MAP (CENTER OF MAP IS STORED
C        ON HOP FILE.)
C
C DATA.  NEXT NIR CARDS IS INPUT OF THE NIR ATOMS:
C        HORIZONTAL COORDINATE OF ATOM IN MAP UNITS (H(I))
C        VERTICAL COORDINATE OF ATOM IN MAP UNITS (V(I))
C        WEIGHT OF ATOM (=0.0 FOR NO OPTIMIZATION) (W(I))
C        THE WEIGHTS W(I) SHOULD EQUAL 1/SIGMA SQUARED IN THE
C        POSITION OF ATOM I.
C        THE WEIGHTS ARE NOT NECESSARY IF NO
C        OPTIMIZATION IS WANTED.
C
C  ***  COLUMNS AND ROWS ARE COUNTED STARTING FROM ZERO. ***
C
C
      REWIND 17
113   READ(17,1,ERR=114,END=114)NNN,X0,Y0,Z0,DXH,DXV,DYH,DYV,DZH,DZV
      READ(17,111,ERR=114,END=114)SCALE,HD,VD
      IF(NNN.NE.NOA)GOTO 113
      IF(HDT.NE.0.0)HD=HDT  ! RING CENTER DIFFERENT FROM MAP CENTER
      IF(VDT.NE.0.0)VD=VDT
      WRITE(3,1)NNN,X0,Y0,Z0,DXH,DXV,DYH,DYV,DZH,DZV
      WRITE(3,111)SCALE,HD,VD
C
C DATA.   READING INFORMATION FROM THE HOP FILE CREATED BY FOURIER. 
C       USING MAP NUMBER FROM THE FILE AS SPECIFIED ON 1ST CARD (NOA).
C        COORDINATES OF STARTING POINT (X0, Y0, Z0), AND
C       HORIZ0NTAL AND VERTICAL INCREMENTS, FIRST FOR X, THEN Y, THEN Z.
C       ALSO INCLUDED ARE THE COORDINATES OF THE MAP CENTER IN MAP UNITS
C       AND THE MAP SCALE IN INCHES PER ANGSTROM.
C
C
C DEF HD = THE HORIZ0NTAL COORDINATE OF THE MAP CENTER
C DEF VD = THE VERTICAL COORDINATE OF THE MAP CENTER
C
C        THIS SECTION ADJUSTS THE MAP COORDINATES SO THAT NO ANGLE
C     IS EXACTLY (N*PI/2) DEGREES.
C
      DO 66 I = 1, NIR
      H(I) = H(I) + 0.001
      V(I) = V(I) + 0.001
   66 CONTINUE
C
C DEF SCALE IS THE SCALE OF THE GENERAL PLANE MAP IN INCHES / ANGSTROM.
C
C
C DEF R IS THE RADIUS OF THE CIRCLE THE ATOMS LIE ON. DEFAULT VALUES ARE
C       3.0 INCHES / ANGSTROM FOR SCALE AND 0.9 ANGSTROM FOR R.
C
      IF (R .EQ.0.)R=0.9
      IF (SCALE .EQ. 0.0) SCALE = 3.0
C
C DEF NUM IS A DUMMY VARIABLE WHICH COUNTS THE PAIRS OF DATA CARDS.
C
      WRITE (3, 54) NOA
      WRITE (3, 58)
      WRITE (3, 71)
      WRITE (3, 58)
      WRITE (3, 50) X0, Y0, Z0
      WRITE (3, 51) DXH, DXV, DYH,DYV,DZH,DZV
      IF(OPT.EQ.1)THEN  ! OPTIMIZATION
        WRITE(3,52)(C3,CN(I),H(I),V(I),W(I),I=1,NIR)
        WRITE(3,53)SCALE
        WRITE(3,59)R
      ELSE ! NO OPTIMIZATION
        WRITE(3,57)(I,H(I),V(I),I=1,NIR)
        WRITE(3,53)SCALE
      ENDIF
      WRITE (3, 58)
C
C DEF T IS USED TO SAVE WRITING 'SCALE' IN EQUATIONS.
C
      T = SCALE
C
C DEF HCN IS THREE TIMES THE HORIZ0NTAL COORDINATE OF THE MAP CENTER.
C
C DEF VCN IS THREE TIMES THE VERTICAL COORDINATE OF THE MAP CENTER.
C
      HCN = NIR * HD
      VCN = NIR * VD
C
C 3.  THE PROGRAM WILL SKIP THE OPTIMIZATION PROCEEDURE AND JUST CONVERT
C       MAP COORDINATES TO X, Y AND Z IF THE WEIGHTS ARE LEFT BLANK.
C
      IF(OPT.EQ.0)GOTO 13
C
C 4.  THIS SECTION TESTS THE INPUT COORDINATES. IF THE THREE INPUT
C       POINTS ARE NOT SYMMETRIC ABOUT THE CENTER OF THE MAP,
C       BOTH VERTICALLY AND HORIZ0NTALLY, A MESSAGE IS
C       PRINTED AND THE CALCULATION PROCEEDS.
C
      DO 171 I=1,NIR
171   SUMH=SUMH+H(I)
      IF ((SUMH - HCN) .GT. 1.0) GO TO 100
      IF ((SUMH - HCN) .LT.-1.0) GO TO 100
      GO TO 98
  100 WRITE (3, 99) NOA
98    DO 172 I=1,NIR
172   SUMV=SUMV+V(I)
      IF ((SUMV - VCN) .GT. 1.0) GO TO 97
      IF ((SUMV - VCN) .LT.-1.0) GO TO 97
      GO TO 8
   97 WRITE (3, 95) NOA
    8 RADSQ = 2.0 * (R * T)**2
C
C 5.  THIS DO LOOP CHANGES THE WEIGHTS FROM INTEGER TO FLOATING POINT
C       VARIABLES AND THEN NORMALIZES EACH INPUT ATOM SO THAT IT IS
C       EXACTLY THE PRESCRIBED DISTANCE FROM THE CENTER POINT. THE DUMMY
C       VARIABLES CH(I) AND CV(I) ARE USED, BUT ARE LATER REPLACED WITH
C       CORRECTED VALUES OF H(I) AND V(I).
C
      DO 5 I=1,NIR
      S(I) = W(I)
      D(I) = SQRT(((H(I) - HD)/2.0)**2 + ((V(I) - VD)/4.0)**2)
      CORR(I) = (R * T) / D(I)
      CH(I) = ((H(I) - HD) * CORR(I)) + HD
      CV(I) = ((V(I) - VD) * CORR(I)) + VD
      H(I) = CH(I)
      V(I) = CV(I)
    5 CONTINUE
C
C   CALCULATE TH(I) FOR THE NIR ATOMS
C   NEXT SECTIONS COURTESY R.E. MARSH
C
      DO 34 I=1,NIR
      AAA=VD-V(I)
      BBB=2.0*(H(I)-HD)
      TH(I)=ATAN2(AAA,BBB)
34    CONTINUE
C
C   NOW DEFINE ATOM #1 AS THE ORIGIN, AND CALCULATE TH(I)-TH(1).
C   PUT IT IN THE RANGE 0 - 2*PI.  CALCULATE WHICH OF THE ATOMS 
C   AROUND THE RING IT MUST BE (K).
C
      TH0=(2.0*PI)/NIR   ! THE CORRECT ANGLE FOR AN N-MEMBERED RING
      DO 35 I=2,NIR
      THX=TH(I)-TH(1)
      IF(THX.LT.0.0)THX=THX+2*PI
      KK=INT((THX/TH0)+1.5)
      ANG(KK)=THX
      AWT(KK)=S(I)
      IWT(KK)=W(I)
35    CONTINUE
      ANG(1)=0.0
      ATOT=S(1)
      IWT(1)=W(1)
      DO 36 I=2,NIR
      ANG(I)=ANG(I)-((I-1)*TH0)
      IF(ABS(ANG(I)).GT.0.6)GOTO 116
      BTOT=BTOT+ANG(I)*AWT(I)
      ATOT=ATOT+AWT(I)
36    CONTINUE
      BETA=BTOT/ATOT
      DO 30 I=1,NIR
      CORANG(I)=BETA+((I-1)*TH0)+TH(1)
C
C 11. THIS DO LOOP CALCULATES THE CORRECTED HORIZ0NTAL AND VERTICAL
C       COORDINATES OF THE THREE ATOMS.
C
      CORANR(I) = CORANG(I)
      CORANG(I)=CORANR(I)/(PI/180.)
      G(I) = HD + 2.0 * R * T * COS(CORANR(I))
      U(I) = VD  - 4.0 * R * T * SIN(CORANR(I))
   30 CONTINUE
C
C 12. THIS DO LOOP CALCULATES THE X, Y AND Z COORDINATES OF THE ATOMS,
C
   40 DO I = 1,NIR
        X(I) = X0 + DXH * G(I) + DXV * U(I)
        Y(I) = Y0 + DYH * G(I) + DYV * U(I)
        Z(I) = Z0 + DZH * G(I) + DZV * U(I)
        WRITE (16,43) C3,CN(I), ATOMTYP, X(I), Y(I), Z(I)
        IF(CISO.EQ.'ISO')WRITE(16,431)C3,CN(I),BISO
431     FORMAT('ISO',3X,A3,A1,2X,F12.8)
      ENDDO
      IF(OPT.NE.0)THEN
        WRITE (3, 72)
        WRITE (3, 52)(C3,CN(I), H(I), V(I), W(I), I=1,NIR)
        WRITE (3, 58)
        WRITE (3, 55) BETA*RADDEG
        WRITE(3,56)(CORANG(I),I=1,NIR)
        WRITE (3, 58)
        WRITE (3, 73)
        WRITE (3, 52)(C3,CN(I), G(I), U(I), IWT(I),I=1,NIR)
        WRITE (3, 58)
      ENDIF
      DO 92 I = 1,NIR
      WRITE (3, 93) C3,CN(I), ATMTYP, X(I), Y(I), Z(I)
   92 CONTINUE
      WRITE (3, 58)
      WRITE (3, 58)
   10 CONTINUE
    3 CLOSE(UNIT=16,DISP='SAVE')
      CLOSE(UNIT=17,DISP='SAVE')
      RETURN
   13 DO 14 L=1,NIR
      G(L) = H(L)
      U(L) = V(L)
   14 CONTINUE
      GO TO 40
114   WRITE(3,115)
115   FORMAT(' ERROR READING HOP FILE.  ARE MAP NUMBERS O.K.?')
118   CLOSE(UNIT=16,DISP='SAVE')
      CLOSE(UNIT=17,DISP='SAVE')
      STOP
116   WRITE(3,117)I,ANG(I)*RADDEG,TH0*(I-1)*RADDEG
117   FORMAT(' ANGLE DISCREPANCY FOR ANGLE # ',I3,' : ANGLE = ',
     1 F9.4,', TH0 = ',F9.4)
      GOTO 118
      END
