      SUBROUTINE LSREPOS_INIT(SHFTC,SHFTB,SHH) !(These arguements are
C a necessary evil to get around conflicts between EQUIVALENCE and COMMON 
C statements in LSINIT and LSTER subroutines,...sorry 'bout that.)
C
C *****************************************************************************
C Billy-bob's contribution to CRYM (6/94) with modifications (7/95). 
C ****************************** DESCRIPTION ********************************** 
C
C This routine allows for repositioning of non-refinable atoms between least 
C squares (and STR) cycles.  The program is broken into 3 parts: LSREPOS_INIT
C (the initialization routine), LSREPOS_REG (regular atom positioning routine),
C and LSREPOS_PR (print routine).  First time through LSQ or STR, the entry pt.
C is _INIT, from LSINIT.  All other entries are _REG from LSTER.  
C    LSREPOS_INIT: First reads end of original .LSQ input file (UNIT 1) looking
C for NType cards.  Then, finds point where new COORD & ISO cards can be 
C inserted in UNIT 4 (=scratch storage of most of LSQ/STR input).  Next, 
C deciphers NTyp cards (read above) defining atom repositioning.  Generates 
C new cards (if necessary) inserting them in UNIT 4 and atom list.  Prepares 
C orthonormal coord sys. and cross products (stolen from HPOS)
C    LSREPS_REG: (slightly modified version of HPOS) Calculates new position of
C each atom requested on NTyp cards
C    LSREPOS_PR: Writes to output the previous, new and shifts in coords and 
C iso B values of the atoms requested on Ntyp cards.
C
C ****************************** INPUT ****************************************
C
C    Input for this routine is based on the NTyp cards used in the HPOS (H atom
C reposition) routine. Thus, NTyp values which are allowed include 1 through 6,
C and correspond to a geometrical situation.  These cards are inserted between
C the END ATOMIC INFO and END LEAST SQUARES cards of the least squares input
C deck.  The only change in their format from HPOS is the factor in columns
C 64-73 which is multiplied by the B of the bound atom to generate the B value
C for the new repostioned atom.  So, the format for the NTYP card is almost
C identical to that of HPOS: (3X,I1,4A4,2F10.5,6X,3A4,1X,A3,1x,F10.6)
C    COORD and ISO cards may already exist in atom data deck, or they will be
C generated automatically by the NTyp card.  A constant ISO card may be 
C specified by setting the factor in columns 64-73 to zero (or leave blank),
C and inserting an ISO card into the input deck (or after the NTyp card). 
C NOTE: it is okay to have both, either or neither of the COORDS and ISO 
C present in input deck.  LSREPOS will generate these cards before 
C returning to LSINIT, THERE WILL BE NO COORD ISO card incompatibility.
C    The situation may arise when one wishes to refine coordinates, but leave
C the B value of the atom riding on that of another.  This corresponds to a new
C NTyp value of 0 (zero).  To use this option, the user MUST HAVE THE
C COORD CARD of the atom in the input deck (above atomic info card).
C The ISO card will be generated automatically by the B multilplier and there
C WILL BE NO incompatibility.
C
C *****************************************************************************
C
C (Note on terminology in comment cards:                   3
C "repositioned atom" refers to the atom H in               \
C the adjacent picture.  "bound atom" refers to              1 - H 
C atom 1; and obviously "non-bound atoms" refers            /
C to atoms 2 and 3.)                                       2
C
C *****************************************************************************
C
      DIMENSION AMult(300),ANREF(300),ANUM(300),AT(300,4),
     1 B(300),BAN(1800),BAT(300),Bfact(300),BVEC(1500),CARD(20),
     2 CAtom(300,3),CNREF(300),CNV(6),CELL(9),DH(300),xBAN(6),
     3 IPB(300),IPC(300),KA(300),KAIDEN(12),KF(300),KIND(300),
     4 KREF(300),LINE(20),MLST(2,300),NTyp(300),NT(300,4),oldB(300),
     5 oldC(300,3),POP(300),NBISO(300),SANIS(9,300),SHFTB(300),
     6 SHFTC(300),SHH(6),SIGMA(300),SISO(4,300),VH(300),WGT(6),
     7 X(300),XTEMP(2),Y(300),YTEMP(2),Z(300),ZTEMP(2),ndp(300)
C
C       CHARACTER*16 NFILE,NAMEFILE
C      BYTE IFLG,IFOP,IONCE,INSEC
         REAL*4 IAK(300)
      CHARACTER*4 NAC(11)
      COMMON/RP/AA,BB,CC,AB,AC,BC
      COMMON/REPOS/NA,KREF,B,KIND,BAN,IPC,IPB,POP,IAK,NNREFA,
     1 NNREFC,CNREF,ANREF,NISO,SISO,NANI,SANIS,PMUL,KAIDEN
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD,JPAGE,IT1,IT2,
     1       X,Y,Z,ANUM,BVEC,MLST,JSI
      COMMON /SAVE/ IUSA,NSV,P,IQ,CELL,SIGMA                                  11
      EQUIVALENCE (BVEC(1),KA(1)),(BVEC(301),BAT(1))
C
      DATA NAC/' X  ',' Y  ',' Z  ',' B  ','B11 ','B22 ',
     1 'B33 ','B12 ','B13 ','B23 ','SCF '/
      data ndp/300*0/
      DATA RAD/0.01745329/
C
      FirstTime=1.0    !indicates that this is the first time through REPOS 
C
C  **************************************************************************
C  This sections reads cards after END ATOMIC... skipping RECYCLE, PRINT and 
C  DO NOT cards,... looking for NType cards specifying atom repositioning.
C  If there are no NType cards then the subroutine is exited.  Otherwise the
C  card info stored in arrays for subsequent analysis.
      NAold=NA  !Previous number of atoms
      I=0       !Initially for counting reposition Ntyp cards
      iTotal=0  !For counting number of cards read
  100 READ(1,115,ERR=800)LINE   !Reading straight from .LSQ file
      iTotal=iTotal+1           !number of cards read
  115 FORMAT(20A4)
  116 IF(LINE(1) .EQ. IS2) GOTO 100      !RECYCLE
      IF(LINE(1) .EQ. IS3) GOTO 100      !PRINT
      IF(LINE(1) .EQ. IS4) GOTO 100      !DO NOT PRINT
      IF(LINE(1) .EQ. 'ISO ') GOTO 800   !ISO CARD OUT OF ORDER
      IF(LINE(1) .EQ. 'END ') GOTO 190   !END
      GOTO 110
C Some error messages leading to program crash:
  800 WRITE(3,805)
  805 FORMAT(1X,'ERROR READING NTYP REPOSITIONING CARDS FROM .LSQ FILE')
      GOTO 999
  810 WRITE(3,815)
  815 FORMAT(1X,'ERROR DECODING NTYP REPOSITIONING CARDS')
      GOTO 999
C End of error message section.
C Decoding valid input
  110 I=I+1
      Bfact(I)=0.0  !B value on ISO card following Ntyp card
      DECODE(80,120,LINE,ERR=810)NTyp(I),(AT(I,l),l=1,4),
     1       DH(I),VH(I),(CAtom(I,j),j=1,3),KF(I),AMult(I)
C [NTyp code #] [atom labels (AT) of atoms specifying geometry] [distance(DH)]
C [angle(VH)] [atom labels (CAtom) of repositioned atoms] 
C [their form factor(KF)]
C [multiplier for iso B value of atom AT(i,1)]
  120 FORMAT(3X,I1,4A4,2F10.5,6X,3A4,1X,A3,1x,F10.6)
      READ(1,115,ERR=800)LINE 
      iTotal=iTotal+1  !counts total number of cards read
      IF(LINE(1) .NE. 'ISO ') GOTO 116     ! Check for ISO card
      DECODE(80,124,LINE,ERR=810)Bfact(I)  ! B value on ISO card
  124 FORMAT(12X,F10.5)
      GOTO 100
  190 CONTINUE          !Finished decoding
      NNtyp=I           !Number of Ntyp input cards
      DO 200 J=1,iTotal
      BACKSPACE 1       !Backup to previous location in .LSQ input
  200 CONTINUE
      IF(NNtyp .EQ. 0) RETURN  !Return if no Ntyp cards in input,...
C
C  **************************************************************************
C  Reading unit 4 scratch which stores much of the .LSQ input.  Finding where
C  the repositioned atom COORD and ISO cards will be inserted (if necessary):
C  either at the end of a NO REFINEMENT (not save) section or in a newly 
C  created NO REFINEMENT section.  Also a scratch file is created to store 
C  scratch data from UNIT 4 while the new data is inserted (if necessary).
C
      OPEN(NAME='XRAYX:REPOS_SCRATCH.TXT',UNIT=47,FORM=
     1'FORMATTED',STATUS='SCRATCH')  ! Scratch status means deleted when closed
      REWIND 4  !Start at the beginning of file
      Lcount=0  !Index for lines read off of UNIT 4 scratch file
      NNoRef=0  !Counts number of NO REFINEMENT cards
   10 READ(4,115,ERR=998)LINE
      Lcount=Lcount+1  !Counting lines,...
      IF((LINE(1).EQ.'NO R'.or.LINE(1).EQ.'FULL'.or.LINE(1).EQ.'DIAG'
     1.or.LINE(1).EQ.'BLOC'.or.LINE(1).EQ.'FULL'.or.LINE(1).EQ.'END ')
     2.AND.NNoRef.GT.0) GOTO 13  !If reached end of a NO REF block
C
      IF(LINE(1).EQ.'NO R'.AND.LINE(5).EQ.'    ')NNoRef=NNoRef+1
      IF(LINE(1).NE.'END '.AND.(LINE(1).NE.'NO R'.OR.LINE(5).NE.
     1'SAVE'))GOTO 10   !If END or NO REF SAVE, then insert NO REF card below
      insert=1   ! Signals that we will have to insert a NO REF CARD
C
   13 WRITE(47,115)LINE  !Store end-of-block card on UNIT 47 scratch file
      NRlast=Lcount-1    !Position of last card before insertion
      IF(LINE(1) .EQ. 'END ')GOTO 17
   16 READ(4,115,ERR=998)LINE
      WRITE(47,115)LINE  !Store ensuing cards on UNIT 47 scratch file
      Lcount=Lcount+1  !Counting lines,...
      IF(LINE(1) .NE. 'END ')GOTO 16
   17 REWIND 47   !rewind so we can write it onto UNIT 4 later
      REWIND 4    !Having read all of scratch file, rewind, and
      DO 18 i=1,NRlast         !position at end of NO REF block.
   18 READ(4,115,ERR=998)LINE  !just a dummy read
      IF(insert.EQ.1) THEN   !Checks if we need to insert NO REF card
        WRITE(4,12)          !And now inserts NO REF card
   12   FORMAT('NO REFINEMENT                                        ')
      ENDIF
C
C  **************************************************************************
C  This section: check for COORD and ISO card existence; if necessary, append
C  these cards, update count, and store location.  Also, check for internal
C  consistencies.
C  For each repositioned atom label, searching atom list for existence already.
      DO 250 i=1,NNtyp
      IF(NTyp(i).LT.0 .OR. NTyp(i).GT.6) GOTO 813 ! Check Ntyp input
      IF(DH(i) .EQ. 0.0)DH(i)=0.95                ! Default bond distance
      IF(NTyp(i).EQ.2 .AND. VH(i).EQ.0.0)VH(i)=120.0  !Default angle
      IF(NTyp(i).GT.3 .AND. VH(i).EQ.0.0)VH(i)=(ACOS(-1./3.))/RAD !Default
      IF(KF(i) .EQ. '   ')KF(i)='HS  '   ! Default atom form factor
      IF(NTyp(i).GT.4 .AND. VH(i).GT.120.)GOTO 801  !Check angle & Ntyp
C ...Now looping through the (1,2, or 3) atoms to be repositioned
      DO 255 j=1,3
      IF(CAtom(i,j) .EQ. '    ') GOTO 251   ! Skip blank atom label entries 
      DO 256 l=1,12
  256 IF(KF(i) .EQ. KAIDEN(l)) GOTO 257 
      GOTO 821
  257 KINDTemp=l  !The value KIND (form factor) will have after 
C                 !atom is located.
C  ...checking for duplicate label input errors in reposition cards.
      DO 261 n=1,NNtyp
      DO 260 m=1,3
      IF(CAtom(i,j) .NE. CAtom(n,m)) GOTO 260
      IF(n .EQ. i .AND. m .EQ. j) GOTO 260
C ...some error messages leading to program crash:
      WRITE(3,807)CAtom(i,j)
  807 FORMAT(1X,'DUPLICATE ATOM LABEL ',A4,' ON NTYP CARD')
      GOTO 999
  801 WRITE(3,802)NTyp(i),VH(i)
  802 FORMAT(1X,'INCOMPATIBLE NTYP, ',I1,', AND ANGLE,',F10.5, 
     1' (DEGREES) IN REPOSITION CARDS')
      GOTO 999
  809 WRITE(3,812)CAtom(i,j)
  812 FORMAT(1X,'ERROR: REPOSITION OF ATOM ',A4,' DEFINED BY ITSELF')
      GOTO 999
  813 WRITE(3,814)NTyp(i)
  814 FORMAT(1X,'ILLEGAL NTYP INPUT ',I2)
      GOTO 999
  819 FORMAT(1X,'FOR Ntyp=0, COORD CARD FOR ATOM ',A4,
     1       ' MUST BE PRESENT IN ATOMIC INFORMATION')
  820 FORMAT(1X,'SECTION OF LEAST SQUARES INPUT DECK.')
  821 WRITE(3,822)KF(i)
  822 FORMAT(1X,'FORM FACTOR ',A4,' ON NTYP CARD NOT FOUND IN HKL')
      GOTO 999
C  End of error message section
  260 CONTINUE      
  261 CONTINUE      
      DO l=1,4  ! Checking that atom does not define its own position
      IF(CAtom(i,j) .EQ. AT(i,l)) GOTO 809
      ENDDO
  264 CONTINUE
  263 CONTINUE
C  ...finally searching current atom list for desired label
      DO 265 n=1,NA
  265 IF(CAtom(i,j) .EQ. ANUM(n)) GOTO 270  !found atom label COORD card
C Having NOT found atom in previous list, check that NTYP not zero.
      IF(NTYP(i) .EQ. 0) THEN     !For NTYP=0, must have both COORD card
          WRITE(3,819)CAtom(i,j)  !in input deck, so write out 
          WRITE(3,820)            !error messages.
          GOTO 999                !Program aborts with this error
      ENDIF
C Having NOT found atom in previous list, generate new COORD card
  269 NA=NA+1 !Increase total atom count by 1
      n=NA    !change index label name for convenience
      ANUM(n)=CAtom(i,j)  !Atom label
      KA(n)=KF(i)        !form factor
      KIND(n)=KINDTemp   !Position of form factor in KAIDEN
      IPC(n)=0       !Number of additional parameters?
      SHFTC(n)=0.0   !No refinement of coordinates
      POP(n)=PMUL    !Standard multiplicity for given space group
      IAK(n)=0.0     !???,but probably a good idea
      DO 268 ix=1,3      !If atom is not found set old coordinate values
  268 oldC(n,ix)=9999.0  !to 9999.0 as signal to not print old values
      WRITE(4,267)ANUM(n),KA(n)   !Write out new COORD card in scratch
  267 FORMAT('COORD ',A4,2X,A3,'                                 ')
      GOTO 271             
C Having FOUND atom, check agreement with existing atom and
  270 IF(KF(i) .NE. KA(n)) GOTO 803  !Form factors must agree
C repostion input:                !But if NTYP=0, then these other checks
      IF(NTYP(i).EQ.0) GOTO 271   !do not apply and are skipped
C ...other checks:
      IF(IPC(n) .NE. 0) GOTO 835   !Coords cannot be refined
      oldC(n,1)=X(n)      !Defining the old coordinate values as
      oldC(n,2)=Y(n)      !those found on the existing COORD card
      oldC(n,3)=Z(n)
C Having found (or defined) atom location in atom list, store location.
  271 CAtom(i,j)=n
C And now searching for the ISO card,...
      DO 272 ix=1,NISO   !There may be an ISO card already
  272 IF(ANUM(n) .EQ. SISO(1,ix)) GOTO 275  !Found ISO card
C Checking that NTYP is not zero
C 7/95 This is probably not necessary -Billy-bob
C     IF(NTYP(i) .EQ. 0) THEN     !For NTYP=0, must have both COORD and
C         WRITE(3,819)ANUM(n)     !ISO cards already in deck
C         WRITE(3,820)            !write out error messages
C         GOTO 999
C     ENDIF
C Billy-bob
      DO 273 ix=1,NANI   !Atom cannot have ANISO card; check for this
  273 IF(ANUM(n) .EQ. SANIS(1,ix)) GOTO 833
C Need to generate new ISO card:
      NISO=NISO+1            !counts no. of ISO cards
      SISO(1,NISO)=ANUM(n)   !Atom label
      IF(AMult(i).EQ.0.0.AND.Bfact(i).EQ.0.0) GOTO 843 !Undefined B
      IF(AMult(i).EQ.0.0) THEN
         AMult(i)=-1.0          !Signals constant B
         SISO(2,NISO)=Bfact(i)  !For input constant B value
         B(n)=Bfact(i)          !Stores constant B value
      ELSE IF(Bfact(i).EQ.0.0) THEN
              B(n)=9999.0  !Signal not to print old values
           ELSE
              B(n)=Bfact(i)     !Stores ISO card value which followed Ntyp card
              SISO(2,NISO)=Bfact(i)
      ENDIF
      SISO(3,NISO)=0.0     !ISO partial shift is zero; no refinement
      SISO(4,NISO)=0       !No special symmetry constraints
      NBISO(i)=NISO        !Store the position of B value in SISO array
      WRITE(4,274)SISO(1,NISO),SISO(2,NISO)      !Write new ISO card to
  274 FORMAT('ISO   ',A4,2X,F12.8,47X,'          ') !scratch file
      GOTO 280
C An ISO card already exists, ensure no change in NPAR, shift is zero
  275 IF(SISO(3,ix).NE.0 .OR. SISO(4,ix).NE.0.0) GOTO 837
      IF(Bfact(i).NE. 0.0) GOTO 839 !Error for duplicate ISO card
      IF(AMult(i).EQ.0.0.AND.SISO(2,ix).EQ.0.0) GOTO 843 !Undefined B
      IF(AMult(i).EQ.0.0) AMult(i)=-1.0 !Signals constant B given on ISO
      B(n)=SISO(2,ix)      !Stores B value
      NBISO(i)=ix          !Store the position of B value in SISO array
C Check that atom label is NOT in NO REFINEMENT SAVE section
  280 DO 281 ix=1,NNREFC
  281 IF(CNREF(ix) .EQ. ANUM(n)) GOTO 831
      DO 283 ix=1,NNREFA
  283 IF(ANREF(ix) .EQ. ANUM(n)) GOTO 831
  255 CONTINUE  !End of loop (j=1-3) through repos atoms on a Ntyp card
C 
  251 GO TO (284,252,253,252,253,254,254),NTyp(i)+1 !Checking 
  252 IF(j.NE.2) GOTO 824                     !agreement of Ntyp 
      GOTO 284                                !and number of 
  253 IF(j.NE.3) GOTO 824                     !atoms(j-1) to be
      GOTO 284                                !generated.
  254 IF(j.NE.4) GOTO 824
  284 CONTINUE  ! Dummy line
C Checking that atoms defining reposition geometry are on atom list
      DO 290 j=1,4   !Going for atom i.d.'s (AT) for repositioning atoms 
      IF(NTYP(i).EQ.0 .AND. j.GE.2) GOTO 290
      IF(AT(i,j).EQ.'    ' .AND. j .LT. 4) GOTO 841
      IF(AT(i,j).EQ.'    ' .AND. j.EQ.4 .AND. NTyp(i).EQ.3) GOTO 841
      IF(AT(i,j).EQ.'    ') GOTO 290  !If blank, then go to next AT value
      DO 285 nn=1,NA
      IF(AT(i,j) .EQ. ANUM(nn)) GOTO 289
  285 CONTINUE
C  ...some more error cards leading to crashes:
      WRITE(3,808)AT(i,j)
  808 FORMAT(1X,'CANNOT FIND ATOM ',A4,' GIVEN ON NTYP CARD')
      GOTO 999
  803 WRITE(3,806)CAtom(i,j) !At this point, CAtom still has atom label
  806 FORMAT(1X,'ERROR: DISAGREEMENT IN FORM FACTORS OF REPOSITIONED
     1 ATOM ',A4,' AND ATOM IN INPUT DECK.')
      GOTO 999
  824 WRITE(3,826)NTyp(i)
  826 FORMAT(1X,'INVALID NYP CARD - INVALID NUMBER OF OUTPUT ATOM 
     1LABELS FOR NTYP',I2)
      GOTO 999
  831 WRITE(3,832)ANUM(n)
  832 FORMAT(1X,'ATOM ',A4,' FOR REPOSITIONING CANNOT BE NO 
     1REFINEMENT SAVE')
      GOTO 999
  833 WRITE(3,834)ANUM(n)
  834 FORMAT(1X,'ERROR: ATOM ',A4,' FOR REPOSITIONING CANNOT HAVE 
     1AN ANISO OR ISO-AN CARD')
      GOTO 999
  835 WRITE(3,836)CAtom(i,j)
  836 FORMAT(1X,'ERROR: COORDINATES OF ATOM ',A4,' CANNOT BE REFINED 
     1AND REPOSITIONED')
      GOTO 999
  837 WRITE(3,838)ANUM(n)
  838 FORMAT(1X,'ERROR: ISOTROPIC B VALUES OF ATOM ',A4,' CANNOT 
     1BE REFINED AND REPOSITIONED')
      GOTO 999
  839 WRITE(3,840)ANUM(n)
  840 FORMAT(1X,'DUPLICATE ISO CARDS IN ATOMIC INFORMATION AND 
     1NTYP INPUT FOR ATOM ',A4)
      GOTO 999
  841 WRITE(3,842)NTyp(i)
  842 FORMAT(1X,'INSUFFICIENT NUMBER OF INPUT ATOMS FOR NTYP',I2)
      GOTO 999
  843 WRITE(3,844)ANUM(n)
  844 FORMAT(1X,'CANNOT FIND ISO B VALUE OR B MULTIPLIER FOR ATOM ',A4)
      GOTO 999
C  End of error card section
C  Record number position of atom in data arrays
  289 NT(i,j)=nn
  290 CONTINUE
C Find the position in iso/aniso decks of the bound atom and record
C (NOTE: if not changing B of repos atom (AMULT=-1.0) then skip. Necessary
      IF(AMULT(i).EQ.-1.0) GOTO 250 !cuz KIND sign switch can screw things up!)
      DO 295 iy=1,NISO  !Searching iso cards
      IF(SISO(1,iy).NE.AT(i,1)) GOTO 295
         B(NT(i,1))=SISO(2,iy)  !Store SISO B value
         GOTO 250
  295 CONTINUE
C
      DO 296 iy=1,NANI  !Searching aniso cards
  296 IF(SANIS(1,iy).EQ.AT(i,1))GOTO 297
      GOTO 250
C ...first AT atom has iso temp factors; record these (based on LSINIT)
  297 DO 298 iz=1,6    !data stored in BAN in clumps of six
      JIS=6*(iy-1)+iz  !index for BAN as used in other subroutines
  298 BAN(JIS)=SANIS(iz+1,iy)  !Stores aniso values
      nnn=NT(i,1) !Remember NT stores AT atom index for data arrays (X,Y,...)
      B(nnn)=6*(iy-1)+1    !Stores index for array BAN containing aniso data
c      KIND(nnn)=-KIND(nnn) !KIND(nn)>0 is ISO; KIND(nn)<0 is ANISO atom
c      replace this with ndp type
      ndp(nnn)=1
  250 CONTINUE  !End of big loop through all Ntyp cards
C  Now append bottom part of old UNIT 4 scratch file completing the
      DO 300 i=1,Lcount-NRlast        ! insertion procedure (if in fact
      READ(47,115)LINE                ! any new ISO and COORD cards had
  300 WRITE(4,115)LINE                ! to be inserted)
      REWIND 4
      CLOSE (47) ! Note 47 is automatically deleted cuz it's scratch file
C
C Get unit cell information
      Ax=CELL(1)
      Bx=CELL(2)
      Cx=CELL(3)
      ALFA=CELL(4)
      BETA=CELL(5)
      GAMMA=CELL(6)
C STOLEN FROM HPOS.FOR
C     CREATING ORTHONORMAL COORDINATE SYSTEM
      AA=Ax*Ax
      BB=Bx*Bx
      CC=Cx*Cx
      AB=Ax*Bx*COS(RAD*GAMMA)
      AC=Ax*Cx*COS(RAD*BETA)
      BC=Bx*Cx*COS(RAD*ALFA)
      ABSIN=Ax*Bx*SIN(RAD*GAMMA)
      ACSIN=Ax*Cx*SIN(RAD*BETA)
      BCSIN=Bx*Cx*SIN(RAD*ALFA)
C    CALCULATING CROSS PRODUCTS
      DET=AA*BB-AB*AB
      AXB1=(AB*BC-BB*AC)/DET
      AXB2=(AB*AC-AA*BC)/DET
      AXB3=ABSIN/DISTR(AXB1,AXB2,1.0)
      AXB1=AXB1*AXB3
      AXB2=AXB2*AXB3
      DET=AC*AC-AA*CC
      AXC1=(AC*BC-AB*CC)/DET
      AXC3=(AB*AC-AA*BC)/DET
      AXC2=ACSIN/DISTR(AXC1,-1.,AXC3)
      AXC1=AXC1*AXC2
      AXC3=AXC3*AXC2
      AXC2=-AXC2
      DET=BB*CC-BC*BC
      BXC2=(AC*BC-AB*CC)/DET
      BXC3=(AB*BC-AC*BB)/DET
      BXC1=BCSIN/DISTR(1.0,BXC2,BXC3)
      BXC2=BXC2*BXC1
      BXC3=BXC3*BXC1
      XTEMP(2)=0.0
      YTEMP(2)=0.0
      ZTEMP(2)=0.0
C Conversion factors for B values and Ueq values; Stolen from LSTER
      DO 27 I=1,3
   27 CNV(I)=1.0/(78.95683522*SHH(I))
      CNV(4)=1.0/(2*78.95683522*SQRT(SHH(1)*SHH(2)))
      CNV(5)=1.0/(2*78.95683522*SQRT(SHH(1)*SHH(3)))
      CNV(6)=1.0/(2*78.95683522*SQRT(SHH(2)*SHH(3)))
C More conversion parameters for Ueqs
      CASQ=CELL(7)*CELL(7)          ! CALCULATIONS FOR U EQUIV
      CBSQ=CELL(8)*CELL(8)
      CGSQ=CELL(9)*CELL(9)
      SNASQ=1-CASQ
      SNBSQ=1-CBSQ
      SNGSQ=1-CGSQ
      SNA=SQRT(SNASQ)
      SNB=SQRT(SNBSQ)
      SNG=SQRT(SNGSQ)
      CEQ=1-CASQ-CBSQ-CGSQ+(2*CELL(7)*CELL(8)*CELL(9))
      GOTO 28
C
      ENTRY LSREPOS_REG   !Mostly stolen from HPOS subroutine
      FirstTime=0.0  !No longer the first time through.
C
C  Begin calculations to be done after each RECYCLE
   28 IF(NNTyp .EQ. 0) RETURN  ! If no reposition cards, return
C
      DO 550 i=1,NNTyp
      NCK=1  ! Index for AT array of reposition specifying atoms
C  (note: if NTYP=0, we skip all of this coordinate calculation)
      GO TO (500,30,31,30,31,31,31), NTYP(i)+1
   30 DH1=DH(i)
      DH2=0.0
   31 k=NT(i,2)
      l=NT(i,1)
      CALL NORMR(S1,S2,S3,X(k),X(l),Y(k),Y(l),Z(k),Z(l))
      k=NT(i,3)
      l=NT(i,1)
      CALL NORMR(T1,T2,T3,X(k),X(l),Y(k),Y(l),Z(k),Z(l))
      GO TO (36,33,32,33,33,33),NTyp(i)
   32 k=NT(i,4)
      l=NT(i,1)
      CALL NORMR(V1,V2,V3,X(k),X(l),Y(k),Y(l),Z(k),Z(l))
      T1=T1+V1
      T2=T2+V2
      T3=T3+V3
      GO TO 36
33    IF(NTYP(I).GT.4)THEN
      VHtemp=ACOS(SQRT(ABS(2./3.*(.5+COS(VH(i)*RAD)))))
C   CALUCULATING "HALF" ANGLE
      ELSE
      VHtemp=VH(i)*RAD/2.0
      ENDIF
      DH1=DH(i)*COS(VHtemp)
      DH2=DH(i)*SIN(VHtemp)
C   FOR NTYPS 5 AND 6 -    X                Y                Z
C       ATOM 1          COS(VH)          SIN(VH)             0
C       ATOM 2          COS(VH)      -1/2*SIN(VH)    SQRT(3)/2*SIN(VH)
C       ATOM 3          COS(VH)      -1/2*SIN(VH)   -SQRT(3)/2*SIN(VH)
C   FOR NTYP 6, Y DIRECTION IS REVERSED
      GO TO (999,39,999,34,34,34),NTyp(i)  !Shouldn't reach here if 1,3
   34 COF1=S1*T2-S2*T1
C   CALCULATING PLANE NORMAL  ("Z" DIRECTION FOR NTYPS 5 AND 6)
      COF2=S1*T3-S3*T1
      COF3=S2*T3-S3*T2
      XTEMP(1)=COF1*AXB1+COF2*AXC1+COF3*BXC1
      YTEMP(1)=COF1*AXB2+COF2*AXC2+COF3*BXC2
      ZTEMP(1)=COF1*AXB3+COF2*AXC3+COF3*BXC3
   35 CALL NORMR(SXT1,SXT2,SXT3,XTEMP(1),XTEMP(2),YTEMP(1),YTEMP(2),
     1           ZTEMP(1),ZTEMP(2))
      GO TO (999,37,999,36,41,41), NTyp(i)
41    COF11=S1*SXT2-S2*SXT1
C   NTYPS 5 AND 6 - CALCULATING "Y" PLANE BY CROSSING PLANE NORMAL
C   WITH NORM OF N1 AND N2
      COF22=S1*SXT3-S3*SXT1
      COF33=S2*SXT3-S3*SXT2
      XTEMP(1)=COF11*AXB1+COF22*AXC1+COF33*BXC1
      YTEMP(1)=COF11*AXB2+COF22*AXC2+COF33*BXC2
      ZTEMP(1)=COF11*AXB3+COF22*AXC3+COF33*BXC3
      CALL NORMR(SYT1,SYT2,SYT3,XTEMP(1),XTEMP(2),YTEMP(1),YTEMP(2),
     1           ZTEMP(1),ZTEMP(2))
C   FOR NTYPS 5 AND 6 "X" PLANE IS NORM OF N1 AND N2
      SPT1=S1
      SPT2=S2
      SPT3=S3
      GOTO 37
   36 XTEMP(1)=S1+T1
      YTEMP(1)=S2+T2
      ZTEMP(1)=S3+T3
      CALL NORMR(SPT1,SPT2,SPT3,XTEMP(1),XTEMP(2),YTEMP(1),YTEMP(2),
     1           ZTEMP(1),ZTEMP(2))
37    IF(NTYP(i).GT.4)THEN
      ICK=1
      IF(NTYP(i).EQ.6)ICK=-1
C   "Y" DIRECTION IS REVERSED FOR STAGGERED AND ECLIPSED
      XH=X(NT(i,1))-SPT1*DH1+ICK*(SYT1*DH2)
C   FIRST ATOM FOR NTYPS 5 AND 6 IS IN PLANE - NO "Z" DIRECTION
      YH=Y(NT(i,1))-SPT2*DH1+ICK*(SYT2*DH2)
      ZH=Z(NT(i,1))-SPT3*DH1+ICK*(SYT3*DH2)
      ELSE
      XH=X(NT(i,1))-SPT1*DH1+SXT1*DH2
      YH=Y(NT(i,1))-SPT2*DH1+SXT2*DH2
      ZH=Z(NT(i,1))-SPT3*DH1+SXT3*DH2
      ENDIF
C      NH = NH + 1
C     
      IF(CATOM(I,1).EQ.BLANK)GO TO 901
      j=CATOM(i,1)
      X(j)=XH
      Y(j)=YH
      Z(j)=ZH
      NTY=NTyp(i)
901   NCK=NCK+1
      IF(NCK .GT. 3) GOTO 500
      j=CATOM(I,NCK)
      GO TO (500,38,500,38,42,42),NTY
  38  XH=XH-2.0*SXT1*DH2
      YH=YH-2.0*SXT2*DH2
      ZH=ZH-2.0*SXT3*DH2
C     NH = NH + 1
   43 IF(CATOM(I,NCK).EQ.BLANK)GO TO 901
      j=CATOM(I,NCK)
      X(j)=XH
      Y(j)=YH
      Z(j)=ZH
      IF(NCK.EQ.2)NCK=3
      IF(NTY.GT.4)GOTO 45
      GO TO 500
   39 SS=1.0/(S1*T1*AA+S2*T2*BB+S3*T3*CC+(S1*T2+S2*T1)*AB+(S1*T3+S3*T1)*
     1AC+(S2*T3+S3*T2)*BC)
      SPT1= S1
      SPT2= S2
      SPT3= S3
      XTEMP(1)=S1-SS*T1
      YTEMP(1)=S2-SS*T2
      ZTEMP(1)=S3-SS*T3
      GO TO 35
42    DH2=-.5*DH(i)*SIN(VHtemp)
      DH3=SQRT(3.)/2.*DH(i)*SIN(VHtemp)
44    XH=X(NT(i,1))-SPT1*DH1+ICK*(SYT1*DH2)+SXT1*DH3
      YH=Y(NT(i,1))-SPT2*DH1+ICK*(SYT2*DH2)+SXT2*DH3
      ZH=Z(NT(i,1))-SPT3*DH1+ICK*(SYT3*DH2)+SXT3*DH3
      GOTO 43
45    DH3=-SQRT(3.)/2.*DH(i)*SIN(VHtemp)
      NTY=1
      GOTO 44
C
C Calculating B values -- based on LSTER
  500 CONTINUE  !Dummy line
      IF(AMult(i).EQ.-1.0)GOTO 550  !Go to next atom if B is constant
C      m=BISO(i,4)  !index for iso/aniso data for bound atom
      nn=NT(i,1)    !Index for data on bound atom
c      IF(KIND(nn) .LT. 0) GOTO 520  !m<0 signals aniso data for bound atom
      IF(ndp(nn) .eq. 1) GOTO 520  !ndp=1 signals aniso data for bound atom
      Bconv=B(nn)  !B value of bound atom
      GOTO 545
C Calculating B values from aniso temperature factors
  520 DO 530 n=1,6        !To figure out next line, see DO loop 297
      iy=B(nn)    !position of aniso data in BAN
      nm=iy+n-1   !index for BAN
  530 xBAN(n)=BAN(nm)*CNV(n)
      AEQ=xBAN(1)*SNASQ+xBAN(2)*SNBSQ+xBAN(3)*SNGSQ
      AEQ=AEQ/(3.*CEQ)
      BEQ=xBAN(4)*SNA*SNB*CELL(9)
     +   +xBAN(5)*SNA*SNG*CELL(8)
     +   +xBAN(6)*SNB*SNG*CELL(7)      !CELL(7)=COS ALPHA
      BEQ=2.*BEQ/(3.*ceq)   !CELL(8)=COS BETA CELL(9)=COS GAMMA
      UEQ=AEQ+BEQ                   !UEQ is calculated as UEQ*(10**4)
      Bconv=UEQ * 78.95683522 !B value for bound atom
c      IF(FirstTime.EQ.1.0) KIND(nn)=-1*KIND(nn)!restore value for lsinit
C Now calculating new B value for repositioned atom:
  545 DO 546 j=1,3
      iz=CAtom(i,j)         !Index for repositioned atom data
      IF(iz.EQ.0) GOTO 546  !If no reposition atom, go to next
      oldB(iz)=B(iz)    !Stores old value of iso B 
      B(iz)=Bconv*AMult(i)  !Calculating B iso value
      imp=NBISO(i)  !Index giving position of B value of reposition atom
      IF(FirstTime.EQ.1.0)SISO(2,imp)=B(iz)  !in the array SISO
  546 CONTINUE
C
  550 CONTINUE
C
C Let's Print! (The third and final section of this program)
      WRITE(3,905)
  905 FORMAT(/,1X,'REPOSITIONED ATOMS:')
      DO 950 i=1,NNTyp
      DO 945 k=1,3
      IF(CAtom(i,k).EQ.'    ') GOTO 945  !No atom label, no print
      j=CAtom(i,k)  !Index for data stored in arrays
C Now check NTYP=0 (i.e. coordinates to be refined)
      IF(NTYP(i) .EQ. 0) GOTO 934  !For NTYP=0, don't print coordinates
C
      WRITE(3,920)ANUM(j)  !prints out headings (Atom,old,shift,new)
  920 FORMAT(/,'0ATOM ',A4,'    OLD      SHIFT      NEW     ')
      IF(oldC(j,1).EQ. 9999.0) GOTO 930  !Different format for no old coord
      WRITE(3,922)NAC(1),oldC(j,1),X(j)-oldC(j,1),X(j)
      WRITE(3,922)NAC(2),oldC(j,2),Y(j)-oldC(j,2),Y(j)
      WRITE(3,922)NAC(3),oldC(j,3),Z(j)-oldC(j,3),Z(j)
  922 FORMAT(' ',4X,A4,3F10.6)  !format for different old coordinates
  929 GOTO 933
  930 WRITE(3,932)NAC(1),X(j)  !NAC stores print data: ' X  ',' Y  ',...etc.
      WRITE(3,932)NAC(2),Y(j)
      WRITE(3,932)NAC(3),Z(j)
  932 FORMAT(' ',4X,A4,20X,F10.6)
  933 oldC(j,1)=X(j)
      oldC(j,2)=Y(j)
      oldC(j,3)=Z(j)
      IF(AMult(i).EQ.-1.0)THEN
         GOTO 945  !If B value is not recaculated skip printing of B
        ELSE
         WRITE(3,971)     ! blank line; for cosmetic reasons
         GOTO 939  !Print B value (for case of NTyp .NE. 0)
      ENDIF
C
C We end up here if Ntyp=0.  First check for fixed B value:
  934 IF(AMult(i) .EQ. -1.0) THEN  !For constant B, do not need NTYP card
           WRITE(3,935)ANUM(j)
  935      FORMAT(/,'0ATOM ',A4,' WARNING: B IS FIXED, SO THERE IS',
     1     ' NO NEED FOR NTYP=0 CARD')
           GOTO 945  !Nothing to print in this case.
        END IF                            !or else goto 937 if coords 
        IF(KREF(j) .NE. 0) GOTO 938 !refine coords (ie. normal situation).
C
C if we reach this section, no ref coords & ride B, unusual case:
        WRITE(3,920)ANUM(j)  !Write out headings (Atom,old,shift,new)
        IF(oldB(j).NE.9999.0) THEN       !9999.0 signals not to print old B
          WRITE(3,941)NAC(4),oldB(j),B(j)-oldB(j),B(j),AMult(i),AT(i,1)
         ELSE
          WRITE(3,942)NAC(4),B(j),AMult(i),AT(i,1) !formatted not to print old B
        ENDIF
        WRITE(3,937)ANUM(j)                !if no ref coords.&ride B, unusual
  937   FORMAT(6X,'WARNING: COORDINATES OF ATOM ',A4,     !case and a warning
     1  'ARE FIXED')                                      !is printed.
        GOTO 945 !Having printed out B shift & warning, go on to next atom. 
C
C for NTyp=0 and ref coords&ride B, need to print headings:
  938      WRITE(3,920)ANUM(j)  !Write out headings (Atom,old,shift,new)
C Now printing B values,... (Note: we get here (#939) from GOTO 939 
C resluting from NTyp=1-6 cards, or from line above resulting from NTyp=0)
  939  IF(oldB(j).NE.9999.0) THEN       !9999.0 signals not to print old B
        WRITE(3,941)NAC(4),oldB(j),B(j)-oldB(j),B(j),AMult(i),AT(i,1)
  941   FORMAT(' ',4X,A4,3F10.6,10X,'(',F6.3,' TIMES B OF ATOM ',A4,
     1  ')')
      ELSE
        WRITE(3,942)NAC(4),B(j),AMult(i),AT(i,1)
  942   FORMAT(' ',4X,A4,20X,F10.6,10X,'(',F6.3,' TIMES B OF ATOM ',
     1  A4,')')  
      ENDIF
  945 CONTINUE
  950 CONTINUE
      WRITE(3,970)
  970 FORMAT(/)
  971 FORMAT('  ')
      RETURN
C Unit=4 scratch file is where a copy of the least squares input is stored
  998 WRITE(3,997)
  997 FORMAT(1X,'ERROR READING SCRATCH FILE UNIT=4 IN LSREPOS 
     1SUBROUTINE.')
C Exiting program with fatal error
  999 WRITE(3,1005)
 1005 FORMAT(1X,'(FATAL ERROR IN SUBROUTINE LSREPOS)')
      STOP 90
      END
      FUNCTION DISTR(P,Q,R)  !Stolen from HPOS's DIST
      COMMON/RP/AA,BB,CC,AB,AC,BC
      DISTR=SQRT(P*P*AA+Q*Q*BB+R*R*CC+2.0*(P*Q*AB+P*R*AC+Q*R*BC))
      RETURN
      END
C Stolen from HPOS's NORM subroutine
      SUBROUTINE NORMR(P,Q,R,XI,XJ,YI,YJ,ZI,ZJ)
      COMMON/RP/AA,BB,CC,AB,AC,BC
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD,JPAGE,IT1,IT2,
     1       X,Y,Z,ANUM,BVEC,MLST,JSI
      P=XI-XJ
      Q=YI-YJ
      R=ZI-ZJ
      ADST=DISTR(P,Q,R)
      P=P/ADST
      Q=Q/ADST
      R=R/ADST
      RETURN
      END
