	SUBROUTINE PAPER (WIDTH,ASPECT)
C-----------------------------------------------------------------------
C PGPLOT: Specify the size and aspect ratio (height/width) of the view
C surface.  If this routine is used, it must be called immediately
C after PGBEGIN.
C
C Arguments:
C
C WIDTH (input, real) : the requested width of the view surface in
C	inches; if WIDTH=0.0, or if the device is an interactive
C	device, PGPAPER will obtain the largest view surface
C	available consistent with argument ASPECT.
C ASPECT (input, real) : the aspect ratio (height/width) of the view
C	surface; e.g., ASPECT=1.0 gives a square view surface,
C	ASPECT=0.618 gives a horiontal rectangle, ASPECT=1.618 gives
C	a vertical rectangle.
C
C (22-Apr-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	CHARACTER*4 JUNK
       COMMON/SIZE/IDENT,NX,NY,NXC,NYC,XPERIN,YPERIN,XSP,YSP,XLEN,
     +YLEN,XORG,YORG,XSCALE,YSCALE
      INTEGER IDENT,NX,NY,NXC,NYC
      REAL XPERIN,YPERIN,XSP,YSP,XLEN,YLEN,XORG,YORG,XSCALE,YSCALE
	LOGICAL  INTER
      REAL XC,YC,XS,YS,XCNEW,XSZ,YSZ
	REAL     ASPECT, HDEF, HMAX, HREQ, WDEF, WMAX, WREQ, WIDTH
	REAL     XSMAX, YSMAX
C
	IF (WIDTH.LT.0.0 .OR. ASPECT.LE.0.0) CALL 
     1		GRQUIT('PAPER: invalid parameter')
C
	CALL GRINQTYP(JUNK,INTER)
	CALL GRSIZE(IDENT,XSZ,YSZ,XSMAX,YSMAX,XPERIN,YPERIN)
C	type *,'PGPAPER',XSZ,YSZ,XSMAX,YSMAX,XPERIN,YPERIN
	WDEF = XSZ/XPERIN
	HDEF = YSZ/YPERIN
	WMAX = XSMAX/XPERIN
	HMAX = YSMAX/YPERIN
C	TYPE *,'PGPAPER',WDEF,HDEF, WMAX,HMAX
	IF (WIDTH.NE.0.0 .AND. .NOT.INTER) THEN
	    WREQ = WIDTH
	    HREQ = WIDTH*ASPECT
	ELSE
	    WREQ = WDEF
	    HREQ = WDEF*ASPECT
	    IF (HREQ.GT.HDEF) THEN
		WREQ = HDEF/ASPECT
		HREQ = HDEF
	    END IF
	END IF
	IF (WMAX.GT.0.0 .AND. WREQ.GT.WMAX) THEN
	    WREQ = WMAX
	    HREQ = WMAX*ASPECT
	END IF
	IF (HMAX.GT.0.0 .AND. HREQ.GT.HMAX) THEN
	    WREQ = HMAX/ASPECT
	    HREQ = HMAX
	END IF
	XSZ = WREQ*XPERIN
	YSZ = HREQ*YPERIN
C	TYPE *,'PGPAPER',WREQ,HREQ,XSZ,YSZ
	CALL GRSETS(IDENT,XSZ,YSZ)
	XSZ = XSZ/NX
	YSZ = YSZ/NX
	NXC = NX
	NYC = NY
      CALL GRCHSZ(IDENT,XC,YC,XS,YS)
      XCNEW=XC*YSZ/YS/40
      XSP=XS*XCNEW/XC
      YSP=YS*XCNEW/XC
CCALL PGVSTAND
	RETURN
	END
