C        SUBROUTINE TO FIND PEAK MAX FROM 19 POINTS
      SUBROUTINE SOLVN(R,IERR)
      DIMENSION R(19)
      REAL*8 S(19),P,A,B,C,U,V,W,H,K,L,D,MH,CA,CB,PPP,APP,BPP,CPP
      REAL*8 SA,SB,AC,SU,SV,SW,SH,SK,SL,AP,BP,CP,TP,SP
      REAL*8 T(4,3)
      COMMON/SOLV/X,Y,Z,RH
      CA=.01378446
      CB=.00501253
      IERR=0               ! INITIALIZE
      P=0.0
      A=0.0
      B=0.0
      C=0.0
      U=0.0
      V=0.0
      W=0.0
      H=0.0
      K=0.0
      L=0.0
      D=0.0
      MH=0.0
      X=0.0
      Y=0.0
      Z=0.0
C     WRITE(36,15)R
15    FORMAT('   IN SOLVN R=',10F11.2,/,15X,9F11.2)
      DO I=1,19
      S(I)=R(I)
      P=P+S(I)
      ENDDO
      A=S(2)+S(3)           ! X**2
      DO I=8,15
      A=A+S(I)
      ENDDO
      B=S(4)+S(5)            ! Y**2             
      DO I=8,11
      B=B+S(I)
      ENDDO
      DO I=16,19
      B=B+S(I)
      ENDDO
      C=S(6)+S(7)
      DO I=12,19
      C=C+S(I)
      ENDDO
      U=S(2)-S(3)+S(8)+S(9)-S(10)-S(11)+S(12)+S(13)-S(14)-S(15)
      V=S(4)-S(5)+S(8)-S(9)+S(10)-S(11)+S(16)+S(17)-S(18)-S(19)
      W=S(6)-S(7)+S(12)-S(13)+S(14)-S(15)+S(16)-S(17)+S(18)-S(19)
      L=S(8)-S(9)-S(10)+S(11)                 ! SUM OVER XY
      K=S(12)-S(13)-S(14)+S(15)               !          XZ
      H=S(16)-S(17)-S(18)+S(19)                !       YZ
C     WRITE(36,12)P,A,B,C,U,V,W,H,K,L
12    FORMAT('  P=',F16.2,' A=',F16.2,' B=',F16.2,' C=',F16.2,/,
     +'   U=',F16.2,' V=',F16.2,' W=',F16.2,/,
     +'   H=',F16.2,' K=',F16.2,' L=',F16.2)
      SU=U/10.0
      SV=V/10.0
      SW=W/10.0
      SH=H/4.0
      SK=K/4.0
      SL=L/4.0
      TP=10.0*P
      AP=(19.0*A)-TP
      BP=(19.0*B)-TP
      CP=(19.0*C)-TP
C     WRITE(36,20)TP,AP,BP,CP
20    FORMAT('  TP=',F15.2,'  AP=',F15.3,'  BP=',F15.3,'  CP=',F15.3)
      SA=CA*AP+CB*BP+CB*CP     ! CA,CB FROM MATRIX , SEE PARAMATERS
      SB=CB*AP+CA*BP+CB*CP
      SC=CB*AP+CB*BP+CA*CP
      SP=S(1)                   ! PEAK AT 0,0,0
C     WRITE(36,22)SA,SB,SC
22     FORMAT('  SA=',F12.4,'  SB=',F12.4,'  SC=',F12.4)
      T(1,1)=2.0*SA
      T(2,1)=SL
      T(3,1)=SK
      T(4,1)=-SU
      T(1,2)=SL
      T(2,2)=2.0*SB
      T(3,2)=SH
      T(4,2)=-SV
      T(1,3)=SK
      T(2,3)=SH
      T(3,3)=2.0*SC
      T(4,3)=-SW
      D=T(1,1)*T(2,2)*T(3,3)+T(2,1)*T(3,2)*T(1,3)
      D=D-T(3,1)*T(2,2)*T(1,3)-T(1,1)*T(3,2)*T(2,3)
      D=D+T(3,1)*T(1,2)*T(2,3)-T(2,1)*T(1,2)*T(3,3)
C     WRITE(36,10)D
10    FORMAT('   D=',F28.6)
       IF(D.EQ.0.0)THEN      
       IERR=1
      GO TO 900
      ENDIF
      X=T(4,1)*T(2,2)*T(3,3)+T(2,1)*T(3,2)*T(4,3)+T(3,1)*T(4,2)*T(2,3)
      X=X-T(3,1)*T(2,2)*T(4,3)-T(4,1)*T(3,2)*T(2,3)-T(2,1)*T(4,2)*T(3,3)
      X=X/D
      Y=T(1,1)*T(4,2)*T(3,3)+T(4,1)*T(3,2)*T(1,3)+T(3,1)*T(1,2)*T(4,3)
      Y=Y-T(3,1)*T(4,2)*T(1,3)-T(1,1)*T(3,2)*T(4,3)-T(4,1)*T(1,2)*T(3,3)
      Y=Y/D
      Z=T(1,1)*T(2,2)*T(4,3)+T(2,1)*T(4,2)*T(1,3)+T(4,1)*T(1,2)*T(2,3)
      Z=Z-T(4,1)*T(2,2)*T(1,3)-T(1,1)*T(4,2)*T(2,3)-T(2,1)*T(1,2)*T(4,3)
      Z=Z/D
      MH=SP+SA*X*X+SB*Y*Y+SC*Z*Z+SU*X+SV*Y+SW*Z
      MH=MH+SH*Y*Z+SK*X*Z+SL*Y*X
C     WRITE(36,100)MH,X,Y,Z
      IF(ABS(X).GT..8)IERR=1
      IF(ABS(Y).GT..8)IERR=1
      IF(ABS(Z).GT..8)IERR=1
C           X IS ROWS  Y IS COLS   Z IS SECTION
100   format('   HEIGHT=',F12.6,'  X=',F12.6,'  Y=',F12.6,'  Z=',F12.6)
      RH=MH
900   RETURN
      END
