      SUBROUTINE TAPEREAD
C   THIS ROUTINE READS A MAGNETIC TAPE AND CREATES A MAG FILE OF ITS
C   CONTENTS.  MAG FILE CONTAINS ID,H,K,L,TTH,PHI,CHI,RANGE,SPEED,
C   B1,SCAN,B2,EXPTM,TBTS AND THREE BLANK FIELDS WHICH WILL BE FILLED
C   BY LATER PROGRAMS.  (BLANK FIELDS INCLUDED SO THAT MAG FILE WILL
C   ALWAYS BE THE SAME LENGTH AND NOT INCREASE IN SIZE, WITH THE DANGER
C   OF OVERFLOWING DISK SPACE, WHEN THE LATER PROGRAMS ARE RUN.)
      INTEGER*2 IDHKL(4),ISTEP(96),ID,H,K,L,IH(10),IK(10),IL(10),IDCNT,
     1 IHAB(6,50),IKAB(6,50),ILAB(6,50)
      REAL*4 INT,INTCOR,IIAB(6,50)
      CHARACTER*2 LA
      CHARACTER*7 NPROF
      CHARACTER*1 ISTAR,PROF(96)
      CHARACTER*4 CARD(20)
      CHARACTER*1 DASH(11)
      CHARACTER*16 NAMFI,NAMFI2
      DATA IBLANK/'    '/
      DIMENSION REAL(12),PHYS(62),ISAB(6)
	INTEGER*2 A(124),IDD(100,2),ID1(200),IDEL(500),NDR(12)
	INTEGER FILE,READRC,RECFM
      EQUIVALENCE (ID,A(1)),(H,A(2)),(K,A(3)),(L,A(4)),(TTH,A(5)),
     1(REAL(1),A(5)),(TTH,REAL(1)),(OM,REAL(2)),(PHI,REAL(3)),
     1(CHI,REAL(4)),(RANGE,REAL(5)),(SPEED,REAL(6)),(BG1,REAL(7)),
     1(SCAN,REAL(8)),(BG2,REAL(9)),(INT,REAL(10)),(SIG,REAL(11)),
     1(EXPTM,REAL(12)),(ISTEP,A(29)),(IDHKL(1),ID),(IDHKL(2),H),
     1(IDHKL(3),K),(IDHKL(4),L)
      COMMON/FNAME/NAMFI,NAMLEN
      OUT=7
      BL1=0.0   ! BLANK FIELDS
      BL2=0.0
      BL3=0.0
      IPROF=0
      IRD=0
      ND=0
      ND1=0
      NTOT=0
      DO I=1,6
        ISAB(I)=0
      ENDDO
      NAMFI(NAMLEN+1:NAMLEN+4)='.MAG'
C   OPENING MAG FILE
25    OPEN(NAME=NAMFI,UNIT=OUT,TYPE='NEW',FORM='UNFORMATTED',
     1BLOCKSIZE=32768,BUFFERCOUNT=2)
      NOCHEK=0   ! NUMBER OF CHECKS
      NOL=10
      TSTBL=0.
C
C  FILE CARD 
C2345678901234567890
C####NN LIST
C LENGTH IS LAST ID TO BE READ FROM THIS FILE
C IFILE IS FILE NUMBER - DEFAULT IS 1
C NLIST NONBLANK REQUESTS THAT PRINTED OUTPUT BE SUPPRESSED
C
      IF(IRD.EQ.0)THEN
      READ(1,10)LENGTH,IFILE,NLIST,NPROF
      ELSE
C   IRD NOT=0 IF READING MORE THAN ONE FILE FROM SAME MAG TAPE
      DECODE(80,10,CARD)LENGTH,IFILE,NLIST
      ENDIF
10    FORMAT(I5,I2,1X,A4,1X,A7)
      IF(NLIST.EQ.IBLANK)THEN
      ILIST=1
      WRITE(3,15)
15    FORMAT(' AS REQUESTED, YOU WILL HAVE PRINTED OUTPUT OF TAPE',
     1' CONTENTS.')
      ELSE
      ILIST=0
      WRITE(3,16)
16    FORMAT(' NO PRINTED OUTPUT OF TAPE CONTENTS.')
      ENDIF
      IF(NPROF.NE.'       ')THEN
C  NPROF NONBLANK MEANS PROFILES LISTED IN FILE NAME.PRO
        WRITE(3,8)
8       FORMAT(' PROFILES WILL BE LISTED IN FILE NAME.PRO')
        NAMFI2(1:NAMLEN)=NAMFI(1:NAMLEN)
        NAMFI2(NAMLEN+1:NAMLEN+4)='.PRO'
        OPEN(NAME=NAMFI2,UNIT=14,TYPE='NEW',FORM='FORMATTED',
     1  BLOCKSIZE=32768)
        IPROF=1
      ENDIF
      IF(IFILE.EQ.0)IFILE=1
      WRITE(3,7)IFILE,LENGTH
      IF(LENGTH.EQ.0)GOTO 901
7     FORMAT(' LAST ID TO BE READ FROM FILE ',I2,' IS: ',I5)
      READ(1,18)CARD
18    FORMAT(20A4)
      IF(CARD(1).NE.'SCAN')THEN
C  DEFAULT IF NO SCAN CARD FOUND IS SCAN 2THETA
      NBT=248
      IOMEG=1
      IRD=1
      GOTO 19
      ENDIF
C   OMEGA OR 2THETA SCAN
      WRITE(3,180)CARD
180   FORMAT(1X,20A4)
      IF(CARD(2).EQ.' 2TH')THEN
C  SCAN 2THETA
      NBT=248
      IOMEG=1
      ELSE
C  SCAN OMEGA
      IF(CARD(2).NE.' OME')GOTO 923
      NBT=96
      IOMEG=2
      ENDIF
181   READ(1,18)CARD
19    CONTINUE
      IF(CARD(1).NE.'DELE')GOTO 253
C DELETE CARDS HERE - DELETED REFLECTIONS NOT STORED ON MAG FILE!
      DECODE(80,21,CARD)(NDR(I),DASH(I),I=1,11),NDR(12)
21    FORMAT(7X,11(I5,A1),I5)
      WRITE(3,22)(NDR(I),DASH(I),I=1,11),NDR(12)
22    FORMAT(1X,'DELETE ',11(I5,A1),I5)
      I=1
23    IF(NDR(I).EQ.0)GOTO 181
      IF(DASH(I).EQ.'-')THEN
C  DASH MEANS RANGE OF IDS TO BE DELETED
      ND=ND+1
C  ND KEEPS TRACK OF RANGES OF DELETIONS
      IF(ND.GT.100)THEN
C  PREVENT ARRAY OVERFLOW - 100 DELETION RANGES ALLOWED
      ND=100
      WRITE(3,24)NDR(I)
24    FORMAT(' DELETION ARRAY OVERFLOW - REFLECTION # ',I6,
     1' NOT DELETED.')
      ENDIF
      IDD(ND,1)=NDR(I)
      IDD(ND,2)=NDR(I+1)
      I=I+2
      ELSE ! SINGLE DELETION
      ND1=ND1+1
C  ND1 KEEPS TRACK OF NUMBER OF SINGLY DELETED REFLECTIONS
      IF(ND1.GT.200)THEN
C  PREVENT ARRAY OVERFLOW - 200 SINGLE DELETIONS ALLOWED
      ND1=200
      WRITE(3,24)NDR(I)
      ENDIF
      ID1(ND1)=NDR(I)
      I=I+1
      ENDIF
      IF(I.LE.12)GOTO 23
      GOTO 181
253   CONTINUE
C    READ IN DATA TAPE HERE                                                  184
C   CODE HERE REPLACES CALL TO RDTP IN IBM VERSION
      RLP = 1                                                           PR   186
      FIRST=0                                                           
	LRECL=NBT
	RECFM=1
	IER=0		! INITIALIZE
C      WRITE(3,9999)IFILE,RECFM,LRECL,IDISK
C9999    FORMAT(' BEFORE OPEN FILE=',I2,' RECFM=',I2,' LRECL=',I4,
C    + ' IDISK=',I2,/,/,/)
	IER=FILE(IFILE,PHYS,RECFM,LRECL,LRECL)
	IF(IER.LT.0)WRITE(3,200)IER
200	FORMAT(1X,' ERROR SIGNAL FROM FILE  IS ',I5,/,
     1 1X,' THIS IS A BAD ERROR SO PROGRAM HAS STOPPED.',/,
     1 1X,' BE SURE YOU HAVE ASSIGNED THE LOGICAL NAME TAPE',/,
     1 1X,' TO WHATEVER TAPE DRIVE YOU ARE USING.')
	IF(IER.LT.0)STOP
      IF(ILIST.EQ.1)WRITE(3,3001)
300   CONTINUE
C300   WRITE(3,9993)
C9993  FORMAT(' AT 300')
   	LRECL=NBT	! NBT=248 FOR TTHETA SCAN AND 92 FOR OMEGA SCAN
	NNREC=NNREC+1
C       WRITE(3,9991)NNREC   
C9991    FORMAT('  NNREC=',I5)
	IER=READRC(A,LRECL)
C 	WRITE(3,999)IER,LRECL
C999	FORMAT(' IER=',I5,' LRECL=',I6)
	IF(LRECL.LT.0)GO TO 301		!E O F
	IF(LRECL.NE.NBT) GO TO 300	! BAD RECORD
	CALL I2V(IDHKL,4)
	CALL R4V(REAL,12)
	CALL I2V(ISTEP,96)
C      WRITE(3,9992)ID,H,K,L
C9992    FORMAT(' ID,H,K,L=',4I5)
        IF(ID.EQ.0)GOTO 300
	IDCNT=ID
      IF(IDCNT.GT.0)GOTO 210
      IDCNT=-IDCNT
      IF(NOCHEK.EQ.0)GOTO 206
      DO 205 I=1,NOCHEK
      IF(H.EQ.IH(I).AND.K.EQ.IK(I).AND.L.EQ.IL(I))THEN
      ICK=I
      GOTO 210
      ENDIF
205   CONTINUE
206   NOCHEK=NOCHEK+1
      ICK=NOCHEK
      IH(ICK)=H
      IK(ICK)=K
      IL(ICK)=L
210   IF(ND.EQ.0)GOTO 211
      DO 211 I=1,ND
C  IS REFLECTION IN ONE OF THE DELETION RANGES
      IF(IDCNT.GE.IDD(I,1).AND.IDCNT.LE.IDD(I,2))THEN
      NTOT=NTOT+1
      IF(NTOT.GT.500)NTOT=500  ! PREVENT ARRAY OVERFLOW
C  NTOT KEEPS TRACK OF TOTAL NUMBER OF DELETED REFLECTIONS
      IDEL(NTOT)=ID
      GOTO 300
      ENDIF
211   CONTINUE
      IF(ND1.EQ.0)GOTO 212
C  SEEING IF REFLECTION IS ONE OF THE SINGLE DELETIONS
      DO 212 I=1,ND1
      IF(IDCNT.EQ.ID1(I))THEN
      NTOT=NTOT+1
      IF(NTOT.GT. 500)NTOT=500  !PREVENT ARRAY OVERFLOW
      IDEL(NTOT)=ID
      GOTO 300
      ENDIF
212   CONTINUE
      IF(LENGTH.NE.0)THEN
       IF(IDCNT.GT.LENGTH)GO TO 301  ! IS ID > LAST ID TO BE READ IN
      ENDIF
      TBTS=(BG1+BG2)/(SCAN-(INT/SPEED))
      TSTB=1./TBTS
      IF(TSTBL.EQ.0.)TSTBL=TSTB
C   TSTBL IS LAST TSTB - IF THERE IS MORE THAN 20% DIFFERENCE BETWEEN 
C  THE TWO, A STAR WILL BE PRINTED ON OUTPUT TO INDICATE THIS.
      IF(ABS(TSTB-TSTBL)/TSTB.GT.0.2)THEN
      ISTAR='*'  ! STAR IN OUTPUT IF CHANGE IN TS/TB> 20%
      ELSE
      ISTAR=' '
      ENDIF
      TSTBL=TSTB
      IF(IOMEG.EQ.2)THEN
C  IF SCAN OMEGA, SCAN CANNOT BE CALCULATED FROM PROFILE AS IT IS NOT
C  STORED ON THE DIFFRACTOMETER TAPE.  THEREFORE, SCAN, SIGMA AND
C  INTENSITY ARE TAKEN FROM THE TAPE RATHER THAN CALCULATED FROM THE
C  PROFILES.
      INTCOR=INT
      SIGCOR=SIG
      RATIO=1.0
      ELSE
      SCAN=0.
      DO 215 I=1,96
215   SCAN=SCAN+ISTEP(I)
      INTCOR=(SCAN-(BG1+BG2)*TSTB)*SPEED
      SIGCOR=SQRT(SPEED**2*(SCAN+(BG1+BG2)*TSTB**2))
      IF(INT.EQ.0.)THEN
      RATIO=0.0
      ELSE
      RATIO=INTCOR/INT
      ENDIF
      ENDIF
      WRITE(OUT)IDHKL,TTH,PHI,CHI,RANGE,SPEED,BG1,SCAN,BG2,EXPTM,TBTS,
     1 BL1,BL2,BL3
C  FOR SPACE GROUP ABSENCES
C  H 0 0
      IF(K.EQ.0.AND.L.EQ.0)THEN
        ISAB(1)=ISAB(1)+1
        I=ISAB(1)
        IF(I.GT.50)GOTO 2121
        IHAB(1,I)=H
        IKAB(1,I)=K
        ILAB(1,I)=L
        IIAB(1,I)=INTCOR
2121  ENDIF
C  0 K 0
      IF(H.EQ.0.AND.L.EQ.0)THEN
        ISAB(2)=ISAB(2)+1
        I=ISAB(2)
        IF(I.GT.50)GOTO 2122
        IHAB(2,I)=H
        IKAB(2,I)=K
        ILAB(2,I)=L
        IIAB(2,I)=INTCOR
2122  ENDIF
C  0 0 L
      IF(H.EQ.0.AND.K.EQ.0)THEN
        ISAB(3)=ISAB(3)+1
        I=ISAB(3)
        IF(I.GT.50)GOTO 2123
        IHAB(3,I)=H
        IKAB(3,I)=K
        ILAB(3,I)=L
        IIAB(3,I)=INTCOR
2123  ENDIF
C  H K 0  (ONLY FOR -5 <= H,K <= 5)
      IF(L.EQ.0.AND.IABS(H).LT.6.AND.IABS(K).LT.6)THEN
        ISAB(4)=ISAB(4)+1
        I=ISAB(4)
        IF(I.GT.50)GOTO 2124
        IHAB(4,I)=H
        IKAB(4,I)=K
        ILAB(4,I)=L
        IIAB(4,I)=INTCOR
2124  ENDIF
C  H 0 L  (ONLY FOR -5 <= H,L <= 5)
      IF(K.EQ.0.AND.IABS(H).LT.6.AND.IABS(L).LT.6)THEN
        ISAB(5)=ISAB(5)+1
        I=ISAB(5)
        IF(I.GT.50)GOTO 2125
        IHAB(5,I)=H
        IKAB(5,I)=K
        ILAB(5,I)=L
        IIAB(5,I)=INTCOR
2125  ENDIF
C  0 K L  (ONLY FOR -5 <= K,L <= 5)
      IF(H.EQ.0.AND.IABS(K).LT.6.AND.IABS(L).LT.6)THEN
        ISAB(6)=ISAB(6)+1
        I=ISAB(6)
        IF(I.GT.50)GOTO 2126
        IHAB(6,I)=H
        IKAB(6,I)=K
        ILAB(6,I)=L
        IIAB(6,I)=INTCOR
2126  ENDIF
      IF(ILIST.EQ.1)THEN
      IF(NOL.EQ.78)THEN
      WRITE(3,3001)
      NOL=1
3001  FORMAT(1H1,'   ID     H     K     L    CK    B1     SCAN  ',
     1'   B2     INT      SIG   RATIO   2TH     PHI     CHI    TIME  ',
     2' SPEED  TB/TS',/,/)
      ENDIF
      NOL=NOL+1  ! KEEPS TRACK OF NUMBER OF LINES
      IBG1=BG1
      IBG2=BG2
      ISCAN=SCAN
      IF(ID.GT.0)THEN
      IF(ABS(1.0-RATIO).GT.0.0005)THEN
C  1.00 - RATIO > .0005 AND NOT A CHECK
      WRITE(3,3000)IDHKL,IBG1,ISCAN,IBG2,INTCOR,SIGCOR,RATIO,TTH,PHI,
     1CHI,EXPTM,SPEED,TBTS,ISTAR
3000  FORMAT(1X,4I6,5X,I7,I9,I7,F9.2,F8.2,F7.3,F7.2,3F8.2,F7.2,
     1F6.2,2X,A1)
      ELSE  ! 1-RATIO < .0005 AND NOT A CHECK
      WRITE(3,3003)IDHKL,IBG1,ISCAN,IBG2,INTCOR,SIGCOR,TTH,PHI,CHI,
     1EXPTM,SPEED,TBTS,ISTAR
3003  FORMAT(1X,4I6,5X,I7,I9,I7,F9.2,F8.2,7X,F7.2,3F8.2,F7.2,
     1F6.2,2X,A1)
      ENDIF
      ELSE  ! CHECK
      IF(1.0-RATIO.GT.0.0005)THEN
C   1.0 - RATIO > .0005 AND IS A CHECK
      WRITE(3,3002)IDHKL,ICK,IBG1,ISCAN,IBG2,INTCOR,SIGCOR,RATIO,TTH,
     1PHI,CHI,EXPTM,SPEED,TBTS,ISTAR
3002  FORMAT(1X,4I6,1X,1H(,I2,1H),I7,I9,I7,F9.2,F8.2,F7.3,F7.2,3F8.2,
     1F7.2,F6.2,2X,A1)
      ELSE  ! 1.0 - RATIO < .0005 AND IS A CHECK
      WRITE(3,3004)IDHKL,ICK,IBG1,ISCAN,IBG2,INTCOR,SIGCOR,TTH,PHI,
     1CHI,EXPTM,SPEED,TBTS,ISTAR
3004  FORMAT(1X,4I6,1X,1H(,I2,1H),I7,I9,I7,F9.2,F8.2,7X,F7.2,3F8.2,
     1F7.2,F6.2,2X,A1)
      ENDIF
      ENDIF
      ENDIF
      IF(IPROF.EQ.0)GOTO 3005
C  WRITING FILE OF PROFILES.  TRANSLATING PROFILES TO THEIR BASE
C  2 COMPLEMENT - I.E. 0-1 = 0, 2-3 = 1, 4-7 = 2, 8-15 = 3, ETC. UP 
C  THROUGH 2**20.  AFTER 9, USE "A","B",...,"K"
      DO 3009 I=1,96
        KK=0
        II=ISTEP(I)
        IF(II.LT.0)II=65536+ISTEP(I)  ! COMPLEMENT IF <0  KMS 3/89
3006    IF(II.LE.1)GOTO 3007
        II=II/2
        KK=KK+1
        IF(KK.LT.20)GOTO 3006
        KK=20
3007    GOTO(40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,
     1  58,59,60)KK+1
40      PROF(I)='0'
        GOTO 3009
41      PROF(I)='1'
        GOTO 3009
42      PROF(I)='2'
        GOTO 3009
43      PROF(I)='3'
        GOTO 3009
44      PROF(I)='4'
        GOTO 3009
45      PROF(I)='5'
        GOTO 3009
46      PROF(I)='6'
        GOTO 3009
47      PROF(I)='7'
        GOTO 3009
48      PROF(I)='8'
        GOTO 3009
49      PROF(I)='9'
        GOTO 3009
50      PROF(I)='A'
        GOTO 3009
51      PROF(I)='B'
        GOTO 3009
52      PROF(I)='C'
        GOTO 3009
53      PROF(I)='D'
        GOTO 3009
54      PROF(I)='E'
        GOTO 3009
55      PROF(I)='F'
        GOTO 3009
56      PROF(I)='G'
        GOTO 3009
57      PROF(I)='H'
        GOTO 3009
58      PROF(I)='I'
        GOTO 3009
59      PROF(I)='J'
        GOTO 3009
60      PROF(I)='K'
3009  CONTINUE
      WRITE(14,3010)IDHKL,TTH,PROF
3010  FORMAT(1X,I6,3I4,F8.2,1X,96A1)
3005  IF(IDCNT.EQ.LENGTH)GOTO 301
      GOTO 300 ! READ NEXT REFLECTION
301   ID=0  ! LAST REFLECTION MARKED WITH ID=0
      WRITE(OUT)IDHKL,TTH,PHI,CHI,RANGE,SPEED,BG1,SCAN,BG2,EXPTM,TBTS,
     1 BL1,BL2,BL3
      CLOSE(UNIT=OUT,DISP='SAVE')
      IF(CARD(1).NE.'END ')GOTO 25 ! READ NEXT FILE FROM SAME TAPE
      IF(NTOT.NE.0)THEN
C  LISTING DELETED REFLECTIONS
      WRITE(3,304)
304   FORMAT(//,' THESE REFLECTIONS HAVE BEEN DELETED AND ARE NOT',
     1' INCLUDED ON THE MAG FILE: ',/)
      IF(NTOT.GE.500)WRITE(3,305)
305   FORMAT(' NOTE - ONLY THE FIRST 500 REFLECTIONS ARE LISTED HERE')
      I=0
302   I=I+1
      I1=15*I-14
      I2=15*I
      IF(NTOT.LT.I2)I2=NTOT
      WRITE(3,303)(IDEL(II),II=I1,I2)
303   FORMAT(1X,15(I6,1X))
      IF(I2.LT.NTOT)GOTO 302
      ENDIF
C  WRITING OUT LIST FOR SPACE GROUP ABSENCES
      WRITE(3,3032)ISAB(1)
3032  FORMAT(//' REFLECTIONS OF TYPE H 0 0:  TOTAL NO: ',I5)
      IF(ISAB(1).GT.50)THEN
        WRITE(3,3033)
        ISAB(1)=50
      ENDIF
3033  FORMAT(' ONLY FIRST 50 ARE LISTED')
      WRITE(3,3034)
3034  FORMAT('     H     K     L       INT                H     K   ',
     1'  L       INT')
      WRITE(3,3035)(IHAB(1,I),IKAB(1,I),ILAB(1,I),IIAB(1,I),I=1,ISAB(1))
3035  FORMAT(I7,I6,I6,F11.2,10X,I6,I6,I6,F11.2)
      WRITE(3,3036)ISAB(2)
3036  FORMAT(/' REFLECTIONS OF TYPE O K O:  TOTAL NO: ',I5)
      IF(ISAB(2).GT.50)THEN
        WRITE(3,3033)
        ISAB(2)=50
      ENDIF
      WRITE(3,3034)
      WRITE(3,3035)(IHAB(2,I),IKAB(2,I),ILAB(2,I),IIAB(2,I),I=1,ISAB(2))
      WRITE(3,3037)ISAB(3)
3037  FORMAT(/' REFLECTIONS OF TYPE O O L:  TOTAL NO: ',I5)
      IF(ISAB(3).GT.50)THEN
        WRITE(3,3033)
        ISAB(3)=50
      ENDIF
      WRITE(3,3034)
      WRITE(3,3035)(IHAB(3,I),IKAB(3,I),ILAB(3,I),IIAB(3,I),I=1,ISAB(3))
      WRITE(3,3038)ISAB(4)
3038  FORMAT(/' REFLECTIONS OF TYPE H K 0 FOR |H,K|<=5:  TOTAL NO: ',I5)
      IF(ISAB(4).GT.50)THEN
        WRITE(3,3033)
        ISAB(4)=50
      ENDIF
      WRITE(3,3034)
      WRITE(3,3035)(IHAB(4,I),IKAB(4,I),ILAB(4,I),IIAB(4,I),I=1,ISAB(4))
      WRITE(3,3039)ISAB(5)
3039  FORMAT(/' REFLECTIONS OF TYPE H 0 L FOR |H,L|<=5:  TOTAL NO: ',I5)
      IF(ISAB(5).GT.50)THEN
        WRITE(3,3033)
        ISAB(5)=50
      ENDIF
      WRITE(3,3034)
      WRITE(3,3035)(IHAB(5,I),IKAB(5,I),ILAB(5,I),IIAB(5,I),I=1,ISAB(5))
      WRITE(3,3040)ISAB(6)
3040  FORMAT(/' REFLECTIONS OF TYPE 0 K L FOR |K,L|<=5:  TOTAL NO: ',I5)
      IF(ISAB(6).GT.50)THEN
        WRITE(3,3033)
        ISAB(6)=50
      ENDIF
      WRITE(3,3034)
      WRITE(3,3035)(IHAB(6,I),IKAB(6,I),ILAB(6,I),IIAB(6,I),I=1,ISAB(6))
      RETURN
923   WRITE(3,101)
101   FORMAT(' ERROR ON SCAN OMEGA OR SCAN 2THETA CARD')
      GOTO 924
901   WRITE(3,102)
102   FORMAT(' NEED TO SPECIFY LAST ID NUMBER TO BE READ IN.')
924   STOP
      END
