C    TWO PLANE NORMAL PROGRAM
C     SUBROUTINE FOR FINDING BEST PLANE THROUGH A SET OF ATOMS.         00000050
C     IN CRYSTALLOGRAPHIC COORDINATES.                                  00000060
C     CALL TWOPL(X,Y,Z,W,D,N,M,A,VC,AR,NT,NC,NP,VAR)
C     WHERE 'X','Y',AND'Z' CONTAIN COORDINATES FOR 'N' ATOMS. 'W'       00000100
C     CONTAINS ATOM WEIGHTS.                                            00000110
C     ATOM TO PLANE DISTANCES ARE PLACED IN 'D'.                        00000120
C     DIRECTION COSINES OF PLANE NORMAL ARE PLACED IN M(1),M(2),M(3).   00000130
C     M(4) IS ORIGIN TO PLANE DISTANCE.                                 00000140
C     'A' IS THE REAL SPACE METRIC TENSOR. 'VC' IS FOR TRANSFORMING TO  00000150
C     DIRECTION COSINES FROM RECIPROCAL SPACE COMPONENTS.  'AR' IS THE  00000160
C     RECIPROCAL SPACE METRIC TENSOR.  'NT' IS A TROUBLE INDICATOR  =0  00000170
C     FOR SUCCESS, =1 FOR TROUBLE.                                      00000180
C     NC= # OF ATOMS IN COMMON
C     NP= NUMBER OF PLANE, EITHER 1 OR 2.
C  PRPL = 1 FOR FULL PLANE OUTPUT
C       = 0 FOR LIMITED PLANE OUTPUT
C   VARD IS ESD OF INDIVIDUAL ESDS - PRINTED OUT IN DISTAN
C  PDES IS PLANE IDENTIFIER
C  GSIG,ICON AND GNAME ARE USED ON THE GENERAL CARD
C  I2P=1 IF FIRST PLANE OF TWOPL, =2 IF 2ND OF TWOPL, =0 IF PLANE
C                                                                       00000190
      SUBROUTINE TWOPL(X,Y,Z,W,D,N,M,A,VC,AR,NT,NC,NP,VAR,PRPL,VARD,
     1 PDES,GSIG,ICON,GNAME,IOP,I2P)
      REAL M(7),MM,MMA,MO(3,3),MOR(3,3),MC,           MORS(2,3,3)
      DIMENSION TX(2,3),TC1(3),TC2(3),TD1(3),TD2(3)
      DIMENSION VMS(2,2,2),XCS(2,40),YCS(2,40),ZCS(2,40),DENXS(2),
     1DENYS(2),AXCS(3,3),           WBS(2),CVCM(2,2)
      DIMENSION TEST(4),GSIG(3)
      DIMENSION MM(3,3),MMA(3,3),SSQ(40),XO(40),YO(40),ZO(40),
     1XC(40),YC(40),ZC(40),VV(3),CHCK(3),VAR(40),COCOS(3,3),
     2MC(3,3),CODCS(3),CORTH(3,3),CDORTH(3),VM(2,2),WS(2,10)
      DIMENSION X(300),Y(300),Z(300),D(300),A(3,3),VC(3),B(3,3),YYB(3),
     1C(3,3),AD(3,3),AR(3,3),W(300),V(3)                  
      CHARACTER*5 NM(3)
      CHARACTER*10 GNAME
      CHARACTER*16 NFILE
      COMMON/FNAME/NFILE,NAMLEN
C
C                                                                       00000240
C     FIND CENTER OF GRAVITY.                                           00000250
C                                                                       00000260
      NSAVE=N
      NT=0                                                              00000270
      XB=0.0                                                            00000280
      YB=0.0                                                            00000290
      ZB=0.0                                                            00000300
      WB=0.0                                                            00000310
      WW=0.0
      DO 15 I=1,N                                                       00000320
      XB=XB+X(I)*W(I)                                                   00000330
      YB=YB+Y(I)*W(I)                                                   00000340
      ZB=ZB+Z(I)*W(I)                                                   00000350
   15 WB=WB+W(I)                                                        00000360
      IF(NP.NE.0)WBS(NP)=WB
      XB=XB/WB                                                          00000370
      YB=YB/WB                                                          00000380
      ZB=ZB/WB                                                          00000390
      IF (N-3) 90,102,19                                                00000400
C                                                                       00000410
C     COMPUTE MATRIX                                                    00000420
C                                                                       00000430
   19 DO 25 I=1,3                                                       00000440
      DO 25 J=1,3                                                       00000450
      C (I,J)=0.0                                                       00000460
   25 B (I,J)=0.0                                                       00000470
      DO 30 I=1,N                                                       00000480
      YYB(1)=X(I)-XB                                                    00000490
      YYB(2)=Y(I)-YB                                                    00000500
      YYB(3)=Z(I)-ZB                                                    00000510
      DO 30 J=1,3                                                       00000520
      DO 30 K=J,3                                                       00000530
   30 B(J,K)=W(I)*YYB(J)*YYB(K)+B(J,K)                                  00000540
      B(2,1)=B(1,2)                                                     00000550
      B(3,1)=B(1,3)                                                     00000560
      B(3,2)=B(2,3)                                                     00000570
      DO 40 I=1,3                                                       00000580
      DO 40 J=1,3                                                       00000590
      DO 40 K=1,3                                                       00000600
   40 C(I,J)=C(I,J)+A(I,K)*B(K,J)                                       00000610
C                                                                       00000620
C     FIND SMALLEST EIGENVALUE AND CORRESPONDING EIGENVECTOR.           00000630
C                                                                       00000640
      CALL EIGEN(C,V,AD,NT)                                             00000650
      IF (NT) 90,50,90                                                  00000660
   45 NT=1                                                              00000670
      GO TO 90                                                          00000680
   50 BG=999999.0                                                       00000690
      DO 52 I=1,3                                                       00000700
      IF (BG-V(I)) 52,52,51                                             00000710
   51 BG=V(I)                                                           00000720
      K=I                                                               00000730
   52 CONTINUE                                                          00000740
      DO 65 I=1,3                                                       00000750
   65 M(I)=AD(I,K)                                                      00000760
C
C        FIND LABELS OF OTHER EIGENVECTORS
C
      VV(3)=V(K)
      IK=K+1
      IF(IK.GT.3)IK=IK-3
      IIK=K+2
      IF(IIK.GT.3)IIK=IIK-3
C                                                                       00000770
C     MAKE M A UNIT VECTOR WITH DIRECTION SUCH THAT THE ORIGIN TO PLANE 00000780
C     DISTANCE IS +.                                                    00000790
C                                                                       00000800
   66 DIS = 0.0                                                         00000810
      DO 67 I=1,3                                                       00000820
      DO 67 J=1,3                                                       00000830
   67 DIS=AR(I,J)*M(I)*M(J)+DIS                                         00000840
      DIS=SQRT(DIS)                                                     00000850
      IF (DIS) 45,45,68                                                 00000860
   68 DO 69 I=1,3                                                       00000870
   69 M(I)=M(I)/DIS                                                     00000880
      DIS=M(1)*XB+M(2)*YB+M(3)*ZB                                       00000890
      IF (DIS) 71,74,74                                                 00000900
   71 DIS = -DIS                                                        00000910
      DO 72 I=1,3                                                       00000920
   72 M(I)= -M(I)                                                       00000930
C
C                                                                       00000940
C     COMPUTE OUT OF PLANE DISTANCES.                                   00000950
C                                                                       00000960
   74 DO 75 I=1,N                                                       00000970
   75 D(I)=M(1)*X(I)+M(2)*Y(I)+M(3)*Z(I)-DIS                            00000980
      DO 109 J=1,3
109   MM(3,J)=M(J)
      M(4)=DIS                                                          00001010
      DO 85 I=1,3
85    M(I)=M(I)*VC(I)
C        CONSTRUCT ORTHONORMAL RIGHT-HANDED COORDINATE SYSTEM
C        FROM BEST PLANE EIGENVECTORS
C
      IJ=IK
108   CONTINUE
      DIS=0.0
      DO 110 I=1,3
      DO 110 J=1,3
110   DIS=AR(I,J)*AD(I,IJ)*AD(J,IJ)+DIS
      DIS=SQRT(DIS)
      IF(DIS)45,45,111
111   DO 902 I=1,3
902   AD(I,IJ)=AD(I,IJ)/DIS
      IF(IJ.EQ.IIK)GO TO 112
      IJ=IIK
      GO TO 108
112   IF(V(IIK)-V(IK))130,132,132
130   VV(1)=V(IK)
      VV(2)=V(IIK)
      DO 131 I=1,3
      MM(1,I)=AD(I,IK)
131   MM(2,I)=AD(I,IIK)
      GO TO 134
132   VV(1)=V(IIK)
      VV(2)=V(IK)
      DO 133 I=1,3
      MM(1,I)=AD(I,IIK)
133   MM(2,I)=AD(I,IK)
134   CALL DETERM(MM,3,DET)
      IF(DET)135,137,137
135   DO 136 I=1,3
136   MM(1,I)=-MM(1,I)
137   CONTINUE
C
C        FIND ATOM COORDINATES IN BEST PLANE SYSTEM RELATIVE TO
C        CRYSTAL ORIGIN AND RELATIVE TO CENTROID
C
      IF(I2P.NE.2.OR.PRPL.EQ.1)WRITE(3,1371)
1371  FORMAT('1')
      IF(PRPL.NE.1.AND.I2P.NE.2)THEN
      WRITE(3,1372)
1372  FORMAT(' SOME PLANE INFORMATION WILL NOT BE WRITTEN ON OUTPUT')
      ENDIF
      IF(PRPL.EQ.1)WRITE(3,9142)PDES
      IF(PRPL.EQ.1.AND.I2P.EQ.1)WRITE(3,1378)
1378  FORMAT(35X,'FIRST PLANE',/)
      IF(PRPL.EQ.1.AND.I2P.EQ.2)WRITE(3,1379)
1379  FORMAT(34X,'SECOND PLANE',/)
9142  FORMAT(' ATOM COORDINATES IN PLANE SYSTEM RELATIVE TO CRYSTAL ORI
     1GIN AND TO PLANE CENTROID, FOR PLANE ',A2,/)
      IF(N.GT.40)GO TO 6900
6151  CONTINUE
      DO 151 I=1,N
      XO(I)=MM(1,1)*X(I)+MM(1,2)*Y(I)+MM(1,3)*Z(I)
      YO(I)=MM(2,1)*X(I)+MM(2,2)*Y(I)+MM(2,3)*Z(I)
151   ZO(I)=MM(3,1)*X(I)+MM(3,2)*Y(I)+MM(3,3)*Z(I)
      XOB=MM(1,1)*XB+MM(1,2)*YB+MM(1,3)*ZB
      YOB=MM(2,1)*XB+MM(2,2)*YB+MM(2,3)*ZB
      ZOB=MM(3,1)*XB+MM(3,2)*YB+MM(3,3)*ZB
      IF(NC.EQ.0)GO TO 1521
      DO 1521 I=1,NC
      XC(I)=XO(I)-XOB
      YC(I)=YO(I)-YOB
      ZC(I)=ZO(I)-ZOB
      XCS(NP,I)=XC(I)
      YCS(NP,I)=YC(I)
      ZCS(NP,I)=ZC(I)
      WS(NP,I)=W(I)
      IF(PRPL.EQ.1)WRITE(3,9143)XO(I),YO(I),ZO(I),XC(I),YC(I),ZC(I)
1521  CONTINUE
      J=NC+1
      IF(J.GT.N)GO TO 1522
      DO 152 I=J,N
      XC(I)=XO(I)-XOB
      YC(I)=YO(I)-YOB
      ZC(I)=ZO(I)-ZOB
152   IF(PRPL.EQ.1)WRITE(3,9143)XO(I),YO(I),ZO(I),XC(I),YC(I),ZC(I)
9143  FORMAT(1X,3F12.4,4X,3F12.4)
      IF(PRPL.EQ.1)THEN
1522  WRITE (3,9140)
      WRITE(3,7000)
      WRITE(3,9143)XB,YB,ZB,XOB,YOB,ZOB
7000  FORMAT(/,'  CENTROID COORDINATES IN CRYSTAL SYSTEM (FRACTIONS) AN
     1D IN PLANE SYSTEM(ANGSTROMS) RELATIVE TO CRYSTAL ORIGIN:',/)
9145  FORMAT(//,'  EIGENVALUES:',3E14.6,//)
      WRITE(3,9145)VV
      WRITE(3,9137)
9137  FORMAT('  DIRECTION COSINES OF WORST, INTERMEDIATE, BEST PLANE NO
     1RMALS IN CRYSTAL SYSTEM AND THEIR',/,'  COMPONENTS IN ORTHOGONALI
     2ZED CRYSTAL SYSTEM:',/)
      WRITE(3,9138)
      ENDIF
9138  FORMAT(T22,'A(1)',T36,'A(2)',T50,'A(3)',T64,'X',T78,'Y',T92,'Z')
      DO 161 I=1,3
      DO 160 J=1,3
160   MC(I,J)=MM(I,J)*VC(J)
161   CONTINUE
      DO 1600 J=1,3
1600   M(J)=MC(3,J)
9140  FORMAT(1X,//)
      DO 162 I=1,3
      DO 162 J=1,3
      MO(I,J)=0.0
162   CONTINUE
      DO 165 I=1,3
      DO 163 J=1,3
      DO 163 K=1,3
163   MO(I,J)=AR(J,K)*MM(I,K)+MO(I,J)
165   CONTINUE
      NM(1)='WORST'
      NM(2)='INTER'
      NM(3)='BEST '
      DO 170 I=1,3
      CALL ORTHOG(MO(I,1),MO(I,2),MO(I,3),MOR(I,1),MOR(I,2),MOR(I,3))
      IF(PRPL.EQ.1)WRITE(3,9148)NM(I),(MC(I,J),J=1,3),(MOR(I,J),J=1,3)
170   CONTINUE
      M(5)=MOR(3,1)
      M(6)=MOR(3,2)
      M(7)=MOR(3,3)
9148  FORMAT('0','      ',A5,6F14.5)
      IF(GSIG(1).EQ.0.0)GOTO 1709
      NFILE(NAMLEN+1:NAMLEN+4)='.GEN' ! CREATE GENERAL CARDS IN NAME.GEN
      WRITE(3,9149),GSIG,ICON,GNAME
9149  FORMAT(' WILL CREATE GENERAL CARD.',/,' SCALE = ',F6.3,', HORIZO',
     1'NTAL WIDTH = ',F6.3,', VERTICAL WIDTH = ',F6.3,' AND INDEX ',I2,
     2' CONSTANT HORIZONTAL. LABEL = ',A10)
      IF(IOP.EQ.1)THEN
        OPEN(NAME=NFILE,UNIT=14,FORM='FORMATTED',TYPE='OLD',
     1  BLOCKSIZE=32768)
1704    READ(14,1702,END=1703)I
1702    FORMAT(68X,I2)
        GOTO 1704
      ELSE
        OPEN(NAME=NFILE,UNIT=14,FORM='FORMATTED',TYPE='NEW',
     1   BLOCKSIZE=32768)
         IOP=1
      ENDIF
1703  WRITE(14,1701)GSIG(1),(MC(3,I),I=1,3),XB,YB,ZB,GSIG(2),GSIG(3),
     1 ICON,GNAME
1701  FORMAT('GENERAL',1X,F6.3,6F7.4,2F6.3,I2,A10)
      CLOSE(UNIT=14,DISP='SAVE')
1709  SWSQ=0.0
      XY=0.0
      XU=0.0
      YU=0.0
      XXD=0.0
      YYD=0.0
      ZZD=0.0
      XYD=0.0
      XZD=0.0
      YZD=0.0
      XX=0.0
      YY=0.0
      ZZ=0.0
      XL=0.0
      YL=0.0
      DO 171 I=1,N
      WDV=W(I)/WB
      WSQ=WDV*WDV*VAR(I)
      SWSQ=WSQ+SWSQ
      XXD=XC(I)*XC(I)*W(I)+XXD
      YYD=YC(I)*YC(I)*W(I)+YYD
      ZZD=ZC(I)*ZC(I)*W(I)+ZZD
      XYD=XC(I)*YC(I)*W(I)+XYD
      XZD=XC(I)*ZC(I)*W(I)+XZD
      YZD=YC(I)*ZC(I)*W(I)+YZD
      XX=XC(I)*XC(I)*WSQ+XX
      YY=YC(I)*YC(I)*WSQ+YY
      ZZ=ZC(I)*ZC(I)*WSQ+ZZ
      XY=XC(I)*YC(I)*WSQ+XY
      XU=XC(I)*WSQ+XU
      YU=YC(I)*WSQ+YU
      XL=XO(I)*WDV+XL
171   YL=YO(I)*WDV+YL
      DENX=(XXD-ZZD)/WB
      DENY=(YYD-ZZD)/WB
      IF(PRPL.EQ.1)THEN
      WRITE (3,8002)
      WRITE(3,8003) XXD,XYD,XZD
      WRITE(3,8003) XYD,YYD,YZD
      WRITE(3,8003) XZD,YZD,ZZD
      ENDIF
8002  FORMAT(//,16X,'SECOND MOMENT MATRIX:',/)
8003  FORMAT(8X,3E14.6)
8001  FORMAT(//,4X,6E14.6)
      IF(NP.EQ.0)GO TO 8004
      DENXS(NP)=DENX
      DENYS(NP)=DENY
8004  CONTINUE
      VM(1,1)=(XX+ZZ)/(DENX*DENX)
      VM(2,2)=(YY+ZZ)/(DENY*DENY)
      VM(1,2)=XY/(DENX*DENY)
      VM(2,1)=VM(1,2)
9171  FORMAT('   MX,MY REFER TO COMPONENTS OF PLANE NORMAL IN PLANE SYST
     1EM , WHICH HAVE THE EXPECTATION VALUES ZERO',/)
      IF(PRPL.EQ.1)THEN
      WRITE(3,9160)VM(1,1),VM(2,2),VM(1,2)
      WRITE(3,9171)
      ENDIF
9160  FORMAT('1',T4,'VARIANCE(MX):',E14.6,3X,'VARIANCE(MY):',E14.6,3X,
     1'COVARIANCE(MX,MY):',E14.6,/)
      VARD=SWSQ+VM(1,1)*XL*XL+VM(2,2)*YL*YL-2.0*XL*XU/DENX-2.0
     1*YL*YU/DENY+2.0*XL*YL*XY/(DENX*DENY)
      CVDM1=VM(1,1)*XL+VM(1,2)*YL-XU/DENX
      CVDM2=VM(2,2)*YL+VM(2,1)*XL-YU/DENY
      SDX=SQRT(VM(1,1))
      SDY=SQRT(VM(2,2))
      SDD=SQRT(VARD)
      SDXD=SDX*180.0/3.14159
      SDYD=SDY*180.0/3.14159
      IF(PRPL.EQ.1)THEN
      WRITE(3,9174)SDD
      WRITE(3,9172)SDX,SDXD
      WRITE(3,9173)SDY,SDYD
9172  FORMAT('   STANDARD DEV. PHI(X),RAD,DEGR.:',2F12.6)
9173  FORMAT(/'   STANDARD DEV. PHI(Y),RAD,DEGR.:',2F12.6,/)
9174  FORMAT('0','  STANDARD DEV. D, ANGSTR.:',F12.6,/)
      WRITE(3,9162)CVDM1,CVDM2
9162  FORMAT(1X,T4,'COVARIANCE(D,MX):',E14.6,3X,'COVARIANCE(D,MY):',
     1E14.6,2X,'ANGSTROM**1',/)
      WRITE(3,9140)
      WRITE(3,9163)
      ENDIF
       DO 1740 I=1,3
      DO 1740 J=1,3
1740  COCOS(I,J)=0.0
      DO 175 I=1,3
      DO 174 J=1,3
      DO 174 K=1,2
      DO 174 L=1,2
174   COCOS(I,J)=MC(K,I)*MC(L,J)*VM(K,L)+COCOS(I,J)
175   IF(PRPL.EQ.1)WRITE(3,9164)(COCOS(I,J),J=1,3)
9163  FORMAT('   COVARIANCES AMONG THE DIRECTION COSINES OF THE PLAN
     'E NORMAL:',/)
9164  FORMAT(1X,3E14.6)
      DO 176 I=1,3
176   CODCS(I)=MC(1,I)*CVDM1+MC(2,I)*CVDM2
      IF(PRPL.EQ.1)THEN
      WRITE(3,9165)
      WRITE(3,9166)CODCS
9165  FORMAT(//'   COVARIANCES BETWEEN D AND THE DIRECTION COSINES, AN
     1GSTROM**1:',/)
9166  FORMAT(1X,3E14.6,//)
      WRITE(3,9167)
      ENDIF
      DO 1780 I=1,3
      DO 1780 J=1,3
1780  CORTH(I,J)=0.0
      DO 178 I=1,3
      DO 177 J=1,3
      DO 177 K=1,2
      DO 177 L=1,2
177   CORTH(I,J)=MOR(K,I)*MOR(L,J)*VM(K,L)+CORTH(I,J)
178   IF(PRPL.EQ.1)WRITE(3,9164)(CORTH(I,J),J=1,3)
9167  FORMAT(//'   COVARIANCES AMONG THE ORTHOGONAL SYSTEM COMPONENTS
     1 OF THE PLANE NORMAL:'/)
      DO 179 I=1,3
179    CDORTH(I)=  MOR(1,I)*CVDM1+  MOR(2,I)*CVDM2
      IF(PRPL.EQ.1)THEN
      WRITE(3,9169)
      WRITE(3,9166) CDORTH
      ENDIF
9169  FORMAT(//,'   COVARIANCES BETWEEN D AND THE ORTHOGONAL SYSTEM PL
     1ANE NORMAL COMPONENTS, ANGSTROM**1:',/)
      IF(NP.EQ.0)GO TO 90
      DO 1111 I=1,3
      DO 1111 J=1,3
1111  MORS(NP,I,J)=MOR(I,J)
      DO 1112 I=1,2
      DO 1112 J=1,2
1112  VMS(NP,I,J)=VM(I,J)
      IF(NP.EQ.2)GO TO 990
90    N=NSAVE
      RETURN
C
C     ONE PLANE CALCULATION ONLY
C
C
6900  WRITE(3,6001)N
6001  FORMAT('0',4X,I3,'  ATOMS ENTERED BUT PROGRAM CAN ONLY HANDLE 40 P
     1ER PLANE. FIRST 40 WILL BE USED.')
      N=40
      GO TO 6151
C                                                                       00001030
C     CASE OF ONLY 3 ATOMS                                              00001040
C                                                                       00001050
102   CONTINUE
      DO 7010 I=1,2
      TX(I,1)=X(I)-XB
      TX(I,2)=Y(I)-YB
      TX(I,3)=Z(I)-ZB
7010  CONTINUE
      C1SQ=0.0
      C2SQ=0.0
      C12=0.0
      DO 7001 I=1,3
      DO 7001 J=1,3
      C1SQ=C1SQ+TX(1,I)*TX(1,J)*A(I,J)
      C2SQ=C2SQ+TX(2,I)*TX(2,J)*A(I,J)
7001  C12=C12+TX(1,I)*TX(2,J)*A(I,J)
      C1=SQRT(C1SQ)
      C2=SQRT(C2SQ)
      C12=C12/(C1*C2)
      M(1)=TX(2,2)*TX(1,3)-TX(1,2)*TX(2,3)
      M(2)=TX(2,3)*TX(1,1)-TX(1,3)*TX(2,1)
      M(3)=TX(2,1)*TX(1,2)-TX(1,1)*TX(2,2)
      D1SQ=2.0*(1.0+C12)
      D2SQ=2.0*(1.0-C12)
      D1=SQRT(D1SQ)
      D2=SQRT(D2SQ)
      DO 7002 I=1,3
      TC1(I)=0.0
7002  TC2(I)=0.0
      DO 7004 I=1,3
      DO 7003 J=1,3
      TC1(I)=TC1(I)+TX(1,J)*A(I,J)
7003  TC2(I)=TC2(I)+TX(2,J)*A(I,J)
      TC1(I)=TC1(I)/C1
      TC2(I)=TC2(I)/C2
      TD1(I)=(TC1(I)+TC2(I))/D1
7004  TD2(I)=(TC1(I)-TC2(I))/D2
      C31=W(1)*C1/W(3)
      C32=W(2)*C2/W(3)
      C13=-C31-C32
      C23=-C31+C32
      A1=W(1)*C1SQ
      A2=W(2)*C2SQ
      A11=A1+A2+W(3)*C13*C13
      A22=A1+A2+W(3)*C23*C23
      A12=A1-A2+W(3)*C13*C23
      A11=A11*D1SQ*0.25
      A22=A22*D2SQ*0.25
      TQ =A12*D1*D2*0.25
      ATQ=ABS(TQ)
      IF(ATQ.GT.(0.000001*A11))GO TO 7005
      IF(ATQ.GT.(0.000001*A22))GO TO 7005
      DO 7014 I=1,3
      AD(I,1)=TD1(I)
7014  AD(I,2)=TD2(I)
      V(1)=A11
      V(2)=A22
      V(3)=0.0
      VV(3)=0.0
      GO TO 7007
7005  TD=0.5*(A11-A22)
      TS=0.5*(A11+A22)
      TRT=SQRT(TD*TD+TQ*TQ)
      V(1)=TS+TRT
      V(2)=TS-TRT
      V(3)=0.0
      VV(3)=0.0
      TT=TD+TRT
      TN=SQRT(TQ*TQ+TT*TT)
      TT=TT/TN
      TQ=TQ/TN
      DO 7006 I=1,3
      AD(I,1)=TT*TD1(I)+TQ*TD2(I)
      AD(I,2)=-TQ*TD1(I)+TT*TD2(I)
7006  CONTINUE
7007  DO 7008 I=1,3
      MC(1,I)=AD(I,1)*VC(I)
7008  MC(2,I)=AD(I,2)*VC(I)
      IK=1
      IIK=2
      K=3
      GO TO 66                                                          00001160
990   DO 500 I=1,3
      DO 500 J=1,3
500   AXCS(I,J)=0.0
      IF(PRPL.EQ.1)WRITE(3,5400)
5400  FORMAT('1   COSINES OF ANGLES BETWEEN PLANE AXES:')
      IF(PRPL.EQ.1)WRITE(3,5401)
5401  FORMAT('0',T16,'I(2)',T30,'J(2)',T44,'K(2)')
      DO 501 I=1,3
      DO 501 J=1,3
      DO 501 K=1,3
501   AXCS(I,J)=AXCS(I,J)+MORS(1,I,K)*MORS(2,J,K)
      IF(PRPL.EQ.1)WRITE(3,5402)(AXCS(1,J),J=1,3)
      IF(PRPL.EQ.1) WRITE(3,5403)(AXCS(2,J),J=1,3)
      IF(PRPL.EQ.1)WRITE(3,5404)(AXCS(3,J),J=1,3)
5402  FORMAT('  I(1) ',3F14.6)
5403  FORMAT('  J(1) ',3F14.6)
5404  FORMAT('  K(1) ',3F14.6,/)
      CTH=AXCS(3,3)
      STHSQ=(1-(CTH*CTH))
      TH=ACOS(CTH)
      THDG=TH*180.0/3.14159
      WRITE(3,5405)THDG
5405  FORMAT(/'  ANGLE BETWEEN PLANE NORMALS:',F9.3,' DEGREES')
      DHDG=180.0-THDG
      WRITE(3,6000)DHDG
6000  FORMAT('  DIHEDRAL ANGLE:',13X,F9.3,' DEGREES')
      C1=0.0
      C2=0.0
      DO 5010 I=1,2
      DO 5010 J=1,2
5010  C1=C1+VMS(1,I,J)*AXCS(I,3)*AXCS(J,3)
      DO 5011 I=1,2
      DO 5011 J=1,2
5011  C2=C2+VMS(2,I,J)*AXCS(3,I)*AXCS(3,J)
      C12=C1+C2
      CC14=0.0
      IF(NC.EQ.0)GO TO 5050
      X1X2=0.0
      X1Y2=0.0
      X1Z2=0.0
      Y1X2=0.0
      Y1Y2=0.0
      Y1Z2=0.0
      Z1X2=0.0
      Z1Y2=0.0
      Z1Z2=0.0
      PRWT=WBS(1)*WBS(2)
      DO 5021 I=1,NC
      WDVC=WS(1,I)*WS(2,I)*VAR(I)
      X1X2=X1X2+XCS(1,I)*XCS(2,I)*WDVC
      X1Y2=X1Y2+XCS(1,I)*YCS(2,I)*WDVC
      X1Z2=X1Z2+XCS(1,I)*ZCS(2,I)*WDVC
      Y1X2=Y1X2+YCS(1,I)*XCS(2,I)*WDVC
      Y1Y2=Y1Y2+YCS(1,I)*YCS(2,I)*WDVC
      Y1Z2=Y1Z2+YCS(1,I)*ZCS(2,I)*WDVC
      Z1X2=Z1X2+ZCS(1,I)*XCS(2,I)*WDVC
      Z1Y2=Z1Y2+ZCS(1,I)*YCS(2,I)*WDVC
      Z1Z2=Z1Z2+ZCS(1,I)*ZCS(2,I)*WDVC
5021  CONTINUE
      CC1=Z1Z2*AXCS(1,1)+X1Z2*AXCS(3,1)+Z1X2*AXCS(1,3)+X1X2*AXCS(3,3)
      CVCM(1,1)=CC1/(DENXS(1)*DENXS(2)*PRWT)
      CC2=Z1Z2*AXCS(2,2)+Y1Z2*AXCS(3,2)+Z1Y2*AXCS(2,3)+Y1Y2*AXCS(3,3)
      CVCM(2,2)=CC2/(DENYS(1)*DENYS(2)*PRWT)
      CC3=Z1Z2*AXCS(1,2)+Z1Y2*AXCS(1,3)+X1Z2*AXCS(3,2)+X1Y2*AXCS(3,3)
      CVCM(1,2)=CC3/(DENXS(1)*DENYS(2)*PRWT)
      CC4=Z1Z2*AXCS(2,1)+Y1Z2*AXCS(3,1)+Z1X2*AXCS(2,3)+Y1X2*AXCS(3,3)
      CVCM(2,1)=CC4/(DENYS(1)*DENXS(2)*PRWT)
      WRITE(3,5506)
5506  FORMAT('0','   COVARIANCES BETWEEN COMPONENTS OF PLANE NORMALS')
      WRITE(3,5510)
5510  FORMAT(16X,'MX(2)',12X,'MY(2)')
      WRITE(3,5511)(CVCM(1,J),J=1,2)
      WRITE(3,5512)(CVCM(2,J),J=1,2)
5511  FORMAT(1X,'MX(1)',2E18.6)
5512  FORMAT(1X,'MY(1)',2E18.6)
      WRITE(3,5501)C12
5501  FORMAT('0',4X,'VARIANCE OF COS THETA DISREGARDING COMMON ATOM CORR
     1ELATION=',E14.4,//)
      IF(NC.NE.0)GO TO 5507
5050  VARCS=C12
      GO TO 5508
5507  C14=0.0
      DO 5600 I=1,2
      DO 5600 J=1,2
      C14=C14+CVCM(I,J)*AXCS(I,3)*AXCS(3,J)
5600  CONTINUE
5513  FORMAT(10X,E14.6)
      C14=2.0*C14
      VARCS=C12+C14
      WRITE(3,5502)VARCS
5502  FORMAT(5X,'VARIANCE OF COS THETA INCLUDING COMMON ATOM CORRELATION
     1=',E14.4,//)
5508  IF(STHSQ.LT.0.00001)GO TO 9508
      VARTH=VARCS/STHSQ
      STDTH=SQRT(VARTH)
      STDDG=STDTH*180.0/3.1459
      WRITE(3,5503)STDDG
5503  FORMAT('  STANDARD DEVIATION:',9X,F9.3,' DEGREES')
      NP=0
C      RESET NUMBER OF TWO PLANE CARDS TO ZERO
      DO 9507 K=1,2
      DO 9507 I=1,2
      IF(TH*TH.GT.9.0*VMS(I,K,K))GO TO 90
9507  CONTINUE
      GO TO 9509
9508  WRITE(3,9503)
9503  FORMAT('     UNABLE TO CALCULATE STANDARD DEVIATION OF PLANE ANGLE
     1')
      NP=0
9509  UPBD=0.0
      DO 3020 I=1,2
      DO 3020 J=1,2
      UPBD=UPBD+VMS(I,J,J)-2*CVCM(I,J)*AXCS(I,J)
3020  CONTINUE
      UPBD=SQRT(UPBD)
      UPBDD=UPBD*180.0/3.14159
      WRITE(3,3019)
3019  FORMAT(//,'    THETA IS COMPARABLE WITH THE STANDARD DEVIATION OF
     1AT LEAST ONE PLANE NORMAL')
      WRITE(3,3021)UPBD,UPBDD
3021  FORMAT(//,'    AN UPPER BOUND OF SIGMA(THETA) IS',F14.6,' OR',F14.
     16,' DEGREES')
      GO TO 90
      END
