      SUBROUTINE MATINS(A,N,B,M,DETERM)                                 MATS0005
C     MATRIX INVERSION WITH ACCOMPANYING SOLUTION OF LINEAR EQUATIONS   MATS0015
      DIMENSION A(7,7),B(7,1),INDEX(7,2),PIVOT(7),IPIVOT(7)             MATS0025
      EQUIVALENCE (IROW,JROW), (ICOLUM,JCOLUM), (AMAX, T, SWAP)         MATS0030
C     INITIALIZATION                                                    MATS0040
   10 DETERM=1.0                                                        MATS0050
   15 DO 20 J=1,N                                                       MATS0055
   20 IPIVOT(J)=0                                                       MATS0060
   30 DO 550 I=1,N                                                      MATS0065
C     SEARCH FOR PIVOT ELEMENT                                          MATS0075
   40 AMAX=0.0                                                          MATS0085
   45 DO 105 J=1,N                                                      MATS0090
   50 IF (IPIVOT(J)-1) 60, 105, 60                                      MATS0095
   60 DO 100 K=1,N                                                      MATS0100
   70 IF (IPIVOT(K)-1) 80, 100, 740                                     MATS0105
   80 IF (ABS (AMAX)-ABS (A(J,K))) 85, 100, 100                         MATS0110
85	IROW=J
   90 ICOLUM=K                                                          MATS0120
   95 AMAX=A(J,K)                                                       MATS0125
  100 CONTINUE                                                          MATS0130
  105 CONTINUE                                                          MATS0135
      IF(AMAX .EQ. 0.) GO TO 760                                        MATS0140
  110 IPIVOT(ICOLUM)=IPIVOT(ICOLUM)+1                                   MATS0145
C     INTERCHANGE ROWS TO PUT PIVOT ELEMENT ON DIAGONAL                 MATS0155
  130 IF (IROW-ICOLUM) 140, 260, 140                                    MATS0165
  140 DETERM=-DETERM                                                    MATS0170
  150 DO 200 L=1,N                                                      MATS0175
  160 SWAP=A(IROW,L)                                                    MATS0180
  170 A(IROW,L)=A(ICOLUM,L)                                             MATS0185
  200 A(ICOLUM,L)=SWAP                                                  MATS0190
  205 IF(M) 260, 260, 210                                               MATS0195
  210 DO 250 L=1, M                                                     MATS0200
  220 SWAP=B(IROW,L)                                                    MATS0205
  230 B(IROW,L)=B(ICOLUM,L)                                             MATS0210
  250 B(ICOLUM,L)=SWAP                                                  MATS0215
  260 INDEX(I,1)=IROW                                                   MATS0220
  270 INDEX(I,2)=ICOLUM                                                 MATS0225
  310 PIVOT(I)=A(ICOLUM,ICOLUM)                                         MATS0230
C     DIVIDE PIVOT ROW BY PIVOT ELEMENT                                 MATS0245
  330 A(ICOLUM,ICOLUM)=1.0                                              MATS0255
  340 DO 350 L= 1,N                                                     MATS0260
  350 A(ICOLUM,L)=A(ICOLUM,L)/PIVOT(I)                                  MATS0265
  355 IF(M) 380, 380, 360                                               MATS0270
  360 DO 370 L=1,M                                                      MATS0275
  370 B(ICOLUM,L)=B(ICOLUM,L)/PIVOT(I)                                  MATS0280
C     REDUCE NON-PIVOT ROWS                                             MATS0290
  380 DO 550 L1=1,N                                                     MATS0300
  390 IF(L1-ICOLUM) 400, 550, 400                                       MATS0305
  400 T=A(L1,ICOLUM)                                                    MATS0310
  420 A(L1,ICOLUM)=0.0                                                  MATS0315
  430 DO 450 L=1,N                                                      MATS0320
  450 A(L1,L)=A(L1,L)-A(ICOLUM,L)*T                                     MATS0325
  455 IF(M) 550, 550, 460                                               MATS0330
  460 DO 500 L=1,M                                                      MATS0335
  500 B(L1,L)=B(L1,L)-B(ICOLUM,L)*T                                     MATS0340
  550 CONTINUE                                                          MATS0345
C     INTERCHANGE COLUMNS                                               MATS0355
  600 DO 710 I=1,N                                                      MATS0365
  610 L=N+1-I                                                           MATS0370
  620 IF (INDEX(L,1)-INDEX(L,2)) 630, 710, 630                          MATS0375
  630 JROW=INDEX(L,1)                                                   MATS0380
  640 JCOLUM=INDEX(L,2)                                                 MATS0385
  650 DO 705 K=1,N                                                      MATS0390
  660 SWAP=A(K,JROW)                                                    MATS0395
  670 A(K,JROW)=A(K,JCOLUM)                                             MATS0400
  700 A(K,JCOLUM)=SWAP                                                  MATS0405
  705 CONTINUE                                                          MATS0410
  710 CONTINUE                                                          MATS0415
  740 RETURN                                                            MATS0420
  760 DETERM = 0.                                                       MATS0425
      RETURN                                                            MATS0429
      END                                                               MATS0430
      SUBROUTINE MATD   (A,N,B,M,DETERM,NMAX)
C     MATRIX INVERSION WITH ACCOMPANYING SOLUTION OF LINEAR EQUATIONS
C**** REMOVE NEXT STATEMENT IN SINGLE PRECISION VERSION
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*4 PIVOT
      DIMENSION A(6,6), B(6,1)
      COMMON /F402/ PIVOT(100), INDEX(100)
C     INITIALIZE DETERMINANT AND PIVOT ELEMENT ARRAY
      DETERM=1.0
      DO 20 I=1,N
      PIVOT(I)=0.0
      IF(A(I,I).NE.0.0)GO TO 20
      A(I,I)=1.0
      WRITE(3,9000)I,I
 9000 FORMAT('0 WARNING - THE',2I2,' ELEMENT OF THE MATRIX IS ZERO.'/
     1'0 THIS ELEMENT HAS BEEN SET TO 1.0 TO ALLOW YOU TO CONTINUE.')
   20 CONTINUE
C     PERFORM SUCCESSIVE PIVOT OPERATIONS (GRAND LOOP)
      DO 550 I=1,N
C     SEARCH FOR PIVOT ELEMENT AND EXTEND DETERMINANT PARTIAL PRODUCT
      AMAX=0.0
      DO 105 J=1,N
      IF (PIVOT(J).NE.0.0) GO TO 105
      DO 100 K=1,N
      IF (PIVOT(K).NE.0.0) GO TO 100
C     TEMP=ABS(A(J,K))
      TEMP=A(J,K)
      IF(TEMP.LT.0.0)TEMP=-TEMP
      IF (TEMP.LT.AMAX) GO TO 100
      IROW=J
      ICOLUM=K
      AMAX=TEMP
  100 CONTINUE
  105 CONTINUE
      INDEX(I)=4096*IROW+ICOLUM
      J=IROW
      AMAX=A(J,ICOLUM)
      DETERM=AMAX*DETERM
C     RETURN IF MATRIX IS SINGULAR (ZERO PIVOT) AFTER COLUMN INTERCHANGE
      IF (DETERM.EQ.0.0) GO TO 600
C
      PIVOT(ICOLUM)=AMAX
C     INTERCHANGE ROWS TO PUT PIVOT ELEMENT ON DIAGONAL
      IF (IROW.EQ.ICOLUM) GO TO 260
      DETERM=-DETERM
      DO 200 K=1,N
      SWAP=A(J,K)
      A(J,K)=A(ICOLUM,K)
      A(ICOLUM,K)=SWAP
  200 CONTINUE
      IF (M.LE.0) GO TO 260
      DO 250 K=1,M
      SWAP=B(J,K)
      B(J,K)=B(ICOLUM,K)
      B(ICOLUM,K)=SWAP
  250 CONTINUE
C     DIVIDE PIVOT ROW BY PIVOT ELEMENT
  260 K=ICOLUM
      A(ICOLUM,K)=1.0
      DO 350 K=1,N
      A(ICOLUM,K)=A(ICOLUM,K)/AMAX
  350 CONTINUE
      IF (M.LE.0) GO TO 380
      DO 370 K=1,M
      B(ICOLUM,K)=B(ICOLUM,K)/AMAX
  370 CONTINUE
C     REDUCE NON-PIVOT ROWS
  380 DO 550 J=1,N
      IF (J.EQ.ICOLUM) GO TO 550
      T=A( J,ICOLUM)
      A( J,ICOLUM)=0.0
      DO 450 K=1,N
      A( J,K)=A( J,K)-A(ICOLUM,K)*T
  450 CONTINUE
      IF (M.LE.0) GO TO 550
      DO 500 K=1,M
      B( J,K)=B( J,K)-B(ICOLUM,K)*T
  500 CONTINUE
550	CONTINUE
C	INTERCHANGE COLUMNS AFTER ALL PIVOT OPS HAVE BENN PERFORMED
600	DO 710 I=1,N
	I1=N+1-I
	K=INDEX(I1)-4096*K
	IF(K.EQ.ICOLUM) GO TO 710
	DO 705 J=I,N
	SWAP=A(J,K)
	A(J,K)=A(J,ICOLUM)
	A(J,ICOLUM)=SWAP
705	CONTINUE
710	CONTINUE
      RETURN
      END
      SUBROUTINE SPHAB
      INTEGER H
      REAL KN, LN
      DATA IEND/4HEND /
   19 FORMAT (F3.0, F7.3)
   20 FORMAT (6X,3F8.5,5F6.3,A4)
   22 FORMAT (3I7, F8.3, I5, F8.3, F10.2, 2X, F10.6)
   29 FORMAT (3X, F3.0, F7.3)
   30 FORMAT (3X, 3F9.4, 3X, 3F9.3,10X,F8.5,10X,F5.2)
   43 FORMAT(A4,I6, 2XI4, 2XI4, F8.2,F8.5)
   45 FORMAT ('1')
C  90 FORMAT (6XI4, 2XI4, 2XI4, F8.2,F8.5)
   90 FORMAT (6XI4, 2XI4, 2XI4, F8.2,F8.6)
      DIMENSION SPACE(31),FF(12),CHK(10)
      COMMON ICOM(6),SCF,B2, CARD(20),JPAGE,IT1,IT2
      DATA ICARD/4HCARD/
      DATA ITAPE/4HTAPE/
      DIMENSION ANGLE (19), ABSC (19)
      ITYPE=3
      WRITE (3, 45)
C     READ A, B, C, ALPHA, BETA, GAMMA, WAVELENGTH, SCALE FACTOR, 'CARD'
C     OR 'TAPE' FOR TYPE OF INPUT.
      READ (1, 20) A, B, C, ALFA, BETA, GAMMA,WAVEL,SCALE,ITYP
      WRITE (3, 30) A, B, C, ALFA, BETA, GAMMA,WAVEL,SCALE
      WAVEL=WAVEL/2.
      IF(ITYP.EQ.ICARD)ITYPE=1
      IF(ITYP.EQ.ITAPE)ITYPE=2
      DO 15 I = 1, 19
      READ (1, 19) ANGLE(I), ABSC(I)
C     READ 19 PAIRS OF ANGLE - ABSORPTION CORRECTION
   15 WRITE (3, 29) ANGLE(I), ABSC(I)
      CAL = COS(ALFA / 57.29578)
      CBE = COS(BETA / 57.29578)
      CGA = COS(GAMMA / 57.29578)
      CALL IMP2
      WRITE (3, 45)
C     READ H, K, L, F, WEIGHT
      GO TO(21,24,23),ITYPE
   24 REWIND IT1
      REWIND IT2
      READ(IT1)SPACE
      WRITE(IT2)SPACE
      READ(IT1)SPACE
      WRITE(IT2)SPACE
   18 READ(IT1)SPACE
      WRITE(IT2)SPACE
      IF(SPACE(1))18,17,18
   17 DO 222 KK=1,6
  222 SPACE(KK)=0.0
  100 READ(IT1)H,K,L,FOBS, WT,PIH,PIK,PIL,BCON,FF,CHK
      IF( H-999999)101,123,101
   21 READ (1,43)INN,H,K,L, FOBS, WT
C     AN 'END' CARD STARTING IN COL. 1 STOPS THE PROGRAM.
      IF(INN.EQ.IEND)GO TO 23
  101 CONTINUE
      XH = H
      XK = K
      XL = L
      HN = XH / A
      KN = XK / B
      LN = XL / C
      D = SQRT(1. / ((HN*(HN+KN*CAL*CBE+LN*CAL*CGA-HN*CAL*CAL-KN*CGA
     1-LN*CBE) + KN * ( KN+ HN*CAL*CBE+LN*CBE*CGA-HN*CGA-KN*CBE*CBE-LN*
     2CAL) + LN * ( LN + KN*CGA*CBE+HN*CAL*CGA-HN*CBE-KN*CAL-LN*CGA*CGA)
     3) / (1. + 2. * CAL * CBE * CGA - CAL*CAL - CBE*CBE - CGA*CGA)))
      THETA = (ASIN (WAVEL  /D)) * 57.29578
      IF(H.EQ.0.AND.K.EQ.0.AND.L.EQ.0)THETA=0.0
      THIN = (THETA + 7.5) / 5.
      I = THIN
      IF(I.EQ.1)I=2
      Y1 = ABSC(I-1)
      Y2 = ABSC(I)
      Y3 = ABSC(I+1)
      X1 = ANGLE(I-1)
      X2 = ANGLE(I)
      X3 = ANGLE(I+1)
      C1 = ((((Y3-Y1)/(X3-X1))-((Y2-Y1)/(X2-X1)))/(((X3**2-X1**2)/
     1 (X3-X1))-((X2**2-X1**2)/(X2-X1))))
      C2 = ((Y2-Y1)/(X2-X1)-(C1*(X2**2-X1**2)/(X2-X1)))
      C3 = Y3 - C1 * X3**2 - C2 * X3
      ABCORR = SQRT (C1 * THETA**2 + C2 * THETA + C3)
      FOBS = FOBS * ABCORR * SCALE
      WT = WT / (((ABCORR)**2)*SCALE**2)
      WRITE (3, 22) H, K, L, THETA, I, ABCORR, FOBS, WT
      WRITE(2,90)H,K,L,   FOBS, WT
      GO TO(201,202),ITYPE
  202 WRITE(IT2)H,K,L,FOBS,WT,PIH,PIK,PIL,BCON,FF,CHK
      GO TO 100
  201 CONTINUE
      GO TO 21
  123 KRK=999999
      WRITE(IT2)KRK,K,L,FOBS,WT,PIH,PIK,PIL,BCON,FF,CHK
      WRITE(IT2)KRK,SPACE
      KRK=IT2
      IT2=IT1
      IT1=KRK
      REWIND IT2
      REWIND IT1
   23 RETURN
      END
      SUBROUTINE THERMO(A,K)                                            THER0005
C    TESTS WHETHER MATRIX IS POSITIVE DEFINITE.                         THER0015
      DIMENSION A(1)                                                    THER0025
      XX=A(2)*A(3)-0.25*A(5)*A(5)                                       THER0030
      XXX=A(2)*A(3)*A(4)+0.25*(A(5)*A(6)*A(7)-A(3)*A(6)*A(6)-A(4)*A(5)* THER0035
     1A(5)-A(2)*A(7)*A(7))                                              THER0040
      K=K+1                                                             THER0045
      IF(A(2).GT.0.0.AND.XX.GT.0.0.AND.XXX.GT.0.0) K=0                  THER0050
      RETURN                                                            THER0055
      END                                                               THER0060
      SUBROUTINE FLIP(A)                                                FLIP0005
C    REORDERS ARRAY OF BETA'S.                                          FLIP0015
      DIMENSION A(1)                                                    FLIP0025
      C=A(4)                                                            FLIP0030
      A(4)=A(3)                                                         FLIP0035
      A(3)=C                                                            FLIP0040
      D=A(6)                                                            FLIP0045
      A(6)=A(5)                                                         FLIP0050
      A(5)=D                                                            FLIP0055
      RETURN                                                            FLIP0060
      END                                                               FLIP0065
      SUBROUTINE IMP2
	INTEGER*2 IGO(112)
   99 FORMAT(///)
      WRITE(3,99)
	DATA IGO/1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,
     1 19,20,21,22,23,24,25,26,27,1,2,3,4,5,6,7,8,9,10,11,12,
     1 13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,1,2,3,4,
     1 5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,
     1 26,27,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,
     1 19,20,21,22,23,24,25,26,27,15,2,3,15/
	TICK=SECNDS(T)
	ITICK=TICK
	T2=ITICK
	TS=TICK-T2
	TS=TS*100.
	IF(TS.LT.0.0)TS=TS*100
       ITS=TS
	IF(ITS.EQ.0)ITS=ITS+1
       IT=IGO(ITS)
	GO TO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,
     1 19,20,21,22,23,24,25,26,27),IT
1	WRITE(3,101)
  101 FORMAT (' IKEY(GOLDBERG)S WORTH IM'/' TOLD $SEVERAL MILLION'/' FIN
     1KLESTEIN(FRITZ)LIVES'/     ' AT THE RITZ WEAR'/' EARL & WILSON COL
     2LARS' //'               E.E.CUMMINGS')
      GO TO 9999
    2 WRITE(3,202)
      WRITE(3,203)
      WRITE(3,204)
  202 FORMAT( ' THE'/
     1'    SKY'/
     2'       WAS'/
     3' CAN DY LU'/
     4' MINOUS'/
     5'       EDIBLE'/
     6' SPRY'/
     7'     PINKS SHY'/
     8' LEMONS'/
     9' GREENS COO L CHOC')
  203 FORMAT(' OLATE'/
     1' S.'//
     2'  UN DER,'/
     3'  A LO'/
     4' CO'/
     5' MO'/
     6'   TIVE  S POUT'/
     7'               ING'/
     8'                  VI'/
     9'                  O')
  204 FORMAT('                  LETS'//10X,'E.E.CUMMINGS')
      GO TO 9999
    3 WRITE(3,301)
  301 FORMAT(' THE DOORS WERE CEDAR'/
     1' AND THE PANELS STRIPS OF GOLD'/
     2' AND THE GIRLS WERE GOLDEN GIRLS'/
     3' AND THE PANELS READ AND THE GIRLS CHANTED:'/
     4'          WE ARE THE GREATEST CITY,'/
     5'          THE GREATEST NATION:'/
     6'          NOTHING LIKE US EVER WAS'//
     7'                              C.SANDBURG')
      GO TO 9999
    4 WRITE (3,401)
  401 FORMAT  (' THUS THE THING STANDS; THE LABOR AND THE GAMES GO ON--
     1'/' WHAT FOR?  WHAT FOR?--AM I A GOD THAT I SHOULD KNOW?'/
     2 ' MEN LIVE IN PEACE AND HAPPINESS; MEN LIVE IN HORROR '/
     3 ' AND DIE HOWLING.  DO YOU THINK THE BLITH SUN'/
     4 ' IS IGNORANT THAT THE BLACK WASTE AND BEGGARLY BLINDNESS TRAIL H
     5IM LIKE HOUNDS,'/' AND WILL HAVE HIM AT LAST?  HE WILL BE STRANGLE
     6D'/' AMONG HIS DEAD SATELLITES, REMEMBERING MAGNIFICENCE. '//
     7'                 R. JEFFERS  '    )
      GO TO 9999
    5 WRITE (3,501)
  501 FORMAT (' I SAW A MAN PURSUING THE HORIZON;'/
     1' ROUND AND ROUND THEY SPED.'/
     2 ' I WAS DISTURBED AT THIS;'/
     3 ' I ACCOSTED THE MAN.'/
     4 ' "IT IS FUTILE," I SAID'/
     5 ' "YOU CAN NEVER --"'/
     6 ' "YOU LIE," HE CRIED,'/
     7 ' AND RAN ON.'//
     8'                   S. CRANE')
      GO TO 9999
    6 WRITE(3,601)
  601 FORMAT('   POEM'///' AS THE CAT'/' CLIMBED OVER'/' THE TOP OF'/ /
     1' THE JAMCLOSET' /' FIRST THE RIGHT' /' FOREFOOT'/
     2/' CAREFULLY' / ' THEN THE HIND' / ' STEPPED DOWN'//
     3' INTO THE PIT OF'/' THE EMPTY'/' FLOWERPOT'///'     WILLIAM CARLO
     4S WILLIAMS')
      RETURN
    7 WRITE(3,701)
  701 FORMAT(' I SHOULD HAVE BEEN A PAIR OF RAGGED CLAWS'/
     1' SCUTTLING ACROSS THE FLOORS OF SILENT SEAS.'//20X,'T. S. ELIOT')
      GO TO 9999
    8 WRITE(3,801)
      WRITE(3,802)
      WRITE(3,803)
  801 FORMAT ('  A NEGRO WOMAN'//
     1'     CARRYING A BUNCH OF MARIGOLDS'/
     2'               WRAPPED'/
     3'                         IN AN OLD NEWSPAPER:'/
     4'     SHE CARRIES THEM UPRIGHT,'/
     5'               BAREHEADED,'/
     6'                         THE BULK'/
     7'     OF HER THIGHS'/
     8'               CAUSING HER TO WADDLE'/
     9'                         AS SHE WALKS'  )
  802  FORMAT('     LOOKING INTO'/
     1'               THE STORE WINDOW WHICH SHE PASSES'/
     2'                         ON HER WAY.'/
     3'     WHAT IS SHE'/
     4'               BUT AN AMBASSADOR'/
     5'                         FROM ANOTHER WORLD'/
     6'     A WORLD OF PRETTY MARIGOLDS'/
     7'               OF TWO SHADES'/
     8'                         WHICH SHE ANNOUNCES'/
     9'     NOT KNOWING WHAT SHE DOES' )
  803 FORMAT('               OTHER'/
     1'                         THAN WALK THE STREETS'/
     2'     HOLDING THE FLOWERS UPRIGHT'/
     3'               AS A TORCH'/
     4'                         SO EARLY IN THE MORNING.'//
     520X,'WILLIAM CARLOS WILLIAMS')
      GO TO 9999
    9 WRITE(3,901)
  901 FORMAT(' BY THE PRICKING OF MY THUMBS'/
     1' SOMETHING WICKED THIS WAY COMES.'//20X,'W. SHAKESPEARE')
      GO TO 9999
   10 WRITE(3,1001)
 1001 FORMAT(' A POLITICIAN IS AN ARSE UPON'/
     1' WHICH EVERYONE HAS SAT EXCEPT A MAN',//20X,'E E CUMMINGS')
      GO TO 9999
   11 WRITE(3,1101)
 1101 FORMAT(    '   TO A POOR OLD WOMAN'/ /
     1' MUNCHING ON A PLUM ON'/
     2' THE STREET IN A PAPER BAG'/
     3' OF THEM IN HER HAND'//
     4' THEY TASTE GOOD TO HER'/
     5' THEY TASTE GOOD'/
     6' TO HER. THEY TASTE'/
     7' GOOD TO HER'//
     8' YOU CAN SEE IT BY'/
     9' THE WAY SHE GIVES HERSELF'/
     1' TO THE ONE HALF'/
     2' SUCKED OUT IN HER HAND'//
     3' COMFORTED'/
     4' A SOLACE OF RIPE PLUMS'/
     5' SEEMING TO FILL THE AIR'/
     6' THEY TASTE GOOD TO HER'//5X,'WILLIAM CARLOS WILLIAMS')
      GO TO 9999
   12 WRITE(3,1201)
 1201 FORMAT(' SO MUCH DEPENDS'/
     1' UPON'/
     2' A RED WHEEL'/
     3' BARROW'/
     4' GLAZED WITH RAIN'/
     5' WATER'/
     6' BESIDE THE WHITE'/
     7' CHICKENS'//5X,'WILLIAM CARLOS WILLIAMS')
      GO TO 9999
   13 WRITE(3,1301)
 1301 FORMAT(' WHEN GOD DECIDED TO INVENT'/
     1' EVERYTHING HE TOOK ONE'/
     2' BREATH BIGGER THAN A CIRCUSTENT'/
     3' AND EVERYTHING BEGAN'//
     4' WHEN MAN DETERMINED TO DESTROY'/
     5' HIMSELF HE PICKED THE WAS'/
     6' OF SHALL AND FINDING ONLY WHY'/
     7' SMASHED IT INTO BECAUSE'//5X,'E E CUMMINGS')
      GO TO 9999
   14 WRITE(3,1401)
 1401 FORMAT(' LOVE IS A PLACE'/
     1' & THROUGH THIS PLACE OF'/
     2' LOVE MOVE'/
     3' (WITH BRIGHTNESS OF PEACE)'/
     4' ALL PLACES'//
     5' YES IS A WORLD'/
     6' & IN THIS WORLD OF'/
     7' YES LIVE'/
     8' (SKILFULLY CURLED)'/
     9' ALL WORLDS'//'    E E CUMMINGS')
      GO TO 9999
   15 WRITE(3,1015)
 1015 FORMAT(' THE LOCUST TREE IN FLOWER'///
     1'     AMONG'/'     OF'/'     GREEN'//
     2'     STIFF'/'     OLD'/'     BRIGHT'//
     3'     BROKEN'/'     BRANCH'/'     COME'//
     4'     WHITE '/'     SWEET'/'     MAY'/
     5/'     AGAIN'///'  WILLIAM CARLOS WILLIAMS')
      GO TO 9999
   16 WRITE(3,1016)
 1016 FORMAT('0A GOOD-TALKING CANDLE'/
     1'0I HAD A GOOD-TALKING CANDLE'/
     2' LAST NIGHT IN MY BEDROOM.'/
     3'0I WAS VERY TIRED BUT I WANTED'/
     4' SOMEBODY TO BE WITH ME,'/
     5'    SO I LIT A CANDLE'/
     6'0 AND LISTENED TO ITS COMFORTABLE'/
     7' VOICE OF LIGHT UNTIL I WAS ASLEEP.'///
     810X,'RICHARD BRAUTIGAN' )
      GO TO 9999
   17 WRITE(3,1017)
 1017 FORMAT('0CATSUP BOTTLE,'/
     1' CATSUP BOTTLE,'/
     213H NONE'LL COME ,/
     3' AND THEN A LOT',1H','LL.'//10X,'O. NASH')
      GO TO 9999
   18 WRITE(3,1018)
 1018 FORMAT('    PROLETARIAN PROTRAIT'///
     1' A BIG YOUNG BAREHEADED WOMAN'/' IN AN APRON'//
     2' HER HAIR SLICKED BACK STANDING'/' ON THE STREET'//
     3' ONE STOCKINGED FOOT TOEING'/' THE SIDEWALK'//
     4' HER SHOE IN HER HAND. LOOKING'/' INTENTLEY INTO IT'//
     5' SHE PULLS OUT THE PAPER INSOLE'/' TO FIND THE NAIL'//
     6' THAT HAS BEEN HURTING HER'///'   WILLIAM CARLOS WILLIAMS')
      GO TO 9999
   19 WRITE(3,1019)
 1019 FORMAT('  BETWEEN WALLS'///
     1' THE BACK WINGS'/' OF THE'//
     2' HOSPITAL WHERE'/' NOTHING'//
     3' WILL GROW LIE'/' CINDERS'//
     4' IN WHICH SHINE'/' THE BROKEN'//
     5' PIECES OF A GREEN'/' BOTTLE'///
     6 '  WILLIAM CARLOS WILLIAMS')
      GO TO 9999
   20 WRITE(3,1020)
 1020 FORMAT(' YES IS A PLEASANT COUNTRY:'/' IF',1H','S WINTRY'/
     1' (MY LOVELY)'/' LET',1H','S OPEN THE YEAR'//
     2' BOTH IS THE VERY WEATHER'/' (NOT EITHER)'//
     3' MY TREASURE,'/' WHEN VIOLETS APPEAR'//
     4' LOVE IS A DEEPER SEASON'/' THAN REASON;'//
     5' MY SWEET ONE'/' (AND APRIL',1H','S WHERE WE',1H','RE)')
      GO TO 9999
21    WRITE(3,1021)
1021  FORMAT('          IMPEACHMENT WITH HONOR')
      GO TO 9999
22     WRITE(3,1022)
1022  FORMAT('     *****UPPITY WOMEN UNITE*****'//
     1'  THIS MESSAGE IS BROUGHT TO YOU'/
     2'  COURTESY OF THE JEAN WESTPHAL',        /
     3'  FOR UPPITY WOMEN FUND'/
     4'  ALL CONTRIBUTIONS GRATEFULLY ACCEPTED')
      GO TO 9999
   23 WRITE(3,1023)
 1023 FORMAT('0GOD, IN HIS WISDOM, MADE THE FLY,'/' AND THEN FORGOT'
     1' TO TELL US WHY.'//5X,'O. NASH')
      GO TO 9999
   24 WRITE(3,1024)
 1024 FORMAT('0ISN',1H','T LIFE BEAUTIFUL?'/
     1' ISN',1H','T LIFE GAY?'/
     2' ISN',1H','T LIFE THE PERFECT THING'/
     3'     TO PASS THE TIME AWAY.'//8X,'MASON WILLIAMS')
      GO TO 9999
   25 WRITE(3,1025)
 1025 FORMAT('0AS YOU TUMBLE ON THROUGH LIFE'/
     1' BROTHER, WHATEVER BE YOUR GOAL,'/
     2' KEEP YOUR EYE UPON THE DOUGHNUT'/
     3' AND NOT UPON THE HOLE'//10X,'FROM SDS')
      GO TO 9999
   26 WRITE(3,1026)
 1026 FORMAT('0     HOW DOES ONE EXPECT A MACHINE TO KNOW THAT, IF A YOU
     1NG MAN OF'/' TWENTY CAN GATHER FIVE POUNDS OF BLACKBERRIES A DAY A
     2ND A GIRL OF'/' EIGHTEEN CAN GATHER THREE, ONE CANNOT ASSUME THAT
     3THEY WILL GATHER'/' EIGHT POUNDS A DAY BETWEEN THEM?'//
     420X,'LORD BOWDEN')
 9999 RETURN
27	RETURN
      END
