	SUBROUTINE GRAR01 (I0,J0,I1,J1)
C-----------------------------------------------------------------------
C GRPCKG (internal routine, ARGS): draw a line segment.
C
C Arguments:
C
C I0,J0 (integer*2, input): the column and row numbers of the starting
C	point.
C I1,J1 (integer*2, input): the column and row numbers of the end point.
C
C Note: the arguments are specified as integer*2, but (on the VAX at
C least) integer*4 values may be used. The values should be in the
C range defined by the hardware: (0...511).
C
C (11-Apr-1983)
C-----------------------------------------------------------------------
	IMPLICIT INTEGER*2 (A-Z)
	INTEGER*2 GRNLBF(4)
	INCLUDE 'GRPCKG1.INC'
C
	CLIP511(X) = X .AND. '1FF'X
C
	IC0 = CLIP511(I0)
	JC0 = CLIP511(J0)
	IC1 = CLIP511(I1)
	JC1 = CLIP511(J1)
C
	GRNLBF(1) = IOR(IC0,'C000'X)
	GRNLBF(2) = IOR(JC0,'A000'X)
	GRNLBF(3) = IOR(IC1,'C000'X)
	GRNLBF(4) = IOR(JC1,'E000'X)
	CALL GRAR02(GRNLBF,4,%VAL(GRPBAD(GRCIDE)))
	RETURN
	END
	SUBROUTINE GRAR02(INSTR,N,BUFFER)
C-----------------------------------------------------------------------
C	GRPCKG (ARGS) : transfer N 16-bit words to output buffer
C	from INSTR(1...N)
C-----------------------------------------------------------------------
	INTEGER*2 INSTR(N)
	INTEGER*2 BUFFER(*)
	INCLUDE 'GRPCKG1.INC'
C
	DO I=1,N
	    IF (GRBHWM(GRCIDE).GE.GRPBXD(GRCIDE)-22) CALL 
     1		GRAR03(%VAL(GRPBAD(GRCIDE)))
	    GRBHWM(GRCIDE) = GRBHWM(GRCIDE)+2
	    BUFFER(GRBHWM(GRCIDE)/2) = INSTR(I)
	END DO
	RETURN
	END
	SUBROUTINE GRAR03(BUFFER)
C-----------------------------------------------------------------------
C	GRPCKG (ARGS): flush buffer contents.  BUFFER is passed as
C	an argument because it is a dynamic array.
C-----------------------------------------------------------------------
	INTEGER*2 BUFFER(*)
C
	INCLUDE 'GRPCKG1.INC'
C	INCLUDE '($IODEF)'
	EXTERNAL IO$_WRITEVBLK
	INCLUDE '($SSDEF)'
	
C
	INTEGER SYS$QIOW
C
	INTEGER RESULT
	INTEGER IOSB(2)
	INTEGER*2 STBC(2), STATUS, COUNT
	EQUIVALENCE (STBC, IOSB(1)), (STATUS, STBC(1)), (COUNT, STBC(2))
C
	N = GRBHWM(GRCIDE)/2
	GRBHWM(GRCIDE) = 0
	IF (N.LT.1) RETURN
	INDEX=1
        IHEAD=INDEX+N
	ITO=8
C  CHECK IF ARRAY STARTS AT LAST WORD IN PAGE
	IADR=IAND(%LOC(BUFFER),'1FE'X)
C  SEND FIRST WORD OUT SEPARATELY IF THIS HAPPENS
	IF(IADR.EQ.'1FE'X) THEN
	TYPE *,'BUFFER STARTS AT END OF PAGE'
	    RESULT = SYS$QIOW(,%VAL(GRUNIT(GRCIDE)),
     1		IO$_WRITEVBLK,IOSB,,,
     2		buffer(ihead),%VAL(4),
     3		BUFFER,%val(1),%VAL(ITO),)
	    IF(RESULT.NE.SYS$_NORMAL) GOTO 998
	    IF(STATUS.NE.SYS$_NORMAL) GOTO 999
	    INDEX=INDEX+1
	    N=N-1
	END IF
	RESULT = SYS$QIOW(,%VAL(GRUNIT(GRCIDE)),
     1		  IO$_WRITEVBLK,IOSB,,,
     2		 BUFFER(IHEAD),%VAL(4),
     3		 BUFFER(INDEX),%VAL(N),%VAL(ITO),)
	IF (RESULT.NE.SS$_NORMAL) THEN
  998	    CALL GRGMSG(RESULT)
	    CALL GRQUIT('SYS$QIOW failure writing to ARGS')
	END IF
  	IF (STATUS.NE.SS$_NORMAL) THEN
  999	    RESULT = STATUS
	    CALL GRGMSG(RESULT)
	    CALL GRQUIT('SYS$QIOW failure writing to ARGS')
	END IF
	RETURN
	END
	SUBROUTINE GRAR10
C-----------------------------------------------------------------------
C GRPCKG (internal routine, ARGS): advance the plotting area to a 
C new page. This routine is called for ARGS devices by GRPAGE to
C reinitialize the display.
C
C (11-Apr-1983)
C-----------------------------------------------------------------------
	INCLUDE 'GRPCKG1.INC'
	INCLUDE '($SSDEF)'
C
	INTEGER SYS$SETIMR
	INTEGER SYS$WAITFR

	EXTERNAL IO$_WRITEVBLK
	LOGICAL RESET
	INTEGER*2 IOSB(4),IVSR(3)
	DATA RESET/.TRUE./
	INTEGER*2 IRED,IGRN,IBLU
C
C
	INTEGER UNIT
	INTEGER I
	INTEGER RESULT
	INTEGER*2 GRNLBF(257),GRRED(8),GRBLUE(8),GRGREEN(8)
	BYTE TWOBYT(2)
	EQUIVALENCE (TWOBYT,J)
C
	DATA GRRED  /0,180,255,0,0,0,200,200/
	DATA GRGREEN/0,180,0,255,0,200,0,200/
	DATA GRBLUE /0,180,0,0,255,200,200,0/
C
C   Cancel any outstanding I/O requests
C
	CALL SYS$CANCEL(%val(GRUNIT(GRCIDE)))
	CALL SYS$WAITFR()
C
C   Interface reset
C
	IF(.NOT.RESET) THEN
	    I=1
	    IOCODE=IOR(%LOC(IO$_WRITEVBLK),'40'X)
	    RESULT=SYS$QIOW(,%VAL(GRUNIT(GRCIDE)),
     *       %VAL(IOCODE),IOSB,,,I,%VAL(I),,,,)
	END IF
C
C   Interface reset and ARGS reset
C
	IF(RESET) THEN
	    I=1
	    IOCODE=IOR(%LOC(IO$_WRITEVBLK),'C0'X)
	    RESULT=SYS$QIOW(,%VAL(GRUNIT(GRCIDE)),
     *       %VAL(IOCODE),IOSB,,,I,%VAL(I),,,,)
	END IF
C
C   Reset GSW to drawing mode,size and direction all zero, autoincrement on,
C   background overlay off, backwash off, cursor scroll disabled
C
	GRNLBF(1)='0E00'X		! LOAD status word
	GRNLBF(2)='2000'X
	CALL GRAR02(GRNLBF,2,%val(GRPBAD(GRCIDE)))
C
C   Reset VSR to display graphics and overlay
C
	GRNLBF(1)='2401'X
	GRNLBF(2)='01C0'X
	GRNLBF(3)=0
	GRNLBF(4)='0007'X
	CALL GRAR02(GRNLBF,4,%val(GRPBAD(GRCIDE)))
C
C   Set origin TO 0,0
C
	GRNLBF(1)='1000'X		! X ORIGIN TO 0
	GRNLBF(2)=0
	GRNLBF(3)='1100'X		! Y ORIGIN TO 0
	GRNLBF(4)=0
C
C   Put pen at origin
C
	GRNLBF(5)='C000'X
	GRNLBF(6)='A000'X
C
C   Unzoom
C
	GRNLBF(7)='5000'X
	GRNLBF(8)=0
	CALL GRAR02(GRNLBF,8,%val(GRPBAD(GRCIDE)))
C
C   No scroll
C
	GRNLBF(1)='3901'X
	GRNLBF(2)='FFFF'X
	GRNLBF(3)=0
	GRNLBF(4)='3B01'X
	GRNLBF(5)='FFFF'X
	GRNLBF(6)=0
	CALL GRAR02(GRNLBF,6,%val(GRPBAD(GRCIDE)))
C
C   Set write enable for lower 8 bit planes only
C
	GRNLBF(1)='2D01'X
	GRNLBF(2)='00FF'X
C
C   Turn on all planes
C
	GRNLBF(3)='2B01'X
	GRNLBF(4)='FFFF'X
	CALL GRAR02(GRNLBF,4,%val(GRPBAD(GRCIDE)))
C
C   Turn off lamps
C
	GRNLBF(1)='3C40'X
	GRNLBF(2)='3C45'X
	GRNLBF(3)=0
	CALL GRAR02(GRNLBF,3,%val(GRPBAD(GRCIDE)))
C
C   Set colour table
C
	INDEX=2
	NN=0
	DO INTN=1,4
	    LI=INTN-1
	    DO ICLR=1,8
		IRED=LI*GRRED(ICLR)/3
		IGRN=LI*GRGREEN(ICLR)/3
		IBLU=LI*GRBLUE(ICLR)/3
		NN=NN+1
		INDEX=INDEX+1
		J=IOR(ISHFT(IGRN,8),IRED)
		GRNLBF(INDEX)=J
		INDEX=INDEX+1
		J=IOR('FF00'X,IBLU)
		GRNLBF(INDEX)=J
	    END DO
	END DO
	GRNLBF(1)=IOR(NN-1,'1800'X)
	GRNLBF(2)=0
	CALL GRAR02(GRNLBF,INDEX,%VAL(GRPBAD(GRCIDE)))
C
C  Set default color
C
	GRNLBF(1)='2901'X
	GRNLBF(2)=GRCCOL(GRCIDE)+8*GRINTN(GRCIDE)
	CALL GRAR02(GRNLBF,2,%val(GRPBAD(GRCIDE)))
C
C  Flush ARGS Buffer
C
	CALL GRAR03(%val(GRPBAD(GRCIDE)))
C
	RETURN
	END
	SUBROUTINE GRAREA (IDENT,X0,Y0,XSIZE,YSIZE)
C-----------------------------------------------------------------------
C GRPCKG: Define a rectangular window in the current plotting area. All
C graphics (except characters written with GRCHAR) will be blanked
C outside this window.  The default window is the full plotting area
C defined by default or by GRSETS.
C
C Arguments:
C
C IDENT (input, integer): the plot identifier, returned by GROPEN.
C X0, Y0 (input, real): the lower left corner of the window, in absolute
C	device coordinates.
C XSIZE, YSIZE (input, real): width and height of the window in absolute
C	coordinates; if either is negative, the window will be reset to
C	the full plotting area.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE 'GRPCKG1.INC'
	INTEGER IDENT
	REAL X0, Y0, XSIZE, YSIZE
C
	CALL GRSELECT(IDENT)
C
	IF ((XSIZE.LE.0.0) .OR. (YSIZE.LE.0.0)) THEN
	    GRXMIN(IDENT) = 0
	    GRXMAX(IDENT) = GRXMXA(IDENT)
	    GRYMIN(IDENT) = 0
	    GRYMAX(IDENT) = GRYMXA(IDENT)
	ELSE
	    GRXMIN(IDENT) = MAX(NINT(X0),0)
	    GRYMIN(IDENT) = MAX(NINT(Y0),0)
	    GRXMAX(IDENT) = MIN(NINT(XSIZE+X0),GRXMXA(IDENT))
	    GRYMAX(IDENT) = MIN(NINT(YSIZE+Y0),GRYMXA(IDENT))
	END IF
	RETURN
	END
	SUBROUTINE GRCHAR (IDENT,CENTER,ORIENT,ABSXY,X0,Y0,STRING)
C-----------------------------------------------------------------------
C GRPCKG: Draw a string of characters. The plot is not windowed
C in the current subarea, but in the full plotting area.
C
C Arguments:
C
C IDENT (input, integer): plot identifier, as returned by GROPEN.
C CENTER (input, logical): if .TRUE., the first character of the string
C	is centered at (X0,Y0); otherwise the bottom left corner of the
C	first character is placed at (X0,Y0).
C ORIENT (input, real): the angle in degrees that the string is to make 
C	with the horizontal, increasing anticlockwise.
C ABSXY (input, logical): if .TRUE., (X0,Y0) are absolute device
C	coordinates; otherwise they are world coordinates (the scaling
C	transformation is applied).
C X0, Y0 (input, real): position of first character (see CENTER).
C STRING (input, character): the string of ASCII characters; control
C	characters 0-20 have special representations; all other
C	non-graphic characters are plotted as blank spaces.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	CHARACTER*(*) STRING
	INTEGER  IDENT
	LOGICAL  ABSXY, CENTER
	REAL     ORIENT, X0, Y0
C
	CALL GRSELECT(IDENT)
	CALL GRCHR0(.FALSE., CENTER, ORIENT, ABSXY, X0, Y0, STRING)
	RETURN
	END
	INTEGER FUNCTION GRCHKT (TERM)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Determine whether a device is a terminal.
C
C Argument:
C
C TERM (input, character): the name of the device according to VMS
C	conventions, ie a physical device name (_TTA4:) or a logical
C	name.
C
C Returns:
C
C GRCHKT (integer): a TRUE value (odd) if TERM is a terminal device,
C	a FALSE value otherwise.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT  NONE
	INTEGER   DC$_TERM, DVI$_DEVCLASS, DVI$_DEVTYP, DVI$_DEVNAM
	PARAMETER (DC$_TERM=66)
	PARAMETER (DVI$_DEVCLASS=4)
	PARAMETER (DVI$_DEVTYP=6)
	PARAMETER (DVI$_DEVNAM=32)
C
	CHARACTER*(*) TERM
	INTEGER  DEVCLASS, IER, IOSB(2), ITMLIST(4), L, SYS$GETDVI
	INTEGER  SYS$WAITFR
C
C		Find device class of TERM
C
	DO L=LEN(TERM),1,-1
	    IF (TERM(L:L).NE.' ') GOTO 10
	END DO
	L = 1
   10	ITMLIST(1) = DVI$_DEVCLASS*2**16 + 4
	ITMLIST(2) = %LOC(DEVCLASS)
	ITMLIST(3) = 0
	ITMLIST(4) = 0
	IER = SYS$GETDVI(%VAL(0),,TERM(:L),ITMLIST,IOSB,,,)
	IF (.NOT.IER) THEN
		GRCHKT = IER
		RETURN
	END IF
	IER = SYS$WAITFR(%VAL(0))
	IF (.NOT.IER) THEN
		GRCHKT = IER
		RETURN
	END IF
	IF (.NOT.IOSB(1)) THEN
	    GRCHKT = IOSB(1)
	ELSE IF (DEVCLASS.EQ.DC$_TERM) THEN
	    GRCHKT = 1
	ELSE
	    GRCHKT = 4828 ! "input device is not a terminal"
	END IF
C
	RETURN
	END
	SUBROUTINE GRCHR0 (WINDOW,CENTER,ORIENT,ABSXY,X0,Y0,STRING)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Support routine for GRCHAR and GRMARK.
C Draw a string of characters.
C
C Arguments:
C
C WINDOW (input, logical): if .TRUE., the plot is windowed in the
C	current window.
C CENTER (input, logical): if .TRUE., the first character of the string
C	is centered at (X0,Y0); otherwise the bottom left corner of the
C	first character is placed at (X0,Y0).
C ORIENT (input, real): the angle in degrees that the string is to make 
C	with the horizontal, increasing anticlockwise.
C ABSXY (input, logical): if .TRUE., (X0,Y0) are absolute device
C	coordinates; otherwise they are world coordinates (the scaling
C	transformation is applied).
C X0, Y0 (input, real): position of first character (see CENTER).
C STRING (input, character): the string of ASCII characters; control
C	characters 0-20 have special representations; all other
C	non-graphic characters are plotted as blank spaces.
C
C (1-Mar-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INTEGER  DOT, MOVE, VECSIZ
	REAL     PI
	PARAMETER (DOT = 3)
	PARAMETER (MOVE = 2)
	PARAMETER (VECSIZ = 30)
	PARAMETER (PI = 3.14159265)
	INCLUDE  'GRPCKG1.INC'
	CHARACTER*(*) STRING
	CHARACTER*1   NEXT
	INTEGER  XMIN, XMAX, YMIN, YMAX
	INTEGER  MODE,LSTYLE,LEVEL
	INTEGER  I, J, L, CHAR, POINTS
	LOGICAL  ABSXY, CENTER, MORE, WINDOW
	REAL     ORIENT, X0, Y0
	REAL     ANGLE, FACTOR, BASE, FAC
	REAL     COSA, SINA
	REAL     DX, DY, XORG, YORG
	REAL     XC(VECSIZ), YC(VECSIZ), XT, YT
C
	IF (LEN(STRING).LE.0) RETURN
C
C		Compute scaling and orientation
C
	CALL GRINQLS(LSTYLE)
	CALL GRSETLS(1)
	ANGLE = (AMOD(ORIENT, 360.0) / 180.0) * PI
	FACTOR = GRCFAC(GRCIDE)
	COSA = FACTOR * COS(ANGLE)
	SINA = FACTOR * SIN(ANGLE)
	DX = GRCXSP * COSA
	DY = GRCXSP * SINA
	CALL GRTXY0(ABSXY, X0, Y0, XORG, YORG)
	IF (.NOT.WINDOW) THEN
	    XMIN = GRXMIN(GRCIDE)
	    XMAX = GRXMAX(GRCIDE)
	    YMIN = GRYMIN(GRCIDE)
	    YMAX = GRYMAX(GRCIDE)
	    CALL GRAREA(GRCIDE, 0.0, 0.0, 0.0, 0.0)
	END IF
C
C		Plot the string of characters
C
	MODE = MOVE
	BASE = 0.0
	FAC = 1.0
	I = 1
	LEVEL = 0
	L = LEN(STRING)
	DO WHILE (I.LE.L)
	  IF (I.LT.L .AND. STRING(I:I).EQ.'\') THEN
		CALL STR$UPCASE(NEXT,STRING(I+1:I+1))
		IF (NEXT.EQ.'U') THEN
		    LEVEL = LEVEL+1
		    BASE = BASE + 4.0*FAC
		    FAC = 0.6**IABS(LEVEL)
		    I = I+2
		ELSE IF (NEXT.EQ.'D') THEN
		    LEVEL = LEVEL-1
		    FAC = 0.6**IABS(LEVEL)
		    BASE = BASE - 4.0*FAC
		    I = I+2
		ELSE
		    I = I+1
		END IF
	  ELSE
	    CHAR = ICHAR(STRING(I:I))
	    IF (CHAR.GT.127 .OR. CHAR.LT.0) CHAR = ICHAR(' ')
	    MORE = .TRUE.
	    DO WHILE (MORE)
		CALL GRGTC0(CHAR, CENTER, POINTS, XC, YC, MORE)
		DO J=1,POINTS
                    XT = XC(J)*FAC
                    YT = YC(J)*FAC + BASE
                    XC(J) = XORG + COSA * XT - SINA * YT
                    YC(J) = YORG + SINA * XT + COSA * YT
		END DO
		IF (POINTS.EQ.1) MODE = DOT
		IF (POINTS.GT.0) CALL GRVCT0(MODE,.TRUE.,POINTS,XC,YC)
		IF (POINTS.EQ.1) MODE = MOVE
	    END DO
	    XORG = XORG + DX*FAC
	    YORG = YORG + DY*FAC
	    I = I+1
	  END IF
	END DO
C
C		Clean up and return
C
	IF (.NOT.WINDOW) THEN
	    GRXMIN(GRCIDE) = XMIN
	    GRXMAX(GRCIDE) = XMAX
	    GRYMIN(GRCIDE) = YMIN
	    GRYMAX(GRCIDE) = YMAX
	END IF
	CALL GRSETLS(LSTYLE)
	RETURN
	END
	SUBROUTINE GRCHSZ (IDENT,XSIZE,YSIZE,XSPACE,YSPACE)
C-----------------------------------------------------------------------
C GRPCKG: Obtain the default character attributes.
C
C Arguments:
C
C IDENT (input, integer): the plot identifier, returned by GROPEN.
C XSIZE, YSIZE (output, real): the default character size 
C	(absolute device units).
C XSPACE, YSPACE (output, real): the default character spacing
C	(absolute units); XSPACE is the distance between the lower left
C	corners of adjacent characters in a plotted string; YSPACE
C	is the corresponding vertical spacing.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  IDENT
	REAL     FACTOR, XSIZE, YSIZE, XSPACE, YSPACE
C
	CALL GRSELECT(IDENT)
	FACTOR = GRCSCL(IDENT)
	XSIZE = GRCXSZ * FACTOR
	YSIZE = GRCYSZ * FACTOR
	XSPACE = GRCXSP * FACTOR
	YSPACE = GRCYSP * FACTOR
	RETURN
	END
	SUBROUTINE GRCLIP (X,Y,XMIN,XMAX,YMIN,YMAX,C)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): support routine for the clipping algorithm;
C called from GRLIN0 only. C is a 4 bit code indicating the relationship
C between point (X,Y) and the window boundaries; 0 implies the point is
C within the window.
C
C Arguments:
C
C (11-Feb-1983)
C-----------------------------------------------------------------------
	INTEGER X,Y,XMIN,XMAX,YMIN,YMAX
	BYTE C
C
	C = 0
	IF (X.LT.XMIN) THEN
	    C = 1
	ELSE IF (X.GT.XMAX) THEN
	    C = 2
	END IF
	IF (Y.LT.YMIN) THEN
	    C = C+4
	ELSE IF (Y.GT.YMAX) THEN
	    C = C+8
	END IF
	RETURN
	END
	SUBROUTINE GRCLOS
C-----------------------------------------------------------------------
C GRPCKG: Close the open plot on the current device. Any pending output
C is sent to the device, the device is released for other users or the
C disk file is closed, and no further plotting is allowed on the device
C without a new call to GROPEN.  
C
C Arguments: none.
C
C (1-Jun-1984)
C 17-Jul-1984 - ignore call if plot is not open [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  BUFSIZ, LIB$FREE_LUN, LIB$FREE_VM, RESULT
	INTEGER  SYS$DASSGN
	BYTE CR,LF
	PARAMETER (CR=13,LF=10)
C
C		Check a plot is open.
C
	IF (GRCIDE.LT.1) RETURN
C
C		This plot identifier is no longer in use. Note
C		that this assignment is made at the beginning of
C		GRCLOS, to prevent recursive execution of GRCLOS
C		by the exit handler (GREXIT).
C
	GRINIT(GRCIDE) = .FALSE.
C
C		Flush the buffer
C
c      write(3,99)grctyp,tek10,tek14
	CALL GRTERM
99     format('   in grclos, grctyp=',I5,' tek10=',I5,'  tek14=',
     + I5)
	IF (GRCTYP.EQ.GMFILE) THEN
	    IF (GRPLTD(GRCIDE)) 
     1	    CALL GRMF02(1,'9100'X,%VAL(GRPBAD(GRCIDE)))
	    CALL GRMF02(1,'8100'X,%VAL(GRPBAD(GRCIDE)))
	    CALL GRMF03(%VAL(GRPBAD(GRCIDE)))
	END IF
C
C		Copy the frame-buffer to the output device (printer
C		plots), and deallocate the dynamically-allocated
C		virtual memory.
C
	IF (GRCTYP.EQ.PRTX .OR. GRCTYP.EQ.TRILOG .OR. GRCTYP.EQ.VERS )
     1       THEN
	    BUFSIZ = GRPBXD(GRCIDE) * GRPBYD(GRCIDE)
c     WRITE(3,100)BUFSIZ,GRPBXD(GRCIDE),GRPBYD(GRCIDE)
100   FORMAT('  IN GRCLOS BUFSIZ=',I10,' GRPBXD=',I10,' GRPBYD=',I10)
	    IF (GRPLTD(GRCIDE)) THEN
		CALL GRPR03(GRPBXD(GRCIDE), GRPBYD(GRCIDE),
     1			    %VAL(GRPBAD(GRCIDE)) )
		GRPCNT(GRCIDE) = GRPCNT(GRCIDE) + 1
		IF (GRCTYP.EQ.VERS) THEN
		    WRITE (GRUNIT(GRCIDE)) CR,LF
		END IF
	    END IF
	ELSE IF (GRCTYP.EQ.TEK10 .OR. GRCTYP.EQ.TEK14 .OR.
     1		 GRCTYP.EQ.RETRO .OR. GRCTYP.EQ.ID100) THEN
	    BUFSIZ = GRTBSZ
	ELSE IF (GRCTYP.EQ.GRINL .OR. GRCTYP.EQ.ARGS) THEN
	    BUFSIZ = GRGBSZ
	ELSE IF (GRCTYP.EQ.VT125) THEN
	    BUFSIZ = GRVBSZ
	ELSE IF (GRCTYP.EQ.GMFILE) THEN
	    BUFSIZ = GRFBSZ
        ELSE IF (GRCTYP.EQ.LASER) THEN
                   WRITE(GRUNIT(GRCIDE),'(A)')'^IGE^-'
                   WRITE(GRUNIT(GRCIDE),'(A)')'^-^PN^-'
          BUFSIZ = GRPBXD(GRCIDE)
C     WRITE(3,100)BUFSIZ,GRPBXD(GRCIDE),GRPBYD(GRCIDE)
	ELSE IF (GRCTYP.NE.GNULL) THEN
	    CALL GRQUIT('Internal error.')
	END IF
	IF (GRCTYP.NE.GNULL) THEN
	    RESULT = LIB$FREE_VM(BUFSIZ, GRPBAD(GRCIDE))
	    IF (.NOT.RESULT) THEN
		CALL GRWARN('Failed to free memory in GRCLOS.')
		CALL GRGMSG(RESULT)
	    END IF
	END IF
C
C		Close/deassign the output file.
C
	IF (GRCTYP.EQ.PRTX .OR. GRCTYP.EQ.TRILOG .OR. GRCTYP.EQ.VERS 
     1		.OR. GRCTYP.EQ.VT125 .OR. GRCTYP.EQ.GMFILE
     1          .OR. GRCTYP.EQ.LASER) THEN
	    CLOSE (UNIT=GRUNIT(GRCIDE))

	    RESULT = LIB$FREE_LUN(GRUNIT(GRCIDE))
	    IF (.NOT.RESULT) THEN
		CALL GRWARN('Failed to free logical unit in GRCLOS.')
		CALL GRGMSG(RESULT)
	    END IF
	ELSE IF (GRCTYP.EQ.TEK10 .OR. GRCTYP.EQ.TEK14 .OR.
     1		 GRCTYP.EQ.RETRO .OR. GRCTYP.EQ.GRINL .OR.
     2	         GRCTYP.EQ.ARGS  .OR. GRCTYP.EQ.ID100) THEN
	    RESULT = SYS$DASSGN(%VAL(GRUNIT(GRCIDE)))
	    IF (.NOT.RESULT) THEN
		CALL GRWARN('Failed to deassign channel in GRCLOS.')
		CALL GRGMSG(RESULT)
	    END IF
	ELSE IF (GRCTYP.NE.GNULL) THEN
	    CALL GRQUIT('Internal error.')
	END IF
C
	RETURN
	END
	SUBROUTINE GRCLPL (X0,Y0,X1,Y1,VIS)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Change the end-points of the line (X0,Y0)
C (X1,Y1) to clip the line at the window boundary.  The algorithm is
C that of Cohen and Sutherland (ref: Newman & Sproull).
C
C Arguments:
C
C X0, Y0 (input/output, real): device coordinates of starting point
C	of line.
C X1, Y1 (input/output, real): device coordinates of end point of line.
C VIS (output, logical): .TRUE. if line lies wholly or partially
C	within the clipping rectangle; .FALSE. if it lies entirely
C	outside the rectangle.
C
C 13-Jul-1984 - [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  XMIN,XMAX,YMIN,YMAX
	LOGICAL  VIS
	BYTE     C0,C1,C
	REAL     X,Y, X0,Y0, X1,Y1
C
	XMIN = GRXMIN(GRCIDE)
	YMIN = GRYMIN(GRCIDE)
	XMAX = GRXMAX(GRCIDE)
	YMAX = GRYMAX(GRCIDE)
	CALL GRCLIP(NINT(X0),NINT(Y0),XMIN,XMAX,YMIN,YMAX,C0)
	CALL GRCLIP(NINT(X1),NINT(Y1),XMIN,XMAX,YMIN,YMAX,C1)
	DO WHILE (C0.NE.0 .OR. C1.NE.0)
	    IF ((C0.AND.C1).NE.0) THEN		! line is invisible
	        VIS = .FALSE.
		RETURN
	    END IF
	    C = C0
	    IF (C.EQ.0) C = C1
	    IF ((C.AND.1).NE.0) THEN		! crosses XMIN
		Y = Y0 + (Y1-Y0)*(XMIN-X0)/(X1-X0)
		X = XMIN
	    ELSE IF ((C.AND.2).NE.0) THEN	! crosses XMAX
		Y = Y0 + (Y1-Y0)*(XMAX-X0)/(X1-X0)
		X = XMAX
	    ELSE IF ((C.AND.4).NE.0) THEN	! crosses YMIN
		X = X0 + (X1-X0)*(YMIN-Y0)/(Y1-Y0)
		Y = YMIN
	    ELSE IF ((C.AND.8).NE.0) THEN	! crosses YMAX
		X = X0 + (X1-X0)*(YMAX-Y0)/(Y1-Y0)
		Y = YMAX
	    END IF
	    IF (C.EQ.C0) THEN
		X0 = X
		Y0 = Y
		CALL GRCLIP(NINT(X),NINT(Y),XMIN,XMAX,YMIN,YMAX,C0)
	    ELSE
		X1 = X
		Y1 = Y
		CALL GRCLIP(NINT(X),NINT(Y),XMIN,XMAX,YMIN,YMAX,C1)
	    END IF
	END DO
	VIS = .TRUE.
	RETURN
	END
	INTEGER FUNCTION GRCURS (IDENT,IX,IY,CH)
C-----------------------------------------------------------------------
C GRPCKG: Read the cursor position and a character typed by the user.
C The position is returned in absolute device coordinates (pixels).
C GRCURS positions the cursor at the position specified, and
C allows the user to move the cursor using the joystick or
C arrow keys or whatever is available on the device. When he has
C positioned the cursor, the user types a single character on his
C keyboard; GRCURS then returns this character and the new cursor
C position.
C
C Returns:
C
C GRCURS (integer): 1 if the call was successful; 0 if the device
C	has no cursor or some other error occurs. To prevent infinite
C	loops, GRCURS aborts the program if it is called more
C	than 10 times for devices without cursors.
C
C Arguments:
C
C IDENT (integer, input): GRPCKG plot identifier (from GROPEN).
C IX (integer, input/output): the device x-coordinate of the cursor.
C IY (integer, input/output): the device y-coordinate of the cursor.
C CH (character, output): the character typed by the user; if the device
C	has no cursor or if some other error occurs, the value CHAR(0)
C	[ASCII NUL character] is returned.
C
C Notes:
C
C Grinnell (/GR):
C   (a) The cursor is a blinking cross (+).
C   (b) The user positions the cursor using the Grinnell joystick.
C   (c) The user indicates that the cursor has been positioned by
C	typing any character on his keyboard (SYS$COMMAND), with the
C	following exceptions: control characters (^C, ^O, ^Q, ^R, ^S,
C	^T, ^U, ^X, ^Y, DEL) are intercepted by the operating system
C	and cannot be used; NUL, ESC (^[) and escape sequences (e.g., 
C	arrow keys) are ignored by GRCURS.
C
C Digital Equipment Corp. VT125 (/VT):
C   (a) The cursor is a blinking diamond-crosshair.
C   (b) The user positions the cursor using the arrow keys and PF1-PF4
C	keys on his keyboard (SYS$COMMAND) [Note: NOT the keyboard
C	of the terminal on which he is plotting, if that is different.]
C	The arrow keys move the cursor in the appropriate direction;
C	the size of the step for each keystroke is controlled by the
C	PF1-PF4 keys: PF1 => 1 pixel, PF2 => 4 pixels, PF3 => 16 
C	pixels, PF4 => 64 pixels. [The VT240 terminal has a built-in
C	capability to position the cursor, but the VT125 does not;
C	hence all the cursor movement is done within the VAX.]
C   (c) The user indicates that the cursor has been positioned by
C	typing any character other than an arrow or PF1-PF4 key,
C	except: control characters (^C, ^O, ^Q, ^R, ^S,
C	^T, ^U, ^X, ^Y, DEL) are intercepted by the operating system
C	and cannot be used; NUL, ESC (^[) and escape sequences (other 
C	than arrow keys and PF1-PF4) are ignored by GRCURS.
C
C Digital Engineering, Inc. Retrographics VT640 (/RE):
C   (a) The cursor is a crosshair across the entire screen.
C   (b) The user positions the cursor using the four arrow keys on
C	the keyboard of the Retrographics terminal. The terminal is
C	in "crosshair mode". "By striking the desired directional
C	arrow key, the crosshair will move across the display screen
C	at the rate of one dot per keystroke. Applying a constant
C	pressure on an arrow key will cause the crosshair to move at
C	a continuous rapid rate; releasing the key will stop the
C	crosshair's movement."
C   (c) The user indicates that the cursor has been positioned by
C	typing any "alphanumeric punctuation key" on the keyboard of 
C	the Retrographics terminal. Some control characters (^C, ^O,
C	^Q, ^R, ^S, ^T, ^U, ^X, ^Y, DEL) are intercepted by the
C	operating system and cannot be used. The corresponding code is
C	returned in the argument CH of GRCURS.
C
C  1-Aug-1984 - extensively revised [TJP].
C-----------------------------------------------------------------------
	LOGICAL*1	BUFFER(7)
	LOGICAL*1	PROMPT(10)
	CHARACTER*1	CH,ESC
	PARAMETER	(ESC=CHAR(27))
	DATA		PROMPT/29,4*0,27,47,102,27,26/
C		        ! <GS> #### <ESC>/f<ESC><SUB
	LOGICAL         GRCHKT
	INTEGER*2	GRNLBF(8),IXG,IYG
	INCLUDE		'GRPCKG1.INC'
	INCLUDE		'($IODEF)'
	INCLUDE		'($SSDEF)'
	INTEGER		SYS$QIOW,GRGETC,SYS$ASSIGN, SYS$DASSGN
	INTEGER		IOSB(2),RESULT,IX,IY
	INTEGER*2	STBC(2), STATUS, COUNT
	INTEGER		ERRCNT
	DATA		ERRCNT/0/
	EQUIVALENCE	(STBC,IOSB(1)),(STATUS,STBC(1)),(COUNT,STBC(2))
	PARAMETER	RPR=IO$_READPROMPT+IO$M_NOFORMAT+
     1			IO$M_PURGE+IO$M_NOECHO+IO$M_TIMED
	DATA		ISTEP/4/	! initial step size for VT125
	INTEGER		QUAD0(2)
	DATA		QUAD0/0,0/
C
C		Validate identifier, and select device.
C
	CALL GRSELECT(IDENT)
	CALL GRTERM
C
C		Make sure cursor is on view surface. (It does not
C		have to be in the viewport.)
C
	IX = MAX(0,MIN(GRXMX0(GRCTYP),IX))
	IY = MAX(0,MIN(GRYMX0(GRCTYP),IY))
C
C		Check that SYS$COMMAND is a terminal; if it is not
C		(e.g., in a batch job), return error status.
C
	IF (.NOT.GRCHKT('SYS$COMMAND')) THEN
	    CALL GRWARN('cursor not available to non-interactive job.')
	    CH = CHAR(0)
	    GRCURS = 0
	    ERRCNT = ERRCNT+1
C
C	Tektronix terminals: a query is sent to the terminal which turns
C	on the cross hair display. If the user types a character on the 
C	Tektronix keyboard within 60 seconds, the terminal sends 
C	that character (ICHAR) and the X and Y cursor settings (IX,IY).
C
	ELSE IF (GRCTYP.EQ.TEK10 .OR. GRCTYP.EQ.TEK14 .OR.
     1	    GRCTYP.EQ.RETRO) THEN
	    PROMPT(2) = ((IY/32).AND.31).OR.32
	    PROMPT(3) = MOD(IY,32).OR.96
	    PROMPT(4) = ((IX/32).AND.31).OR.32
	    PROMPT(5) = MOD(IX,32).OR.64
	    BUFFER(1) = 0
	    BUFFER(2) = PROMPT(2)
	    BUFFER(3) = PROMPT(3)
	    BUFFER(4) = PROMPT(4)
	    BUFFER(5) = PROMPT(5)
	    RESULT = SYS$QIOW(,%VAL(GRUNIT(GRCIDE)),%VAL(RPR),IOSB,,,
     1		BUFFER,		! P1 = buffer address
     2		%VAL(6),	! P2 = length of buffer
     3		%VAL(60),	! P3 = timeout count (seconds)
     4		QUAD0,		! P4 = terminator mask
     5		PROMPT,		! P5 = prompt string address
     6		%VAL(10))	! P6 = prompt string length
	    IF (RESULT.NE.SS$_NORMAL) THEN
		CALL GRGMSG(RESULT)
		CALL GRQUIT('SYS$QIOW error reading from Tek terminal')
	    END IF
	    CH = CHAR(BUFFER(1))
	    I1 = BUFFER(2).AND.'1F'X
	    I2 = BUFFER(3).AND.'1F'X
	    IX = I1*32 +I2
	    I1 = BUFFER(4).AND.'1F'X
	    I2 = BUFFER(5).AND.'1F'X
	    IY = I1*32 + I2
	    IF (GRCTYP.EQ.TEK14) THEN
		IX = IX*4
		IY = IY*4
	    END IF
	    GRCURS = 1
C
C	VT125 terminals: cursor movement is done with the
C	arrow keys, keys PF1 ... PF4 control the stepsize. N.B. Uses
C	logged-in terminal (SYS$COMMAND), NOT plotting terminal!
C
	ELSE IF (GRCTYP.EQ.VT125) THEN
	    IER = SYS$ASSIGN('SYS$COMMAND',ICHAN,,)
	    IF (IER.NE.1) THEN
		CALL GRGMSG(IER)
		CALL GRQUIT('Fatal error.')
	    END IF
	    IUNIT = GRUNIT(GRCIDE)
	    WRITE (IUNIT,101) ESC//'Pp'	! graphics mode
	    WRITE (IUNIT,111) IX,IY	! position graphics cursor
	    IVAL = -100
	    DO WHILE (IVAL .LE. 0)
		IVAL = GRGETC(ICHAN)
		IF (IVAL .EQ. -14) THEN		! PF4 - large step
		    ISTEP = 64
		ELSE IF (IVAL .EQ. -13) THEN	! PF3
		    ISTEP = 16
		ELSE IF (IVAL .EQ. -12) THEN	! PF2
		    ISTEP = 4
		ELSE IF (IVAL .EQ. -11) THEN	! PF1 - small step
		    ISTEP = 1
		ELSE IF (IVAL .LT. 0) THEN
		    IDELTA = ISTEP
		    IF ((IVAL .EQ. -2).OR.(IVAL .EQ.-4)) IDELTA = -ISTEP
		    IF (IVAL .GE. -2) THEN
			IY = IY + IDELTA
			IY = MAX(IY,0)
			IY = MIN(IY,GRYMXA(GRCIDE))
		    ELSE
			IX = IX + IDELTA
			IX = MAX(IX,0)
			IX = MIN(IX,GRXMXA(GRCIDE))
		    ENDIF
		    WRITE (IUNIT,111) IX,IY	! position graphics cursor
		END IF
	    END DO
	    WRITE (IUNIT,101) ESC//'\'   ! back to text mode
	    CH = CHAR(IVAL)
	    IER = SYS$DASSGN(%VAL(ICHAN))
	    GRCURS = 1
C
C		Grinnell.
C
	ELSE IF (GRCTYP.EQ.GRINL) THEN
	    IER = SYS$ASSIGN('SYS$COMMAND',ICHAN,,)
	    IF (IER.NE.1) THEN
		CALL GRGMSG(IER)
		CALL GRQUIT('Fatal error.')
	    END IF
	    ixg = ix
	    iyg = iy
	    GRNLBF(1) = 'A080'X		! SPD cursor
	    GRNLBF(2) = 'C011'X		! enable cursor 1, blink
	    GRNLBF(3) = 'B000'X		! LPA 0
	    GRNLBF(4) = 'D800'X .OR. IXG	! load X coord
	    GRNLBF(5) = 'B001'X
	    GRNLBF(6) = 'D800'X .OR. IYG	! load Y coord
	    CALL GRGR02(GRNLBF,6,%VAL(GRPBAD(GRCIDE)))
	    do jj=1,2
	    GRNLBF(1) = 'B000'X		! LPA 0
	    GRNLBF(2) = 'E000'X		! RPD
	    CALL GRGR02(GRNLBF,2,%VAL(GRPBAD(GRCIDE)))
	    CALL GRTERM
	    if (jj.eq.1) THEN
   70		ICH = GRGETC(ICHAN)
		IF (ICH.LE.0 .OR. ICH.GT.255) GOTO 70
		CH = CHAR(ICH)
	    END IF
	    RESULT = SYS$QIOW(,%VAL(GRUNIT(GRCIDE)),
     1		%VAL(IO$_READVBLK.OR.IO$M_SETFNCT),
     1		%REF(IOSB),,,GRNLBF,%VAL(16),,%VAL(1),,)
	    IF (.NOT.RESULT) THEN
		CALL GRGMSG(RESULT)
		CALL GRQUIT('SYS$QIOW failure reading from Grinnell')
	    END IF
	    IF (STATUS.NE.SS$_NORMAL) THEN
		CALL GRGMSG(STATUS)
		CALL GRQUIT('SYS$QIOW failure reading from Grinnell')
	    END IF
	    IX = GRNLBF(1).AND.'3FF'X
	    IY = GRNLBF(2).AND.'3FF'X
	    end do
	    GRNLBF(1) = 'A080'X
	    GRNLBF(2) = 'C000'X		! disable all cursors
	    GRNLBF(3) = 'A000'X
	    CALL GRGR02(GRNLBF,3,%VAL(GRPBAD(GRCIDE)))
	    CALL GRTERM
	    IER = SYS$DASSGN(%VAL(ICHAN))
	    GRCURS = 1
C
C		Other devices are illegal.
C
	ELSE
	    CALL GRWARN('output device has no cursor: '//GRTYPN(GRCTYP))
	    CH = CHAR(0)
	    GRCURS = 0
	    ERRCNT = ERRCNT+1
	END IF
C
	IF (ERRCNT.GT.10) CALL GRQUIT('too many cursor errors.')
	RETURN
C
  101	FORMAT(A)
  111	FORMAT('P[', I4 ,',', I4 ,']')
	END
	BLOCK DATA GRDAT1
C-----------------------------------------------------------------------
C GRPCKG (internal routine): block data for initializing common blocks.
C
C Device types (mnemonics defined in GRPCKG1.INC):
C
C PRTX   : Printronix P300/P600 line printer.
C TEK14  : Tektronix 4100 series terminals.
C TEK10  : Tektronix 4006/4010 storage tube terminal.
C TRILOG : Trilog line printer.
C VT125  : Digital Equipment Corp VT125/VT240 Regis graphics terminals.
C GRINL  : Grinnell Image Display.
C VERS   : Versatec printer/plotter.
C RETRO  : Retro-Graphics modified VT100.
C GNULL  : Null graphics device.
C ARGS   : Sigma ARGS color graphics display.
C ID100  : ID Systems Corp. ID100V (modified VT100).
C GMFILE : Core-like metafile.
C LASER  : Laser printer
C
C Device parameters:
C
C GRTYPN() : standard name for the device type.
C GRKIND() : .TRUE. if device is interactive; .FALSE. if hardcopy.
C GRXMX0() : maximum physical x-coordinate (minimum is always 0) on
C            standard view surface.
C GRYMX0() : maximum physical y-coordinate (minimum is always 0) on
C            standard view surface.
C GRXMX1() : maximum physical x-coordinate (minimum is always 0) which
C            may be requested when re-sizing the view surface; -1
C            implies there is no fundamental limit.
C GRYMX1() : maximum physical y-coordinate (minimum is always 0) which
C            may be requested when re-sizing the view surface; -1
C            implies there is no fundamental limit.
C GRCSC0() : character scale factor.
C GRXPIN() : number of x-coordinate units per inch (nominal).
C GRYPIN() : number of y-coordinate units per inch (nominal).
C
C 2-Aug-1984 - TJP.
C-----------------------------------------------------------------------
	INCLUDE 'GRPCKG1.INC'
C
C		All the plot identifiers are initially not in use.
C
	DATA GRINIT / GRIMAX*.FALSE. /
C
C		Parameters of each device type.
C
	DATA GRTYPN(PRTX)  / 'PRINTRONIX' /
	DATA GRKIND(PRTX)  / .FALSE. /
	DATA GRXMX0(PRTX)  / 791 /
	DATA GRYMX0(PRTX)  / 738 /
	DATA GRXMX1(PRTX)  / 791 /
	DATA GRYMX1(PRTX)  / -1 /
	DATA GRCSC0(PRTX)  / 1.0 /
	DATA GRXPIN(PRTX)  / 60.0 /
	DATA GRYPIN(PRTX)  / 72.0 /
C
	DATA GRTYPN(TEK14) / 'TK4100' /
	DATA GRKIND(TEK14) / .TRUE. /
	DATA GRXMX0(TEK14) / 4095 /
	DATA GRYMX0(TEK14) /  3071 /
	DATA GRXMX1(TEK14) / 4095 /
	DATA GRYMX1(TEK14) / 3071 /
	DATA GRCSC0(TEK14) / 4.0 /
	DATA GRXPIN(TEK14) /  286.7 /
	DATA GRYPIN(TEK14) /  286.7 /
C
	DATA GRTYPN(TEK10) / 'TEK4010' /
	DATA GRKIND(TEK10) / .TRUE. /
	DATA GRXMX0(TEK10) / 1023 /
	DATA GRYMX0(TEK10) /  767 /
	DATA GRXMX1(TEK10) / 1023 /
	DATA GRYMX1(TEK10) /  767 /
	DATA GRCSC0(TEK10) / 2.0 /
	DATA GRXPIN(TEK10) / 136.4 /
	DATA GRYPIN(TEK10) / 136.4 /
C
	DATA GRTYPN(TRILOG)/ 'TRILOG'  /
	DATA GRKIND(TRILOG)/ .FALSE. /
	DATA GRXMX0(TRILOG)/ 1319 /
	DATA GRYMX0(TRILOG)/ 1025/
	DATA GRXMX1(TRILOG)/ 1319/
	DATA GRYMX1(TRILOG)/ -1 /
	DATA GRCSC0(TRILOG)/ 1.0 /
	DATA GRXPIN(TRILOG)/ 100.0 /
	DATA GRYPIN(TRILOG)/ 100.0 /
C
	DATA GRTYPN(VT125) / 'VT125' /
	DATA GRKIND(VT125) / .TRUE. /
	DATA GRXMX0(VT125) / 767 /
	DATA GRYMX0(VT125) / 479 /
	DATA GRXMX1(VT125) / 767 /
	DATA GRYMX1(VT125) / 479/
	DATA GRCSC0(VT125) / 1.0 /
	DATA GRXPIN(VT125) / 100.0 /
	DATA GRYPIN(VT125) / 100.0 /
C
	DATA GRTYPN(GRINL) / 'GRINNELL' /
	DATA GRKIND(GRINL) / .TRUE. /
	DATA GRXMX0(GRINL) / 511 /
	DATA GRYMX0(GRINL) / 511 /
	DATA GRXMX1(GRINL) / 511 /
	DATA GRYMX1(GRINL) / 511 /
	DATA GRCSC0(GRINL) / 1.0 /
	DATA GRXPIN(GRINL) / 50.0 /
	DATA GRYPIN(GRINL) / 50.0 /
C
	DATA GRTYPN(VERS)  / 'VERSATEC' /
	DATA GRKIND(VERS)  / .FALSE. /
	DATA GRXMX0(VERS)  / 2001 /
	DATA GRYMX0(VERS)  / 1601 /
	DATA GRXMX1(VERS)  / 2001 /
	DATA GRYMX1(VERS)  / -1 /
	DATA GRCSC0(VERS)  / 3.0 /
	DATA GRXPIN(VERS)  / 200.0 /
	DATA GRYPIN(VERS)  / 200.0 /
C
	DATA GRTYPN(RETRO) / 'RETRO' /
	DATA GRKIND(RETRO) / .TRUE. /
	DATA GRXMX0(RETRO) / 1023 /
	DATA GRYMX0(RETRO) /  779 /
	DATA GRXMX1(RETRO) / 1023 /
	DATA GRYMX1(RETRO) /  779 /
	DATA GRCSC0(RETRO) /  2.0 /
	DATA GRXPIN(RETRO) / 80.0 /
	DATA GRYPIN(RETRO) / 80.0 /
C
	DATA GRTYPN(GNULL) / 'NULL' /
	DATA GRKIND(GNULL) / .FALSE. /
	DATA GRXMX0(GNULL) / 1023 /
	DATA GRYMX0(GNULL) / 1023 /
	DATA GRXMX1(GNULL) / 1023 /
	DATA GRYMX1(GNULL) / 1023 /
	DATA GRCSC0(GNULL) / 1.0 /
	DATA GRXPIN(GNULL) / 200.0 /
	DATA GRYPIN(GNULL) / 200.0 /
C
	DATA GRTYPN(ARGS)  / 'ARGS' /
	DATA GRKIND(ARGS)  / .TRUE. /
	DATA GRXMX0(ARGS)  / 511 /
	DATA GRYMX0(ARGS)  / 511 /
	DATA GRXMX1(ARGS)  / 511 /
	DATA GRYMX1(ARGS)  / 511 /
	DATA GRCSC0(ARGS)  / 1.0 /
	DATA GRXPIN(ARGS)  / 50.0 /
	DATA GRYPIN(ARGS)  / 50.0 /
C
	DATA GRTYPN(ID100) / 'ID100' /
	DATA GRKIND(ID100) / .TRUE. /
	DATA GRXMX0(ID100) / 1023 /
	DATA GRYMX0(ID100) / 925 /
	DATA GRXMX1(ID100) / 1023 /
	DATA GRYMX1(ID100) / 925 /
	DATA GRCSC0(ID100) / 1.0 /
	DATA GRXPIN(ID100) / 136.4 /
	DATA GRYPIN(ID100) / 150.8 /
C
	DATA GRTYPN(GMFILE) / 'FILE' /
	DATA GRKIND(GMFILE) / .FALSE. /
	DATA GRXMX0(GMFILE) / 32767 /
	DATA GRYMX0(GMFILE) / 32767 /
	DATA GRXMX1(GMFILE) / 32767 /
	DATA GRYMX1(GMFILE) / 32767/
	DATA GRCSC0(GMFILE) / 20.0 /
	DATA GRXPIN(GMFILE) / 4096.0 /
	DATA GRYPIN(GMFILE) / 4096.0 /
C
	DATA GRTYPN(LASER)  / 'LASER' /    !THIS IS COPIED FROM 
	DATA GRKIND(LASER)  / .FALSE. /    ! SHCNEIDER'S LASER ADDITIONS
	DATA GRXMX0(LASER)  / 11000 /
	DATA GRYMX0(LASER)  / 8000 /
	DATA GRXMX1(LASER)  / 11000 /
	DATA GRYMX1(LASER)  / 8000 /
	DATA GRCSC0(LASER)  / 8.0 /
	DATA GRXPIN(LASER)  / 1000. /
	DATA GRYPIN(LASER)  / 1000. /
C
	END
	BLOCK DATA GRDAT2
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Block data for to define the character set.
C
C Arguments: none.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	INTEGER   CTD1, CTD2
	PARAMETER (CTD1 = 30)
	PARAMETER (CTD2 = 128)
C
	INTEGER   CINDX1, CINDX2
	BYTE      CHTBL(CTD1,CTD2)
	BYTE    SPCH00(CTD1), SPCH01(CTD1), SPCH02(CTD1), SPCH03(CTD1)
     1        , SPCH04(CTD1), SPCH05(CTD1), SPCH06(CTD1), SPCH07(CTD1)
     2        , SPCH08(CTD1), SPCH09(CTD1), SPCH10(CTD1), SPCH11(CTD1)
     3        , SPCH12(CTD1), SPCH13(CTD1), SPCH14(CTD1), SPCH15(CTD1)
     4        , SPCH16(CTD1), SPCH17(CTD1), SPCH18(CTD1), SPCH19(CTD1)
     5        , SPCH20(CTD1), SPCH21(CTD1), SPCH22(CTD1), SPCH23(CTD1)
     6        , SPCH24(CTD1), SPCH25(CTD1), SPCH26(CTD1), SPCH27(CTD1)
     7        , SPCH28(CTD1), SPCH29(CTD1), SPCH30(CTD1), SPCH31(CTD1)
     8        , SPACE (CTD1), EXCLAM(CTD1), QUOTE (CTD1), POUND (CTD1)
     9        , DOLLAR(CTD1), PERCNT(CTD1), AMPERS(CTD1), APOSTR(CTD1)
     A        , LPAREN(CTD1), RPAREN(CTD1), ASTER (CTD1), PLUS  (CTD1)
     B        , COMMA (CTD1), MINUS (CTD1), PERIOD(CTD1), SLASH (CTD1)
     C        , ZERO  (CTD1), ONE   (CTD1), TWO   (CTD1), THREE (CTD1)
     D        , FOUR  (CTD1), FIVE  (CTD1), SIX   (CTD1), SEVEN (CTD1)
     E        , EIGHT (CTD1), NINE  (CTD1), COLON (CTD1), SEMICO(CTD1)
     F        , LESS  (CTD1), EQUALS(CTD1), GREATR(CTD1), QUESTN(CTD1)
	BYTE    ATSIGN(CTD1), AUPPER(CTD1), BUPPER(CTD1), CUPPER(CTD1)
     1        , DUPPER(CTD1), EUPPER(CTD1), FUPPER(CTD1), GUPPER(CTD1)
     2        , HUPPER(CTD1), IUPPER(CTD1), JUPPER(CTD1), KUPPER(CTD1)
     3        , LUPPER(CTD1), MUPPER(CTD1), NUPPER(CTD1), OUPPER(CTD1)
     4        , PUPPER(CTD1), QUPPER(CTD1), RUPPER(CTD1), SUPPER(CTD1)
     5        , TUPPER(CTD1), UUPPER(CTD1), VUPPER(CTD1), WUPPER(CTD1)
     6        , XUPPER(CTD1), YUPPER(CTD1), ZUPPER(CTD1), LBRACK(CTD1)
     7        , BKSLSH(CTD1), RBRACK(CTD1), CARET (CTD1), USCORE(CTD1)
     8        , ACCENT(CTD1), ALOWER(CTD1), BLOWER(CTD1), CLOWER(CTD1)
     9        , DLOWER(CTD1), ELOWER(CTD1), FLOWER(CTD1), GLOWER(CTD1)
     A        , HLOWER(CTD1), ILOWER(CTD1), JLOWER(CTD1), KLOWER(CTD1)
     B        , LLOWER(CTD1), MLOWER(CTD1), NLOWER(CTD1), OLOWER(CTD1)
     C        , PLOWER(CTD1), QLOWER(CTD1), RLOWER(CTD1), SLOWER(CTD1)
     D        , TLOWER(CTD1), ULOWER(CTD1), VLOWER(CTD1), WLOWER(CTD1)
     E        , XLOWER(CTD1), YLOWER(CTD1), ZLOWER(CTD1), LBRACE(CTD1)
     F        , ORSIGN(CTD1), RBRACE(CTD1), TILDE (CTD1), SPC127(CTD1)
	EQUIVALENCE (SPCH00, CHTBL(1,   1)), (SPCH01, CHTBL(1,   2))
     1          , (SPCH02, CHTBL(1,   3)), (SPCH03, CHTBL(1,   4))
     2          , (SPCH04, CHTBL(1,   5)), (SPCH05, CHTBL(1,   6))
     3          , (SPCH06, CHTBL(1,   7)), (SPCH07, CHTBL(1,   8))
     4          , (SPCH08, CHTBL(1,   9)), (SPCH09, CHTBL(1,  10))
     5          , (SPCH10, CHTBL(1,  11)), (SPCH11, CHTBL(1,  12))
     6          , (SPCH12, CHTBL(1,  13)), (SPCH13, CHTBL(1,  14))
     7          , (SPCH14, CHTBL(1,  15)), (SPCH15, CHTBL(1,  16))
     8          , (SPCH16, CHTBL(1,  17)), (SPCH17, CHTBL(1,  18))
     9          , (SPCH18, CHTBL(1,  19)), (SPCH19, CHTBL(1,  20))
     A          , (SPCH20, CHTBL(1,  21)), (SPCH21, CHTBL(1,  22))
     B          , (SPCH22, CHTBL(1,  23)), (SPCH23, CHTBL(1,  24))
     C          , (SPCH24, CHTBL(1,  25)), (SPCH25, CHTBL(1,  26))
     D          , (SPCH26, CHTBL(1,  27)), (SPCH27, CHTBL(1,  28))
     E          , (SPCH28, CHTBL(1,  29)), (SPCH29, CHTBL(1,  30))
     F          , (SPCH30, CHTBL(1,  31)), (SPCH31, CHTBL(1,  32))
	EQUIVALENCE (SPACE , CHTBL(1,  33)), (EXCLAM, CHTBL(1,  34))
     1          , (QUOTE , CHTBL(1,  35)), (POUND , CHTBL(1,  36))
     2          , (DOLLAR, CHTBL(1,  37)), (PERCNT, CHTBL(1,  38))
     3          , (AMPERS, CHTBL(1,  39)), (APOSTR, CHTBL(1,  40))
     4          , (LPAREN, CHTBL(1,  41)), (RPAREN, CHTBL(1,  42))
     5          , (ASTER , CHTBL(1,  43)), (PLUS  , CHTBL(1,  44))
     6          , (COMMA , CHTBL(1,  45)), (MINUS , CHTBL(1,  46))
     7          , (PERIOD, CHTBL(1,  47)), (SLASH , CHTBL(1,  48))
     8          , (ZERO  , CHTBL(1,  49)), (ONE   , CHTBL(1,  50))
     9          , (TWO   , CHTBL(1,  51)), (THREE , CHTBL(1,  52))
     A          , (FOUR  , CHTBL(1,  53)), (FIVE  , CHTBL(1,  54))
     B          , (SIX   , CHTBL(1,  55)), (SEVEN , CHTBL(1,  56))
     C          , (EIGHT , CHTBL(1,  57)), (NINE  , CHTBL(1,  58))
     D          , (COLON , CHTBL(1,  59)), (SEMICO, CHTBL(1,  60))
     E          , (LESS  , CHTBL(1,  61)), (EQUALS, CHTBL(1,  62))
     F          , (GREATR, CHTBL(1,  63)), (QUESTN, CHTBL(1,  64))
	EQUIVALENCE (ATSIGN, CHTBL(1,  65)), (AUPPER, CHTBL(1,  66))
     1          , (BUPPER, CHTBL(1,  67)), (CUPPER, CHTBL(1,  68))
     2          , (DUPPER, CHTBL(1,  69)), (EUPPER, CHTBL(1,  70))
     3          , (FUPPER, CHTBL(1,  71)), (GUPPER, CHTBL(1,  72))
     4          , (HUPPER, CHTBL(1,  73)), (IUPPER, CHTBL(1,  74))
     5          , (JUPPER, CHTBL(1,  75)), (KUPPER, CHTBL(1,  76))
     6          , (LUPPER, CHTBL(1,  77)), (MUPPER, CHTBL(1,  78))
     7          , (NUPPER, CHTBL(1,  79)), (OUPPER, CHTBL(1,  80))
     8          , (PUPPER, CHTBL(1,  81)), (QUPPER, CHTBL(1,  82))
     9          , (RUPPER, CHTBL(1,  83)), (SUPPER, CHTBL(1,  84))
     A          , (TUPPER, CHTBL(1,  85)), (UUPPER, CHTBL(1,  86))
     B          , (VUPPER, CHTBL(1,  87)), (WUPPER, CHTBL(1,  88))
     C          , (XUPPER, CHTBL(1,  89)), (YUPPER, CHTBL(1,  90))
     D          , (ZUPPER, CHTBL(1,  91)), (LBRACK, CHTBL(1,  92))
     E          , (BKSLSH, CHTBL(1,  93)), (RBRACK, CHTBL(1,  94))
     F          , (CARET , CHTBL(1,  95)), (USCORE, CHTBL(1,  96))
	EQUIVALENCE (ACCENT, CHTBL(1,  97)), (ALOWER, CHTBL(1,  98))
     1          , (BLOWER, CHTBL(1,  99)), (CLOWER, CHTBL(1, 100))
     2          , (DLOWER, CHTBL(1, 101)), (ELOWER, CHTBL(1, 102))
     3          , (FLOWER, CHTBL(1, 103)), (GLOWER, CHTBL(1, 104))
     4          , (HLOWER, CHTBL(1, 105)), (ILOWER, CHTBL(1, 106))
     5          , (JLOWER, CHTBL(1, 107)), (KLOWER, CHTBL(1, 108))
     6          , (LLOWER, CHTBL(1, 109)), (MLOWER, CHTBL(1, 110))
     7          , (NLOWER, CHTBL(1, 111)), (OLOWER, CHTBL(1, 112))
     8          , (PLOWER, CHTBL(1, 113)), (QLOWER, CHTBL(1, 114))
     9          , (RLOWER, CHTBL(1, 115)), (SLOWER, CHTBL(1, 116))
     A          , (TLOWER, CHTBL(1, 117)), (ULOWER, CHTBL(1, 118))
     B          , (VLOWER, CHTBL(1, 119)), (WLOWER, CHTBL(1, 120))
     C          , (XLOWER, CHTBL(1, 121)), (YLOWER, CHTBL(1, 122))
     D          , (ZLOWER, CHTBL(1, 123)), (LBRACE, CHTBL(1, 124))
     E          , (ORSIGN, CHTBL(1, 125)), (RBRACE, CHTBL(1, 126))
     F          , (TILDE , CHTBL(1, 127)), (SPC127, CHTBL(1, 128))
C
	COMMON /GRCS02/ CINDX1, CINDX2, CHTBL
C
	DATA CINDX1 /1/
	DATA CINDX2 /0/
C
      DATA SPCH00 /07, 34, 37, 67, 61, 01, 07, 37, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH01 /11, 34, 37, 47, 65, 63, 41, 21, 03, 05
     1           , 27, 37, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH02 /07, 34, 37, 64, 61, 01, 04, 37, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH03 /02, 04, 64, 02, 37, 31, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00

     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH04 /02, 01, 67, 02, 07, 61, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH05 /06, 34, 37, 64, 31, 04, 37, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH06 /05, 31, 37, 64, 04, 37, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH07 /04, 01, 67, 07, 61, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH08 /04, 07, 67, 01, 61, 02, 14, 54, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH09 /03, 07, 34, 67, 02, 34, 31, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH10 /06, 61, 52, 56, 16, 12, 52, 02, 01, 12
     1           , 02, 07, 16, 02, 67, 34, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH11 /02, 01, 67, 02, 07, 61, 02, 04, 64, 02
     1           , 37, 31, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH12 /05, 01, 67, 07, 61, 01, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH13 /02, 24, 44, 02, 37, 31, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH14 /02, 07, 67, 02, 01, 61, 05, 31, 64, 37
     1           , 04, 31, 01, 34, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH15 /07, 23, 43, 44, 24, 25, 45, 44, 02, 35
     1           , 33, 02, 23, 24, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH16 /27, 01, 61, 62, 02, 03, 63, 64, 04, 05
     1           , 65, 66, 06, 07, 67, 61, 51, 57, 47, 41
     2           , 31, 37, 27, 21, 11, 17, 07, 01, 00, 00/
      DATA SPCH17 /14, 21, 41, 52, 12, 03, 63, 64, 04, 05
     1           , 65, 56, 16, 27, 47, 14, 03, 05, 16, 12
     2           , 21, 27, 37, 31, 41, 47, 56, 52, 63, 65/
      DATA SPCH18 /12, 31, 42, 22, 13, 53, 64, 04, 15, 55
     1           , 46, 26, 37, 12, 64, 55, 53, 42, 46, 37
     2           , 31, 22, 26, 15, 13, 04, 00, 00, 00, 00/
      DATA SPCH19 /09, 26, 15, 13, 22, 42, 53, 55, 46, 26
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH20 /09, 27, 05, 03, 21, 41, 63, 65, 47, 27
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH21 /00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH22 /00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH23 /00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH24 /00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH25 /00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH26 /00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH27 /00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH28 /00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH29 /00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH30 /00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPCH31 /00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPACE  /00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA EXCLAM /02, 38, 33, 01, 30, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA QUOTE  /02, 28, 26, 02, 48, 46, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA POUND  /02, 10, 18, 02, 58, 50, 02, 62, 02, 02
     1           , 06, 66, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA DOLLAR /10, 01, 51, 62, 63, 54, 14, 05, 06, 17
     1           , 67, 02, 38, 30, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA PERCNT /05, 07, 18, 27, 16, 07, 02, 01, 67, 05
     1           , 50, 61, 52, 41, 50, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA AMPERS /11, 60, 06, 07, 18, 48, 46, 02, 01, 10
     1           , 30, 63, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA APOSTR /06, 24, 46, 48, 38, 37, 47, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA LPAREN /04, 40, 22, 26, 48, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA RPAREN /04, 20, 42, 46, 28, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA ASTER  /02, 01, 67, 02, 07, 61, 02, 04, 64, 02
     1           , 37, 31, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA PLUS   /02, 14, 54, 02, 36, 32, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA COMMA  /06, 20, 42, 44, 34, 33, 43, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA MINUS  /02, 14, 54, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA PERIOD /05, 20, 30, 31, 21, 20, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SLASH  /02, 01, 67, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA ZERO   /09, 10, 50, 61, 67, 58, 18, 07, 01, 10
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA ONE    /02, 10, 50, 03, 30, 38, 16, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA TWO    /10, 07, 18, 58, 67, 65, 54, 24, 02, 00
     1           , 60, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA THREE  /07, 07, 18, 58, 67, 65, 54, 34, 06, 54
     1           , 63, 61, 50, 10, 01, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA FOUR   /05, 50, 58, 03, 02, 72, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA FIVE   /10, 01, 10, 40, 62, 63, 45, 05, 08, 68
     1           , 67, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SIX    /11, 04, 54, 63, 61, 50, 10, 01, 06, 28
     1           , 58, 67, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SEVEN  /06, 20, 23, 67, 68, 08, 07, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA EIGHT  /16, 14, 03, 01, 10, 50, 61, 63, 54, 14
     1           , 05, 07, 18, 58, 67, 65, 54, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA NINE   /11, 01, 10, 40, 62, 67, 58, 18, 07, 05
     1           , 14, 64, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA COLON  /05, 22, 32, 33, 23, 22, 05, 26, 36, 37
     1           , 27, 26, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SEMICO /06, 10, 32, 34, 24, 23, 33, 05, 26, 36
     1           , 37, 27, 26, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA LESS   /03, 50, 14, 58, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA EQUALS /02, 12, 52, 02, 16, 56, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA GREATR /03, 10, 54, 18, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA QUESTN /07, 06, 07, 18, 58, 67, 34, 33, 01, 31
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA ATSIGN /13, 54, 45, 34, 43, 54, 64, 66, 48, 28
     1           , 06, 02, 20, 50, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA AUPPER /05, 00, 05, 38, 65, 60, 02, 03, 63, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA BUPPER /06, 00, 50, 61, 63, 54, 14, 05, 08, 58
     1           , 67, 65, 54, 02, 18, 10, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA CUPPER /08, 67, 58, 28, 06, 02, 20, 50, 61, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA DUPPER /06, 00, 40, 62, 66, 48, 08, 02, 18, 10
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA EUPPER /04, 60, 00, 08, 68, 02, 34, 04, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA FUPPER /03, 00, 08, 68, 02, 34, 04, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA GUPPER /10, 67, 58, 28, 06, 02, 20, 50, 61, 64
     1           , 44, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA HUPPER /02, 00, 08, 02, 60, 68, 02, 04, 64, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA IUPPER /02, 10, 50, 02, 30, 38, 02, 18, 58, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA JUPPER /05, 01, 10, 20, 31, 38, 02, 18, 58, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA KUPPER /02, 00, 08, 02, 68, 02, 02, 24, 60, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA LUPPER /03, 08, 00, 60, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA MUPPER /05, 00, 08, 35, 68, 60, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA NUPPER /02, 00, 08, 02, 07, 61, 02, 60, 68, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA OUPPER /09, 20, 40, 62, 66, 48, 28, 06, 02, 20
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA PUPPER /07, 00, 08, 58, 67, 66, 55, 05, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA QUPPER /09, 20, 40, 62, 66, 48, 28, 06, 02, 20
     1           , 02, 33, 60, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA RUPPER /07, 00, 08, 58, 67, 66, 55, 05, 02, 15
     1           , 60, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SUPPER /12, 01, 10, 50, 61, 63, 54, 14, 05, 07
     1           , 18, 58, 67, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA TUPPER /02, 30, 38, 02, 08, 68, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA UUPPER /06, 08, 01, 10, 50, 61, 68, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA VUPPER /05, 08, 03, 30, 63, 68, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA WUPPER /05, 08, 00, 33, 60, 68, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA XUPPER /04, 00, 01, 67, 68, 04, 08, 07, 61, 60
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA YUPPER /03, 08, 35, 68, 02, 35, 30, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA ZUPPER /06, 08, 68, 67, 01, 00, 60, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA LBRACK /04, 40, 20, 28, 48, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA BKSLSH /02, 07, 61, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA RBRACK /04, 20, 40, 48, 28, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA CARET  /03, 05, 38, 65, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA USCORE /02,-01,-61, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA ACCENT /05, 27, 28, 38, 37, 55, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA ALOWER /05, 06, 26, 35, 31, 40, 07, 31, 20, 10
     1           , 01, 02, 13, 33, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA BLOWER /02, 08, 00, 08, 02, 20, 30, 41, 44, 35
     1           , 25, 03, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA CLOWER /08, 41, 30, 10, 01, 04, 15, 35, 44, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA DLOWER /02, 48, 40, 08, 42, 20, 10, 01, 04, 15
     1           , 25, 43, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA ELOWER /10, 40, 10, 01, 04, 15, 35, 44, 43, 32
     1           , 02, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA FLOWER /04, 10, 17, 28, 37, 02, 04, 24, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA GLOWER /11, 40, 10, 01, 04, 15, 35, 44,-41,-23
     1           ,-13,-02, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA HLOWER /02, 00, 08, 05, 03, 25, 35, 44, 40, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA ILOWER /01, 37, 03, 25, 35, 30, 02, 20, 40, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA JLOWER /01, 37, 06, 35,-32,-23,-13,-02,-01, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA KLOWER /02, 08, 00, 02, 01, 45, 03, 40, 22, 23
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA LLOWER /02, 20, 40, 03, 30, 38, 28, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA MLOWER /06, 00, 04, 15, 25, 34, 30, 05, 34, 45
     1           , 55, 64, 60, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA NLOWER /02, 00, 05, 05, 03, 25, 35, 44, 40, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA OLOWER /09, 01, 04, 15, 35, 44, 41, 30, 10, 01
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA PLOWER /02,-03, 05, 08, 03, 25, 35, 44, 41, 30
     1           , 20, 02, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA QLOWER /02,-43, 45, 08, 43, 25, 15, 04, 01, 10
     1           , 20, 42, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA RLOWER /02, 00, 05, 04, 03, 25, 35, 44, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SLOWER /09, 00, 30, 41, 42, 33, 13, 04, 15, 45
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA TLOWER /02, 06, 26, 05, 18, 11, 20, 30, 41, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA ULOWER /05, 05, 01, 10, 20, 42, 02, 40, 45, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA VLOWER /05, 05, 02, 20, 42, 45, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA WLOWER /06, 05, 01, 10, 20, 31, 35, 05, 31, 40
     1           , 50, 61, 65, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA XLOWER /02, 00, 55, 02, 05, 50, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA YLOWER /05, 05, 01, 10, 30, 41, 05, 45,-42,-33
     1           ,-23,-12, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA ZLOWER /04, 05, 55, 00, 50, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA LBRACE /06, 40, 30, 21, 23, 14, 04, 05, 14, 25
     1           , 27, 38, 48, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA ORSIGN /02, 30, 38, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA RBRACE /06, 20, 30, 41, 43, 54, 64, 05, 54, 45
     1           , 47, 38, 28, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA TILDE  /04, 06, 28, 46, 68, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
      DATA SPC127 /00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     1           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
     2           , 00, 00, 00, 00, 00, 00, 00, 00, 00, 00/
	END
	SUBROUTINE GRDOT0 (X,Y)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Draw a single dot (pixel) at a specified
C location.
C
C Arguments:
C
C X, Y (real, input): absolute device coordinates of the dot (these
C	are rounded to the nearest integer by GRDOT0).
C
C (1-Jun-1984)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  I, J
	REAL     X, Y
C
C		(X,Y) is the new current position
C
	GRXPRE(GRCIDE) = X
	GRYPRE(GRCIDE) = Y
C
C		Convert to integer
C
	I = NINT(X)
	J = NINT(Y)
C
C		Check window
C
	IF (I .LT. GRXMIN(GRCIDE)) RETURN
	IF (I .GT. GRXMAX(GRCIDE)) RETURN
	IF (J .LT. GRYMIN(GRCIDE)) RETURN
	IF (J .GT. GRYMAX(GRCIDE)) RETURN
	GRPLTD(GRCIDE) = .TRUE.
C
C		If a "thick pen" is to be simulated, use the
C		line-drawing routines instead.
C
	IF (GRWIDT(GRCIDE).GT.1) THEN
	    CALL GRLIN3(X,Y,X,Y)
C
C		Otherwise call the appropriate device-dependent
C		low level routine to plot the point.
C
	ELSE IF (GRCTYP.EQ.PRTX .OR. GRCTYP.EQ.TRILOG .OR.
     1		 GRCTYP.EQ.VERS ) THEN          
	    CALL GRPR01(I, J, GRPBXD(GRCIDE), GRPBYD(GRCIDE),
     1			%VAL(GRPBAD(GRCIDE)))
	ELSE IF (GRCTYP.EQ.GMFILE) THEN
	    CALL GRMF01(I, J, I, J)
	ELSE IF (GRCTYP.EQ.TEK10 .OR. GRCTYP.EQ.TEK14 .OR.
     1	         GRCTYP.EQ.RETRO .OR. GRCTYP.EQ.ID100) THEN
	    CALL GRTK01(I, J, I, J)
	ELSE IF (GRCTYP.EQ.VT125) THEN
	    CALL GRVT01(I, J, I, J)
	ELSE IF (GRCTYP.EQ.GRINL) THEN
	    CALL GRGR01(I, J, I, J)
	ELSE IF (GRCTYP.EQ.ARGS) THEN
	    CALL GRAR01(I, J, I, J)
        ELSE IF (GRCTYP.EQ.LASER) THEN
            CALL GRQM01(I, J, I, J)
	ELSE IF (GRCTYP.NE.GNULL) THEN
	    CALL GRQUIT('Internal error.')
	END IF
	RETURN
	END
	INTEGER FUNCTION GRDTYP (TEXT)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): determine graphics device type code from
C type name.
C
C Argument:
C
C TEXT (input, character): device type name, eg 'PRINTRONIX'; the name
C	may be abbreviated to uniqueness.
C
C Returns:
C
C GRDTYP (integer): the device type code, in the range 1 to 
C	GRTMAX, or zero if the type name is not legal.
C
C (1-Jun-1984)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INTEGER MAXTYP
	PARAMETER (MAXTYP=16)
	CHARACTER*(*) TEXT
	CHARACTER*10  NAMES(MAXTYP)
	INTEGER  CODES(MAXTYP), I, L
C
	DATA NAMES/'PRINTRONIX', 'TEKTRONIX', 'TEK4010', 'TEK4014',
     1		   'TRILOG', 'VT125', 'GRINNELL', 'VERSATEC',  
     2		   'RETRO', 'NULL', 'ARGS', 'ID100',
     3		   'FILE', 'METAFILE', 'TK4100', 'LASER' /
      DATA CODES/ 1, 3, 3, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 12, 2, 13 /
C
	GRDTYP = 0
C		Check for ambiguous single-letter types
	IF (TEXT.EQ.'V'.OR.TEXT.EQ.'T') RETURN
	L = LEN(TEXT)
c     WRITE(3,100)L
100   FORMAT('   TEXT LENGTH L=',I4)
	IF (TEXT.EQ.' ') RETURN
	DO WHILE (TEXT(L:L).EQ.' ')
		L = L-1
	END DO
	DO I=1,MAXTYP
	    IF (TEXT(1:L).EQ.NAMES(I)(1:L)) THEN
		GRDTYP = CODES(I)
		RETURN
	    END IF
	END DO
	RETURN
	END
	SUBROUTINE GRETEXT
C-----------------------------------------------------------------------
C GRPCKG: Erase the text screen.  Some graphics devices (eg VT125) have
C two superimposed view surfaces, of which one is used for graphics and
C the other for alphanumeric text.  This routine erases the text 
C view surface without affecting the graphics view surface. It does
C nothing if there is no text view surface associated with the device.
C
C Arguments: none.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	CHARACTER*1   ESC
	CHARACTER*(*) VTER
	PARAMETER   (ESC=CHAR(27))
	PARAMETER   (VTER=ESC//'[2J'//ESC//'[H')
C
C		If no device is currently selected, do nothing.
C
	IF (GRCIDE.LT.1) THEN
C
C		VT125.
C
	ELSE IF (GRCTYP.EQ.VT125) THEN
	    CALL GRTERM
	    WRITE (GRUNIT(GRCIDE),'(A)') VTER
C
C		Retro.
C
	ELSE IF (GRCTYP.EQ.RETRO) THEN
	    CALL GRTERM
	    CALL GRTK02(%REF(VTER), LEN(VTER), %VAL(GRPBAD(GRCIDE)))
	    CALL GRTERM
C
C		Other devices are ignored.
C
	END IF
	RETURN
	END
	SUBROUTINE GREXIT
C-----------------------------------------------------------------------
C GRPCKG: Close all open plot devices and files.  This routine is
C declared as an exit handler by GROPEN, to clean up if the user
C fails to call GRCLOS.
C
C Arguments: none.
C
C 13-Apr-1983 - [TJP].
C  2-Jul-1984 - change to call GRSELECT [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  IDENT
C
	DO IDENT=1,GRIMAX
	    IF (GRINIT(IDENT)) THEN
		CALL GRSELECT(IDENT)
		CALL GRCLOS
	    END IF
	END DO
C
	RETURN
	END
	SUBROUTINE GRFA (N,PX,PY)
C-----------------------------------------------------------------------
C GRPCKG: FILL AREA: fill a polygon with solid color.  The polygon
C is defined by the (x,y) world coordinates of its N vertices.  If
C this is not a function supported by the device, shading is
C accomplished by drawing horizontal lines spaced by 1 pixel.  By
C selecting color index 0, the interior of the polygon can be erased
C on devices which permit it.  The polygon need not be convex, but if
C it is re-entrant (i.e., edges intersect other than at the vertices),
C it may not be obvious which regions are "inside" the polygon.  The
C following rule is applied: for a given point, create a straight line 
C starting at the point and going to infinity. If the number of 
C intersections between the straight line and the polygon is odd, the
C point is within the polygon; otherwise it is outside. If the 
C straight line passes a polygon vertex tangentially, the
C intersection  count is not affected. [There is a bug in this version
C of GRFA which fails to apply this rule correctly for some scan lines
C across a re-entrant polygon.] The only attribute which applies to
C FILL AREA is color index: line-width and line-style are ignored. 
C There is a limitation on the complexity of the polygon: GFA will
C fail if any horizontal line intersects more than 32 edges of the
C polygon. 
C
C Arguments:
C
C N (input, integer): the number of vertices of the polygon (at least
C	3).
C PX, PY (input, real arrays, dimension at least N): world coordinates
C	of the N vertices of the polygon.
C
C 16-Jul-1984 - [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER MAXSECT
	PARAMETER (MAXSECT=32)
	INTEGER  I, J, N, NSECT, LW, LS
	REAL     X(MAXSECT), PX(*), PY(*), Y, YMIN, YMAX
 	REAL	 TEMP, S1,S2, T1,T2
C
	IF (GRCIDE.LT.1) RETURN
	IF (N.LT.3) THEN
	    CALL GRWARN('GRFA - polygon has < 3 vertices.')
	    RETURN
	END IF
C
C		Special treatment for Metafile device.
C
	IF (GRCTYP.EQ.GMFILE) THEN
	    CALL GRMF02(1,'A701'X,%VAL(GRPBAD(GRCIDE)))
	    CALL GRMF02(1,N,      %VAL(GRPBAD(GRCIDE)))
	    CALL GRMOVA(PX(1),PY(1))
	    DO I=2,N
		CALL GRLINA(PX(I),PY(I))
	    END DO
	    RETURN
C
C		Special treatment for Null device.
C
	ELSE IF (GRCTYP.EQ.GNULL) THEN
	    RETURN
	END IF
C
C		For other devices fill area is simulated.
C
C		Save attributes.
C
	CALL GRINQLS(LS)
	CALL GRINQLW(LW)
	CALL GRSETLS(1)
	CALL GRSETLW(1)
C
C		Find range of raster-lines to be shaded.
C
	YMIN = PY(1)
	YMAX = YMIN
	DO I=2,N
	    TEMP = PY(I)
	    YMIN = MIN(YMIN,TEMP)
	    YMAX = MAX(YMAX,TEMP)
	END DO
	YMIN = YMIN*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
	YMAX = YMAX*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
C
C		Find intersections of edges with current raster line.
C
	DO Y=YMIN,YMAX
	    NSECT = 0
	    DO I=2,N+1
		IF (I.GT.N) THEN
		    S1 = PX(N)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
		    S2 = PX(1)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
		    T1 = PY(N)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
		    T2 = PY(1)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
		ELSE
		    S1 = PX(I-1)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
		    S2 = PX(I)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
		    T1 = PY(I-1)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
		    T2 = PY(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
		END IF
		IF ((T1.LT.Y .AND. Y.LE.T2).OR.
     1		    (T1.GT.Y .AND. Y.GE.T2)) THEN

		    NSECT = NSECT+1
		    IF (NSECT.GT.MAXSECT) THEN
			CALL GRWARN('GRFA - polygon is too complex.')
			RETURN
		    END IF
		    X(NSECT) = S1 + (S2-S1)*(Y-T1)/(T2-T1)
		END IF
	    END DO
C
C		Sort the intersections into increasing x order.
C
	    DO I=2,NSECT
	    DO J=1,I
		IF (X(J).GT.X(I)) THEN
		    TEMP = X(J)
		    X(J) = X(I)
		    X(I) = TEMP
		END IF
	    END DO
	    END DO
C
C		Draw the horizontal line-segments.
C
	    DO I=1,NSECT-1,2
		GRXPRE(GRCIDE) = X(I)
		GRYPRE(GRCIDE) = Y
		CALL GRLIN0(X(I+1),Y)
	    END DO
	END DO
C
C		Restore attributes.
C
	CALL GRSETLS(LS)
	CALL GRSETLW(LW)
	RETURN
	END
	INTEGER FUNCTION GRGETC (CHAN)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): read a single character from a terminal.
C Normal ASCII characters are returned as the corresponding integer 
C codes. Escape sequences generated by the VT100 are recognised and
C returned as negative integer codes.  Some characters (eg control-U,
C control-R, delete, control-C, control-Y) are normally intercepted
C by the operating system and cannot be read with GRGETC.
C
C Argument:
C
C CHAN (input, integer): the channel number assigned to the terminal;
C	this must have been previously assigned by SYS$ASSIGN.
C
C Returns:
C
C GRGETC (integer): either a positive number (0-127) equal to
C	the ASCII code of the character read, or a negative number, as
C	follows, if one of the VT100 escape sequences has been read:
C	 UP ARROW, DOWN ARROW, RIGHT ARROW, LEFT ARROW: -1,-2,-3,-4;
C	 PF1, PF2, PF3, PF4: -11,-12,-13,-14.
C	If the terminal is in "alternate keypad mode", the following
C	codes are generated by typing the keypad keys:
C	 Keypad digits 0 through 9: -20 through -29;
C	 Keypad ENTER: -8;
C	 Keypad comma, minus, period: -16,-17,-18.
C	If an unrecognized escape sequence is received, GRGETC is set
C	 to zero.
C
C (7-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT  NONE
	INCLUDE   '($IODEF)'
	INCLUDE   '($SSDEF)'
	INTEGER   IOFUNC
	PARAMETER (IOFUNC=IO$_READVBLK.OR.IO$M_NOECHO.OR.IO$M_ESCAPE)
	INTEGER   CHAN, IER, SYS$QIOW, TERMSK(2), J
	INTEGER*2 IOSB(4), CODE_TABLE(22)
	BYTE	  TERMCH(32),BUFFER(20), VALID_TABLE(22)
	DATA      TERMCH/32*'FF'X/
	DATA	  TERMSK(1) / 32 /
C
C		Valid escape sequences are <esc> O or <esc> [
C		followed by one of the characters in VALID_TABLE;
C		CODE_TABLE contains the corresponding integer codes
C		returned by GRGETC.
C
	DATA VALID_TABLE/ 'A','B','C','D',  'P','Q','R','S',
     1		'p','q','r','s','t','u','v','w','x','y',
     2		'm','l','n', 'M'/
	DATA CODE_TABLE/ -1,-2,-3,-4, -11,-12,-13,-14,
     1		-20,-21,-22,-23,-24,-25,-26,-27,-28,-29,
     2		-17,-16,-18, -8/
C
C		Read a single character; all characters are
C		terminators, and escape sequences are recognised.
C
	TERMSK(2) = %LOC(TERMCH)
	IER = SYS$QIOW(, %VAL(CHAN), %VAL(IOFUNC), IOSB, , ,
     1	              BUFFER, 	! P1 (buffer address)
     2		      %VAL(20),	! P2 (buffer size)
     3		      ,		! P3 (timeout count)
     4		      TERMSK,	! P4 (read terminator descr.block)
     5		      ,		! P5 (prompt buffer address)
     6		      )		! P6 (prompt buffer size)
	IF (IER.NE.1) THEN
	    CALL GRGMSG(IER)
	    CALL GRQUIT('Fatal error.')
	END IF
C
C		If terminator is a single character, return it.
C
	IF (IOSB(4).EQ.1) THEN
	    GRGETC = BUFFER(1)
	    RETURN
C
C		If terminator is an escape sequence, interpret it.
C
	ELSE IF ((BUFFER(1).EQ.27) .AND.
     1	        (BUFFER(2).EQ.79 .OR. BUFFER(2).EQ.91)) THEN
	    DO J=1,22
		IF (BUFFER(3).EQ.VALID_TABLE(J)) THEN
		    GRGETC = CODE_TABLE(J)
		    RETURN
		END IF
	    END DO
	END IF
C
C		Otherwise, return zero.
C
	GRGETC = 0
	RETURN
	END
	SUBROUTINE GRGMSG (STATUS)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Print system message corresponding to code
C STATUS on SYS$OUTPUT.
C
C Argument:
C
C STATUS (input, integer): 32-bit system message code.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	CHARACTER*80 BUFFER
	INTEGER  LENGTH, MSGLEN, STATUS
C
	CALL SYS$GETMSG(%VAL(STATUS),MSGLEN,BUFFER,%VAL(1),)
	LENGTH = INDEX(BUFFER(1:MSGLEN),'!')
	IF (LENGTH.GT.1) MSGLEN = LENGTH-1
	CALL GRWARN(BUFFER(1:MSGLEN))
	RETURN
	END
	SUBROUTINE GRGR01 (I0,J0,I1,J1)
C-----------------------------------------------------------------------
C GRPCKG (internal routine, Grinnell): draw a line segment.
C
C Arguments:
C
C I0,J0 (integer*2, input): the column and row numbers of the starting
C	point.
C I1,J1 (integer*2, input): the column and row numbers of the end point.
C
C Note: the arguments are specified as integer*2, but (on the VAX at
C least) integer*4 values may be used. The values should be in the
C range defined by the hardware: (0...511).
C
C (11-Apr-1983)
C-----------------------------------------------------------------------
	IMPLICIT INTEGER*2 (A-Z)
	INTEGER*2 GRNLBF(4)
	INCLUDE 'GRPCKG1.INC'
C
	CLIP511(X) = X .AND. '1FF'X
C
	IC0 = CLIP511(I0)
	JC0 = CLIP511(J0)
	IC1 = CLIP511(I1)
	JC1 = CLIP511(J1)
	DX = CLIP511(IC1-IC0)
	DY = CLIP511(JC1-JC0)
C
C		Assume Grinnell has already been initialized for
C		vector drawing (LWM) and SPD 0 has been selected,
C		and appropriate channels have been selected
C
	GRNLBF(1) = '4800'X .OR. IC0	! LEA
	GRNLBF(2) = '5000'X .OR. DX	! LEB
	GRNLBF(3) = '6800'X .OR. JC0	! LLA
	GRNLBF(4) = '7400'X .OR. DY	! LLB (W=1)
	CALL GRGR02(GRNLBF,4,%VAL(GRPBAD(GRCIDE)))
	RETURN
	END
	SUBROUTINE GRGR02 (INSTR,N,BUFFER)
C-----------------------------------------------------------------------
C GRPCKG (internal routine, Grinnell): transfer N 16-bit words to the
C output buffer, flushing the buffer as necessary.
C
C Arguments:
C
C INSTR (integer*2 array, dimension at least N, input): the instruction
C	words to be put in the output buffer.
C N (integer, input): the number of words to transfer.
C BUFFER (integer*2 array, input/output): (address of) output buffer;
C	the current location in the buffer is maintained in common
C	variable GRBHWM(GRCIDE).
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  I,N
	INTEGER*2 INSTR(*), BUFFER(*)
C
	DO I=1,N
	    IF (GRBHWM(GRCIDE).GE.GRPBXD(GRCIDE)) CALL 
     1		GRGR03(%VAL(GRPBAD(GRCIDE)))
	    GRBHWM(GRCIDE) = GRBHWM(GRCIDE)+2
	    BUFFER(GRBHWM(GRCIDE)/2) = INSTR(I)
	END DO
	RETURN
	END
	SUBROUTINE GRGR03 (BUFFER)
C-----------------------------------------------------------------------
C	GRPCKG (Grinnell): flush buffer contents.  BUFFER is passed as
C	an argument because it is a dynamic array.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	BYTE BUFFER(*)
C
	INCLUDE 'GRPCKG1.INC'
	INCLUDE '($IODEF)'
	INCLUDE '($SSDEF)'
C
	INTEGER SYS$QIOW
C
	INTEGER RESULT
	INTEGER IOSB(2)
	INTEGER*2 STBC(2), STATUS, COUNT
	EQUIVALENCE (STBC, IOSB(1)), (STATUS, STBC(1)), (COUNT, STBC(2))
C
	N = GRBHWM(GRCIDE)
	GRBHWM(GRCIDE) = 0
	IF (N.LT.1) RETURN
	RESULT = SYS$QIOW(,%VAL(GRUNIT(GRCIDE)),
     1		%VAL(IO$_WRITEVBLK.OR.IO$M_SETFNCT),IOSB,,
     2		,BUFFER,%VAL(N),,%VAL(0),,)
	IF (RESULT.NE.SS$_NORMAL) THEN
	    CALL GRGMSG(RESULT)
	    CALL GRQUIT('SYS$QIOW failure writing to Grinnell')
	END IF
	IF (STATUS.NE.SS$_NORMAL) THEN
	    RESULT = STATUS
	    CALL GRGMSG(RESULT)
	    CALL GRQUIT('SYS$QIOW failure writing to Grinnell')
	END IF
	RETURN
	END
	SUBROUTINE GRGR10
C-----------------------------------------------------------------------
C GRPCKG (Grinnell): Initialize the display. Note that the screen is
C NOT erased. The color tables are initialized as follows:
C
C Index	Name			   (H,L,S)		   (R,G,B)
C
C  0	Black			  0, 0.0, 0.0		0.0, 0.0, 0.0
C  1	White			  0, 1.0, 0.0		1.0, 1.0, 1.0
C  2	Red			120, 0.5, 1.0		1.0, 0.0, 0.0
C  3	Green			240, 0.5, 1.0		0.0, 1.0, 0.0
C  4	Blue			  0, 0.5, 1.0		0.0, 0.0, 1.0
C  5	Cyan    (Green+Blue)	300, 0.5, 1.0		0.0, 1.0, 1.0
C  6	Magenta (Red+Blue)	 60, 0.5, 1.0		1.0, 0.0, 1.0
C  7	Yellow  (Red+Green)	180, 0.5, 1.0		1.0, 1.0, 0.0
C  8	Red+Yellow (Orange)	150, 0.5, 1.0		1.0, 0.5, 0.0
C  9	Green+Yellow		210, 0.5, 1.0		0.5, 1.0, 0.0
C 10	Green+Cyan		270, 0.5, 1.0		0.0, 1.0, 0.5
C 11	Blue+Cyan		330, 0.5, 1.0		0.0, 0.5, 1.0
C 12	Blue+Magenta		 30, 0.5, 1.0		0.5, 0.0, 1.0
C 13	Red+Magenta		 90, 0.5, 1.0		1.0, 0.0, 0.5
C 14	Dark Gray		  0, .33, 0.0		.33, .33, .33
C 15	Light Gray		  0, .66, 0.0		.66, .66, .66
C
C Arguments: none.
C
C 26-Jul-1984 - [TJP].
C-----------------------------------------------------------------------
	IMPLICIT  NONE
	INCLUDE   'GRPCKG1.INC'
	INTEGER*2 GRNLBF(17), GCTABL(3,0:15)
	INTEGER   I
C
	DATA GCTABL /000,000,000, 255,255,255, 255,000,000, 000,255,000,
     1		     000,000,255, 000,255,255, 255,000,255, 255,255,000,
     2		     255,128,000, 128,255,000, 000,255,128, 000,128,255,
     3		     128,000,255, 255,000,128, 085,085,085, 170,170,170/
C
	GRNLBF(1) = 'A001'X		! SPD 1 (image function video)
	GRNLBF(2) = 'C800'X		! LPR4  (select ABC channels)
	GRNLBF(3) = 'CA00'X		! LPR5  (no bypass or invert)
	CALL GRGR02(GRNLBF,3,%VAL(GRPBAD(GRCIDE)))
	GRNLBF(1) = 'B000'X		! LPA (table A) (red)
	DO I=0,15
		GRNLBF(I+2)  = 'D000'X.OR.GCTABL(1,I)
	END DO
	CALL GRGR02(GRNLBF,17,%VAL(GRPBAD(GRCIDE)))
	GRNLBF(1) = 'B400'X		! LPA (table B) (green)
	DO I=0,15
		GRNLBF(I+2)  = 'D000'X.OR.GCTABL(2,I)
	END DO
	CALL GRGR02(GRNLBF,17,%VAL(GRPBAD(GRCIDE)))
	GRNLBF(1) = 'B800'X		! LPA (table C) (blue)
	DO I=0,15
		GRNLBF(I+2)  = 'D000'X.OR.GCTABL(3,I)
	END DO
	CALL GRGR02(GRNLBF,17,%VAL(GRPBAD(GRCIDE)))
	GRNLBF(1) = 'A008'X		! SPD 8 (zoom/pan)
	GRNLBF(2) = 'B000'X
	GRNLBF(3) = 'B000'X
	GRNLBF(4) = 'D000'X
	GRNLBF(5) = 'C004'X
	GRNLBF(6) = 'A080'X		! SPD 80 (cursor)
	GRNLBF(7) = 'C000'X		! all cursors off
	GRNLBF(8) = 'A000'X		! SPD 0
	GRNLBF(9) = '10FF'X		! LSM FF
	GRNLBF(10) = '80FF'X		! LDC FF
	GRNLBF(11) = '2830'X		! LWM (R0,A0,Z1,V1,H0,W0)
	GRNLBF(12) = '1001'X 		! LSM <color=1>
	CALL GRGR02(GRNLBF,12,%VAL(GRPBAD(GRCIDE)))
	RETURN
	END
	SUBROUTINE GRGTC0 (CHAR,CENTER,POINTS,X,Y,MORE)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): obtain character digitization.
C
C (10-Feb-1983)
C-----------------------------------------------------------------------
	EXTERNAL GRDAT2
	LOGICAL CENTER
	INTEGER POINTS, CHAR
	REAL X(1)
	REAL Y(1)
	LOGICAL MORE
C
	INTEGER CINDX1, CINDX2
	PARAMETER CTD1 = 30, CTD2 = 128
	LOGICAL*1 CHTBL(CTD1, CTD2)
	COMMON /GRCS02/ CINDX1, CINDX2, CHTBL
C
C**********  LOCAL VARIABLES  **********
C
	INTEGER I
	INTEGER COORDS
	LOGICAL TAILED
C
	IF (CINDX2.LE.0) CINDX2 = CHAR + 1
C
C		Get the next segment of the character
C
	POINTS = CHTBL(CINDX1, CINDX2)
      IF(POINTS .EQ. 0) GO TO 240
      DO 220 I = 1, POINTS
          CINDX1 = CINDX1 + 1
          COORDS = CHTBL(CINDX1, CINDX2)
          TAILED = COORDS .LT. 0
          IF(TAILED) COORDS = IABS(COORDS)
          X(I) = FLOAT(COORDS / 10)
          Y(I) = FLOAT(MOD(COORDS, 10))
          IF(TAILED) Y(I) = - Y(I)
          IF(.NOT. CENTER) GO TO 220
          X(I) = X(I) - 3.0
          Y(I) = Y(I) - 4.0
  220     CONTINUE
  240 CONTINUE
C
C**********  SET STATUS AND RETURN  **********
C
  300 IF(CINDX1 .EQ. CTD1) GO TO 320
      CINDX1 = CINDX1 + 1
      IF(CHTBL(CINDX1, CINDX2) .EQ. 0) GO TO 320
      MORE = .TRUE.
      RETURN
  320 MORE = .FALSE.
      CINDX1 = 1
      CINDX2 = 0
	RETURN
	END
	INTEGER FUNCTION GRIBF0
C-----------------------------------------------------------------------
C GRPCKG (internal routine): obtain dynamic memory for a plot
C buffer.  Printer devices have a two-dimensional buffer of GRPBXD
C by GRPBYD bytes, initialized with blank plot codes.  Terminal
C devices have a one-dimensional buffer of GRPBXD bytes.
C
C Returns:
C
C GRIBF0 (integer, output): 1 => successful completion, any other
C		value indicates that an error occurred.
C
C (1-Jun-1984)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE 'GRPCKG1.INC'
	INTEGER BITS, LIB$FREE_VM, LIB$GET_VM, NEWSIZ, OLDSIZ, RESULT
	INTEGER XDIM, YDIM
	BYTE    BLANK
C
C		Assume success
C
	GRIBF0 = 1
C
C		Bit-map devices.
C
	IF (GRCTYP.EQ.PRTX .OR. GRCTYP.EQ.TRILOG .OR. GRCTYP.EQ.VERS 
     1		.OR. GRCTYP.EQ.LASER)THEN
	    IF (GRCTYP.EQ.VERS) THEN
		BITS = 8
		BLANK = '00'X
	    ELSE IF(GRCTYP.EQ.LASER) THEN
                BITS = 8                    ! BACK TO 8
                BLANK = '00'X
            ELSE
		BITS = 6
		BLANK = 'C0'X
	    END IF
	    XDIM = GRXMXA(GRCIDE)/BITS + 1
	    YDIM = GRYMXA(GRCIDE)      + 1
	    NEWSIZ = XDIM * YDIM
            IF(GRCTYP.EQ.LASER)NEWSIZ=NEWSIZ/100
C           WRITE(3,100)XDIM,YDIM,GRCIDE,NEWSIZ
C100      FORMAT(' IN GRIBF0 XDIM=',I12,' YDIM=',I12,' GRCIDE=',I3
C    +   ' NEWSIZ=',I10)
	    IF (.NOT. GRINIT(GRCIDE)) GO TO 220
	    OLDSIZ = GRPBXD(GRCIDE) * GRPBYD(GRCIDE)
            IF (GRCTYP.EQ.LASER)OLDSIZ=OLDSIZ/10
C           WRITE(3,101)OLDSIZ,NEWSIZ
C101         FORMAT('  IN GRIBF0 OLDSIZ=',I12,'  NEWSIZ=',I12)
	    IF (OLDSIZ .EQ. NEWSIZ) GO TO 230
	    RESULT = LIB$FREE_VM(OLDSIZ, GRPBAD(GRCIDE))
	    IF (RESULT.NE.1) THEN
		CALL GRGMSG(RESULT)
		CALL GRWARN('Failed to deallocate plot buffer.')
		GRIBF0 = RESULT
	  	RETURN
	    END IF
  220	    RESULT = LIB$GET_VM(NEWSIZ, GRPBAD(GRCIDE))
	    IF (RESULT.NE.1) THEN
		CALL GRGMSG(RESULT)
		CALL GRWARN('Failed to allocate plot buffer.')
		GRIBF0 = RESULT
	  	RETURN
	    END IF
C           WRITE(3,102)%VAL(GRPBAD(GRCIDE))
C102       FORMAT(' IN GRIBF0 BUFFER ADDRESS=',I10)
  230	    CALL GRIBF1(NEWSIZ, %VAL(GRPBAD(GRCIDE)),BLANK)
C
C		Other devices.
C
	ELSE IF (GRCTYP.EQ.TEK10 .OR. GRCTYP.EQ.TEK14 .OR.
     1		 GRCTYP.EQ.VT125 .OR. GRCTYP.EQ.GRINL .OR.
     2		 GRCTYP.EQ.RETRO .OR. GRCTYP.EQ.ARGS  .OR.
     3		 GRCTYP.EQ.ID100 .OR. GRCTYP.EQ.GMFILE) THEN
	    IF (GRINIT(GRCIDE)) RETURN
	    XDIM = GRTBSZ
	    IF (GRCTYP.EQ.VT125) XDIM = GRVBSZ
	    IF (GRCTYP.EQ.GRINL) XDIM = GRGBSZ
	    IF (GRCTYP.EQ.ARGS) XDIM = GRGBSZ
	    IF (GRCTYP.EQ.GMFILE) XDIM = GRFBSZ
	    YDIM = 0
	    RESULT = LIB$GET_VM(XDIM, GRPBAD(GRCIDE))
	    IF (RESULT.NE.1) THEN
		CALL GRGMSG(RESULT)
		CALL GRWARN('Failed to allocate plot buffer.')
		GRIBF0 = RESULT
	  	RETURN
	    END IF
	ELSE IF (GRCTYP.NE.GNULL) THEN
	    CALL GRQUIT('Internal error.')
	END IF
C
C		Install the buffer parameters
C
	GRPBXD(GRCIDE) = XDIM
	GRPBYD(GRCIDE) = YDIM
	RETURN
	END
	SUBROUTINE GRIBF1 (BUFSIZ,BUFFER,FILL)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): fill a buffer with a given character.
C
C Arguments:
C
C BUFFER (byte array, input): (address of) the buffer.
C BUFSIZ (integer, input): number of bytes in BUFFER.
C FILL (byte, input): the fill character. BUFSIZ bytes starting at
C	address BUFFER are set to contents of FILL.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INTEGER  BUFSIZ, I
	BYTE     BUFFER(BUFSIZ), FILL
C
	DO I=1,BUFSIZ
            BUFFER(I) = FILL
	END DO
	RETURN
	END
	SUBROUTINE GRINQCOL (C)
C-----------------------------------------------------------------------
C GRPCKG: obtain the color index of the current graphics device.
C
C Argument:
C
C C (integer, output): receives the current color index (0-255).
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  C
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRINQCOL - no graphics device is active.')
	    C = 1
	ELSE
	    C = GRCCOL(GRCIDE)
	END IF
	RETURN
	END
	SUBROUTINE GRINQDEV (DEVICE)
C-----------------------------------------------------------------------
C GRPCKG: obtain the name and type of the current graphics device.
C
C Argument:
C
C DEVICE (output, character): receives the device name and type of the 
C	currently active device in the form 'device/type'; this is a
C	valid string for input to GROPEN.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT  NONE
	INCLUDE   'GRPCKG1.INC'
	CHARACTER*(*) DEVICE
	CHARACTER*14 TYPE
	LOGICAL   JUNK 
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRINQDEV - no graphics device is active.')
	    DEVICE = '/NULL'
	ELSE
	    CALL GRINQTYP(TYPE,JUNK)
	    IF (GRFNLN(GRCIDE).GT.0) THEN
		DEVICE = GRFILE(GRCIDE)(1:GRFNLN(GRCIDE))//'/'//TYPE
	    ELSE
		DEVICE = '/'//TYPE
	    END IF
	END IF
	RETURN
	END
	SUBROUTINE GRINQFONT (IF)
C-----------------------------------------------------------------------
C GRPCKG: obtain the font number of the current graphics device.
C
C Argument:
C
C IF (integer, output): receives the current font number (1-3).
C
C (19-Mar-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  IF
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRINQFONT - no graphics device is active.')
	    IF = 1
	ELSE
	    IF = GRCFNT(GRCIDE)
	END IF
	RETURN
	END
	SUBROUTINE GRINQLI (INTEN)
C-----------------------------------------------------------------------
C GRPCKG: obtain the line intensity of the current graphics device.
C
C Argument:
C
C INTEN (integer, output): receives the current line intensity (0-3).
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  INTEN
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRINQLI - no graphics device is active.')
	    INTEN = 3
	ELSE
	    INTEN = GRINTN(GRCIDE)
	END IF
	RETURN
	END
	SUBROUTINE GRINQLS (ISTYLE)
C-----------------------------------------------------------------------
C GRPCKG: obtain the line-style of the current graphics device.
C
C Argument:
C
C ISTYLE (integer, output): receives the current line-style code.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  ISTYLE
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRINQLS - no graphics device is active.')
	    ISTYLE = 1
	ELSE
	    ISTYLE = GRSTYL(GRCIDE)
	END IF
	RETURN
	END
	SUBROUTINE GRINQLW (IWIDTH)
C-----------------------------------------------------------------------
C GRPCKG: obtain the line-width of the current graphics device.
C
C Argument:
C
C IWIDTH (integer, output): receives the current line-width.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  IWIDTH
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRINQLW - no graphics device is active.')
	    IWIDTH = 1
	ELSE
	    IWIDTH = ABS(GRWIDT(GRCIDE))
	END IF
	RETURN
	END
	SUBROUTINE GRINQPEN (IP)
C-----------------------------------------------------------------------
C GRPCKG: obtain the pen number of the current graphics device.
C
C Argument:
C
C IP (integer, output): receives the current pen index (0-255).
C
C 6-Jun-1984 - [TJP].

C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  IP
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRINQPEN - no graphics device is active.')
	    IP = 0
	ELSE
	    IP = GRCPEN(GRCIDE)
	END IF
	RETURN
	END
	SUBROUTINE GRINQTYP (TYPE,INTER)
C-----------------------------------------------------------------------
C GRPCKG: obtain the device type of the currently selected graphics
C device, and determine whether or not it is an interactive device.
C
C Arguments:
C
C TYPE (output, CHARACTER*(*)): receives the device type, as a
C	character string, eg 'PRINTRONIX', 'TRILOG', 'VERSATEC',
C	'TEK4010', 'TEK4014', 'GRINNELL', or 'VT125'.  The character
C	string should have a length of at least 8 to ensure that the
C	type is unique.
C INTER (output, LOGICAL*4): receives the value .TRUE. if the device is
C	interactive, .FALSE. otherwise.  Interactive devices are
C	terminals and Grinnells, which are capable of graphical input;
C	non-interactive devices include the printers, metafiles, and
C	the null device.
C
C (23-May-1983)
C-----------------------------------------------------------------------
	IMPLICIT  NONE
	INCLUDE   'GRPCKG1.INC'
	CHARACTER*(*) TYPE
	LOGICAL   INTER, GRCHKT
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRINQTYP - no graphics device is active.')
	    TYPE = 'NULL'
	    INTER = .FALSE.
	ELSE
	    TYPE = GRTYPN(GRCTYP)
	    INTER = GRKIND(GRCTYP)
	    IF (GRCTYP.EQ.VT125) INTER = GRCHKT(GRFILE(GRCIDE))
	END IF
	RETURN
	END
	SUBROUTINE GRLEN (STRING, D)
C-----------------------------------------------------------------------
C GRPCKG: length of text string (absolute units)
C
C (3-Mar-1983)
C-----------------------------------------------------------------------
	INCLUDE 'GRPCKG1.INC'
	LOGICAL UNUSED
	INTEGER*2 XYGRID(300)
	INTEGER   LIST(256)
	CHARACTER*(*) STRING
C
C**********  LOCAL VARIABLES  **********
C
	REAL ANGLE, FACTOR
	REAL COSA, SINA
	REAL DX, DY
	REAL XORG, YORG
	INTEGER XMIN, XMAX, YMIN, YMAX
	INTEGER MODE,LSTYLE
	INTEGER I, J
	INTEGER POINTS
	LOGICAL MORE
	REAL XT, YT
C
	D = 0.0
	IF (LEN(STRING).LE.0) RETURN
C-----------------------------------------------------------------------
C		Compute scaling and orientation
C-----------------------------------------------------------------------
	FACTOR = GRCFAC(GRCIDE)/2.5
	RATIO = GRXPIN(GRCTYP)/GRYPIN(GRCTYP)
	COSA = FACTOR 
	SINA = 0.0
	FNTBAS = 0.0
	FNTFAC = 1.0
	IFNTLV = 0
C
C		Convert string to symbol numbers:
C		\u and \d escape sequences are converted to -1,-2
C
	CALL GRSYMDS(LIST,NLIST,STRING)
C
C		Plot the string of characters
C
	DO 380 I = 1,NLIST
	    IF (LIST(I).LT.0) THEN
		IF (LIST(I).EQ.-1) THEN
		    IFNTLV = IFNTLV+1
		    FNTBAS = FNTBAS + 16.0*FNTFAC
		    FNTFAC = 0.6**IABS(IFNTLV)
		ELSE IF (LIST(I).EQ.-2) THEN
		    IFNTLV = IFNTLV-1
		    FNTFAC = 0.6**IABS(IFNTLV)
		    FNTBAS = FNTBAS - 16.0*FNTFAC
		END IF
	        GOTO 380
	    END IF
	    CALL GRSYMXD(LIST(I),XYGRID,UNUSED)
	    LX = XYGRID(5)-XYGRID(4)
	    DX = COSA*LX*RATIO
  330	    D = D + DX*FNTFAC
  380   CONTINUE
C
	RETURN
	END
	SUBROUTINE GRLGTR (NAME)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): recursive translation of a logical name.
C Up to 20 levels of equivalencing can be handled.
C
C Argument:
C
C NAME (character, input/output): initially contains the name to be
C	inspected.  If an equivalence is found it will be replaced
C 	with the new name. If not, the old name will be left there. The
C	escape sequence at the beginning of process-permanent file
C	names is deleted and the '_' character at the beginning of
C	device names is left in place. 
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE '($SSDEF)'
	CHARACTER*(*) NAME
	INTEGER I, LENGTH, RET, SYS$TRNLOG 
C
	DO I=1,20
	    IF (NAME.EQ.' ') RETURN
	    CALL STR$UPCASE(NAME,NAME)
	    IF (NAME(1:1) .EQ. '_') RETURN
	    LENGTH = LEN(NAME)
	    DO WHILE (NAME(LENGTH:LENGTH).EQ.' ')
	    	LENGTH = LENGTH-1
	    END DO
	    RET = SYS$TRNLOG( NAME(1:LENGTH), LENGTH, NAME, , ,)
	    NAME(LENGTH+1:) = ' '
	    IF (RET .EQ. SS$_NOTRAN) RETURN
	    IF (.NOT.RET) THEN
	    	CALL GRGMSG(RET)
	    	RETURN
	    END IF
	    IF (ICHAR(NAME(1:1)) .EQ. 27) NAME = NAME(5:) !Delete Esc
	END DO
	RETURN
	END
	SUBROUTINE GRLIN0 (XP,YP)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): draw a line from the current position to a
C specified position, which becomes the new current position. This
C routine takes care of clipping at the viewport boundary, dashed and
C thick lines.
C
C Arguments:
C
C XP, YP (input, real): absolute device coordinates of the end-point of
C	the line.
C
C 13-Jul-1984
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	LOGICAL  VIS
	REAL     XP,YP, X0,Y0, X1,Y1
C
C		End-points of line are (X0,Y0), (X1,Y1).
C
	X0 = GRXPRE(GRCIDE)
	Y0 = GRYPRE(GRCIDE)
	X1 = XP
	Y1 = YP
	GRXPRE(GRCIDE) = X1
	GRYPRE(GRCIDE) = Y1
C
C		Change the end-points of the line (X0,Y0) - (X1,Y1)
C		to clip the line at the window boundary.
C
	CALL GRCLPL(X0,Y0,X1,Y1,VIS)
	IF (.NOT.VIS) RETURN
C
C		Draw the line in the appropriate style.
C
	IF (GRDASH(GRCIDE)) THEN
	    CALL GRLIN1(X0,Y0,X1,Y1,.FALSE.)	! dashed line
	ELSE IF (GRWIDT(GRCIDE).GT.1) THEN
	    CALL GRLIN3(X0,Y0,X1,Y1)		! heavy line
	ELSE
	    CALL GRLIN2(X0,Y0,X1,Y1)		! full line
	END IF
	RETURN
	END
	SUBROUTINE GRLIN1 (X0,Y0,X1,Y1,RESET)
C-----------------------------------------------------------------------
C	GRPCKG : dashed line.
C	Generate a visible dashed line between points (X0,Y0) and 
C	(X1,Y1) according to the dash pattern stored in common.
C	If RESET = .TRUE., the pattern will start from the beginning.
C	Otherwise, it will continue from its last position.
C     DASHED LINE PATTERN ARRAY CONTAINING LENGTHS OF
C          MARKS AND SPACES IN UNIT CUBE: GRPATN(*)
C     OFFSET IN CURRENT PATTERN SEGMENT: GRPOFF
C     CURRENT PATTERN SEGMENT NUMBER: GRIPAT
C     NUMBER OF PATTERN SEGMENTS: 8
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	INCLUDE 'GRPCKG1.INC'
C
	LOGICAL RESET
	INTEGER THICK
	ADJUST(ARG1,ARG2,ALFARG) = ALFARG*(ARG2 - ARG1) + ARG1
C
	THICK = GRWIDT(GRCIDE)
	SCALE = SQRT(FLOAT(THICK))
	IF (RESET) THEN
	    GRPOFF(GRCIDE) = 0.0
	    GRIPAT(GRCIDE) = 1
	END IF
	SEGLEN = SQRT((X1-X0)**2 + (Y1-Y0)**2)
	IF (SEGLEN .EQ. 0.0) RETURN
	DS = 0.0
C 
C	Repeat until (ALPHA2 .GE. 1.0)
C 
C	Line segments matching the pattern segments are determined
C	by finding values (ALPHA1,ALPHA2) defining the start and end
C	of the segment in the parametric equation (1-ALPHA)*P1 + ALPHA*P2
C	defining the line.  DS measures the progress along the line
C	segment and defines the starting ALPHA1.  The ending ALPHA2
C	is computed from the end of the current pattern mark or space
C	or the segment end, whichever comes first.
C 
   10	DSOLD = DS
	ALPHA1 = DS/SEGLEN
	ALPHA2 = AMIN1(1.0,(DS+SCALE*GRPATN(GRCIDE,GRIPAT(GRCIDE))-
     1		 GRPOFF(GRCIDE))/SEGLEN)
	IF (MOD(GRIPAT(GRCIDE),2) .NE. 0) THEN
	    XP = ADJUST(X0,X1,ALPHA1)
	    YP = ADJUST(Y0,Y1,ALPHA1)
	    XQ = ADJUST(X0,X1,ALPHA2)
	    YQ = ADJUST(Y0,Y1,ALPHA2)
	    IF (THICK.GT.1) THEN
		CALL GRLIN3(XP,YP,XQ,YQ)
	    ELSE
		CALL GRLIN2(XP,YP,XQ,YQ)
	    END IF
	END IF
	DS = ALPHA2*SEGLEN
	IF (ALPHA2 .GE. 1.0) THEN
	    GRPOFF(GRCIDE) = GRPOFF(GRCIDE) + DS - DSOLD
	    RETURN
	END IF
	GRIPAT(GRCIDE) = MOD(GRIPAT(GRCIDE),8) + 1
	GRPOFF(GRCIDE) = 0.0
	GO TO 10
	END
	SUBROUTINE GRLIN2 (X0,Y0,X1,Y1)
C-----------------------------------------------------------------------
C GRPCKG : plot a visible line segment in absolute coords from
C (X0,Y0) to (X1,Y1).  Printer devices use a Simple
C Digital Differential Analyser (ref: Newman & Sproull)
C to generate the constituent dots of the line.
C
C (1-Jun-1984)
C-----------------------------------------------------------------------
	INCLUDE 'GRPCKG1.INC'
C
	GRPLTD(GRCIDE) = .TRUE.
	I0 = NINT(X0)
	J0 = NINT(Y0)
	I1 = NINT(X1)
	J1 = NINT(Y1)
	IF (GRCTYP.EQ.PRTX .OR. GRCTYP.EQ.TRILOG .OR. GRCTYP.EQ. VERS)
     1       THEN
	    LENGTH = MAX(ABS(I1-I0), ABS(J1-J0))
	    D = MAX(1,LENGTH)
	    XINC = FLOAT(I1-I0)/D
	    YINC = FLOAT(J1-J0)/D
	    XP = I0
	    YP = J0
	    DO K=0,LENGTH
		CALL GRPR01(NINT(XP), NINT(YP), GRPBXD(GRCIDE),
     1			 GRPBYD(GRCIDE), %VAL(GRPBAD(GRCIDE)))
		XP = XP + XINC
		YP = YP + YINC
	    END DO
	ELSE IF (GRCTYP.EQ.GMFILE) THEN
	    CALL GRMF01(I0, J0, I1, J1)
	ELSE IF (GRCTYP.EQ.TEK10 .OR. GRCTYP.EQ.TEK14 .OR.
     1	         GRCTYP.EQ.RETRO .OR. GRCTYP.EQ.ID100) THEN
	    CALL GRTK01(I0, J0, I1, J1)
	ELSE IF (GRCTYP.EQ.GRINL) THEN
	    CALL GRGR01(I0, J0, I1, J1)
	ELSE IF (GRCTYP.EQ.VT125) THEN
	    CALL GRVT01(I0, J0, I1, J1)
	ELSE IF (GRCTYP.EQ.ARGS) THEN
	    CALL GRAR01(I0, J0, I1, J1)
        ELSE IF (GRCTYP.EQ.LASER) THEN
            CALL GRQM01(I0,J0,I1,J1)
	ELSE IF (GRCTYP.NE.GNULL) THEN
	    CALL GRQUIT('Internal error.')
	END IF
	RETURN
	END
	SUBROUTINE GRLIN3 (X0,Y0,X1,Y1)
C-----------------------------------------------------------------------
C GRPCKG: draw a heavy line from (X0,Y0) to (X1,Y1) by making multiple
C strokes.  In order to simulate a thick pen, the line drawn has
C circular, rather than square, end points.  If this is not done,
C thick letters and other figures have an abnormal and unpleasant
C appearance.
C
C Vocabulary:
C
C LINEWT: the number of strokes required to draw the line; if
C	this is odd, one stroke will lie along the requested vector.
C	The nominal line thickness is (LINEWT-1) pixels.
C RSQURD: the square of the semi-line thickness.
C (DX,DY): the vector length of the line.
C (VX,VY): a vector of length 1 pixel in the direction of the line.
C (VY,-VX): a vector of length 1 pixel perpendicular to (VX,VY).
C OFF: the offset parallel to (VY,-VX) of the K'th stroke.
C (VXK,VYK): the vector increment of the K'th stroke to allow for the
C	semi-circular terminal on the line.
C (PXK,PYK): the vector offset of the K'th stroke perpendicular to the
C	line vector.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  K,LINEWT
	REAL     DX,DY, HK, OFF, PXK,PYK, RSQURD, VLEN,VX,VY,VXK,VYK
	REAL     X0,X1,Y0,Y1
	REAL     XS0,XS1, YS0,YS1
	LOGICAL  VIS
C
C		Determine number of strokes and line thickness.
C
	LINEWT = GRWIDT(GRCIDE)
	RSQURD = ((LINEWT-1)**2)*0.25
C
C		Determine the vectors (VX,VY), (VY,-VX). If the
C		line-length is zero, pretend it is a very short
C		horizontal line.
C
	DX = X1 - X0
	DY = Y1 - Y0
	VLEN = SQRT(DX**2 + DY**2)
	IF (VLEN .EQ. 0.0) THEN
	    VX = 1.0
	    VY = 0.0
	ELSE
	    VX = DX/VLEN
	    VY = DY/VLEN
	END IF
C
C		Draw LINEWT strokes. We have to clip again in case 
C		thickening the line has taken us outside the window.
C
	OFF = (LINEWT-1)*0.5
	DO K=1,LINEWT
	    PXK = VY*OFF
	    PYK = -VX*OFF
	    HK  = SQRT(RSQURD - OFF**2)
	    VXK = VX*HK
	    VYK = VY*HK
	    XS1 = X1+PXK+VXK
	    YS1 = Y1+PYK+VYK
	    XS0 = X0+PXK-VXK
	    YS0 = Y0+PYK-VYK
	    CALL GRCLPL(XS1,YS1,XS0,YS0,VIS)
	    IF (VIS) CALL GRLIN2(XS1, YS1, XS0, YS0)
	    OFF = OFF - 1.0
	END DO
	RETURN
	END
	SUBROUTINE GRLINA (X,Y)
C-----------------------------------------------------------------------
C GRPCKG: draw line from current position to a specified position.
C
C Arguments:
C
C X, Y (real, input): world coordinates of the end-point of the line.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	REAL     X,Y, XT,YT
C
	IF (GRCIDE.GE.1) THEN
	    CALL GRLIN0( X * GRXSCL(GRCIDE) + GRXORG(GRCIDE),
     1			 Y * GRYSCL(GRCIDE) + GRYORG(GRCIDE) )
	END IF
	RETURN
	END
	SUBROUTINE GRLINR (DX,DY)
C-----------------------------------------------------------------------
C GRPCKG: draw a line from the current position by a specified
C relative displacement.
C
C Arguments:
C
C DX, DY (real, input): the displacement in world coordinates: the pen
C	position is incremented by DX in x and DY in y.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	REAL     DX,DY
C
	IF (GRCIDE.GE.1) THEN
	    CALL GRLIN0( DX * GRXSCL(GRCIDE) + GRXPRE(GRCIDE),
     1		         DY * GRYSCL(GRCIDE) + GRYPRE(GRCIDE) )
	END IF
	RETURN
	END
	SUBROUTINE GRMARK (IDENT,CENTER,SYMBOL,ABSXY,POINTS,X,Y)
C-----------------------------------------------------------------------
C GRPCKG: mark a sequence of points with a specified symbol. The
C plot is windowed in the current subarea.
C
C Arguments:
C
C IDENT (integer, input): plot identifier from GROPEN.
C CENTER (input, logical): if .TRUE. the symbol is centered on the point,
C	otherwise the bottom left corner is placed at the point.
C SYMBOL (byte or integer, input): code number of symbol in range 0-127
C	(ASCII character or special symbol); if SYMBOL is outside this
C	range, nothing is plotted.
C ABSXY (logical, input): if .TRUE. (X,Y) are absolute (device)
C	coordinates; otherwise they are world coordinates and the
C	scaling transformation is applied.
C POINTS (integer, input): the number of points; if POINTS is less than
C	or equal to 0, nothing is plotted.
C X,Y (real arrays, dimension at least POINTS, input): the coordinate
C	pairs; if POINTS=1, these may be scalars instead of arrays.
C
C (9-Mar-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	BYTE     SYMBOL
	CHARACTER*1 MARK
	INTEGER  I, IDENT, POINTS
	LOGICAL  ABSXY, CENTER
	REAL     X(*), Y(*)
C
	IF (POINTS.LE.0 .OR. SYMBOL.LT.0 .OR. SYMBOL.GT.127) RETURN
	CALL GRSELECT(IDENT)
	MARK = CHAR(SYMBOL)
	DO I=1,POINTS
	    CALL GRCHR0(.TRUE., CENTER, 0.0, ABSXY, X(I), Y(I), MARK)
	END DO
	RETURN
	END
	SUBROUTINE GRMARKER (SYMBOL,ABSXY,N,X,Y)
C-----------------------------------------------------------------------
C GRPCKG: Draw a graph marker at a set of points in the current
C window. Line attributes (color, intensity, and  thickness)
C apply to markers, but line-style is ignored. After the call to
C GRMARKER, the current pen position will be the center of the last
C marker plotted.
C
C Arguments:
C
C SYMBOL (input, integer): the marker number to be drawn. Numbers
C       0-31 are special marker symbols; numbers 32-127 are the
C	corresponding ASCII characters (in the current font). Other
C	values (e.g., negative) produce a single dot.
C ABSXY (input, logical): if .TRUE., the input corrdinates (X,Y) are
C	taken to be absolute device coordinates; if .FALSE., they are
C	taken to be world coordinates.
C N (input, integer): the number of points to be plotted.
C X, Y (input, real arrays, dimensioned at least N): the (X,Y) 
C	coordinates of the points to be plotted.
C
C (19-Mar-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	BYTE     SYMBOL,C
	LOGICAL  ABSXY, UNUSED, VISBLE
	INTEGER  I, K, LSTYLE, LX, LY, LXLAST, LYLAST, N, SYMNUM
	INTEGER*2 XYGRID(300), HERSH(0:175,3), GMFBUF(3)
	REAL     ANGLE, COSA, SINA, FACTOR, RATIO, X(*), Y(*)
	REAL	 XCUR, YCUR, XORG, YORG
	COMMON   /GRHERSH/ HERSH
C
C		Check that there is something to be plotted.
C
	IF (N.LE.0) RETURN
C
C		Check that a device is selected.
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRMARKER - no graphics device is active.')
	    RETURN
	END IF
C
	IF (GRCTYP.EQ.GMFILE) GOTO 500
C
C		Save current line-style, and set style "normal".
C
	CALL GRINQLS(LSTYLE)
	CALL GRSETLS(1)
C
C		Compute scaling and orientation.
C
	ANGLE = 0.0
	FACTOR = GRCFAC(GRCIDE)/2.5
	RATIO = GRXPIN(GRCTYP)/GRYPIN(GRCTYP)
	COSA = FACTOR * COS(ANGLE)
	SINA = FACTOR * SIN(ANGLE)
C
C		Convert the supplied symbol number SYMBOL to a
C		Hershey number and obtain the digitization.
C
	IF (SYMBOL.LT.0) SYMBOL = 1
	IF (SYMBOL.GT.127) SYMBOL = 1
	SYMNUM = HERSH(SYMBOL,GRCFNT(GRCIDE))
	CALL GRSYMXD(SYMNUM, XYGRID, UNUSED)
C
C		Plot the symbols.
C
	DO 380 I=1,N
	    CALL GRTXY0(ABSXY, X(I), Y(I), XORG, YORG)
	    VISBLE = .FALSE.
	    K = 4
	    LXLAST = -64
	    LYLAST = -64
  320	    K = K+2
	    LX = XYGRID(K) 
	    LY = XYGRID(K+1) 
	    IF (LY.EQ.-64) GOTO 380
	    IF (LX.EQ.-64) THEN
		VISBLE = .FALSE.
	    ELSE
		IF ((LX.NE.LXLAST) .OR. (LY.NE.LYLAST)) THEN
		    XCUR = XORG + (COSA*LX - SINA*LY)*RATIO
		    YCUR = YORG + (SINA*LX + COSA*LY)
		    IF (VISBLE) THEN
		        CALL GRLIN0(XCUR,YCUR)
		    ELSE
		        GRXPRE(GRCIDE) = XCUR
		        GRYPRE(GRCIDE) = YCUR
		    END IF
	        END IF
	        VISBLE = .TRUE.
	        LXLAST = LX
	        LYLAST = LY
	    END IF
	    GOTO 320
  380   CONTINUE
C
C		Set current pen position.
C
	GRXPRE(GRCIDE) = XORG
	GRYPRE(GRCIDE) = YORG
C
C		Restore the line-style, and return.
C
	CALL GRSETLS(LSTYLE)
	RETURN
C
C		Special code for device type GMFILE (hardware markers).
C
  500	IF (SYMBOL.NE.GRCMRK(GRCIDE)) THEN
	    GMFBUF(1) = 'A201'X
	    GMFBUF(2) = SYMBOL
	    CALL GRMF02(2,GMFBUF,%VAL(GRPBAD(GRCIDE)))
	    GRCMRK(GRCIDE) = SYMBOL
	END IF
	DO I=1,N
		CALL GRTXY0(ABSXY,X(I),Y(I),XORG,YORG)
		LX = NINT(XORG)
		LY = NINT(YORG)
		CALL GRCLIP(LX,LY,GRXMIN(GRCIDE),GRXMAX(GRCIDE),
     1		            GRYMIN(GRCIDE),GRYMAX(GRCIDE),C)
		IF (C.EQ.0) THEN
		    GMFBUF(1) = LX
		    GMFBUF(2) = LY
		    GMFBUF(3) = 'A300'X
		    CALL GRMF02(3,GMFBUF,%VAL(GRPBAD(GRCIDE)))
		END IF
	END DO
C
C		Set current pen position and return.
C
	GRXPRE(GRCIDE) = XORG
	GRYPRE(GRCIDE) = YORG
	RETURN
	END
	INTEGER FUNCTION GRMF00
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Open a file for metafile graphics.
C If an error occurs, a message is sent to SYS$OUTPUT via GRWARN. The
C file is opened for Fortran I/O with fixed-length, 720-byte records.
C
C Arguments: none.
C
C Returns:
C
C GRMF00 (integer): receives 1 if the file was opened successfully; any
C	other value indicates an error (the value is the associated VMS
C	error code).
C
C (1-Jun-1984)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  I, IER, IK1, IK2, IK3, IK4, IK5
	INTEGER  LIB$GET_LUN
C
	IER = LIB$GET_LUN(GRUNIT(GRCIDE))
	IF (IER.NE.1) THEN
	    CALL GRGMSG(IER)
	    GRMF00 = IER
	    RETURN
	END IF
	OPEN (UNIT=GRUNIT(GRCIDE), NAME=GRFILE(GRCIDE), STATUS='NEW',
     1		DEFAULTFILE='GRAPHICS.GMF',
     2		FORM='UNFORMATTED', CARRIAGECONTROL='NONE', 
     3		RECORDTYPE='FIXED', RECL=180, IOSTAT=IER)
	IF (IER.NE.0) THEN
	    CALL ERRSNS(IK1,IK2,IK3,IK4,IK5)
	    CALL GRWARN('Cannot open graphics file '
     1				//GRFILE(GRCIDE)(1:GRFNLN(GRCIDE)))
	    IF (IK2.NE.0 .AND. IK2.NE.1) THEN
		CALL GRGMSG(IK2)
	        GRMF00 = IK2
	    ELSE IF (IK5.NE.0 .AND. IK5.NE.1) THEN
		CALL GRGMSG(IK5)
	    	GRMF00 = IK5
	    END IF
	ELSE
	    INQUIRE (UNIT=GRUNIT(GRCIDE), NAME=GRFILE(GRCIDE))
	    I = LEN(GRFILE(GRCIDE))
	    DO WHILE (GRFILE(GRCIDE)(I:I).EQ.' ')
		I = I-1
	    END DO
	    GRFNLN(GRCIDE) = I
	    GRRCNT(GRCIDE) = 0
	    GRMF00 = 1
	END IF

	RETURN
	END
	SUBROUTINE GRMF01 (I0,J0,I1,J1)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Draw a line (metafile only). This requires
C a MOVE command (unless the starting point is the same point as the end 
C point of the last line) followed by a DRAW command.
C
C Arguments:
C
C I0, J0 (input, integer): the absolute device coordinates of the 
C	starting point of the line.
C I1, J1 (input, integer): the absolute device coordinates of the 
C	end point of the line.
C
C (1-Jun-1984)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER    K ,jj
	INTEGER*2  I0,J0,I1,J1
	INTEGER*2  OUTPUT(4)
C
	IF (I0.NE.GRLSTI(GRCIDE).OR. J0.NE.GRLSTJ(GRCIDE)) THEN
	    OUTPUT(1) = I0
	    OUTPUT(2) = J0
	    K = 2
	ELSE
	    K = 0
	END IF
	OUTPUT(K+1) = I1
	K = K+2
	OUTPUT(K) = IBSET(J1,15)
	CALL GRMF02(K,OUTPUT,%VAL(GRPBAD(GRCIDE)))
	GRLSTI(GRCIDE) = I1
	GRLSTJ(GRCIDE) = J1
	RETURN
	END
	SUBROUTINE GRMF02 (N,CHUNKS,BUFFER)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Transfer metafile chunks to output
C buffer. If the buffer fills up, it is flushed to the output device
C using routine GRMF03.
C
C Arguments:
C
C N (input, integer): the number of chunks to transfer.
C CHUNKS (input, integer*2 array): the chunks to transfer.
C BUFFER (input/output, array): the (address of the) buffer, passed
C	as an argument because it is a dynamic array.
C
C (1-Jun-1984)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER I,N
	INTEGER*2 CHUNKS(N), BUFFER(*)
C
	DO I=1,N
	    IF (GRBHWM(GRCIDE)*2.GE.GRPBXD(GRCIDE))
     1		CALL GRMF03(%VAL(GRPBAD(GRCIDE)))
	    GRBHWM(GRCIDE) = GRBHWM(GRCIDE)+1
	    BUFFER(GRBHWM(GRCIDE)) = CHUNKS(I)
	END DO
	RETURN
	END
	SUBROUTINE GRMF03 (BUFFER)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Flush metafile buffer contents. If the 
C buffer is not full, it is padded with NO_OPERATION commands.
C
C Argument:
C
C BUFFER (input, byte array): address of the buffer (passed as an 
C	argument because it is a dynamic array).
C
C (1-Jun-1984) [TJP]
C-----------------------------------------------------------------------
	IMPLICIT  NONE
	INCLUDE   'GRPCKG1.INC'
	INTEGER   I, J, UNIT
	INTEGER*2 BUFFER(GRFBSZ/2)
C
	I = GRBHWM(GRCIDE)
	IF (I.GT.0) THEN
	    DO J=I+1,GRFBSZ/2
		BUFFER(J) = '8400'X
	    END DO
	    UNIT = GRUNIT(GRCIDE)
	    WRITE (UNIT) BUFFER
	    GRBHWM(GRCIDE) = 0
	END IF
	RETURN
	END
	SUBROUTINE GRMOVA (X,Y)
C-----------------------------------------------------------------------
C GRPCKG: move the pen to a specified location.
C
C Arguments:
C
C X, Y (real, input): world coordinates of the new pen position.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	REAL     X,Y
C
	IF (GRCIDE.GE.1) THEN
	    GRXPRE(GRCIDE) = X * GRXSCL(GRCIDE) + GRXORG(GRCIDE)
	    GRYPRE(GRCIDE) = Y * GRYSCL(GRCIDE) + GRYORG(GRCIDE)
	END IF
	RETURN
	END
	SUBROUTINE GRMOVR (DX,DY)
C-----------------------------------------------------------------------
C GRPCKG: move the pen through a specified displacement.
C
C Arguments:
C
C DX, DY (real, input): the displacement in world coordinates: the pen
C	position is incremented by DX in x and DY in y.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	REAL     DX,DY
C
	IF (GRCIDE.GE.1) THEN
	    GRXPRE(GRCIDE) = GRXPRE(GRCIDE) + DX*GRXSCL(GRCIDE)
	    GRYPRE(GRCIDE) = GRYPRE(GRCIDE) + DY*GRYSCL(GRCIDE)
	END IF
	RETURN
	END
	INTEGER FUNCTION GROPEN (TYPE,DUMMY,FILE,IDENT)
C-----------------------------------------------------------------------
C GRPCKG: assign a device and prepare for plotting.  GROPEN must be
C called before all other calls to GRPCKG routines. 
C
C Returns:
C
C GROPEN (output, integer): 1 => success, any other value 
C	indicates a failure (usually the value returned will
C	be a VMS error code). In the event of an error, a
C	message will be sent to SYS$OUTPUT.
C
C Arguments:
C
C TYPE (input, integer): default device type (integer code).
C DUMMY (input, integer): not used at present.
C FILE (input, character): plot specifier, of form 'device/type'.
C IDENT (output, integer): plot identifier to be used in later
C	calls to GRPCKG.
C
C  1-Jun-1984 - [TJP].
C  2-Jul-1984 - change to call GRSELECT [TJP].
C 13-Jul-1984 - add device initialization [TJP].
C 23-Jul-1984 - add /APPEND qualifier.
C-----------------------------------------------------------------------
	INCLUDE 'GRPCKG1.INC'
	INTEGER       TYPE, DUMMY, IER
	CHARACTER*(*) FILE
	INTEGER       IDENT
	INTEGER       EXITBLOCK(4)
	EXTERNAL GRDAT1, GREXIT
	INTEGER  GRIBF0, GRMF00, GRPR00, GRTK00, GRVT00, GRDTYP
	INTEGER FTYPE, GRPARS
	LOGICAL FNTOPN, APPEND
	CHARACTER*16 ERRSTR
	CHARACTER*128 FFILE
	SAVE    FNTOPN
	DATA    FNTOPN / .TRUE. /
C
C		Initialise character-drawing routines and exit
C		handler (first call to GROPEN only).
C
	IF (FNTOPN) THEN
	    CALL GRSYM00
	    FNTOPN = .FALSE.
	    EXITBLOCK(1) = 0
	    EXITBLOCK(2) = %LOC(GREXIT)
	    EXITBLOCK(3) = 0
	    EXITBLOCK(4) = %LOC(STATUS)
	    CALL SYS$DCLEXH(EXITBLOCK)
	END IF
C
C		Allocate an identifier
C
	IDENT = 1
	DO WHILE (GRINIT(IDENT))
	    IDENT = IDENT+1
	    IF (IDENT.GT.GRIMAX) THEN
		CALL GRWARN('Too many active plots.')
		GROPEN = -1
		IDENT = 0
		RETURN
	    END IF
	END DO
	GRCIDE = IDENT
C
C		Validate the device specification.
C
	IER = GRPARS(FILE,FFILE,FTYPE,APPEND)
	IF (IER.NE.1) THEN
	    CALL GRWARN('Bad device spec: '//FILE)
	    GROPEN = -1
	    RETURN
	END IF
	IF (FTYPE.EQ.0) FTYPE = TYPE
	IF (1.LE.FTYPE .AND. FTYPE.LE.GRTMAX) THEN
	    GRTYPE(IDENT) = FTYPE
	    GRCTYP = FTYPE
	ELSE
	    WRITE (ERRSTR,'(I)') FTYPE
	    CALL GRWARN('Invalid plot type code:'//ERRSTR)
	    GROPEN = -1
	    RETURN
	END IF
C
C		Install the file name, or assign default
C
	NAMLEN = 0
	GRFILE(IDENT) = ' '
	DO I=1,LEN(FFILE)
	    IF (FFILE(I:I).NE.' ') THEN
		NAMLEN = MIN(NAMLEN+1,GRFNMX)
		GRFILE(IDENT)(NAMLEN:NAMLEN) = FFILE(I:I)
	    END IF
	END DO
	IF (NAMLEN.LE.0) THEN
	    IF (FTYPE.EQ.PRTX .OR. FTYPE.EQ.TRILOG .OR.
     1	        FTYPE.EQ.VERS .OR. FTYPE.EQ.GMFILE .OR.          
     1          FTYPE.EQ.LASER ) THEN
		GRFILE(IDENT) = ' '
		NAMLEN = 1
	    ELSE IF (FTYPE.EQ.TEK10 .OR. FTYPE.EQ.TEK14 .OR.
     1		     FTYPE.EQ.RETRO .OR. FTYPE.EQ.VT125 .OR.
     2		     FTYPE.EQ.ID100) THEN
		GRFILE(IDENT) = 'TT'
		NAMLEN = 2
	    ELSE IF (FTYPE.EQ.GRINL) THEN
		GRFILE(IDENT) = '_GRA0:'
		NAMLEN = 6
	    ELSE IF (FTYPE.EQ.ARGS) THEN
		GRFILE(IDENT) = 'ARGS_DEVICE'
		NAMLEN = 11
	    ELSE IF (FTYPE.EQ.GNULL) THEN
		GRFILE(IDENT) = ' '
		NAMLEN = 0
	    ELSE
		CALL GRQUIT('Internal error.')
	    END IF
	END IF
	GRFNLN(IDENT) = NAMLEN
	CALL STR$UPCASE(GRFILE(IDENT),GRFILE(IDENT))
C
C		Open the output file
C
	IF (FTYPE.EQ.PRTX .OR. FTYPE.EQ.TRILOG .OR. FTYPE.EQ.VERS .OR.
     1      FTYPE.EQ.LASER) THEN
	    GROPEN = GRPR00()
	ELSE IF (FTYPE.EQ.GMFILE) THEN
	    GROPEN = GRMF00()
	ELSE IF (FTYPE.EQ.TEK10 .OR. FTYPE.EQ.TEK14 .OR.
     1	         FTYPE.EQ.RETRO .OR. FTYPE.EQ.GRINL .OR.
     2	         FTYPE.EQ.ARGS  .OR. FTYPE.EQ.ID100) THEN
	    GROPEN = GRTK00(FTYPE)
	ELSE IF (FTYPE.EQ.VT125) THEN
	    GROPEN = GRVT00()
	ELSE IF (FTYPE.EQ.GNULL) THEN
	    GROPEN = 1
	    GRFNLN(IDENT) = 0
	ELSE
	    CALL GRQUIT('Internal error.')
	END IF
c     WRITE(3,100)FTYPE,TEK10,VT125,GROPEN
100   FORMAT('  IN OPEN, FTYPE=',I3,'  TEK10=',I2,' VT125=',I2,
     +'  GROPEN=',I3)
	IF (GROPEN.NE.1) RETURN
C
C		Install the default plot parameters
C
	GRXPRE(IDENT) = 0.0
	GRYPRE(IDENT) = 0.0
	GRRCNT(IDENT) = 0
	CALL GRTRN0(0.0, 0.0, 1.0, 1.0)
	GRCSCL(IDENT) = GRCSC0(FTYPE)
	GRCFAC(IDENT) = GRCSC0(FTYPE)
	GRPLTD(IDENT) = .FALSE.
	GRXMXA(IDENT) = GRXMX0(FTYPE)
	GRYMXA(IDENT) = GRYMX0(FTYPE)
	GRXMIN(IDENT) = 0
	GRXMAX(IDENT) = GRXMX0(FTYPE)
	GRYMIN(IDENT) = 0
	GRYMAX(IDENT) = GRYMX0(FTYPE)
C
C		Allocate a dynamic buffer
C
	GROPEN = GRIBF0()
	IF (GROPEN.NE.1) RETURN
	GRINIT(IDENT) = .TRUE.
	GRPCNT(IDENT) = 0
      WRITE(6,500)IDENT
500   FORMAT('   IN GROPEN, BEFORE CALL TO GRSELECT, IDENT=',I5)
	CALL GRSELECT(IDENT)
C
C		Default attributes
C
	GRCFNT(GRCIDE) = 1	! text font (normal)
	GRCCOL(GRCIDE) = 1	! color (white)
	GRSTYL(GRCIDE) = 1	! line-style (full)
	GRWIDT(GRCIDE) = 1	! line-width (minimum)
	GRCPEN(GRCIDE) = 0	! pen number (none selected)
	GRCMRK(GRCIDE) = 1	! marker number (dot)
	GRDASH(GRCIDE) = .FALSE.
	GRLSTI(GRCIDE) = -1	! illegal current plot position
	GRLSTJ(GRCIDE) = -1
C
	GROPEN = 1
C
C		Perform device initialization.
C
	IF (GRCTYP.EQ.GMFILE) THEN
	    CALL GRMF02(1,'8001'X,%VAL(GRPBAD(GRCIDE)))
	    CALL GRMF02(1,    1,  %VAL(GRPBAD(GRCIDE)))
	ELSE IF (GRCTYP.EQ.GRINL.AND..NOT.APPEND) THEN
	    CALL GRGR10
	ELSE IF (GRCTYP.EQ.ARGS.AND..NOT.APPEND) THEN
	    CALL GRAR10
	ELSE IF (GRCTYP.EQ.VT125.AND..NOT.APPEND) THEN
	    CALL GRVT10
	END IF
	RETURN
	END
	SUBROUTINE GRPAGE
C-----------------------------------------------------------------------
C GRPCKG: Advance the plotting area to a new page. For video devices,
C this amounts to erasing the screen; for hardcopy devices, the plot
C buffer is written to the output file followed by a form-feed to
C advance the paper to the start of the next page.
C
C Arguments: none.
C
C  3-Jun-1983 - [TJP].
C 18-Feb-1984 - remove unnecessary 'T' initialization of VT125, and add
C               S(G1) for Rainbow REGIS [TJP].
C  1-Jun-1984 - add type GMFILE [TJP].
C  2-Jul-1984 - change initialization of VT125 for color [TJP].
C 13-Jul-1984 - move initialization of VT125 and Grinnell to GROPEN 
C	        [TJP].
C-----------------------------------------------------------------------
	INCLUDE 'GRPCKG1.INC'
C
	INTEGER SYS$SETIMR
	INTEGER SYS$WAITFR
C
	INTEGER I, GRPRPP
        INTEGER DELAY(2)
        LOGICAL WAIT
	BYTE FF
	BYTE TKPAGE(4),TKTEK(4)
	INTEGER RESULT
	INTEGER ONESEC(2)
	INTEGER*2 GRNLBF(6)
C
	DATA FF/12/
	DATA TKPAGE / 29, 27, 12, 24/
	DATA TKTEK  / 27, 37, 33, 48/
	DATA ONESEC /-10000000, -1/
      DATA DELAY /0, -1/
C
C		Flush the buffer.
C
	CALL GRTERM
C
C		Erase the text screen (if there is one).
C
	CALL GRETEXT
C
C	Printer devices: write out bit-map. For Printronix and Trilog,
C	follow this with enough blank plot lines to advance to the
C	beginning of the next page (as formfeeds don't seem to do the
C	right thing). For Versatec, follow bit-map with a formfeed. If
C	the bit-map is empty (nothing plotted), do not write it out:
C	this is to conserve paper.
C
	IF (GRCTYP.EQ.PRTX .OR. GRCTYP.EQ.TRILOG .OR. GRCTYP.EQ.VERS)
     1   THEN      
	    GRPRPP = 792
	    IF (GRCTYP.EQ.TRILOG) GRPRPP = 1100
	    IF (GRPLTD(GRCIDE)) THEN
		CALL GRPR03(GRPBXD(GRCIDE),
     1			GRPBYD(GRCIDE), %VAL(GRPBAD(GRCIDE)))
		GRRCNT(GRCIDE) = MOD(GRRCNT(GRCIDE) + GRPBYD(GRCIDE),
     1			GRPRPP)
		GRPCNT(GRCIDE) = GRPCNT(GRCIDE) + 1
		GRPLTD(GRCIDE) = .FALSE.
	    END IF
	    IF (GRRCNT(GRCIDE).NE.0) THEN
		IF (GRCTYP.NE.VERS) THEN
		    DO I=1,GRPRPP - GRRCNT(GRCIDE)
			CALL GRPR04('C0'X,1,GRUNIT(GRCIDE))
		    END DO
		ELSE
		    WRITE (GRUNIT(GRCIDE)) FF
		END IF
		GRRCNT(GRCIDE) = 0
	    END IF
C
C		Metafile: send END_PICTURE and BEGIN_PICTURE
C		commands. The BEGIN_PICTURE command must begin
C		on a record boundary.
C
	ELSE IF (GRCTYP.EQ.GMFILE) THEN
	    IF (GRPLTD(GRCIDE)) THEN
		CALL GRMF02(1,'9100'X,%VAL(GRPBAD(GRCIDE)))
	    END IF
	    GRPCNT(GRCIDE) = GRPCNT(GRCIDE) + 1
	    CALL GRMF03(%VAL(GRPBAD(GRCIDE)))
	    CALL GRMF02(1,'9001'X,%VAL(GRPBAD(GRCIDE)))
	    CALL GRMF02(1,GRPCNT(GRCIDE),%VAL(GRPBAD(GRCIDE)))
	    GRPLTD(GRCIDE) = .TRUE.
C
C		Tektronix: erase screen.
C		Tek 4010 series require a 1-sec wait.
C
	ELSE IF (GRCTYP.EQ.TEK10 .OR. GRCTYP.EQ.TEK14 .OR.
     1	         GRCTYP.EQ.RETRO .OR. GRCTYP.EQ.ID100) THEN
	    IF (GRCTYP.EQ.TEK14) 
     1		CALL GRTK02(TKTEK,4,%VAL(GRPBAD(GRCIDE)))
	    CALL GRTK02(TKPAGE,4,%VAL(GRPBAD(GRCIDE)))
	    CALL GRTK03(%VAL(GRPBAD(GRCIDE)))
	    IF (GRCTYP.EQ.TEK10) THEN
	        RESULT = SYS$SETIMR(,ONESEC,,)
		IF (.NOT.RESULT) THEN
		    CALL GRGMSG(RESULT)
		    CALL GRQUIT('SYS$SETIMR error in routine GRPAGE.')
		END IF
		RESULT = SYS$WAITFR()
		IF (.NOT.RESULT) THEN
		    CALL GRGMSG(RESULT)
		    CALL GRQUIT('SYS$WAITFR error in routine GRPAGE.')
		END IF
	    END IF
C
C		Grinnell: erase screen.
C
	ELSE IF (GRCTYP.EQ.GRINL) THEN
	    GRNLBF(1) = 'A000'X		! SPD 0
	    GRNLBF(2) = '10FF'X		! LSM FF
	    GRNLBF(3) = '80FF'X		! LDC FF
	    GRNLBF(4) = '2830'X		! LWM (R0,A0,Z1,V1,H0,W0)
	    GRNLBF(5) = '3000'X		! ERS
	    GRNLBF(6) = '1000'X .OR. GRCCOL(GRCIDE)
					! LSM <color>
	    CALL GRGR02(GRNLBF,6,%VAL(GRPBAD(GRCIDE)))
C
C		ARGS: reinitialize display.
C
	ELSE IF (GRCTYP.EQ.ARGS) THEN
	    CALL GRAR10
C
C		VT125: erase screen.
C
	ELSE IF (GRCTYP.EQ.VT125) THEN
	    CALL GRVT02(';S(E)',%VAL(GRPBAD(GRCIDE)))
       ELSE IF(GRCTYP.EQ.LASER)THEN
        WAIT=.FALSE.
          GRPRPP=1100
          WRITE(GRUNIT(GRCIDE),'(A)')'^,'
C
C		Check for internal error.
C
	ELSE IF (GRCTYP.NE.GNULL) THEN
	    CALL GRQUIT('Internal error.')
	END IF
	RETURN
	END
	INTEGER FUNCTION GRPARS (DESCR,DEV,TYPE,APPEND)
C-----------------------------------------------------------------------
C GRPCKG: decode a device-specification; called by GROPEN.
C
C Returns:
C
C GRPARS (output, integer): 1 if the device-specification is
C	acceptable; any other value indicates an error.
C
C Arguments:
C
C DESCR (input, character): the device specification.
C DEV (output, character): device name or file spec.
C TYPE (output, integer): device type (integer code); 0 if no device
C	type is specified.
C APPEND (output, logical):  .TRUE. if /APPEND specified, .FALSE.
C	otherwise.
C
C 23-Jul-1984 - [TJP].
C-----------------------------------------------------------------------
	IMPLICIT      NONE
	INTEGER	      MAXW
	PARAMETER     (MAXW=3)
	CHARACTER*(*) DESCR, DEV
	CHARACTER*128 UPPER
	CHARACTER*32  CTYPE
	INTEGER       GRDTYP, I, L, TYPE, NW, P1(10), P2(10)
	LOGICAL       APPEND
C
C		Default results.
C
	DEV = ' '
	TYPE = 0
	APPEND = .FALSE.
C
C		Null string is acceptable.
C
	GRPARS = 1
	IF (LEN(DESCR).LT.1) RETURN
	IF (DESCR.EQ.' ') RETURN
	L = LEN(DESCR)
	DO WHILE (DESCR(L:L).EQ.' ')
	    L = L-1
	END DO
C
C		Convert to upper case and perform logical name
C		translation.
C
	UPPER = ' '
	CALL STR$UPCASE(UPPER,DESCR(1:L))
	CALL GRLGTR(UPPER)
	L = LEN(UPPER)
	DO WHILE (UPPER(L:L).EQ.' ')
	    L = L-1
	END DO
C	
C		Divide string into substrings delimited by
C		slashes.
C
	NW = 1
	I = 1
	P1(1) = 0
	DO WHILE (I.LE.L)
	    IF (UPPER(I:I).EQ.'/') THEN
		P2(NW) = I-1
		NW = NW+1
		IF (NW.GT.MAXW) THEN
		    GRPARS = 64
		    RETURN
		END IF
		P1(NW) = I
	    END IF
	    I = I+1
	END DO
	P2(NW) = L
C
C		Substring 1 is the device name.
C		It may be a logical name; if so, we translate it.
C
	IF (P2(1).GT.P1(1)) THEN
	    DEV = UPPER(P1(1)+1:P2(1))
	    CALL GRLGTR(DEV)
	END IF
C
C		Substring 2, if present, is the device type.
C		It may be a logical name; if so, we translate it.
C
	IF (NW.LT.2) THEN
	    TYPE = 0
	ELSE IF (P2(2).LE.P1(2)) THEN
	    GRPARS = GRPARS+16
	    TYPE = 0
	ELSE
	    CTYPE = UPPER(P1(2)+1:P2(2))
	    CALL GRLGTR(CTYPE)
	    CALL STR$UPCASE(CTYPE,CTYPE)
	    TYPE = GRDTYP(CTYPE)
	    IF (TYPE.EQ.0) GRPARS = GRPARS+2
	END IF
C
C		Substring 3, if present, is a qualifier.
C
	IF (NW.LT.3) THEN
	    APPEND = .FALSE.
	ELSE IF (P2(3).LE.P1(3)) THEN
	    GRPARS = GRPARS+4
	    APPEND = .FALSE.
	ELSE 
	    CTYPE = UPPER(P1(3)+1:P2(3))
	    L = P2(3) - P1(3)
	    IF (CTYPE(1:L) .EQ. 'NOAPPEND') THEN
		APPEND = .FALSE. ! /NOAPPEND specified
	    ELSE  IF (CTYPE(1:L).EQ.'APPEND') THEN
	        APPEND = .TRUE. ! /APPEND specified
	    ELSE
		GRPARS = GRPARS+8
	    END IF
	END IF
C
	RETURN
	END
	INTEGER FUNCTION GRPR00
C-----------------------------------------------------------------------
C GRPCKG (internal routine, printer devices): open a file for graphics.
C If an error occurs, a message is sent to SYS$OUTPUT via GRWARN.
C
C Arguments: none.
C
C Returns:
C
C GRPR00 (integer): receives 1 if the file was opened
C	successfully; any other value indicates an error (usually the
C	value is the associated VMS error code).
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  GRCHKT, I, IER, IK1, IK2, IK3, IK4, IK5
	INTEGER  LIB$GET_LUN
C
	IER = LIB$GET_LUN(GRUNIT(GRCIDE))
	IF (IER.NE.1) THEN
	    CALL GRGMSG(IER)
	    GRPR00 = IER
	    RETURN
	END IF
        IF(GRCTYP.EQ.LASER)THEN
       OPEN (UNIT=GRUNIT(GRCIDE),NAME=GRFILE(GRCIDE)(1:GRFNLN(GRCIDE)),
     + STATUS='NEW', CARRIAGECONTROL='LIST',IOSTAT=IER)
       CALL GRQM10(0)                ! SPECIAL FOR LASER FROM SCHNEIDER
        ELSE
	OPEN (UNIT=GRUNIT(GRCIDE),
     1		NAME=GRFILE(GRCIDE)(1:GRFNLN(GRCIDE)),
     1		STATUS='NEW',
     1		FORM='UNFORMATTED', RECORDTYPE='VARIABLE',
     2		RECORDSIZE=300, CARRIAGECONTROL='NONE', IOSTAT=IER)
       ENDIF
	IF (IER.NE.0) THEN
	    CALL ERRSNS(IK1,IK2,IK3,IK4,IK5)
	    CALL GRWARN('Cannot open graphics device '
     1				//GRFILE(GRCIDE)(1:GRFNLN(GRCIDE)))
	    IF (IK2.NE.0 .AND. IK2.NE.1) CALL GRGMSG(IK2)
	    IF (IK5.NE.0 .AND. IK5.NE.1) CALL GRGMSG(IK5)
	    GRPR00 = IK5
	ELSE
	    INQUIRE (UNIT=GRUNIT(GRCIDE), NAME=GRFILE(GRCIDE))
	    I = LEN(GRFILE(GRCIDE))
	    DO WHILE (GRFILE(GRCIDE)(I:I).EQ.' ')
		I = I-1
	    END DO
	    GRFNLN(GRCIDE) = I
	    IF (GRCHKT(GRFILE(GRCIDE)(1:I))) THEN
		CALL GRWARN('Cannot send printer plot to terminal.')
		GRPR00 = 0
	    ELSE

		GRPR00 = 1
	    END IF
	END IF
	RETURN
	END
      SUBROUTINE GRQM10(MODE)
C     INCLUDE 'GRCM00.INS /NOLIST'
      INCLUDE 'GRPCKG1.INC'
      WRITE(GRUNIT(GRCIDE),'(A)') '^PY^-'
      IF(MODE.EQ.0) THEN
      WRITE(GRUNIT(GRCIDE),'(A)') '^IOL'
      ELSE IF(MODE.EQ.1) THEN
      WRITE(GRUNIT(GRCIDE),'(A)') '^IOP'
      END IF
      WRITE(GRUNIT(GRCIDE),'(A)') '^F^IMV0000011000^IMH0000008500'
      WRITE(GRUNIT(GRCIDE),'(A)') '^IGV'
      RETURN
      END
      SUBROUTINE GRQM01(I0,J0,I1,J1)
C     INCLUDE 'GRCM00.INS /NOLIST'
      INCLUDE 'GRPCKG1.INC'
      CHARACTER*26 VECTOR
      L=0
      IF((I0.NE.GRLSTI(GRCIDE)).OR.(J0.NE.GRLSTJ(GRCIDE)))THEN
      WRITE(VECTOR(L+1:),'(A2,I5.5,A1,I5.5)')  '^U',I0,
     $':',GRYMXA(GRCIDE)-J0
      L=L+13
      END IF
      WRITE(VECTOR(L+1:),'(A2,I5.5,A1,I5.5)')  '^D',I1,
     $':',GRYMXA(GRCIDE)-J1
      L=L+13
      WRITE(GRUNIT(GRCIDE),'(A)') VECTOR(1:L)
      GRLSTI(GRCIDE)=I1
      GRLSTJ(GRCIDE)=J1
      RETURN
      END
	SUBROUTINE GRPR01 (X,Y,XDIM,YDIM,XYBUF)
C-----------------------------------------------------------------------
C GRPCKG (internal routine, printer devices): write a dot in the frame
C buffer at position (X,Y).  This routine is called by basic plotting
C routines GRDOT0 and GRLIN2.
C
C Arguments:
C
C X, Y (integer, input): location of the dot to be set.
C XDIM, YDIM (integer, input): array dimensions of the frame buffer
C	considered as a two-dimensional byte array.
C XYBUF (byte array, input/output): (address of) the frame buffer.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE 'GRPCKG1.INC'
	BYTE    XYBUF(*), MASK(8)
	INTEGER I, K, X, Y, XDIM, YDIM
	DATA    MASK /'80'X,'40'X,'20'X,'10'X,'08'X,'04'X,'02'X,'01'X/
C
	IF (GRCTYP.EQ.VERS) THEN
	    I = X/8
	    K = 1 + X - I*8
	ELSE
	    I = X/6
	    K = 8 - X + I*6
	END IF
	I = (YDIM-Y-1)*XDIM + I + 1
	XYBUF(I) = XYBUF(I).OR.MASK(K)
	RETURN
	END
	SUBROUTINE GRPR03 (XDIM,YDIM,XYBUF)
C-----------------------------------------------------------------------
C GRPCKG (internal routine, printer devices): Copy the frame buffer to
C the external device. Output is written in unformatted mode through
C routine GRPR04 or GRPR05 with a single array specification. The
C Printronix printer does not like totally blank lines, so one null 
C plot character is written for blank lines.  This routine is called
C by GRCLOS and GRPAGE.
C
C Arguments:
C
C XDIM (integer, input): first dimension of frame buffer.
C YDIM (integer, input): second dimension of frame buffer.
C XYBUF (byte array(XDIM,YDIM), input/output): the frame buffer; each
C	byte holds 6 pixels (Printronix/Trilog) or 8 pixels (Versatec).
C	The buffer is reset to its "empty" state after printing.
C
C (11-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  I, IMAX, J, UNIT, XDIM, YDIM
	BYTE     NULL, XYBUF(XDIM,YDIM)
C
10    FORMAT(1X,' IN GRPR03 XDIM,YDIM,UNIT=',3I10)
	UNIT = GRUNIT(GRCIDE)
c     WRITE(3,10)XDIM,YDIM,UNIT
	IF (GRCTYP.EQ.VERS) THEN
	    NULL = '00'X
	    DO J=1,YDIM
		DO IMAX=XDIM,1,-1
		    IF (XYBUF(IMAX,J).NE.NULL) GOTO 100
		END DO
		IMAX = 1
  100		CALL GRPR05(XYBUF(1,J),IMAX,UNIT)
		DO I=1,IMAX
		    XYBUF(I,J) = NULL
		END DO
	    END DO
	ELSE
	    NULL = 'C0'X
	    DO J=1,YDIM
		DO IMAX=XDIM,1,-1
		    IF (XYBUF(IMAX,J).NE.NULL) GOTO 200
		END DO
		IMAX = 1
  200		CALL GRPR04(XYBUF(1,J),IMAX,UNIT,J)
		DO I=1,IMAX
		    XYBUF(I,J) = NULL
		END DO
	    END DO
	END IF
	RETURN
	END
	SUBROUTINE GRPR04 (X,N,UNIT,J)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Write one raster line to output device, in
C Printronix/Trilog format (append '05'X, CR, LF to buffer).  This
C routine is called by GRPR03 and GRPAGE.
C
C Arguments:
C
C X (input, byte array): line buffer.
C N (input, integer): number of bytes in buffer.
C UNIT (input, integer): Fortran unit number for output file.
C
C (11-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INTEGER  N, UNIT, J
	BYTE     X(N), SUFFIX(3)
	DATA	 SUFFIX /'05'X, 13, 10/
C
c     IF(N.EQ.220)WRITE(3,100)N,UNIT,J
100   FORMAT(1X,'   IN GRPR04 DIMENSION OF X IS N,UNIT=',2I12,
     +' J=',I6)
 	WRITE (UNIT,ERR=20) X, SUFFIX
20      CONTINUE
	RETURN
	END
	SUBROUTINE GRPR05 (X,N,UNIT)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Write one raster line to output device, in
C Versatec format (prefix '04'X to buffer).  This routine is called by
C GRPR03.
C
C Arguments:
C
C X (input, byte array): line buffer.
C N (input, integer): number of bytes in buffer.
C UNIT (input, integer): Fortran unit number for output file.
C
C (11-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INTEGER  N, UNIT
	BYTE     PREFIX, X(N)
	DATA     PREFIX /'04'X/
C
	WRITE (UNIT) PREFIX, X
	RETURN
	END
	SUBROUTINE GRQUIT (TEXT)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Report a fatal error (via GRWARN) and exit
C with fatal status; a traceback is generated unless the program is
C linked /NOTRACE. 
C
C Argument:
C
C TEXT (input, character): text of message to be sent to GRWARN.
C
C (10-Feb-1983)
C-----------------------------------------------------------------------
	CHARACTER*(*) TEXT
C
	CALL GRWARN(TEXT)
	CALL LIB$STOP(%VAL('15820C'X))	! "fatal error in library"
	END
	SUBROUTINE GRRECT (X0,Y0,X1,Y1)
C-----------------------------------------------------------------------
C GRPCKG: Fill a rectangle.  The rectangle is defined by its bottom
C left and top right corners. Attributes INTENSITY and COLOR apply to
C rectangle filling; attributes line-style and line-width are
C irrelevant.  On devices for which fill-rectangle is not a hardware
C function, filling is accomplished by drawing a
C series of vertical lines spaced by one pixel. Zero
C intensity may be used to erase the rectangle. CAUTION: this routine
C has no window checks at present.
C
C Arguments:
C
C X0, Y0 (input, real): world coordinates of bottom left corner of
C	rectangle.
C X1, Y1 (input, real): world coordinates of top right corner of 
C	rectangle.
C
C (11-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	CHARACTER*64 INSTR
	INTEGER  I,IX0,IX1,IY0,IY1,L
	REAL     X0,Y0,X1,Y1
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRRECT - no graphics device is active.')
	    RETURN
	END IF
C
	IX0 = NINT(X0*GRXSCL(GRCIDE) + GRXORG(GRCIDE))
	IY0 = NINT(Y0*GRYSCL(GRCIDE) + GRYORG(GRCIDE))
	IX1 = NINT(X1*GRXSCL(GRCIDE) + GRXORG(GRCIDE))
	IY1 = NINT(Y1*GRYSCL(GRCIDE) + GRYORG(GRCIDE))
	IF (IX0.GT.IX1) THEN
	    I = IX0
	    IX0 = IX1
	    IX1 = I
	END IF
	IF (GRCTYP.EQ.VT125) THEN
	    CALL SYS$FAO('P[!SL,!SL]V(W(S1[,!SL]))[][!SL]P',L,INSTR,
     1		%VAL(IX0), %VAL(IY1), %VAL(IY0), %VAL(IX1))
	    CALL GRVT02(INSTR(1:L),%VAL(GRPBAD(GRCIDE)))
	ELSE
	    DO I=IX0,IX1
		CALL GRLIN2(FLOAT(I),FLOAT(IY0),FLOAT(I),FLOAT(IY1))
	    END DO
	END IF
	RETURN
	END
	SUBROUTINE GRSCR (CI, CR, CG, CB)
C-----------------------------------------------------------------------
C GRPCKG: SET COLOUR REPRESENTATION -- define the colour to be
C associated with a colour index.  Ignored for devices which do not
C support variable colour or intensity.  On monochrome output
C devices (e.g. VT125 terminals with monochrome monitors), the
C monochrome intensity is computed from the specified Red, Green, Blue
C intensities as 0.30*R + 0.59*G + 0.11*B, as in US color television
C systems, NTSC encoding.  Note that most devices do not have an
C infinite range of colours or monochrome intensities available;
C the nearest available colour is used.
C
C Arguments:
C
C CI (integer, input): colour index, in the range 0-255. If the
C	a colour index greater than the device maximum is specified,
C	the call is ignored. Colour index 0 applies to the background 
C	colour.
C CR, CG, CB (real, input): red, green, and blue intensities, 
C	in range 0.0 to 1.0.
C
C 20-Feb-1984 - [TJP].
C  5-Jun-1984 - add GMFILE device [TJP].
C  2-Jul-1984 - add REGIS device [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	REAL      CR, CG, CB, CH, CL, CS
	INTEGER*2 GRNLBF(7), IR, IG, IB, CI, MONO
	INTEGER L
	CHARACTER*32 INSTR
C
C		Check for errors.
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRSCR - Specified workstation is not open.')
	ELSE IF (CI.LT.0) THEN
	    CALL GRWARN('GRSCR - Colour index is less than zero.')
	ELSE IF (CI.GT.255) THEN
	    CALL GRWARN('GRSCR - Colour index is invalid.')
	ELSE IF (CR.LT.0.0 .OR. CG.LT.0.0 .OR. CB.LT.0.0 .OR.
     1	         CR.GT.1.0 .OR. CG.GT.1.0 .OR. CB.GT.1.0) THEN
	    CALL GRWARN('GRSCR - Colour is outside range [0,1].')
C
C		Grinnell.
C
	ELSE IF (GRCTYP.EQ.GRINL) THEN
	    IR = MIN(255.,MAX(CR*255.,0.))
	    IG = MIN(255.,MAX(CG*255.,0.))
	    IB = MIN(255.,MAX(CB*255.,0.))
	    GRNLBF(1) = 'A001'X		! SPD 1 (image function video)
	    GRNLBF(2) = 'B000'X .OR. CI	! LPA (table A) (red)
	    GRNLBF(3) = 'D000'X .OR. IR
	    GRNLBF(4) = 'B400'X .OR. CI	! LPA (table B) (green)
	    GRNLBF(5) = 'D000'X .OR. IG
	    GRNLBF(6) = 'B800'X .OR. CI	! LPA (table C) (blue)
	    GRNLBF(7) = 'D000'X. OR. IB
	    CALL GRGR02(GRNLBF,7,%VAL(GRPBAD(GRCIDE)))
C
C		Metafile.
C
	ELSE IF (GRCTYP.EQ.GMFILE) THEN
	    IR = MIN(32767.,MAX(CR*32767.,0.))
	    IG = MIN(32767.,MAX(CG*32767.,0.))
	    IB = MIN(32767.,MAX(CB*32767.,0.))
	    GRNLBF(1) = 'C004'X
	    GRNLBF(2) = CI
	    GRNLBF(3) = IR
	    GRNLBF(4) = IG
	    GRNLBF(5) = IB
	    CALL GRMF02(5,GRNLBF,%VAL(GRPBAD(GRCIDE)))
C
C		Regis.
C
	ELSE IF (GRCTYP.EQ.VT125 .AND. CI.LE.3) THEN
	    MONO = NINT(30.*CR + 59.*CG + 11.*CB)
	    CALL GRXHLS(CR,CG,CB,CH,CL,CS)
	    IR = NINT(CH)	! hue
	    IG = NINT(100.*CL)	! lightness
	    IB = NINT(100.*CS)	! saturation
	    CALL SYS$FAO('S(M!SL(L!SL)(AH!SLL!SLS!SL))',L,INSTR,
     1		         %VAL(CI),%VAL(MONO),%VAL(IR),%VAL(IG),%VAL(IB))
	    CALL GRVT02(INSTR(1:L),%VAL(GRPBAD(GRCIDE)))
C
C		Tektronix 4100 series.
C
	ELSE IF (GRCTYP.EQ.TEK14 .AND. CI.LE.15) THEN
	    CALL GRXHLS(CR,CG,CB,CH,CL,CS)
C	    *** not yet implemented ***
	END IF
	RETURN
	END
	SUBROUTINE GRSELECT (IDENT)
C-----------------------------------------------------------------------
C GRPCKG: Check that IDENT is a valid plot identifier, and select the
C corresponding plot as the current plot. All subsequent plotting will
C be directed to this device until the assignment is changed by another
C call to GRSELECT.
C
C Argument:
C
C IDENT (input, integer): the identifier of the plot to be selected, as
C	returned by GROPEN.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  IDENT
C
C     WRITE(6,600)IDENT
C600   FORMAT('  IN GRSELECT IDENT=',I5)
	IF ((IDENT.LE.0) .OR. (IDENT.GT.GRIMAX) .OR.
     1	    (.NOT.GRINIT(IDENT))) THEN
	    CALL GRWARN('GRSELECT - invalid plot identifier.')
	ELSE
	    GRCIDE = IDENT
	    GRCTYP = GRTYPE(IDENT)
	END IF
	RETURN
	END
	SUBROUTINE GRSETC (IDENT,XSIZE)
C-----------------------------------------------------------------------
C	GRPCKG : change the character size
C	(User-callable routine)
C	Input:	IDENT : plot identifier
C	        XSIZE : the new character width. The character height
C		        and spacing will be scaled by the same factor.
C			If XSIZE is negative or zero, the character size
C			will be set to the default size.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	INCLUDE 'GRPCKG1.INC'
	INTEGER IDENT
	REAL XSIZE
C
C
	CALL GRSELECT(IDENT)
	IF (XSIZE.LE.0.0) THEN
	    GRCFAC(IDENT) = 1.0
	ELSE
	    GRCFAC(IDENT) = XSIZE / GRCXSZ
	END IF
	RETURN
	END
	SUBROUTINE GRSETCOL (IC)
C-----------------------------------------------------------------------
C GRPCKG: Set the color index for subsequent plotting. Calls to GRSETCOL
C are ignored for monochrome devices. The default color index is 1, 
C usually white on a black background for video displays or black on a
C white background for printer plots. The color index is an integer in
C the range 0 to a device-dependent maximum. Color index 0 corresponds
C to the background color; lines may be "erased" by overwriting them
C with color index 0.
C
C Color indices 0-7 are predefined as follows: 0 = black (background
C color), 1 = white (default), 2 = red, 3 = green, 4 = blue, 5 = cyan 
C (blue + green), 6 = magenta (red + blue), 7 = yellow (red + green).
C The assignment of colors to color indices can be changed with
C subroutine GRSCR (set color representation).
C
C Argument:
C
C IC (integer, input): the color index to be used for subsequent
C	plotting on the current device (in range 0-255). If the
C	index exceeds the device-dependent maximum, the maximum is
C	used.
C
C 11-Apr-1983 - [TJP].
C  3-Jun-1984 - add GMFILE device [TJP].
C 13-Jun-1984 - add code for TK4100 devices [TJP].
C  2-Jul-1984 - add code for RETRO and VT125 (REGIS) devices [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  IC,COLOR,L
	INTEGER*2 GRNLBF(2)
	CHARACTER*20 INSTR
	BYTE     IDBUF(8), IDCOL(0:7), TKBUF(4), REBUF(6)
	DATA IDBUF / 27, 80, 32, 48, 44, 48, 32, 13 /
	DATA IDCOL / 48, 55, 49, 50, 52, 54, 53, 51 /
	DATA TKBUF / 27, 77, 76, 48 /
	DATA REBUF / 29, 27, 47, 48, 100, 31 /
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRSETCOL - no graphics device is active.')
	    RETURN
	END IF
C
	COLOR = IC
	IF (COLOR.LT.0) THEN
	    CALL GRWARN('Illegal color selected: 1 used.')
	    COLOR = 1
	END IF
	IF (COLOR.EQ.GRCCOL(GRCIDE)) RETURN
	IF (GRCTYP.EQ.GMFILE) THEN
	    COLOR = MIN(COLOR,255)
	    CALL GRMF02(1,'C101'X,%VAL(GRPBAD(GRCIDE)))
	    CALL GRMF02(1,COLOR,%VAL(GRPBAD(GRCIDE)))
	    GRCCOL(GRCIDE) = COLOR
	ELSE IF (GRCTYP.EQ.GRINL) THEN
	    COLOR = MIN(COLOR,255)
	    GRNLBF(1) = '1000'X.OR.COLOR
	    CALL GRGR02(GRNLBF,1,%VAL(GRPBAD(GRCIDE)))
	    GRCCOL(GRCIDE) = COLOR
	ELSE IF (GRCTYP.EQ.ARGS) THEN
	    COLOR = MIN(COLOR,255)
	    GRNLBF(1) = '2901'X
	    GRNLBF(2) = COLOR
	    CALL GRAR02(GRNLBF,2,%VAL(GRPBAD(GRCIDE)))
	    GRCCOL(GRCIDE) = COLOR
	ELSE IF (GRCTYP.EQ.ID100) THEN
	    COLOR = MIN(COLOR,15)
	    IDBUF(4) = IDCOL(MOD(COLOR,8))
	    IDBUF(6) = 48
	    IF (COLOR.GT.7) IDBUF(6) = 1
	    CALL GRTK02(IDBUF,8,%VAL(GRPBAD(GRCIDE)))
	    GRCCOL(GRCIDE) = COLOR
	ELSE IF (GRCTYP.EQ.TEK14) THEN
	    COLOR = MIN(COLOR,15)
	    TKBUF(4) = 48 + COLOR
	    CALL GRTK02(TKBUF,4,%VAL(GRPBAD(GRCIDE)))
	    GRCCOL(GRCIDE) = COLOR
	ELSE IF (GRCTYP.EQ.VT125) THEN
	    COLOR = MIN(COLOR,3)
	    CALL SYS$FAO('W(I!SL)',L,INSTR,%VAL(COLOR))
	    CALL GRVT02(INSTR(1:L),%VAL(GRPBAD(GRCIDE)))
	    GRCCOL(GRCIDE) = COLOR
	ELSE IF (GRCTYP.EQ.RETRO) THEN
	    COLOR = MIN(COLOR,1)
	    REBUF(4) = 49 - COLOR
	    CALL GRTK02(REBUF,6,%VAL(GRPBAD(GRCIDE)))
	    GRCCOL(GRCIDE) = COLOR
	ELSE
	    GRCCOL(GRCIDE) = 1
	END IF
	RETURN
	END
	SUBROUTINE GRSETFONT (IF)
C-----------------------------------------------------------------------
C GRPCKG: Set the font for subsequent text plotting.  
C The default font is 1 ("Normal" font); others available are 2
C ("Roman"), 3 ("Italic"), and 4 ("Script").
C
C Argument:
C
C IF (integer, input): the font number to be used for subsequent
C	text plotting on the current device (in range 1-4).
C
C 19-Mar-1983 - [TJP].
C  4-Jun-1984 - add code for GMFILE device [TJP].
C-----------------------------------------------------------------------
	IMPLICIT   NONE
	INCLUDE    'GRPCKG1.INC'
	INTEGER    IF
	INTEGER*2  GMFBUF(2)
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRSETFONT - no graphics device is active.')
	    RETURN
	END IF
C
C		Set software font index.
C
	IF (IF.LT.1 .OR. IF.GT.4) THEN
	    CALL GRWARN('Illegal font selected: font not changed.')
	ELSE
	    GRCFNT(GRCIDE) = IF
	END IF
C
C		Devices which do hardware character generation
C		need special code.
C
	IF (GRCTYP.EQ.GMFILE) THEN
	    GMFBUF(1) = 'B101'X
	    GMFBUF(2) = IF
	    CALL GRMF02(2,GMFBUF,%VAL(GRPBAD(GRCIDE)))
	END IF
C
	RETURN
	END
	SUBROUTINE GRSETLI (IN)
C-----------------------------------------------------------------------
C GRPCKG: Set the line intensity for subsequent plotting on the current
C device. *** OBSOLETE ROUTINE *** Intensity is now set with GRSETCOL
C and GRSCR. For compatibility, GRSETLI now sets color zero if its
C argument is 0, and resets the previous color if its argument is
C non-zero.
C
C Argument:
C
C IN (integer, input): the intensity to be used for subsequent
C	plotting on the current device (in range 0-3).
C
C 11-Apr-1983 - [TJP].
C 12-Jul-1984 - modify to call GRSETCOL [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  IN, OLDCOL(GRIMAX)
	DATA     OLDCOL /GRIMAX*1/
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRSETLI - no graphics device is active.')
	ELSE IF (IN.EQ.0) THEN
	    OLDCOL(GRCIDE) = GRCCOL(GRCIDE)
	    CALL GRSETCOL(0)
	ELSE
	    CALL GRSETCOL(OLDCOL(GRCIDE))
	END IF
	RETURN
	END
	SUBROUTINE GRSETLS (IS)
C-----------------------------------------------------------------------
C GRPCKG: Set the line style for subsequent plotting on the current
C device. The different line styles are generated in hardware on
C some devices and by GRPCKG software for the other devices. Five
C different line styles are available, with the following codes:
C 1 (full line), 2 (dashed), 3 (dot-dash-dot-dash), 4 (dotted),
C 5 (dash-dot-dot-dot). The default is 1 (normal full line). Line
C style is ignored when drawing characters, which are always drawn with
C a full line.
C
C Argument:
C
C IS (input, integer): the line-style code for subsequent plotting on
C	the current device (in range 1-5).
C
C  9-Feb-1983 - [TJP].
C  3-Jun-1984 - add GMFILE device [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE 'GRPCKG1.INC'
	BYTE     RETRO_DASH(4), RETRO_CODE(5)
	CHARACTER*20 INSTR, KEYWORD
	INTEGER I,IS,L
	REAL PATERN(8,5)
C
	DATA PATERN/ 8*10.0,
     1		     8*10.0,
     2		     8.0, 6.0, 1.0, 6.0, 8.0, 6.0, 1.0, 6.0,
     3		     1.0, 6.0, 1.0, 6.0, 1.0, 6.0, 1.0, 6.0,
     4		     8.0, 6.0, 1.0, 6.0, 1.0, 6.0, 1.0, 6.0 /
	DATA RETRO_DASH /29, 27, 96, 31 /
	DATA RETRO_CODE /96, 99, 98, 97, 100/
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRSETLS - no graphics device is active.')
	    RETURN
	END IF
C
	I = IS
	IF (I.LT.1 .OR. I.GT.5) THEN
	    CALL GRWARN('GRSETLS - invalid line-style requested.')
	    I = 1
	END IF
	IF (GRCTYP.EQ.VT125) THEN
	    GRDASH(GRCIDE) = .FALSE.		! hardware dashing
	    IF (I.NE.GRSTYL(GRCIDE)) THEN
		CALL SYS$FAO('W(P!SL)',L,INSTR,%VAL(I))
		CALL GRVT02(INSTR(1:L),%VAL(GRPBAD(GRCIDE)))
	    END IF
	ELSE IF (GRCTYP.EQ.GMFILE) THEN
	    GRDASH(GRCIDE) = .FALSE.		! hardware dashing
	    IF (I.NE.GRSTYL(GRCIDE)) THEN
		CALL GRMF02(1,'C301'X,%VAL(GRPBAD(GRCIDE)))
		CALL GRMF02(1,I,%VAL(GRPBAD(GRCIDE)))
	    END IF
C*- Code for /RETRO doesn't work at present as pattern gets reset at
C*- start of every vector.
C*	ELSE IF (GRCTYP.EQ.RETRO) THEN
C*	    GRDASH(GRCIDE) = .FALSE.
C*	    IF (I.NE.GRSTYL(GRCIDE)) THEN
C*		RETRO_DASH(3) = RETRO_CODE(I)
C*		CALL GRTK02(RETRO_DASH,4,%VAL(GRPBAD(GRCIDE)))
C*	    END IF
	ELSE
	    IF (I.EQ.1) THEN
		GRDASH(GRCIDE) = .FALSE.
	    ELSE
		GRDASH(GRCIDE) = .TRUE.		! software dashing
		GRIPAT(GRCIDE) = 1
		GRPOFF(GRCIDE) = 0.0
		DO L=1,8
		    GRPATN(GRCIDE,L) =
     1			PATERN(L,I)*GRYMX0(GRCTYP)/1000.0
		END DO
	    END IF
	END IF
	GRSTYL(GRCIDE) = I
	RETURN
	END
	SUBROUTINE GRSETLW (IW)
C-----------------------------------------------------------------------
C GRPCKG: Set the line width for subsequent plotting on the current
C device. Thick lines are generated by tracing each line with multiple
C strokes offset in the direction perpendicular to the line. The line
C width is specified by the number of strokes to be used, which must be 
C in the range 1-21. The actual line width obtained depends on the
C device resolution.
C
C Argument:
C
C IW (integer, input): the number of strokes to be used for subsequent
C	plotting on the current device (in range 1-21).
C
C  1-Feb-1983 - [TJP].
C  3-Jun-1984 - add GMFILE device [TJP].
C 28-Aug-1984 - correct bug in GMFILE: redundant SET_LINEWIDTH commands
C               were not being filtered out [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE 'GRPCKG1.INC'
	INTEGER I,IW
C
	IF (GRCIDE.LT.1) THEN

	    CALL GRWARN('GRSETLW - no graphics device is active.')
	    RETURN
	END IF
C
	I = IW
	IF (I.LT.1 .OR. I.GT.21) THEN
	    CALL GRWARN('GRSETLW - invalid line-width requested.')
	    I = 1
	END IF
	IF (GRCTYP.EQ.GMFILE .AND. I.NE.ABS(GRWIDT(GRCIDE))) THEN
	    CALL GRMF02(1,'C401'X,%VAL(GRPBAD(GRCIDE)))
	    CALL GRMF02(1,I,%VAL(GRPBAD(GRCIDE)))
	    I = -I
C	    [The negative value suppresses software linewidth 
C	    emulation.]
	END IF
	GRWIDT(GRCIDE) = I
	RETURN
	END
	SUBROUTINE GRSETPEN (IP)
C-----------------------------------------------------------------------
C GRPCKG: Set the pen number for subsequent plotting.  This is only
C available for the Metafile device; calls to GRSETPEN are ignored
C for other devices. The default pen is 0: i.e., no pen is selected
C and the other attributes are used.
C
C Argument:
C
C IC (integer, input): the pen to be used for subsequent
C	plotting on the current device (in range 0-255). If IP=0,
C	any currently-selected pen is deselected. If IP>0, that pen
C	is selected.
C
C 6-Jun-1984 - new routine [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  IP
	INTEGER*2 GMFBUF(2)
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRSETPEN - no graphics device is active.')
	    RETURN
	END IF
C
	IF (IP.EQ.GRCPEN(GRCIDE)) RETURN
	IF (IP.LT.0 .OR. IP.GT.255) THEN
	    CALL GRWARN('GRSETPEN - illegal pen selected.')
	    RETURN
	END IF
	IF (GRCTYP.EQ.GMFILE) THEN
	    GMFBUF(1) = 'C501'X
	    GMFBUF(2) = IP
	    CALL GRMF02(2,GMFBUF,%VAL(GRPBAD(GRCIDE)))
	    GRCPEN(GRCIDE) = IP
	ELSE
	    GRCPEN(GRCIDE) = 0
	END IF
	RETURN
	END
	SUBROUTINE GRSETS (IDENT,XSIZE,YSIZE)
C-----------------------------------------------------------------------
C	GRPCKG : change size of plotting area. The requested dimensions
C	will be reduced to the absolute maximum of the plot device if
C	necessary.
C
C	Arguments:
C
C	IDENT (input, integer): plot identifier from GROPEN.
C	XSIZE (input, real): new x dimension of plot area (absolute
C		units); if less than zero, the default dimension
C		will be used.
C	YSIZE (input, real): new y dimension of plot area (absolute
C		units); if less than zero, the default dimension
C		will be used.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  GRIBF0, I, IER, IDENT, J
	REAL     XSIZE,YSIZE
C
	CALL GRSELECT(IDENT)
	CALL GRPAGE
	IF ((XSIZE .LT. 0.0) .OR. (YSIZE .LT. 0.0)) THEN
	    GRXMXA(IDENT) = GRXMX0(GRCTYP)
	    GRYMXA(IDENT) = GRYMX0(GRCTYP)
	ELSE
	    I = NINT(XSIZE)
	    J = NINT(YSIZE)
	    IF (GRXMX1(GRCTYP).GT.0) I = MIN(I,GRXMX1(GRCTYP))
	    IF (GRYMX1(GRCTYP).GT.0) J = MIN(J,GRYMX1(GRCTYP))
	    GRXMXA(IDENT) = I
	    GRYMXA(IDENT) = J
	END IF
	GRXMIN(IDENT) = 0
	GRXMAX(IDENT) = GRXMXA(IDENT)
	GRYMIN(IDENT) = 0
	GRYMAX(IDENT) = GRYMXA(IDENT)
	IER = GRIBF0()
	IF (IER.NE.1) CALL GRQUIT('dynamic allocation failed in GRSETS')
	RETURN
	END
	SUBROUTINE GRSIZE (IDENT,XSZDEF,YSZDEF,XSZMAX,YSZMAX,
     1			  XPERIN,YPERIN)
C-----------------------------------------------------------------------
C	GRPCKG : obtain device parameters
C	(User-callable routine)
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	INCLUDE 'GRPCKG1.INC'
	INTEGER IDENT
	REAL XSZDEF, YSZDEF, XSZMAX, YSZMAX, XPERIN, YPERIN
C
	CALL GRSELECT(IDENT)
	XSZDEF = FLOAT(GRXMX0(GRCTYP))
	YSZDEF = FLOAT(GRYMX0(GRCTYP))
	XSZMAX = FLOAT(GRXMX1(GRCTYP))
	YSZMAX = FLOAT(GRYMX1(GRCTYP))
	XPERIN = GRXPIN(GRCTYP)
	YPERIN = GRYPIN(GRCTYP)
	RETURN
	END
	SUBROUTINE GRSYM00
C-----------------------------------------------------------------------
C GRPCKG (internal routine): initialize font definition. This routine
C is called once by GROPEN. The character digitization is read from a
C file with logical name PLT$FONT.
C
C Arguments: none.
C
C (2-Jan-1984)
C 22-Jul-1984 - revise to use DATA statements [TJP].
C-----------------------------------------------------------------------
	IMPLICIT   NONE
	INTEGER*2  HERSH(0:175,4), BUFFER(27000), XYGRID(300)
	INTEGER    FNTFIL, IER, INDEX(3000), K, NC1, NC2, NC3
	COMMON     /GRSYMB/ NC1, NC2, INDEX, BUFFER
	COMMON     /GRHERSH/ HERSH
C
C		Read the font file.
C
	CALL LIB$GET_LUN(FNTFIL)
	OPEN (UNIT=FNTFIL, NAME='PLT$FONT', FORM='UNFORMATTED',
     1		  STATUS='OLD', READONLY, IOSTAT=IER)
	IF (IER.NE.0) CALL GRQUIT('Cannot open font file PLT$FONT')
	READ (FNTFIL) NC1,NC2,NC3,INDEX,BUFFER
	CLOSE (UNIT=FNTFIL)
	CALL LIB$FREE_LUN(FNTFIL)
	RETURN
C-----------------------------------------------------------------------
C
C		Special characters (graph markers).
C
	DATA (HERSH(  0,K),K=1,4) / 841, 841, 841, 841/
	DATA (HERSH(  1,K),K=1,4) / 899, 899, 899, 899/
	DATA (HERSH(  2,K),K=1,4) / 845, 845, 845, 845/
	DATA (HERSH(  3,K),K=1,4) / 847, 847, 847, 847/
	DATA (HERSH(  4,K),K=1,4) / 840, 840, 840, 840/
	DATA (HERSH(  5,K),K=1,4) / 846, 846, 846, 846/
	DATA (HERSH(  6,K),K=1,4) / 841, 841, 841, 841/
	DATA (HERSH(  7,K),K=1,4) / 842, 842, 842, 842/
	DATA (HERSH(  8,K),K=1,4) /2284,2284,2284,2284/
	DATA (HERSH(  9,K),K=1,4) /2281,2281,2281,2281/
	DATA (HERSH( 10,K),K=1,4) / 735, 735, 735, 735/
	DATA (HERSH( 11,K),K=1,4) / 843, 843, 843, 843/
	DATA (HERSH( 12,K),K=1,4) / 844, 844, 844, 844/
	DATA (HERSH( 13,K),K=1,4) / 852, 852, 852, 852/
	DATA (HERSH( 14,K),K=1,4) / 866, 866, 866, 866/
	DATA (HERSH( 15,K),K=1,4) / 868, 868, 868, 868/
	DATA (HERSH( 16,K),K=1,4) / 851, 851, 851, 851/
	DATA (HERSH( 17,K),K=1,4) / 850, 850, 850, 850/
	DATA (HERSH( 18,K),K=1,4) / 856, 856, 856, 856/
	DATA (HERSH( 19,K),K=1,4) / 254, 254, 254, 254/
	DATA (HERSH( 20,K),K=1,4) / 900, 900, 900, 900/
	DATA (HERSH( 21,K),K=1,4) / 901, 901, 901, 901/
	DATA (HERSH( 22,K),K=1,4) / 902, 902, 902, 902/
	DATA (HERSH( 23,K),K=1,4) / 903, 903, 903, 903/
	DATA (HERSH( 24,K),K=1,4) / 904, 904, 904, 904/
	DATA (HERSH( 25,K),K=1,4) / 905, 905, 905, 905/
	DATA (HERSH( 26,K),K=1,4) / 906, 906, 906, 906/
	DATA (HERSH( 27,K),K=1,4) / 907, 907, 907, 907/
	DATA (HERSH( 28,K),K=1,4) /2263,2263,2263,2263/
	DATA (HERSH( 29,K),K=1,4) /2261,2261,2261,2261/
	DATA (HERSH( 30,K),K=1,4) /2262,2262,2262,2262/
	DATA (HERSH( 31,K),K=1,4) /2264,2264,2264,2264/
C
C		Printable ASCII characters.
C
	DATA (HERSH( 32,K),K=1,4) / 699,2199,2199,2199/  ! space
	DATA (HERSH( 33,K),K=1,4) / 714,2214,2764,2764/  ! !
	DATA (HERSH( 34,K),K=1,4) / 717,2217,2778,2778/  ! "
	DATA (HERSH( 35,K),K=1,4) / 733,2275,2275,2275/  ! #
	DATA (HERSH( 36,K),K=1,4) / 719,2274,2769,2769/  ! $
	DATA (HERSH( 37,K),K=1,4) /2271,2271,2271,2271/  ! %
	DATA (HERSH( 38,K),K=1,4) / 734,2272,2768,2768/  ! &
	DATA (HERSH( 39,K),K=1,4) / 716,2216,2777,2777/  ! '
	DATA (HERSH( 40,K),K=1,4) / 721,2221,2771,2771/  ! (
	DATA (HERSH( 41,K),K=1,4) / 722,2222,2772,2772/  ! )
	DATA (HERSH( 42,K),K=1,4) / 728,2219,2773,2773/  ! *
	DATA (HERSH( 43,K),K=1,4) / 725,2232,2775,2775/  ! +
	DATA (HERSH( 44,K),K=1,4) / 711,2211,2761,2761/  ! ,
	DATA (HERSH( 45,K),K=1,4) / 724,2231,2774,2774/  ! -
	DATA (HERSH( 46,K),K=1,4) / 710,2210,2760,2760/  ! .
	DATA (HERSH( 47,K),K=1,4) / 720,2220,2770,2770/  ! /
	DATA (HERSH( 48,K),K=1,4) / 700,2200,2750,2750/  ! 0
	DATA (HERSH( 49,K),K=1,4) / 701,2201,2751,2751/  ! 1
	DATA (HERSH( 50,K),K=1,4) / 702,2202,2752,2752/  ! 2
	DATA (HERSH( 51,K),K=1,4) / 703,2203,2753,2753/  ! 3
	DATA (HERSH( 52,K),K=1,4) / 704,2204,2754,2754/  ! 4
	DATA (HERSH( 53,K),K=1,4) / 705,2205,2755,2755/  ! 5
	DATA (HERSH( 54,K),K=1,4) / 706,2206,2756,2756/  ! 6
	DATA (HERSH( 55,K),K=1,4) / 707,2207,2757,2757/  ! 7
	DATA (HERSH( 56,K),K=1,4) / 708,2208,2758,2758/  ! 8
	DATA (HERSH( 57,K),K=1,4) / 709,2209,2759,2759/  ! 9
	DATA (HERSH( 58,K),K=1,4) / 712,2212,2762,2762/  ! :
	DATA (HERSH( 59,K),K=1,4) / 713,2213,2763,2763/  ! ;
	DATA (HERSH( 60,K),K=1,4) /2241,2241,2241,2241/  ! <
	DATA (HERSH( 61,K),K=1,4) / 726,2238,2776,2776/  ! =
	DATA (HERSH( 62,K),K=1,4) /2242,2242,2242,2242/  ! >
	DATA (HERSH( 63,K),K=1,4) / 715,2215,2765,2765/  ! ?
	DATA (HERSH( 64,K),K=1,4) /2273,2273,2273,2273/  ! @
	DATA (HERSH( 65,K),K=1,4) / 501,2001,2051,2551/  ! A
	DATA (HERSH( 66,K),K=1,4) / 502,2002,2052,2552/  ! B
	DATA (HERSH( 67,K),K=1,4) / 503,2003,2053,2553/  ! C
	DATA (HERSH( 68,K),K=1,4) / 504,2004,2054,2554/  ! D
	DATA (HERSH( 69,K),K=1,4) / 505,2005,2055,2555/  ! E
	DATA (HERSH( 70,K),K=1,4) / 506,2006,2056,2556/  ! F
	DATA (HERSH( 71,K),K=1,4) / 507,2007,2057,2557/  ! G
	DATA (HERSH( 72,K),K=1,4) / 508,2008,2058,2558/  ! H
	DATA (HERSH( 73,K),K=1,4) / 509,2009,2059,2559/  ! I
	DATA (HERSH( 74,K),K=1,4) / 510,2010,2060,2560/  ! J
	DATA (HERSH( 75,K),K=1,4) / 511,2011,2061,2561/  ! K
	DATA (HERSH( 76,K),K=1,4) / 512,2012,2062,2562/  ! L
	DATA (HERSH( 77,K),K=1,4) / 513,2013,2063,2563/  ! M
	DATA (HERSH( 78,K),K=1,4) / 514,2014,2064,2564/  ! N
	DATA (HERSH( 79,K),K=1,4) / 515,2015,2065,2565/  ! O
	DATA (HERSH( 80,K),K=1,4) / 516,2016,2066,2566/  ! P
	DATA (HERSH( 81,K),K=1,4) / 517,2017,2067,2567/  ! Q
	DATA (HERSH( 82,K),K=1,4) / 518,2018,2068,2568/  ! R
	DATA (HERSH( 83,K),K=1,4) / 519,2019,2069,2569/  ! S
	DATA (HERSH( 84,K),K=1,4) / 520,2020,2070,2570/  ! T
	DATA (HERSH( 85,K),K=1,4) / 521,2021,2071,2571/  ! U
	DATA (HERSH( 86,K),K=1,4) / 522,2022,2072,2572/  ! V
	DATA (HERSH( 87,K),K=1,4) / 523,2023,2073,2573/  ! W
	DATA (HERSH( 88,K),K=1,4) / 524,2024,2074,2574/  ! X
	DATA (HERSH( 89,K),K=1,4) / 525,2025,2075,2575/  ! Y
	DATA (HERSH( 90,K),K=1,4) / 526,2026,2076,2576/  ! Z
	DATA (HERSH( 91,K),K=1,4) /2223,2223,2223,2223/  ! [
	DATA (HERSH( 92,K),K=1,4) /2235,2235,2235,2235/  ! \
	DATA (HERSH( 93,K),K=1,4) /2224,2224,2224,2224/  ! ]
	DATA (HERSH( 94,K),K=1,4) / 718,2218,2779,2779/  ! ^
	DATA (HERSH( 95,K),K=1,4) / 729,2236,2236,2236/  ! _
	DATA (HERSH( 96,K),K=1,4) /2249,2249,2249,2249/  ! `
	DATA (HERSH( 97,K),K=1,4) / 601,2101,2151,2651/  ! a
	DATA (HERSH( 98,K),K=1,4) / 602,2102,2152,2652/  ! b
	DATA (HERSH( 99,K),K=1,4) / 603,2103,2153,2653/  ! c
	DATA (HERSH(100,K),K=1,4) / 604,2104,2154,2654/  ! d
	DATA (HERSH(101,K),K=1,4) / 605,2105,2155,2655/  ! e
	DATA (HERSH(102,K),K=1,4) / 606,2106,2156,2656/  ! f
	DATA (HERSH(103,K),K=1,4) / 607,2107,2157,2657/  ! g
	DATA (HERSH(104,K),K=1,4) / 608,2108,2158,2658/  ! h
	DATA (HERSH(105,K),K=1,4) / 609,2109,2159,2659/  ! i
	DATA (HERSH(106,K),K=1,4) / 610,2110,2160,2660/  ! j
	DATA (HERSH(107,K),K=1,4) / 611,2111,2161,2661/  ! k
	DATA (HERSH(108,K),K=1,4) / 612,2112,2162,2662/  ! l
	DATA (HERSH(109,K),K=1,4) / 613,2113,2163,2663/  ! m
	DATA (HERSH(110,K),K=1,4) / 614,2114,2164,2664/  ! n
	DATA (HERSH(111,K),K=1,4) / 615,2115,2165,2665/  ! o
	DATA (HERSH(112,K),K=1,4) / 616,2116,2166,2666/  ! p
	DATA (HERSH(113,K),K=1,4) / 617,2117,2167,2667/  ! q
	DATA (HERSH(114,K),K=1,4) / 618,2118,2168,2668/  ! r
	DATA (HERSH(115,K),K=1,4) / 619,2119,2169,2669/  ! s
	DATA (HERSH(116,K),K=1,4) / 620,2120,2170,2670/  ! t
	DATA (HERSH(117,K),K=1,4) / 621,2121,2171,2671/  ! u
	DATA (HERSH(118,K),K=1,4) / 622,2122,2172,2672/  ! v
	DATA (HERSH(119,K),K=1,4) / 623,2123,2173,2673/  ! w
	DATA (HERSH(120,K),K=1,4) / 624,2124,2174,2674/  ! x
	DATA (HERSH(121,K),K=1,4) / 625,2125,2175,2675/  ! y
	DATA (HERSH(122,K),K=1,4) / 626,2126,2176,2676/  ! z
	DATA (HERSH(123,K),K=1,4) /2225,2225,2225,2225/  ! {
	DATA (HERSH(124,K),K=1,4) / 723,2229,2229,2229/  ! |
	DATA (HERSH(125,K),K=1,4) /2226,2226,2226,2226/  ! }
	DATA (HERSH(126,K),K=1,4) /2246,2246,2246,2246/  ! ~
	DATA (HERSH(127,K),K=1,4) / 699,2199,2199,2199/  ! delete
C
C		Greek alphabet.
C
	DATA (HERSH(128,K),K=1,4) / 527,2027,2027,2027/  ! \gA
	DATA (HERSH(129,K),K=1,4) / 528,2028,2028,2028/  ! \gB
	DATA (HERSH(130,K),K=1,4) / 529,2029,2029,2029/  ! \gG
	DATA (HERSH(131,K),K=1,4) / 530,2030,2030,2030/  ! \gD
	DATA (HERSH(132,K),K=1,4) / 531,2031,2031,2031/  ! \gE
	DATA (HERSH(133,K),K=1,4) / 532,2032,2032,2032/  ! \gZ
	DATA (HERSH(134,K),K=1,4) / 533,2033,2033,2033/  ! \gY
	DATA (HERSH(135,K),K=1,4) / 534,2034,2034,2034/  ! \gH
	DATA (HERSH(136,K),K=1,4) / 535,2035,2035,2035/  ! \gI
	DATA (HERSH(137,K),K=1,4) / 536,2036,2036,2036/  ! \gK
	DATA (HERSH(138,K),K=1,4) / 537,2037,2037,2037/  ! \gL
	DATA (HERSH(139,K),K=1,4) / 538,2038,2038,2038/  ! \gM
	DATA (HERSH(140,K),K=1,4) / 539,2039,2039,2039/  ! \gN
	DATA (HERSH(141,K),K=1,4) / 540,2040,2040,2040/  ! \gC
	DATA (HERSH(142,K),K=1,4) / 541,2041,2041,2041/  ! \gO
	DATA (HERSH(143,K),K=1,4) / 542,2042,2042,2042/  ! \gP
	DATA (HERSH(144,K),K=1,4) / 543,2043,2043,2043/  ! \gR
	DATA (HERSH(145,K),K=1,4) / 544,2044,2044,2044/  ! \gS
	DATA (HERSH(146,K),K=1,4) / 545,2045,2045,2045/  ! \gT
	DATA (HERSH(147,K),K=1,4) / 546,2046,2046,2046/  ! \gU
	DATA (HERSH(148,K),K=1,4) / 547,2047,2047,2047/  ! \gF
	DATA (HERSH(149,K),K=1,4) / 548,2048,2048,2048/  ! \gX
	DATA (HERSH(150,K),K=1,4) / 549,2049,2049,2049/  ! \gQ
	DATA (HERSH(151,K),K=1,4) / 550,2050,2050,2050/  ! \gW
	DATA (HERSH(152,K),K=1,4) / 627,2127,2127,2127/  ! \ga
	DATA (HERSH(153,K),K=1,4) / 628,2128,2128,2128/  ! \gb
	DATA (HERSH(154,K),K=1,4) / 629,2129,2129,2129/  ! \gg
	DATA (HERSH(155,K),K=1,4) / 630,2130,2130,2130/  ! \gd
	DATA (HERSH(156,K),K=1,4) / 684,2184,2184,2184/  ! \ge
	DATA (HERSH(157,K),K=1,4) / 632,2132,2132,2132/  ! \gz
	DATA (HERSH(158,K),K=1,4) / 633,2133,2133,2133/  ! \gy
	DATA (HERSH(159,K),K=1,4) / 685,2185,2185,2185/  ! \gh
	DATA (HERSH(160,K),K=1,4) / 635,2135,2135,2135/  ! \gi
	DATA (HERSH(161,K),K=1,4) / 636,2136,2136,2136/  ! \gk
	DATA (HERSH(162,K),K=1,4) / 637,2137,2137,2137/  ! \gl
	DATA (HERSH(163,K),K=1,4) / 638,2138,2138,2138/  ! \gm
	DATA (HERSH(164,K),K=1,4) / 639,2139,2139,2139/  ! \gn
	DATA (HERSH(165,K),K=1,4) / 640,2140,2140,2140/  ! \gc
	DATA (HERSH(166,K),K=1,4) / 641,2141,2141,2141/  ! \go
	DATA (HERSH(167,K),K=1,4) / 642,2142,2142,2142/  ! \gp
	DATA (HERSH(168,K),K=1,4) / 643,2143,2143,2143/  ! \gr
	DATA (HERSH(169,K),K=1,4) / 644,2144,2144,2144/  ! \gs
	DATA (HERSH(170,K),K=1,4) / 645,2145,2145,2145/  ! \gt
	DATA (HERSH(171,K),K=1,4) / 646,2146,2146,2146/  ! \gu
	DATA (HERSH(172,K),K=1,4) / 686,2186,2186,2186/  ! \gf
	DATA (HERSH(173,K),K=1,4) / 648,2148,2148,2148/  ! \gx
	DATA (HERSH(174,K),K=1,4) / 649,2149,2149,2149/  ! \gq
	DATA (HERSH(175,K),K=1,4) / 650,2150,2150,2150/  ! \gw
C-----------------------------------------------------------------------
	END
	SUBROUTINE  GRSYMDS (NUMSYM,LENNUM,TEXT)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Decode a character string, and
C return an array of integer symbol numbers. This routine is
C responsible for interpreting all escape sequences. At present the
C following escape sequences are defined (the letter following the \
C may be either upper or lower case):
C
C \u       :	up one level (returns -1)
C \d       :	down one level (returns -2)
C \b       :	backspace (returns -3)
C \A	   :    (upper case only) Angstrom symbol, roman font
C \\       :	\, returns the code for backslash
C \gx      :	greek letter corresponding to roman letter x
C \fn      :	switch to Normal font
C \fr      :	switch to Roman font
C \fi      :	switch to Italic font
C \fs      :	switch to Script font
C \(nnn)   :	Hershey symbol number nnn (any number of digits)
C
C Arguments:
C
C NUMSYM (output, integer array): receives the list of symbol numers.
C LENNUM (output, integer): receives the actual number of symbols
C	specified by the string; it is assumed that the dimension of
C	NUMSYM is big enough (not less than LEN(TEXT)).
C TEXT (input, character): the text string to be decoded.
C
C  3-May-1983 - [TJP].
C 13-Jun-1984 - add \A [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	CHARACTER*8  FONTS
	CHARACTER*48 GREEK
	PARAMETER (FONTS = 'nrisNRIS')
	PARAMETER (GREEK = 'ABGDEZYHIKLMNCOPRSTUFXQW' //
     1	                   'abgdezyhiklmncoprstufxqw' )
	INTEGER  CHAR, IFONT, IG, J, LENTXT, LENNUM, NUMSYM(*)
	INTEGER*2 HERSH(0:175,4)
	CHARACTER*(*) TEXT
	COMMON   /GRHERSH/ HERSH
C
C		Initialize parameters.
C
	LENTXT = LEN(TEXT)
	LENNUM = 0
	J = 0
	CALL GRINQFONT(IFONT)
C
C		Get next character; treat non-printing characters as
C		spaces.
C
  100	J = J+1
	IF (J.GT.LENTXT) RETURN
	CHAR = ICHAR(TEXT(J:J))
	IF (CHAR.LT.0)   CHAR = 32
	IF (CHAR.GT.175) CHAR = 32
C
C		Test for escape sequence (\)
C
	IF (CHAR.EQ.ICHAR('\')) THEN
	    IF ((LENTXT-J).GE.1) THEN
		IF (TEXT(J+1:J+1).EQ.'\') THEN
		    J = J+1
		ELSE IF (TEXT(J+1:J+1).EQ.'u' .OR.
     1		         TEXT(J+1:J+1).EQ.'U') THEN
		    LENNUM = LENNUM + 1
		    NUMSYM(LENNUM) = -1
		    J = J+1
		    GOTO 100
		ELSE IF (TEXT(J+1:J+1).EQ.'d' .OR.
     1		         TEXT(J+1:J+1).EQ.'D') THEN
		    LENNUM = LENNUM + 1
		    NUMSYM(LENNUM) = -2
		    J = J+1
		    GOTO 100
		ELSE IF (TEXT(J+1:J+1).EQ.'b' .OR.
     1		         TEXT(J+1:J+1).EQ.'B') THEN
		    LENNUM = LENNUM + 1
		    NUMSYM(LENNUM) = -3
		    J = J+1
		    GOTO 100
		ELSE IF (TEXT(J+1:J+1).EQ.'A') THEN
		    LENNUM = LENNUM + 1
		    NUMSYM(LENNUM) = 2078
		    J = J+1
		    GOTO 100
		ELSE IF (TEXT(J+1:J+1).EQ.'(') THEN
		    LENNUM = LENNUM + 1
		    NUMSYM(LENNUM) = 0
		    J = J+2
		    DO WHILE ('0'.LE.TEXT(J:J).AND.TEXT(J:J).LE.'9')
			NUMSYM(LENNUM) = NUMSYM(LENNUM)*10 +
     1			    ICHAR(TEXT(J:J)) - ICHAR('0')
		 	J = J+1
		    END DO
		    IF (TEXT(J:J).NE.')') J = J-1
		    GOTO 100
		ELSE IF (TEXT(J+1:J+1).EQ.'f' .OR.
     1			 TEXT(J+1:J+1).EQ.'F') THEN
		    IFONT = INDEX(FONTS, TEXT(J+2:J+2))
		    IF (IFONT.GT.4) IFONT = IFONT-4
		    IF (IFONT.EQ.0) IFONT = 1
		    J = J+2
		    GOTO 100
		ELSE IF (TEXT(J+1:J+1).EQ.'g' .OR.
     1			 TEXT(J+1:J+1).EQ.'G') THEN
		    IG = INDEX(GREEK, TEXT(J+2:J+2))
		    LENNUM = LENNUM + 1
		    NUMSYM(LENNUM) = HERSH(127 + IG, IFONT)
		    J = J+2
		    GOTO 100
		END IF
	    END IF
	END IF
C
C		Decode character.
C
	LENNUM = LENNUM + 1
	NUMSYM(LENNUM) = HERSH(CHAR,IFONT)
	GOTO 100
	END
	SUBROUTINE  GRSYMXD (NUMBER,XYGRID,UNUSED)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Return the digitization coordinates of a
C character. Each character is built up on a grid with X and Y
C coordinates in the range (-49,49), with the origin (0,0) at the
C center of the character.  The coordinate system is right-handed, with
C X positive to the right, and Y positive upward.  Characters are drawn
C with their tops upward, towards positive Y values. 
C
C Arguments:
C 
C NUMBER (input, integer): symbol number in range (1..3000).
C XYGRID (output, INTEGER*2 array): Height range, width range, and pairs
C	of (x,y) coordinates returned.  Height range = (XYGRID(1),
C	XYGRID(3)).  Width range = (XYGRID(4),XYGRID(5)).
C	(X,Y) = (XYGRID(K),XYGRID(K+1)) (K=6,8,...).
C UNUSED (output, logical): receives .TRUE. if NUMBER is an unused symbol
C	number. A character of normal height and zero width
C	is returned. Receives .FALSE. if NUMBER is a valid symbol number.
C 
C	The height range consists of 3 values: (minimum Y, baseline
C	Y, maximum Y).  The first is reached by descenders on
C	lower-case g, p, q, and y.  The second is the bottom of
C	upper-case letters.  The third is the top of upper-case
C	letters.  A coordinate pair (-64,0) requests a pen raise,
C	and a pair (-64,-64) terminates the coordinate list.  It is
C	assumed that movement to the first coordinate position will
C	be done with the pen raised - no raise command is
C	explicitly included to do this.
C
C (7-Mar-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INTEGER*2    BUFFER(27000), XYGRID(300)
        INTEGER      INDEX(3000), IX, IY, K, L, LOCBUF
	INTEGER      NC1, NC2, NUMBER
	LOGICAL      UNUSED
	COMMON       /GRSYMB/ NC1, NC2, INDEX, BUFFER
C
C		Extract digitization.
C
	IF (NUMBER.LT.NC1 .OR. NUMBER.GT.NC2) GOTO 3000
	L = NUMBER - NC1 + 1
	LOCBUF = INDEX(L)
	IF (LOCBUF .EQ. 0) GOTO 3000
	XYGRID(1) = BUFFER(LOCBUF)
	LOCBUF = LOCBUF + 1
	K = 2
	IY = -1
	DO WHILE (IY.NE.-64)
	    IX = BUFFER(LOCBUF)/128
	    IY = BUFFER(LOCBUF) - 128*IX - 64
	    XYGRID(K) = IX - 64
	    XYGRID(K+1) = IY
	    K = K + 2
	    LOCBUF = LOCBUF + 1
	END DO
	UNUSED = .FALSE.
	RETURN
C
C		Unimplemented character.
C
3000	XYGRID(1) = -16
	XYGRID(2) =  -9
	XYGRID(3) = +12
	XYGRID(4) =   0
	XYGRID(5) =   0
	XYGRID(6) = -64
	XYGRID(7) = -64
	UNUSED = .TRUE.
	RETURN
	END
	SUBROUTINE GRTEK1 (X0,Y0,MODE,PREXY,CURSOR,VECTOR)
C-----------------------------------------------------------------------
C GRPCKG (Tektronix): generate vector instruction. This routine
C handles optimization: after transmission of the first four bytes
C in a sequence ofvector instructions, subsequent bytes that do not
C change (excpet for the low X byte) need not be sent. If the high X
C byte changes then the low Y byte must also be sent.  For real
C Tektronixes, an extra null byte is needed after optimized vectors
C (requested by MODE=TEK10).
C
C (21-Nov-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE 'GRPCKG1.INC'
	INTEGER X0, Y0, CURSOR, X, Y, MODE
	BYTE PREXY(4), VECTOR(*)
	BYTE LOX, HIX, LOY, HIY
	BYTE LXMASK, HXMASK, LYMASK, HYMASK
	PARAMETER (LXMASK = '40'X)
	PARAMETER (HXMASK = '20'X)
	PARAMETER (LYMASK = '60'X)
	PARAMETER (HYMASK = '20'X)
C
	X = X0
	Y = Y0
	IF (MODE.EQ.TEK14) THEN
	    X = X/4
	    Y = Y/4
	END IF
	LOX = MOD(X,32) + LXMASK
	HIX = (X/32)    + HXMASK
	LOY = MOD(Y,32) + LYMASK
	HIY = (Y/32)    + HYMASK
	IF (HIY.NE.PREXY(1)) THEN
	    PREXY(1) = HIY
	    CURSOR = CURSOR + 1
	    VECTOR(CURSOR) = HIY
	END IF
	IF (LOY.NE.PREXY(2) .OR. HIX.NE.PREXY(3)) THEN
	    PREXY(2) = LOY
	    CURSOR = CURSOR + 1
	    VECTOR(CURSOR) = LOY
	END IF
	IF (HIX.NE.PREXY(3)) THEN
	    PREXY(3) = HIX
	    CURSOR = CURSOR+1
	    VECTOR(CURSOR) = HIX
	END IF
	CURSOR = CURSOR + 1
	VECTOR(CURSOR) = LOX
	IF (MODE.EQ.TEK10) THEN
	    CURSOR = CURSOR+1
	    VECTOR(CURSOR) = 0
	END IF
	RETURN
	END
	SUBROUTINE GRTERM
C-----------------------------------------------------------------------
C GRPCKG: flush the buffer associated with the current plot. GRTERM
C should be called only when it is necessary to make sure that all the
C graphics created up to this point in the program are visible on the
C device, e.g., before beginning a dialog with the user. GRTERM has no
C effect on hardcopy devices. 
C
C Arguments: none.
C
C (6-Oct-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	BYTE     TKHOME(7)
	DATA	 TKHOME / 29, 55, 127, 32, 64, 31, 24 /
C	(the "24" is a CAN code to reset VT640 terminals)
C
c     write(3,100)%val(grpbad(grcide)),grcide
100   format('  IN GRTERM GRPBAD=',I10,'  GRCIDE=',I5)
	IF (GRCIDE.LT.1) RETURN
	IF (GRCTYP.EQ.GRINL) THEN
	    CALL GRGR03(%VAL(GRPBAD(GRCIDE)))
	ELSE IF (GRCTYP.EQ.ARGS) THEN
	    CALL GRAR03(%VAL(GRPBAD(GRCIDE)))
	ELSE IF (GRCTYP.EQ.VT125) THEN
	    CALL GRVT03(%VAL(GRPBAD(GRCIDE)))
	ELSE IF (GRCTYP.EQ.TEK10 .OR. GRCTYP.EQ.TEK14 .OR.
     1		 GRCTYP.EQ.RETRO .OR. GRCTYP.EQ.ID100) THEN
	    CALL GRTK02(TKHOME,7,%VAL(GRPBAD(GRCIDE)))
	    CALL GRTK03(%VAL(GRPBAD(GRCIDE)))
	END IF
	RETURN
	END
	SUBROUTINE GRTEXT (CENTER,ORIENT,ABSXY,X0,Y0,STRING)
C-----------------------------------------------------------------------
C GRPCKG: Write a text string using the high-quality character set.
C The text is NOT windowed in the current viewport, but may extend over
C the whole view surface.  Line attributes (color, intensity thickness)
C apply to text, but line-style is ignored.  The current pen position
C after a call to GRTEXT is undefined.
C
C Arguments:
C
C STRING (input, character): the character string to be plotted. This
C	may include standard escape-sequences to represent non-ASCII
C	characters and special commands. The number of characters in
C	STRING (i.e., LEN(STRING)) should not exceed 256.
C
C (3-May-1983)
C-----------------------------------------------------------------------
*	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	LOGICAL ABSXY,UNUSED,VISBLE,CENTER
	INTEGER*2 XYGRID(300)
	INTEGER   LIST(256)
	CHARACTER*(*) STRING
	REAL ANGLE, FACTOR
	REAL COSA, SINA
	REAL DX, DY
	REAL XORG, YORG
	INTEGER XMIN, XMAX, YMIN, YMAX
	INTEGER MODE,LSTYLE
	INTEGER I, J
	INTEGER POINTS

	LOGICAL MORE
	REAL XT, YT
C
C		Check that there is something to be plotted.
C
	IF (LEN(STRING).LE.0) RETURN
C
C		Check that a device is selected.
C
	IF (GRCIDE.LT.1) THEN
	    CALL GRWARN('GRTEXT - no graphics device is active.')
	    RETURN
	END IF
C
C		Save current line-style, and set style "normal".
C
	CALL GRINQLS(LSTYLE)
	CALL GRSETLS(1)
C
C		Save current viewport, and open the
C		viewport to include the full view surface.
C
	XORG = GRXPRE(GRCIDE)
	YORG = GRYPRE(GRCIDE)
	XMIN = GRXMIN(GRCIDE)
	XMAX = GRXMAX(GRCIDE)
	YMIN = GRYMIN(GRCIDE)
	YMAX = GRYMAX(GRCIDE)
	CALL GRAREA(GRCIDE, 0.0, 0.0, 0.0, 0.0)
C
C		Compute scaling and orientation.
C
	ANGLE = ORIENT*(3.14159265/180.)
	FACTOR = GRCFAC(GRCIDE)/2.5
	RATIO = GRXPIN(GRCTYP)/GRYPIN(GRCTYP)
	COSA = FACTOR * COS(ANGLE)
	SINA = FACTOR * SIN(ANGLE)
	CALL GRTXY0(ABSXY, X0, Y0, XORG, YORG)
	FNTBAS = 0.0
	FNTFAC = 1.0
	IFNTLV = 0
	DX = 0.0
	DY = 0.0
C
C		Convert the string to a list of symbol numbers;
C		to prevent overflow of array LIST, the length of
C		STRING is limited to 256 ASCII characters.
C
	CALL GRSYMDS(LIST,NLIST,STRING(1:MIN(256,LEN(STRING))))
C
C		Plot the string of characters
C
	DO 380 I = 1,NLIST
	    IF (LIST(I).LT.0) THEN
		IF (LIST(I).EQ.-1) THEN		! up
		    IFNTLV = IFNTLV+1
		    FNTBAS = FNTBAS + 16.0*FNTFAC
		    FNTFAC = 0.75**IABS(IFNTLV)
		ELSE IF (LIST(I).EQ.-2) THEN	! down
		    IFNTLV = IFNTLV-1
		    FNTFAC = 0.75**IABS(IFNTLV)
		    FNTBAS = FNTBAS - 16.0*FNTFAC
		ELSE IF (LIST(I).EQ.-3) THEN	! backspace
		    XORG = XORG - DX*FNTFAC
		    YORG = YORG - DY*FNTFAC
		END IF
	        GOTO 380
	    END IF
	    CALL GRSYMXD(LIST(I),XYGRID,UNUSED)
	    VISBLE = .FALSE.
	    LX = XYGRID(5)-XYGRID(4)
	    DX = COSA*LX*RATIO
	    DY = SINA*LX
	    K = 4
	    LXLAST = -64
	    LYLAST = -64
  320	    K = K+2
	    LX = XYGRID(K) 
	    LY = XYGRID(K+1) 
	    IF (LY.EQ.-64) GOTO 330
	    IF (LX.EQ.-64) THEN
		VISBLE = .FALSE.
	    ELSE
		RLX = (LX - XYGRID(4))*FNTFAC
		RLY = (LY - XYGRID(2))*FNTFAC + FNTBAS
		IF ((LX.NE.LXLAST) .OR. (LY.NE.LYLAST)) THEN
		    XCUR = XORG + (COSA*RLX - SINA*RLY)*RATIO
		    YCUR = YORG + (SINA*RLX + COSA*RLY)
		    IF (VISBLE) THEN
		        CALL GRLIN0(XCUR,YCUR)
		    ELSE
		        GRXPRE(GRCIDE) = XCUR
		        GRYPRE(GRCIDE) = YCUR
		    END IF
	        END IF
	        VISBLE = .TRUE.
	        LXLAST = LX
	        LYLAST = LY
	    END IF
	    GOTO 320
  330	    XORG = XORG + DX*FNTFAC
            YORG = YORG + DY*FNTFAC
  380   CONTINUE
C
C		Restore the viewport and line-style, and return.
C
	GRXMIN(GRCIDE) = XMIN
	GRXMAX(GRCIDE) = XMAX
	GRYMIN(GRCIDE) = YMIN
	GRYMAX(GRCIDE) = YMAX
	CALL GRSETLS(LSTYLE)
	RETURN
C
	END
	INTEGER FUNCTION GRTK00 (FTYPE)
C-----------------------------------------------------------------------
C GRPCKG (internal routine, terminal devices): open a device for
C plotting. If an error occurs, a message is sent to SYS$OUTPUT.
C
C Arguments:
C
C FTYPE (integer, input): specifies the device type code.
C	GRTK00 checks that the device is of the correct type.
C
C Returns:
C
C GRTK00 (integer, output): receives 1 if the device was opened
C	successfully. Any other value indicates that an error occurred.
C	Usually the value is the corresponding VMS error code.
C
C (11-Apr-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  DVI$_DEVCLASS, DVI$_DEVNAM
	PARAMETER (DVI$_DEVCLASS=4)
	PARAMETER (DVI$_DEVNAM=32)
	INTEGER  DEVCLASS, ITMLIST(7), IOSB(2)
	INTEGER  FTYPE, DEVTYP, IER, L, SYS$ASSIGN
	INTEGER  SYS$GETDVI, SYS$DASSGN, SYS$WAITFR
C
C		Assign an i/o channel
C
	L = GRFNLN(GRCIDE)
c       WRITE(3,200)(GRFILE(GRCIDE)(1:L))
200    FORMAT('  DEVICE TYPE RECOGNIZED AS ',A)
	IER = SYS$ASSIGN(GRFILE(GRCIDE)(1:L), GRUNIT(GRCIDE),,)
	IF (.NOT.IER) GOTO 100
C
C		Check that device has correct characteristics,
C		and obtain true device name.
C
	ITMLIST(1) = DVI$_DEVCLASS*2**16 + 4
	ITMLIST(2) = %LOC(DEVCLASS)
	ITMLIST(3) = 0
	ITMLIST(4) = DVI$_DEVNAM*2**16 + LEN(GRFILE(GRCIDE))
	ITMLIST(5) = %LOC(GRFILE(GRCIDE))
	ITMLIST(6) = %LOC(GRFNLN(GRCIDE))
	ITMLIST(7) = 0
	IER = SYS$GETDVI(%VAL(0),,GRFILE(GRCIDE)(1:GRFNLN(GRCIDE)),
     1		ITMLIST,IOSB,,,)
	IF (.NOT.IER) GOTO 100
	IER = SYS$WAITFR(%VAL(0))
	IF (.NOT.IER) GOTO 100
	IF (.NOT.IOSB(1)) THEN
	    IER = IOSB(1)
	    GOTO 100
	END IF
	DEVTYP = 66
	IF (FTYPE.EQ.GRINL) DEVTYP = 32
	IF (FTYPE.EQ.ARGS)  DEVTYP = 32
	IF (DEVCLASS.NE.DEVTYP) THEN
	    CALL GRWARN(
     1		GRFILE(GRCIDE)(1:GRFNLN(GRCIDE))//
     2		' is the wrong sort of device for plot type '//
     3		GRTYPN(FTYPE))
	    GRTK00 = 32767	! indicate error
	    IER = SYS$DASSGN(%VAL(GRUNIT(GRCIDE)))
	    RETURN
	END IF
C
C		Successful completion
C
	GRTK00 = 1
	RETURN
C
C		Error exit
C
  100	CALL GRWARN('Cannot open graphics device '//
     1			GRFILE(GRCIDE)(1:L))
	CALL GRGMSG(IER)
	GRTK00 = IER
	RETURN
	END
	SUBROUTINE GRTK01 (X0,Y0,X1,Y1)
C-----------------------------------------------------------------------
C GRPCKG (Tektronix) : draw a line from (X0,Y0) to (X1,Y1)
C
C (21-Nov-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INTEGER X0, Y0, X1, Y1
	INCLUDE 'GRPCKG1.INC'
	BYTE GS, US
	PARAMETER (GS = '1D'X, US = '1F'X)
	INTEGER CURSOR
	BYTE VECTOR(20)
C
	CURSOR = 0
C
	IF (X0.NE.GRLSTI(GRCIDE) .OR. Y0.NE.GRLSTJ(GRCIDE)) THEN
	     CURSOR = CURSOR+1
	     VECTOR(CURSOR) = GS
	     GRXYSV(GRCIDE) = 0
	     CALL GRTEK1(X0,Y0,GRCTYP,GRXYSV(GRCIDE),CURSOR,VECTOR)
	END IF
	CALL GRTEK1(X1,Y1,GRCTYP,GRXYSV(GRCIDE),CURSOR,VECTOR)
	GRLSTI(GRCIDE) = X1
	GRLSTJ(GRCIDE) = Y1
	CALL GRTK02(VECTOR,CURSOR,%VAL(GRPBAD(GRCIDE)))
	RETURN
	END
	SUBROUTINE GRTK02 (INSTR,N,BUFFER)
C-----------------------------------------------------------------------
C GRPCKG (Tektronix) : transfer N bytes to output buffer
C from INSTR(1...N). Note N must be < 20. Check that 20 bytes are left
C is done at end, not beginning, as this affects how vector commands
C are formatted. A bit of mess, I am afraid.
C
C (21-Nov-1983)
C-----------------------------------------------------------------------
	BYTE INSTR(N)
	BYTE BUFFER(*)
	INCLUDE 'GRPCKG1.INC'
C
C     WRITE(3,102)%VAL(BUFFER(1))
C      write(3,100)n,(instr(i),i=1,n)
C100    format('   IN GRTK03 N=',I2,' INSTR=',7I4)
	DO I=1,N
	    GRBHWM(GRCIDE) = GRBHWM(GRCIDE)+1
C        WRITE(3,101)GRCIDE,GRBHWM(GRCIDE)
CC101   FORMAT('  GRCIDE=',I4,'  GRBHWM=',I6)
C102   FORMAT('   BUFFER ADDRESS=',I10)
	    BUFFER(GRBHWM(GRCIDE)) = INSTR(I)
	END DO
	IF (GRBHWM(GRCIDE)+20 .GE. GRPBXD(GRCIDE)) THEN
	    GRBHWM(GRCIDE) = GRBHWM(GRCIDE)+1
	    BUFFER(GRBHWM(GRCIDE)) = '1F'X
	    CALL GRTK03(BUFFER)
	END IF
	RETURN
	END
	SUBROUTINE GRTK03 (BUFFER)
C-----------------------------------------------------------------------
C GRPCKG (Tektronix) : flush buffer contents.  BUFFER is passed as
C an argument because it is a dynamic array.
C
C (21-Nov-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	BYTE BUFFER(*)
	INCLUDE 'GRPCKG1.INC'
	INCLUDE '($IODEF)'
	INCLUDE '($SSDEF)'
	INTEGER SYS$QIOW
	PARAMETER WRITE = IO$_WRITEVBLK + IO$M_NOFORMAT + IO$M_CANCTRLO
	INTEGER RESULT, N
	INTEGER IOSB(2)
	INTEGER*2 STBC(2), STATUS, COUNT
	EQUIVALENCE (STBC, IOSB(1)), (STATUS, STBC(1)), (COUNT, STBC(2))
C
	N = GRBHWM(GRCIDE)
	GRLSTI(GRCIDE) = -1
	GRLSTJ(GRCIDE) = -1
	GRXYSV(GRCIDE) = 0
	GRBHWM(GRCIDE) = 0
	IF (N.LT.1) RETURN
	RESULT = SYS$QIOW(,%VAL(GRUNIT(GRCIDE)),%VAL(WRITE),IOSB,,
     1			  ,BUFFER,%VAL(N),,,,)
	IF (RESULT.NE.SS$_NORMAL) THEN
	    CALL GRGMSG(RESULT)
	    CALL GRQUIT('SYS$QIOW failure writing to Tek terminal')
	END IF
	IF ((STATUS.NE.SS$_NORMAL) .AND.
     1	    (STATUS.NE.SS$_CONTROLO) .AND.
     2	    (STATUS.NE.SS$_CONTROLY) .AND.
     3	    (STATUS.NE.SS$_CONTROLC)) THEN
	    RESULT = STATUS
	    CALL GRGMSG(RESULT)
	    CALL GRQUIT('SYS$QIOW failure writing to Tek terminal')
	END IF
	RETURN
	END
	SUBROUTINE GRTRAN (IDENT,XORG,YORG,XSCALE,YSCALE)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Define scaling transformation.
C
C Arguments:
C
C IDENT (input, integer): plot identifier, as returned by GROPEN.
C XORG, YORG, XSCALE, YSCALE (input, real): parameters of the scaling
C	transformation. This is defined by:
C		XABS = XORG + XWORLD * XSCALE,
C		YABS = YORG + YWORLD * YSCALE,
C	where (XABS, YABS) are the absolute device coordinates
C	corresponding to world coordinates (XWORLD, YWORLD).
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INTEGER  IDENT
	REAL     XORG, YORG, XSCALE, YSCALE
C
	CALL GRSELECT(IDENT)
	CALL GRTRN0(XORG, YORG, XSCALE, YSCALE)
	RETURN
	END
	SUBROUTINE GRTRN0 (XORG,YORG,XSCALE,YSCALE)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Define scaling transformation for current
C device (equivalent to GRTRAN without device selection).
C
C Arguments:
C
C XORG, YORG, XSCALE, YSCALE (input, real): parameters of the scaling
C	transformation. This is defined by:
C		XABS = XORG + XWORLD * XSCALE,
C		YABS = YORG + YWORLD * YSCALE,
C	where (XABS, YABS) are the absolute device coordinates
C	corresponding to world coordinates (XWORLD, YWORLD).
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	REAL     XORG, YORG, XSCALE, YSCALE
C
	GRXORG(GRCIDE) = XORG
	GRXSCL(GRCIDE) = XSCALE
	GRYORG(GRCIDE) = YORG
	GRYSCL(GRCIDE) = YSCALE
	RETURN
	END
	SUBROUTINE GRTXY0 (ABSXY,X,Y,XT,YT)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Convert scaled position to absolute 
C position.
C
C Arguments:
C
C ABSXY (input, logical): if FALSE, convert world coordinates to
C	absolute device coordinates; if TRUE, return the input
C	coordinates unchanged.
C X, Y (input, real): input coordinates (absolute or world, depending
C	on setting of ABSXY).
C XT, YT (output, real): output absolute device coordinates.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	LOGICAL  ABSXY
	REAL     X, Y, XT, YT
C
	IF (ABSXY) THEN
	    XT = X
	    YT = Y
	ELSE
	    XT = X * GRXSCL(GRCIDE) + GRXORG(GRCIDE)
	    YT = Y * GRYSCL(GRCIDE) + GRYORG(GRCIDE)
	END IF
	RETURN
	END
	SUBROUTINE GRVCT0 (MODE,ABSXY,POINTS,X,Y)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Draw a line or a set of dots. This
C is the same as GRVECT, but without device selection. It can be used to
C draw a single line-segment, a continuous series of line segments, or
C one or more single dots (pixels).
C
C Arguments:
C
C MODE (input, integer): if MODE=1, a series of line segments is drawn,
C	starting at the current position, moving to X(1),Y(1), ... and
C	ending at X(POINTS),Y(POINTS).
C	If MODE=2, the first vector is blanked, so the line starts at
C	X(1),Y(1).
C	If MODE=3, a single dot is placed at each coordinate pair, with
C	no connecting lines.
C ABSXY (input, logical): if TRUE, the coordinates are absolute device
C	coordinates; if FALSE, they are world coordinates and the 
C	scaling transformation is applied.
C POINTS (input, integer): the number of coordinate pairs.
C X, Y (input, real arrays, dimensioned POINTS or greater): the
C	X and Y coordinates of the points.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  I, MODE, POINTS
	LOGICAL  ABSXY
	REAL     X(POINTS), Y(POINTS), XCUR, YCUR
C
	IF (MODE.EQ.1) THEN
	    CALL GRTXY0(ABSXY, X(1), Y(1), XCUR, YCUR)
	    CALL GRLIN0(XCUR, YCUR)
	ELSE IF (MODE.EQ.2) THEN
	    CALL GRTXY0(ABSXY, X(1), Y(1), GRXPRE(GRCIDE), GRYPRE(GRCIDE))
	END IF
	IF (MODE.EQ.1 .OR. MODE.EQ.2) THEN
	    DO I=2,POINTS
		CALL GRTXY0(ABSXY, X(I), Y(I), XCUR, YCUR)
		CALL GRLIN0(XCUR, YCUR)
	    END DO
	ELSE IF (MODE.EQ.3) THEN
	    DO I=1,POINTS
		CALL GRTXY0(ABSXY, X(I), Y(I), XCUR, YCUR)
		CALL GRDOT0(XCUR, YCUR)
	    END DO
	END IF
	RETURN
	END
	SUBROUTINE GRVECT (IDENT,MODE,ABSXY,POINTS,X,Y)
C-----------------------------------------------------------------------
C GRPCKG: Draw a line or a set of dots. This routine can be used to
C draw a single line-segment, a continuous series of line segments, or
C one or more single dots (pixels).
C
C Arguments:
C
C IDENT (input, integer): the plot identifier, as returned by GROPEN.
C MODE (input, integer): if MODE=1, a series of line segments is drawn,
C	starting at the current position, moving to X(1),Y(1), ... and
C	ending at X(POINTS),Y(POINTS).
C	If MODE=2, the first vector is blanked, so the line starts at
C	X(1),Y(1).
C	If MODE=3, a single dot is placed at each coordinate pair, with
C	no connecting lines.
C ABSXY (input, logical): if TRUE, the coordinates are absolute device
C	coordinates; if FALSE, they are world coordinates and the 
C	scaling transformation is applied.
C POINTS (input, integer): the number of coordinate pairs.
C X, Y (input, real arrays, dimensioned POINTS or greater): the
C	X and Y coordinates of the points.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INTEGER  IDENT, MODE, POINTS
	LOGICAL  ABSXY
	REAL     X(POINTS), Y(POINTS)
C
	CALL GRSELECT(IDENT)
	IF (MODE.LE.0 .OR. MODE.GT.3) THEN
	    CALL GRWARN('GRVECT - invalid MODE parameter.')
	ELSE IF (POINTS.GT.0) THEN
	    CALL GRVCT0(MODE, ABSXY, POINTS, X, Y)
	END IF
	RETURN
	END
	INTEGER FUNCTION GRVT00
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Open a file for VT125 REGIS graphics.
C If an error occurs, a message is sent to SYS$OUTPUT via GRWARN. The
C file is opened for Fortran I/O, so it may be either a VT125 terminal
C or a disk file.
C
C Arguments: none.
C
C Returns:
C
C GRVT00 (integer): receives 1 if the file was opened successfully; any
C	other value indicates an error (the value is the associated VMS
C	error code).
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	INTEGER  GRCHKT, I, IER, IK1, IK2, IK3, IK4, IK5
	INTEGER  LIB$GET_LUN
C
	IER = LIB$GET_LUN(GRUNIT(GRCIDE))
	IF (IER.NE.1) THEN
	    CALL GRGMSG(IER)
	    GRVT00 = IER
	    RETURN
	END IF
	OPEN (UNIT=GRUNIT(GRCIDE), NAME=GRFILE(GRCIDE), STATUS='NEW',
     1		FORM='FORMATTED', CARRIAGECONTROL='NONE', IOSTAT=IER)
	IF (IER.NE.0) THEN
	    CALL ERRSNS(IK1,IK2,IK3,IK4,IK5)
	    CALL GRWARN('Cannot open graphics device '
     1				//GRFILE(GRCIDE)(1:GRFNLN(GRCIDE)))
	    IF (IK2.NE.0 .AND. IK2.NE.1) CALL GRGMSG(IK2)
	    IF (IK5.NE.0 .AND. IK5.NE.1) CALL GRGMSG(IK5)
	    GRVT00 = IK5
	ELSE
	    INQUIRE (UNIT=GRUNIT(GRCIDE), NAME=GRFILE(GRCIDE))
c      WRITE(3,200)GRUNIT(GRCIDE),GRFILE(GRCIDE)
200    FORMAT('  IN GRVT00,UNIT=',I4,'  NAME=',A)
	    I = LEN(GRFILE(GRCIDE))
	    DO WHILE (GRFILE(GRCIDE)(I:I).EQ.' ')
		I = I-1
	    END DO
	    GRFNLN(GRCIDE) = I
	    GRRCNT(GRCIDE) = 0
	    GRVT00 = 1
	END IF
	RETURN
	END
	SUBROUTINE GRVT01 (I0,J0,I1,J1)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Draw a line (VT125 only). This requires a
C P command (unless the starting point is the same point as the end 
C point of the last line) followed by a V command.
C
C Arguments:
C
C I0, J0 (input, integer): the absolute device coordinates of the 
C	starting point of the line.
C I1, J1 (input, integer): the absolute device coordinates of the 
C	end point of the line.
C
C (15-May-1984)
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	CHARACTER*20 INSTR,INSTR1,INSTR2
	CHARACTER*2 PIX(0:22)
	INTEGER  I0,J0,I1,J1, L,L1,L2
	DATA PIX /'V5','V4','V3',7*'  ','V6',' ','V2',7*' ','V7',
     1	          'V0','V1'/
C
	IF (I0.NE.GRLSTI(GRCIDE).OR. J0.NE.GRLSTJ(GRCIDE)) THEN
	    CALL SYS$FAO('P[!SL,!SL]',L,INSTR,%VAL(I0),%VAL(J0))
	    CALL GRVT02(INSTR(1:L),%VAL(GRPBAD(GRCIDE)))
	    CALL GRVT02('V[]',%VAL(GRPBAD(GRCIDE)))
	END IF
	IF (I1.EQ.I0 .AND. J1.EQ.J0) THEN
	    CONTINUE
	ELSE IF (ABS(I1-I0).LE.1 .AND. ABS(J1-J0).LE.1) THEN
	    L = 10*(I1-I0+1) + (J1-J0+1)
	    CALL GRVT02(PIX(L),%VAL(GRPBAD(GRCIDE)))
	ELSE
	    IF (I1.EQ.I0) THEN
		INSTR1 = 'V['
		L1 = 2
	    ELSE IF (ABS(I1-I0).GE.100) THEN
		CALL SYS$FAO('V[!SL',L1,INSTR1,%VAL(I1))
	    ELSE IF (I1.GT.I0) THEN
		CALL SYS$FAO('V[+!SL',L1,INSTR1,%VAL(I1-I0))
	    ELSE
		CALL SYS$FAO('V[!SL',L1,INSTR1,%VAL(I1-I0))
	    END IF
	    IF (J1.EQ.J0) THEN
		INSTR2 = ']'
		L2 = 1
	    ELSE IF (ABS(J1-J0).GE.100) THEN
		CALL SYS$FAO(',!SL]',L2,INSTR2,%VAL(J1))
	    ELSE IF (J1.GT.J0) THEN
		CALL SYS$FAO(',+!SL]',L2,INSTR2,%VAL(J1-J0))
	    ELSE
		CALL SYS$FAO(',!SL]',L2,INSTR2,%VAL(J1-J0))
	    END IF
	    CALL GRVT02(INSTR1(1:L1)//INSTR2(1:L2),%VAL(GRPBAD(GRCIDE)))
	END IF
	GRLSTI(GRCIDE) = I1
	GRLSTJ(GRCIDE) = J1
	RETURN
	END
	SUBROUTINE GRVT02 (INSTR,BUFFER)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Transfer VT125 REGIS instruction to output
C buffer. If the buffer fills up, it is flushed to the output device
C using routine GRVT03.
C
C Arguments:
C
C INSTR (input, character): the REGIS command. This must be one
C	complete command beginning with a command keyletter (P,V,C,T,W,
C	S,@,L,R,;). If the command has the same keyletter as the
C	previous command, the keyletter is stripped off.
C BUFFER (input/output, byte array): the (address of the) buffer, passed
C	as an argument because it is a dynamic array.
C
C  1-Feb-1983 - [TJP].
C 23-Jul-1983 - fix bug: SAVKEY must be an array [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  'GRPCKG1.INC'
	CHARACTER*(*) INSTR
	CHARACTER*(1) SAVKEY(GRIMAX)
	INTEGER  I,IN
	BYTE     BUFFER(*)
	SAVE     SAVKEY
	DATA	 SAVKEY/GRIMAX*'*'/
C
	IN = 1
	IF (INSTR(1:1).EQ.SAVKEY(GRCIDE) .AND. 
     1	    GRBHWM(GRCIDE).GT.0) IN=2
	SAVKEY(GRCIDE) = INSTR(1:1)
	DO I=IN,LEN(INSTR)
	    IF (GRBHWM(GRCIDE).GE.GRPBXD(GRCIDE))
     1		CALL GRVT03(%VAL(GRPBAD(GRCIDE)))
	    GRBHWM(GRCIDE) = GRBHWM(GRCIDE)+1
	    BUFFER(GRBHWM(GRCIDE)) = ICHAR(INSTR(I:I))
	END DO
	RETURN
	END
	SUBROUTINE GRVT03 (BUFFER)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Flush VT125 buffer contents. The REGIS
C commands in the buffer are prefixed with <ESC>Pp (switch to REGIS
C mode), and followed by <ESC>\ (return to text mode).
C
C Argument:
C
C BUFFER (input, byte array): address of the buffer (passed as an 
C	argument because it is a dynamic array).
C
C 16-Mar-1983 - [TJP].
C-----------------------------------------------------------------------
	IMPLICIT  NONE
	INCLUDE   'GRPCKG1.INC'
	INTEGER   I, J, UNIT
	BYTE      BUFFER(*), PREFIX(3), SUFFIX(2)
	DATA      PREFIX / 27, 'P', 'p' /
	DATA      SUFFIX / 27, '\'/
C
	I = GRBHWM(GRCIDE)
	IF (I.GT.0) THEN
	    UNIT = GRUNIT(GRCIDE)
	    WRITE (UNIT,'(80A1)') PREFIX,(BUFFER(J),J=1,I),SUFFIX
	END IF
	GRBHWM(GRCIDE) = 0
	GRLSTI(GRCIDE) = -1	! force new P command for next buffer
	RETURN
	END
	SUBROUTINE GRVT10
C-----------------------------------------------------------------------
C GRPCKG (Regis, VT125, VT240, Rainbow): Initialize the display.
C Note that the display is NOT erased.
C The Regis initialization commands are:
C
C ;		           - resynchronize
C W(R)		           - replace mode writing
C W(I1)		           - color index 1
C W(F3)		           - both bit planes
C W(M1)		           - unit multiplier
C W(N0)		           - negative off
C W(P1)		           - pattern 1
C W(P(M2))	           - pattern multiplier 1
C W(S0)		           - shading off

C S(G1)		           - select graphics plane [Rainbow REGIS]
C S(A[0,479][767,0])       - screen addressing, origin at bottom left
C S(I0)		           - background dark
C S(S1)		           - scale 1
C S(M0(L0)(AL0))           - output map section 0 (black)
C S(M1(L100)(AL100))       - output map section 1 (white)
C S(M2(L30)(AH120L50S100)) - output map section 3 (red/dim grey)
C S(M3(L59)(AH240L50S100)) - output map section 4 (green/light grey)
C
C Arguments: none.
C
C 26-Jul-1984 - [TJP].
C-----------------------------------------------------------------------
	CHARACTER*(*) INITVT
	PARAMETER (INITVT=';W(RI1F3M1N0P1P(M2)S0)'//
     1			  'S(G1A[0,479][767,0]I0S1)'//
     2			  'S(M0(L0)(AL0))'//
     3			  'S(M1(L100)(AL100))'//
     4			  'S(M2(L30)(AH120L50S100))'//
     5			  'S(M3(L59)(AH240L50S100))')
	INCLUDE 'GRPCKG1.INC'
C
	CALL GRVT02(INITVT,%VAL(GRPBAD(GRCIDE)))
	RETURN
	END
	SUBROUTINE GRWARN (TEXT)
C-----------------------------------------------------------------------
C GRPCKG (internal routine): Report a warning message on SYS$OUTPUT,
C with prefix "%GRPCKG, ".  I/O is done with routine LIB$PUT_OUTPUT.
C
C Argument:
C
C TEXT (input, character): text of message to be printed (the string
C	may not be blank).
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
	IMPLICIT  NONE
	CHARACTER*(*) TEXT
	INTEGER   I
C
	I = LEN(TEXT)
	DO WHILE (TEXT(I:I).EQ.' ')
	    I = I-1
	END DO
	CALL LIB$PUT_OUTPUT('%GRPCKG, '//TEXT(1:I) )
	RETURN
	END
	SUBROUTINE GRXHLS (R,G,B,H,L,S)
C-----------------------------------------------------------------------
C GRPCKG: Convert a color specified in the RGB color model to one in
C the HLS model.  This is a support routine: no graphics I/O occurs.
C The inverse transformation is accomplished with routine GRXRGB.
C Reference: SIGGRAPH Status Report of the Graphic Standards Planning
C Committee, Computer Graphics, Vol.13, No.3, Association for
C Computing Machinery, New York, NY, 1979.
C
C Arguments:
C
C R,G,B (real, input): red, green, blue color coordinates, each in the
C	range 0.0 to 1.0. Input outside this range causes HLS = (0,1,0)
C	[white] to be returned.
C H,L,S (real, output): hue (0 to 360), lightness (0 to 1.0), and
C	saturation (0 to 1.0).
C
C  2-Jul-1984 - new routine [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	REAL     R,G,B, H,L,S, MA, MI, RR, GG, BB, D
C
	H = 0.0
	L = 1.0
	S = 0.0
	MA = MAX(R,G,B)
	MI = MIN(R,G,B)
	IF (MA.GT.1.0 .OR. MI.LT.0.0) RETURN
	RR = (MA-R)
	GG = (MA-G)
	BB = (MA-B)
	L = 0.5*(MA+MI)
	IF (MA.EQ.MI) THEN
	    S = 0.0
	    H = 0.0
	ELSE
	    D = MA-MI
	    IF (L.LE.0.5) THEN
		S = D/(MA+MI)
	    ELSE
		S = D/(2.0-MA-MI)
	    END IF
	    IF (R.EQ.MA) THEN
		H = (2.0*D+BB-GG)
	    ELSE IF (G.EQ.MA) THEN
		H = (4.0*D+RR-BB)
	    ELSE	! (B.EQ.MA)
		H = (6.0*D+GG-RR)
	    END IF
	    H = H*60.0/D
	END IF
	RETURN
	END
	SUBROUTINE GRXRGB (H,L,S,R,G,B)
C-----------------------------------------------------------------------
C GRPCKG: Convert a color specified in the HLS color model to one in
C the RGB model.  This is a support routine: no graphics I/O occurs.
C The inverse transformation is accomplished with routine GRXHLS.
C Reference: SIGGRAPH Status Report of the Graphic Standards Planning
C Committee, Computer Graphics, Vol.13, No.3, Association for
C Computing Machinery, New York, NY, 1979.
C
C Arguments:
C
C H,L,S (real, input): hue (0 to 360), lightness (0 to 1.0), and
C	saturation (0 to 1.0).
C R,G,B (real, output): red, green, blue color coordinates, each in the
C	range 0.0 to 1.0.
C
C  2-Jul-1984 - new routine [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	REAL     H,L,S, R,G,B, MA, MI
C
	IF (L.LE.0.5) THEN
	    MA = L*(1.+S)
	ELSE
	    MA = L + S - L*S
	END IF
	MI = 2*L-MA
	IF (H.LT.60.0) THEN
	    R = MI + (MA-MI)*H/60.0
	ELSE IF (H.LT.180.0) THEN
	    R = MA
	ELSE IF (H.LT.240.0) THEN
	    R = MI + (MA-MI)*(240.0-H)/60.0
	ELSE
	    R = MI
	END IF
	IF (H.LT.120.0) THEN
	    G = MI
	ELSE IF (H.LT.180.0) THEN
	    G = MI + (MA-MI)*(H-120.0)/60.0
	ELSE IF (H.LT.300.0) THEN
	    G = MA
	ELSE
	    G = MI + (MA-MI)*(360.0-H)/60.0
	END IF
	IF (H.LT.60.0 .OR. H.GE.300.0) THEN
	    B = MA
	ELSE IF (H.LT.120.0) THEN
	    B = MI + (MA-MI)*(120.0-H)/60.0
	ELSE IF (H.LT.240.0) THEN
	    B = MI
	ELSE
	    B = MI + (MA-MI)*(H-240.0)/60.0
	END IF	    
	RETURN
	END
